#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include <colm/pdarun.h>
#include <colm/debug.h>
#include <colm/bytecode.h>
#include <colm/config.h>
#include <colm/defs.h>
#include <colm/input.h>
#include <colm/tree.h>
#include <colm/program.h>
#include <colm/colm.h>

extern struct colm_sections colm_object;

#define parser_start 45
#define parser_first_final 45
#define parser_error 0
#define false 0
#define true 1

static long parser_entry_by_region[] = {
	0, 45, 259, 472, 472, 474, 476, 478, 
	478, 479, 481, 483, 483, 484, 486, 488, 
	488, 489, 501, 512, 512, 514, 515, 516, 
	516, 517, 532, 547, 547
};

static struct fsm_tables fsmTables_start =
{
	0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	parser_entry_by_region,

	0,  0,  0,  0,  0,  0,  0,  0,
	28,

	parser_start,
	parser_first_final,
	parser_error,

	0,
	0
};

static void fsm_execute( struct pda_run *pdaRun, struct input_impl *inputStream )
{
	pdaRun->start = pdaRun->p;
/*_resume:*/
	if ( pdaRun->fsm_cs == 0 )
		goto out;
	if ( pdaRun->p == pdaRun->pe )
		goto out_switch;
	--pdaRun->p;

	switch ( pdaRun->fsm_cs )
	{
tr1:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 109;
	goto out;
}
	goto st45;
tr2:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 106;
	goto out;
}
	goto st45;
tr5:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 73;
	goto out;
}
	goto st45;
tr69:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 74;
	goto out;
}
	goto st45;
tr70:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 100;
	goto out;
}
	goto st45;
tr71:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 103;
	goto out;
}
	goto st45;
tr73:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 75;
	goto out;
}
	goto st45;
tr74:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 85;
	goto out;
}
	goto st45;
tr75:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 86;
	goto out;
}
	goto st45;
tr76:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 89;
	goto out;
}
	goto st45;
tr77:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 104;
	goto out;
}
	goto st45;
tr78:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 94;
	goto out;
}
	goto st45;
tr80:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 83;
	goto out;
}
	goto st45;
tr81:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 80;
	goto out;
}
	goto st45;
tr87:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 90;
	goto out;
}
	goto st45;
tr88:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 102;
	goto out;
}
	goto st45;
tr90:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 77;
	goto out;
}
	goto st45;
tr91:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 78;
	goto out;
}
	goto st45;
tr92:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 101;
	goto out;
}
	goto st45;
tr112:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 87;
	goto out;
}
	goto st45;
tr114:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 88;
	goto out;
}
	goto st45;
tr115:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 76;
	goto out;
}
	goto st45;
tr116:
	{	pdaRun->matched_token = 108;
	goto out;
}
	goto st45;
tr117:
	{	pdaRun->matched_token = 99;
	goto out;
}
	goto st45;
tr118:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 93;
	goto out;
}
	goto st45;
tr119:
	{	pdaRun->matched_token = 105;
	goto out;
}
	goto st45;
tr120:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 84;
	goto out;
}
	goto st45;
tr121:
	{	pdaRun->matched_token = 72;
	goto out;
}
	goto st45;
tr122:
	{	pdaRun->matched_token = 81;
	goto out;
}
	goto st45;
tr123:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 82;
	goto out;
}
	goto st45;
tr124:
	{	pdaRun->matched_token = 95;
	goto out;
}
	goto st45;
tr125:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 97;
	goto out;
}
	goto st45;
tr126:
	{	pdaRun->matched_token = 91;
	goto out;
}
	goto st45;
tr127:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 92;
	goto out;
}
	goto st45;
tr128:
	{	pdaRun->matched_token = 96;
	goto out;
}
	goto st45;
tr129:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 98;
	goto out;
}
	goto st45;
tr130:
	{	pdaRun->toklen = pdaRun->tokend;
	switch( pdaRun->act ) {
	case 3:
	pdaRun->matched_token = 5;
	break;
	case 5:
	pdaRun->matched_token = 6;
	break;
	case 7:
	pdaRun->matched_token = 7;
	break;
	case 9:
	pdaRun->matched_token = 8;
	break;
	case 11:
	pdaRun->matched_token = 9;
	break;
	case 15:
	pdaRun->matched_token = 11;
	break;
	case 21:
	pdaRun->matched_token = 14;
	break;
	case 23:
	pdaRun->matched_token = 15;
	break;
	case 25:
	pdaRun->matched_token = 16;
	break;
	case 27:
	pdaRun->matched_token = 17;
	break;
	case 29:
	pdaRun->matched_token = 18;
	break;
	case 31:
	pdaRun->matched_token = 19;
	break;
	case 35:
	pdaRun->matched_token = 21;
	break;
	case 37:
	pdaRun->matched_token = 22;
	break;
	case 39:
	pdaRun->matched_token = 23;
	break;
	case 41:
	pdaRun->matched_token = 24;
	break;
	case 43:
	pdaRun->matched_token = 25;
	break;
	case 45:
	pdaRun->matched_token = 26;
	break;
	case 47:
	pdaRun->matched_token = 27;
	break;
	case 49:
	pdaRun->matched_token = 28;
	break;
	case 51:
	pdaRun->matched_token = 29;
	break;
	case 55:
	pdaRun->matched_token = 31;
	break;
	case 59:
	pdaRun->matched_token = 33;
	break;
	case 63:
	pdaRun->matched_token = 35;
	break;
	case 65:
	pdaRun->matched_token = 36;
	break;
	case 67:
	pdaRun->matched_token = 37;
	break;
	case 69:
	pdaRun->matched_token = 38;
	break;
	case 71:
	pdaRun->matched_token = 39;
	break;
	case 73:
	pdaRun->matched_token = 40;
	break;
	case 75:
	pdaRun->matched_token = 41;
	break;
	case 77:
	pdaRun->matched_token = 42;
	break;
	case 79:
	pdaRun->matched_token = 43;
	break;
	case 81:
	pdaRun->matched_token = 44;
	break;
	case 83:
	pdaRun->matched_token = 45;
	break;
	case 85:
	pdaRun->matched_token = 46;
	break;
	case 87:
	pdaRun->matched_token = 47;
	break;
	case 89:
	pdaRun->matched_token = 48;
	break;
	case 91:
	pdaRun->matched_token = 49;
	break;
	case 93:
	pdaRun->matched_token = 50;
	break;
	case 95:
	pdaRun->matched_token = 51;
	break;
	case 97:
	pdaRun->matched_token = 52;
	break;
	case 99:
	pdaRun->matched_token = 53;
	break;
	case 101:
	pdaRun->matched_token = 54;
	break;
	case 103:
	pdaRun->matched_token = 55;
	break;
	case 105:
	pdaRun->matched_token = 56;
	break;
	case 107:
	pdaRun->matched_token = 57;
	break;
	case 109:
	pdaRun->matched_token = 58;
	break;
	case 111:
	pdaRun->matched_token = 59;
	break;
	case 113:
	pdaRun->matched_token = 60;
	break;
	case 115:
	pdaRun->matched_token = 61;
	break;
	case 117:
	pdaRun->matched_token = 62;
	break;
	case 121:
	pdaRun->matched_token = 64;
	break;
	case 123:
	pdaRun->matched_token = 65;
	break;
	case 125:
	pdaRun->matched_token = 66;
	break;
	case 127:
	pdaRun->matched_token = 67;
	break;
	case 129:
	pdaRun->matched_token = 68;
	break;
	case 131:
	pdaRun->matched_token = 69;
	break;
	case 133:
	pdaRun->matched_token = 70;
	break;
	case 135:
	pdaRun->matched_token = 71;
	break;
	}
		goto skip_toklen;
}
	goto st45;
tr131:
	{	pdaRun->matched_token = 73;
	goto out;
}
	goto st45;
tr132:
	{	pdaRun->matched_token = 71;
	goto out;
}
	goto st45;
tr160:
	{	pdaRun->matched_token = 17;
	goto out;
}
	goto st45;
tr171:
	{	pdaRun->matched_token = 4;
	goto out;
}
	goto st45;
tr209:
	{	pdaRun->matched_token = 30;
	goto out;
}
	goto st45;
tr226:
	{	pdaRun->matched_token = 32;
	goto out;
}
	goto st45;
tr248:
	{	pdaRun->matched_token = 34;
	goto out;
}
	goto st45;
tr266:
	{	pdaRun->matched_token = 63;
	goto out;
}
	goto st45;
tr280:
	{	pdaRun->matched_token = 12;
	goto out;
}
	goto st45;
tr297:
	{	pdaRun->matched_token = 10;
	goto out;
}
	goto st45;
tr321:
	{	pdaRun->matched_token = 13;
	goto out;
}
	goto st45;
tr348:
	{	pdaRun->matched_token = 20;
	goto out;
}
	goto st45;
tr385:
	{	pdaRun->matched_token = 79;
	goto out;
}
	goto st45;
tr386:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 107;
	goto out;
}
	goto st45;
st45:
case 45:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out45;
	{pdaRun->tokstart = pdaRun->p;}
	switch( (*pdaRun->p) ) {
		case 32: goto st46;
		case 33: goto st47;
		case 34: goto tr69;
		case 35: goto st1;
		case 36: goto tr70;
		case 37: goto tr71;
		case 38: goto st2;
		case 39: goto tr73;
		case 40: goto tr74;
		case 41: goto tr75;
		case 42: goto tr76;
		case 43: goto tr77;
		case 44: goto tr78;
		case 45: goto st48;
		case 46: goto tr80;
		case 47: goto tr81;
		case 58: goto st50;
		case 60: goto st51;
		case 61: goto st52;
		case 62: goto st53;
		case 63: goto tr87;
		case 64: goto tr88;
		case 91: goto tr90;
		case 93: goto tr91;
		case 94: goto tr92;
		case 96: goto st3;
		case 97: goto st56;
		case 98: goto st63;
		case 99: goto st69;
		case 100: goto st85;
		case 101: goto st91;
		case 102: goto st101;
		case 103: goto st106;
		case 105: goto st111;
		case 108: goto st123;
		case 109: goto st135;
		case 110: goto st151;
		case 112: goto st167;
		case 114: goto st187;
		case 115: goto st221;
		case 116: goto st237;
		case 118: goto st247;
		case 119: goto st250;
		case 121: goto st254;
		case 123: goto tr112;
		case 124: goto st258;
		case 125: goto tr114;
		case 126: goto tr115;
	}
	if ( (*pdaRun->p) < 48 ) {
		if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
			goto st46;
	} else if ( (*pdaRun->p) > 57 ) {
		if ( (*pdaRun->p) > 90 ) {
			if ( 95 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
				goto tr89;
		} else if ( (*pdaRun->p) >= 65 )
			goto tr89;
	} else
		goto st49;
	goto st0;
st46:
case 46:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out46;
	if ( (*pdaRun->p) == 32 )
		goto st46;
	if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
		goto st46;
	goto tr116;
st47:
case 47:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out47;
	if ( (*pdaRun->p) == 61 )
		goto tr118;
	goto tr117;
st1:
case 1:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out1;
	if ( (*pdaRun->p) == 10 )
		goto tr1;
	goto st1;
st2:
case 2:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out2;
	if ( (*pdaRun->p) == 38 )
		goto tr2;
	goto st0;
st0:
	goto out0;
st48:
case 48:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out48;
	if ( (*pdaRun->p) == 62 )
		goto tr120;
	goto tr119;
st50:
case 50:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out50;
	if ( (*pdaRun->p) == 58 )
		goto tr123;
	goto tr122;
st51:
case 51:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out51;
	if ( (*pdaRun->p) == 61 )
		goto tr125;
	goto tr124;
st52:
case 52:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out52;
	if ( (*pdaRun->p) == 61 )
		goto tr127;
	goto tr126;
st53:
case 53:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out53;
	if ( (*pdaRun->p) == 61 )
		goto tr129;
	goto tr128;
st3:
case 3:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out3;
	switch( (*pdaRun->p) ) {
		case 32: goto st0;
		case 93: goto tr5;
	}
	if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
		goto st0;
	goto st55;
st55:
case 55:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out55;
	switch( (*pdaRun->p) ) {
		case 32: goto tr131;
		case 93: goto tr131;
	}
	if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
		goto tr131;
	goto st55;
st56:
case 56:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out56;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 99: goto st57;
		case 108: goto st60;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
tr89:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 135;}
	goto st54;
tr137:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 55;}
	goto st54;
tr140:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 81;}
	goto st54;
tr144:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 103;}
	goto st54;
tr147:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 75;}
	goto st54;
tr151:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 97;}
	goto st54;
tr152:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 93;}
	goto st54;
tr157:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 83;}
	goto st54;
tr165:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 27;}
	goto st54;
tr168:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 115;}
	goto st54;
tr175:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 99;}
	goto st54;
tr181:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 51;}
	goto st54;
tr183:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 49;}
	goto st54;
tr184:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 5;}
	goto st54;
tr185:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 91;}
	goto st54;
tr189:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 71;}
	goto st54;
tr194:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 125;}
	goto st54;
tr195:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 41;}
	goto st54;
tr200:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 89;}
	goto st54;
tr201:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 43;}
	goto st54;
tr208:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 11;}
	goto st54;
tr211:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 101;}
	goto st54;
tr215:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 133;}
	goto st54;
tr217:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 67;}
	goto st54;
tr221:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 3;}
	goto st54;
tr222:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 127;}
	goto st54;
tr229:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 59;}
	goto st54;
tr233:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 113;}
	goto st54;
tr245:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 107;}
	goto st54;
tr247:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 109;}
	goto st54;
tr251:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 63;}
	goto st54;
tr253:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 29;}
	goto st54;
tr264:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 37;}
	goto st54;
tr265:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 85;}
	goto st54;
tr267:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 121;}
	goto st54;
tr273:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 131;}
	goto st54;
tr286:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 25;}
	goto st54;
tr289:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 23;}
	goto st54;
tr294:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 87;}
	goto st54;
tr298:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 15;}
	goto st54;
tr299:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 65;}
	goto st54;
tr302:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 9;}
	goto st54;
tr305:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 69;}
	goto st54;
tr316:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 21;}
	goto st54;
tr326:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 79;}
	goto st54;
tr329:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 39;}
	goto st54;
tr332:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 77;}
	goto st54;
tr336:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 31;}
	goto st54;
tr339:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 73;}
	goto st54;
tr342:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 129;}
	goto st54;
tr353:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 35;}
	goto st54;
tr357:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 117;}
	goto st54;
tr361:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 95;}
	goto st54;
tr367:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 7;}
	goto st54;
tr369:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 123;}
	goto st54;
tr373:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 111;}
	goto st54;
tr376:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 105;}
	goto st54;
tr380:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 47;}
	goto st54;
tr384:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 45;}
	goto st54;
st54:
case 54:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out54;
	if ( (*pdaRun->p) == 95 )
		goto tr89;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr130;
st57:
case 57:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out57;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 99: goto st58;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st58:
case 58:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out58;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 117: goto st59;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st59:
case 59:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out59;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 109: goto tr137;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st60:
case 60:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out60;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 105: goto st61;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st61:
case 61:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out61;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 97: goto st62;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st62:
case 62:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out62;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 115: goto tr140;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st63:
case 63:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out63;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 111: goto st64;
		case 114: goto st66;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st64:
case 64:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out64;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 111: goto st65;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st65:
case 65:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out65;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 108: goto tr144;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st66:
case 66:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out66;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto st67;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st67:
case 67:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out67;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 97: goto st68;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st68:
case 68:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out68;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 107: goto tr147;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st69:
case 69:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out69;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 97: goto st70;
		case 111: goto st72;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st70:
case 70:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out70;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 115: goto st71;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st71:
case 71:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out71;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto tr151;
		case 116: goto tr152;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st72:
case 72:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out72;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 109: goto st73;
		case 110: goto st76;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st73:
case 73:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out73;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 109: goto st74;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st74:
case 74:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out74;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 105: goto st75;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st75:
case 75:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out75;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 116: goto tr157;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st76:
case 76:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out76;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 115: goto st77;
		case 116: goto st82;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st77:
case 77:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out77;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 116: goto st78;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr160;
st78:
case 78:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out78;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 114: goto st79;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st79:
case 79:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out79;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 117: goto st80;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st80:
case 80:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out80;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 99: goto st81;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st81:
case 81:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out81;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 116: goto tr165;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st82:
case 82:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out82;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto st83;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st83:
case 83:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out83;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 120: goto st84;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st84:
case 84:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out84;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 116: goto tr168;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st85:
case 85:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out85;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto st86;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st86:
case 86:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out86;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 102: goto st87;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st87:
case 87:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out87;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 97: goto st88;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr171;
st88:
case 88:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out88;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 117: goto st89;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st89:
case 89:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out89;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 108: goto st90;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st90:
case 90:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out90;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 116: goto tr175;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st91:
case 91:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out91;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 108: goto st92;
		case 110: goto st95;
		case 111: goto st96;
		case 120: goto st97;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st92:
case 92:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out92;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 115: goto st93;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st93:
case 93:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out93;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto tr181;
		case 105: goto st94;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st94:
case 94:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out94;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 102: goto tr183;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st95:
case 95:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out95;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 100: goto tr184;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st96:
case 96:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out96;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 115: goto tr185;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st97:
case 97:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out97;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 112: goto st98;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st98:
case 98:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out98;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 111: goto st99;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st99:
case 99:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out99;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 114: goto st100;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st100:
case 100:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out100;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 116: goto tr189;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st101:
case 101:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out101;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 97: goto st102;
		case 111: goto st105;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st102:
case 102:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out102;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 108: goto st103;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st103:
case 103:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out103;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 115: goto st104;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st104:
case 104:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out104;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto tr194;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st105:
case 105:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out105;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 114: goto tr195;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st106:
case 106:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out106;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 108: goto st107;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st107:
case 107:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out107;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 111: goto st108;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st108:
case 108:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out108;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 98: goto st109;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st109:
case 109:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out109;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 97: goto st110;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st110:
case 110:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out110;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 108: goto tr200;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st111:
case 111:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out111;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 102: goto tr201;
		case 103: goto st112;
		case 110: goto st116;
		case 116: goto st121;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st112:
case 112:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out112;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 110: goto st113;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st113:
case 113:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out113;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 111: goto st114;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st114:
case 114:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out114;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 114: goto st115;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st115:
case 115:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out115;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto tr208;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st116:
case 116:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out116;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 99: goto st117;
		case 116: goto tr211;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr209;
st117:
case 117:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out117;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 108: goto st118;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st118:
case 118:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out118;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 117: goto st119;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st119:
case 119:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out119;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 100: goto st120;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st120:
case 120:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out120;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto tr215;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st121:
case 121:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out121;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto st122;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st122:
case 122:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out122;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 114: goto tr217;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st123:
case 123:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out123;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto st124;
		case 105: goto st126;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st124:
case 124:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out124;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 102: goto st125;
		case 120: goto tr221;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st125:
case 125:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out125;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 116: goto tr222;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st126:
case 126:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out126;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 115: goto st127;
		case 116: goto st131;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st127:
case 127:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out127;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 116: goto st128;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st128:
case 128:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out128;
	if ( (*pdaRun->p) == 95 )
		goto st129;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr226;
st129:
case 129:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out129;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto st130;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st130:
case 130:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out130;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 108: goto tr229;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st131:
case 131:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out131;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto st132;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st132:
case 132:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out132;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 114: goto st133;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st133:
case 133:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out133;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 97: goto st134;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st134:
case 134:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out134;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 108: goto tr233;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st135:
case 135:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out135;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 97: goto st136;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st136:
case 136:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out136;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 107: goto st137;
		case 112: goto st146;
		case 116: goto st149;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st137:
case 137:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out137;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto st138;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st138:
case 138:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out138;
	if ( (*pdaRun->p) == 95 )
		goto st139;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st139:
case 139:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out139;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 116: goto st140;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st140:
case 140:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out140;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 111: goto st141;
		case 114: goto st144;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st141:
case 141:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out141;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 107: goto st142;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st142:
case 142:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out142;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto st143;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st143:
case 143:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out143;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 110: goto tr245;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st144:
case 144:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out144;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto st145;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st145:
case 145:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out145;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto tr247;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st146:
case 146:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out146;
	if ( (*pdaRun->p) == 95 )
		goto st147;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr248;
st147:
case 147:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out147;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto st148;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st148:
case 148:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out148;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 108: goto tr251;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st149:
case 149:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out149;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 99: goto st150;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st150:
case 150:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out150;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 104: goto tr253;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st151:
case 151:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out151;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 97: goto st152;
		case 101: goto st159;
		case 105: goto st160;
		case 111: goto st161;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st152:
case 152:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out152;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 109: goto st153;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st153:
case 153:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out153;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto st154;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st154:
case 154:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out154;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 115: goto st155;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st155:
case 155:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out155;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 112: goto st156;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st156:
case 156:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out156;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 97: goto st157;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st157:
case 157:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out157;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 99: goto st158;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st158:
case 158:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out158;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto tr264;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st159:
case 159:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out159;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 119: goto tr265;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st160:
case 160:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out160;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 108: goto tr267;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr266;
st161:
case 161:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out161;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 110: goto st162;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st162:
case 162:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out162;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 97: goto st163;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st163:
case 163:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out163;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 115: goto st164;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st164:
case 164:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out164;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 115: goto st165;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st165:
case 165:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out165;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 111: goto st166;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st166:
case 166:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out166;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 99: goto tr273;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st167:
case 167:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out167;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 97: goto st168;
		case 114: goto st179;
		case 116: goto st186;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st168:
case 168:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out168;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 114: goto st169;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st169:
case 169:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out169;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 115: goto st170;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st170:
case 170:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out170;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto st171;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st171:
case 171:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out171;
	switch( (*pdaRun->p) ) {
		case 95: goto st172;
		case 114: goto tr137;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr280;
st172:
case 172:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out172;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 115: goto st173;
		case 116: goto st176;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st173:
case 173:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out173;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 116: goto st174;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st174:
case 174:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out174;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 111: goto st175;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st175:
case 175:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out175;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 112: goto tr286;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st176:
case 176:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out176;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 114: goto st177;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st177:
case 177:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out177;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto st178;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st178:
case 178:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out178;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto tr289;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st179:
case 179:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out179;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto st180;
		case 105: goto st183;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st180:
case 180:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out180;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto st181;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st181:
case 181:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out181;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 111: goto st182;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st182:
case 182:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out182;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 102: goto tr294;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st183:
case 183:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out183;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 110: goto st184;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st184:
case 184:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out184;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 116: goto st185;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st185:
case 185:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out185;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 115: goto tr298;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr297;
st186:
case 186:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out186;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 114: goto tr299;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st187:
case 187:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out187;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto st188;
		case 105: goto st218;
		case 108: goto tr302;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st188:
case 188:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out188;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 97: goto st189;
		case 100: goto st197;
		case 102: goto tr305;
		case 106: goto st208;
		case 113: goto st211;
		case 116: goto st215;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st189:
case 189:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out189;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 100: goto st190;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st190:
case 190:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out190;
	if ( (*pdaRun->p) == 95 )
		goto st191;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st191:
case 191:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out191;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 114: goto st192;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st192:
case 192:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out192;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto st193;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st193:
case 193:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out193;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 100: goto st194;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st194:
case 194:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out194;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 117: goto st195;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st195:
case 195:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out195;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 99: goto st196;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st196:
case 196:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out196;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto tr316;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st197:
case 197:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out197;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 117: goto st198;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st198:
case 198:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out198;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 99: goto st199;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st199:
case 199:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out199;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto st200;
		case 116: goto st205;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st200:
case 200:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out200;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 102: goto st201;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr321;
st201:
case 201:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out201;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 105: goto st202;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st202:
case 202:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out202;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 114: goto st203;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st203:
case 203:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out203;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 115: goto st204;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st204:
case 204:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out204;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 116: goto tr326;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st205:
case 205:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out205;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 105: goto st206;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st206:
case 206:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out206;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 111: goto st207;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st207:
case 207:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out207;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 110: goto tr329;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st208:
case 208:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out208;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto st209;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st209:
case 209:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out209;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 99: goto st210;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st210:
case 210:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out210;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 116: goto tr332;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st211:
case 211:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out211;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 117: goto st212;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st212:
case 212:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out212;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 105: goto st213;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st213:
case 213:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out213;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 114: goto st214;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st214:
case 214:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out214;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto tr336;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st215:
case 215:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out215;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 117: goto st216;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st216:
case 216:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out216;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 114: goto st217;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st217:
case 217:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out217;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 110: goto tr339;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st218:
case 218:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out218;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 103: goto st219;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st219:
case 219:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out219;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 104: goto st220;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st220:
case 220:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out220;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 116: goto tr342;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st221:
case 221:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out221;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto st222;
		case 116: goto st229;
		case 119: goto st233;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st222:
case 222:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out222;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 110: goto st223;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st223:
case 223:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out223;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 100: goto st224;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st224:
case 224:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out224;
	if ( (*pdaRun->p) == 95 )
		goto st225;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr348;
st225:
case 225:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out225;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 116: goto st226;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st226:
case 226:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out226;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 114: goto st227;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st227:
case 227:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out227;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto st228;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st228:
case 228:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out228;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto tr353;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st229:
case 229:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out229;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 114: goto st230;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st230:
case 230:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out230;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 117: goto st231;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st231:
case 231:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out231;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 99: goto st232;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st232:
case 232:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out232;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 116: goto tr357;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st233:
case 233:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out233;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 105: goto st234;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st234:
case 234:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out234;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 116: goto st235;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st235:
case 235:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out235;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 99: goto st236;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st236:
case 236:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out236;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 104: goto tr361;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st237:
case 237:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out237;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 111: goto st238;
		case 114: goto st241;
		case 121: goto st243;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st238:
case 238:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out238;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 107: goto st239;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st239:
case 239:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out239;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto st240;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st240:
case 240:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out240;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 110: goto tr367;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st241:
case 241:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out241;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 117: goto st242;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st242:
case 242:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out242;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto tr369;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st243:
case 243:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out243;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 112: goto st244;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st244:
case 244:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out244;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto st245;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st245:
case 245:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out245;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 105: goto st246;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st246:
case 246:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out246;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 100: goto tr373;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st247:
case 247:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out247;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 111: goto st248;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st248:
case 248:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out248;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 105: goto st249;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st249:
case 249:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out249;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 100: goto tr376;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st250:
case 250:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out250;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 104: goto st251;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st251:
case 251:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out251;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 105: goto st252;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st252:
case 252:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out252;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 108: goto st253;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st253:
case 253:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out253;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto tr380;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st254:
case 254:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out254;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 105: goto st255;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st255:
case 255:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out255;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 101: goto st256;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st256:
case 256:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out256;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 108: goto st257;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st257:
case 257:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out257;
	switch( (*pdaRun->p) ) {
		case 95: goto tr89;
		case 100: goto tr384;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr89;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr89;
	} else
		goto tr89;
	goto tr132;
st258:
case 258:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out258;
	if ( (*pdaRun->p) == 124 )
		goto tr386;
	goto tr385;
st49:
case 49:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out49;
	if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
		goto st49;
	goto tr121;
tr6:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 106;
	goto out;
}
	goto st259;
tr8:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 73;
	goto out;
}
	goto st259;
tr388:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 74;
	goto out;
}
	goto st259;
tr389:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 100;
	goto out;
}
	goto st259;
tr390:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 103;
	goto out;
}
	goto st259;
tr392:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 75;
	goto out;
}
	goto st259;
tr393:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 85;
	goto out;
}
	goto st259;
tr394:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 86;
	goto out;
}
	goto st259;
tr395:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 89;
	goto out;
}
	goto st259;
tr396:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 104;
	goto out;
}
	goto st259;
tr397:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 94;
	goto out;
}
	goto st259;
tr399:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 83;
	goto out;
}
	goto st259;
tr400:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 80;
	goto out;
}
	goto st259;
tr406:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 90;
	goto out;
}
	goto st259;
tr407:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 102;
	goto out;
}
	goto st259;
tr409:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 77;
	goto out;
}
	goto st259;
tr410:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 78;
	goto out;
}
	goto st259;
tr411:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 101;
	goto out;
}
	goto st259;
tr431:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 87;
	goto out;
}
	goto st259;
tr433:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 88;
	goto out;
}
	goto st259;
tr434:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 76;
	goto out;
}
	goto st259;
tr435:
	{	pdaRun->matched_token = 99;
	goto out;
}
	goto st259;
tr436:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 93;
	goto out;
}
	goto st259;
tr437:
	{	pdaRun->matched_token = 105;
	goto out;
}
	goto st259;
tr438:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 84;
	goto out;
}
	goto st259;
tr439:
	{	pdaRun->matched_token = 72;
	goto out;
}
	goto st259;
tr440:
	{	pdaRun->matched_token = 81;
	goto out;
}
	goto st259;
tr441:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 82;
	goto out;
}
	goto st259;
tr442:
	{	pdaRun->matched_token = 95;
	goto out;
}
	goto st259;
tr443:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 97;
	goto out;
}
	goto st259;
tr444:
	{	pdaRun->matched_token = 91;
	goto out;
}
	goto st259;
tr445:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 92;
	goto out;
}
	goto st259;
tr446:
	{	pdaRun->matched_token = 96;
	goto out;
}
	goto st259;
tr447:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 98;
	goto out;
}
	goto st259;
tr448:
	{	pdaRun->toklen = pdaRun->tokend;
	switch( pdaRun->act ) {
	case 4:
	pdaRun->matched_token = 5;
	break;
	case 6:
	pdaRun->matched_token = 6;
	break;
	case 8:
	pdaRun->matched_token = 7;
	break;
	case 10:
	pdaRun->matched_token = 8;
	break;
	case 12:
	pdaRun->matched_token = 9;
	break;
	case 16:
	pdaRun->matched_token = 11;
	break;
	case 22:
	pdaRun->matched_token = 14;
	break;
	case 24:
	pdaRun->matched_token = 15;
	break;
	case 26:
	pdaRun->matched_token = 16;
	break;
	case 28:
	pdaRun->matched_token = 17;
	break;
	case 30:
	pdaRun->matched_token = 18;
	break;
	case 32:
	pdaRun->matched_token = 19;
	break;
	case 36:
	pdaRun->matched_token = 21;
	break;
	case 38:
	pdaRun->matched_token = 22;
	break;
	case 40:
	pdaRun->matched_token = 23;
	break;
	case 42:
	pdaRun->matched_token = 24;
	break;
	case 44:
	pdaRun->matched_token = 25;
	break;
	case 46:
	pdaRun->matched_token = 26;
	break;
	case 48:
	pdaRun->matched_token = 27;
	break;
	case 50:
	pdaRun->matched_token = 28;
	break;
	case 52:
	pdaRun->matched_token = 29;
	break;
	case 56:
	pdaRun->matched_token = 31;
	break;
	case 60:
	pdaRun->matched_token = 33;
	break;
	case 64:
	pdaRun->matched_token = 35;
	break;
	case 66:
	pdaRun->matched_token = 36;
	break;
	case 68:
	pdaRun->matched_token = 37;
	break;
	case 70:
	pdaRun->matched_token = 38;
	break;
	case 72:
	pdaRun->matched_token = 39;
	break;
	case 74:
	pdaRun->matched_token = 40;
	break;
	case 76:
	pdaRun->matched_token = 41;
	break;
	case 78:
	pdaRun->matched_token = 42;
	break;
	case 80:
	pdaRun->matched_token = 43;
	break;
	case 82:
	pdaRun->matched_token = 44;
	break;
	case 84:
	pdaRun->matched_token = 45;
	break;
	case 86:
	pdaRun->matched_token = 46;
	break;
	case 88:
	pdaRun->matched_token = 47;
	break;
	case 90:
	pdaRun->matched_token = 48;
	break;
	case 92:
	pdaRun->matched_token = 49;
	break;
	case 94:
	pdaRun->matched_token = 50;
	break;
	case 96:
	pdaRun->matched_token = 51;
	break;
	case 98:
	pdaRun->matched_token = 52;
	break;
	case 100:
	pdaRun->matched_token = 53;
	break;
	case 102:
	pdaRun->matched_token = 54;
	break;
	case 104:
	pdaRun->matched_token = 55;
	break;
	case 106:
	pdaRun->matched_token = 56;
	break;
	case 108:
	pdaRun->matched_token = 57;
	break;
	case 110:
	pdaRun->matched_token = 58;
	break;
	case 112:
	pdaRun->matched_token = 59;
	break;
	case 114:
	pdaRun->matched_token = 60;
	break;
	case 116:
	pdaRun->matched_token = 61;
	break;
	case 118:
	pdaRun->matched_token = 62;
	break;
	case 122:
	pdaRun->matched_token = 64;
	break;
	case 124:
	pdaRun->matched_token = 65;
	break;
	case 126:
	pdaRun->matched_token = 66;
	break;
	case 128:
	pdaRun->matched_token = 67;
	break;
	case 130:
	pdaRun->matched_token = 68;
	break;
	case 132:
	pdaRun->matched_token = 69;
	break;
	case 134:
	pdaRun->matched_token = 70;
	break;
	case 136:
	pdaRun->matched_token = 71;
	break;
	}
		goto skip_toklen;
}
	goto st259;
tr449:
	{	pdaRun->matched_token = 73;
	goto out;
}
	goto st259;
tr450:
	{	pdaRun->matched_token = 71;
	goto out;
}
	goto st259;
tr478:
	{	pdaRun->matched_token = 17;
	goto out;
}
	goto st259;
tr489:
	{	pdaRun->matched_token = 4;
	goto out;
}
	goto st259;
tr527:
	{	pdaRun->matched_token = 30;
	goto out;
}
	goto st259;
tr544:
	{	pdaRun->matched_token = 32;
	goto out;
}
	goto st259;
tr566:
	{	pdaRun->matched_token = 34;
	goto out;
}
	goto st259;
tr584:
	{	pdaRun->matched_token = 63;
	goto out;
}
	goto st259;
tr598:
	{	pdaRun->matched_token = 12;
	goto out;
}
	goto st259;
tr615:
	{	pdaRun->matched_token = 10;
	goto out;
}
	goto st259;
tr639:
	{	pdaRun->matched_token = 13;
	goto out;
}
	goto st259;
tr666:
	{	pdaRun->matched_token = 20;
	goto out;
}
	goto st259;
tr703:
	{	pdaRun->matched_token = 79;
	goto out;
}
	goto st259;
tr704:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 107;
	goto out;
}
	goto st259;
st259:
case 259:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out259;
	{pdaRun->tokstart = pdaRun->p;}
	switch( (*pdaRun->p) ) {
		case 33: goto st260;
		case 34: goto tr388;
		case 36: goto tr389;
		case 37: goto tr390;
		case 38: goto st4;
		case 39: goto tr392;
		case 40: goto tr393;
		case 41: goto tr394;
		case 42: goto tr395;
		case 43: goto tr396;
		case 44: goto tr397;
		case 45: goto st261;
		case 46: goto tr399;
		case 47: goto tr400;
		case 58: goto st263;
		case 60: goto st264;
		case 61: goto st265;
		case 62: goto st266;
		case 63: goto tr406;
		case 64: goto tr407;
		case 91: goto tr409;
		case 93: goto tr410;
		case 94: goto tr411;
		case 96: goto st5;
		case 97: goto st269;
		case 98: goto st276;
		case 99: goto st282;
		case 100: goto st298;
		case 101: goto st304;
		case 102: goto st314;
		case 103: goto st319;
		case 105: goto st324;
		case 108: goto st336;
		case 109: goto st348;
		case 110: goto st364;
		case 112: goto st380;
		case 114: goto st400;
		case 115: goto st434;
		case 116: goto st450;
		case 118: goto st460;
		case 119: goto st463;
		case 121: goto st467;
		case 123: goto tr431;
		case 124: goto st471;
		case 125: goto tr433;
		case 126: goto tr434;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st262;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 95 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto st0;
st260:
case 260:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out260;
	if ( (*pdaRun->p) == 61 )
		goto tr436;
	goto tr435;
st4:
case 4:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out4;
	if ( (*pdaRun->p) == 38 )
		goto tr6;
	goto st0;
st261:
case 261:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out261;
	if ( (*pdaRun->p) == 62 )
		goto tr438;
	goto tr437;
st263:
case 263:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out263;
	if ( (*pdaRun->p) == 58 )
		goto tr441;
	goto tr440;
st264:
case 264:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out264;
	if ( (*pdaRun->p) == 61 )
		goto tr443;
	goto tr442;
st265:
case 265:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out265;
	if ( (*pdaRun->p) == 61 )
		goto tr445;
	goto tr444;
st266:
case 266:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out266;
	if ( (*pdaRun->p) == 61 )
		goto tr447;
	goto tr446;
st5:
case 5:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out5;
	switch( (*pdaRun->p) ) {
		case 32: goto st0;
		case 93: goto tr8;
	}
	if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
		goto st0;
	goto st268;
st268:
case 268:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out268;
	switch( (*pdaRun->p) ) {
		case 32: goto tr449;
		case 93: goto tr449;
	}
	if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
		goto tr449;
	goto st268;
st269:
case 269:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out269;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 99: goto st270;
		case 108: goto st273;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
tr408:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 136;}
	goto st267;
tr455:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 56;}
	goto st267;
tr458:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 82;}
	goto st267;
tr462:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 104;}
	goto st267;
tr465:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 76;}
	goto st267;
tr469:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 98;}
	goto st267;
tr470:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 94;}
	goto st267;
tr475:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 84;}
	goto st267;
tr483:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 28;}
	goto st267;
tr486:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 116;}
	goto st267;
tr493:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 100;}
	goto st267;
tr499:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 52;}
	goto st267;
tr501:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 50;}
	goto st267;
tr502:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 6;}
	goto st267;
tr503:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 92;}
	goto st267;
tr507:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 72;}
	goto st267;
tr512:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 126;}
	goto st267;
tr513:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 42;}
	goto st267;
tr518:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 90;}
	goto st267;
tr519:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 44;}
	goto st267;
tr526:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 12;}
	goto st267;
tr529:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 102;}
	goto st267;
tr533:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 134;}
	goto st267;
tr535:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 68;}
	goto st267;
tr539:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 4;}
	goto st267;
tr540:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 128;}
	goto st267;
tr547:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 60;}
	goto st267;
tr551:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 114;}
	goto st267;
tr563:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 108;}
	goto st267;
tr565:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 110;}
	goto st267;
tr569:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 64;}
	goto st267;
tr571:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 30;}
	goto st267;
tr582:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 38;}
	goto st267;
tr583:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 86;}
	goto st267;
tr585:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 122;}
	goto st267;
tr591:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 132;}
	goto st267;
tr604:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 26;}
	goto st267;
tr607:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 24;}
	goto st267;
tr612:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 88;}
	goto st267;
tr616:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 16;}
	goto st267;
tr617:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 66;}
	goto st267;
tr620:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 10;}
	goto st267;
tr623:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 70;}
	goto st267;
tr634:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 22;}
	goto st267;
tr644:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 80;}
	goto st267;
tr647:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 40;}
	goto st267;
tr650:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 78;}
	goto st267;
tr654:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 32;}
	goto st267;
tr657:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 74;}
	goto st267;
tr660:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 130;}
	goto st267;
tr671:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 36;}
	goto st267;
tr675:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 118;}
	goto st267;
tr679:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 96;}
	goto st267;
tr685:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 8;}
	goto st267;
tr687:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 124;}
	goto st267;
tr691:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 112;}
	goto st267;
tr694:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 106;}
	goto st267;
tr698:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 48;}
	goto st267;
tr702:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 46;}
	goto st267;
st267:
case 267:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out267;
	if ( (*pdaRun->p) == 95 )
		goto tr408;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr448;
st270:
case 270:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out270;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 99: goto st271;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st271:
case 271:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out271;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 117: goto st272;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st272:
case 272:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out272;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 109: goto tr455;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st273:
case 273:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out273;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 105: goto st274;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st274:
case 274:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out274;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 97: goto st275;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st275:
case 275:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out275;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 115: goto tr458;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st276:
case 276:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out276;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 111: goto st277;
		case 114: goto st279;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st277:
case 277:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out277;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 111: goto st278;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st278:
case 278:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out278;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 108: goto tr462;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st279:
case 279:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out279;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto st280;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st280:
case 280:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out280;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 97: goto st281;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st281:
case 281:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out281;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 107: goto tr465;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st282:
case 282:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out282;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 97: goto st283;
		case 111: goto st285;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st283:
case 283:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out283;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 115: goto st284;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st284:
case 284:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out284;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto tr469;
		case 116: goto tr470;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st285:
case 285:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out285;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 109: goto st286;
		case 110: goto st289;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st286:
case 286:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out286;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 109: goto st287;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st287:
case 287:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out287;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 105: goto st288;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st288:
case 288:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out288;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 116: goto tr475;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st289:
case 289:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out289;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 115: goto st290;
		case 116: goto st295;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st290:
case 290:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out290;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 116: goto st291;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr478;
st291:
case 291:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out291;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 114: goto st292;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st292:
case 292:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out292;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 117: goto st293;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st293:
case 293:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out293;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 99: goto st294;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st294:
case 294:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out294;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 116: goto tr483;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st295:
case 295:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out295;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto st296;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st296:
case 296:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out296;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 120: goto st297;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st297:
case 297:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out297;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 116: goto tr486;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st298:
case 298:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out298;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto st299;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st299:
case 299:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out299;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 102: goto st300;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st300:
case 300:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out300;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 97: goto st301;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr489;
st301:
case 301:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out301;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 117: goto st302;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st302:
case 302:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out302;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 108: goto st303;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st303:
case 303:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out303;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 116: goto tr493;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st304:
case 304:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out304;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 108: goto st305;
		case 110: goto st308;
		case 111: goto st309;
		case 120: goto st310;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st305:
case 305:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out305;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 115: goto st306;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st306:
case 306:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out306;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto tr499;
		case 105: goto st307;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st307:
case 307:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out307;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 102: goto tr501;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st308:
case 308:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out308;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 100: goto tr502;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st309:
case 309:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out309;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 115: goto tr503;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st310:
case 310:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out310;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 112: goto st311;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st311:
case 311:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out311;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 111: goto st312;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st312:
case 312:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out312;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 114: goto st313;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st313:
case 313:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out313;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 116: goto tr507;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st314:
case 314:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out314;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 97: goto st315;
		case 111: goto st318;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st315:
case 315:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out315;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 108: goto st316;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st316:
case 316:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out316;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 115: goto st317;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st317:
case 317:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out317;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto tr512;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st318:
case 318:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out318;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 114: goto tr513;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st319:
case 319:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out319;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 108: goto st320;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st320:
case 320:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out320;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 111: goto st321;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st321:
case 321:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out321;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 98: goto st322;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st322:
case 322:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out322;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 97: goto st323;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st323:
case 323:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out323;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 108: goto tr518;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st324:
case 324:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out324;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 102: goto tr519;
		case 103: goto st325;
		case 110: goto st329;
		case 116: goto st334;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st325:
case 325:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out325;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 110: goto st326;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st326:
case 326:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out326;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 111: goto st327;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st327:
case 327:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out327;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 114: goto st328;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st328:
case 328:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out328;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto tr526;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st329:
case 329:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out329;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 99: goto st330;
		case 116: goto tr529;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr527;
st330:
case 330:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out330;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 108: goto st331;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st331:
case 331:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out331;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 117: goto st332;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st332:
case 332:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out332;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 100: goto st333;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st333:
case 333:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out333;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto tr533;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st334:
case 334:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out334;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto st335;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st335:
case 335:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out335;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 114: goto tr535;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st336:
case 336:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out336;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto st337;
		case 105: goto st339;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st337:
case 337:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out337;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 102: goto st338;
		case 120: goto tr539;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st338:
case 338:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out338;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 116: goto tr540;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st339:
case 339:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out339;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 115: goto st340;
		case 116: goto st344;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st340:
case 340:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out340;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 116: goto st341;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st341:
case 341:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out341;
	if ( (*pdaRun->p) == 95 )
		goto st342;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr544;
st342:
case 342:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out342;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto st343;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st343:
case 343:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out343;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 108: goto tr547;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st344:
case 344:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out344;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto st345;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st345:
case 345:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out345;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 114: goto st346;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st346:
case 346:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out346;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 97: goto st347;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st347:
case 347:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out347;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 108: goto tr551;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st348:
case 348:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out348;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 97: goto st349;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st349:
case 349:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out349;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 107: goto st350;
		case 112: goto st359;
		case 116: goto st362;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st350:
case 350:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out350;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto st351;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st351:
case 351:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out351;
	if ( (*pdaRun->p) == 95 )
		goto st352;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st352:
case 352:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out352;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 116: goto st353;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st353:
case 353:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out353;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 111: goto st354;
		case 114: goto st357;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st354:
case 354:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out354;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 107: goto st355;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st355:
case 355:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out355;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto st356;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st356:
case 356:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out356;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 110: goto tr563;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st357:
case 357:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out357;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto st358;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st358:
case 358:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out358;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto tr565;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st359:
case 359:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out359;
	if ( (*pdaRun->p) == 95 )
		goto st360;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr566;
st360:
case 360:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out360;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto st361;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st361:
case 361:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out361;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 108: goto tr569;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st362:
case 362:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out362;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 99: goto st363;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st363:
case 363:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out363;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 104: goto tr571;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st364:
case 364:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out364;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 97: goto st365;
		case 101: goto st372;
		case 105: goto st373;
		case 111: goto st374;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st365:
case 365:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out365;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 109: goto st366;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st366:
case 366:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out366;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto st367;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st367:
case 367:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out367;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 115: goto st368;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st368:
case 368:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out368;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 112: goto st369;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st369:
case 369:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out369;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 97: goto st370;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st370:
case 370:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out370;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 99: goto st371;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st371:
case 371:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out371;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto tr582;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st372:
case 372:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out372;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 119: goto tr583;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st373:
case 373:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out373;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 108: goto tr585;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr584;
st374:
case 374:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out374;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 110: goto st375;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st375:
case 375:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out375;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 97: goto st376;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st376:
case 376:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out376;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 115: goto st377;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st377:
case 377:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out377;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 115: goto st378;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st378:
case 378:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out378;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 111: goto st379;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st379:
case 379:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out379;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 99: goto tr591;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st380:
case 380:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out380;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 97: goto st381;
		case 114: goto st392;
		case 116: goto st399;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st381:
case 381:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out381;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 114: goto st382;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st382:
case 382:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out382;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 115: goto st383;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st383:
case 383:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out383;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto st384;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st384:
case 384:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out384;
	switch( (*pdaRun->p) ) {
		case 95: goto st385;
		case 114: goto tr455;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr598;
st385:
case 385:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out385;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 115: goto st386;
		case 116: goto st389;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st386:
case 386:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out386;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 116: goto st387;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st387:
case 387:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out387;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 111: goto st388;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st388:
case 388:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out388;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 112: goto tr604;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st389:
case 389:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out389;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 114: goto st390;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st390:
case 390:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out390;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto st391;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st391:
case 391:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out391;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto tr607;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st392:
case 392:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out392;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto st393;
		case 105: goto st396;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st393:
case 393:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out393;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto st394;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st394:
case 394:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out394;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 111: goto st395;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st395:
case 395:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out395;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 102: goto tr612;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st396:
case 396:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out396;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 110: goto st397;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st397:
case 397:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out397;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 116: goto st398;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st398:
case 398:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out398;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 115: goto tr616;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr615;
st399:
case 399:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out399;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 114: goto tr617;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st400:
case 400:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out400;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto st401;
		case 105: goto st431;
		case 108: goto tr620;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st401:
case 401:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out401;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 97: goto st402;
		case 100: goto st410;
		case 102: goto tr623;
		case 106: goto st421;
		case 113: goto st424;
		case 116: goto st428;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st402:
case 402:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out402;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 100: goto st403;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st403:
case 403:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out403;
	if ( (*pdaRun->p) == 95 )
		goto st404;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st404:
case 404:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out404;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 114: goto st405;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st405:
case 405:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out405;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto st406;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st406:
case 406:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out406;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 100: goto st407;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st407:
case 407:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out407;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 117: goto st408;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st408:
case 408:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out408;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 99: goto st409;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st409:
case 409:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out409;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto tr634;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st410:
case 410:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out410;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 117: goto st411;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st411:
case 411:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out411;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 99: goto st412;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st412:
case 412:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out412;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto st413;
		case 116: goto st418;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st413:
case 413:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out413;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 102: goto st414;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr639;
st414:
case 414:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out414;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 105: goto st415;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st415:
case 415:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out415;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 114: goto st416;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st416:
case 416:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out416;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 115: goto st417;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st417:
case 417:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out417;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 116: goto tr644;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st418:
case 418:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out418;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 105: goto st419;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st419:
case 419:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out419;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 111: goto st420;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st420:
case 420:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out420;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 110: goto tr647;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st421:
case 421:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out421;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto st422;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st422:
case 422:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out422;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 99: goto st423;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st423:
case 423:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out423;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 116: goto tr650;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st424:
case 424:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out424;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 117: goto st425;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st425:
case 425:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out425;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 105: goto st426;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st426:
case 426:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out426;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 114: goto st427;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st427:
case 427:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out427;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto tr654;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st428:
case 428:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out428;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 117: goto st429;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st429:
case 429:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out429;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 114: goto st430;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st430:
case 430:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out430;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 110: goto tr657;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st431:
case 431:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out431;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 103: goto st432;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st432:
case 432:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out432;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 104: goto st433;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st433:
case 433:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out433;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 116: goto tr660;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st434:
case 434:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out434;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto st435;
		case 116: goto st442;
		case 119: goto st446;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st435:
case 435:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out435;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 110: goto st436;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st436:
case 436:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out436;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 100: goto st437;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st437:
case 437:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out437;
	if ( (*pdaRun->p) == 95 )
		goto st438;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr666;
st438:
case 438:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out438;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 116: goto st439;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st439:
case 439:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out439;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 114: goto st440;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st440:
case 440:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out440;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto st441;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st441:
case 441:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out441;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto tr671;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st442:
case 442:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out442;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 114: goto st443;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st443:
case 443:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out443;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 117: goto st444;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st444:
case 444:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out444;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 99: goto st445;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st445:
case 445:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out445;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 116: goto tr675;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st446:
case 446:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out446;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 105: goto st447;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st447:
case 447:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out447;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 116: goto st448;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st448:
case 448:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out448;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 99: goto st449;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st449:
case 449:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out449;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 104: goto tr679;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st450:
case 450:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out450;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 111: goto st451;
		case 114: goto st454;
		case 121: goto st456;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st451:
case 451:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out451;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 107: goto st452;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st452:
case 452:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out452;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto st453;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st453:
case 453:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out453;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 110: goto tr685;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st454:
case 454:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out454;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 117: goto st455;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st455:
case 455:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out455;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto tr687;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st456:
case 456:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out456;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 112: goto st457;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st457:
case 457:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out457;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto st458;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st458:
case 458:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out458;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 105: goto st459;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st459:
case 459:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out459;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 100: goto tr691;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st460:
case 460:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out460;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 111: goto st461;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st461:
case 461:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out461;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 105: goto st462;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st462:
case 462:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out462;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 100: goto tr694;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st463:
case 463:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out463;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 104: goto st464;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st464:
case 464:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out464;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 105: goto st465;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st465:
case 465:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out465;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 108: goto st466;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st466:
case 466:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out466;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto tr698;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st467:
case 467:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out467;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 105: goto st468;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st468:
case 468:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out468;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 101: goto st469;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st469:
case 469:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out469;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 108: goto st470;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st470:
case 470:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out470;
	switch( (*pdaRun->p) ) {
		case 95: goto tr408;
		case 100: goto tr702;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr408;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr408;
	} else
		goto tr408;
	goto tr450;
st471:
case 471:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out471;
	if ( (*pdaRun->p) == 124 )
		goto tr704;
	goto tr703;
st262:
case 262:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out262;
	if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
		goto st262;
	goto tr439;
tr10:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 109;
	goto out;
}
	goto st472;
tr706:
	{	pdaRun->matched_token = 108;
	goto out;
}
	goto st472;
st472:
case 472:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out472;
	{pdaRun->tokstart = pdaRun->p;}
	switch( (*pdaRun->p) ) {
		case 32: goto st473;
		case 35: goto st6;
	}
	if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
		goto st473;
	goto st0;
st473:
case 473:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out473;
	if ( (*pdaRun->p) == 32 )
		goto st473;
	if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
		goto st473;
	goto tr706;
st6:
case 6:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out6;
	if ( (*pdaRun->p) == 10 )
		goto tr10;
	goto st6;
tr12:
	{	pdaRun->toklen = pdaRun->tokend;
	switch( pdaRun->act ) {
	case 0: goto st0;
	case 221:
	pdaRun->matched_token = 114;
	break;
	}
		goto skip_toklen;
}
	goto st474;
tr707:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 111;
	goto out;
}
	goto st474;
tr708:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 110;
	goto out;
}
	goto st474;
tr709:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 112;
	goto out;
}
	goto st474;
tr711:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 113;
	goto out;
}
	goto st474;
tr712:
	{	pdaRun->matched_token = 114;
	goto out;
}
	goto st474;
st474:
	{pdaRun->act = 0;}
case 474:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out474;
	{pdaRun->tokstart = pdaRun->p;}
	switch( (*pdaRun->p) ) {
		case 10: goto tr707;
		case 34: goto tr708;
		case 91: goto tr709;
		case 92: goto st7;
		case 93: goto tr711;
	}
	goto tr11;
st7:
case 7:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out7;
	goto tr11;
tr11:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 221;}
	goto st475;
st475:
case 475:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out475;
	switch( (*pdaRun->p) ) {
		case 10: goto tr712;
		case 34: goto tr712;
		case 92: goto st7;
	}
	if ( 91 <= (*pdaRun->p) && (*pdaRun->p) <= 93 )
		goto tr712;
	goto tr11;
tr14:
	{	pdaRun->toklen = pdaRun->tokend;
	switch( pdaRun->act ) {
	case 0: goto st0;
	case 222:
	pdaRun->matched_token = 114;
	break;
	}
		goto skip_toklen;
}
	goto st476;
tr713:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 111;
	goto out;
}
	goto st476;
tr714:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 110;
	goto out;
}
	goto st476;
tr715:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 112;
	goto out;
}
	goto st476;
tr717:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 113;
	goto out;
}
	goto st476;
tr718:
	{	pdaRun->matched_token = 114;
	goto out;
}
	goto st476;
st476:
	{pdaRun->act = 0;}
case 476:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out476;
	{pdaRun->tokstart = pdaRun->p;}
	switch( (*pdaRun->p) ) {
		case 10: goto tr713;
		case 34: goto tr714;
		case 91: goto tr715;
		case 92: goto st8;
		case 93: goto tr717;
	}
	goto tr13;
st8:
case 8:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out8;
	goto tr13;
tr13:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 222;}
	goto st477;
st477:
case 477:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out477;
	switch( (*pdaRun->p) ) {
		case 10: goto tr718;
		case 34: goto tr718;
		case 92: goto st8;
	}
	if ( 91 <= (*pdaRun->p) && (*pdaRun->p) <= 93 )
		goto tr718;
	goto tr13;
tr719:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 169;
	goto out;
}
	goto st478;
st478:
case 478:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out478;
	{pdaRun->tokstart = pdaRun->p;}
	goto tr719;
tr16:
	{	pdaRun->toklen = pdaRun->tokend;
	switch( pdaRun->act ) {
	case 0: goto st0;
	case 227:
	pdaRun->matched_token = 117;
	break;
	}
		goto skip_toklen;
}
	goto st479;
tr720:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 116;
	goto out;
}
	goto st479;
tr721:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 115;
	goto out;
}
	goto st479;
tr723:
	{	pdaRun->matched_token = 117;
	goto out;
}
	goto st479;
st479:
	{pdaRun->act = 0;}
case 479:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out479;
	{pdaRun->tokstart = pdaRun->p;}
	switch( (*pdaRun->p) ) {
		case 10: goto tr720;
		case 39: goto tr721;
		case 92: goto st9;
	}
	goto tr15;
st9:
case 9:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out9;
	goto tr15;
tr15:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 227;}
	goto st480;
st480:
case 480:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out480;
	switch( (*pdaRun->p) ) {
		case 10: goto tr723;
		case 39: goto tr723;
		case 92: goto st9;
	}
	goto tr15;
tr18:
	{	pdaRun->toklen = pdaRun->tokend;
	switch( pdaRun->act ) {
	case 0: goto st0;
	case 228:
	pdaRun->matched_token = 117;
	break;
	}
		goto skip_toklen;
}
	goto st481;
tr724:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 116;
	goto out;
}
	goto st481;
tr725:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 115;
	goto out;
}
	goto st481;
tr727:
	{	pdaRun->matched_token = 117;
	goto out;
}
	goto st481;
st481:
	{pdaRun->act = 0;}
case 481:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out481;
	{pdaRun->tokstart = pdaRun->p;}
	switch( (*pdaRun->p) ) {
		case 10: goto tr724;
		case 39: goto tr725;
		case 92: goto st10;
	}
	goto tr17;
st10:
case 10:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out10;
	goto tr17;
tr17:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 228;}
	goto st482;
st482:
case 482:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out482;
	switch( (*pdaRun->p) ) {
		case 10: goto tr727;
		case 39: goto tr727;
		case 92: goto st10;
	}
	goto tr17;
tr728:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 170;
	goto out;
}
	goto st483;
st483:
case 483:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out483;
	{pdaRun->tokstart = pdaRun->p;}
	goto tr728;
tr730:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 118;
	goto out;
}
	goto st484;
tr731:
	{	pdaRun->matched_token = 119;
	goto out;
}
	goto st484;
st484:
case 484:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out484;
	{pdaRun->tokstart = pdaRun->p;}
	if ( (*pdaRun->p) == 10 )
		goto tr730;
	goto st485;
st485:
case 485:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out485;
	if ( (*pdaRun->p) == 10 )
		goto tr731;
	goto st485;
tr733:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 118;
	goto out;
}
	goto st486;
tr734:
	{	pdaRun->matched_token = 119;
	goto out;
}
	goto st486;
st486:
case 486:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out486;
	{pdaRun->tokstart = pdaRun->p;}
	if ( (*pdaRun->p) == 10 )
		goto tr733;
	goto st487;
st487:
case 487:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out487;
	if ( (*pdaRun->p) == 10 )
		goto tr734;
	goto st487;
tr735:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 171;
	goto out;
}
	goto st488;
st488:
case 488:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out488;
	{pdaRun->tokstart = pdaRun->p;}
	goto tr735;
tr23:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 144;
	goto out;
}
	goto st489;
tr26:
	{	pdaRun->toklen = pdaRun->tokend;
	pdaRun->matched_token = 121;
	goto skip_toklen;
}
	goto st489;
tr29:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 142;
	goto out;
}
	goto st489;
tr737:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 126;
	goto out;
}
	goto st489;
tr738:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 128;
	goto out;
}
	goto st489;
tr739:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 129;
	goto out;
}
	goto st489;
tr741:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 133;
	goto out;
}
	goto st489;
tr744:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 138;
	goto out;
}
	goto st489;
tr749:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 132;
	goto out;
}
	goto st489;
tr752:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 134;
	goto out;
}
	goto st489;
tr753:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 125;
	goto out;
}
	goto st489;
tr754:
	{	pdaRun->matched_token = 143;
	goto out;
}
	goto st489;
tr755:
	{	pdaRun->matched_token = 123;
	goto out;
}
	goto st489;
tr756:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 123;
	goto out;
}
	goto st489;
tr757:
	{	pdaRun->matched_token = 130;
	goto out;
}
	goto st489;
tr758:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 131;
	goto out;
}
	goto st489;
tr759:
	{	pdaRun->matched_token = 127;
	goto out;
}
	goto st489;
tr760:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 139;
	goto out;
}
	goto st489;
tr761:
	{	pdaRun->matched_token = 124;
	goto out;
}
	goto st489;
tr762:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 135;
	goto out;
}
	goto st489;
tr763:
	{	pdaRun->matched_token = 121;
	goto out;
}
	goto st489;
tr765:
	{	pdaRun->matched_token = 122;
	goto out;
}
	goto st489;
tr766:
	{	pdaRun->matched_token = 140;
	goto out;
}
	goto st489;
tr767:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 141;
	goto out;
}
	goto st489;
tr768:
	{	pdaRun->matched_token = 120;
	goto out;
}
	goto st489;
tr769:
	{	pdaRun->matched_token = 136;
	goto out;
}
	goto st489;
tr770:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 137;
	goto out;
}
	goto st489;
st489:
case 489:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out489;
	{pdaRun->tokstart = pdaRun->p;}
	switch( (*pdaRun->p) ) {
		case 32: goto st490;
		case 34: goto st11;
		case 35: goto st13;
		case 38: goto tr737;
		case 39: goto st14;
		case 40: goto tr738;
		case 41: goto tr739;
		case 42: goto st492;
		case 43: goto tr741;
		case 45: goto st493;
		case 46: goto st494;
		case 47: goto tr744;
		case 48: goto tr745;
		case 58: goto st17;
		case 60: goto st18;
		case 63: goto tr749;
		case 91: goto st500;
		case 94: goto tr752;
		case 95: goto st499;
		case 124: goto tr753;
	}
	if ( (*pdaRun->p) < 49 ) {
		if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
			goto st490;
	} else if ( (*pdaRun->p) > 57 ) {
		if ( (*pdaRun->p) > 90 ) {
			if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
				goto st499;
		} else if ( (*pdaRun->p) >= 65 )
			goto st499;
	} else
		goto st496;
	goto st0;
st490:
case 490:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out490;
	if ( (*pdaRun->p) == 32 )
		goto st490;
	if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
		goto st490;
	goto tr754;
st11:
case 11:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out11;
	switch( (*pdaRun->p) ) {
		case 34: goto st491;
		case 92: goto st12;
	}
	goto st11;
st491:
case 491:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out491;
	if ( (*pdaRun->p) == 105 )
		goto tr756;
	goto tr755;
st12:
case 12:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out12;
	goto st11;
st13:
case 13:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out13;
	if ( (*pdaRun->p) == 10 )
		goto tr23;
	goto st13;
st14:
case 14:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out14;
	switch( (*pdaRun->p) ) {
		case 39: goto st491;
		case 92: goto st15;
	}
	goto st14;
st15:
case 15:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out15;
	goto st14;
st492:
case 492:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out492;
	if ( (*pdaRun->p) == 42 )
		goto tr758;
	goto tr757;
st493:
case 493:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out493;
	if ( (*pdaRun->p) == 45 )
		goto tr760;
	goto tr759;
st494:
case 494:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out494;
	if ( (*pdaRun->p) == 46 )
		goto tr762;
	goto tr761;
tr745:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	goto st495;
st495:
case 495:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out495;
	if ( (*pdaRun->p) == 120 )
		goto st16;
	if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
		goto st496;
	goto tr763;
st16:
case 16:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out16;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st497;
	} else if ( (*pdaRun->p) > 70 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 102 )
			goto st497;
	} else
		goto st497;
	goto tr26;
st497:
case 497:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out497;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st497;
	} else if ( (*pdaRun->p) > 70 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 102 )
			goto st497;
	} else
		goto st497;
	goto tr765;
st496:
case 496:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out496;
	if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
		goto st496;
	goto tr763;
st17:
case 17:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out17;
	if ( (*pdaRun->p) == 62 )
		goto st498;
	goto st0;
st498:
case 498:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out498;
	if ( (*pdaRun->p) == 62 )
		goto tr767;
	goto tr766;
st18:
case 18:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out18;
	if ( (*pdaRun->p) == 58 )
		goto tr29;
	goto st0;
st500:
case 500:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out500;
	if ( (*pdaRun->p) == 94 )
		goto tr770;
	goto tr769;
st499:
case 499:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out499;
	if ( (*pdaRun->p) == 95 )
		goto st499;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st499;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st499;
	} else
		goto st499;
	goto tr768;
tr35:
	{	pdaRun->toklen = pdaRun->tokend;
	pdaRun->matched_token = 121;
	goto skip_toklen;
}
	goto st501;
tr38:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 142;
	goto out;
}
	goto st501;
tr771:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 126;
	goto out;
}
	goto st501;
tr772:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 128;
	goto out;
}
	goto st501;
tr773:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 129;
	goto out;
}
	goto st501;
tr775:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 133;
	goto out;
}
	goto st501;
tr778:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 138;
	goto out;
}
	goto st501;
tr783:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 132;
	goto out;
}
	goto st501;
tr786:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 134;
	goto out;
}
	goto st501;
tr787:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 125;
	goto out;
}
	goto st501;
tr788:
	{	pdaRun->matched_token = 123;
	goto out;
}
	goto st501;
tr789:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 123;
	goto out;
}
	goto st501;
tr790:
	{	pdaRun->matched_token = 130;
	goto out;
}
	goto st501;
tr791:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 131;
	goto out;
}
	goto st501;
tr792:
	{	pdaRun->matched_token = 127;
	goto out;
}
	goto st501;
tr793:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 139;
	goto out;
}
	goto st501;
tr794:
	{	pdaRun->matched_token = 124;
	goto out;
}
	goto st501;
tr795:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 135;
	goto out;
}
	goto st501;
tr796:
	{	pdaRun->matched_token = 121;
	goto out;
}
	goto st501;
tr798:
	{	pdaRun->matched_token = 122;
	goto out;
}
	goto st501;
tr799:
	{	pdaRun->matched_token = 140;
	goto out;
}
	goto st501;
tr800:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 141;
	goto out;
}
	goto st501;
tr801:
	{	pdaRun->matched_token = 120;
	goto out;
}
	goto st501;
tr802:
	{	pdaRun->matched_token = 136;
	goto out;
}
	goto st501;
tr803:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 137;
	goto out;
}
	goto st501;
st501:
case 501:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out501;
	{pdaRun->tokstart = pdaRun->p;}
	switch( (*pdaRun->p) ) {
		case 34: goto st19;
		case 38: goto tr771;
		case 39: goto st21;
		case 40: goto tr772;
		case 41: goto tr773;
		case 42: goto st503;
		case 43: goto tr775;
		case 45: goto st504;
		case 46: goto st505;
		case 47: goto tr778;
		case 48: goto tr779;
		case 58: goto st24;
		case 60: goto st25;
		case 63: goto tr783;
		case 91: goto st511;
		case 94: goto tr786;
		case 95: goto st510;
		case 124: goto tr787;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 49 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st507;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st510;
	} else
		goto st510;
	goto st0;
st19:
case 19:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out19;
	switch( (*pdaRun->p) ) {
		case 34: goto st502;
		case 92: goto st20;
	}
	goto st19;
st502:
case 502:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out502;
	if ( (*pdaRun->p) == 105 )
		goto tr789;
	goto tr788;
st20:
case 20:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out20;
	goto st19;
st21:
case 21:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out21;
	switch( (*pdaRun->p) ) {
		case 39: goto st502;
		case 92: goto st22;
	}
	goto st21;
st22:
case 22:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out22;
	goto st21;
st503:
case 503:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out503;
	if ( (*pdaRun->p) == 42 )
		goto tr791;
	goto tr790;
st504:
case 504:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out504;
	if ( (*pdaRun->p) == 45 )
		goto tr793;
	goto tr792;
st505:
case 505:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out505;
	if ( (*pdaRun->p) == 46 )
		goto tr795;
	goto tr794;
tr779:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	goto st506;
st506:
case 506:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out506;
	if ( (*pdaRun->p) == 120 )
		goto st23;
	if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
		goto st507;
	goto tr796;
st23:
case 23:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out23;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st508;
	} else if ( (*pdaRun->p) > 70 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 102 )
			goto st508;
	} else
		goto st508;
	goto tr35;
st508:
case 508:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out508;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st508;
	} else if ( (*pdaRun->p) > 70 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 102 )
			goto st508;
	} else
		goto st508;
	goto tr798;
st507:
case 507:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out507;
	if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
		goto st507;
	goto tr796;
st24:
case 24:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out24;
	if ( (*pdaRun->p) == 62 )
		goto st509;
	goto st0;
st509:
case 509:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out509;
	if ( (*pdaRun->p) == 62 )
		goto tr800;
	goto tr799;
st25:
case 25:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out25;
	if ( (*pdaRun->p) == 58 )
		goto tr38;
	goto st0;
st511:
case 511:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out511;
	if ( (*pdaRun->p) == 94 )
		goto tr803;
	goto tr802;
st510:
case 510:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out510;
	if ( (*pdaRun->p) == 95 )
		goto st510;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st510;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st510;
	} else
		goto st510;
	goto tr801;
tr40:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 144;
	goto out;
}
	goto st512;
tr805:
	{	pdaRun->matched_token = 143;
	goto out;
}
	goto st512;
st512:
case 512:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out512;
	{pdaRun->tokstart = pdaRun->p;}
	switch( (*pdaRun->p) ) {
		case 32: goto st513;
		case 35: goto st26;
	}
	if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
		goto st513;
	goto st0;
st513:
case 513:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out513;
	if ( (*pdaRun->p) == 32 )
		goto st513;
	if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
		goto st513;
	goto tr805;
st26:
case 26:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out26;
	if ( (*pdaRun->p) == 10 )
		goto tr40;
	goto st26;
tr41:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 146;
	goto out;
}
	goto st514;
tr806:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 145;
	goto out;
}
	goto st514;
tr808:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 147;
	goto out;
}
	goto st514;
st514:
case 514:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out514;
	{pdaRun->tokstart = pdaRun->p;}
	switch( (*pdaRun->p) ) {
		case 45: goto tr806;
		case 92: goto st27;
		case 93: goto tr808;
	}
	goto tr41;
st27:
case 27:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out27;
	goto tr41;
tr42:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 146;
	goto out;
}
	goto st515;
tr809:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 145;
	goto out;
}
	goto st515;
tr811:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 147;
	goto out;
}
	goto st515;
st515:
case 515:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out515;
	{pdaRun->tokstart = pdaRun->p;}
	switch( (*pdaRun->p) ) {
		case 45: goto tr809;
		case 92: goto st28;
		case 93: goto tr811;
	}
	goto tr42;
st28:
case 28:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out28;
	goto tr42;
tr812:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 172;
	goto out;
}
	goto st516;
st516:
case 516:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out516;
	{pdaRun->tokstart = pdaRun->p;}
	goto tr812;
tr46:
	{	pdaRun->toklen = pdaRun->tokend;
	pdaRun->matched_token = 161;
	goto skip_toklen;
}
	goto st517;
tr53:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 151;
	goto out;
}
	goto st517;
tr813:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 161;
	goto out;
}
	goto st517;
tr821:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 148;
	goto out;
}
	goto st517;
tr822:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 149;
	goto out;
}
	goto st517;
tr823:
	{	pdaRun->matched_token = 152;
	goto out;
}
	goto st517;
tr824:
	{	pdaRun->matched_token = 161;
	goto out;
}
	goto st517;
tr825:
	{	pdaRun->matched_token = 153;
	goto out;
}
	goto st517;
tr826:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 153;
	goto out;
}
	goto st517;
tr827:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 154;
	goto out;
}
	goto st517;
tr831:
	{	pdaRun->matched_token = 160;
	goto out;
}
	goto st517;
tr832:
	{	pdaRun->matched_token = 157;
	goto out;
}
	goto st517;
tr833:
	{	pdaRun->matched_token = 158;
	goto out;
}
	goto st517;
tr834:
	{	pdaRun->matched_token = 155;
	goto out;
}
	goto st517;
tr837:
	{	pdaRun->matched_token = 159;
	goto out;
}
	goto st517;
tr838:
	{	pdaRun->matched_token = 156;
	goto out;
}
	goto st517;
tr839:
	{	pdaRun->matched_token = 150;
	goto out;
}
	goto st517;
st517:
case 517:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out517;
	{pdaRun->tokstart = pdaRun->p;}
	switch( (*pdaRun->p) ) {
		case 32: goto st518;
		case 34: goto tr815;
		case 36: goto tr816;
		case 39: goto tr817;
		case 47: goto tr818;
		case 64: goto st528;
		case 95: goto st531;
		case 123: goto tr821;
		case 125: goto tr822;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
			goto st518;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st531;
	} else
		goto st531;
	goto tr813;
st518:
case 518:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out518;
	if ( (*pdaRun->p) == 32 )
		goto st518;
	if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
		goto st518;
	goto tr823;
tr815:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	goto st519;
st519:
case 519:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out519;
	switch( (*pdaRun->p) ) {
		case 34: goto st520;
		case 92: goto st30;
	}
	goto st29;
st520:
case 520:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out520;
	if ( (*pdaRun->p) == 105 )
		goto tr826;
	goto tr825;
st30:
case 30:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out30;
	goto st29;
st29:
case 29:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out29;
	switch( (*pdaRun->p) ) {
		case 34: goto st520;
		case 92: goto st30;
	}
	goto st29;
tr816:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	goto st521;
st521:
case 521:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out521;
	switch( (*pdaRun->p) ) {
		case 36: goto tr827;
		case 42: goto st31;
		case 95: goto st525;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 49 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st524;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st525;
	} else
		goto st525;
	goto tr824;
st31:
case 31:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out31;
	if ( (*pdaRun->p) == 95 )
		goto st523;
	if ( (*pdaRun->p) < 65 ) {
		if ( 49 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st522;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st523;
	} else
		goto st523;
	goto tr46;
st523:
case 523:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out523;
	if ( (*pdaRun->p) == 95 )
		goto st523;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st523;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st523;
	} else
		goto st523;
	goto tr832;
st522:
case 522:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out522;
	if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
		goto st522;
	goto tr831;
st525:
case 525:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out525;
	if ( (*pdaRun->p) == 95 )
		goto st525;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st525;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st525;
	} else
		goto st525;
	goto tr834;
st524:
case 524:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out524;
	if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
		goto st524;
	goto tr833;
tr817:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	goto st526;
st526:
case 526:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out526;
	switch( (*pdaRun->p) ) {
		case 39: goto st520;
		case 92: goto st33;
	}
	goto st32;
st33:
case 33:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out33;
	goto st32;
st32:
case 32:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out32;
	switch( (*pdaRun->p) ) {
		case 39: goto st520;
		case 92: goto st33;
	}
	goto st32;
tr818:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	goto st527;
st527:
case 527:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out527;
	switch( (*pdaRun->p) ) {
		case 42: goto st34;
		case 47: goto st36;
	}
	goto tr824;
st34:
case 34:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out34;
	if ( (*pdaRun->p) == 42 )
		goto st35;
	goto st34;
st35:
case 35:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out35;
	switch( (*pdaRun->p) ) {
		case 42: goto st35;
		case 47: goto tr53;
	}
	goto st34;
st36:
case 36:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out36;
	if ( (*pdaRun->p) == 10 )
		goto tr53;
	goto st36;
st528:
case 528:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out528;
	if ( (*pdaRun->p) == 95 )
		goto st530;
	if ( (*pdaRun->p) < 65 ) {
		if ( 49 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st529;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st530;
	} else
		goto st530;
	goto tr824;
st530:
case 530:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out530;
	if ( (*pdaRun->p) == 95 )
		goto st530;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st530;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st530;
	} else
		goto st530;
	goto tr838;
st529:
case 529:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out529;
	if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
		goto st529;
	goto tr837;
st531:
case 531:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out531;
	if ( (*pdaRun->p) == 95 )
		goto st531;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st531;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st531;
	} else
		goto st531;
	goto tr839;
tr58:
	{	pdaRun->toklen = pdaRun->tokend;
	pdaRun->matched_token = 161;
	goto skip_toklen;
}
	goto st532;
tr65:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 151;
	goto out;
}
	goto st532;
tr840:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 161;
	goto out;
}
	goto st532;
tr848:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 148;
	goto out;
}
	goto st532;
tr849:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 149;
	goto out;
}
	goto st532;
tr850:
	{	pdaRun->matched_token = 152;
	goto out;
}
	goto st532;
tr851:
	{	pdaRun->matched_token = 161;
	goto out;
}
	goto st532;
tr852:
	{	pdaRun->matched_token = 153;
	goto out;
}
	goto st532;
tr853:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 153;
	goto out;
}
	goto st532;
tr854:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 154;
	goto out;
}
	goto st532;
tr858:
	{	pdaRun->matched_token = 160;
	goto out;
}
	goto st532;
tr859:
	{	pdaRun->matched_token = 157;
	goto out;
}
	goto st532;
tr860:
	{	pdaRun->matched_token = 158;
	goto out;
}
	goto st532;
tr861:
	{	pdaRun->matched_token = 155;
	goto out;
}
	goto st532;
tr864:
	{	pdaRun->matched_token = 159;
	goto out;
}
	goto st532;
tr865:
	{	pdaRun->matched_token = 156;
	goto out;
}
	goto st532;
tr866:
	{	pdaRun->matched_token = 150;
	goto out;
}
	goto st532;
st532:
case 532:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out532;
	{pdaRun->tokstart = pdaRun->p;}
	switch( (*pdaRun->p) ) {
		case 32: goto st533;
		case 34: goto tr842;
		case 36: goto tr843;
		case 39: goto tr844;
		case 47: goto tr845;
		case 64: goto st543;
		case 95: goto st546;
		case 123: goto tr848;
		case 125: goto tr849;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
			goto st533;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st546;
	} else
		goto st546;
	goto tr840;
st533:
case 533:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out533;
	if ( (*pdaRun->p) == 32 )
		goto st533;
	if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
		goto st533;
	goto tr850;
tr842:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	goto st534;
st534:
case 534:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out534;
	switch( (*pdaRun->p) ) {
		case 34: goto st535;
		case 92: goto st38;
	}
	goto st37;
st535:
case 535:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out535;
	if ( (*pdaRun->p) == 105 )
		goto tr853;
	goto tr852;
st38:
case 38:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out38;
	goto st37;
st37:
case 37:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out37;
	switch( (*pdaRun->p) ) {
		case 34: goto st535;
		case 92: goto st38;
	}
	goto st37;
tr843:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	goto st536;
st536:
case 536:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out536;
	switch( (*pdaRun->p) ) {
		case 36: goto tr854;
		case 42: goto st39;
		case 95: goto st540;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 49 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st539;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st540;
	} else
		goto st540;
	goto tr851;
st39:
case 39:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out39;
	if ( (*pdaRun->p) == 95 )
		goto st538;
	if ( (*pdaRun->p) < 65 ) {
		if ( 49 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st537;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st538;
	} else
		goto st538;
	goto tr58;
st538:
case 538:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out538;
	if ( (*pdaRun->p) == 95 )
		goto st538;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st538;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st538;
	} else
		goto st538;
	goto tr859;
st537:
case 537:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out537;
	if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
		goto st537;
	goto tr858;
st540:
case 540:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out540;
	if ( (*pdaRun->p) == 95 )
		goto st540;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st540;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st540;
	} else
		goto st540;
	goto tr861;
st539:
case 539:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out539;
	if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
		goto st539;
	goto tr860;
tr844:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	goto st541;
st541:
case 541:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out541;
	switch( (*pdaRun->p) ) {
		case 39: goto st535;
		case 92: goto st41;
	}
	goto st40;
st41:
case 41:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out41;
	goto st40;
st40:
case 40:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out40;
	switch( (*pdaRun->p) ) {
		case 39: goto st535;
		case 92: goto st41;
	}
	goto st40;
tr845:
	{{ pdaRun->tokend = pdaRun->toklen + ( pdaRun->p - pdaRun->start ) + 1; }}
	goto st542;
st542:
case 542:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out542;
	switch( (*pdaRun->p) ) {
		case 42: goto st42;
		case 47: goto st44;
	}
	goto tr851;
st42:
case 42:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out42;
	if ( (*pdaRun->p) == 42 )
		goto st43;
	goto st42;
st43:
case 43:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out43;
	switch( (*pdaRun->p) ) {
		case 42: goto st43;
		case 47: goto tr65;
	}
	goto st42;
st44:
case 44:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out44;
	if ( (*pdaRun->p) == 10 )
		goto tr65;
	goto st44;
st543:
case 543:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out543;
	if ( (*pdaRun->p) == 95 )
		goto st545;
	if ( (*pdaRun->p) < 65 ) {
		if ( 49 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st544;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st545;
	} else
		goto st545;
	goto tr851;
st545:
case 545:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out545;
	if ( (*pdaRun->p) == 95 )
		goto st545;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st545;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st545;
	} else
		goto st545;
	goto tr865;
st544:
case 544:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out544;
	if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
		goto st544;
	goto tr864;
st546:
case 546:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out546;
	if ( (*pdaRun->p) == 95 )
		goto st546;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st546;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st546;
	} else
		goto st546;
	goto tr866;
tr867:
	{	pdaRun->p += 1;
	pdaRun->matched_token = 173;
	goto out;
}
	goto st547;
st547:
case 547:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out547;
	{pdaRun->tokstart = pdaRun->p;}
	goto tr867;
	}
out_switch:
	switch ( pdaRun->fsm_cs )
	{
	case 45: out45: pdaRun->fsm_cs = 45; goto out; 
	case 46: out46: if ( pdaRun->scan_eof ) {goto tr116;
}pdaRun->fsm_cs = 46; goto out; 
	case 47: out47: if ( pdaRun->scan_eof ) {goto tr117;
}pdaRun->fsm_cs = 47; goto out; 
	case 1: out1: pdaRun->fsm_cs = 1; goto out; 
	case 2: out2: pdaRun->fsm_cs = 2; goto out; 
	case 0: out0: pdaRun->fsm_cs = 0; goto out; 
	case 48: out48: if ( pdaRun->scan_eof ) {goto tr119;
}pdaRun->fsm_cs = 48; goto out; 
	case 50: out50: if ( pdaRun->scan_eof ) {goto tr122;
}pdaRun->fsm_cs = 50; goto out; 
	case 51: out51: if ( pdaRun->scan_eof ) {goto tr124;
}pdaRun->fsm_cs = 51; goto out; 
	case 52: out52: if ( pdaRun->scan_eof ) {goto tr126;
}pdaRun->fsm_cs = 52; goto out; 
	case 53: out53: if ( pdaRun->scan_eof ) {goto tr128;
}pdaRun->fsm_cs = 53; goto out; 
	case 3: out3: pdaRun->fsm_cs = 3; goto out; 
	case 55: out55: if ( pdaRun->scan_eof ) {goto tr131;
}pdaRun->fsm_cs = 55; goto out; 
	case 56: out56: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 56; goto out; 
	case 54: out54: if ( pdaRun->scan_eof ) {goto tr130;
}pdaRun->fsm_cs = 54; goto out; 
	case 57: out57: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 57; goto out; 
	case 58: out58: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 58; goto out; 
	case 59: out59: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 59; goto out; 
	case 60: out60: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 60; goto out; 
	case 61: out61: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 61; goto out; 
	case 62: out62: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 62; goto out; 
	case 63: out63: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 63; goto out; 
	case 64: out64: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 64; goto out; 
	case 65: out65: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 65; goto out; 
	case 66: out66: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 66; goto out; 
	case 67: out67: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 67; goto out; 
	case 68: out68: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 68; goto out; 
	case 69: out69: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 69; goto out; 
	case 70: out70: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 70; goto out; 
	case 71: out71: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 71; goto out; 
	case 72: out72: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 72; goto out; 
	case 73: out73: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 73; goto out; 
	case 74: out74: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 74; goto out; 
	case 75: out75: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 75; goto out; 
	case 76: out76: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 76; goto out; 
	case 77: out77: if ( pdaRun->scan_eof ) {goto tr160;
}pdaRun->fsm_cs = 77; goto out; 
	case 78: out78: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 78; goto out; 
	case 79: out79: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 79; goto out; 
	case 80: out80: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 80; goto out; 
	case 81: out81: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 81; goto out; 
	case 82: out82: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 82; goto out; 
	case 83: out83: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 83; goto out; 
	case 84: out84: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 84; goto out; 
	case 85: out85: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 85; goto out; 
	case 86: out86: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 86; goto out; 
	case 87: out87: if ( pdaRun->scan_eof ) {goto tr171;
}pdaRun->fsm_cs = 87; goto out; 
	case 88: out88: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 88; goto out; 
	case 89: out89: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 89; goto out; 
	case 90: out90: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 90; goto out; 
	case 91: out91: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 91; goto out; 
	case 92: out92: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 92; goto out; 
	case 93: out93: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 93; goto out; 
	case 94: out94: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 94; goto out; 
	case 95: out95: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 95; goto out; 
	case 96: out96: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 96; goto out; 
	case 97: out97: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 97; goto out; 
	case 98: out98: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 98; goto out; 
	case 99: out99: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 99; goto out; 
	case 100: out100: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 100; goto out; 
	case 101: out101: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 101; goto out; 
	case 102: out102: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 102; goto out; 
	case 103: out103: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 103; goto out; 
	case 104: out104: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 104; goto out; 
	case 105: out105: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 105; goto out; 
	case 106: out106: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 106; goto out; 
	case 107: out107: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 107; goto out; 
	case 108: out108: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 108; goto out; 
	case 109: out109: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 109; goto out; 
	case 110: out110: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 110; goto out; 
	case 111: out111: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 111; goto out; 
	case 112: out112: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 112; goto out; 
	case 113: out113: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 113; goto out; 
	case 114: out114: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 114; goto out; 
	case 115: out115: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 115; goto out; 
	case 116: out116: if ( pdaRun->scan_eof ) {goto tr209;
}pdaRun->fsm_cs = 116; goto out; 
	case 117: out117: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 117; goto out; 
	case 118: out118: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 118; goto out; 
	case 119: out119: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 119; goto out; 
	case 120: out120: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 120; goto out; 
	case 121: out121: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 121; goto out; 
	case 122: out122: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 122; goto out; 
	case 123: out123: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 123; goto out; 
	case 124: out124: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 124; goto out; 
	case 125: out125: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 125; goto out; 
	case 126: out126: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 126; goto out; 
	case 127: out127: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 127; goto out; 
	case 128: out128: if ( pdaRun->scan_eof ) {goto tr226;
}pdaRun->fsm_cs = 128; goto out; 
	case 129: out129: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 129; goto out; 
	case 130: out130: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 130; goto out; 
	case 131: out131: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 131; goto out; 
	case 132: out132: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 132; goto out; 
	case 133: out133: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 133; goto out; 
	case 134: out134: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 134; goto out; 
	case 135: out135: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 135; goto out; 
	case 136: out136: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 136; goto out; 
	case 137: out137: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 137; goto out; 
	case 138: out138: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 138; goto out; 
	case 139: out139: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 139; goto out; 
	case 140: out140: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 140; goto out; 
	case 141: out141: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 141; goto out; 
	case 142: out142: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 142; goto out; 
	case 143: out143: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 143; goto out; 
	case 144: out144: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 144; goto out; 
	case 145: out145: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 145; goto out; 
	case 146: out146: if ( pdaRun->scan_eof ) {goto tr248;
}pdaRun->fsm_cs = 146; goto out; 
	case 147: out147: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 147; goto out; 
	case 148: out148: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 148; goto out; 
	case 149: out149: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 149; goto out; 
	case 150: out150: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 150; goto out; 
	case 151: out151: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 151; goto out; 
	case 152: out152: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 152; goto out; 
	case 153: out153: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 153; goto out; 
	case 154: out154: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 154; goto out; 
	case 155: out155: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 155; goto out; 
	case 156: out156: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 156; goto out; 
	case 157: out157: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 157; goto out; 
	case 158: out158: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 158; goto out; 
	case 159: out159: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 159; goto out; 
	case 160: out160: if ( pdaRun->scan_eof ) {goto tr266;
}pdaRun->fsm_cs = 160; goto out; 
	case 161: out161: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 161; goto out; 
	case 162: out162: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 162; goto out; 
	case 163: out163: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 163; goto out; 
	case 164: out164: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 164; goto out; 
	case 165: out165: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 165; goto out; 
	case 166: out166: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 166; goto out; 
	case 167: out167: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 167; goto out; 
	case 168: out168: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 168; goto out; 
	case 169: out169: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 169; goto out; 
	case 170: out170: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 170; goto out; 
	case 171: out171: if ( pdaRun->scan_eof ) {goto tr280;
}pdaRun->fsm_cs = 171; goto out; 
	case 172: out172: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 172; goto out; 
	case 173: out173: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 173; goto out; 
	case 174: out174: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 174; goto out; 
	case 175: out175: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 175; goto out; 
	case 176: out176: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 176; goto out; 
	case 177: out177: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 177; goto out; 
	case 178: out178: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 178; goto out; 
	case 179: out179: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 179; goto out; 
	case 180: out180: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 180; goto out; 
	case 181: out181: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 181; goto out; 
	case 182: out182: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 182; goto out; 
	case 183: out183: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 183; goto out; 
	case 184: out184: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 184; goto out; 
	case 185: out185: if ( pdaRun->scan_eof ) {goto tr297;
}pdaRun->fsm_cs = 185; goto out; 
	case 186: out186: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 186; goto out; 
	case 187: out187: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 187; goto out; 
	case 188: out188: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 188; goto out; 
	case 189: out189: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 189; goto out; 
	case 190: out190: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 190; goto out; 
	case 191: out191: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 191; goto out; 
	case 192: out192: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 192; goto out; 
	case 193: out193: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 193; goto out; 
	case 194: out194: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 194; goto out; 
	case 195: out195: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 195; goto out; 
	case 196: out196: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 196; goto out; 
	case 197: out197: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 197; goto out; 
	case 198: out198: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 198; goto out; 
	case 199: out199: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 199; goto out; 
	case 200: out200: if ( pdaRun->scan_eof ) {goto tr321;
}pdaRun->fsm_cs = 200; goto out; 
	case 201: out201: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 201; goto out; 
	case 202: out202: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 202; goto out; 
	case 203: out203: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 203; goto out; 
	case 204: out204: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 204; goto out; 
	case 205: out205: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 205; goto out; 
	case 206: out206: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 206; goto out; 
	case 207: out207: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 207; goto out; 
	case 208: out208: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 208; goto out; 
	case 209: out209: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 209; goto out; 
	case 210: out210: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 210; goto out; 
	case 211: out211: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 211; goto out; 
	case 212: out212: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 212; goto out; 
	case 213: out213: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 213; goto out; 
	case 214: out214: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 214; goto out; 
	case 215: out215: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 215; goto out; 
	case 216: out216: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 216; goto out; 
	case 217: out217: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 217; goto out; 
	case 218: out218: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 218; goto out; 
	case 219: out219: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 219; goto out; 
	case 220: out220: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 220; goto out; 
	case 221: out221: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 221; goto out; 
	case 222: out222: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 222; goto out; 
	case 223: out223: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 223; goto out; 
	case 224: out224: if ( pdaRun->scan_eof ) {goto tr348;
}pdaRun->fsm_cs = 224; goto out; 
	case 225: out225: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 225; goto out; 
	case 226: out226: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 226; goto out; 
	case 227: out227: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 227; goto out; 
	case 228: out228: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 228; goto out; 
	case 229: out229: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 229; goto out; 
	case 230: out230: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 230; goto out; 
	case 231: out231: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 231; goto out; 
	case 232: out232: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 232; goto out; 
	case 233: out233: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 233; goto out; 
	case 234: out234: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 234; goto out; 
	case 235: out235: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 235; goto out; 
	case 236: out236: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 236; goto out; 
	case 237: out237: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 237; goto out; 
	case 238: out238: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 238; goto out; 
	case 239: out239: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 239; goto out; 
	case 240: out240: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 240; goto out; 
	case 241: out241: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 241; goto out; 
	case 242: out242: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 242; goto out; 
	case 243: out243: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 243; goto out; 
	case 244: out244: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 244; goto out; 
	case 245: out245: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 245; goto out; 
	case 246: out246: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 246; goto out; 
	case 247: out247: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 247; goto out; 
	case 248: out248: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 248; goto out; 
	case 249: out249: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 249; goto out; 
	case 250: out250: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 250; goto out; 
	case 251: out251: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 251; goto out; 
	case 252: out252: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 252; goto out; 
	case 253: out253: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 253; goto out; 
	case 254: out254: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 254; goto out; 
	case 255: out255: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 255; goto out; 
	case 256: out256: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 256; goto out; 
	case 257: out257: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 257; goto out; 
	case 258: out258: if ( pdaRun->scan_eof ) {goto tr385;
}pdaRun->fsm_cs = 258; goto out; 
	case 49: out49: if ( pdaRun->scan_eof ) {goto tr121;
}pdaRun->fsm_cs = 49; goto out; 
	case 259: out259: pdaRun->fsm_cs = 259; goto out; 
	case 260: out260: if ( pdaRun->scan_eof ) {goto tr435;
}pdaRun->fsm_cs = 260; goto out; 
	case 4: out4: pdaRun->fsm_cs = 4; goto out; 
	case 261: out261: if ( pdaRun->scan_eof ) {goto tr437;
}pdaRun->fsm_cs = 261; goto out; 
	case 263: out263: if ( pdaRun->scan_eof ) {goto tr440;
}pdaRun->fsm_cs = 263; goto out; 
	case 264: out264: if ( pdaRun->scan_eof ) {goto tr442;
}pdaRun->fsm_cs = 264; goto out; 
	case 265: out265: if ( pdaRun->scan_eof ) {goto tr444;
}pdaRun->fsm_cs = 265; goto out; 
	case 266: out266: if ( pdaRun->scan_eof ) {goto tr446;
}pdaRun->fsm_cs = 266; goto out; 
	case 5: out5: pdaRun->fsm_cs = 5; goto out; 
	case 268: out268: if ( pdaRun->scan_eof ) {goto tr449;
}pdaRun->fsm_cs = 268; goto out; 
	case 269: out269: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 269; goto out; 
	case 267: out267: if ( pdaRun->scan_eof ) {goto tr448;
}pdaRun->fsm_cs = 267; goto out; 
	case 270: out270: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 270; goto out; 
	case 271: out271: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 271; goto out; 
	case 272: out272: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 272; goto out; 
	case 273: out273: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 273; goto out; 
	case 274: out274: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 274; goto out; 
	case 275: out275: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 275; goto out; 
	case 276: out276: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 276; goto out; 
	case 277: out277: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 277; goto out; 
	case 278: out278: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 278; goto out; 
	case 279: out279: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 279; goto out; 
	case 280: out280: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 280; goto out; 
	case 281: out281: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 281; goto out; 
	case 282: out282: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 282; goto out; 
	case 283: out283: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 283; goto out; 
	case 284: out284: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 284; goto out; 
	case 285: out285: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 285; goto out; 
	case 286: out286: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 286; goto out; 
	case 287: out287: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 287; goto out; 
	case 288: out288: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 288; goto out; 
	case 289: out289: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 289; goto out; 
	case 290: out290: if ( pdaRun->scan_eof ) {goto tr478;
}pdaRun->fsm_cs = 290; goto out; 
	case 291: out291: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 291; goto out; 
	case 292: out292: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 292; goto out; 
	case 293: out293: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 293; goto out; 
	case 294: out294: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 294; goto out; 
	case 295: out295: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 295; goto out; 
	case 296: out296: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 296; goto out; 
	case 297: out297: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 297; goto out; 
	case 298: out298: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 298; goto out; 
	case 299: out299: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 299; goto out; 
	case 300: out300: if ( pdaRun->scan_eof ) {goto tr489;
}pdaRun->fsm_cs = 300; goto out; 
	case 301: out301: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 301; goto out; 
	case 302: out302: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 302; goto out; 
	case 303: out303: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 303; goto out; 
	case 304: out304: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 304; goto out; 
	case 305: out305: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 305; goto out; 
	case 306: out306: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 306; goto out; 
	case 307: out307: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 307; goto out; 
	case 308: out308: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 308; goto out; 
	case 309: out309: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 309; goto out; 
	case 310: out310: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 310; goto out; 
	case 311: out311: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 311; goto out; 
	case 312: out312: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 312; goto out; 
	case 313: out313: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 313; goto out; 
	case 314: out314: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 314; goto out; 
	case 315: out315: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 315; goto out; 
	case 316: out316: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 316; goto out; 
	case 317: out317: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 317; goto out; 
	case 318: out318: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 318; goto out; 
	case 319: out319: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 319; goto out; 
	case 320: out320: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 320; goto out; 
	case 321: out321: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 321; goto out; 
	case 322: out322: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 322; goto out; 
	case 323: out323: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 323; goto out; 
	case 324: out324: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 324; goto out; 
	case 325: out325: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 325; goto out; 
	case 326: out326: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 326; goto out; 
	case 327: out327: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 327; goto out; 
	case 328: out328: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 328; goto out; 
	case 329: out329: if ( pdaRun->scan_eof ) {goto tr527;
}pdaRun->fsm_cs = 329; goto out; 
	case 330: out330: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 330; goto out; 
	case 331: out331: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 331; goto out; 
	case 332: out332: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 332; goto out; 
	case 333: out333: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 333; goto out; 
	case 334: out334: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 334; goto out; 
	case 335: out335: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 335; goto out; 
	case 336: out336: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 336; goto out; 
	case 337: out337: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 337; goto out; 
	case 338: out338: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 338; goto out; 
	case 339: out339: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 339; goto out; 
	case 340: out340: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 340; goto out; 
	case 341: out341: if ( pdaRun->scan_eof ) {goto tr544;
}pdaRun->fsm_cs = 341; goto out; 
	case 342: out342: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 342; goto out; 
	case 343: out343: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 343; goto out; 
	case 344: out344: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 344; goto out; 
	case 345: out345: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 345; goto out; 
	case 346: out346: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 346; goto out; 
	case 347: out347: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 347; goto out; 
	case 348: out348: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 348; goto out; 
	case 349: out349: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 349; goto out; 
	case 350: out350: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 350; goto out; 
	case 351: out351: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 351; goto out; 
	case 352: out352: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 352; goto out; 
	case 353: out353: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 353; goto out; 
	case 354: out354: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 354; goto out; 
	case 355: out355: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 355; goto out; 
	case 356: out356: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 356; goto out; 
	case 357: out357: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 357; goto out; 
	case 358: out358: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 358; goto out; 
	case 359: out359: if ( pdaRun->scan_eof ) {goto tr566;
}pdaRun->fsm_cs = 359; goto out; 
	case 360: out360: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 360; goto out; 
	case 361: out361: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 361; goto out; 
	case 362: out362: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 362; goto out; 
	case 363: out363: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 363; goto out; 
	case 364: out364: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 364; goto out; 
	case 365: out365: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 365; goto out; 
	case 366: out366: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 366; goto out; 
	case 367: out367: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 367; goto out; 
	case 368: out368: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 368; goto out; 
	case 369: out369: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 369; goto out; 
	case 370: out370: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 370; goto out; 
	case 371: out371: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 371; goto out; 
	case 372: out372: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 372; goto out; 
	case 373: out373: if ( pdaRun->scan_eof ) {goto tr584;
}pdaRun->fsm_cs = 373; goto out; 
	case 374: out374: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 374; goto out; 
	case 375: out375: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 375; goto out; 
	case 376: out376: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 376; goto out; 
	case 377: out377: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 377; goto out; 
	case 378: out378: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 378; goto out; 
	case 379: out379: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 379; goto out; 
	case 380: out380: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 380; goto out; 
	case 381: out381: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 381; goto out; 
	case 382: out382: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 382; goto out; 
	case 383: out383: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 383; goto out; 
	case 384: out384: if ( pdaRun->scan_eof ) {goto tr598;
}pdaRun->fsm_cs = 384; goto out; 
	case 385: out385: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 385; goto out; 
	case 386: out386: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 386; goto out; 
	case 387: out387: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 387; goto out; 
	case 388: out388: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 388; goto out; 
	case 389: out389: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 389; goto out; 
	case 390: out390: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 390; goto out; 
	case 391: out391: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 391; goto out; 
	case 392: out392: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 392; goto out; 
	case 393: out393: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 393; goto out; 
	case 394: out394: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 394; goto out; 
	case 395: out395: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 395; goto out; 
	case 396: out396: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 396; goto out; 
	case 397: out397: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 397; goto out; 
	case 398: out398: if ( pdaRun->scan_eof ) {goto tr615;
}pdaRun->fsm_cs = 398; goto out; 
	case 399: out399: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 399; goto out; 
	case 400: out400: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 400; goto out; 
	case 401: out401: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 401; goto out; 
	case 402: out402: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 402; goto out; 
	case 403: out403: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 403; goto out; 
	case 404: out404: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 404; goto out; 
	case 405: out405: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 405; goto out; 
	case 406: out406: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 406; goto out; 
	case 407: out407: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 407; goto out; 
	case 408: out408: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 408; goto out; 
	case 409: out409: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 409; goto out; 
	case 410: out410: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 410; goto out; 
	case 411: out411: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 411; goto out; 
	case 412: out412: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 412; goto out; 
	case 413: out413: if ( pdaRun->scan_eof ) {goto tr639;
}pdaRun->fsm_cs = 413; goto out; 
	case 414: out414: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 414; goto out; 
	case 415: out415: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 415; goto out; 
	case 416: out416: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 416; goto out; 
	case 417: out417: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 417; goto out; 
	case 418: out418: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 418; goto out; 
	case 419: out419: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 419; goto out; 
	case 420: out420: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 420; goto out; 
	case 421: out421: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 421; goto out; 
	case 422: out422: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 422; goto out; 
	case 423: out423: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 423; goto out; 
	case 424: out424: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 424; goto out; 
	case 425: out425: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 425; goto out; 
	case 426: out426: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 426; goto out; 
	case 427: out427: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 427; goto out; 
	case 428: out428: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 428; goto out; 
	case 429: out429: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 429; goto out; 
	case 430: out430: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 430; goto out; 
	case 431: out431: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 431; goto out; 
	case 432: out432: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 432; goto out; 
	case 433: out433: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 433; goto out; 
	case 434: out434: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 434; goto out; 
	case 435: out435: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 435; goto out; 
	case 436: out436: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 436; goto out; 
	case 437: out437: if ( pdaRun->scan_eof ) {goto tr666;
}pdaRun->fsm_cs = 437; goto out; 
	case 438: out438: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 438; goto out; 
	case 439: out439: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 439; goto out; 
	case 440: out440: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 440; goto out; 
	case 441: out441: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 441; goto out; 
	case 442: out442: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 442; goto out; 
	case 443: out443: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 443; goto out; 
	case 444: out444: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 444; goto out; 
	case 445: out445: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 445; goto out; 
	case 446: out446: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 446; goto out; 
	case 447: out447: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 447; goto out; 
	case 448: out448: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 448; goto out; 
	case 449: out449: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 449; goto out; 
	case 450: out450: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 450; goto out; 
	case 451: out451: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 451; goto out; 
	case 452: out452: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 452; goto out; 
	case 453: out453: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 453; goto out; 
	case 454: out454: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 454; goto out; 
	case 455: out455: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 455; goto out; 
	case 456: out456: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 456; goto out; 
	case 457: out457: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 457; goto out; 
	case 458: out458: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 458; goto out; 
	case 459: out459: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 459; goto out; 
	case 460: out460: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 460; goto out; 
	case 461: out461: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 461; goto out; 
	case 462: out462: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 462; goto out; 
	case 463: out463: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 463; goto out; 
	case 464: out464: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 464; goto out; 
	case 465: out465: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 465; goto out; 
	case 466: out466: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 466; goto out; 
	case 467: out467: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 467; goto out; 
	case 468: out468: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 468; goto out; 
	case 469: out469: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 469; goto out; 
	case 470: out470: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 470; goto out; 
	case 471: out471: if ( pdaRun->scan_eof ) {goto tr703;
}pdaRun->fsm_cs = 471; goto out; 
	case 262: out262: if ( pdaRun->scan_eof ) {goto tr439;
}pdaRun->fsm_cs = 262; goto out; 
	case 472: out472: pdaRun->fsm_cs = 472; goto out; 
	case 473: out473: if ( pdaRun->scan_eof ) {goto tr706;
}pdaRun->fsm_cs = 473; goto out; 
	case 6: out6: pdaRun->fsm_cs = 6; goto out; 
	case 474: out474: pdaRun->fsm_cs = 474; goto out; 
	case 7: out7: if ( pdaRun->scan_eof ) {goto tr12;
}pdaRun->fsm_cs = 7; goto out; 
	case 475: out475: if ( pdaRun->scan_eof ) {goto tr712;
}pdaRun->fsm_cs = 475; goto out; 
	case 476: out476: pdaRun->fsm_cs = 476; goto out; 
	case 8: out8: if ( pdaRun->scan_eof ) {goto tr14;
}pdaRun->fsm_cs = 8; goto out; 
	case 477: out477: if ( pdaRun->scan_eof ) {goto tr718;
}pdaRun->fsm_cs = 477; goto out; 
	case 478: out478: pdaRun->fsm_cs = 478; goto out; 
	case 479: out479: pdaRun->fsm_cs = 479; goto out; 
	case 9: out9: if ( pdaRun->scan_eof ) {goto tr16;
}pdaRun->fsm_cs = 9; goto out; 
	case 480: out480: if ( pdaRun->scan_eof ) {goto tr723;
}pdaRun->fsm_cs = 480; goto out; 
	case 481: out481: pdaRun->fsm_cs = 481; goto out; 
	case 10: out10: if ( pdaRun->scan_eof ) {goto tr18;
}pdaRun->fsm_cs = 10; goto out; 
	case 482: out482: if ( pdaRun->scan_eof ) {goto tr727;
}pdaRun->fsm_cs = 482; goto out; 
	case 483: out483: pdaRun->fsm_cs = 483; goto out; 
	case 484: out484: pdaRun->fsm_cs = 484; goto out; 
	case 485: out485: if ( pdaRun->scan_eof ) {goto tr731;
}pdaRun->fsm_cs = 485; goto out; 
	case 486: out486: pdaRun->fsm_cs = 486; goto out; 
	case 487: out487: if ( pdaRun->scan_eof ) {goto tr734;
}pdaRun->fsm_cs = 487; goto out; 
	case 488: out488: pdaRun->fsm_cs = 488; goto out; 
	case 489: out489: pdaRun->fsm_cs = 489; goto out; 
	case 490: out490: if ( pdaRun->scan_eof ) {goto tr754;
}pdaRun->fsm_cs = 490; goto out; 
	case 11: out11: pdaRun->fsm_cs = 11; goto out; 
	case 491: out491: if ( pdaRun->scan_eof ) {goto tr755;
}pdaRun->fsm_cs = 491; goto out; 
	case 12: out12: pdaRun->fsm_cs = 12; goto out; 
	case 13: out13: pdaRun->fsm_cs = 13; goto out; 
	case 14: out14: pdaRun->fsm_cs = 14; goto out; 
	case 15: out15: pdaRun->fsm_cs = 15; goto out; 
	case 492: out492: if ( pdaRun->scan_eof ) {goto tr757;
}pdaRun->fsm_cs = 492; goto out; 
	case 493: out493: if ( pdaRun->scan_eof ) {goto tr759;
}pdaRun->fsm_cs = 493; goto out; 
	case 494: out494: if ( pdaRun->scan_eof ) {goto tr761;
}pdaRun->fsm_cs = 494; goto out; 
	case 495: out495: if ( pdaRun->scan_eof ) {goto tr763;
}pdaRun->fsm_cs = 495; goto out; 
	case 16: out16: if ( pdaRun->scan_eof ) {goto tr26;
}pdaRun->fsm_cs = 16; goto out; 
	case 497: out497: if ( pdaRun->scan_eof ) {goto tr765;
}pdaRun->fsm_cs = 497; goto out; 
	case 496: out496: if ( pdaRun->scan_eof ) {goto tr763;
}pdaRun->fsm_cs = 496; goto out; 
	case 17: out17: pdaRun->fsm_cs = 17; goto out; 
	case 498: out498: if ( pdaRun->scan_eof ) {goto tr766;
}pdaRun->fsm_cs = 498; goto out; 
	case 18: out18: pdaRun->fsm_cs = 18; goto out; 
	case 500: out500: if ( pdaRun->scan_eof ) {goto tr769;
}pdaRun->fsm_cs = 500; goto out; 
	case 499: out499: if ( pdaRun->scan_eof ) {goto tr768;
}pdaRun->fsm_cs = 499; goto out; 
	case 501: out501: pdaRun->fsm_cs = 501; goto out; 
	case 19: out19: pdaRun->fsm_cs = 19; goto out; 
	case 502: out502: if ( pdaRun->scan_eof ) {goto tr788;
}pdaRun->fsm_cs = 502; goto out; 
	case 20: out20: pdaRun->fsm_cs = 20; goto out; 
	case 21: out21: pdaRun->fsm_cs = 21; goto out; 
	case 22: out22: pdaRun->fsm_cs = 22; goto out; 
	case 503: out503: if ( pdaRun->scan_eof ) {goto tr790;
}pdaRun->fsm_cs = 503; goto out; 
	case 504: out504: if ( pdaRun->scan_eof ) {goto tr792;
}pdaRun->fsm_cs = 504; goto out; 
	case 505: out505: if ( pdaRun->scan_eof ) {goto tr794;
}pdaRun->fsm_cs = 505; goto out; 
	case 506: out506: if ( pdaRun->scan_eof ) {goto tr796;
}pdaRun->fsm_cs = 506; goto out; 
	case 23: out23: if ( pdaRun->scan_eof ) {goto tr35;
}pdaRun->fsm_cs = 23; goto out; 
	case 508: out508: if ( pdaRun->scan_eof ) {goto tr798;
}pdaRun->fsm_cs = 508; goto out; 
	case 507: out507: if ( pdaRun->scan_eof ) {goto tr796;
}pdaRun->fsm_cs = 507; goto out; 
	case 24: out24: pdaRun->fsm_cs = 24; goto out; 
	case 509: out509: if ( pdaRun->scan_eof ) {goto tr799;
}pdaRun->fsm_cs = 509; goto out; 
	case 25: out25: pdaRun->fsm_cs = 25; goto out; 
	case 511: out511: if ( pdaRun->scan_eof ) {goto tr802;
}pdaRun->fsm_cs = 511; goto out; 
	case 510: out510: if ( pdaRun->scan_eof ) {goto tr801;
}pdaRun->fsm_cs = 510; goto out; 
	case 512: out512: pdaRun->fsm_cs = 512; goto out; 
	case 513: out513: if ( pdaRun->scan_eof ) {goto tr805;
}pdaRun->fsm_cs = 513; goto out; 
	case 26: out26: pdaRun->fsm_cs = 26; goto out; 
	case 514: out514: pdaRun->fsm_cs = 514; goto out; 
	case 27: out27: pdaRun->fsm_cs = 27; goto out; 
	case 515: out515: pdaRun->fsm_cs = 515; goto out; 
	case 28: out28: pdaRun->fsm_cs = 28; goto out; 
	case 516: out516: pdaRun->fsm_cs = 516; goto out; 
	case 517: out517: pdaRun->fsm_cs = 517; goto out; 
	case 518: out518: if ( pdaRun->scan_eof ) {goto tr823;
}pdaRun->fsm_cs = 518; goto out; 
	case 519: out519: if ( pdaRun->scan_eof ) {goto tr824;
}pdaRun->fsm_cs = 519; goto out; 
	case 520: out520: if ( pdaRun->scan_eof ) {goto tr825;
}pdaRun->fsm_cs = 520; goto out; 
	case 30: out30: if ( pdaRun->scan_eof ) {goto tr46;
}pdaRun->fsm_cs = 30; goto out; 
	case 29: out29: if ( pdaRun->scan_eof ) {goto tr46;
}pdaRun->fsm_cs = 29; goto out; 
	case 521: out521: if ( pdaRun->scan_eof ) {goto tr824;
}pdaRun->fsm_cs = 521; goto out; 
	case 31: out31: if ( pdaRun->scan_eof ) {goto tr46;
}pdaRun->fsm_cs = 31; goto out; 
	case 523: out523: if ( pdaRun->scan_eof ) {goto tr832;
}pdaRun->fsm_cs = 523; goto out; 
	case 522: out522: if ( pdaRun->scan_eof ) {goto tr831;
}pdaRun->fsm_cs = 522; goto out; 
	case 525: out525: if ( pdaRun->scan_eof ) {goto tr834;
}pdaRun->fsm_cs = 525; goto out; 
	case 524: out524: if ( pdaRun->scan_eof ) {goto tr833;
}pdaRun->fsm_cs = 524; goto out; 
	case 526: out526: if ( pdaRun->scan_eof ) {goto tr824;
}pdaRun->fsm_cs = 526; goto out; 
	case 33: out33: if ( pdaRun->scan_eof ) {goto tr46;
}pdaRun->fsm_cs = 33; goto out; 
	case 32: out32: if ( pdaRun->scan_eof ) {goto tr46;
}pdaRun->fsm_cs = 32; goto out; 
	case 527: out527: if ( pdaRun->scan_eof ) {goto tr824;
}pdaRun->fsm_cs = 527; goto out; 
	case 34: out34: if ( pdaRun->scan_eof ) {goto tr46;
}pdaRun->fsm_cs = 34; goto out; 
	case 35: out35: if ( pdaRun->scan_eof ) {goto tr46;
}pdaRun->fsm_cs = 35; goto out; 
	case 36: out36: if ( pdaRun->scan_eof ) {goto tr46;
}pdaRun->fsm_cs = 36; goto out; 
	case 528: out528: if ( pdaRun->scan_eof ) {goto tr824;
}pdaRun->fsm_cs = 528; goto out; 
	case 530: out530: if ( pdaRun->scan_eof ) {goto tr838;
}pdaRun->fsm_cs = 530; goto out; 
	case 529: out529: if ( pdaRun->scan_eof ) {goto tr837;
}pdaRun->fsm_cs = 529; goto out; 
	case 531: out531: if ( pdaRun->scan_eof ) {goto tr839;
}pdaRun->fsm_cs = 531; goto out; 
	case 532: out532: pdaRun->fsm_cs = 532; goto out; 
	case 533: out533: if ( pdaRun->scan_eof ) {goto tr850;
}pdaRun->fsm_cs = 533; goto out; 
	case 534: out534: if ( pdaRun->scan_eof ) {goto tr851;
}pdaRun->fsm_cs = 534; goto out; 
	case 535: out535: if ( pdaRun->scan_eof ) {goto tr852;
}pdaRun->fsm_cs = 535; goto out; 
	case 38: out38: if ( pdaRun->scan_eof ) {goto tr58;
}pdaRun->fsm_cs = 38; goto out; 
	case 37: out37: if ( pdaRun->scan_eof ) {goto tr58;
}pdaRun->fsm_cs = 37; goto out; 
	case 536: out536: if ( pdaRun->scan_eof ) {goto tr851;
}pdaRun->fsm_cs = 536; goto out; 
	case 39: out39: if ( pdaRun->scan_eof ) {goto tr58;
}pdaRun->fsm_cs = 39; goto out; 
	case 538: out538: if ( pdaRun->scan_eof ) {goto tr859;
}pdaRun->fsm_cs = 538; goto out; 
	case 537: out537: if ( pdaRun->scan_eof ) {goto tr858;
}pdaRun->fsm_cs = 537; goto out; 
	case 540: out540: if ( pdaRun->scan_eof ) {goto tr861;
}pdaRun->fsm_cs = 540; goto out; 
	case 539: out539: if ( pdaRun->scan_eof ) {goto tr860;
}pdaRun->fsm_cs = 539; goto out; 
	case 541: out541: if ( pdaRun->scan_eof ) {goto tr851;
}pdaRun->fsm_cs = 541; goto out; 
	case 41: out41: if ( pdaRun->scan_eof ) {goto tr58;
}pdaRun->fsm_cs = 41; goto out; 
	case 40: out40: if ( pdaRun->scan_eof ) {goto tr58;
}pdaRun->fsm_cs = 40; goto out; 
	case 542: out542: if ( pdaRun->scan_eof ) {goto tr851;
}pdaRun->fsm_cs = 542; goto out; 
	case 42: out42: if ( pdaRun->scan_eof ) {goto tr58;
}pdaRun->fsm_cs = 42; goto out; 
	case 43: out43: if ( pdaRun->scan_eof ) {goto tr58;
}pdaRun->fsm_cs = 43; goto out; 
	case 44: out44: if ( pdaRun->scan_eof ) {goto tr58;
}pdaRun->fsm_cs = 44; goto out; 
	case 543: out543: if ( pdaRun->scan_eof ) {goto tr851;
}pdaRun->fsm_cs = 543; goto out; 
	case 545: out545: if ( pdaRun->scan_eof ) {goto tr865;
}pdaRun->fsm_cs = 545; goto out; 
	case 544: out544: if ( pdaRun->scan_eof ) {goto tr864;
}pdaRun->fsm_cs = 544; goto out; 
	case 546: out546: if ( pdaRun->scan_eof ) {goto tr866;
}pdaRun->fsm_cs = 546; goto out; 
	case 547: out547: pdaRun->fsm_cs = 547; goto out; 
	}
out:
	if ( pdaRun->p != 0 )
		pdaRun->toklen += pdaRun->p - pdaRun->start;
skip_toklen:
	{}
}

static void sendNamedLangEl( struct colm_program *prg, tree_t **tree,
		struct pda_run *pda_run, struct input_impl *input ) { }
static void initBindings( struct pda_run *pdaRun ) {}
static void popBinding( struct pda_run *pdaRun, parse_tree_t *tree ) {}


static int pid_0_parser_indicies[] = {
	27, 28, 829, 25, 23, 26, 55, 56, 
	64, 67, 68, 65, 66, 73, 74, 830, 
	69, 70, 30, 52, 35, 36, 40, 38, 
	93, 92, 90, 853, 853, 853, 853, 853, 
	95, 32, 184, 47, 41, 42, 43, 109, 
	50, 150, 75, 48, 46, 111, 993, 37, 
	993, 163, 853, 853, 853, 72, 71, 196, 
	24, 54, 53, 865, 57, 195, 155, 77, 
	78, 79, 51, 61, 153, 164, 82, 84, 
	86, 88, 110, 857, 858, 98, 165, 188, 
	82, 84, 86, 88, 101, 102, 993, 159, 
	993, 158, 199, 96, 833, 202, 833, 203, 
	896, 208, 249, 897, 1022, 173, 138, 139, 
	141, 140, 142, 288, 834, 256, 834, 255, 
	250, 251, 253, 252, 254, 1022, 173, 293, 
	315, 313, 327, 321, 322, 135, 136, 137, 
	290, 1021, 325, 326, 334, 328, 329, 330, 
	338, 852, 852, 852, 852, 852, 993, 835, 
	289, 835, 1123, 1123, 171, 993, 336, 359, 
	337, 1120, 360, 384, 993, 929, 993, 386, 
	852, 852, 852, 993, 414, 418, 431, 437, 
	432, 433, 434, 0, 2, 21, 19, 49, 
	471, 60, 18, 20, 94, 17, 16, 14, 
	473, 160, 161, 162, 31, 12, 13, 483, 
	29, 10, 4, 179, 180, 484, 417, 22, 
	488, 833, 833, 494, 11, 496, 499, 864, 
	8, 9, 3, 503, 5, 6, 1122, 1122, 
	7, 834, 834, 999, 999, 999, 999, 999, 
	218, 219, 220, 221, 15, 523, 62, 524, 
	62, 156, 1147, 1147, 169, 928, 168, 546, 
	34, 33, 999, 999, 999, 385, 172, 554, 
	365, 1133, 853, 63, 835, 835, 547, 1130, 
	44, 274, 275, 100, 1151, 1151, 260, 262, 
	259, 416, 157, 993, 148, 993, 181, 163, 
	864, 325, 326, 320, 833, 57, 324, 80, 
	76, 45, 886, 1133, 321, 322, 993, 39, 
	993, 80, 76, 97, 834, 1126, 1123, 1022, 
	173, 1146, 1146, 1, 189, 27, 28, 1121, 
	25, 23, 26, 55, 56, 64, 67, 68, 
	65, 66, 73, 74, 555, 69, 70, 30, 
	52, 35, 36, 40, 38, 182, 183, 835, 
	853, 853, 853, 853, 853, 62, 32, 170, 
	47, 41, 42, 43, 62, 50, 62, 75, 
	48, 46, 865, 62, 37, 189, 151, 853, 
	853, 853, 72, 71, 571, 24, 54, 53, 
	852, 852, 1122, 1148, 77, 78, 79, 51, 
	61, 107, 993, 82, 84, 86, 88, 572, 
	108, 993, 106, 993, 992, 573, 992, 207, 
	993, 574, 1147, 1123, 1123, 171, 999, 999, 
	999, 999, 999, 575, 1133, 576, 1148, 999, 
	999, 999, 999, 999, 57, 438, 167, 321, 
	322, 366, 325, 326, 1151, 999, 999, 999, 
	364, 1133, 217, 216, 215, 430, 999, 999, 
	999, 274, 275, 577, 578, 579, 100, 886, 
	1133, 886, 1133, 584, 429, 258, 201, 100, 
	166, 399, 999, 999, 589, 99, 1152, 1022, 
	173, 1146, 198, 591, 848, 847, 590, 939, 
	603, 604, 607, 1124, 1081, 592, 999, 999, 
	999, 999, 999, 1082, 257, 927, 62, 1133, 
	631, 2, 21, 19, 49, 633, 1121, 18, 
	20, 1152, 17, 16, 14, 999, 999, 999, 
	644, 31, 12, 13, 647, 29, 10, 4, 
	82, 84, 86, 88, 22, 650, 100, 307, 
	309, 11, 461, 993, 653, 8, 9, 3, 
	663, 5, 6, 197, 476, 7, 1140, 885, 
	999, 999, 999, 999, 999, 82, 84, 86, 
	88, 15, 1123, 1123, 171, 1134, 1133, 1123, 
	325, 326, 302, 325, 326, 34, 33, 999, 
	999, 999, 138, 139, 141, 140, 142, 853, 
	63, 1140, 509, 510, 511, 44, 487, 544, 
	100, 668, 307, 309, 1123, 1123, 171, 508, 
	512, 135, 136, 137, 1001, 1001, 1001, 1001, 
	261, 198, 670, 937, 80, 76, 45, 388, 
	677, 938, 993, 683, 39, 993, 1059, 1059, 
	1059, 491, 1059, 138, 139, 141, 140, 142, 
	178, 992, 1134, 138, 139, 141, 140, 142, 
	138, 139, 141, 140, 142, 999, 999, 502, 
	103, 685, 135, 136, 137, 1136, 999, 999, 
	686, 104, 135, 136, 137, 1120, 687, 135, 
	136, 137, 692, 993, 138, 139, 141, 140, 
	142, 470, 200, 993, 509, 510, 511, 699, 
	993, 138, 139, 141, 140, 142, 703, 1128, 
	849, 890, 512, 135, 136, 137, 706, 1150, 
	1150, 1123, 1123, 171, 885, 708, 885, 626, 
	135, 136, 137, 648, 993, 649, 1123, 709, 
	303, 305, 301, 710, 545, 999, 999, 606, 
	105, 993, 1123, 1123, 171, 846, 713, 1123, 
	1123, 171, 625, 1001, 1001, 1001, 1001, 321, 
	322, 80, 76, 222, 1116, 1116, 388, 716, 
	1123, 850, 1001, 1001, 1001, 1001, 721, 316, 
	722, 850, 1147, 1147, 169, 388, 168, 138, 
	139, 141, 140, 142, 725, 1144, 80, 76, 
	223, 475, 474, 303, 305, 480, 1059, 999, 
	999, 731, 154, 1123, 1123, 171, 135, 136, 
	137, 323, 1134, 1134, 393, 851, 732, 468, 
	467, 469, 1059, 734, 501, 851, 500, 993, 
	1144, 209, 183, 1117, 1117, 187, 736, 729, 
	1001, 1001, 1001, 1121, 737, 1138, 1138, 0, 
	2, 21, 19, 49, 1117, 1117, 18, 20, 
	94, 17, 16, 14, 1059, 160, 161, 162, 
	31, 12, 13, 723, 29, 10, 4, 179, 
	180, 325, 326, 22, 993, 1123, 993, 1150, 
	11, 744, 210, 183, 8, 9, 3, 747, 
	5, 6, 211, 183, 7, 749, 750, 212, 
	183, 1072, 1072, 1072, 724, 1072, 1123, 740, 
	15, 741, 62, 1123, 62, 156, 138, 139, 
	141, 140, 142, 756, 34, 33, 398, 605, 
	321, 322, 172, 213, 183, 615, 613, 62, 
	1116, 758, 325, 326, 44, 135, 136, 137, 
	214, 183, 1147, 262, 1022, 173, 157, 490, 
	148, 759, 181, 387, 549, 470, 993, 320, 
	1022, 173, 324, 80, 76, 45, 167, 1123, 
	845, -1, 389, 39, 849, 80, 76, 97, 
	845, 615, 616, -1, 1001, 1001, 1001, 1, 
	189, 993, 502, 993, 138, 139, 141, 140, 
	142, 1022, 173, 1001, 1001, 1001, 506, 1117, 
	319, -1, 1123, 1123, 171, 1138, 1119, 1119, 
	581, 182, 183, 135, 136, 137, -1, 507, 
	1117, 62, 470, 170, 321, 322, 295, 183, 
	62, -1, 62, -1, 993, 646, 1015, 62, 
	1015, 189, 151, 1139, 1139, 397, 714, 396, 
	325, 326, 715, 1001, 1001, 1001, 1001, 1001, 
	1001, 1001, 1001, -1, -1, 107, 388, -1, 
	-1, 1072, 388, -1, 108, -1, 106, 538, 
	539, 540, 541, 207, 552, -1, -1, 374, 
	375, 376, 373, 468, 608, 469, 551, 380, 
	645, -1, 1072, -1, -1, 371, 662, 378, 
	379, 614, 167, -1, -1, 366, 550, 493, 
	-1, -1, -1, -1, 364, -1, 217, 216, 
	215, 430, 582, 998, 998, 998, 998, 998, 
	-1, 1072, 509, 510, 511, -1, 612, -1, 
	429, 258, 325, 326, 166, 399, -1, -1, 
	512, 99, 998, 998, 998, 614, 198, 682, 
	669, -1, 469, 639, -1, 296, 183, -1, 
	-1, -1, -1, 998, -1, -1, 1123, -1, 
	257, -1, 62, -1, -1, 2, 21, 19, 
	49, -1, 1119, 18, 20, -1, 17, 16, 
	14, 181, -1, -1, 661, 31, 12, 13, 
	1133, 29, 10, 4, 1127, 1147, 1147, 169, 
	22, 168, -1, 1139, 691, 11, 461, 638, 
	395, 8, 9, 3, 1133, 5, 6, 197, 
	-1, 7, 321, 322, 57, 138, 139, 141, 
	140, 142, 1133, 317, 183, 15, 1015, 852, 
	852, 852, 852, 852, 218, 219, 220, 221, 
	1015, 34, 33, 390, 135, 136, 137, 391, 
	1142, 1142, 1022, 173, 62, 394, 852, 852, 
	852, 44, 487, 544, 367, 993, 368, 369, 
	370, 377, 381, 372, 1001, 1001, 1001, 852, 
	1001, 1001, 1001, -1, 261, 198, -1, -1, 
	80, 76, 45, 537, 536, 535, 712, 1133, 
	39, -1, 1151, 1151, 260, 491, 259, 1139, 
	1139, 397, -1, 396, 178, 771, 771, 771, 
	771, 771, 771, 771, 771, 771, 771, 771, 
	771, 771, 771, 771, 103, 771, 771, 771, 
	771, 771, 771, 771, 771, 104, 321, 322, 
	771, 771, 771, 771, 771, -1, 771, -1, 
	771, 771, 771, 771, -1, 771, 200, 771, 
	771, 771, 998, 998, 771, 1147, 1133, 771, 
	771, 771, 771, 771, -1, 771, 771, 771, 
	1133, -1, -1, -1, 771, 771, 771, 771, 
	771, 167, 690, 771, 771, 771, 771, 1133, 
	-1, 1133, -1, -1, 303, 305, 301, -1, 
	545, 325, 326, 606, 105, 684, 1118, 1118, 
	-1, 198, 246, 247, 675, 245, -1, -1, 
	1142, -1, 901, 489, 901, 80, 76, 222, 
	-1, -1, -1, -1, 1022, 173, -1, -1, 
	-1, -1, -1, 316, -1, -1, -1, 1047, 
	1047, 1047, -1, 1047, -1, -1, 217, 216, 
	671, -1, 80, 76, 223, 475, 474, 303, 
	305, 480, 1151, -1, 248, 183, 154, 1139, 
	-1, -1, -1, -1, 395, 323, 852, 852, 
	393, 993, 363, 468, 467, 469, -1, 993, 
	501, 993, 500, 258, -1, 209, 183, -1, 
	-1, 771, 771, 771, 771, -1, 745, 771, 
	771, -1, 771, 771, 771, -1, -1, -1, 
	-1, 771, 771, 771, -1, 771, 771, 771, 
	244, 543, 428, -1, 771, 1001, 1001, 1001, 
	1001, 771, -1, -1, -1, 771, 771, 771, 
	388, 771, 771, -1, -1, 771, 210, 183, 
	-1, -1, 374, 375, 376, 373, 211, 183, 
	-1, 771, 380, 212, 183, 746, -1, -1, 
	371, -1, 378, 379, 891, 771, 771, -1, 
	-1, 993, 1118, 993, 694, 695, 696, 771, 
	771, -1, 398, 605, -1, 771, 728, 213, 
	183, 409, -1, 1016, 403, 405, 407, 1132, 
	1141, 904, -1, 904, 214, 183, -1, 1047, 
	904, -1, -1, 490, 771, 771, 771, 387, 
	549, -1, 901, 1132, 771, 771, 1047, 1029, 
	1029, 1029, 167, 1029, -1, -1, 389, -1, 
	771, 1132, 772, 772, 772, 772, 772, 772, 
	772, 772, 772, 772, 772, 772, 772, 772, 
	772, 382, 772, 772, 772, 772, 772, 772, 
	772, 772, 506, 1047, 319, 772, 772, 772, 
	772, 772, -1, 772, 581, 772, 772, 772, 
	772, 62, 772, 507, 772, 772, 772, 719, 
	-1, 772, 295, 183, 772, 772, 772, 772, 
	772, 646, 772, 772, 772, -1, 1132, -1, 
	-1, 772, 772, 772, 772, 772, -1, -1, 
	772, 772, 772, 772, -1, 594, 993, 1151, 
	1151, 260, -1, 259, -1, 392, -1, 478, 
	-1, -1, 218, 219, 220, 221, -1, 383, 
	552, 368, 369, 370, 377, 381, 372, 468, 
	608, 469, 551, -1, 645, -1, 1001, 1001, 
	1001, -1, 662, -1, -1, 614, -1, 904, 
	904, 609, 550, 493, -1, 1132, -1, -1, 
	-1, 693, -1, -1, -1, -1, 582, 1132, 
	-1, -1, -1, -1, -1, -1, -1, 1029, 
	-1, 1016, -1, -1, 1029, -1, 1132, 402, 
	1132, 904, -1, 1016, 401, -1, -1, -1, 
	-1, 614, -1, 682, 669, -1, 469, 639, 
	-1, 296, 183, -1, -1, -1, 772, 772, 
	772, 772, -1, 771, 772, 772, -1, 772, 
	772, 772, -1, -1, -1, -1, 772, 772, 
	772, 1029, 772, 772, 772, 181, 1127, -1, 
	661, 772, -1, 400, -1, -1, 772, -1, 
	-1, -1, 772, 772, 772, -1, 772, 772, 
	691, -1, 772, 638, 395, -1, -1, 138, 
	139, 141, 140, 142, -1, -1, 772, 1151, 
	1139, 1139, 397, -1, 396, -1, -1, 317, 
	183, -1, 772, 772, -1, -1, 135, 136, 
	137, -1, -1, -1, 772, 772, -1, 390, 
	258, -1, 772, 391, 1060, 1060, 1060, 993, 
	1060, 394, 1123, 1123, 171, 1123, 1123, 171, 
	367, -1, 368, 369, 370, 377, 381, 372, 
	-1, 772, 772, 772, 217, 216, 477, 580, 
	-1, 772, 772, -1, -1, -1, -1, 537, 
	536, 535, 712, -1, -1, 772, -1, 773, 
	773, 773, 773, 773, 773, 773, 773, 773, 
	773, 773, 773, 773, 773, 773, -1, 773, 
	773, 773, 773, 773, 773, 773, 773, -1, 
	-1, -1, 773, 773, 773, 773, 773, -1, 
	773, -1, 773, 773, 773, 773, -1, 773, 
	-1, 773, 773, 773, -1, -1, 773, -1, 
	-1, 773, 773, 773, 773, 773, -1, 773, 
	773, 773, -1, -1, -1, -1, 773, 773, 
	773, 773, 773, -1, -1, 773, 773, 773, 
	773, -1, -1, -1, -1, 167, 690, -1, 
	1139, -1, -1, -1, -1, 395, 629, 630, 
	628, -1, -1, -1, 246, 247, -1, 245, 
	-1, -1, -1, -1, -1, 198, 246, 247, 
	675, 245, -1, -1, 1060, -1, 1123, 489, 
	-1, 1123, -1, 1089, 1089, 1089, 1089, 517, 
	1087, 1087, 1087, 1089, 1087, -1, -1, -1, 
	1060, 1089, 548, 1089, 1089, 1087, 1087, 514, 
	515, 516, 217, 216, 671, -1, 248, 183, 
	-1, 138, 139, 141, 140, 142, -1, 674, 
	248, 183, 727, -1, -1, -1, -1, -1, 
	395, -1, 1060, -1, -1, -1, 363, -1, 
	135, 136, 137, 773, 773, 773, 773, 258, 
	772, 773, 773, -1, 773, 773, 773, -1, 
	-1, 993, 745, 773, 773, 773, -1, 773, 
	773, 773, 415, 903, 807, 903, 773, -1, 
	-1, -1, 903, 773, 244, 543, 428, 773, 
	773, 773, -1, 773, 773, -1, -1, 773, 
	82, 84, 86, 88, 993, 807, 807, 807, 
	807, 807, -1, 773, 138, 139, 141, 140, 
	142, 138, 139, 141, 140, 142, -1, 773, 
	773, 746, -1, -1, 807, 807, 807, -1, 
	-1, 773, 773, 135, 136, 137, -1, 773, 
	135, 136, 137, -1, -1, 807, -1, 627, 
	381, -1, 728, -1, 993, -1, -1, -1, 
	-1, 993, -1, -1, -1, -1, 773, 773, 
	773, -1, -1, 681, -1, 902, 773, 773, 
	-1, 513, 679, 1089, 1089, 1089, 1089, 1089, 
	-1, -1, 773, -1, 774, 774, 774, 774, 
	774, 774, 774, 774, 774, 774, 774, 774, 
	774, 774, 774, -1, 774, 774, 774, 774, 
	774, 774, 774, 774, -1, 382, -1, 774, 
	774, 774, 774, 774, -1, 774, -1, 774, 
	774, 774, 774, -1, 774, -1, 774, 774, 
	774, 903, 903, 774, -1, 62, 774, 774, 
	774, 774, 774, 719, 774, 774, 774, -1, 
	-1, -1, -1, 774, 774, 774, 774, 774, 
	419, 183, 774, 774, 774, 774, 82, 84, 
	86, 88, -1, 903, -1, -1, -1, -1, 
	-1, 594, -1, 1030, 1030, 1030, -1, 1030, 
	-1, 392, 807, 807, -1, 807, -1, -1, 
	-1, -1, -1, 383, 62, 368, 369, 370, 
	377, 381, 372, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1073, 1073, 1073, -1, 1073, 
	-1, 80, 76, 530, -1, 609, -1, -1, 
	-1, 678, 680, -1, -1, 693, -1, -1, 
	705, 993, -1, -1, 807, 807, 138, 139, 
	141, 140, 142, 420, 183, -1, -1, -1, 
	421, 183, -1, 402, -1, -1, -1, -1, 
	401, -1, -1, 902, -1, 135, 136, 137, 
	774, 774, 774, 774, -1, 773, 774, 774, 
	-1, 774, 774, 774, -1, -1, 993, -1, 
	774, 774, 774, -1, 774, 774, 774, -1, 
	807, 808, -1, 774, 82, 84, 86, 88, 
	774, -1, -1, -1, 774, 774, 774, 400, 
	774, 774, -1, -1, 774, -1, -1, -1, 
	-1, -1, 808, 808, 808, 808, 808, -1, 
	774, 138, 139, 141, 140, 142, 138, 139, 
	141, 140, 142, 1030, 774, 774, -1, -1, 
	1030, 808, 808, 808, -1, -1, 774, 774, 
	135, 136, 137, -1, 774, 135, 136, 137, 
	-1, -1, 808, -1, 258, -1, -1, -1, 
	-1, 993, -1, 1073, -1, -1, 993, -1, 
	-1, -1, -1, 774, 774, 774, -1, 80, 
	76, 531, -1, 774, 774, 1030, -1, -1, 
	217, 216, 477, 580, 1073, -1, -1, 774, 
	-1, 775, 775, 775, 775, 775, 775, 775, 
	775, 775, 775, 775, 775, 775, 775, 775, 
	-1, 775, 775, 775, 775, 775, 775, 775, 
	775, -1, -1, 1073, 775, 775, 775, 775, 
	775, -1, 775, -1, 775, 775, 775, 775, 
	-1, 775, -1, 775, 775, 775, -1, -1, 
	775, -1, -1, 775, 775, 775, 775, 775, 
	-1, 775, 775, 775, -1, -1, -1, -1, 
	775, 775, 775, 775, 775, 422, 183, 775, 
	775, 775, 775, -1, 374, 375, 376, 373, 
	-1, -1, -1, 522, 380, -1, 374, 375, 
	376, 373, 371, -1, 378, 379, 380, 808, 
	808, 395, 808, -1, 371, -1, 378, 379, 
	246, 247, -1, 245, -1, 80, 76, 532, 
	-1, -1, -1, -1, 1094, 1094, 1094, 1094, 
	1094, 1094, 1094, 1094, 1094, 1094, 518, 519, 
	521, 520, 1094, -1, 1094, 1094, 1094, 1094, 
	1094, 1094, 1094, -1, -1, -1, 548, -1, 
	-1, 808, 808, 138, 139, 141, 140, 142, 
	423, 183, 248, 183, -1, 424, 183, -1, 
	-1, -1, -1, 674, -1, -1, 727, -1, 
	-1, -1, 135, 136, 137, 775, 775, 775, 
	775, -1, 774, 775, 775, -1, 775, 775, 
	775, -1, -1, 993, -1, 775, 775, 775, 
	-1, 775, 775, 775, -1, 808, -1, -1, 
	775, 82, 84, 86, 88, 775, 415, -1, 
	-1, 775, 775, 775, -1, 775, 775, -1, 
	-1, 775, -1, -1, 138, 139, 141, 140, 
	142, 82, 84, 86, 88, 775, 409, -1, 
	1016, 403, 405, 407, -1, -1, -1, -1, 
	-1, 775, 775, 135, 136, 137, 1143, 1143, 
	637, -1, 636, 775, 775, 505, 377, 381, 
	372, 775, -1, 504, 993, 368, 369, 370, 
	377, 381, 372, 899, -1, 899, -1, 900, 
	1141, 900, 899, 627, 381, -1, 900, -1, 
	775, 775, 775, -1, -1, -1, -1, -1, 
	775, 775, 1094, -1, 1094, 1094, 1094, 1094, 
	1094, -1, -1, -1, 775, 513, 776, 776, 
	776, 776, 776, 776, 776, 776, 776, 776, 
	776, 776, 776, 776, 776, -1, 776, 776, 
	776, 776, 776, 776, 776, 776, -1, -1, 
	-1, 776, 776, 776, 776, 776, -1, 776, 
	-1, 776, 776, 776, 776, -1, 776, -1, 
	776, 776, 776, -1, -1, 776, 1103, -1, 
	776, 776, 776, 776, 776, -1, 776, 776, 
	776, 1000, 1000, 1000, 1000, 776, 776, 776, 
	776, 776, 425, 183, 776, 776, 776, 776, 
	-1, -1, -1, -1, 419, 183, -1, 1103, 
	1103, 1103, 1103, 1103, 1103, 1103, 1103, 1103, 
	1103, 1103, 1103, 1103, 1103, 1103, 1143, 1103, 
	1103, 1103, 1103, 1103, 1103, 1103, -1, -1, 
	-1, -1, 80, 76, 533, 635, 1016, -1, 
	62, 899, 899, -1, 402, 900, 900, -1, 
	1016, 401, -1, -1, -1, -1, -1, -1, 
	-1, -1, 80, 76, 534, 80, 76, 530, 
	-1, -1, -1, 426, 183, 678, 680, -1, 
	-1, -1, 634, 899, 705, -1, -1, 900, 
	-1, -1, -1, -1, -1, -1, -1, 420, 
	183, -1, -1, -1, 421, 183, -1, -1, 
	542, -1, 776, 776, 776, 776, -1, 775, 
	776, 776, -1, 776, 776, 776, -1, -1, 
	-1, -1, 776, 776, 776, -1, 776, 776, 
	776, -1, -1, -1, -1, 776, -1, -1, 
	-1, -1, 776, -1, -1, -1, 776, 776, 
	776, -1, 776, 776, -1, -1, 776, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 776, 1088, 1088, 1088, 1088, -1, 
	-1, -1, -1, 1088, -1, -1, 776, 776, 
	-1, 1088, -1, 1088, 1088, -1, -1, -1, 
	776, 776, -1, -1, -1, 1103, 776, 1103, 
	1103, 1103, 1103, 1103, -1, 1000, 1000, 1000, 
	-1, -1, 1000, 1000, 1000, -1, -1, -1, 
	-1, 374, 375, 376, 373, 776, 776, 776, 
	-1, 380, -1, -1, -1, 776, 776, 371, 
	-1, 378, 379, 80, 76, 531, -1, -1, 
	-1, 776, -1, 777, 777, 777, 777, 777, 
	777, 777, 777, 777, 777, 777, 777, 777, 
	777, 777, -1, 777, 777, 777, 777, 777, 
	777, 777, 777, -1, -1, -1, 777, 777, 
	777, 777, 777, -1, 777, -1, 777, 777, 
	777, 777, -1, 777, -1, 777, 777, 777, 
	-1, -1, 777, 1105, -1, 777, 777, 777, 
	777, 777, -1, 777, 777, 777, -1, -1, 
	-1, -1, 777, 777, 777, 777, 777, -1, 
	-1, 777, 777, 777, 777, -1, -1, -1, 
	-1, 422, 183, -1, 1105, 1105, 1105, 1105, 
	1105, 1105, 1105, 1105, 1105, 1105, 1105, 1105, 
	1105, 1105, 1105, -1, 1105, 1105, 1105, 1105, 
	1105, 1105, 1105, 1088, 1088, 1088, 1088, 1088, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 80, 76, 532, -1, -1, -1, -1, 
	-1, -1, 570, 1129, 558, 560, 561, 559, 
	563, 564, 566, 565, 567, 569, 568, 562, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	617, 369, 370, 377, 381, 372, -1, -1, 
	-1, -1, -1, -1, 423, 183, -1, -1, 
	-1, 424, 183, -1, -1, -1, -1, 777, 
	777, 777, 777, -1, 776, 777, 777, -1, 
	777, 777, 777, -1, 557, -1, -1, 777, 
	777, 777, -1, 777, 777, 777, -1, -1, 
	-1, -1, 777, -1, -1, -1, -1, 777, 
	-1, -1, -1, 777, 777, 777, -1, 777, 
	777, -1, -1, 777, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 777, 
	-1, 374, 375, 376, 373, -1, -1, -1, 
	-1, 380, -1, 777, 777, -1, -1, 371, 
	-1, 378, 379, -1, -1, 777, 777, -1, 
	-1, -1, 1105, 777, 1105, 1105, 1105, 1105, 
	1105, 505, 377, 381, 372, -1, -1, 504, 
	-1, 368, 369, 370, 377, 381, 372, -1, 
	-1, -1, 777, 777, 777, -1, -1, -1, 
	-1, 556, 777, 777, -1, 1162, 1162, 673, 
	-1, 672, -1, -1, -1, -1, 777, -1, 
	778, 778, 778, 778, 778, 778, 778, 778, 
	778, 778, 778, 778, 778, 778, 778, -1, 
	778, 778, 778, 778, 778, 778, 778, 778, 
	-1, -1, -1, 778, 778, 778, 778, 778, 
	-1, 778, -1, 778, 778, 778, 778, -1, 
	778, -1, 778, 778, 778, -1, -1, 778, 
	1110, -1, 778, 778, 778, 778, 778, -1, 
	778, 778, 778, -1, -1, -1, -1, 778, 
	778, 778, 778, 778, -1, -1, 778, 778, 
	778, 778, -1, -1, -1, -1, 425, 183, 
	-1, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 
	1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 
	1106, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 
	618, 369, 370, 377, 381, 372, -1, -1, 
	-1, -1, -1, -1, -1, -1, 80, 76, 
	533, 635, -1, -1, -1, -1, -1, -1, 
	402, -1, -1, -1, -1, 401, -1, -1, 
	-1, -1, -1, -1, -1, 1162, 80, 76, 
	534, -1, 395, -1, -1, -1, -1, 426, 
	183, -1, -1, -1, -1, -1, 634, -1, 
	-1, 167, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 778, 778, 778, 778, 
	-1, 777, 778, 778, 542, 778, 778, 778, 
	-1, -1, -1, -1, 778, 778, 778, 394, 
	778, 778, 778, 166, -1, -1, -1, 778, 
	-1, -1, -1, -1, 778, -1, -1, -1, 
	778, 778, 778, -1, 778, 778, -1, -1, 
	778, -1, -1, -1, -1, -1, 138, 139, 
	141, 140, 142, -1, 778, 409, -1, 1016, 
	403, 405, 407, -1, 1141, -1, -1, -1, 
	778, 778, -1, -1, -1, 135, 136, 137, 
	-1, -1, 778, 778, -1, -1, -1, 1110, 
	778, 1110, 1110, 1110, 1110, 1110, 993, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1141, 
	-1, -1, -1, 374, 375, 376, 373, 778, 
	778, 778, -1, 380, -1, -1, -1, 778, 
	778, 371, -1, 378, 379, 891, -1, -1, 
	-1, -1, -1, 778, -1, 779, 779, 779, 
	779, 779, 779, 779, 779, 779, 779, 779, 
	779, 779, 779, 779, -1, 779, 779, 779, 
	779, 779, 779, 779, 779, -1, -1, -1, 
	779, 779, 779, 779, 779, -1, 779, -1, 
	779, 779, 779, 779, -1, 779, -1, 779, 
	779, 779, -1, -1, 779, 1111, -1, 779, 
	779, 779, 779, 779, -1, 779, 779, 779, 
	-1, -1, -1, -1, 779, 779, 779, 779, 
	779, -1, 611, 779, 779, 779, 779, -1, 
	-1, -1, -1, -1, -1, -1, 1111, 1111, 
	1111, 1111, 1111, 1111, 1111, 1111, 1111, 1111, 
	1111, 1111, 1111, 1111, 1111, -1, 1111, 1111, 
	1111, 1111, 1111, 1111, 1111, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1016, -1, -1, 
	-1, -1, -1, 402, -1, -1, -1, 1016, 
	401, -1, -1, -1, 570, 1129, 558, 560, 
	561, 559, 563, 564, 566, 565, 567, 569, 
	568, 562, -1, -1, -1, 658, 183, -1, 
	383, -1, 368, 369, 370, 377, 381, 372, 
	-1, -1, -1, -1, 617, 369, 370, 377, 
	381, 372, -1, -1, -1, -1, -1, 553, 
	-1, 779, 779, 779, 779, -1, 778, 779, 
	779, -1, 779, 779, 779, -1, 557, -1, 
	-1, 779, 779, 779, -1, 779, 779, 779, 
	557, -1, -1, -1, 779, -1, -1, -1, 
	-1, 779, -1, -1, -1, 779, 779, 779, 
	-1, 779, 779, -1, -1, 779, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 779, -1, 374, 375, 376, 373, -1, 
	-1, -1, -1, 380, -1, 779, 779, -1, 
	-1, 371, -1, 378, 379, -1, -1, 779, 
	779, -1, -1, -1, 1111, 779, 1111, 1111, 
	1111, 1111, 1111, -1, -1, -1, -1, -1, 
	-1, 374, 375, 376, 373, -1, -1, -1, 
	-1, 380, -1, -1, 779, 779, 779, 371, 
	-1, 378, 379, 652, 779, 779, -1, -1, 
	-1, -1, -1, -1, -1, 556, -1, -1, 
	779, -1, 780, 780, 780, 780, 780, 780, 
	780, 780, 780, 780, 780, 780, 780, 780, 
	780, -1, 780, 780, 780, 780, 780, 780, 
	780, 780, -1, -1, -1, 780, 780, 780, 
	780, 780, -1, 780, -1, 780, 780, 780, 
	780, -1, 780, -1, 780, 780, 780, -1, 
	-1, 780, 1160, -1, 780, 780, 780, 780, 
	780, -1, 780, 780, 780, -1, -1, -1, 
	-1, 780, 780, 780, 780, 780, -1, -1, 
	780, 780, 780, 780, -1, -1, -1, -1, 
	-1, -1, -1, 1160, 1160, 1160, 1160, 1160, 
	1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 
	1160, 1160, 1108, 1160, 1160, 1160, 1160, 1160, 
	1160, 1160, 619, 369, 370, 377, 381, 372, 
	-1, -1, -1, -1, 618, 369, 370, 377, 
	381, 372, -1, -1, 1048, 1048, 1048, -1, 
	1048, 871, 871, 871, 871, 871, 871, 871, 
	871, 871, 871, 871, 871, 871, 871, -1, 
	620, 369, 370, 377, 381, 372, -1, -1, 
	-1, -1, -1, -1, -1, -1, 395, 872, 
	872, 872, 872, 872, 872, 872, 872, 872, 
	872, 872, 872, 872, 872, 167, 780, 780, 
	780, 780, -1, 779, 780, 780, -1, 780, 
	780, 780, -1, 871, -1, -1, 780, 780, 
	780, -1, 780, 780, 780, -1, -1, -1, 
	-1, 780, -1, 394, -1, -1, 780, 166, 
	-1, -1, 780, 780, 780, -1, 780, 780, 
	-1, 872, 780, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 780, 374, 
	375, 376, 373, -1, -1, -1, -1, 380, 
	-1, -1, 780, 780, -1, 371, -1, 378, 
	379, -1, -1, -1, 780, 780, -1, -1, 
	-1, 1160, 780, 1160, 1160, 1160, 1160, 1160, 
	-1, -1, -1, -1, -1, -1, 374, 375, 
	376, 373, -1, -1, 1048, -1, 380, -1, 
	-1, 780, 780, 780, 371, -1, 378, 379, 
	871, 780, 780, 1048, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 780, -1, 781, 
	781, 781, 781, 781, 781, 781, 781, 781, 
	781, 781, 781, 781, 781, 781, 872, 781, 
	781, 781, 781, 781, 781, 781, 781, -1, 
	1048, -1, 781, 781, 781, 781, 781, -1, 
	781, -1, 781, 781, 781, 781, -1, 781, 
	-1, 781, 781, 781, -1, -1, 781, 1161, 
	-1, 781, 781, 781, 781, 781, -1, 781, 
	781, 781, -1, -1, -1, -1, 781, 781, 
	781, 781, 781, -1, -1, 781, 781, 781, 
	781, -1, -1, -1, -1, -1, 611, -1, 
	1161, 1161, 1161, 1161, 1161, 1161, 1161, 1161, 
	1161, 1161, 1161, 1161, 1161, 1161, 1161, 1109, 
	1161, 1161, 1161, 1161, 1161, 1161, 1161, 624, 
	370, 377, 381, 372, -1, -1, -1, -1, 
	873, 873, 873, 873, 873, 873, 873, 873, 
	873, 873, 873, 873, 873, 873, -1, 402, 
	-1, -1, -1, -1, 401, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 621, 370, 
	377, 381, 372, -1, -1, -1, -1, -1, 
	-1, 658, 183, -1, 383, -1, 368, 369, 
	370, 377, 381, 372, -1, -1, -1, -1, 
	-1, -1, 873, 781, 781, 781, 781, -1, 
	780, 781, 781, 553, 781, 781, 781, -1, 
	-1, -1, -1, 781, 781, 781, -1, 781, 
	781, 781, 557, -1, -1, -1, 781, -1, 
	-1, -1, -1, 781, -1, -1, -1, 781, 
	781, 781, -1, 781, 781, -1, -1, 781, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 781, 374, 375, 376, 373, 
	-1, -1, -1, -1, 380, -1, -1, 781, 
	781, -1, 371, -1, 378, 379, -1, -1, 
	-1, 781, 781, -1, -1, -1, 1161, 781, 
	1161, 1161, 1161, 1161, 1161, -1, -1, -1, 
	-1, -1, -1, 374, 375, 376, 373, 873, 
	-1, -1, -1, 380, -1, -1, 781, 781, 
	781, 371, -1, 378, 379, -1, 781, 781, 
	-1, -1, -1, -1, -1, -1, -1, 652, 
	-1, -1, 781, -1, 782, 782, 782, 782, 
	782, 782, 782, 782, 782, 782, 782, 782, 
	782, 782, 782, -1, 782, 782, 782, 782, 
	782, 782, 782, 782, -1, -1, -1, 782, 
	782, 782, 782, 782, -1, 782, -1, 782, 
	782, 782, 782, -1, 782, -1, 782, 782, 
	782, -1, -1, 782, 1107, -1, 782, 782, 
	782, 782, 782, -1, 782, 782, 782, -1, 
	-1, -1, -1, 782, 782, 782, 782, 782, 
	-1, -1, 782, 782, 782, 782, -1, -1, 
	-1, -1, -1, -1, -1, 1107, 1107, 1107, 
	1107, 1107, 1107, 1107, 1107, 1107, 1107, 1107, 
	1107, 1107, 1107, 1107, 1107, 1107, 1107, 1107, 
	1107, 1107, 1107, 1107, 622, 370, 377, 381, 
	372, -1, -1, -1, -1, -1, 619, 369, 
	370, 377, 381, 372, -1, -1, -1, -1, 
	-1, -1, 874, 874, 874, 874, 874, 874, 
	874, 874, 874, 874, 874, 874, 874, 874, 
	-1, -1, -1, 623, 370, 377, 381, 372, 
	-1, -1, -1, -1, 620, 369, 370, 377, 
	381, 372, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	782, 782, 782, 782, -1, 781, 782, 782, 
	-1, 782, 782, 782, 874, -1, -1, -1, 
	782, 782, 782, -1, 782, 782, 782, -1, 
	-1, -1, -1, 782, -1, -1, -1, -1, 
	782, -1, -1, -1, 782, 782, 782, -1, 
	782, 782, -1, -1, 782, -1, -1, -1, 
	-1, -1, 138, 139, 141, 140, 142, -1, 
	782, -1, 1025, -1, 1025, 1025, 1025, 1025, 
	-1, 1025, -1, -1, 782, 782, -1, -1, 
	-1, 135, 136, 137, -1, -1, 782, 782, 
	-1, -1, -1, 1107, 782, 1107, 1107, 1107, 
	1107, 1107, 993, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1025, -1, -1, -1, 
	-1, -1, -1, 782, 782, 782, -1, -1, 
	-1, 874, -1, 782, 782, -1, -1, -1, 
	1143, 1143, 637, -1, 636, -1, -1, 782, 
	-1, 783, 783, 783, 783, 783, 783, 783, 
	783, 783, 783, 783, 783, 783, 783, 783, 
	-1, 783, 783, 783, 783, 783, 783, 783, 
	783, -1, -1, -1, 783, 783, 783, 783, 
	783, -1, 783, -1, 783, 783, 783, 783, 
	-1, 783, -1, 783, 783, 783, -1, -1, 
	783, 1104, -1, 783, 783, 783, 783, 783, 
	-1, 783, 783, 783, -1, -1, -1, -1, 
	783, 783, 783, 783, 783, -1, -1, 783, 
	783, 783, 783, -1, -1, -1, -1, -1, 
	-1, -1, 1104, 1104, 1104, 1104, 1104, 1104, 
	1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 
	1104, -1, 1104, 1104, 1104, 1104, 1104, 1104, 
	1104, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1025, 624, 370, 377, 381, 372, 
	1025, -1, -1, -1, 1025, 1025, -1, 875, 
	875, 875, 875, 875, 875, 875, 875, 875, 
	875, 875, 875, 875, 875, -1, -1, -1, 
	1143, 659, 183, -1, -1, -1, -1, -1, 
	-1, -1, 621, 370, 377, 381, 372, 635, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1025, 783, 783, 783, 
	783, -1, 782, 783, 783, -1, 783, 783, 
	783, 875, -1, -1, -1, 783, 783, 783, 
	-1, 783, 783, 783, 689, -1, -1, -1, 
	783, -1, -1, -1, -1, 783, -1, -1, 
	-1, 783, 783, 783, -1, 783, 783, -1, 
	-1, 783, -1, -1, -1, -1, -1, 138, 
	139, 141, 140, 142, -1, 783, -1, 1026, 
	-1, 1026, 1026, 1026, 1026, -1, 1026, -1, 
	-1, 783, 783, -1, -1, -1, 135, 136, 
	137, -1, -1, 783, 783, -1, -1, -1, 
	1104, 783, 1104, 1104, 1104, 1104, 1104, 993, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1026, -1, -1, -1, -1, -1, -1, 
	783, 783, 783, -1, -1, -1, 875, -1, 
	783, 783, -1, 1157, 1157, 1157, -1, 1157, 
	-1, -1, -1, -1, 783, -1, 784, 784, 
	784, 784, 784, 784, 784, 784, 784, 784, 
	784, 784, 784, 784, 784, -1, 784, 784, 
	784, 784, 784, 784, 784, 784, -1, -1, 
	-1, 784, 784, 784, 784, 784, -1, 784, 
	-1, 784, 784, 784, 784, -1, 784, -1, 
	784, 784, 784, -1, -1, 784, 1095, -1, 
	784, 784, 784, 784, 784, -1, 784, 784, 
	784, -1, -1, -1, -1, 784, 784, 784, 
	784, 784, -1, -1, 784, 784, 784, 784, 
	-1, -1, -1, -1, -1, -1, -1, 1095, 
	1095, 1095, 1095, 1095, 1095, 1095, 1095, 1095, 
	1095, 1095, 1095, 1095, 1095, 1095, -1, 1095, 
	1095, 1095, 1095, 1095, 1095, 1095, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1026, 
	622, 370, 377, 381, 372, 1026, -1, -1, 
	-1, 1026, 1026, -1, 876, 876, 876, 876, 
	876, 876, 876, 876, 876, 876, 876, 876, 
	876, 876, -1, 1157, -1, -1, 733, 183, 
	1029, -1, -1, -1, -1, -1, -1, 623, 
	370, 377, 381, 372, -1, -1, -1, 1059, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1026, 784, 784, 784, 784, -1, 783, 
	784, 784, -1, 784, 784, 784, 876, -1, 
	-1, -1, 784, 784, 784, 1029, 784, 784, 
	784, 1059, -1, -1, -1, 784, -1, -1, 
	-1, -1, 784, -1, -1, -1, 784, 784, 
	784, -1, 784, 784, -1, -1, 784, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 784, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 784, 784, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	784, 784, -1, -1, -1, 1095, 784, 1095, 
	1095, 1095, 1095, 1095, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 784, 784, 784, 
	-1, -1, -1, 876, -1, 784, 784, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 784, -1, 785, 785, 785, 785, 785, 
	785, 785, 785, 785, 785, 785, 785, 785, 
	785, 785, -1, 785, 785, 785, 785, 785, 
	785, 785, 785, -1, -1, -1, 785, 785, 
	785, 785, 785, -1, 785, -1, 785, 785, 
	785, 785, -1, 785, -1, 785, 785, 785, 
	-1, -1, 785, 1096, -1, 785, 785, 785, 
	785, 785, -1, 785, 785, 785, -1, -1, 
	-1, -1, 785, 785, 785, 785, 785, -1, 
	-1, 785, 785, 785, 785, -1, -1, -1, 
	-1, -1, -1, -1, 1096, 1096, 1096, 1096, 
	1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 
	1096, 1096, 1096, -1, 1096, 1096, 1096, 1096, 
	1096, 1096, 1096, 877, 877, 877, 877, 877, 
	877, 877, 877, 877, 877, 877, 877, 877, 
	877, 878, 878, 878, 878, 878, 878, 878, 
	878, 878, 878, 878, 878, 878, 878, -1, 
	879, 879, 879, 879, 879, 879, 879, 879, 
	879, 879, 879, 879, 879, 879, -1, -1, 
	-1, -1, -1, -1, -1, 659, 183, -1, 
	-1, -1, -1, -1, -1, 877, -1, -1, 
	-1, -1, -1, 635, -1, -1, -1, 785, 
	785, 785, 785, 878, 784, 785, 785, -1, 
	785, 785, 785, -1, -1, -1, -1, 785, 
	785, 785, 879, 785, 785, 785, -1, -1, 
	-1, -1, 785, -1, -1, -1, -1, 785, 
	689, -1, -1, 785, 785, 785, -1, 785, 
	785, -1, -1, 785, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 785, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 785, 785, -1, -1, -1, 
	-1, -1, -1, -1, -1, 785, 785, -1, 
	-1, -1, 1096, 785, 1096, 1096, 1096, 1096, 
	1096, -1, 877, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	878, -1, 785, 785, 785, -1, -1, -1, 
	-1, -1, 785, 785, -1, -1, -1, 879, 
	-1, -1, -1, -1, -1, -1, 785, -1, 
	786, 786, 786, 786, 786, 786, 786, 786, 
	786, 786, 786, 786, 786, 786, 786, -1, 
	786, 786, 786, 786, 786, 786, 786, 786, 
	-1, -1, -1, 786, 786, 786, 786, 786, 
	-1, 786, -1, 786, 786, 786, 786, -1, 
	786, -1, 786, 786, 786, -1, -1, 786, 
	1097, -1, 786, 786, 786, 786, 786, -1, 
	786, 786, 786, -1, -1, -1, -1, 786, 
	786, 786, 786, 786, -1, -1, 786, 786, 
	786, 786, -1, -1, -1, -1, -1, -1, 
	-1, 1097, 1097, 1097, 1097, 1097, 1097, 1097, 
	1097, 1097, 1097, 1097, 1097, 1097, 1097, 1097, 
	-1, 1097, 1097, 1097, 1097, 1097, 1097, 1097, 
	880, 880, 880, 880, 880, 880, 880, 880, 
	880, 880, 880, 880, 880, 880, 881, 881, 
	881, 881, 881, 881, 881, 881, 881, 881, 
	881, 881, 881, 881, -1, 882, 882, 882, 
	882, 882, 882, 882, 882, 882, 882, 882, 
	882, 882, 882, -1, -1, -1, -1, -1, 
	-1, -1, 733, 183, -1, -1, -1, -1, 
	-1, -1, 880, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 786, 786, 786, 786, 
	881, 785, 786, 786, -1, 786, 786, 786, 
	-1, -1, -1, -1, 786, 786, 786, 882, 
	786, 786, 786, -1, -1, -1, -1, 786, 
	-1, -1, -1, -1, 786, -1, -1, -1, 
	786, 786, 786, -1, 786, 786, -1, -1, 
	786, -1, -1, -1, -1, -1, 138, 139, 
	141, 140, 142, -1, 786, 667, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	786, 786, -1, -1, -1, 135, 136, 137, 
	-1, -1, 786, 786, -1, -1, -1, 1097, 
	786, 1097, 1097, 1097, 1097, 1097, 993, 880, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 881, -1, 786, 
	786, 786, -1, -1, -1, -1, -1, 786, 
	786, -1, -1, -1, 882, -1, -1, -1, 
	-1, -1, -1, 786, -1, 787, 787, 787, 
	787, 787, 787, 787, 787, 787, 787, 787, 
	787, 787, 787, 787, -1, 787, 787, 787, 
	787, 787, 787, 787, 787, -1, -1, -1, 
	787, 787, 787, 787, 787, -1, 787, -1, 
	787, 787, 787, 787, -1, 787, -1, 787, 
	787, 787, -1, -1, 787, 1098, -1, 787, 
	787, 787, 787, 787, -1, 787, 787, 787, 
	-1, -1, -1, -1, 787, 787, 787, 787, 
	787, -1, -1, 787, 787, 787, 787, -1, 
	-1, -1, -1, 666, -1, -1, 1098, 1098, 
	1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 
	1098, 1098, 1098, 1098, 1098, -1, 1098, 1098, 
	1098, 1098, 1098, 1098, 1098, -1, -1, -1, 
	-1, 570, 1129, 558, 560, 561, 559, 563, 
	564, 566, 565, 567, 569, 568, 562, -1, 
	-1, -1, -1, -1, 570, 1129, 558, 560, 
	561, 559, 563, 564, 566, 565, 567, 569, 
	568, 562, -1, -1, -1, 665, 183, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 557, -1, -1, -1, -1, 
	-1, 787, 787, 787, 787, -1, 786, 787, 
	787, -1, 787, 787, 787, -1, 557, -1, 
	-1, 787, 787, 787, -1, 787, 787, 787, 
	-1, -1, -1, -1, 787, -1, -1, -1, 
	-1, 787, -1, -1, -1, 787, 787, 787, 
	-1, 787, 787, -1, -1, 787, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 787, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 787, 787, -1, 
	-1, -1, 1143, 1143, 637, -1, 636, 787, 
	787, -1, -1, -1, 1098, 787, 1098, 1098, 
	1098, 1098, 1098, -1, -1, -1, -1, -1, 
	651, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 787, 787, 787, -1, 
	-1, -1, -1, 702, 787, 787, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	787, -1, 788, 788, 788, 788, 788, 788, 
	788, 788, 788, 788, 788, 788, 788, 788, 
	788, -1, 788, 788, 788, 788, 788, 788, 
	788, 788, -1, -1, -1, 788, 788, 788, 
	788, 788, -1, 788, -1, 788, 788, 788, 
	788, -1, 788, -1, 788, 788, 788, -1, 
	-1, 788, 1115, -1, 788, 788, 788, 788, 
	788, -1, 788, 788, 788, -1, -1, -1, 
	-1, 788, 788, 788, 788, 788, -1, -1, 
	788, 788, 788, 788, -1, -1, -1, -1, 
	-1, -1, -1, 1115, 1115, 1115, 1115, 1115, 
	1115, 1115, 1115, 1115, 1115, 1115, 1115, 1115, 
	1115, 1115, 1143, 1115, 1115, 1115, 1115, 1115, 
	1115, 1115, -1, -1, -1, -1, -1, -1, 
	-1, 635, -1, -1, -1, -1, 1089, 1089, 
	1089, 1089, 517, 1083, 1083, 1083, 1089, 1083, 
	-1, -1, -1, -1, 1089, -1, 1089, 1089, 
	1083, 1083, 514, 515, 516, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 726, -1, 
	-1, -1, -1, -1, -1, -1, -1, 883, 
	883, 883, 883, 883, 883, 883, 883, 883, 
	883, 883, 883, 883, 883, -1, 788, 788, 
	788, 788, -1, 787, 788, 788, -1, 788, 
	788, 788, -1, -1, -1, -1, 788, 788, 
	788, -1, 788, 788, 788, -1, -1, -1, 
	-1, 788, -1, -1, -1, -1, 788, -1, 
	-1, -1, 788, 788, 788, -1, 788, 788, 
	-1, 883, 788, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 788, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 788, 788, -1, -1, -1, -1, 
	-1, -1, -1, -1, 788, 788, -1, -1, 
	-1, 1115, 788, 1115, 1115, 1115, 1115, 1115, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 788, 788, 788, -1, -1, -1, -1, 
	-1, 788, 788, -1, 513, -1, 1089, 1089, 
	1089, 1089, 1089, -1, -1, 788, -1, 789, 
	789, 789, 789, 789, 789, 789, 789, 789, 
	789, 789, 789, 789, 789, 789, 883, 789, 
	789, 789, 789, 789, 789, 789, 789, -1, 
	-1, -1, 789, 789, 789, 789, 789, -1, 
	789, -1, 789, 789, 789, 789, -1, 789, 
	-1, 789, 789, 789, -1, -1, 789, -1, 
	-1, 789, 789, 789, 789, 789, -1, 789, 
	789, 789, 1113, -1, -1, -1, 789, 789, 
	789, 789, 789, -1, -1, 789, 789, 789, 
	789, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1114, -1, -1, -1, -1, -1, 666, 
	-1, -1, -1, 1113, 1113, 1113, 1113, 1113, 
	1113, 1113, 1113, 1113, 1113, 1113, 1113, 1113, 
	1113, 1113, -1, 1113, 1113, 1113, 1113, 1113, 
	1113, 1113, 1114, 1114, 1114, 1114, 1114, 1114, 
	1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 
	1114, -1, 1114, 1114, 1114, 1114, 1114, 1114, 
	1114, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 665, 183, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 789, 789, 789, 789, 557, 
	788, 789, 789, -1, 789, 789, 789, -1, 
	-1, -1, -1, 789, 789, 789, -1, 789, 
	789, 789, 557, 997, -1, 997, 789, -1, 
	-1, -1, 997, 789, -1, -1, 359, 789, 
	789, 789, -1, 789, 789, 463, 465, 789, 
	1089, 1089, 1089, 1089, 517, 1084, 1084, 1084, 
	1089, 1084, -1, 789, 464, -1, 1089, -1, 
	1089, 1089, 1084, 1084, 514, 515, 516, 789, 
	789, -1, -1, -1, -1, -1, -1, -1, 
	-1, 789, 789, -1, -1, -1, 1027, 789, 
	1027, 1027, 1027, 1027, -1, 1027, -1, -1, 
	-1, 1113, -1, 1113, 1113, 1113, 1113, 1113, 
	-1, -1, -1, -1, 651, -1, 789, 789, 
	789, -1, -1, -1, -1, -1, 789, 789, 
	1114, -1, 1114, 1114, 1114, 1114, 1114, 702, 
	1027, -1, 789, -1, 790, 790, 790, 790, 
	790, 790, 790, 790, 790, 790, 790, 790, 
	790, 790, 790, -1, 790, 790, 790, 790, 
	790, 790, 790, 790, -1, -1, -1, 790, 
	790, 790, 790, 790, -1, 790, -1, 790, 
	790, 790, 790, -1, 790, -1, 790, 790, 
	790, 997, 997, 790, -1, -1, 790, 790, 
	790, 790, 790, -1, 790, 790, 790, -1, 
	-1, -1, -1, 790, 790, 790, 790, 790, 
	-1, -1, 790, 790, 790, 790, -1, -1, 
	-1, -1, -1, 997, 753, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 513, -1, 
	1089, 1089, 1089, 1089, 1089, 1089, 1089, 1089, 
	1089, 517, 1085, 1085, 1085, 1089, 1085, -1, 
	-1, -1, -1, 1089, -1, 1089, 1089, 1085, 
	1085, 514, 515, 516, -1, 635, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1027, -1, 
	-1, -1, -1, -1, 1027, -1, -1, -1, 
	1027, 1027, -1, -1, -1, -1, -1, -1, 
	-1, -1, 726, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	790, 790, 790, 790, -1, 789, 790, 790, 
	-1, 790, 790, 790, -1, -1, -1, -1, 
	790, 790, 790, -1, 790, 790, 790, -1, 
	1027, -1, -1, 790, -1, -1, -1, -1, 
	790, -1, -1, -1, 790, 790, 790, -1, 
	790, 790, -1, -1, 790, 1089, 1089, 1089, 
	1089, 517, 1086, 1086, 1086, 1089, 1086, -1, 
	790, -1, -1, 1089, -1, 1089, 1089, 1086, 
	1086, 514, 515, 516, 790, 790, -1, -1, 
	-1, -1, -1, -1, -1, -1, 790, 790, 
	-1, -1, -1, 1028, 790, 1028, 1028, 1028, 
	1028, -1, 1028, -1, -1, -1, -1, -1, 
	-1, -1, -1, 513, -1, 1089, 1089, 1089, 
	1089, 1089, -1, 790, 790, 790, -1, -1, 
	-1, -1, -1, 790, 790, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1028, -1, 790, 
	513, 27, 28, 1121, 25, 23, 26, 55, 
	56, 64, 67, 68, 65, 66, 73, 74, 
	-1, 69, 70, 30, 52, 35, 36, 40, 
	38, -1, -1, -1, 853, 853, 853, 853, 
	853, -1, 32, -1, 47, 41, 42, 43, 
	-1, 50, -1, 75, 48, 46, -1, -1, 
	37, -1, -1, 853, 853, 853, 72, 71, 
	-1, 24, 54, 53, -1, -1, -1, -1, 
	77, 78, 79, 51, 61, -1, -1, 82, 
	84, 86, 88, -1, -1, -1, -1, -1, 
	997, -1, 997, 522, -1, -1, -1, 997, 
	-1, -1, -1, 513, -1, 1089, 1089, 1089, 
	1089, 1089, 463, 465, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 464, -1, -1, 1091, 1091, 1091, 1091, 
	1091, 1091, 1091, 1091, 1091, 1091, 518, 519, 
	521, 520, 1091, -1, 1091, 1091, 1091, 1091, 
	1091, 1091, 1091, 1028, -1, -1, -1, -1, 
	-1, 1028, -1, -1, -1, 1028, 1028, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 2, 21, 19, 
	49, -1, 790, 18, 20, -1, 17, 16, 
	14, -1, -1, -1, -1, 31, 12, 13, 
	-1, 29, 10, 4, -1, 1028, -1, -1, 
	22, -1, -1, -1, -1, 11, -1, -1, 
	-1, 8, 9, 3, -1, 5, 6, -1, 
	997, 7, 997, 997, 997, 997, -1, 997, 
	-1, -1, -1, 359, -1, 15, 997, 997, 
	-1, -1, 463, 465, -1, -1, -1, -1, 
	-1, 34, 33, -1, -1, -1, -1, -1, 
	-1, 464, -1, 853, 63, -1, -1, -1, 
	-1, 44, 997, -1, -1, -1, -1, -1, 
	997, 754, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	80, 76, 45, -1, -1, -1, -1, -1, 
	39, 993, 1091, -1, 1091, 1091, 1091, 1091, 
	1091, -1, -1, -1, 91, 826, 826, 826, 
	826, 826, 826, 826, 826, 826, 826, 826, 
	826, 826, 826, 826, 826, 826, 826, 826, 
	826, 826, 826, 826, 826, 826, 826, -1, 
	826, 826, 826, 826, 826, -1, 826, -1, 
	826, 826, 826, 826, -1, 826, -1, 826, 
	826, 826, -1, -1, 826, 826, 826, 826, 
	826, 826, 826, 826, -1, 826, 826, 826, 
	-1, -1, -1, -1, 826, 826, 826, 826, 
	826, -1, -1, 826, 826, 826, 826, 64, 
	67, 68, 65, 66, 73, 74, -1, 69, 
	70, 826, -1, -1, -1, -1, -1, -1, 
	753, -1, 138, 139, 141, 140, 142, -1, 
	997, 700, 513, -1, -1, -1, 997, -1, 
	-1, 75, 997, 997, -1, 131, -1, -1, 
	-1, 135, 136, 137, 72, 71, 130, -1, 
	-1, -1, -1, 124, 125, 126, -1, -1, 
	-1, -1, 993, 122, -1, 144, 145, 146, 
	147, -1, -1, -1, -1, -1, -1, -1, 
	127, -1, 1023, -1, 1023, 1023, 1023, 1023, 
	-1, 1023, 997, -1, -1, -1, 117, 118, 
	119, -1, 120, -1, -1, -1, -1, -1, 
	-1, 826, 826, 826, 826, -1, -1, 826, 
	826, -1, 826, 826, 826, -1, -1, -1, 
	-1, 826, 826, 826, 1023, 826, 826, 826, 
	-1, -1, -1, -1, 826, -1, -1, -1, 
	-1, 826, -1, -1, -1, 826, 826, 826, 
	-1, 826, 826, -1, -1, 826, 1024, 869, 
	1024, 1024, 1024, 1024, -1, 1024, 826, 826, 
	826, 826, 826, 826, 826, -1, -1, -1, 
	-1, 826, 826, -1, -1, 826, 826, -1, 
	869, 869, 869, 869, 869, -1, -1, 826, 
	826, -1, -1, -1, -1, 826, -1, -1, 
	1024, -1, -1, -1, -1, -1, -1, 869, 
	869, 869, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 826, 826, 826, 513, 
	869, -1, -1, -1, 826, 826, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	826, -1, -1, -1, -1, -1, -1, 826, 
	-1, -1, 112, 113, 114, 115, 116, -1, 
	121, 129, 133, -1, -1, -1, -1, 132, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 522, 1023, -1, -1, -1, -1, -1, 
	1023, -1, -1, -1, 1023, 1023, -1, -1, 
	-1, -1, -1, 143, 134, 128, 123, 993, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1092, 1092, 1092, 1092, 1092, 1092, 
	1092, 1092, 1092, 1092, 518, 519, 521, 520, 
	1092, -1, 1092, 1092, 1092, 1092, 1092, 1092, 
	1092, -1, -1, -1, 1023, -1, 522, -1, 
	-1, -1, -1, -1, -1, -1, 1024, 513, 
	-1, -1, -1, -1, 1024, -1, -1, -1, 
	1024, 1024, -1, -1, -1, 869, 869, -1, 
	869, -1, -1, -1, -1, -1, -1, 1093, 
	1093, 1093, 1093, 1093, 1093, 1093, 1093, 1093, 
	1093, 518, 519, 521, 520, 1093, -1, 1093, 
	1093, 1093, 1093, 1093, 1093, 1093, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1024, -1, -1, -1, -1, -1, -1, 869, 
	869, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 826, -1, -1, -1, -1, 
	-1, 2, 21, 19, 49, -1, -1, 18, 
	20, -1, 17, 16, 14, -1, -1, -1, 
	-1, 31, 12, 13, -1, 29, 10, 4, 
	-1, -1, -1, -1, 22, -1, -1, -1, 
	-1, 11, -1, 869, -1, 8, 9, 3, 
	-1, 5, 6, -1, -1, 7, -1, -1, 
	809, 809, 809, 809, 809, 809, -1, -1, 
	1092, 15, 1092, 1092, 1092, 1092, 1092, -1, 
	-1, -1, 809, -1, -1, 34, 33, -1, 
	-1, -1, -1, 809, 809, 809, 809, 809, 
	62, 809, -1, 809, -1, 44, -1, -1, 
	809, -1, -1, 809, 809, 754, -1, -1, 
	-1, -1, 809, 809, 809, -1, -1, -1, 
	809, 809, 809, -1, 80, 76, 45, 809, 
	809, 809, 809, 809, 39, 1093, -1, 1093, 
	1093, 1093, 1093, 1093, -1, -1, -1, -1, 
	91, 941, 941, 941, 941, 941, 941, 941, 
	941, 941, 941, 941, 941, 941, 941, 941, 
	941, 941, 941, 941, 941, 941, 941, 941, 
	941, 941, 941, -1, 941, 941, 941, 941, 
	941, -1, 941, -1, 941, 941, 941, 941, 
	-1, 941, -1, 941, 941, 941, -1, -1, 
	941, 941, 941, 941, 941, 941, 941, 941, 
	-1, 941, 941, 941, -1, -1, -1, -1, 
	941, 941, 941, 941, 941, -1, -1, 941, 
	941, 941, 941, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 941, -1, -1, 
	186, -1, -1, -1, 870, 809, 809, 809, 
	-1, -1, 809, 809, -1, 700, 809, 809, 
	-1, -1, -1, -1, 809, 809, 809, -1, 
	809, 809, 809, -1, -1, 870, 870, 870, 
	870, 870, -1, -1, 809, 809, -1, -1, 
	809, 809, 809, -1, 809, 809, -1, -1, 
	809, -1, -1, -1, 870, 870, 870, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 870, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 809, 809, -1, 941, 941, 941, 
	941, -1, -1, 941, 941, -1, 941, 941, 
	941, -1, -1, -1, -1, 941, 941, 941, 
	-1, 941, 941, 941, -1, -1, -1, -1, 
	941, -1, -1, -1, -1, 941, -1, -1, 
	-1, 941, 941, 941, -1, 941, 941, -1, 
	-1, 941, -1, -1, -1, -1, -1, -1, 
	809, -1, 941, 941, 941, 941, 941, 941, 
	941, -1, -1, -1, -1, 941, 941, -1, 
	185, 941, 941, -1, -1, -1, -1, -1, 
	-1, -1, -1, 941, 941, -1, -1, -1, 
	-1, 941, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	941, 941, 941, -1, -1, -1, -1, -1, 
	941, 941, 870, 870, -1, 870, -1, -1, 
	-1, -1, -1, -1, 941, -1, -1, -1, 
	-1, -1, -1, 941, -1, -1, 112, 113, 
	114, 115, 116, -1, 121, 129, 133, -1, 
	-1, -1, -1, 132, 64, 67, 68, 65, 
	66, 73, 74, -1, 69, 70, -1, -1, 
	-1, -1, -1, -1, 870, 870, -1, 138, 
	139, 141, 140, 142, -1, -1, -1, 143, 
	134, 128, 123, -1, -1, -1, 75, -1, 
	-1, -1, 131, -1, -1, -1, 135, 136, 
	137, 72, 71, 130, -1, -1, -1, -1, 
	124, 125, 126, -1, -1, -1, -1, 993, 
	122, -1, 144, 145, 146, 147, -1, -1, 
	870, -1, -1, -1, -1, 127, 64, 67, 
	68, 65, 66, 73, 74, -1, 69, 70, 
	-1, -1, -1, 117, 118, 119, -1, 120, 
	-1, 138, 139, 141, 140, 142, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	75, -1, -1, -1, 131, -1, -1, -1, 
	135, 136, 137, 72, 71, 130, -1, -1, 
	-1, -1, 124, 125, 126, -1, -1, -1, 
	-1, 993, 122, 522, 144, 145, 146, 147, 
	-1, -1, -1, -1, -1, -1, -1, 127, 
	-1, -1, -1, -1, -1, -1, -1, 941, 
	-1, -1, -1, -1, -1, 117, 118, 119, 
	-1, 120, -1, -1, 1090, 1090, 1090, 1090, 
	1090, 1090, 1090, 1090, 1090, 1090, 518, 519, 
	521, 520, 1090, -1, 1090, 1090, 1090, 1090, 
	1090, 1090, 1090, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 149, 
	113, 114, 115, 116, -1, 121, 129, 133, 
	-1, -1, -1, -1, 132, 1112, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	143, 134, 128, 123, 993, -1, 1112, 1112, 
	1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 
	1112, 1112, 1112, 1112, 1112, -1, 1112, 1112, 
	1112, 1112, 1112, 1112, 1112, -1, -1, -1, 
	-1, 152, 113, 114, 115, 116, -1, 121, 
	129, 133, -1, -1, -1, -1, 132, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1090, -1, 1090, 1090, 1090, 1090, 
	1090, -1, 143, 134, 128, 123, 993, -1, 
	-1, 827, 827, 827, 827, 827, 827, 827, 
	827, 827, 827, 827, 827, 827, 827, 827, 
	827, 827, 827, 827, 827, 827, 827, 827, 
	827, 827, 827, -1, 827, 827, 827, 827, 
	827, -1, 827, -1, 827, 827, 827, 827, 
	-1, 827, -1, 827, 827, 827, -1, -1, 
	827, 827, 827, 827, 827, 827, 827, 827, 
	-1, 827, 827, 827, -1, -1, -1, -1, 
	827, 827, 827, 827, 827, -1, -1, 827, 
	827, 827, 827, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1106, -1, 827, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1112, -1, 1112, 1112, 
	1112, 1112, 1112, -1, -1, -1, -1, -1, 
	-1, -1, 1108, -1, 1106, 1106, 1106, 1106, 
	1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 
	1106, 1106, 1106, -1, 1106, 1106, 1106, 1106, 
	1106, 1106, 1106, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1108, 1108, 1108, 1108, 1108, 
	1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 
	1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 
	1108, 1108, -1, -1, 185, 827, 827, 827, 
	827, -1, -1, 827, 827, -1, 827, 827, 
	827, -1, -1, -1, -1, 827, 827, 827, 
	-1, 827, 827, 827, -1, -1, -1, -1, 
	827, -1, -1, -1, -1, 827, -1, -1, 
	-1, 827, 827, 827, -1, 827, 827, -1, 
	-1, 827, -1, -1, -1, -1, -1, -1, 
	-1, -1, 827, 827, 827, 827, 827, 827, 
	827, -1, -1, -1, -1, 827, 827, -1, 
	-1, 827, 827, -1, -1, -1, -1, -1, 
	-1, -1, -1, 827, 827, -1, -1, -1, 
	-1, 827, -1, -1, -1, -1, -1, -1, 
	-1, -1, 997, -1, 997, 997, 997, 997, 
	-1, 997, -1, -1, -1, -1, -1, -1, 
	827, 827, 827, -1, 463, 465, -1, -1, 
	827, 827, 1106, -1, 1106, 1106, 1106, 1106, 
	1106, -1, -1, 464, 827, -1, -1, -1, 
	-1, -1, -1, 827, 997, -1, -1, 64, 
	67, 68, 65, 66, 73, 74, -1, 69, 
	70, 1108, -1, 1108, 1108, 1108, 1108, 1108, 
	-1, -1, 138, 139, 141, 140, 142, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 75, -1, -1, -1, 131, -1, -1, 
	-1, 135, 136, 137, 72, 71, 130, -1, 
	-1, -1, -1, 124, 125, 126, -1, -1, 
	-1, -1, 993, 122, 1109, 144, 145, 146, 
	147, -1, -1, -1, -1, -1, -1, -1, 
	127, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1109, 1109, 1109, 
	1109, 1109, 1109, 1109, 1109, 1109, 1109, 1109, 
	1109, 1109, 1109, 1109, 1109, 1109, 1109, 1109, 
	1109, 1109, 1109, 1109, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 997, 701, -1, -1, -1, -1, 
	997, -1, -1, -1, 997, 997, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 827, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 149, 113, 114, 115, 116, 
	-1, 121, 129, 133, -1, -1, -1, -1, 
	132, -1, -1, -1, 997, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 143, 134, 128, 123, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	268, 129, 133, -1, -1, -1, -1, 132, 
	-1, -1, -1, -1, -1, 152, 113, 114, 
	115, 116, -1, 121, 129, 133, -1, -1, 
	-1, -1, 132, 1109, -1, 1109, 1109, 1109, 
	1109, 1109, -1, 143, 134, 128, 123, 993, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 143, 134, 
	128, 123, 828, 828, 828, 828, 828, 828, 
	828, 828, 828, 828, 828, 828, 828, 828, 
	828, 828, 828, 828, 828, 828, 828, 828, 
	828, 828, 828, 828, -1, 828, 828, 828, 
	828, 828, -1, 828, -1, 828, 828, 828, 
	828, -1, 828, -1, 828, 828, 828, -1, 
	-1, 828, 828, 828, 828, 828, 828, 828, 
	828, 1099, 828, 828, 828, -1, -1, -1, 
	-1, 828, 828, 828, 828, 828, -1, -1, 
	828, 828, 828, 828, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1100, -1, 828, -1, 
	-1, -1, 1099, 1099, 1099, 1099, 1099, 1099, 
	1099, 1099, 1099, 1099, 1099, 1099, 1099, 1099, 
	1099, -1, 1099, 1099, 1099, 1099, 1099, 1099, 
	1099, -1, -1, -1, -1, 1100, 1100, 1100, 
	1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 
	1100, 1100, 1100, 1100, -1, 1100, 1100, 1100, 
	1100, 1100, 1100, 1100, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 828, 828, 
	828, 828, -1, -1, 828, 828, -1, 828, 
	828, 828, -1, -1, -1, -1, 828, 828, 
	828, -1, 828, 828, 828, -1, -1, -1, 
	-1, 828, -1, -1, -1, -1, 828, -1, 
	-1, -1, 828, 828, 828, -1, 828, 828, 
	-1, -1, 828, -1, -1, -1, -1, -1, 
	-1, -1, -1, 828, 828, 828, 828, 828, 
	828, 828, -1, -1, -1, -1, 828, 828, 
	-1, -1, 828, 828, -1, -1, -1, -1, 
	-1, -1, -1, -1, 828, 828, -1, -1, 
	-1, -1, 828, -1, -1, -1, -1, -1, 
	1099, -1, 1099, 1099, 1099, 1099, 1099, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 828, 828, 828, -1, -1, -1, -1, 
	-1, 828, 828, 1100, -1, 1100, 1100, 1100, 
	1100, 1100, -1, -1, -1, 828, -1, -1, 
	-1, -1, -1, -1, 828, 920, 920, 920, 
	920, 920, 920, 920, 920, 920, 920, 920, 
	920, 920, 920, 920, 920, 920, 920, 920, 
	920, 920, 920, 920, 920, 920, 920, -1, 
	920, 920, 920, 920, 920, -1, 920, -1, 
	920, 920, 920, 920, -1, 920, -1, 920, 
	920, 920, -1, -1, 920, 920, 920, 920, 
	920, 920, 920, 920, 1101, 920, 920, 920, 
	-1, -1, -1, -1, 920, 920, 920, 920, 
	920, -1, -1, 920, 920, 920, 920, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1102, 
	-1, 920, -1, -1, -1, 1101, 1101, 1101, 
	1101, 1101, 1101, 1101, 1101, 1101, 1101, 1101, 
	1101, 1101, 1101, 1101, -1, 1101, 1101, 1101, 
	1101, 1101, 1101, 1101, -1, -1, -1, -1, 
	1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 
	1102, 1102, 1102, 1102, 1102, 1102, 1102, -1, 
	1102, 1102, 1102, 1102, 1102, 1102, 1102, -1, 
	-1, -1, -1, -1, -1, -1, -1, 701, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	828, 920, 920, 920, 920, -1, -1, 920, 
	920, -1, 920, 920, 920, -1, -1, -1, 
	-1, 920, 920, 920, -1, 920, 920, 920, 
	-1, -1, -1, -1, 920, -1, -1, -1, 
	-1, 920, -1, -1, -1, 920, 920, 920, 
	-1, 920, 920, -1, -1, 920, -1, -1, 
	-1, -1, -1, -1, -1, -1, 920, 920, 
	920, 920, 920, 920, 920, -1, -1, -1, 
	-1, 920, 920, -1, -1, 920, 920, -1, 
	-1, -1, -1, -1, 268, 129, 133, 920, 
	920, -1, -1, 132, -1, 920, -1, -1, 
	-1, -1, -1, 1101, -1, 1101, 1101, 1101, 
	1101, 1101, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 920, 920, 920, 143, 
	134, 128, 123, -1, 920, 920, 1102, -1, 
	1102, 1102, 1102, 1102, 1102, -1, -1, -1, 
	920, -1, -1, -1, -1, -1, -1, 920, 
	970, 970, 970, 970, 970, 970, 970, 970, 
	970, 970, 970, 970, 970, 970, 970, 970, 
	970, 970, 970, 970, 970, 970, 970, 970, 
	970, 970, -1, 970, 970, 970, 970, 970, 
	-1, 970, -1, 970, 970, 970, 970, -1, 
	970, -1, 970, 970, 970, 194, -1, 970, 
	970, 970, 970, 970, 970, 970, 970, -1, 
	970, 970, 970, -1, -1, -1, -1, 970, 
	970, 970, 970, 970, -1, -1, 970, 970, 
	970, 970, -1, -1, -1, -1, -1, 193, 
	-1, -1, -1, -1, 970, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 920, 970, 970, 970, 970, 
	-1, -1, 970, 970, -1, 970, 970, 970, 
	-1, -1, -1, -1, 970, 970, 970, -1, 
	970, 970, 970, -1, -1, -1, -1, 970, 
	-1, -1, -1, -1, 970, -1, -1, -1, 
	970, 970, 970, -1, 970, 970, -1, -1, 
	970, -1, -1, -1, -1, -1, -1, -1, 
	-1, 970, 970, 970, 970, 970, 970, 970, 
	-1, -1, -1, -1, 970, 970, -1, -1, 
	970, 970, -1, -1, -1, -1, -1, -1, 
	192, -1, 970, 970, -1, -1, -1, -1, 
	970, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 970, 
	970, 970, -1, -1, -1, -1, -1, 970, 
	970, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 970, -1, -1, -1, -1, 
	-1, -1, 970, 1067, 1067, 1067, 1067, 1067, 
	1067, 1067, 1067, 1067, 1067, 1067, 1067, 1067, 
	1067, 1067, 1067, 1067, 1067, 1067, 1067, 1067, 
	1067, 1067, 1067, 1067, 1067, -1, 1067, 1067, 
	1067, 1067, 1067, -1, 1067, -1, 1067, 1067, 
	1067, 1067, -1, 1067, -1, 1067, 1067, 1067, 
	1067, 1067, 1067, 1067, 1067, 1067, 1067, 1067, 
	1067, 1067, 1067, 1067, 1067, 1067, -1, 1067, 
	1067, 1067, 1067, 1067, 1067, 1067, 1067, 1067, 
	1067, 1067, 1067, 1067, 1067, 1067, -1, 1067, 
	-1, -1, 1067, -1, 1067, 1067, 1067, 1067, 
	1067, -1, -1, 1067, 1067, 1067, 1067, 1067, 
	1067, 1067, 1067, 1067, 1067, 1067, 1067, 1067, 
	1067, 1067, 1067, -1, -1, -1, -1, -1, 
	1067, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 970, 1067, 
	1067, 1067, 1067, -1, -1, 1067, 1067, 1067, 
	1067, 1067, 1067, -1, -1, -1, -1, 1067, 
	1067, 1067, 1067, 1067, 1067, 1067, -1, -1, 
	-1, -1, 1067, -1, -1, -1, -1, 1067, 
	1067, -1, -1, 1067, 1067, 1067, -1, 1067, 
	1067, -1, -1, 1067, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1067, 1067, 1067, 1067, 
	1067, 1067, 1067, -1, -1, -1, 1067, 1067, 
	1067, -1, -1, 1067, 1067, -1, 1067, 1067, 
	1067, 1067, 1067, 1067, 1067, 1067, 1067, -1, 
	-1, -1, 1067, 1067, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1067, 1067, 
	1067, -1, -1, 1067, -1, -1, -1, -1, 
	1067, -1, 1067, 1067, 1067, 1067, -1, 1067, 
	1067, 1067, 1067, 1067, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1067, -1, 
	1067, -1, -1, 1067, -1, 1067, 1067, -1, 
	-1, -1, 1067, -1, 1067, -1, 1067, -1, 
	-1, -1, 1066, 1066, 1066, 1066, 1066, 1066, 
	1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 
	1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 
	1066, 1066, 1066, 1066, -1, 1066, 1066, 1066, 
	1066, 1066, -1, 1066, -1, 1066, 1066, 1066, 
	1066, -1, 1066, -1, 1066, 1066, 1066, 1066, 
	1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 
	1066, 1066, 1066, 1066, 1066, -1, 1066, 1066, 
	1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 
	83, 85, 87, 89, 1066, -1, 1066, -1, 
	-1, 1066, -1, 1066, 1066, 1066, 1066, 1066, 
	-1, -1, 1066, 1066, 1066, 1066, 1066, 1066, 
	1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 
	1066, 1066, -1, -1, -1, -1, -1, 1066, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1067, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1066, 1066, 
	1066, 1066, -1, -1, 1066, 1066, 1066, 1066, 
	1066, 1066, -1, -1, -1, -1, 1066, 1066, 
	1066, 1066, 1066, 1066, 1066, -1, -1, -1, 
	-1, 1066, -1, -1, -1, -1, 1066, 1066, 
	-1, -1, 1066, 1066, 1066, -1, 1066, 1066, 
	-1, -1, 1066, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1066, 1066, 1066, 1066, 1066, 
	1066, 1066, -1, -1, 192, 1066, 1066, 1066, 
	-1, -1, 1066, 1066, -1, 1066, 1066, 1066, 
	1066, 1066, 1066, 1066, 1066, 1066, -1, -1, 
	-1, 1066, 1066, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1066, 1066, 1066, 
	-1, -1, 1066, -1, -1, -1, -1, 1066, 
	-1, 81, 191, 1066, 1066, -1, 1066, 1066, 
	1066, 1066, 1066, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1066, -1, 1066, 
	-1, -1, 1066, -1, 1066, 1066, -1, -1, 
	-1, 1066, -1, 1066, -1, 1066, 1040, 1040, 
	1040, 1040, 1040, 1040, 1040, -1, 1040, 1040, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1040, 1040, 1040, 1040, 1040, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1040, -1, -1, -1, 1040, -1, -1, -1, 
	1040, 1040, 1040, 1040, 1040, 1040, -1, -1, 
	-1, -1, 1040, 1040, 1040, -1, -1, -1, 
	-1, 1040, 1040, -1, 1154, 1154, 1154, 1040, 
	1149, -1, -1, -1, -1, -1, -1, 1040, 
	-1, -1, 64, 67, 68, 65, 66, 73, 
	74, -1, 69, 70, -1, 1040, 1040, 1040, 
	1040, 1040, -1, -1, -1, 138, 139, 141, 
	140, 142, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 75, -1, -1, -1, 
	131, -1, -1, -1, 135, 136, 137, 72, 
	71, 130, -1, -1, -1, -1, 124, 125, 
	126, -1, -1, -1, -1, 993, 122, -1, 
	144, 145, 146, 147, -1, -1, -1, -1, 
	-1, -1, -1, 127, 930, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1066, 117, 118, 119, -1, 120, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1040, 1040, 1040, 1040, 1040, -1, 1040, 
	1040, 1040, -1, -1, -1, -1, 1040, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1040, 176, 177, -1, -1, -1, -1, 
	-1, -1, -1, 175, -1, -1, -1, -1, 
	-1, -1, 1040, 1040, 1040, 1040, 1040, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 205, 204, -1, -1, -1, 174, 
	-1, -1, -1, -1, -1, 206, 113, 114, 
	115, 116, -1, 121, 129, 133, -1, -1, 
	-1, -1, 132, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 143, 134, 
	128, 123, 993, 945, 945, 945, 945, 945, 
	945, 945, 945, 945, 945, 945, 945, 945, 
	945, 945, 945, 945, 945, 945, 945, 945, 
	945, 945, 945, 945, 945, -1, 945, 945, 
	945, 945, 945, -1, 945, -1, 945, 945, 
	945, 945, -1, 945, -1, 945, 945, 945, 
	-1, -1, 945, 945, 945, 945, 945, 945, 
	945, 945, -1, 945, 945, 945, -1, -1, 
	-1, -1, 945, 945, 945, 945, 945, -1, 
	-1, 945, 945, 945, 945, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 945, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 64, 67, 68, 65, 66, 73, 
	74, -1, 69, 70, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 138, 139, 141, 
	140, 142, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 75, -1, -1, -1, 
	131, -1, -1, -1, 135, 136, 137, 72, 
	71, 130, -1, -1, -1, -1, 124, 125, 
	126, -1, -1, -1, -1, 993, 122, -1, 
	144, 145, 146, 147, -1, -1, -1, 945, 
	945, 945, 945, 127, -1, 945, 945, -1, 
	945, 945, 945, -1, -1, -1, -1, 945, 
	945, 945, 270, 945, 945, 945, -1, -1, 
	-1, -1, 945, -1, -1, -1, -1, 945, 
	-1, -1, -1, 945, 945, 945, -1, 945, 
	945, -1, -1, 945, -1, 80, 190, -1, 
	-1, -1, -1, -1, 945, 945, 945, 945, 
	945, 945, 945, -1, -1, -1, -1, 945, 
	945, -1, -1, 945, 945, -1, -1, -1, 
	-1, -1, -1, -1, -1, 945, 945, -1, 
	-1, -1, -1, 945, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 27, 28, 
	1131, 25, 23, 26, -1, -1, -1, -1, 
	-1, -1, 945, 945, 945, -1, -1, -1, 
	30, -1, 945, 945, -1, -1, -1, -1, 
	-1, 853, 853, 853, 853, 853, 945, 32, 
	-1, 243, -1, -1, -1, 945, 50, -1, 
	-1, 48, 46, -1, -1, -1, -1, -1, 
	853, 853, 853, -1, -1, -1, 24, 54, 
	53, -1, -1, -1, -1, 77, 78, 79, 
	51, 853, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 269, 129, 133, -1, -1, 
	-1, -1, 132, -1, -1, -1, 55, 56, 
	64, 67, 68, 65, 66, 73, 74, -1, 
	69, 70, -1, -1, 35, 36, 40, 38, 
	-1, -1, -1, -1, -1, -1, 143, 134, 
	128, 123, 993, -1, 41, 42, 43, -1, 
	-1, -1, 75, -1, -1, -1, -1, 37, 
	-1, -1, -1, -1, -1, 72, 71, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 59, -1, -1, 82, 84, 
	86, 88, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 276, -1, -1, -1, -1, 
	-1, -1, -1, 241, 239, 49, -1, -1, 
	238, 240, -1, -1, 242, 237, 274, 275, 
	-1, -1, 31, 235, 236, -1, 29, 233, 
	227, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 234, 225, -1, -1, 231, 232, 
	226, 945, 228, 229, -1, -1, 230, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 176, 177, 
	853, 853, -1, -1, -1, -1, -1, 175, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 205, 204, 
	-1, -1, -1, 174, -1, -1, -1, -1, 
	-1, 206, 113, 114, 115, 116, 224, 121, 
	129, 133, -1, -1, 277, -1, 132, -1, 
	-1, -1, -1, 273, -1, -1, -1, -1, 
	34, 33, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 62, -1, -1, -1, -1, 
	44, -1, 143, 134, 128, 123, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 80, 
	76, 45, -1, -1, -1, -1, -1, 39, 
	993, 948, 948, 948, 948, 948, 948, 948, 
	948, 948, 948, 948, 948, 948, 948, 948, 
	948, 948, 948, 948, 948, 948, 948, 948, 
	948, 948, 948, -1, 948, 948, 948, 948, 
	948, -1, 948, -1, 948, 948, 948, 948, 
	-1, 948, -1, 948, 948, 948, -1, 948, 
	948, 948, 948, 948, 948, 948, 948, 948, 
	948, 948, 948, 948, -1, 948, 948, 948, 
	948, 948, 948, 948, 948, 948, 948, 948, 
	948, 948, 948, 948, -1, -1, -1, -1, 
	-1, -1, 948, 948, 948, 948, -1, -1, 
	-1, 278, 279, 948, 280, 281, 282, 283, 
	948, 948, 948, 948, 948, -1, -1, 948, 
	948, -1, -1, -1, -1, -1, 948, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 948, 948, 948, 
	948, -1, -1, 948, 948, 948, 948, 948, 
	948, -1, -1, -1, -1, 948, 948, 948, 
	948, 948, 948, 948, -1, -1, -1, -1, 
	948, -1, -1, -1, -1, 948, 948, -1, 
	-1, 948, 948, 948, -1, 948, 948, -1, 
	-1, 948, -1, -1, -1, -1, -1, -1, 
	-1, -1, 948, 948, 948, 948, 948, 948, 
	948, -1, -1, -1, 948, 948, 948, -1, 
	-1, 948, 948, -1, 948, 948, 948, 948, 
	948, -1, 948, 948, 948, -1, -1, -1, 
	948, 948, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 948, 948, 948, -1, 
	-1, 948, -1, -1, -1, -1, 948, -1, 
	948, 948, 948, 948, -1, 948, 948, 948, 
	948, 948, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 948, -1, 948, -1, 
	-1, 948, -1, 948, 948, -1, -1, -1, 
	948, -1, 948, -1, 948, -1, -1, 269, 
	129, 133, -1, -1, -1, -1, 132, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 791, 791, 791, 791, 791, 791, -1, 
	-1, -1, 143, 134, 128, 123, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 791, 791, 791, 791, 
	791, -1, 791, -1, 791, -1, -1, -1, 
	-1, 791, -1, -1, 791, -1, -1, -1, 
	-1, -1, -1, 791, 791, 791, -1, -1, 
	-1, 791, 791, 791, -1, -1, -1, -1, 
	791, 791, 791, -1, 791, -1, -1, 241, 
	239, 49, -1, -1, 238, 240, -1, -1, 
	242, 237, -1, -1, -1, -1, 31, 235, 
	236, -1, 29, 233, 227, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 234, 225, 
	-1, -1, 231, 232, 226, -1, 228, 229, 
	-1, -1, 230, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 948, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 791, 
	791, -1, -1, 791, 791, 791, 791, -1, 
	791, -1, -1, -1, -1, 791, 791, 791, 
	791, 791, 791, 791, -1, -1, -1, -1, 
	-1, -1, 224, -1, -1, -1, -1, -1, 
	277, 791, 791, 791, -1, 791, 791, 273, 
	-1, 791, -1, -1, 34, 33, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 62, 
	-1, -1, -1, -1, 44, -1, -1, -1, 
	-1, 791, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 791, 791, -1, -1, -1, 
	-1, -1, -1, 80, 76, 45, -1, -1, 
	-1, -1, -1, 39, 955, 955, 955, 955, 
	955, 955, 955, 955, 955, 955, 955, 955, 
	955, 955, 955, 955, 955, 955, 955, 955, 
	955, 955, 955, 955, 955, 955, -1, 955, 
	955, 955, 955, 955, -1, 955, 791, 955, 
	955, 955, 955, -1, 955, -1, 955, 955, 
	955, -1, 955, 955, 955, 955, 955, 955, 
	955, 955, 955, 955, 955, 955, 955, -1, 
	955, 955, 955, 955, 955, 955, 955, 955, 
	955, 955, 955, 955, 955, 955, 955, -1, 
	-1, -1, -1, -1, -1, 955, 955, 955, 
	955, -1, -1, -1, 955, 955, 955, 955, 
	955, 955, 955, 955, 955, 955, 955, 955, 
	284, 285, 955, 955, -1, -1, -1, -1, 
	-1, 955, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	955, 955, 955, 955, -1, -1, 955, 955, 
	955, 955, 955, 955, -1, -1, -1, -1, 
	955, 955, 955, 955, 955, 955, 955, -1, 
	-1, -1, -1, 955, -1, -1, -1, -1, 
	955, 955, -1, -1, 955, 955, 955, -1, 
	955, 955, -1, -1, 955, -1, -1, -1, 
	-1, -1, -1, -1, -1, 955, 955, 955, 
	955, 955, 955, 955, -1, -1, -1, 955, 
	955, 955, -1, -1, 955, 955, -1, 955, 
	955, 955, 955, 955, -1, 955, 955, 955, 
	-1, -1, -1, 955, 955, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 955, 
	955, 955, -1, -1, 955, -1, -1, -1, 
	-1, 955, -1, 955, 955, 955, 955, -1, 
	955, 955, 955, 955, 955, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 955, 
	-1, 955, -1, -1, 955, -1, 955, 955, 
	-1, -1, -1, 955, -1, 955, -1, 955, 
	958, 958, 958, 958, 958, 958, 958, 958, 
	958, 958, 958, 958, 958, 958, 958, 958, 
	958, 958, 958, 958, 958, 958, 958, 958, 
	958, 958, -1, 958, 958, 958, 958, 958, 
	-1, 958, -1, 958, 958, 958, 958, -1, 
	958, -1, 958, 958, 958, -1, 958, 958, 
	958, 958, 958, 958, 958, 958, 958, 958, 
	958, 958, 958, -1, 958, 958, 958, 958, 
	958, 958, 958, 958, 958, 958, 958, 958, 
	958, 958, 958, -1, 287, -1, -1, -1, 
	-1, 958, 958, 958, 958, 286, -1, -1, 
	958, 958, 958, 958, 958, 958, 958, 958, 
	958, 958, 958, 958, 958, 958, 958, 958, 
	-1, -1, -1, -1, -1, 958, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 955, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 958, 958, 958, 958, 
	-1, -1, 958, 958, 958, 958, 958, 958, 
	-1, -1, -1, -1, 958, 958, 958, 958, 
	958, 958, 958, -1, -1, -1, -1, 958, 
	-1, -1, -1, -1, 958, 958, -1, -1, 
	958, 958, 958, -1, 958, 958, -1, -1, 
	958, -1, -1, -1, -1, -1, -1, -1, 
	-1, 958, 958, 958, 958, 958, 958, 958, 
	-1, -1, -1, 958, 958, 958, -1, -1, 
	958, 958, -1, 958, 958, 958, 958, 958, 
	-1, 958, 958, 958, -1, -1, -1, 958, 
	958, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 958, 958, 958, -1, -1, 
	958, -1, -1, -1, -1, 958, -1, 958, 
	958, 958, 958, -1, 958, 958, 958, 958, 
	958, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 958, -1, 958, -1, -1, 
	958, -1, 958, 958, -1, -1, -1, 958, 
	-1, 958, -1, 958, 961, 961, 961, 961, 
	961, 961, 961, 961, 961, 961, 961, 961, 
	961, 961, 961, 961, 961, 961, 961, 961, 
	961, 961, 961, 961, 961, 961, -1, 961, 
	961, 961, 961, 961, -1, 961, -1, 961, 
	961, 961, 961, -1, 961, -1, 961, 961, 
	961, -1, 961, 961, 961, 961, 961, 961, 
	961, 961, 961, 961, 961, 961, 961, -1, 
	961, 961, 961, 961, 961, 961, 961, 961, 
	961, 961, 961, 961, 961, 961, 961, -1, 
	961, -1, -1, -1, -1, 961, 961, 961, 
	961, 961, -1, -1, 961, 961, 961, 961, 
	961, 961, 961, 961, 961, 961, 961, 961, 
	961, 961, 961, 961, -1, -1, -1, -1, 
	-1, 961, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 958, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	961, 961, 961, 961, -1, -1, 961, 961, 
	961, 961, 961, 961, -1, -1, -1, -1, 
	961, 961, 961, 961, 961, 961, 961, -1, 
	-1, -1, -1, 961, -1, -1, -1, -1, 
	961, 961, -1, -1, 961, 961, 961, -1, 
	961, 961, -1, -1, 961, -1, -1, -1, 
	-1, -1, -1, -1, -1, 961, 961, 961, 
	961, 961, 961, 961, -1, -1, -1, 961, 
	961, 961, -1, -1, 961, 961, -1, 961, 
	961, 961, 961, 961, -1, 961, 961, 961, 
	-1, -1, -1, 961, 961, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 961, 
	961, 961, -1, -1, 961, -1, -1, -1, 
	-1, 961, -1, 961, 961, 961, 961, -1, 
	961, 961, 961, 961, 961, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 961, 
	-1, 961, -1, -1, 961, -1, 961, 961, 
	-1, -1, -1, 961, -1, 961, -1, 961, 
	64, 67, 68, 65, 66, 73, 74, -1, 
	69, 70, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 138, 139, 141, 140, 142, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 75, -1, -1, -1, 131, -1, 
	-1, -1, 135, 136, 137, 72, 71, 130, 
	-1, -1, -1, -1, 124, 125, 126, -1, 
	-1, -1, -1, 993, 122, -1, 144, 145, 
	146, 147, 64, 67, 68, 65, 66, 73, 
	74, 127, 69, 70, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 138, 139, 141, 
	140, 142, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 75, -1, -1, -1, 
	131, -1, -1, -1, 135, 136, 137, 72, 
	71, 130, -1, -1, -1, -1, 124, 125, 
	126, -1, -1, -1, -1, 993, 122, -1, 
	144, 145, 146, 147, -1, -1, -1, -1, 
	-1, -1, -1, 127, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 961, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 271, 129, 133, -1, -1, -1, -1, 
	132, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 143, 134, 128, 123, 
	993, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 272, 129, 133, -1, -1, 
	-1, -1, 132, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 143, 134, 
	128, 123, 993, 967, 967, 967, 967, 967, 
	967, 967, 967, 967, 967, 967, 967, 967, 
	967, 967, 967, 967, 967, 967, 967, 967, 
	967, 967, 967, 967, 967, -1, 967, 967, 
	967, 967, 967, -1, 967, -1, 967, 967, 
	967, 967, -1, 967, -1, 967, 967, 967, 
	-1, 967, 967, 967, 967, 967, 967, 967, 
	967, 967, 967, 967, 967, 967, -1, 967, 
	967, 967, 967, 967, 967, 967, 967, 967, 
	967, 967, 967, 967, 967, 967, -1, 967, 
	-1, -1, -1, -1, 967, 967, 967, 967, 
	967, -1, -1, 967, 967, 967, 967, 967, 
	967, 967, 967, 967, 967, 967, 967, 967, 
	967, 967, 967, -1, -1, -1, -1, -1, 
	967, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 967, 
	967, 967, 967, -1, -1, 967, 967, 967, 
	967, 967, 967, -1, -1, -1, -1, 967, 
	967, 967, 967, 967, 967, 967, -1, -1, 
	-1, -1, 967, -1, -1, -1, -1, 967, 
	967, -1, -1, 967, 967, 967, -1, 967, 
	967, -1, -1, 967, -1, -1, -1, -1, 
	-1, -1, -1, -1, 967, 967, 967, 967, 
	967, 967, 967, -1, -1, -1, 967, 967, 
	967, -1, -1, 967, 967, -1, 967, 967, 
	967, 967, 967, -1, 967, 967, 967, -1, 
	-1, -1, 967, 967, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 967, 967, 
	967, -1, -1, 967, -1, -1, -1, -1, 
	967, -1, 967, 967, 967, 967, -1, 967, 
	967, 967, 967, 967, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 967, -1, 
	967, -1, -1, 967, -1, 967, 967, -1, 
	-1, -1, 967, -1, 967, -1, 967, 1038, 
	1038, 1038, 1038, 1038, 1038, 1038, -1, 1038, 
	1038, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1038, 1038, 1038, 1038, 1038, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1038, -1, -1, -1, 1038, -1, -1, 
	-1, 1038, 1038, 1038, 1038, 1038, 1038, -1, 
	-1, -1, -1, 1038, 1038, 1038, -1, -1, 
	-1, -1, 1038, 1038, -1, 1038, 1038, 1038, 
	1038, -1, -1, -1, -1, -1, -1, -1, 
	1038, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1038, 1038, 
	1038, 332, 1038, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 967, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 271, 129, 133, 
	-1, -1, -1, -1, 132, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	143, 134, 128, 123, -1, -1, -1, -1, 
	-1, -1, 1038, 1038, 1038, 1038, 1038, -1, 
	1038, 1038, 1038, -1, -1, -1, -1, 1038, 
	-1, -1, -1, -1, -1, -1, -1, 272, 
	129, 133, 331, -1, -1, -1, 132, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1038, 1038, 1038, 1038, 1038, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 143, 134, 128, 123, 971, 971, 
	971, 971, 971, 971, 971, 971, 971, 971, 
	971, 971, 971, 971, 971, 971, 971, 971, 
	971, 971, 971, 971, 971, 971, 971, 971, 
	-1, 971, 971, 971, 971, 971, -1, 971, 
	-1, 971, 971, 971, 971, -1, 971, -1, 
	971, 971, 971, -1, 971, 971, 971, 971, 
	971, 971, 971, 971, 971, 971, 971, 971, 
	971, -1, 971, 971, 971, 971, 971, 971, 
	971, 971, 971, 971, 971, 971, 971, 971, 
	971, -1, 971, -1, -1, -1, -1, 971, 
	971, 971, 971, 971, -1, -1, 971, 971, 
	971, 971, 971, 971, 971, 971, 971, 971, 
	971, 971, 971, 971, 971, 971, -1, -1, 
	-1, -1, -1, 971, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 971, 971, 971, 971, -1, -1, 
	971, 971, 971, 971, 971, 971, -1, -1, 
	-1, -1, 971, 971, 971, 971, 971, 971, 
	971, -1, -1, -1, -1, 971, -1, -1, 
	-1, -1, 971, 971, -1, -1, 971, 971, 
	971, -1, 971, 971, -1, -1, 971, -1, 
	-1, -1, -1, -1, -1, -1, -1, 971, 
	971, 971, 971, 971, 971, 971, -1, -1, 
	-1, 971, 971, 971, -1, -1, 971, 971, 
	-1, 971, 971, 971, 971, 971, -1, 971, 
	971, 971, -1, -1, -1, 971, 971, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 971, 971, 971, -1, -1, 971, -1, 
	-1, -1, -1, 971, -1, 971, 971, 971, 
	971, -1, 971, 971, 971, 971, 971, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 971, -1, 971, -1, -1, 971, -1, 
	971, 971, -1, -1, -1, 971, -1, 971, 
	-1, 971, 973, 973, 973, 973, 973, 973, 
	973, 973, 973, 973, 973, 973, 973, 973, 
	973, 973, 973, 973, 973, 973, 973, 973, 
	973, 973, 973, 973, -1, 973, 973, 973, 
	973, 973, -1, 973, -1, 973, 973, 973, 
	973, -1, 973, -1, 973, 973, 973, -1, 
	973, 973, 973, 973, 973, 973, 973, 973, 
	973, 973, 973, 973, 973, -1, 973, 973, 
	973, 973, 973, 973, 973, 973, 973, 973, 
	973, 973, 973, 973, 973, -1, 973, -1, 
	-1, -1, -1, 291, 973, 973, 973, 973, 
	-1, -1, 973, 973, 973, 973, 973, 973, 
	973, 973, 973, 973, 973, 973, 973, 973, 
	973, 973, -1, -1, -1, -1, -1, 973, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 971, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 973, 973, 
	973, 973, -1, -1, 973, 973, 973, 973, 
	973, 973, -1, -1, -1, -1, 973, 973, 
	973, 973, 973, 973, 973, -1, -1, -1, 
	-1, 973, -1, -1, -1, -1, 973, 973, 
	-1, -1, 973, 973, 973, -1, 973, 973, 
	-1, -1, 973, -1, -1, -1, -1, -1, 
	-1, -1, -1, 973, 973, 973, 973, 973, 
	973, 973, -1, -1, -1, 973, 973, 973, 
	-1, -1, 973, 973, -1, 973, 973, 973, 
	973, 973, -1, 973, 973, 973, -1, -1, 
	-1, 973, 973, -1, -1, -1, 331, -1, 
	-1, -1, -1, -1, -1, 973, 973, 973, 
	-1, -1, 973, -1, -1, -1, -1, 973, 
	-1, 973, 973, 973, 973, -1, 973, 973, 
	973, 973, 973, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 973, -1, 973, 
	-1, -1, 973, -1, 973, 973, -1, -1, 
	-1, 973, -1, 973, -1, 973, 974, 974, 
	974, 974, 974, 974, 974, 974, 974, 974, 
	974, 974, 974, 974, 974, 974, 974, 974, 
	974, 974, 974, 974, 974, 974, 974, 974, 
	-1, 974, 974, 974, 974, 974, -1, 974, 
	-1, 974, 974, 974, 974, -1, 974, -1, 
	974, 974, 974, -1, 974, 974, 974, 974, 
	974, 974, 974, 974, 974, 974, 974, 974, 
	974, -1, 974, 974, 974, 974, 974, 974, 
	974, 974, 974, 974, 974, 974, 974, 974, 
	974, -1, 974, -1, -1, -1, -1, 974, 
	974, 974, 974, 974, -1, -1, 974, 974, 
	974, 974, 974, 974, 974, 974, 974, 974, 
	974, 974, 974, 974, 974, 974, -1, -1, 
	-1, -1, -1, 974, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	973, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 974, 974, 974, 974, -1, -1, 
	974, 974, 974, 974, 974, 974, -1, -1, 
	-1, -1, 974, 974, 974, 974, 974, 974, 
	974, -1, -1, -1, -1, 974, -1, -1, 
	-1, -1, 974, 974, -1, -1, 974, 974, 
	974, -1, 974, 974, -1, -1, 974, -1, 
	-1, -1, -1, -1, -1, -1, -1, 974, 
	974, 974, 974, 974, 974, 974, -1, -1, 
	-1, 974, 974, 974, -1, -1, 974, 974, 
	-1, 974, 974, 974, 974, 974, -1, 974, 
	974, 974, -1, -1, -1, 974, 974, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 974, 974, 974, -1, -1, 974, -1, 
	-1, -1, -1, 974, -1, 974, 974, 974, 
	974, -1, 974, 974, 974, 974, 974, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 974, -1, 974, -1, -1, 974, -1, 
	974, 974, -1, -1, -1, 974, -1, 974, 
	-1, 974, 975, 975, 975, 975, 975, 975, 
	975, 975, 975, 975, 975, 975, 975, 975, 
	975, 975, 975, 975, 975, 975, 975, 975, 
	975, 975, 975, 975, -1, 975, 975, 975, 
	975, 975, -1, 975, -1, 975, 975, 975, 
	975, -1, 975, -1, 975, 975, 975, -1, 
	975, 975, 975, 975, 975, 975, 975, 975, 
	975, 975, 975, 975, 975, -1, 975, 975, 
	975, 975, 975, 975, 975, 975, 975, 975, 
	975, 975, 975, 975, 975, -1, 975, -1, 
	-1, -1, -1, 975, 975, 975, 975, 975, 
	-1, -1, 975, 975, 975, 975, 975, 975, 
	975, 975, 975, 975, 975, 975, 975, 975, 
	975, 975, -1, -1, -1, -1, -1, 975, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 974, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 975, 975, 
	975, 975, -1, -1, 975, 975, 975, 975, 
	975, 975, -1, -1, -1, -1, 975, 975, 
	975, 975, 975, 975, 975, -1, -1, -1, 
	-1, 975, -1, -1, -1, -1, 975, 975, 
	-1, -1, 975, 975, 975, -1, 975, 975, 
	-1, -1, 975, -1, -1, -1, -1, -1, 
	-1, -1, -1, 975, 975, 975, 975, 975, 
	975, 975, -1, -1, -1, 975, 975, 975, 
	-1, -1, 975, 975, -1, 975, 975, 975, 
	975, 975, -1, 975, 975, 975, -1, -1, 
	-1, 975, 975, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 975, 975, 975, 
	-1, -1, 975, -1, -1, -1, -1, 975, 
	-1, 975, 975, 975, 975, -1, 975, 975, 
	975, 975, 975, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 975, -1, 975, 
	-1, -1, 975, -1, 975, 975, -1, -1, 
	-1, 975, -1, 975, -1, 975, 976, 976, 
	976, 976, 976, 976, 976, 976, 976, 976, 
	976, 976, 976, 976, 976, 976, 976, 976, 
	976, 976, 976, 976, 976, 976, 976, 976, 
	-1, 976, 976, 976, 976, 976, -1, 976, 
	-1, 976, 976, 976, 976, -1, 976, -1, 
	976, 976, 976, -1, 976, 976, 976, 976, 
	976, 976, 976, 976, 976, 976, 976, 976, 
	976, -1, 976, 976, 976, 976, 976, 976, 
	976, 976, 976, 976, 976, 976, 976, 976, 
	976, -1, 976, -1, -1, -1, -1, 976, 
	976, 976, 976, 976, -1, -1, 976, 976, 
	976, 976, 976, 976, 976, 976, 976, 976, 
	976, 976, 976, 976, 976, 976, -1, -1, 
	-1, -1, -1, 976, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	975, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 976, 976, 976, 976, -1, -1, 
	976, 976, 976, 976, 976, 976, -1, -1, 
	-1, -1, 976, 976, 976, 976, 976, 976, 
	976, -1, -1, -1, -1, 976, -1, -1, 
	-1, -1, 976, 976, -1, -1, 976, 976, 
	976, -1, 976, 976, -1, -1, 976, -1, 
	-1, -1, -1, -1, -1, -1, -1, 976, 
	976, 976, 976, 976, 976, 976, -1, -1, 
	-1, 976, 976, 976, -1, -1, 976, 976, 
	-1, 976, 976, 976, 976, 976, -1, 976, 
	976, 976, -1, -1, -1, 976, 976, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 976, 976, 976, -1, -1, 976, -1, 
	-1, -1, -1, 976, -1, 976, 976, 976, 
	976, -1, 976, 976, 976, 976, 976, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 976, -1, 976, -1, -1, 976, -1, 
	976, 976, -1, -1, -1, 976, -1, 976, 
	-1, 976, 64, 67, 68, 65, 66, 73, 
	74, -1, 69, 70, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 138, 139, 141, 
	140, 142, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 75, -1, -1, -1, 
	131, -1, -1, -1, 135, 136, 137, 72, 
	71, 130, -1, -1, -1, -1, 124, 125, 
	126, -1, -1, -1, -1, 993, 122, -1, 
	144, 145, 146, 147, -1, -1, -1, -1, 
	-1, -1, -1, 127, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 117, 118, 119, -1, 120, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 978, 
	978, 978, 978, 978, 978, 978, 978, 978, 
	978, 978, 978, 978, 978, 978, 978, 978, 
	978, 978, 978, 978, 978, 978, 978, 978, 
	978, -1, 978, 978, 978, 978, 978, -1, 
	978, -1, 978, 978, 978, 978, -1, 978, 
	-1, 978, 978, 978, 976, 978, 978, 978, 
	978, 978, 978, 978, 978, 978, 978, 978, 
	978, 978, -1, 978, 978, 978, 978, 978, 
	978, 978, 978, 978, 978, 978, 978, 978, 
	978, 978, -1, 978, -1, -1, -1, -1, 
	978, 978, 978, 978, 978, -1, -1, 978, 
	978, 978, 978, 978, 978, 978, 978, 978, 
	978, 978, 978, 978, 978, 978, 978, -1, 
	-1, -1, -1, -1, 978, -1, -1, -1, 
	-1, -1, -1, -1, -1, 267, 113, 114, 
	115, 116, -1, 121, 129, 133, -1, -1, 
	-1, -1, 132, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 143, 134, 
	128, 123, 993, -1, -1, -1, -1, -1, 
	-1, -1, -1, 978, 978, 978, 978, -1, 
	-1, 978, 978, 978, 978, 978, 978, -1, 
	-1, -1, -1, 978, 978, 978, 978, 978, 
	978, 978, -1, -1, -1, -1, 978, -1, 
	-1, -1, -1, 978, 978, -1, -1, 978, 
	978, 978, -1, 978, 978, -1, -1, 978, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	978, 978, 978, 978, 978, 978, 978, -1, 
	-1, -1, 978, 978, 978, -1, -1, 978, 
	978, -1, 978, 978, 978, 978, 978, -1, 
	978, 978, 978, -1, -1, -1, 978, 978, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 978, 978, 978, -1, -1, 978, 
	-1, -1, -1, -1, 978, -1, 978, 978, 
	978, 978, -1, 978, 978, 978, 978, 978, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 978, -1, 978, -1, -1, 978, 
	-1, 978, 978, -1, -1, -1, 978, -1, 
	978, -1, 978, 982, 982, 982, 982, 982, 
	982, 982, 982, 982, 982, 982, 982, 982, 
	982, 982, 982, 982, 982, 982, 982, 982, 
	982, 982, 982, 982, 982, -1, 982, 982, 
	982, 982, 982, -1, 982, -1, 982, 982, 
	982, 982, -1, 982, -1, 982, 982, 982, 
	-1, 982, 982, 982, 982, 982, 982, 982, 
	982, 982, 982, 982, 982, 982, -1, 982, 
	982, 982, 982, 982, 982, 982, 982, 982, 
	982, 982, 982, 982, 982, 982, -1, 982, 
	-1, -1, -1, -1, 982, 982, 982, 982, 
	982, -1, -1, 982, 982, 982, 982, 982, 
	982, 982, 982, 982, 982, 982, 982, 982, 
	982, 982, 982, -1, -1, -1, -1, -1, 
	982, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 978, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 982, 
	982, 982, 982, -1, -1, 982, 982, 982, 
	982, 982, 982, -1, -1, -1, -1, 982, 
	982, 982, 982, 982, 982, 982, -1, -1, 
	-1, -1, 982, -1, -1, -1, -1, 982, 
	982, -1, -1, 982, 982, 982, -1, 982, 
	982, -1, -1, 982, -1, -1, -1, -1, 
	-1, -1, -1, -1, 982, 982, 982, 982, 
	982, 982, 982, -1, -1, -1, 982, 982, 
	982, -1, -1, 982, 982, -1, 982, 982, 
	982, 982, 982, -1, 982, 982, 982, -1, 
	-1, -1, 982, 982, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 982, 982, 
	982, -1, -1, 982, -1, -1, -1, -1, 
	982, -1, 982, 982, 982, 982, -1, 982, 
	982, 982, 982, 982, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 982, -1, 
	982, -1, -1, 982, -1, 982, 982, -1, 
	-1, -1, 982, -1, 982, -1, 982, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 55, 
	56, 64, 67, 68, 65, 66, 73, 74, 
	-1, 69, 70, -1, -1, 35, 36, 40, 
	38, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 41, 42, 43, 
	-1, -1, -1, 75, -1, -1, -1, -1, 
	37, -1, -1, -1, -1, -1, 72, 71, 
	-1, 267, 113, 114, 115, 116, -1, 121, 
	129, 133, -1, -1, 59, -1, 132, 82, 
	84, 86, 88, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 276, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 143, 134, 128, 123, -1, 274, 
	275, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 982, 1079, 1079, 1079, 1079, 1079, 1079, 
	1079, 1079, 1079, 1079, 1079, 1079, 1079, 1079, 
	1079, 1079, 1079, 1079, 1079, 1079, 1079, 1079, 
	1079, 1079, 1079, 1079, -1, 1079, 1079, 1079, 
	1079, 1079, -1, 1079, -1, 1079, 1079, 1079, 
	1079, -1, 1079, -1, 1079, 1079, 1079, -1, 
	1079, 1079, 1079, 1079, 1079, 1079, 1079, 1079, 
	1079, 1079, 1079, 1079, 1079, -1, 1079, 1079, 
	1079, 1079, 1079, 1079, 1079, 1079, 1079, 1079, 
	1079, 1079, 1079, 1079, 1079, -1, 1079, -1, 
	-1, -1, -1, 1079, 1079, 1079, 1079, 1079, 
	-1, -1, 1079, 1079, 1079, 1079, 1079, 1079, 
	1079, 1079, 1079, 1079, 1079, 1079, 1079, 1079, 
	1079, 1079, -1, -1, -1, 277, -1, 1079, 
	-1, -1, -1, -1, 292, -1, -1, -1, 
	-1, 34, 33, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 62, -1, -1, -1, 
	-1, 44, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	80, 76, 45, -1, -1, -1, -1, -1, 
	39, 993, -1, -1, -1, -1, 1079, 1079, 
	1079, 1079, -1, -1, 1079, 1079, 1079, 1079, 
	1079, 1079, -1, -1, -1, -1, 1079, 1079, 
	1079, 1079, 1079, 1079, 1079, -1, -1, -1, 
	-1, 1079, -1, -1, -1, -1, 1079, 1079, 
	-1, -1, 1079, 1079, 1079, -1, 1079, 1079, 
	-1, -1, 1079, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1079, 1079, 1079, 1079, 1079, 
	1079, 1079, -1, -1, -1, 1079, 1079, 1079, 
	-1, -1, 1079, 1079, -1, 1079, 1079, 1079, 
	1079, 1079, -1, 1079, 1079, 1079, -1, -1, 
	-1, 1079, 1079, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1079, 1079, 1079, 
	-1, -1, 1079, -1, -1, -1, -1, 1079, 
	-1, 1079, 1079, 1079, 1079, -1, 1079, 1079, 
	1079, 1079, 1079, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1079, -1, 1079, 
	-1, -1, 1079, -1, 1079, 1079, -1, -1, 
	-1, 1079, -1, 1079, -1, 1079, 984, 984, 
	984, 984, 984, 984, 984, 984, 984, 984, 
	984, 984, 984, 984, 984, 984, 984, 984, 
	984, 984, 984, 984, 984, 984, 984, 984, 
	984, 984, 984, 984, 984, 984, -1, 984, 
	-1, 984, 984, 984, 984, 984, 984, -1, 
	984, 984, 984, -1, -1, 984, 984, 984, 
	984, 984, 984, 984, 984, -1, 984, 984, 
	984, 984, -1, -1, -1, 984, 984, 984, 
	984, 984, -1, -1, 984, 984, 984, 984, 
	-1, -1, -1, 984, -1, -1, -1, 984, 
	984, -1, 984, -1, -1, 984, -1, -1, 
	984, -1, 984, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 984, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 984, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1079, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 984, 984, 984, 984, -1, -1, 
	984, 984, 984, 984, 984, 984, -1, -1, 
	-1, -1, 984, 984, 984, 984, 984, 984, 
	984, -1, -1, 984, -1, 984, -1, -1, 
	-1, -1, 984, 984, -1, 984, 984, 984, 
	984, -1, 984, 984, -1, -1, 984, -1, 
	-1, -1, -1, -1, 984, -1, 984, 984, 
	984, 984, 984, 984, 984, 984, -1, -1, 
	-1, -1, 984, 984, -1, 984, 984, 984, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	984, 984, -1, -1, 984, -1, 984, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	984, 984, 984, -1, -1, 984, 984, 984, 
	-1, -1, -1, -1, -1, 984, 984, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 984, -1, 984, -1, -1, 984, 984, 
	984, 985, 985, 985, 985, 985, 985, 985, 
	985, 985, 985, 985, 985, 985, 985, 985, 
	985, 985, 985, 985, 985, 985, 985, 985, 
	985, 985, 985, 985, 985, 985, 985, 985, 
	985, -1, 985, -1, 985, 985, 985, 985, 
	985, 985, -1, 985, 985, 985, -1, -1, 
	985, 985, 985, 985, 985, 985, 985, 985, 
	-1, 985, 985, 985, 985, -1, -1, -1, 
	985, 985, 985, 985, 985, -1, -1, 985, 
	985, 985, 985, -1, -1, -1, 985, -1, 
	-1, -1, 985, 985, -1, 985, -1, -1, 
	985, -1, -1, 985, -1, 985, -1, -1, 
	-1, 277, -1, -1, -1, -1, -1, -1, 
	292, -1, -1, -1, -1, 34, 33, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	62, -1, -1, -1, -1, 44, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 985, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 985, -1, -1, 80, 76, 45, -1, 
	-1, -1, -1, -1, 39, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 984, 985, 985, 985, 
	985, -1, -1, 985, 985, 985, 985, 985, 
	985, -1, -1, -1, -1, 985, 985, 985, 
	985, 985, 985, 985, -1, -1, 985, -1, 
	985, -1, -1, -1, -1, 985, 985, -1, 
	985, 985, 985, 985, -1, 985, 985, -1, 
	-1, 985, -1, -1, -1, -1, -1, 985, 
	-1, 985, 985, 985, 985, 985, 985, 985, 
	985, -1, -1, -1, -1, 985, 985, -1, 
	985, 985, 985, -1, -1, -1, -1, -1, 
	-1, -1, -1, 985, 985, -1, -1, 985, 
	-1, 985, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 985, 985, 985, -1, -1, 
	985, 985, 985, -1, -1, -1, -1, -1, 
	985, 985, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 985, -1, 985, -1, 
	-1, 985, 985, 985, 986, 986, 986, 986, 
	986, 986, 986, 986, 986, 986, 986, 986, 
	986, 986, 986, 986, 986, 986, 986, 986, 
	986, 986, 986, 986, 986, 986, 986, 986, 
	986, 986, 986, 986, -1, 986, -1, 986, 
	986, 986, 986, 986, 986, -1, 986, 986, 
	986, -1, -1, 986, 986, 986, 986, 986, 
	986, 986, 986, -1, 986, 986, 986, 986, 
	-1, -1, -1, 986, 986, 986, 986, 986, 
	-1, -1, 986, 986, 986, 986, -1, -1, 
	-1, 986, -1, -1, -1, 986, 986, -1, 
	986, -1, -1, 986, -1, -1, 986, -1, 
	986, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 986, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 986, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 985, 
	986, 986, 986, 986, -1, -1, 986, 986, 
	986, 986, 986, 986, -1, -1, -1, -1, 
	986, 986, 986, 986, 986, 986, 986, -1, 
	-1, 986, -1, 986, -1, -1, -1, -1, 
	986, 986, -1, 986, 986, 986, 986, -1, 
	986, 986, -1, -1, 986, -1, -1, -1, 
	-1, -1, 986, -1, 986, 986, 986, 986, 
	986, 986, 986, 986, -1, -1, -1, -1, 
	986, 986, -1, 986, 986, 986, -1, -1, 
	-1, -1, -1, -1, -1, -1, 986, 986, 
	-1, -1, 986, -1, 986, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 986, 986, 
	986, -1, -1, 986, 986, 986, -1, -1, 
	-1, -1, -1, 986, 986, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 986, 
	-1, 986, -1, -1, 986, 986, 986, 1078, 
	1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 
	1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 
	1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 
	1078, -1, 1078, 1078, 1078, 1078, 1078, -1, 
	1078, -1, 1078, 1078, 1078, 1078, -1, 1078, 
	-1, 1078, 1078, 1078, -1, 1078, 1078, 1078, 
	1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 
	1078, 1078, -1, 1078, 1078, 1078, 1078, 1078, 
	1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 
	1078, 1078, -1, 1078, -1, -1, -1, -1, 
	1078, 1078, 1078, 1078, 1078, -1, -1, 1078, 
	1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 
	1078, 1078, 1078, 1078, 1078, 1078, 1078, -1, 
	-1, -1, -1, -1, 1078, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 986, 1078, 1078, 1078, 1078, -1, 
	-1, 1078, 1078, 1078, 1078, 1078, 1078, -1, 
	-1, -1, -1, 1078, 1078, 1078, 1078, 1078, 
	1078, 1078, -1, -1, -1, -1, 1078, -1, 
	-1, -1, -1, 1078, 1078, -1, -1, 1078, 
	1078, 1078, -1, 1078, 1078, -1, -1, 1078, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1078, 1078, 1078, 1078, 1078, 1078, 1078, -1, 
	-1, -1, 1078, 1078, 1078, -1, -1, 1078, 
	1078, -1, 1078, 1078, 1078, 1078, 1078, -1, 
	1078, 1078, 1078, -1, -1, -1, 1078, 1078, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1078, 1078, 1078, -1, -1, 1078, 
	-1, -1, -1, -1, 1078, -1, 1078, 1078, 
	1078, 1078, -1, 1078, 1078, 1078, 1078, 1078, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1078, -1, 1078, -1, -1, 1078, 
	-1, 1078, 1078, -1, -1, -1, 1078, -1, 
	1078, -1, 1078, 1040, 1040, 1040, 1040, 1040, 
	1040, 1040, -1, 1040, 1040, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1040, 1040, 
	1040, 1040, 1040, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1040, -1, -1, 
	-1, 1040, -1, -1, -1, 1040, 1040, 1040, 
	1040, 1040, 1040, -1, -1, -1, -1, 1040, 
	1040, 1040, -1, -1, -1, -1, 1040, 1040, 
	-1, 1154, 1154, 1154, 1040, 1153, -1, -1, 
	-1, -1, -1, -1, 1040, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1040, 1040, 1040, 1040, 1040, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 769, 
	769, 769, 769, 769, 769, 769, 769, 769, 
	769, 769, 769, 769, 769, 769, 769, 769, 
	769, 769, 769, 769, 769, 769, 769, 769, 
	769, -1, 769, 769, 769, 769, 769, -1, 
	769, -1, 769, 769, 769, 769, -1, 769, 
	-1, 769, 769, 769, -1, 1078, 769, 769, 
	769, 769, 769, 769, 769, 769, -1, 769, 
	769, 769, -1, -1, -1, -1, 769, 769, 
	769, 769, 769, -1, -1, 769, 769, 769, 
	769, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 769, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1040, 1040, 
	1040, 1040, 1040, -1, 1040, 1040, 1040, -1, 
	-1, -1, -1, 1040, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1040, 265, 
	266, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 264, -1, 1040, 
	1040, 1040, 1040, 1040, -1, -1, -1, -1, 
	-1, -1, -1, 769, 769, 769, 769, -1, 
	-1, 769, 769, -1, 769, 769, 769, -1, 
	-1, -1, -1, 769, 769, 769, 263, 769, 
	769, 769, -1, -1, -1, -1, 769, -1, 
	-1, -1, -1, 769, -1, -1, -1, 769, 
	769, 769, -1, 769, 769, -1, -1, 769, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	769, 769, 769, 769, 769, 769, 769, -1, 
	-1, -1, -1, 769, 769, -1, -1, 769, 
	769, -1, -1, -1, -1, -1, -1, -1, 
	-1, 769, 769, -1, -1, -1, -1, 769, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 769, 769, 
	769, -1, -1, -1, -1, -1, 769, 769, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 769, -1, -1, -1, -1, -1, 
	-1, 769, 941, 941, 941, 941, 941, 941, 
	941, 941, 941, 941, 941, 941, 941, 941, 
	941, -1, 941, 941, 941, 941, 941, 941, 
	941, 941, -1, -1, -1, 941, 941, 941, 
	941, 941, -1, 941, -1, 941, 941, 941, 
	941, -1, 941, -1, 941, 941, 941, -1, 
	-1, 941, -1, -1, 941, 941, 941, 941, 
	941, -1, 941, 941, 941, -1, -1, -1, 
	-1, 941, 941, 941, 941, 941, -1, -1, 
	941, 941, 941, 941, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 186, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 769, 941, 941, 
	941, 941, -1, -1, 941, 941, 941, 941, 
	941, 941, -1, -1, -1, -1, 941, 941, 
	941, 941, 941, 941, 941, -1, -1, -1, 
	-1, 941, -1, -1, -1, -1, 941, -1, 
	-1, -1, 941, 941, 941, -1, 941, 941, 
	-1, -1, 941, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 941, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 294, 941, 941, -1, -1, -1, -1, 
	-1, -1, -1, -1, 941, 941, -1, -1, 
	-1, -1, 941, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 941, 941, 941, -1, -1, -1, -1, 
	-1, 941, 941, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 941, -1, 941, 
	-1, -1, -1, -1, -1, -1, -1, 770, 
	770, 770, 770, 770, 770, 770, 770, 770, 
	770, 770, 770, 770, 770, 770, 770, 770, 
	770, 770, 770, 770, 770, 770, 770, 770, 
	770, -1, 770, 770, 770, 770, 770, -1, 
	770, -1, 770, 770, 770, 770, -1, 770, 
	-1, 770, 770, 770, -1, -1, 770, 770, 
	770, 770, 770, 770, 770, 770, -1, 770, 
	770, 770, -1, -1, -1, -1, 770, 770, 
	770, 770, 770, -1, -1, 770, 770, 770, 
	770, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 770, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 274, 275, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 265, 266, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 264, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	941, -1, -1, 770, 770, 770, 770, -1, 
	-1, 770, 770, -1, 770, 770, 770, -1, 
	-1, -1, 263, 770, 770, 770, -1, 770, 
	770, 770, -1, -1, -1, -1, 770, -1, 
	-1, -1, -1, 770, -1, -1, -1, 770, 
	770, 770, -1, 770, 770, -1, -1, 770, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	770, 770, 770, 770, 770, 770, 770, -1, 
	-1, -1, -1, 770, 770, -1, -1, 770, 
	770, -1, -1, -1, -1, -1, -1, -1, 
	-1, 770, 770, -1, -1, -1, -1, 770, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 770, 770, 
	770, -1, -1, -1, -1, -1, 770, 770, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 770, -1, -1, -1, -1, -1, 
	-1, 770, -1, -1, 55, 56, 64, 67, 
	68, 65, 66, 73, 74, 1135, 69, 70, 
	-1, -1, 35, 36, 40, 38, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 41, 42, 43, -1, -1, -1, 
	75, -1, -1, -1, -1, 37, -1, -1, 
	-1, -1, -1, 72, 71, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 59, -1, -1, 82, 84, 86, 88, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1135, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 941, 941, 
	941, 941, 941, 941, 941, 941, 941, 941, 
	941, 941, 941, 941, 941, -1, 941, 941, 
	941, 941, 941, 941, 941, 941, -1, -1, 
	-1, 941, 941, 941, 941, 941, -1, 941, 
	-1, 941, 941, 941, 941, -1, 941, -1, 
	941, 941, 941, -1, -1, 941, -1, -1, 
	941, 941, 941, 941, 941, 770, 941, 941, 
	941, -1, -1, -1, -1, 941, 941, 941, 
	941, 941, -1, -1, 941, 941, 941, 941, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 186, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 299, -1, -1, -1, -1, -1, 
	-1, -1, 1135, 1135, 297, 294, 34, 33, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 62, -1, -1, -1, -1, 44, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 80, 76, 45, 
	-1, -1, -1, -1, -1, 39, 993, -1, 
	-1, -1, 941, 941, 941, 941, -1, -1, 
	941, 941, -1, 941, 941, 941, -1, -1, 
	298, -1, 941, 941, 941, -1, 941, 941, 
	941, -1, -1, -1, -1, 941, -1, -1, 
	-1, -1, 941, 941, -1, -1, 941, 941, 
	941, -1, 941, 941, -1, -1, 941, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 941, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 300, 941, 941, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	941, 941, -1, -1, -1, -1, 941, -1, 
	-1, -1, -1, -1, -1, 64, 67, 68, 
	65, 66, 73, 74, -1, 69, 70, -1, 
	-1, -1, -1, -1, -1, 941, 941, 941, 
	138, 139, 141, 140, 142, 941, 941, -1, 
	-1, -1, -1, -1, -1, -1, -1, 75, 
	-1, 941, -1, 131, -1, -1, 941, 135, 
	136, 137, 72, 71, 130, -1, -1, -1, 
	-1, 124, 125, 126, -1, -1, -1, -1, 
	993, 122, -1, 144, 145, 146, 147, -1, 
	-1, -1, -1, -1, -1, -1, 127, 930, 
	64, 67, 68, 65, 66, 73, 74, -1, 
	69, 70, -1, -1, 117, 118, 119, -1, 
	120, -1, -1, 138, 139, 141, 140, 142, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 75, -1, -1, -1, 131, -1, 
	-1, -1, 135, 136, 137, 72, 71, 130, 
	-1, -1, -1, -1, 124, 125, 126, -1, 
	-1, -1, -1, 993, 122, -1, 144, 145, 
	146, 147, -1, -1, -1, -1, -1, -1, 
	-1, 127, 930, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 117, 
	118, 119, -1, 120, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 941, -1, -1, -1, 
	-1, -1, -1, -1, -1, 205, 311, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	206, 113, 114, 115, 116, -1, 121, 129, 
	133, -1, -1, -1, -1, 132, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 143, 134, 128, 123, 993, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	205, 312, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 206, 113, 114, 115, 116, 
	-1, 121, 129, 133, -1, -1, -1, -1, 
	132, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 143, 134, 128, 123, 
	993, -1, -1, -1, -1, -1, -1, -1, 
	-1, 860, 860, 860, 860, 860, 860, 860, 
	860, 860, 860, 860, 860, 860, 860, 860, 
	-1, 860, 860, 860, 860, 860, 860, 860, 
	860, -1, -1, -1, 860, 860, 860, 860, 
	860, -1, 860, -1, 860, 860, 860, 860, 
	-1, 860, -1, 860, 860, 860, -1, -1, 
	860, -1, -1, 860, 860, 860, 860, 860, 
	-1, 860, 860, 860, 163, -1, -1, -1, 
	860, 860, 860, 860, 860, -1, 865, 860, 
	860, 860, 860, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 792, 792, 792, 
	792, 792, 792, -1, -1, -1, 299, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	297, -1, 34, 33, -1, -1, -1, -1, 
	792, 792, 792, 792, 792, 62, 792, -1, 
	792, -1, 44, -1, -1, 792, -1, -1, 
	792, -1, -1, -1, -1, -1, -1, 792, 
	792, 792, -1, -1, -1, 792, 792, 792, 
	-1, 80, 76, 45, 792, 792, 792, -1, 
	792, 39, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 298, 860, 860, 860, 
	860, -1, -1, 860, 860, 860, 860, 860, 
	860, -1, -1, -1, -1, 860, 860, 860, 
	860, 860, 860, 860, -1, 314, 162, -1, 
	860, -1, -1, -1, -1, 860, 860, -1, 
	-1, 860, 860, 860, -1, 860, 860, -1, 
	-1, 860, -1, -1, -1, -1, -1, -1, 
	-1, 300, -1, -1, -1, 860, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 860, 860, -1, -1, -1, -1, -1, 
	-1, -1, -1, 860, 860, -1, -1, -1, 
	-1, 860, -1, 792, 792, -1, -1, 792, 
	792, 792, 792, -1, 792, -1, -1, -1, 
	-1, 792, 792, 792, 792, 792, 792, 792, 
	860, 860, 860, -1, -1, -1, -1, -1, 
	860, 860, -1, -1, -1, 792, 792, 792, 
	-1, 792, 792, -1, 860, 792, 860, -1, 
	-1, 860, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 792, -1, 810, 
	810, 810, 810, 810, 810, -1, -1, 792, 
	792, -1, -1, -1, -1, -1, -1, -1, 
	-1, 810, -1, -1, -1, -1, -1, -1, 
	-1, -1, 810, 810, 810, 810, 810, -1, 
	810, -1, 810, -1, -1, -1, -1, 810, 
	-1, -1, 810, 810, -1, -1, -1, -1, 
	-1, 810, 810, 810, -1, -1, -1, 810, 
	810, 810, 792, -1, -1, -1, 810, 810, 
	810, 810, 810, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 205, 311, -1, -1, -1, -1, 860, 
	-1, -1, -1, -1, 206, 113, 114, 115, 
	116, -1, 121, 129, 133, -1, -1, -1, 
	-1, 132, -1, -1, 810, 810, 810, -1, 
	-1, 810, 810, -1, -1, 810, 810, -1, 
	-1, -1, -1, 810, 810, 810, -1, 810, 
	810, 810, -1, -1, -1, 143, 134, 128, 
	123, -1, -1, 810, 810, -1, -1, 810, 
	810, 810, -1, 810, 810, -1, -1, 810, 
	-1, -1, -1, -1, 205, 312, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 206, 
	113, 114, 115, 116, -1, 121, 129, 133, 
	-1, -1, -1, -1, 132, -1, -1, -1, 
	-1, 810, 810, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	143, 134, 128, 123, -1, -1, -1, 862, 
	862, 862, 862, 862, 862, 862, 862, 862, 
	862, 862, 862, 862, 862, 862, -1, 862, 
	862, 862, 862, 862, 862, 862, 862, 810, 
	-1, -1, 862, 862, 862, 862, 862, -1, 
	862, -1, 862, 862, 862, 862, -1, 862, 
	-1, 862, 862, 862, -1, -1, 862, -1, 
	-1, 862, 862, 862, 862, 862, -1, 862, 
	862, 862, 862, -1, -1, -1, 862, 862, 
	862, 862, 862, -1, 862, 862, 862, 862, 
	862, -1, 1040, 1040, 1040, 1040, 1040, 1040, 
	1040, -1, 1040, 1040, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1040, 1040, 1040, 
	1040, 1040, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1040, -1, -1, -1, 
	1040, -1, -1, -1, 1040, 1040, 1040, 1040, 
	1040, 1040, -1, -1, -1, -1, 1040, 1040, 
	1040, -1, -1, -1, -1, 1040, 1040, -1, 
	1154, 1154, 1154, 1040, -1, -1, -1, -1, 
	-1, -1, -1, 1040, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1040, 1040, 1040, 1040, 1040, -1, -1, 
	-1, -1, -1, 862, 862, 862, 862, 1149, 
	-1, 862, 862, 862, 862, 862, 862, -1, 
	-1, -1, -1, 862, 862, 862, 862, 862, 
	862, 862, -1, 862, 862, -1, 862, -1, 
	-1, 314, 162, 862, 862, -1, -1, 862, 
	862, 862, -1, 862, 862, -1, -1, 862, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 862, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 862, 
	862, -1, -1, -1, -1, -1, -1, -1, 
	-1, 862, 862, -1, -1, -1, -1, 862, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 862, 862, 
	862, -1, -1, -1, -1, -1, 862, 862, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 862, -1, 862, -1, -1, 862, 
	-1, -1, -1, -1, -1, 1040, 1040, 1040, 
	1040, 1040, -1, 1040, 1040, 1040, -1, -1, 
	-1, -1, 1040, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1040, 176, 177, 
	-1, -1, -1, -1, -1, -1, -1, 175, 
	-1, -1, -1, -1, -1, -1, 1040, 1040, 
	1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 
	1040, 1040, -1, 1040, 1040, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1040, 1040, 
	1040, 1040, 1040, 318, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1040, -1, -1, 
	-1, 1040, -1, -1, -1, 1040, 1040, 1040, 
	1040, 1040, 1040, -1, -1, -1, -1, 1040, 
	1040, 1040, -1, -1, -1, -1, 1040, 1040, 
	-1, 1154, 1154, 1154, 1040, 1149, -1, -1, 
	-1, -1, -1, -1, 1040, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1040, 1040, 1040, 1040, 1040, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1149, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 862, -1, -1, 
	-1, -1, -1, 832, 832, 832, 832, 832, 
	832, 832, 832, 832, 832, 832, 832, 832, 
	832, 832, -1, 832, 832, 832, 832, 832, 
	832, 832, 832, -1, -1, -1, 832, 832, 
	832, 832, 832, -1, 832, -1, 832, 832, 
	832, 832, -1, 832, -1, 832, 832, 832, 
	-1, -1, 832, -1, -1, 832, 832, 832, 
	832, 832, -1, 832, 832, 832, -1, -1, 
	-1, -1, 832, 832, 832, 832, 832, -1, 
	-1, 832, 832, 832, 832, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 335, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1040, 1040, 
	1040, 1040, 1040, -1, 1040, 1040, 1040, -1, 
	-1, -1, -1, 1040, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1040, 176, 
	177, -1, -1, -1, -1, -1, -1, -1, 
	175, -1, -1, -1, -1, -1, -1, 1040, 
	1040, 1040, 1040, 1040, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 832, 
	832, 832, 832, -1, 333, 832, 832, 832, 
	832, 832, 832, -1, -1, -1, -1, 832, 
	832, 832, 832, 832, 832, 832, -1, -1, 
	-1, -1, 832, -1, -1, -1, -1, 832, 
	832, -1, -1, 832, 832, 832, -1, 832, 
	832, -1, -1, 832, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 832, 
	-1, -1, -1, -1, 27, 28, 1125, 25, 
	23, 26, -1, 832, 832, -1, -1, -1, 
	-1, -1, -1, -1, -1, 832, 832, -1, 
	-1, -1, -1, 832, -1, -1, -1, 853, 
	853, 853, 853, 853, -1, 32, -1, 47, 
	-1, -1, -1, -1, 50, -1, -1, 48, 
	-1, -1, 832, 832, 832, -1, 853, 853, 
	853, -1, 832, 832, 24, 54, 53, -1, 
	-1, -1, -1, 77, 78, 79, 832, 58, 
	832, -1, -1, 832, -1, -1, 837, 837, 
	837, 837, 837, 837, 837, 837, 837, 837, 
	837, 837, 837, 837, 837, -1, 837, 837, 
	837, 837, 837, 837, 837, 837, -1, -1, 
	-1, 837, 837, 837, 837, 837, -1, 837, 
	-1, 837, 837, 837, 837, -1, 837, -1, 
	837, 837, 837, -1, -1, 837, -1, -1, 
	837, 837, 837, 837, 837, -1, 837, 837, 
	837, -1, -1, -1, -1, 837, 837, 837, 
	837, 837, -1, -1, 837, 837, 837, 837, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	837, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 355, 49, -1, -1, 354, 356, 
	340, 353, -1, 352, -1, -1, -1, -1, 
	31, 350, 351, 341, 29, 349, 342, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 347, 348, 343, -1, 
	344, 345, -1, -1, 346, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 176, 177, -1, -1, -1, -1, 
	-1, -1, -1, 175, 357, -1, -1, -1, 
	-1, 832, 837, 837, 837, 837, 853, 853, 
	837, 837, 837, 837, 837, 837, -1, -1, 
	-1, -1, 837, 837, 837, 837, 837, 837, 
	837, -1, -1, -1, -1, 837, -1, 318, 
	-1, -1, 837, 837, -1, -1, 837, 837, 
	837, -1, 837, 837, -1, -1, 837, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 339, 837, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 837, 837, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	837, 837, -1, -1, -1, -1, 837, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 837, 837, 837, 
	-1, -1, -1, -1, -1, 837, 837, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 837, -1, 837, -1, -1, 837, -1, 
	-1, -1, -1, -1, -1, 768, 768, 768, 
	768, 768, 768, 768, 768, 768, 768, 768, 
	768, 768, 768, 768, 768, 768, 768, 768, 
	768, 768, 768, 768, 768, 768, 768, -1, 
	768, 768, 768, 768, 768, -1, 768, -1, 
	768, 768, 768, 768, -1, 768, -1, 768, 
	768, 768, -1, -1, 768, 768, 768, 768, 
	768, 768, 768, 768, -1, 768, 768, 768, 
	-1, -1, -1, -1, 768, 768, 768, 768, 
	768, -1, -1, 768, 768, 768, 768, -1, 
	-1, -1, 64, 67, 68, 65, 66, 73, 
	74, 768, 69, 70, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 138, 139, 141, 
	140, 142, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 75, -1, -1, -1, 
	131, -1, -1, -1, 135, 136, 137, 72, 
	71, 130, -1, 176, 177, -1, 124, 125, 
	126, -1, -1, -1, 175, 993, 122, -1, 
	144, 145, 146, 147, -1, -1, -1, -1, 
	-1, -1, -1, 127, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 117, 118, 119, 837, 120, -1, -1, 
	333, 768, 768, 768, 768, -1, -1, 768, 
	768, -1, 768, 768, 768, -1, -1, -1, 
	-1, 768, 768, 768, -1, 768, 768, 768, 
	-1, -1, -1, -1, 768, -1, -1, -1, 
	-1, 768, -1, -1, -1, 768, 768, 768, 
	-1, 768, 768, -1, -1, 768, -1, -1, 
	-1, -1, -1, -1, -1, -1, 768, 768, 
	768, 768, 768, 768, 768, -1, -1, -1, 
	-1, 768, 768, -1, -1, 768, 768, -1, 
	-1, -1, -1, -1, -1, -1, -1, 768, 
	768, -1, -1, -1, -1, 768, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 768, 768, 768, -1, 
	-1, -1, -1, -1, 768, 768, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	768, -1, -1, -1, -1, -1, -1, 768, 
	-1, -1, -1, -1, -1, 358, 113, 114, 
	115, 116, -1, 121, 129, 133, -1, -1, 
	-1, -1, 132, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 143, 134, 
	128, 123, 993, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 355, 49, 
	-1, -1, 354, 356, 340, 353, -1, 352, 
	-1, -1, -1, -1, 31, 350, 351, 341, 
	29, 349, 342, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	347, 348, 343, -1, 344, 345, -1, -1, 
	346, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	357, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 768, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1065, 1065, 1065, 1065, 1065, 
	1065, 1065, 1065, 1065, 1065, 1065, 1065, 1065, 
	1065, 1065, 1065, 1065, 1065, 1065, 1065, 1065, 
	1065, 1065, 1065, 1065, 1065, -1, 1065, 1065, 
	1065, 1065, 1065, -1, 1065, 339, 1065, 1065, 
	1065, 1065, -1, 1065, -1, 1065, 1065, 1065, 
	1065, 1065, 1065, 1065, 1065, 1065, 1065, 1065, 
	1065, 1065, 1065, 1065, 1065, 1065, -1, 1065, 
	1065, 1065, 1065, 1065, 1065, 1065, 1065, 1065, 
	1065, 1065, 1065, 1065, 1065, 1065, -1, 1065, 
	-1, -1, 1065, -1, 1065, 1065, 1065, 1065, 
	1065, -1, -1, 1065, 1065, 1065, 1065, 1065, 
	1065, 1065, 1065, 1065, 1065, 1065, 1065, 1065, 
	1065, 1065, 1065, -1, -1, -1, -1, -1, 
	1065, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1065, 
	1065, 1065, 1065, -1, -1, 1065, 1065, 1065, 
	1065, 1065, 1065, -1, -1, -1, -1, 1065, 
	1065, 1065, 1065, 1065, 1065, 1065, -1, -1, 
	-1, -1, 1065, -1, -1, -1, -1, 1065, 
	1065, -1, -1, 1065, 1065, 1065, -1, 1065, 
	1065, -1, -1, 1065, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1065, 1065, 1065, 1065, 
	1065, 1065, 1065, -1, -1, -1, 1065, 1065, 
	1065, -1, -1, 1065, 1065, -1, 1065, 1065, 
	1065, 1065, 1065, 1065, 1065, 1065, 1065, -1, 
	-1, -1, 1065, 1065, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1065, 1065, 
	1065, -1, -1, 1065, -1, -1, -1, -1, 
	1065, -1, 1065, 1065, 1065, 1065, -1, 1065, 
	1065, 1065, 1065, 1065, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1065, -1, 
	1065, -1, -1, 1065, -1, 1065, 1065, -1, 
	-1, -1, 1065, -1, 1065, -1, 1065, 921, 
	921, 921, 921, 921, 921, 921, 921, 921, 
	921, 921, 921, 921, 921, 921, 921, 921, 
	921, 921, 921, 921, 921, 921, 921, 921, 
	921, -1, 921, 921, 921, 921, 921, -1, 
	921, -1, 921, 921, 921, 921, -1, 921, 
	-1, 921, 921, 921, -1, -1, 921, 921, 
	921, 921, 921, 921, 921, 921, -1, 921, 
	921, 921, -1, -1, -1, -1, 921, 921, 
	921, 921, 921, -1, -1, 921, 921, 921, 
	921, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 921, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 358, 113, 114, 115, 116, -1, 121, 
	129, 133, -1, -1, -1, -1, 132, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 143, 134, 128, 123, -1, -1, 
	-1, 1065, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 921, 921, 921, 921, -1, 
	-1, 921, 921, -1, 921, 921, 921, -1, 
	-1, -1, -1, 921, 921, 921, -1, 921, 
	921, 921, -1, -1, -1, -1, 921, -1, 
	-1, -1, -1, 921, -1, -1, -1, 921, 
	921, 921, -1, 921, 921, -1, -1, 921, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	921, 921, 921, 921, 921, 921, 921, -1, 
	-1, -1, -1, 921, 921, -1, -1, 921, 
	921, -1, -1, -1, -1, -1, -1, -1, 
	-1, 921, 921, -1, -1, -1, -1, 921, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 921, 921, 
	921, -1, -1, -1, -1, -1, 921, 921, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 921, -1, -1, -1, -1, -1, 
	-1, 921, 968, 968, 968, 968, 968, 968, 
	968, 968, 968, 968, 968, 968, 968, 968, 
	968, 968, 968, 968, 968, 968, 968, 968, 
	968, 968, 968, 968, -1, 968, 968, 968, 
	968, 968, -1, 968, -1, 968, 968, 968, 
	968, -1, 968, -1, 968, 968, 968, -1, 
	968, 968, 968, 968, 968, 968, 968, 968, 
	968, 968, 968, 968, 968, -1, 968, 968, 
	968, 968, 968, 968, 968, 968, 968, 968, 
	968, 968, 968, 968, 968, -1, 968, -1, 
	-1, -1, -1, 968, 968, 968, 968, 968, 
	-1, -1, 968, 968, 968, 968, 968, 968, 
	968, 968, 968, 968, 968, 968, 968, 968, 
	968, 968, -1, -1, -1, -1, -1, 968, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 921, 968, 968, 
	968, 968, -1, -1, 968, 968, 968, 968, 
	968, 968, -1, -1, -1, -1, 968, 968, 
	968, 968, 968, 968, 968, -1, -1, -1, 
	-1, 968, -1, -1, -1, -1, 968, 968, 
	-1, -1, 968, 968, 968, -1, 968, 968, 
	-1, -1, 968, -1, -1, -1, -1, -1, 
	-1, -1, -1, 968, 968, 968, 968, 968, 
	968, 968, -1, -1, -1, 968, 968, 968, 
	-1, -1, 968, 968, -1, 968, 968, 968, 
	968, 968, -1, 968, 968, 968, -1, -1, 
	-1, 968, 968, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 968, 968, 968, 
	-1, -1, 968, -1, -1, -1, -1, 968, 
	-1, 968, 968, 968, 968, -1, 968, 968, 
	968, 968, 968, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 968, -1, 968, 
	-1, -1, 968, -1, 968, 968, -1, -1, 
	-1, 968, -1, 968, -1, 968, 969, 969, 
	969, 969, 969, 969, 969, 969, 969, 969, 
	969, 969, 969, 969, 969, 969, 969, 969, 
	969, 969, 969, 969, 969, 969, 969, 969, 
	-1, 969, 969, 969, 969, 969, -1, 969, 
	-1, 969, 969, 969, 969, -1, 969, -1, 
	969, 969, 969, -1, 969, 969, 969, 969, 
	969, 969, 969, 969, 969, 969, 969, 969, 
	969, -1, 969, 969, 969, 969, 969, 969, 
	969, 969, 969, 969, 969, 969, 969, 969, 
	969, -1, 969, -1, -1, -1, -1, 969, 
	969, 969, 969, 969, -1, -1, 969, 969, 
	969, 969, 969, 969, 969, 969, 969, 969, 
	969, 969, 969, 969, 969, 969, -1, -1, 
	-1, -1, -1, 969, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	968, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 969, 969, 969, 969, -1, -1, 
	969, 969, 969, 969, 969, 969, -1, -1, 
	-1, -1, 969, 969, 969, 969, 969, 969, 
	969, -1, -1, -1, -1, 969, -1, -1, 
	-1, -1, 969, 969, -1, -1, 969, 969, 
	969, -1, 969, 969, -1, -1, 969, -1, 
	-1, -1, -1, -1, -1, -1, -1, 969, 
	969, 969, 969, 969, 969, 969, -1, -1, 
	-1, 969, 969, 969, -1, -1, 969, 969, 
	-1, 969, 969, 969, 969, 969, -1, 969, 
	969, 969, -1, -1, -1, 969, 969, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 969, 969, 969, -1, -1, 969, -1, 
	-1, -1, -1, 969, -1, 969, 969, 969, 
	969, -1, 969, 969, 969, 969, 969, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 969, -1, 969, -1, -1, 969, -1, 
	969, 969, -1, -1, -1, 969, -1, 969, 
	-1, 969, 64, 67, 68, 65, 66, 73, 
	74, -1, 69, 70, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 138, 139, 141, 
	140, 142, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 75, -1, -1, -1, 
	131, -1, -1, -1, 135, 136, 137, 72, 
	71, 130, -1, -1, -1, -1, 124, 125, 
	126, -1, -1, -1, -1, 993, 122, -1, 
	144, 145, 146, 147, -1, -1, -1, -1, 
	-1, -1, -1, 127, -1, -1, 64, 67, 
	68, 65, 66, 73, 74, -1, 69, 70, 
	-1, 117, 118, 119, -1, 120, -1, -1, 
	-1, 138, 139, 141, 140, 142, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	75, -1, -1, -1, 131, -1, -1, -1, 
	135, 136, 137, 72, 71, 130, -1, -1, 
	-1, -1, 124, 125, 126, -1, -1, -1, 
	-1, 993, 122, -1, 144, 145, 146, 147, 
	-1, -1, -1, -1, -1, -1, -1, 127, 
	930, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 969, 117, 118, 119, 
	-1, 120, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 362, 113, 114, 
	115, 116, -1, 121, 129, 133, -1, -1, 
	-1, -1, 132, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 143, 134, 
	128, 123, 993, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 205, 361, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 206, 113, 114, 115, 116, -1, 121, 
	129, 133, -1, -1, -1, -1, 132, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 143, 134, 128, 123, 993, 888, 
	888, 888, 888, 888, 888, 888, 888, 888, 
	888, 888, 888, 888, 888, 888, -1, 888, 
	888, 888, 888, 888, 888, 888, 888, -1, 
	-1, -1, 888, 888, 888, 888, 888, -1, 
	888, -1, 888, 888, 888, 888, -1, 888, 
	-1, 888, 888, 888, -1, -1, 888, -1, 
	-1, 888, 888, 888, 888, 888, -1, 888, 
	888, 888, -1, -1, -1, -1, 888, 888, 
	888, 888, 888, -1, -1, 888, 888, 888, 
	888, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 793, 793, 793, 793, 793, 
	793, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 793, 793, 
	793, 793, 793, -1, 793, -1, 793, -1, 
	-1, -1, -1, 793, -1, -1, 793, -1, 
	-1, -1, -1, -1, -1, 793, 793, 793, 
	-1, -1, -1, 793, 793, 793, -1, -1, 
	-1, -1, 793, 793, 793, -1, 793, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 888, 888, 888, 888, -1, 
	-1, 888, 888, 888, 888, 888, 888, -1, 
	-1, -1, -1, 888, 888, 888, 888, 888, 
	888, 888, -1, -1, -1, -1, 888, -1, 
	-1, -1, -1, 888, 888, -1, -1, 888, 
	888, 888, -1, 888, 888, -1, -1, 888, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 888, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 888, 
	888, -1, -1, -1, -1, -1, -1, -1, 
	-1, 888, 888, -1, -1, -1, -1, 888, 
	-1, 793, 793, -1, -1, 793, 793, 793, 
	793, -1, 793, -1, -1, -1, -1, 793, 
	793, 793, 793, 793, 793, 793, 888, 888, 
	888, -1, -1, -1, -1, -1, 888, 888, 
	-1, -1, -1, 793, 793, 793, -1, 793, 
	793, -1, 888, 793, 888, -1, -1, 888, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 793, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 793, 793, 893, 
	893, 893, 893, 893, 893, 893, 893, 893, 
	893, 893, 893, 893, 893, 893, -1, 893, 
	893, 893, 893, 893, 893, 893, 893, -1, 
	-1, -1, 893, 893, 893, 893, 893, -1, 
	893, -1, 893, 893, 893, 893, -1, 893, 
	-1, 893, 893, 893, -1, -1, 893, -1, 
	793, 893, 893, 893, 893, 893, -1, 893, 
	893, 893, -1, -1, -1, -1, 893, 893, 
	893, 893, 893, -1, -1, 893, 893, 893, 
	893, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 888, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 362, 113, 114, 115, 116, -1, 121, 
	129, 133, -1, -1, -1, -1, 132, -1, 
	-1, -1, -1, 893, 893, 893, 893, -1, 
	-1, 893, 893, 893, 893, 893, 893, -1, 
	-1, -1, -1, 893, 893, 893, 893, 893, 
	893, 893, 143, 134, 128, 123, 893, -1, 
	-1, -1, -1, 893, 893, -1, -1, 893, 
	893, 893, -1, 893, 893, -1, -1, 893, 
	-1, -1, 205, 361, -1, -1, -1, -1, 
	-1, -1, -1, 893, -1, 206, 113, 114, 
	115, 116, -1, 121, 129, 133, -1, 893, 
	893, -1, 132, -1, -1, -1, -1, -1, 
	-1, 893, 893, -1, -1, -1, -1, 893, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 143, 134, 
	128, 123, -1, -1, -1, -1, 893, 893, 
	893, -1, -1, -1, -1, -1, 893, 893, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 893, -1, 893, -1, -1, 893, 
	-1, -1, 1013, 1013, 1013, 1013, 1013, 1013, 
	1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 
	1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 
	1013, 1013, 1013, 1013, -1, 1013, 1013, 1013, 
	1013, 1013, -1, 1013, -1, 1013, 1013, 1013, 
	1013, -1, 1013, -1, 1013, 1013, 1013, -1, 
	1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 
	1013, 1013, 1013, 1013, 1013, -1, 1013, 1013, 
	1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 
	1013, 1013, 1013, 1013, 1013, -1, 1013, -1, 
	-1, -1, -1, 1013, 1013, 1013, 1013, 1013, 
	-1, -1, 1013, 1013, 1013, 1013, 1013, 1013, 
	1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 
	1013, 1013, -1, -1, -1, -1, -1, 1013, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 893, 1013, 1013, 
	1013, 1013, -1, -1, 1013, 1013, 1013, 1013, 
	1013, 1013, -1, -1, -1, -1, 1013, 1013, 
	1013, 1013, 1013, 1013, 1013, -1, -1, -1, 
	-1, 1013, -1, -1, -1, -1, 1013, 1013, 
	-1, -1, 1013, 1013, 1013, -1, 1013, 1013, 
	-1, -1, 1013, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1013, 1013, 1013, 1013, 1013, 
	1013, 1013, -1, -1, -1, 1013, 1013, 1013, 
	-1, -1, 1013, 1013, -1, 1013, 1013, 1013, 
	1013, 1013, -1, 1013, 1013, 1013, -1, -1, 
	-1, 1013, 1013, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1013, 1013, 1013, 
	-1, -1, 1013, -1, -1, -1, -1, 1013, 
	-1, 1013, 1013, 1013, 1013, -1, 1013, 1013, 
	1013, 1013, 1013, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1013, -1, 1013, 
	-1, -1, 1013, -1, 1013, 1013, -1, -1, 
	-1, 1013, -1, 1013, -1, 1013, 1036, 1036, 
	1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 
	1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 
	1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 
	-1, 1036, 1036, 1036, 1036, 1036, -1, 1036, 
	-1, 1036, 1036, 1036, 1036, -1, 1036, -1, 
	1036, 1036, 1036, -1, 1036, 1036, 1036, 1036, 
	1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 
	1036, -1, 1036, 1036, 1036, 1036, 1036, 1036, 
	1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 
	1036, -1, 1036, -1, -1, -1, -1, 1036, 
	1036, 1036, 1036, 1036, -1, -1, 1036, 1036, 
	1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 
	1036, 1036, 1036, 1036, 1036, 1036, -1, -1, 
	-1, -1, -1, 1036, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1013, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1036, 1036, 1036, 1036, -1, -1, 
	1036, 1036, 1036, 1036, 1036, 1036, -1, -1, 
	-1, -1, 1036, 1036, 1036, 1036, 1036, 1036, 
	1036, -1, -1, -1, -1, 1036, -1, -1, 
	-1, -1, 1036, 1036, -1, -1, 1036, 1036, 
	1036, -1, 1036, 1036, -1, -1, 1036, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1036, 
	1036, 1036, 1036, 1036, 1036, 1036, -1, -1, 
	-1, 1036, 1036, 1036, 1036, -1, 1036, 1036, 
	-1, 1036, 1036, 1036, 1036, 1036, -1, 1036, 
	1036, 1036, -1, -1, -1, 1036, 1036, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1036, 1036, 1036, -1, -1, 1036, -1, 
	-1, -1, -1, 1036, -1, 1036, 1036, 1036, 
	1036, -1, 1036, 1036, 1036, 1036, 1036, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1036, -1, 1036, -1, -1, 1036, -1, 
	1036, 1036, -1, -1, -1, 1036, -1, 1036, 
	-1, 1036, 1035, 1035, 1035, 1035, 1035, 1035, 
	1035, 1035, 1035, 1035, 1035, 1035, 1035, 1035, 
	1035, 1035, 1035, 1035, 1035, 1035, 1035, 1035, 
	1035, 1035, 1035, 1035, -1, 1035, 1035, 1035, 
	1035, 1035, -1, 1035, -1, 1035, 1035, 1035, 
	1035, -1, 1035, -1, 1035, 1035, 1035, -1, 
	1035, 1035, 1035, 1035, 1035, 1035, 1035, 1035, 
	1035, 1035, 1035, 1035, 1035, -1, 1035, 1035, 
	1035, 1035, 1035, 1035, 1035, 1035, 1035, 1035, 
	1035, 1035, 1035, 1035, 1035, -1, 1035, -1, 
	-1, -1, -1, 1035, 1035, 1035, 1035, 1035, 
	-1, -1, 1035, 1035, 1035, 1035, 1035, 1035, 
	1035, 1035, 1035, 1035, 1035, 1035, 1035, 1035, 
	1035, 1035, -1, -1, -1, -1, -1, 1035, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1036, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1035, 1035, 
	1035, 1035, -1, -1, 1035, 1035, 1035, 1035, 
	1035, 1035, -1, -1, -1, -1, 1035, 1035, 
	1035, 1035, 1035, 1035, 1035, -1, -1, -1, 
	-1, 1035, -1, -1, -1, -1, 1035, 1035, 
	-1, -1, 1035, 1035, 1035, -1, 1035, 1035, 
	-1, -1, 1035, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1035, 1035, 1035, 1035, 1035, 
	1035, 1035, -1, -1, -1, 1035, 1035, 1035, 
	1035, -1, 1035, 1035, -1, 1035, 1035, 1035, 
	1035, 1035, -1, 1035, 1035, 1035, -1, -1, 
	-1, 1035, 1035, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1035, 1035, 1035, 
	-1, -1, 1035, -1, -1, -1, -1, 1035, 
	-1, 1035, 1035, 1035, 1035, -1, 1035, 1035, 
	1035, 1035, 1035, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1035, -1, 1035, 
	-1, -1, 1035, -1, 1035, 1035, -1, -1, 
	-1, 1035, -1, 1035, -1, 1035, 970, 970, 
	970, 970, 970, 970, 970, 970, 970, 970, 
	970, 970, 970, 970, 970, 970, 970, 970, 
	970, 970, 970, 970, 970, 970, 970, 970, 
	-1, 970, 970, 970, 970, 970, -1, 970, 
	-1, 970, 970, 970, 970, -1, 970, -1, 
	970, 970, 970, 194, 970, 970, 970, 970, 
	970, 970, 970, 970, 970, 970, 970, 970, 
	970, -1, 970, 970, 970, 970, 970, 970, 
	970, 970, 970, 970, 970, 970, 970, 970, 
	970, -1, 970, -1, -1, 193, -1, 970, 
	970, 970, 970, 970, -1, -1, 970, 970, 
	970, 970, 970, 970, 970, 970, 970, 970, 
	970, 970, 970, 970, 970, 970, -1, -1, 
	-1, -1, -1, 970, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1035, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 970, 970, 970, 970, -1, -1, 
	970, 970, 970, 970, 970, 970, -1, -1, 
	-1, -1, 970, 970, 970, 970, 970, 970, 
	970, -1, -1, -1, -1, 970, -1, -1, 
	-1, -1, 970, 970, -1, -1, 970, 970, 
	970, -1, 970, 970, -1, -1, 970, -1, 
	-1, -1, -1, -1, -1, -1, -1, 970, 
	970, 970, 970, 970, 970, 970, -1, -1, 
	-1, 970, 970, 970, -1, -1, 970, 970, 
	-1, 970, 970, 970, 970, 970, 411, 970, 
	970, 970, -1, -1, -1, 970, 970, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 970, 970, 970, -1, -1, 970, -1, 
	-1, -1, -1, 970, -1, 970, 970, 970, 
	970, -1, 970, 970, 970, 970, 970, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 970, -1, 970, -1, -1, 970, -1, 
	970, 970, -1, -1, -1, 970, -1, 970, 
	-1, 970, 970, 970, 970, 970, 970, 970, 
	970, 970, 970, 970, 970, 970, 970, 970, 
	970, 970, 970, 970, 970, 970, 970, 970, 
	970, 970, 970, 970, -1, 970, 970, 970, 
	970, 970, -1, 970, -1, 970, 970, 970, 
	970, -1, 970, -1, 970, 970, 970, 194, 
	970, 970, 970, 970, 970, 970, 970, 970, 
	970, 970, 970, 970, 970, -1, 970, 970, 
	970, 970, 970, 970, 970, 970, 970, 970, 
	970, 970, 970, 970, 970, -1, 970, -1, 
	-1, 193, -1, 970, 970, 970, 970, 970, 
	-1, -1, 970, 970, 970, 970, 970, 970, 
	970, 970, 970, 970, 970, 970, 970, 970, 
	970, 970, -1, -1, -1, -1, -1, 970, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 970, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 970, 970, 
	970, 970, -1, -1, 970, 970, 970, 970, 
	970, 970, -1, -1, -1, -1, 970, 970, 
	970, 970, 970, 970, 970, -1, -1, -1, 
	-1, 970, -1, -1, -1, -1, 970, 970, 
	-1, -1, 970, 970, 970, -1, 970, 970, 
	-1, -1, 970, -1, -1, -1, -1, -1, 
	-1, -1, -1, 970, 970, 970, 970, 970, 
	970, 970, -1, -1, -1, 970, 970, 970, 
	-1, -1, 970, 970, -1, 970, 970, 970, 
	970, 970, 412, 970, 970, 970, -1, -1, 
	-1, 970, 970, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 970, 970, 970, 
	-1, -1, 970, -1, -1, -1, -1, 970, 
	-1, 970, 970, 970, 970, -1, 970, 970, 
	970, 970, 970, -1, -1, 27, 28, 1131, 
	25, 23, 26, -1, -1, 970, -1, 970, 
	-1, -1, 970, -1, 970, 970, -1, 30, 
	-1, 970, -1, 970, -1, 970, -1, -1, 
	853, 853, 853, 853, 853, -1, 32, -1, 
	243, -1, -1, -1, -1, 50, -1, -1, 
	48, 46, -1, -1, -1, -1, -1, 853, 
	853, 853, -1, -1, -1, 24, 54, 53, 
	-1, -1, -1, -1, 77, 78, 79, 51, 
	853, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 811, 811, 
	811, 811, 811, 811, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	811, -1, -1, -1, -1, -1, -1, -1, 
	-1, 811, 811, 811, 811, 811, -1, 811, 
	-1, 811, -1, -1, -1, -1, 811, -1, 
	-1, 811, 811, -1, -1, -1, -1, -1, 
	811, 811, 811, -1, -1, -1, 811, 811, 
	811, -1, -1, -1, -1, 811, 811, 811, 
	811, 811, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 241, 239, 49, -1, -1, 238, 
	240, -1, -1, 242, 237, -1, -1, -1, 
	970, 31, 235, 236, -1, 29, 233, 227, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 234, 225, -1, -1, 231, 232, 226, 
	-1, 228, 229, -1, -1, 230, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 853, 
	853, -1, 411, 811, 811, 811, -1, -1, 
	811, 811, -1, -1, 811, 811, -1, -1, 
	-1, -1, 811, 811, 811, -1, 811, 811, 
	811, -1, -1, 812, 812, 812, 812, 812, 
	812, -1, 811, 811, -1, -1, 811, 811, 
	811, -1, 811, 811, -1, 812, 811, -1, 
	-1, -1, -1, -1, -1, 413, 812, 812, 
	812, 812, 812, -1, 812, -1, 812, -1, 
	-1, -1, -1, 812, -1, -1, 812, 812, 
	-1, -1, -1, -1, -1, 812, 812, 812, 
	811, 811, -1, 812, 812, 812, -1, -1, 
	-1, -1, 812, 812, 812, 812, 812, -1, 
	-1, 813, 813, 813, 813, 813, 813, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 813, -1, -1, -1, -1, 
	-1, -1, -1, -1, 813, 813, 813, 813, 
	813, -1, 813, -1, 813, -1, 811, -1, 
	-1, 813, -1, -1, 813, 813, -1, -1, 
	-1, -1, -1, 813, 813, 813, -1, -1, 
	-1, 813, 813, 813, -1, -1, -1, -1, 
	813, 813, 813, 813, 813, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	812, 812, 812, -1, -1, 812, 812, -1, 
	-1, 812, 812, -1, -1, -1, -1, 812, 
	812, 812, -1, 812, 812, 812, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 812, 
	812, -1, -1, 812, 812, 812, -1, 812, 
	812, -1, -1, 812, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 813, 813, 
	813, -1, -1, 813, 813, 812, 812, 813, 
	813, -1, -1, -1, -1, 813, 813, 813, 
	-1, 813, 813, 813, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 813, 813, -1, 
	-1, 813, 813, 813, -1, 813, 813, -1, 
	-1, 813, -1, -1, -1, -1, 412, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 812, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 813, 813, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 813, -1, -1, -1, 814, 814, 814, 
	814, 814, 814, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 814, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	814, 814, 814, 814, 814, -1, 814, -1, 
	814, -1, -1, -1, -1, 814, -1, -1, 
	814, 814, -1, -1, -1, -1, -1, 814, 
	814, 814, -1, -1, -1, 814, 814, 814, 
	-1, -1, -1, -1, 814, 814, 814, 814, 
	814, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 241, 239, 
	49, -1, -1, 238, 240, -1, -1, 242, 
	237, -1, -1, -1, -1, 31, 235, 236, 
	-1, 29, 233, 227, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 234, 225, -1, 
	-1, 231, 232, 226, -1, 228, 229, -1, 
	-1, 230, 814, 814, 814, -1, -1, 814, 
	814, -1, -1, 814, 814, -1, -1, -1, 
	-1, 814, 814, 814, -1, 814, 814, 814, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 814, 814, -1, -1, 814, 814, 814, 
	-1, 814, 814, -1, -1, 814, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 815, 
	815, 815, 815, 815, 815, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 815, -1, -1, -1, -1, -1, 814, 
	814, -1, 815, 815, 815, 815, 815, -1, 
	815, 413, 815, -1, -1, -1, -1, 815, 
	-1, -1, 815, 815, -1, -1, -1, -1, 
	-1, 815, 815, 815, -1, -1, -1, 815, 
	815, 815, -1, -1, -1, -1, 815, 815, 
	815, 815, 815, -1, -1, 816, 816, 816, 
	816, 816, 816, -1, -1, 814, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 816, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	816, 816, 816, 816, 816, -1, 816, -1, 
	816, -1, -1, -1, -1, 816, -1, -1, 
	816, 816, -1, -1, -1, -1, -1, 816, 
	816, 816, -1, -1, -1, 816, 816, 816, 
	-1, -1, -1, -1, 816, 816, 816, 816, 
	816, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 815, 815, 815, -1, 
	-1, 815, 815, -1, -1, 815, 815, -1, 
	-1, -1, -1, 815, 815, 815, -1, 815, 
	815, 815, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 815, 815, -1, -1, 815, 
	815, 815, -1, 815, 815, -1, -1, 815, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 816, 816, 816, -1, -1, 816, 
	816, 815, 815, 816, 816, -1, -1, -1, 
	-1, 816, 816, 816, -1, 816, 816, 816, 
	-1, 817, 817, 817, 817, 817, 817, -1, 
	-1, 816, 816, -1, -1, 816, 816, 816, 
	-1, 816, 816, 817, -1, 816, -1, -1, 
	-1, -1, -1, -1, 817, 817, 817, 817, 
	817, -1, 817, -1, 817, -1, -1, 815, 
	-1, 817, -1, -1, 817, 817, -1, -1, 
	-1, -1, -1, 817, 817, 817, -1, 816, 
	816, 817, 817, 817, -1, -1, -1, -1, 
	817, 817, 817, 817, 817, -1, -1, 818, 
	818, 818, 818, 818, 818, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 818, -1, -1, -1, -1, -1, -1, 
	-1, -1, 818, 818, 818, 818, 818, -1, 
	818, -1, 818, -1, -1, 816, -1, 818, 
	-1, -1, 818, 818, -1, -1, -1, -1, 
	-1, 818, 818, 818, -1, -1, -1, 818, 
	818, 818, -1, -1, -1, -1, 818, 818, 
	818, 818, 818, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 817, 817, 
	817, -1, -1, 817, 817, -1, -1, 817, 
	817, -1, -1, -1, -1, 817, 817, 817, 
	-1, 817, 817, 817, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 817, 817, -1, 
	-1, 817, 817, 817, -1, 817, 817, -1, 
	-1, 817, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 818, 818, 818, -1, 
	-1, 818, 818, 817, 817, 818, 818, -1, 
	-1, -1, -1, 818, 818, 818, -1, 818, 
	818, 818, -1, 819, 819, 819, 819, 819, 
	819, -1, -1, 818, 818, -1, -1, 818, 
	818, 818, -1, 818, 818, 819, -1, 818, 
	-1, -1, -1, -1, -1, -1, 819, 819, 
	819, 819, 819, -1, 819, -1, 819, -1, 
	-1, 817, -1, 819, -1, -1, 819, 819, 
	-1, -1, -1, -1, -1, 819, 819, 819, 
	-1, 818, 818, 819, 819, 819, -1, -1, 
	-1, -1, 819, 819, 819, 819, 819, -1, 
	-1, 820, 820, 820, 820, 820, 820, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 820, -1, -1, -1, -1, 
	-1, -1, -1, -1, 820, 820, 820, 820, 
	820, -1, 820, -1, 820, -1, -1, 818, 
	-1, 820, -1, -1, 820, 820, -1, -1, 
	-1, -1, -1, 820, 820, 820, -1, -1, 
	-1, 820, 820, 820, -1, -1, -1, -1, 
	820, 820, 820, 820, 820, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	819, 819, 819, -1, -1, 819, 819, -1, 
	-1, 819, 819, -1, -1, -1, -1, 819, 
	819, 819, -1, 819, 819, 819, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 819, 
	819, -1, -1, 819, 819, 819, -1, 819, 
	819, -1, -1, 819, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 820, 820, 
	820, -1, -1, 820, 820, 819, 819, 820, 
	820, -1, -1, -1, -1, 820, 820, 820, 
	-1, 820, 820, 820, -1, 821, 821, 821, 
	821, 821, 821, -1, -1, 820, 820, -1, 
	-1, 820, 820, 820, -1, 820, 820, 821, 
	-1, 820, -1, -1, -1, -1, -1, -1, 
	821, 821, 821, 821, 821, -1, 821, -1, 
	821, -1, -1, 819, -1, 821, -1, -1, 
	821, 821, -1, -1, -1, -1, -1, 821, 
	821, 821, -1, 820, 820, 821, 821, 821, 
	-1, -1, -1, -1, 821, 821, 821, 821, 
	821, -1, -1, 822, 822, 822, 822, 822, 
	822, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 822, -1, -1, 
	-1, -1, -1, -1, -1, -1, 822, 822, 
	822, 822, 822, -1, 822, -1, 822, -1, 
	-1, 820, -1, 822, -1, -1, 822, 822, 
	-1, -1, -1, -1, -1, 822, 822, 822, 
	-1, -1, -1, 822, 822, 822, -1, -1, 
	-1, -1, 822, 822, 822, 822, 822, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 821, 821, 821, -1, -1, 821, 
	821, -1, -1, 821, 821, -1, -1, -1, 
	-1, 821, 821, 821, -1, 821, 821, 821, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 821, 821, -1, -1, 821, 821, 821, 
	-1, 821, 821, -1, -1, 821, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	822, 822, 822, -1, -1, 822, 822, 821, 
	821, 822, 822, -1, -1, -1, -1, 822, 
	822, 822, -1, 822, 822, 822, -1, 823, 
	823, 823, 823, 823, 823, -1, -1, 822, 
	822, -1, -1, 822, 822, 822, -1, 822, 
	822, 823, -1, 822, -1, -1, -1, -1, 
	-1, -1, 823, 823, 823, 823, 823, -1, 
	823, -1, 823, -1, -1, 821, -1, 823, 
	-1, -1, 823, 823, -1, -1, -1, -1, 
	-1, 823, 823, 823, -1, 822, 822, 823, 
	823, 823, -1, -1, -1, -1, 823, 823, 
	823, 823, 823, -1, -1, 824, 824, 824, 
	824, 824, 824, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 824, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	824, 824, 824, 824, 824, -1, 824, -1, 
	824, -1, -1, 822, -1, 824, -1, -1, 
	824, 824, -1, -1, -1, -1, -1, 824, 
	824, 824, -1, -1, -1, 824, 824, 824, 
	-1, -1, -1, -1, 824, 824, 824, 824, 
	824, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 823, 823, 823, -1, 
	-1, 823, 823, -1, -1, 823, 823, -1, 
	-1, -1, -1, 823, 823, 823, -1, 823, 
	823, 823, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 823, 823, -1, -1, 823, 
	823, 823, -1, 823, 823, -1, -1, 823, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 824, 824, 824, -1, -1, 824, 
	824, 823, 823, 824, 824, -1, -1, -1, 
	-1, 824, 824, 824, -1, 824, 824, 824, 
	-1, 825, 825, 825, 825, 825, 825, -1, 
	-1, 824, 824, -1, -1, 824, 824, 824, 
	-1, 824, 824, 825, -1, 824, -1, -1, 
	-1, -1, -1, -1, 825, 825, 825, 825, 
	825, -1, 825, -1, 825, -1, -1, 823, 
	-1, 825, -1, -1, 825, 825, -1, -1, 
	-1, -1, -1, 825, 825, 825, -1, 824, 
	824, 825, 825, 825, -1, -1, -1, -1, 
	825, 825, 825, 825, 825, -1, -1, -1, 
	1040, 1040, 1040, 1040, 1040, 1040, 1040, -1, 
	1040, 1040, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1040, 1040, 1040, 1040, 1040, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1040, -1, -1, 824, 1040, -1, 
	-1, -1, 1040, 1040, 1040, 1040, 1040, 1040, 
	-1, -1, -1, -1, 1040, 1040, 1040, -1, 
	-1, -1, -1, 1040, 1040, -1, 1154, 1154, 
	1154, 1040, -1, -1, -1, -1, -1, -1, 
	-1, 1040, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1040, 
	1040, 1040, 1040, 1040, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1153, 825, 825, 
	825, -1, -1, 825, 825, -1, -1, 825, 
	825, -1, -1, -1, -1, 825, 825, 825, 
	-1, 825, 825, 825, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 825, 825, -1, 
	-1, 825, 825, 825, -1, 825, 825, -1, 
	-1, 825, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 825, 825, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 825, -1, 1040, 1040, 1040, 1040, 1040, 
	-1, 1040, 1040, 1040, -1, -1, -1, -1, 
	1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 
	-1, 1040, 1040, 1040, 265, 266, -1, -1, 
	-1, -1, -1, -1, 1040, 1040, 1040, 1040, 
	1040, -1, 264, -1, 1040, 1040, 1040, 1040, 
	1040, -1, -1, 1040, -1, -1, -1, 1040, 
	-1, -1, -1, 1040, 1040, 1040, 1040, 1040, 
	1040, -1, -1, -1, -1, 1040, 1040, 1040, 
	-1, -1, -1, 427, 1040, 1040, -1, 1154, 
	1154, 1154, 1040, 1153, -1, -1, -1, -1, 
	-1, -1, 1040, 1038, 1038, 1038, 1038, 1038, 
	1038, 1038, -1, 1038, 1038, -1, -1, -1, 
	1040, 1040, 1040, 1040, 1040, -1, 1038, 1038, 
	1038, 1038, 1038, -1, -1, -1, 1153, -1, 
	-1, -1, -1, -1, -1, 1038, -1, -1, 
	-1, 1038, -1, -1, -1, 1038, 1038, 1038, 
	1038, 1038, 1038, -1, -1, -1, -1, 1038, 
	1038, 1038, -1, -1, -1, -1, 1038, 1038, 
	-1, 1038, 1038, 1038, 1038, -1, -1, -1, 
	-1, -1, -1, -1, 1038, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1038, 1038, 1038, 332, 1038, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1040, 1040, 1040, 1040, 
	1040, -1, 1040, 1040, 1040, -1, -1, -1, 
	-1, 1040, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1040, 265, 266, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 264, -1, 1040, 1040, 1040, 
	1040, 1040, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 436, -1, 1038, 1038, 
	1038, 1038, 1038, -1, 1038, 1038, 1038, -1, 
	-1, -1, -1, 1038, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 435, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1038, 
	1038, 1038, 1038, 1038, -1, -1, -1, -1, 
	-1, -1, 962, 962, 962, 962, 962, 962, 
	962, 962, 962, 962, 962, 962, 962, 962, 
	962, 962, 962, 962, 962, 962, 962, 962, 
	962, 962, 962, 962, -1, 962, 962, 962, 
	962, 962, -1, 962, -1, 962, 962, 962, 
	962, -1, 962, -1, 962, 962, 962, -1, 
	962, 962, 962, 962, 962, 962, 962, 962, 
	962, 962, 962, 962, 962, -1, 962, 962, 
	962, 962, 962, 962, 962, 962, 962, 962, 
	962, 962, 962, 962, 962, -1, 962, -1, 
	-1, -1, -1, 962, 962, 962, 962, 962, 
	-1, -1, 962, 962, 962, 962, 962, 962, 
	962, 962, 962, 962, 962, 962, 962, 962, 
	962, 962, -1, -1, -1, -1, -1, 962, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 962, 962, 
	962, 962, -1, -1, 962, 962, 962, 962, 
	962, 962, -1, -1, -1, -1, 962, 962, 
	962, 962, 962, 962, 962, -1, -1, -1, 
	-1, 962, -1, -1, -1, -1, 962, 962, 
	-1, -1, 962, 962, 962, -1, 962, 962, 
	-1, -1, 962, -1, -1, -1, -1, -1, 
	-1, -1, -1, 962, 962, 962, 962, 962, 
	962, 962, -1, -1, -1, 962, 962, 962, 
	-1, -1, 962, 962, -1, 962, 962, 962, 
	962, 962, -1, 962, 962, 962, -1, -1, 
	-1, 962, 962, -1, -1, -1, -1, -1, 
	265, 266, -1, -1, -1, 962, 962, 962, 
	-1, -1, 962, -1, -1, -1, 264, 962, 
	-1, 962, 962, 962, 962, -1, 962, 962, 
	962, 962, 962, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 962, -1, 962, 
	-1, -1, 962, -1, 962, 962, -1, 427, 
	-1, 962, -1, 962, -1, 962, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 963, 
	963, 963, 963, 963, 963, 963, 963, 963, 
	963, 963, 963, 963, 963, 963, 963, 963, 
	963, 963, 963, 963, 963, 963, 963, 963, 
	963, -1, 963, 963, 963, 963, 963, -1, 
	963, -1, 963, 963, 963, 963, -1, 963, 
	-1, 963, 963, 963, -1, 963, 963, 963, 
	963, 963, 963, 963, 963, 963, 963, 963, 
	963, 963, -1, 963, 963, 963, 963, 963, 
	963, 963, 963, 963, 963, 963, 963, 963, 
	963, 963, -1, 963, -1, -1, -1, -1, 
	963, 963, 963, 963, 963, -1, -1, 963, 
	963, 963, 963, 963, 963, 963, 963, 963, 
	963, 963, 963, 963, 963, 963, 963, -1, 
	-1, -1, -1, -1, 963, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	962, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 963, 963, 963, 963, -1, 
	-1, 963, 963, 963, 963, 963, 963, -1, 
	-1, 265, 266, 963, 963, 963, 963, 963, 
	963, 963, -1, -1, -1, -1, 963, 264, 
	-1, -1, -1, 963, 963, -1, -1, 963, 
	963, 963, -1, 963, 963, -1, -1, 963, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	963, 963, 963, 963, 963, 963, 963, -1, 
	436, -1, 963, 963, 963, -1, -1, 963, 
	963, -1, 963, 963, 963, 963, 963, -1, 
	963, 963, 963, -1, -1, -1, 963, 963, 
	-1, -1, 435, -1, -1, -1, -1, -1, 
	-1, -1, 963, 963, 963, -1, -1, 963, 
	-1, -1, -1, -1, 963, -1, 963, 963, 
	963, 963, -1, 963, 963, 963, 963, 963, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 963, -1, 963, -1, -1, 963, 
	-1, 963, 963, -1, -1, -1, 963, -1, 
	963, -1, 963, 64, 67, 68, 65, 66, 
	73, 74, -1, 69, 70, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 138, 139, 
	141, 140, 142, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 75, -1, -1, 
	-1, 131, -1, -1, -1, 135, 136, 137, 
	72, 71, 130, -1, -1, -1, -1, 124, 
	125, 126, -1, -1, -1, -1, 993, 122, 
	-1, 144, 145, 146, 147, -1, -1, -1, 
	-1, -1, -1, -1, 127, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	965, 965, 965, 965, 965, 965, 965, 965, 
	965, 965, 965, 965, 965, 965, 965, 965, 
	965, 965, 965, 965, 965, 965, 965, 965, 
	965, 965, -1, 965, 965, 965, 965, 965, 
	-1, 965, -1, 965, 965, 965, 965, -1, 
	965, -1, 965, 965, 965, 963, 965, 965, 
	965, 965, 965, 965, 965, 965, 965, 965, 
	965, 965, 965, -1, 965, 965, 965, 965, 
	965, 965, 965, 965, 965, 965, 965, 965, 
	965, 965, 965, -1, 965, -1, -1, -1, 
	-1, 965, 965, 965, 965, 965, -1, -1, 
	965, 965, 965, 965, 965, 965, 965, 965, 
	965, 965, 965, 965, 965, 965, 965, 965, 
	-1, -1, -1, -1, -1, 965, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 439, 129, 133, -1, 
	-1, -1, -1, 132, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 143, 
	134, 128, 123, 993, -1, -1, -1, -1, 
	-1, -1, -1, -1, 965, 965, 965, 965, 
	-1, -1, 965, 965, 965, 965, 965, 965, 
	-1, -1, -1, -1, 965, 965, 965, 965, 
	965, 965, 965, -1, -1, -1, -1, 965, 
	-1, -1, -1, -1, 965, 965, -1, -1, 
	965, 965, 965, -1, 965, 965, -1, -1, 
	965, -1, -1, -1, -1, -1, -1, -1, 
	-1, 965, 965, 965, 965, 965, 965, 965, 
	-1, -1, -1, 965, 965, 965, -1, -1, 
	965, 965, -1, 965, 965, 965, 965, 965, 
	-1, 965, 965, 965, -1, -1, -1, 965, 
	965, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 965, 965, 965, -1, -1, 
	965, -1, -1, -1, -1, 965, -1, 965, 
	965, 965, 965, -1, 965, 965, 965, 965, 
	965, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 965, -1, 965, -1, -1, 
	965, -1, 965, 965, -1, -1, -1, 965, 
	-1, 965, -1, 965, 966, 966, 966, 966, 
	966, 966, 966, 966, 966, 966, 966, 966, 
	966, 966, 966, 966, 966, 966, 966, 966, 
	966, 966, 966, 966, 966, 966, -1, 966, 
	966, 966, 966, 966, -1, 966, -1, 966, 
	966, 966, 966, -1, 966, -1, 966, 966, 
	966, -1, 966, 966, 966, 966, 966, 966, 
	966, 966, 966, 966, 966, 966, 966, -1, 
	966, 966, 966, 966, 966, 966, 966, 966, 
	966, 966, 966, 966, 966, 966, 966, -1, 
	966, -1, -1, -1, -1, 966, 966, 966, 
	966, 966, -1, -1, 966, 966, 966, 966, 
	966, 966, 966, 966, 966, 966, 966, 966, 
	966, 966, 966, 966, -1, -1, -1, -1, 
	-1, 966, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 965, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	966, 966, 966, 966, -1, -1, 966, 966, 
	966, 966, 966, 966, -1, -1, -1, -1, 
	966, 966, 966, 966, 966, 966, 966, -1, 
	-1, -1, -1, 966, -1, -1, -1, -1, 
	966, 966, -1, -1, 966, 966, 966, -1, 
	966, 966, -1, -1, 966, -1, -1, -1, 
	-1, -1, -1, -1, -1, 966, 966, 966, 
	966, 966, 966, 966, -1, -1, -1, 966, 
	966, 966, -1, -1, 966, 966, -1, 966, 
	966, 966, 966, 966, -1, 966, 966, 966, 
	-1, -1, -1, 966, 966, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 966, 
	966, 966, -1, -1, 966, -1, -1, -1, 
	-1, 966, -1, 966, 966, 966, 966, -1, 
	966, 966, 966, 966, 966, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 966, 
	-1, 966, -1, -1, 966, -1, 966, 966, 
	-1, -1, -1, 966, -1, 966, -1, 966, 
	926, 926, 926, 926, 926, 926, 926, 926, 
	926, 926, 926, 926, 926, 926, 926, 926, 
	926, 926, 926, 926, 926, 926, 926, 926, 
	449, 450, -1, 926, 926, 926, 926, 926, 
	-1, 926, -1, 926, 926, 926, 926, -1, 
	926, -1, 926, 926, 926, -1, -1, 926, 
	926, 926, 926, 926, 926, 926, 926, -1, 
	926, 926, 926, -1, -1, -1, -1, 926, 
	926, 926, 926, 926, -1, -1, 926, 926, 
	926, 926, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 926, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	439, 129, 133, -1, -1, -1, -1, 132, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 143, 134, 128, 123, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 966, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 926, 926, 926, 926, 
	-1, -1, 926, 926, -1, 926, 926, 926, 
	-1, -1, -1, -1, 926, 926, 926, -1, 
	926, 926, 926, -1, -1, -1, -1, 926, 
	-1, -1, -1, -1, 926, -1, -1, -1, 
	926, 926, 926, -1, 926, 926, -1, -1, 
	926, -1, -1, -1, -1, -1, -1, -1, 
	-1, 926, 926, 926, 926, 444, 446, 448, 
	-1, -1, -1, -1, 926, 926, -1, -1, 
	926, 926, -1, -1, -1, -1, -1, -1, 
	-1, -1, 926, 926, -1, -1, -1, -1, 
	926, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 926, 
	926, 926, -1, -1, -1, -1, -1, 926, 
	926, 64, 67, 68, 65, 66, 73, 74, 
	-1, 69, 70, 926, -1, -1, -1, -1, 
	-1, -1, 926, -1, 138, 139, 141, 140, 
	142, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 75, -1, -1, -1, 131, 
	-1, -1, -1, 135, 136, 137, 72, 71, 
	130, -1, -1, -1, -1, 124, 125, 126, 
	-1, -1, -1, -1, 993, 122, -1, 144, 
	145, 146, 147, -1, -1, -1, -1, -1, 
	-1, -1, 127, 64, 67, 68, 65, 66, 
	73, 74, -1, 69, 70, -1, -1, -1, 
	117, 118, 119, -1, 120, -1, 138, 139, 
	141, 140, 142, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 75, -1, -1, 
	-1, 131, -1, -1, -1, 135, 136, 137, 
	72, 71, 130, -1, -1, -1, -1, 124, 
	125, 126, -1, -1, -1, -1, 993, 122, 
	-1, 144, 145, 146, 147, -1, -1, -1, 
	-1, -1, -1, -1, 127, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 117, 118, 119, -1, 120, 55, 
	56, 64, 67, 68, 65, 66, 73, 74, 
	1135, 69, 70, -1, -1, 35, 36, 40, 
	38, -1, -1, -1, -1, -1, 926, -1, 
	-1, -1, -1, -1, -1, 41, 42, 43, 
	-1, -1, -1, 75, -1, -1, -1, -1, 
	37, -1, -1, -1, -1, -1, 72, 71, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 59, -1, -1, 82, 
	84, 86, 88, -1, -1, 441, 114, 115, 
	116, -1, 121, 129, 133, 1135, -1, -1, 
	-1, 132, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 143, 134, 128, 
	123, 993, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 442, 
	114, 115, 116, -1, 121, 129, 133, -1, 
	-1, -1, -1, 132, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 143, 
	134, 128, 123, 993, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 299, -1, -1, 
	-1, -1, -1, -1, -1, 1135, 1135, 440, 
	-1, 34, 33, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 62, -1, -1, -1, 
	-1, 44, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	80, 76, 45, -1, -1, -1, -1, -1, 
	39, 993, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 298, 935, 935, 935, 935, 
	935, 935, 935, 935, 935, 935, 935, 935, 
	935, 935, 935, 935, 935, 935, 935, 935, 
	935, 935, 935, 935, 935, 935, -1, 935, 
	935, 935, 935, 935, -1, 935, -1, 935, 
	935, 935, 935, -1, 935, -1, 935, 935, 
	935, -1, -1, 935, 935, 935, 935, 935, 
	935, 935, 935, -1, 935, 935, 935, -1, 
	-1, -1, -1, 935, 935, 935, 935, 935, 
	-1, -1, 935, 935, 935, 935, 64, 67, 
	68, 65, 66, 73, 74, -1, 69, 70, 
	935, 443, 445, 447, -1, -1, -1, -1, 
	-1, 138, 139, 141, 140, 142, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	75, -1, -1, -1, 131, -1, -1, -1, 
	135, 136, 137, 72, 71, 130, -1, -1, 
	-1, -1, 124, 125, 126, -1, -1, -1, 
	-1, 993, 122, -1, 144, 145, 146, 147, 
	-1, -1, -1, -1, -1, -1, -1, 127, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 117, 118, 119, 
	-1, 120, -1, -1, -1, -1, -1, -1, 
	935, 935, 935, 935, -1, -1, 935, 935, 
	-1, 935, 935, 935, -1, -1, -1, -1, 
	935, 935, 935, -1, 935, 935, 935, -1, 
	-1, -1, -1, 935, -1, -1, -1, -1, 
	935, -1, -1, -1, 935, 935, 935, -1, 
	935, 935, -1, -1, 935, -1, -1, -1, 
	-1, -1, -1, -1, -1, 935, 935, 935, 
	935, 935, 935, 935, -1, -1, -1, -1, 
	935, 935, -1, -1, 935, 935, -1, -1, 
	-1, -1, -1, -1, -1, -1, 935, 935, 
	-1, -1, -1, -1, 935, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 935, 935, 935, -1, -1, 
	-1, -1, -1, 935, 935, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 935, 
	-1, -1, -1, -1, -1, -1, 935, -1, 
	-1, -1, -1, 451, 115, 116, -1, 121, 
	129, 133, -1, -1, -1, -1, 132, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 143, 134, 128, 123, 993, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 441, 114, 115, 116, -1, 121, 129, 
	133, -1, -1, -1, -1, 132, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 143, 134, 128, 123, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 442, 114, 115, 116, -1, 
	121, 129, 133, -1, -1, -1, -1, 132, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 935, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 143, 134, 128, 123, -1, 
	-1, -1, -1, -1, -1, -1, 64, 67, 
	68, 65, 66, 73, 74, -1, 69, 70, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 138, 139, 141, 140, 142, -1, -1, 
	-1, 299, -1, -1, -1, -1, -1, -1, 
	75, -1, -1, 440, 131, 34, 33, -1, 
	135, 136, 137, 72, 71, 130, -1, -1, 
	62, -1, 124, 125, 126, 44, -1, -1, 
	-1, 993, 122, -1, 144, 145, 146, 147, 
	-1, -1, -1, -1, -1, -1, -1, 127, 
	-1, -1, -1, -1, 80, 76, 45, -1, 
	-1, -1, -1, -1, 39, 117, 118, 119, 
	-1, 120, 64, 67, 68, 65, 66, 73, 
	74, -1, 69, 70, -1, -1, -1, 298, 
	-1, -1, -1, -1, -1, 138, 139, 141, 
	140, 142, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 75, -1, -1, -1, 
	131, -1, -1, -1, 135, 136, 137, 72, 
	71, 130, -1, -1, -1, -1, 124, 125, 
	126, -1, -1, -1, -1, 993, 122, -1, 
	144, 145, 146, 147, -1, -1, -1, -1, 
	-1, -1, -1, 127, -1, 64, 67, 68, 
	65, 66, 73, 74, -1, 69, 70, -1, 
	-1, 117, 118, 119, -1, 120, -1, -1, 
	138, 139, 141, 140, 142, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 75, 
	-1, -1, -1, 131, -1, -1, -1, 135, 
	136, 137, 72, 71, 130, -1, -1, -1, 
	-1, 124, 125, 126, -1, -1, -1, -1, 
	993, 122, -1, 144, 145, 146, 147, -1, 
	-1, -1, -1, 452, 115, 116, 127, 121, 
	129, 133, -1, -1, -1, -1, 132, -1, 
	-1, -1, -1, -1, 117, 118, 119, -1, 
	120, -1, -1, -1, -1, 64, 67, 68, 
	65, 66, 73, 74, -1, 69, 70, -1, 
	-1, -1, 143, 134, 128, 123, 993, -1, 
	138, 139, 141, 140, 142, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 75, 
	-1, -1, -1, 131, -1, -1, -1, 135, 
	136, 137, 72, 71, 130, -1, -1, -1, 
	-1, 124, 125, 126, -1, -1, -1, -1, 
	993, 122, -1, 144, 145, 146, 147, 453, 
	115, 116, -1, 121, 129, 133, 127, -1, 
	-1, -1, 132, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 117, 118, 119, -1, 
	120, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 143, 134, 
	128, 123, 993, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 454, 115, 116, -1, 121, 129, 
	133, -1, -1, -1, -1, 132, -1, 451, 
	115, 116, -1, 121, 129, 133, -1, -1, 
	-1, -1, 132, -1, 64, 67, 68, 65, 
	66, 73, 74, -1, 69, 70, -1, -1, 
	-1, 143, 134, 128, 123, 993, -1, 138, 
	139, 141, 140, 142, -1, -1, 143, 134, 
	128, 123, -1, -1, -1, -1, 75, -1, 
	-1, -1, 131, -1, -1, -1, 135, 136, 
	137, 72, 71, 130, -1, -1, -1, -1, 
	124, 125, 126, -1, -1, -1, -1, 993, 
	122, -1, 144, 145, 146, 147, -1, -1, 
	-1, -1, 455, 115, 116, 127, 121, 129, 
	133, -1, -1, -1, -1, 132, -1, -1, 
	-1, -1, -1, 117, 118, 119, -1, 120, 
	-1, -1, -1, 64, 67, 68, 65, 66, 
	73, 74, -1, 69, 70, -1, -1, -1, 
	-1, 143, 134, 128, 123, 993, 138, 139, 
	141, 140, 142, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 75, -1, -1, 
	-1, 131, -1, -1, -1, 135, 136, 137, 
	72, 71, 130, -1, -1, -1, -1, 124, 
	125, 126, -1, -1, -1, -1, 993, 122, 
	-1, 144, 145, 146, 147, -1, -1, -1, 
	-1, -1, -1, -1, 127, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 117, 118, 119, -1, 120, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 456, 115, 116, -1, 121, 129, 133, 
	-1, -1, -1, -1, 132, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 64, 67, 68, 65, 66, 73, 
	74, -1, 69, 70, -1, -1, -1, -1, 
	143, 134, 128, 123, 993, 138, 139, 141, 
	140, 142, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 75, -1, -1, -1, 
	131, -1, -1, -1, 135, 136, 137, 72, 
	71, 130, -1, -1, -1, -1, 124, 125, 
	126, -1, -1, -1, -1, 993, 122, -1, 
	144, 145, 146, 147, -1, -1, -1, -1, 
	-1, 457, 116, 127, 121, 129, 133, -1, 
	-1, -1, -1, 132, -1, -1, -1, -1, 
	-1, 117, 118, 119, -1, 120, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 143, 
	134, 128, 123, 993, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 932, 932, 
	932, 932, 932, 932, 932, 932, 932, -1, 
	932, 932, -1, -1, 932, 932, 932, 932, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 932, 932, 932, 452, 
	115, 116, 932, 121, 129, 133, -1, 932, 
	-1, -1, 132, -1, -1, 932, 932, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 932, -1, -1, 932, 932, 
	932, 932, -1, -1, -1, -1, 143, 134, 
	128, 123, -1, 932, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	458, 116, -1, 121, 129, 133, -1, -1, 
	-1, -1, 132, 453, 115, 116, -1, 121, 
	129, 133, -1, -1, -1, -1, 132, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 143, 134, 
	128, 123, 993, -1, -1, -1, -1, -1, 
	-1, -1, 143, 134, 128, 123, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 454, 115, 
	116, -1, 121, 129, 133, -1, -1, -1, 
	-1, 132, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 932, -1, -1, -1, 
	-1, -1, -1, 932, -1, -1, -1, -1, 
	932, 932, -1, -1, -1, 143, 134, 128, 
	123, -1, -1, 932, -1, -1, -1, -1, 
	932, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 932, 
	932, 932, -1, -1, -1, -1, -1, 932, 
	932, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 455, 115, 
	116, -1, 121, 129, 133, -1, -1, -1, 
	-1, 132, 64, 67, 68, 65, 66, 73, 
	74, -1, 69, 70, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 138, 139, 141, 
	140, 142, -1, -1, -1, 143, 134, 128, 
	123, -1, -1, -1, 75, -1, -1, -1, 
	131, -1, -1, -1, 135, 136, 137, 72, 
	71, 130, -1, -1, -1, -1, 124, 125, 
	126, -1, -1, -1, -1, 993, 122, -1, 
	144, 145, 146, 147, -1, -1, -1, -1, 
	-1, -1, -1, 127, -1, -1, 64, 67, 
	68, 65, 66, 73, 74, -1, 69, 70, 
	-1, 117, 118, 119, -1, 120, -1, -1, 
	-1, 138, 139, 141, 140, 142, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	75, -1, -1, -1, 131, -1, -1, -1, 
	135, 136, 137, 72, 71, 130, -1, -1, 
	-1, -1, 124, 125, 126, -1, -1, -1, 
	-1, 993, 122, -1, 144, 145, 146, 147, 
	-1, -1, -1, -1, -1, -1, -1, 127, 
	-1, -1, -1, -1, -1, 456, 115, 116, 
	-1, 121, 129, 133, -1, 117, 118, 119, 
	132, 120, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 143, 134, 128, 123, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 460, -1, 121, 129, 133, -1, -1, 
	-1, -1, 132, -1, -1, 457, 116, -1, 
	121, 129, 133, -1, -1, -1, -1, 132, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 143, 134, 
	128, 123, 993, -1, -1, -1, -1, -1, 
	-1, -1, -1, 143, 134, 128, 123, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 459, -1, 121, 
	129, 133, -1, -1, -1, -1, 132, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 64, 67, 68, 65, 
	66, 73, 74, -1, 69, 70, -1, -1, 
	-1, -1, 143, 134, 128, 123, 993, 138, 
	139, 141, 140, 142, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 75, -1, 
	-1, -1, 131, -1, -1, -1, 135, 136, 
	137, 72, 71, 130, -1, -1, -1, -1, 
	124, 125, 126, -1, -1, -1, -1, 993, 
	122, -1, 144, 145, 146, 147, -1, -1, 
	-1, -1, -1, -1, -1, 127, 930, -1, 
	-1, -1, -1, -1, 458, 116, -1, 121, 
	129, 133, -1, 117, 118, 119, 132, 120, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 143, 134, 128, 123, 997, 997, 
	997, 997, 997, 997, 997, 997, 997, 997, 
	997, 997, 997, 997, 997, 997, 997, 997, 
	997, 997, 997, 997, 997, 997, 997, 997, 
	997, 997, 997, 997, 997, 997, -1, 997, 
	-1, 997, 997, 997, 997, 997, 997, -1, 
	997, 997, 997, -1, -1, 997, 997, 997, 
	997, 997, 997, 997, 997, -1, 997, 997, 
	997, 997, -1, -1, -1, 997, 997, 997, 
	997, 997, -1, -1, 997, 997, 997, 997, 
	-1, -1, -1, 997, 359, -1, -1, 997, 
	997, -1, 997, 463, 465, 997, -1, -1, 
	997, -1, 997, -1, -1, -1, -1, -1, 
	-1, -1, 464, -1, 205, 466, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 206, 
	113, 114, 115, 116, -1, 121, 129, 133, 
	-1, -1, -1, -1, 132, -1, -1, -1, 
	-1, -1, -1, -1, 997, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 997, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	143, 134, 128, 123, 993, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 997, 997, 997, 997, -1, -1, 
	997, 997, 997, 997, 997, 997, -1, -1, 
	-1, -1, 997, 997, 997, 997, 997, 997, 
	997, -1, -1, 997, -1, 997, -1, -1, 
	-1, -1, 997, 997, -1, 997, 997, 997, 
	997, -1, 997, 997, -1, -1, 997, -1, 
	-1, -1, -1, -1, 997, -1, 997, 997, 
	997, 997, 997, 997, 997, 997, -1, -1, 
	-1, -1, 997, 997, -1, 997, 997, 997, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	997, 997, 462, -1, 997, -1, 997, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	997, 997, 997, -1, -1, 997, 997, 997, 
	-1, -1, -1, -1, -1, 997, 997, 1037, 
	1037, 1037, 1037, 1037, 1037, 1037, -1, 1037, 
	1037, 997, -1, 997, -1, -1, 997, 997, 
	997, -1, 1037, 1037, 1037, 1037, 1037, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1037, -1, -1, -1, 1037, -1, -1, 
	-1, 1037, 1037, 1037, 1037, 1037, 1037, -1, 
	-1, -1, -1, 1037, 1037, 1037, -1, -1, 
	-1, -1, 1037, 1037, -1, 1037, 1037, 1037, 
	1037, -1, -1, -1, -1, -1, -1, -1, 
	1037, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1037, 1037, 
	1037, -1, 1037, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 460, -1, 121, 
	129, 133, -1, -1, -1, -1, 132, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 143, 134, 128, 123, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 459, -1, 121, 129, 133, -1, -1, 
	-1, -1, 132, -1, 997, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 143, 134, 
	128, 123, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1037, 1037, 1037, 1037, 1037, -1, 
	1037, 1037, 1037, -1, -1, -1, -1, 1037, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1037, 1037, 1037, 1037, 1037, 
	-1, 765, 765, 765, 765, 765, 765, 765, 
	765, 765, 765, 765, 765, 765, 765, 765, 
	765, 765, 765, 765, 765, 765, 765, 765, 
	765, 765, 765, -1, 765, 765, 765, 765, 
	765, -1, 765, -1, 765, 765, 765, 765, 
	-1, 765, -1, 765, 765, 765, -1, -1, 
	765, 765, 765, 765, 765, 765, 765, 765, 
	-1, 765, 765, 765, -1, -1, -1, -1, 
	765, 765, 765, 765, 765, -1, -1, 765, 
	765, 765, 765, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 765, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	205, 466, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 206, 113, 114, 115, 116, 
	-1, 121, 129, 133, -1, -1, -1, -1, 
	132, -1, -1, -1, -1, 765, 765, 765, 
	765, -1, -1, 765, 765, -1, 765, 765, 
	765, -1, -1, -1, -1, 765, 765, 765, 
	-1, 765, 765, 765, 143, 134, 128, 123, 
	765, -1, -1, -1, -1, 765, -1, -1, 
	-1, 765, 765, 765, -1, 765, 765, -1, 
	-1, 765, -1, -1, -1, -1, -1, -1, 
	-1, -1, 765, 765, 765, 765, 765, 765, 
	765, -1, -1, -1, -1, 765, 765, -1, 
	-1, 765, 765, -1, -1, -1, -1, -1, 
	-1, -1, -1, 765, 765, -1, -1, -1, 
	-1, 765, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	765, 765, 765, -1, -1, -1, -1, -1, 
	765, 765, -1, -1, -1, -1, 462, -1, 
	-1, -1, -1, -1, 765, -1, -1, -1, 
	-1, -1, -1, 765, 842, 842, 842, 842, 
	842, 842, 842, 842, 842, 842, 842, 842, 
	842, 842, 842, -1, 842, 842, 842, 842, 
	842, 842, 842, 842, -1, -1, -1, 842, 
	842, 842, 842, 842, -1, 842, -1, 842, 
	842, 842, 842, -1, 842, -1, 842, 842, 
	842, -1, -1, 842, -1, -1, 842, 842, 
	842, 842, 842, -1, 842, 842, 842, -1, 
	-1, -1, -1, 842, 842, 842, 842, 842, 
	-1, -1, 842, 842, 842, 842, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 765, 
	842, 842, 842, 842, -1, -1, 842, 842, 
	842, 842, 842, 842, -1, -1, -1, -1, 
	842, 842, 842, 842, 842, 842, 842, -1, 
	-1, -1, -1, 842, -1, -1, -1, -1, 
	842, -1, -1, -1, 842, 842, 842, -1, 
	842, 842, -1, -1, 842, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	842, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 842, 842, -1, -1, 
	-1, -1, -1, -1, -1, -1, 842, 842, 
	-1, -1, -1, -1, 842, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 842, 842, 842, -1, -1, 
	-1, -1, -1, 842, 842, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 842, 
	-1, 842, 841, 841, 841, 841, 841, 841, 
	841, 841, 841, 841, 841, 841, 841, 841, 
	841, -1, 841, 841, 841, 841, 841, 841, 
	841, 841, -1, -1, -1, 841, 841, 841, 
	841, 841, -1, 841, -1, 841, 841, 841, 
	841, -1, 841, -1, 841, 841, 841, -1, 
	-1, 841, -1, -1, 841, 841, 841, 841, 
	841, -1, 841, 841, 841, -1, -1, -1, 
	-1, 841, 841, 841, 841, 841, -1, -1, 
	841, 841, 841, 841, -1, 55, 56, 64, 
	67, 68, 65, 66, 73, 74, 1135, 69, 
	70, -1, -1, 35, 36, 40, 38, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 41, 42, 43, -1, -1, 
	-1, 75, -1, -1, -1, -1, 37, -1, 
	-1, -1, -1, -1, 72, 71, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 59, -1, -1, 82, 84, 86, 
	88, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1135, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 841, 841, 
	841, 841, 842, -1, 841, 841, 841, 841, 
	841, 841, -1, -1, -1, -1, 841, 841, 
	841, 841, 841, 841, 841, -1, -1, -1, 
	-1, 841, -1, -1, -1, -1, 841, 841, 
	-1, -1, 841, 841, 841, -1, 841, 841, 
	-1, -1, 841, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 841, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 841, 841, -1, -1, -1, -1, 
	-1, -1, -1, -1, 841, 841, -1, -1, 
	-1, -1, 841, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 841, 841, 841, -1, -1, -1, -1, 
	-1, 841, 841, -1, -1, -1, -1, -1, 
	-1, -1, -1, 299, -1, 841, -1, 841, 
	-1, -1, 841, 1135, 1135, -1, -1, 34, 
	33, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 62, -1, -1, -1, -1, 44, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 80, 76, 
	45, -1, -1, -1, -1, -1, 39, 993, 
	-1, -1, 843, 843, 843, 843, 843, 843, 
	843, 843, 843, 843, 843, 843, 843, 843, 
	843, 472, 843, 843, 843, 843, 843, 843, 
	843, 843, -1, -1, -1, 843, 843, 843, 
	843, 843, -1, 843, -1, 843, 843, 843, 
	843, -1, 843, -1, 843, 843, 843, -1, 
	-1, 843, -1, -1, 843, 843, 843, 843, 
	843, -1, 843, 843, 843, -1, -1, -1, 
	-1, 843, 843, 843, 843, 843, -1, -1, 
	843, 843, 843, 843, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	841, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 843, 843, 
	843, 843, -1, -1, 843, 843, -1, 843, 
	843, 843, -1, -1, -1, -1, 843, 843, 
	843, -1, 843, 843, 843, -1, -1, -1, 
	-1, 843, -1, -1, -1, -1, 843, 843, 
	-1, -1, 843, 843, 843, -1, 843, 843, 
	-1, -1, 843, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 843, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 843, 843, -1, -1, -1, -1, 
	-1, -1, -1, -1, 843, 843, -1, -1, 
	-1, -1, 843, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 843, 843, 843, -1, -1, -1, -1, 
	-1, 843, 843, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 843, -1, -1, 
	-1, -1, 843, -1, -1, 917, 917, 917, 
	917, 917, 917, 917, 917, 917, 917, 917, 
	917, 917, 917, 917, 917, 917, 917, 917, 
	917, 917, 917, 917, 917, 917, 917, -1, 
	917, 917, 917, 917, 917, -1, 917, -1, 
	917, 917, 917, 917, -1, 917, -1, 917, 
	917, 917, -1, -1, 917, 917, 917, 917, 
	917, 917, 917, 917, -1, 917, 917, 917, 
	-1, -1, -1, -1, 917, 917, 917, 917, 
	917, -1, -1, 917, 917, 917, 917, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 917, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	843, 917, 917, 917, 917, -1, -1, 917, 
	917, -1, 917, 917, 917, -1, -1, -1, 
	-1, 917, 917, 917, -1, 917, 917, 917, 
	-1, -1, -1, -1, 917, -1, -1, -1, 
	-1, 917, -1, -1, -1, 917, 917, 917, 
	-1, 917, 917, -1, -1, 917, -1, -1, 
	-1, -1, -1, -1, -1, -1, 917, 917, 
	917, 917, 917, 917, 917, -1, -1, -1, 
	-1, 917, 917, -1, -1, 917, 917, 299, 
	-1, -1, -1, -1, -1, -1, -1, 917, 
	917, -1, -1, 34, 33, 917, -1, -1, 
	-1, -1, -1, -1, -1, -1, 62, -1, 
	-1, -1, -1, 44, -1, -1, -1, -1, 
	-1, -1, -1, -1, 917, 917, 917, -1, 
	-1, -1, -1, -1, 917, 917, -1, -1, 
	-1, -1, 80, 76, 45, -1, -1, -1, 
	917, -1, 39, -1, -1, -1, -1, 917, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 472, 915, 915, 
	915, 915, 915, 915, 915, 915, 915, 915, 
	915, 915, 915, 915, 915, 915, 915, 915, 
	915, 915, 915, 915, 915, 915, 915, 915, 
	-1, 915, 915, 915, 915, 915, -1, 915, 
	-1, 915, 915, 915, 915, -1, 915, -1, 
	915, 915, 915, -1, -1, 915, 308, 310, 
	915, 915, 915, 915, 915, -1, 915, 915, 
	915, -1, -1, -1, -1, 915, 915, 915, 
	915, 915, -1, -1, 915, 915, 915, 915, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 915, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 917, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 915, 915, 915, 915, -1, -1, 
	915, 915, -1, 915, 915, 915, -1, -1, 
	-1, -1, 915, 915, 915, -1, 915, 915, 
	915, -1, -1, -1, -1, 915, -1, -1, 
	-1, -1, 915, -1, -1, -1, 915, 915, 
	915, -1, 915, 915, -1, -1, 915, -1, 
	-1, -1, -1, -1, -1, -1, -1, 304, 
	306, 482, 915, 915, 915, 915, -1, -1, 
	-1, -1, 915, 915, -1, -1, 915, 915, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	915, 915, -1, -1, -1, -1, 915, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 915, 915, 915, 
	-1, -1, -1, -1, -1, 915, 915, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 915, -1, -1, -1, -1, -1, -1, 
	915, 916, 916, 916, 916, 916, 916, 916, 
	916, 916, 916, 916, 916, 916, 916, 916, 
	916, 916, 916, 916, 916, 916, 916, 916, 
	916, 916, 916, -1, 916, 916, 916, 916, 
	916, -1, 916, -1, 916, 916, 916, 916, 
	-1, 916, -1, 916, 916, 916, -1, -1, 
	916, 916, 916, 916, 916, 916, 916, 916, 
	-1, 916, 916, 916, -1, -1, -1, -1, 
	916, 916, 916, 916, 916, -1, -1, 916, 
	916, 916, 916, -1, 55, 56, 64, 67, 
	68, 65, 66, 73, 74, 916, 69, 70, 
	-1, -1, 35, 36, 40, 38, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 41, 42, 43, -1, -1, -1, 
	75, -1, -1, -1, -1, 37, -1, -1, 
	-1, -1, -1, 72, 71, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 59, -1, -1, 82, 84, 86, 88, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 276, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 915, 916, 916, 916, 
	916, -1, -1, 916, 916, -1, 916, 916, 
	916, -1, -1, -1, -1, 916, 916, 916, 
	-1, 916, 916, 916, -1, -1, -1, -1, 
	916, -1, -1, -1, -1, 916, -1, -1, 
	-1, 916, 916, 916, -1, 916, 916, -1, 
	-1, 916, -1, -1, -1, -1, -1, -1, 
	-1, -1, 916, 916, 916, 916, 916, 916, 
	916, -1, -1, -1, -1, 916, 916, -1, 
	-1, 916, 916, -1, -1, -1, -1, -1, 
	-1, -1, -1, 916, 916, -1, -1, -1, 
	-1, 916, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	916, 916, 916, -1, -1, -1, -1, -1, 
	916, 916, -1, -1, -1, -1, -1, -1, 
	-1, -1, 277, -1, 916, -1, -1, -1, 
	-1, 479, -1, 916, -1, -1, 34, 33, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 62, -1, -1, -1, -1, 44, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 80, 76, 45, 
	-1, -1, -1, -1, -1, 39, 993, -1, 
	-1, -1, 861, 861, 861, 861, 861, 861, 
	861, 861, 861, 861, 861, 861, 861, 861, 
	861, -1, 861, 861, 861, 861, 861, 861, 
	861, 861, -1, -1, -1, 861, 861, 861, 
	861, 861, -1, 861, -1, 861, 861, 861, 
	861, -1, 861, -1, 861, 861, 861, -1, 
	-1, 861, -1, -1, 861, 861, 861, 861, 
	861, -1, 861, 861, 861, 861, -1, -1, 
	-1, 861, 861, 861, 861, 861, -1, 861, 
	861, 861, 861, 861, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 916, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 303, 305, 481, 861, 861, 
	861, 861, -1, -1, 861, 861, 861, 861, 
	861, 861, -1, -1, -1, -1, 861, 861, 
	861, 861, 861, 861, 861, -1, 861, 861, 
	-1, 861, -1, -1, -1, -1, 861, 861, 
	-1, -1, 861, 861, 861, -1, 861, 861, 
	-1, -1, 861, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 861, -1, 
	-1, -1, -1, 794, 794, 794, 794, 794, 
	794, -1, 861, 861, -1, -1, -1, -1, 
	-1, -1, -1, -1, 861, 861, -1, -1, 
	-1, -1, 861, -1, -1, -1, 794, 794, 
	794, 794, 794, -1, 794, -1, 794, -1, 
	-1, -1, -1, 794, -1, -1, 794, -1, 
	-1, 861, 861, 861, -1, 794, 794, 794, 
	-1, 861, 861, 794, 794, 794, -1, -1, 
	-1, -1, 794, 794, 794, 861, 794, 861, 
	-1, -1, 861, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 867, 867, 
	867, 867, 867, 867, 867, 867, 867, 867, 
	867, 867, 867, 867, 867, -1, 867, 867, 
	867, 867, 867, 867, 867, 867, -1, -1, 
	-1, 867, 867, 867, 867, 867, -1, 867, 
	-1, 867, 867, 867, 867, -1, 867, -1, 
	867, 867, 867, -1, -1, 867, -1, -1, 
	867, 867, 867, 867, 867, -1, 867, 867, 
	867, 867, -1, -1, -1, 867, 867, 867, 
	867, 867, -1, 867, 867, 867, 867, 867, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 794, 794, -1, -1, 794, 794, 794, 
	794, -1, 794, 486, -1, -1, -1, 794, 
	794, 794, 794, 794, 794, 794, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 794, 794, 794, -1, 794, 
	794, -1, -1, 794, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 794, -1, -1, -1, -1, 
	861, -1, -1, -1, -1, 794, 794, -1, 
	-1, -1, 867, 867, 867, 867, -1, -1, 
	867, 867, 867, 867, 867, 867, -1, -1, 
	-1, -1, 867, 867, 867, 867, 867, 867, 
	867, -1, 867, 867, 485, 867, -1, -1, 
	-1, -1, 867, 867, -1, -1, 867, 867, 
	867, -1, 867, 867, -1, -1, 867, -1, 
	794, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 867, -1, -1, -1, 277, -1, 
	-1, -1, -1, -1, -1, 479, 867, 867, 
	-1, -1, 34, 33, -1, -1, -1, -1, 
	867, 867, -1, -1, -1, 62, 867, -1, 
	-1, -1, 44, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 867, 867, 867, 
	-1, 80, 76, 45, -1, 867, 867, -1, 
	-1, 39, -1, -1, -1, -1, -1, -1, 
	-1, 867, -1, 867, -1, -1, 867, -1, 
	-1, 942, 942, 942, 942, 942, 942, 942, 
	942, 942, 942, 942, 942, 942, 942, 942, 
	942, 942, 942, 942, 942, 942, 942, 942, 
	942, 942, 942, -1, 942, 942, 942, 942, 
	942, -1, 942, -1, 942, 942, 942, 942, 
	942, 942, -1, 942, 942, 942, -1, -1, 
	942, 942, 942, 942, 942, 942, 942, 942, 
	-1, 942, 942, 942, 942, -1, -1, -1, 
	942, 942, 942, 942, 942, -1, -1, 942, 
	942, 942, 942, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 942, -1, -1, 
	942, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 942, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 867, 942, 942, 942, 
	942, -1, -1, 942, 942, 942, 942, 942, 
	942, -1, -1, -1, -1, 942, 942, 942, 
	942, 942, 942, 942, -1, -1, 942, -1, 
	942, -1, -1, -1, -1, 942, 942, -1, 
	942, 942, 942, 942, -1, 942, 942, -1, 
	-1, 942, -1, -1, -1, -1, -1, 942, 
	-1, 942, 942, 942, 942, 942, 942, 942, 
	942, -1, -1, -1, -1, 942, 942, -1, 
	942, 942, 942, -1, -1, -1, -1, -1, 
	-1, -1, -1, 942, 942, -1, -1, -1, 
	-1, 942, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	942, 942, 942, -1, -1, -1, -1, -1, 
	942, 942, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 942, -1, 942, -1, 
	-1, 942, 942, 942, 1061, 1061, 1061, 1061, 
	1061, 1061, 1061, 1061, 1061, 1061, 1061, 1061, 
	1061, 1061, 1061, 1061, 1061, 1061, 1061, 1061, 
	1061, 1061, 1061, 1061, 1061, 1061, -1, 1061, 
	1061, 1061, 1061, 1061, -1, 1061, -1, 1061, 
	1061, 1061, 1061, -1, 1061, -1, 1061, 1061, 
	1061, 1061, 1061, 1061, 1061, 1061, 1061, 1061, 
	1061, 1061, 1061, 1061, 1061, 1061, 1061, -1, 
	1061, 1061, 1061, 1061, 1061, 1061, 1061, 1061, 
	1061, 1061, 1061, 1061, 1061, 1061, 1061, -1, 
	1061, -1, -1, 1061, -1, 1061, 1061, 1061, 
	1061, 1061, -1, -1, 1061, 1061, 1061, 1061, 
	1061, 1061, 1061, 1061, 1061, 1061, 1061, 1061, 
	1061, 1061, 1061, 1061, -1, -1, -1, -1, 
	-1, 1061, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 942, 
	1061, 1061, 1061, 1061, -1, -1, 1061, 1061, 
	1061, 1061, 1061, 1061, -1, -1, -1, -1, 
	1061, 1061, 1061, 1061, 1061, 1061, 1061, -1, 
	485, -1, -1, 1061, -1, -1, -1, -1, 
	1061, 1061, -1, -1, 1061, 1061, 1061, -1, 
	1061, 1061, -1, -1, 1061, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1061, 1061, 1061, 
	1061, 1061, 1061, 1061, -1, -1, -1, 1061, 
	1061, 1061, -1, -1, 1061, 1061, -1, 1061, 
	1061, 1061, 1061, 1061, 1061, 1061, 1061, 1061, 
	-1, -1, -1, 1061, 1061, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1061, 
	1061, 1061, -1, -1, 1061, -1, -1, -1, 
	-1, 1061, -1, 1061, 1061, 1061, 1061, -1, 
	1061, 1061, 1061, 1061, 1061, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1061, 
	-1, 1061, -1, -1, 1061, -1, 1061, 1061, 
	-1, -1, -1, 1061, -1, 1061, -1, 1061, 
	1017, 1017, 1017, 1017, 1017, 1017, 1017, 1017, 
	1017, 1017, 1017, 1017, 1017, 1017, 1017, 1017, 
	1017, 1017, 1017, 1017, 1017, 1017, 1017, 1017, 
	1017, 1017, -1, 1017, 1017, 1017, 1017, 1017, 
	-1, 1017, -1, 1017, 1017, 1017, 1017, -1, 
	1017, -1, 1017, 1017, 1017, 1017, 1017, 1017, 
	1017, 1017, 1017, 1017, 1017, 1017, 1017, 1017, 
	1017, 1017, 1017, -1, 1017, 1017, 1017, 1017, 
	1017, 1017, 1017, 1017, 1017, 1017, 1017, 1017, 
	1017, 1017, 1017, -1, 1017, -1, -1, 1017, 
	-1, 1017, 1017, 1017, 1017, 1017, -1, -1, 
	1017, 1017, 1017, 1017, 1017, 1017, 1017, 1017, 
	1017, 1017, 1017, 1017, 1017, 1017, 1017, 1017, 
	-1, -1, -1, -1, -1, 1017, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1061, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1017, 1017, 1017, 1017, 
	-1, -1, 1017, 1017, 1017, 1017, 1017, 1017, 
	-1, -1, -1, -1, 1017, 1017, 1017, 1017, 
	1017, 1017, 1017, -1, -1, -1, -1, 1017, 
	-1, -1, -1, -1, 1017, 1017, -1, -1, 
	1017, 1017, 1017, -1, 1017, 1017, -1, -1, 
	1017, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1017, 1017, 1017, 1017, 1017, 1017, 1017, 
	-1, -1, -1, 1017, 1017, 1017, 1017, -1, 
	1017, 1017, -1, 1017, 1017, 1017, 1017, 1017, 
	1017, 1017, 1017, 1017, -1, -1, -1, 1017, 
	1017, 1017, -1, -1, -1, 1017, 1017, -1, 
	-1, -1, -1, 1017, 1017, 1017, -1, -1, 
	1017, -1, -1, -1, -1, 1017, -1, 1017, 
	1017, 1017, 1017, -1, 1017, 1017, 1017, 1017, 
	1017, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1017, -1, 1017, -1, -1, 
	1017, -1, 1017, 1017, -1, 1017, -1, 1017, 
	-1, 1017, -1, 1017, 1018, 1018, 1018, 1018, 
	1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 
	1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 
	1018, 1018, 1018, 1018, 1018, 1018, -1, 1018, 
	1018, 1018, 1018, 1018, -1, 1018, -1, 1018, 
	1018, 1018, 1018, -1, 1018, -1, 1018, 1018, 
	1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 
	1018, 1018, 1018, 1018, 1018, 1018, 1018, -1, 
	1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 
	1018, 1018, 1018, 1018, 1018, 1018, 1018, -1, 
	1018, -1, -1, 1018, -1, 1018, 1018, 1018, 
	1018, 1018, -1, -1, 1018, 1018, 1018, 1018, 
	1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 
	1018, 1018, 1018, 1018, -1, -1, -1, -1, 
	-1, 1018, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1017, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1018, 1018, 1018, 1018, -1, -1, 1018, 1018, 
	1018, 1018, 1018, 1018, -1, -1, -1, -1, 
	1018, 1018, 1018, 1018, 1018, 1018, 1018, -1, 
	-1, -1, -1, 1018, -1, -1, -1, -1, 
	1018, 1018, -1, -1, 1018, 1018, 1018, -1, 
	1018, 1018, -1, -1, 1018, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1018, 1018, 1018, 
	1018, 1018, 1018, 1018, -1, -1, -1, 1018, 
	1018, 1018, 1018, -1, 1018, 1018, -1, 1018, 
	1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 
	-1, -1, -1, 1018, 1018, 1018, -1, -1, 
	-1, 1018, 1018, -1, -1, -1, -1, 1018, 
	1018, 1018, -1, -1, 1018, -1, -1, -1, 
	-1, 1018, -1, 1018, 1018, 1018, 1018, -1, 
	1018, 1018, 1018, 1018, 1018, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1018, 
	-1, 1018, -1, -1, 1018, -1, 1018, 1018, 
	-1, 1018, -1, 1018, -1, 1018, -1, 1018, 
	1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 
	1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 
	1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 
	1062, 1062, -1, 1062, 1062, 1062, 1062, 1062, 
	-1, 1062, -1, 1062, 1062, 1062, 1062, -1, 
	1062, -1, 1062, 1062, 1062, 1062, 1062, 1062, 
	1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 
	1062, 1062, 1062, -1, 1062, 1062, 1062, 1062, 
	1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 
	1062, 1062, 1062, -1, 1062, -1, -1, 1062, 
	-1, 1062, 1062, 1062, 1062, 1062, -1, -1, 
	1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 
	1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 
	-1, -1, -1, -1, -1, 1062, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1018, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1062, 1062, 1062, 1062, 
	-1, -1, 1062, 1062, 1062, 1062, 1062, 1062, 
	-1, -1, -1, -1, 1062, 1062, 1062, 1062, 
	1062, 1062, 1062, -1, -1, -1, -1, 1062, 
	-1, -1, -1, -1, 1062, 1062, -1, -1, 
	1062, 1062, 1062, -1, 1062, 1062, -1, -1, 
	1062, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 
	-1, -1, -1, 1062, 1062, 1062, -1, -1, 
	1062, 1062, -1, 1062, 1062, 1062, 1062, 1062, 
	1062, 1062, 1062, 1062, -1, -1, -1, 1062, 
	1062, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1062, 1062, 1062, -1, -1, 
	1062, -1, -1, -1, -1, 1062, -1, 1062, 
	1062, 1062, 1062, -1, 1062, 1062, 1062, 1062, 
	1062, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1062, -1, 1062, -1, -1, 
	1062, -1, 1062, 1062, -1, -1, -1, 1062, 
	-1, 1062, -1, 1062, 1019, 1019, 1019, 1019, 
	1019, 1019, 1019, 1019, 1019, 1019, 1019, 1019, 
	1019, 1019, 1019, 1019, 1019, 1019, 1019, 1019, 
	1019, 1019, 1019, 1019, 1019, 1019, -1, 1019, 
	1019, 1019, 1019, 1019, -1, 1019, -1, 1019, 
	1019, 1019, 1019, -1, 1019, -1, 1019, 1019, 
	1019, 1019, 1019, 1019, 1019, 1019, 1019, 1019, 
	1019, 1019, 1019, 1019, 1019, 1019, 1019, -1, 
	1019, 1019, 1019, 1019, 1019, 1019, 1019, 1019, 
	1019, 1019, 1019, 1019, 1019, 1019, 1019, -1, 
	1019, -1, -1, 1019, -1, 1019, 1019, 1019, 
	1019, 1019, -1, -1, 1019, 1019, 1019, 1019, 
	1019, 1019, 1019, 1019, 1019, 1019, 1019, 1019, 
	1019, 1019, 1019, 1019, -1, -1, -1, -1, 
	-1, 1019, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1062, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1019, 1019, 1019, 1019, -1, -1, 1019, 1019, 
	1019, 1019, 1019, 1019, -1, -1, -1, -1, 
	1019, 1019, 1019, 1019, 1019, 1019, 1019, -1, 
	-1, -1, -1, 1019, -1, -1, -1, -1, 
	1019, 1019, -1, -1, 1019, 1019, 1019, -1, 
	1019, 1019, -1, -1, 1019, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1019, 1019, 1019, 
	1019, 1019, 1019, 1019, -1, -1, -1, 1019, 
	1019, 1019, 1019, -1, 1019, 1019, -1, 1019, 
	1019, 1019, 1019, 1019, 1019, 1019, 1019, 1019, 
	-1, -1, -1, 1019, 1019, 1019, -1, -1, 
	-1, 1019, 1019, -1, -1, -1, -1, 1019, 
	1019, 1019, -1, -1, 1019, -1, -1, -1, 
	-1, 1019, -1, 1019, 1019, 1019, 1019, -1, 
	1019, 1019, 1019, 1019, 1019, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1019, 
	-1, 1019, -1, -1, 1019, -1, 1019, 1019, 
	-1, 1019, -1, 1019, -1, 1019, -1, 1019, 
	1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 
	1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 
	1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 
	1020, 1020, -1, 1020, 1020, 1020, 1020, 1020, 
	-1, 1020, -1, 1020, 1020, 1020, 1020, -1, 
	1020, -1, 1020, 1020, 1020, 1020, 1020, 1020, 
	1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 
	1020, 1020, 1020, -1, 1020, 1020, 1020, 1020, 
	1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 
	1020, 1020, 1020, -1, 1020, -1, -1, 1020, 
	-1, 1020, 1020, 1020, 1020, 1020, -1, -1, 
	1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 
	1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 
	-1, -1, -1, -1, -1, 1020, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1019, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1020, 1020, 1020, 1020, 
	-1, -1, 1020, 1020, 1020, 1020, 1020, 1020, 
	-1, -1, -1, -1, 1020, 1020, 1020, 1020, 
	1020, 1020, 1020, -1, -1, -1, -1, 1020, 
	-1, -1, -1, -1, 1020, 1020, -1, -1, 
	1020, 1020, 1020, -1, 1020, 1020, -1, -1, 
	1020, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 
	-1, -1, -1, 1020, 1020, 1020, 1020, -1, 
	1020, 1020, -1, 1020, 1020, 1020, 1020, 1020, 
	1020, 1020, 1020, 1020, -1, -1, -1, 1020, 
	1020, 1020, -1, -1, -1, 1020, 1020, -1, 
	-1, -1, -1, 1020, 1020, 1020, -1, -1, 
	1020, -1, -1, -1, -1, 1020, -1, 1020, 
	1020, 1020, 1020, -1, 1020, 1020, 1020, 1020, 
	1020, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1020, -1, 1020, -1, -1, 
	1020, -1, 1020, 1020, -1, 1020, -1, 1020, 
	-1, 1020, -1, 1020, 1063, 1063, 1063, 1063, 
	1063, 1063, 1063, 1063, 1063, 1063, 1063, 1063, 
	1063, 1063, 1063, 1063, 1063, 1063, 1063, 1063, 
	1063, 1063, 1063, 1063, 1063, 1063, -1, 1063, 
	1063, 1063, 1063, 1063, -1, 1063, -1, 1063, 
	1063, 1063, 1063, -1, 1063, -1, 1063, 1063, 
	1063, 1063, 1063, 1063, 1063, 1063, 1063, 1063, 
	1063, 1063, 1063, 1063, 1063, 1063, 1063, -1, 
	1063, 1063, 1063, 1063, 1063, 1063, 1063, 1063, 
	1063, 1063, 1063, 1063, 1063, 1063, 1063, -1, 
	1063, -1, -1, 1063, -1, 1063, 1063, 1063, 
	1063, 1063, -1, -1, 1063, 1063, 1063, 1063, 
	1063, 1063, 1063, 1063, 1063, 1063, 1063, 1063, 
	1063, 1063, 1063, 1063, -1, -1, -1, -1, 
	-1, 1063, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1020, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1063, 1063, 1063, 1063, -1, -1, 1063, 1063, 
	1063, 1063, 1063, 1063, -1, -1, -1, -1, 
	1063, 1063, 1063, 1063, 1063, 1063, 1063, -1, 
	-1, -1, -1, 1063, -1, -1, -1, -1, 
	1063, 1063, -1, -1, 1063, 1063, 1063, -1, 
	1063, 1063, -1, -1, 1063, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1063, 1063, 1063, 
	1063, 1063, 1063, 1063, -1, -1, -1, 1063, 
	1063, 1063, -1, -1, 1063, 1063, -1, 1063, 
	1063, 1063, 1063, 1063, 1063, 1063, 1063, 1063, 
	-1, -1, -1, 1063, 1063, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1063, 
	1063, 1063, -1, -1, 1063, -1, -1, -1, 
	-1, 1063, -1, 1063, 1063, 1063, 1063, -1, 
	1063, 1063, 1063, 1063, 1063, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1063, 
	-1, 1063, -1, -1, 1063, -1, 1063, 1063, 
	-1, -1, -1, 1063, -1, 1063, -1, 1063, 
	64, 67, 68, 65, 66, 73, 74, -1, 
	69, 70, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 138, 139, 141, 140, 142, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 75, -1, -1, -1, 131, -1, 
	-1, -1, 135, 136, 137, 72, 71, 130, 
	-1, -1, -1, -1, 124, 125, 126, -1, 
	-1, -1, -1, 993, 122, -1, 144, 145, 
	146, 147, -1, -1, -1, -1, -1, -1, 
	-1, 127, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 117, 
	118, 119, -1, 120, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 
	1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 
	1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 
	1064, 1064, 1064, -1, 1064, 1064, 1064, 1064, 
	1064, -1, 1064, -1, 1064, 1064, 1064, 1064, 
	-1, 1064, 1063, 1064, 1064, 1064, 1064, 1064, 
	1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 
	1064, 1064, 1064, 1064, -1, 1064, 1064, 1064, 
	1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 
	1064, 1064, 1064, 1064, -1, 1064, -1, -1, 
	1064, -1, 1064, 1064, 1064, 1064, 1064, -1, 
	-1, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 
	1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 
	1064, -1, -1, -1, -1, -1, 1064, -1, 
	-1, -1, -1, 492, 113, 114, 115, 116, 
	-1, 121, 129, 133, -1, -1, -1, -1, 
	132, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 143, 134, 128, 123, 
	993, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1064, 1064, 1064, 
	1064, -1, -1, 1064, 1064, 1064, 1064, 1064, 
	1064, -1, -1, -1, -1, 1064, 1064, 1064, 
	1064, 1064, 1064, 1064, -1, -1, -1, -1, 
	1064, -1, -1, -1, -1, 1064, 1064, -1, 
	-1, 1064, 1064, 1064, -1, 1064, 1064, -1, 
	-1, 1064, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1064, 1064, 1064, 1064, 1064, 1064, 
	1064, -1, -1, -1, 1064, 1064, 1064, -1, 
	-1, 1064, 1064, -1, 1064, 1064, 1064, 1064, 
	1064, 1064, 1064, 1064, 1064, -1, -1, -1, 
	1064, 1064, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1064, 1064, 1064, -1, 
	-1, 1064, -1, -1, -1, -1, 1064, -1, 
	1064, 1064, 1064, 1064, -1, 1064, 1064, 1064, 
	1064, 1064, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1064, -1, 1064, -1, 
	-1, 1064, -1, 1064, 1064, -1, -1, -1, 
	1064, -1, 1064, -1, 1064, 838, 838, 838, 
	838, 838, 838, 838, 838, 838, 838, 838, 
	838, 838, 838, 838, -1, 838, 838, 838, 
	838, 838, 838, 838, 838, -1, -1, -1, 
	838, 838, 838, 838, 838, -1, 838, -1, 
	838, 838, 838, 838, -1, 838, -1, 838, 
	838, 838, -1, -1, 838, -1, -1, 838, 
	838, 838, 838, 838, -1, 838, 838, 838, 
	-1, -1, -1, -1, 838, 838, 838, 838, 
	838, -1, -1, 838, 838, 838, 838, -1, 
	-1, -1, -1, 359, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 838, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1064, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 838, 838, 838, 838, -1, -1, 838, 
	838, 838, 838, 838, 838, -1, -1, -1, 
	-1, 838, 838, 838, 838, 838, 838, 838, 
	-1, -1, -1, -1, 838, -1, -1, -1, 
	-1, 838, 838, -1, -1, 838, 838, 838, 
	-1, 838, 838, -1, -1, 838, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 838, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 838, 838, -1, 
	-1, -1, -1, -1, -1, -1, -1, 838, 
	838, -1, -1, -1, -1, 838, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 838, 838, 838, -1, 
	-1, -1, -1, -1, 838, 838, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	838, -1, 838, -1, -1, 838, -1, -1, 
	839, 839, 839, 839, 839, 839, 839, 839, 
	839, 839, 839, 839, 839, 839, 839, -1, 
	839, 839, 839, 839, 839, 839, 839, 839, 
	-1, -1, -1, 839, 839, 839, 839, 839, 
	-1, 839, -1, 839, 839, 839, 839, -1, 
	839, -1, 839, 839, 839, -1, -1, 839, 
	-1, -1, 839, 839, 839, 839, 839, -1, 
	839, 839, 839, -1, -1, -1, -1, 839, 
	839, 839, 839, 839, -1, -1, 839, 839, 
	839, 839, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 839, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 492, 
	113, 114, 115, 116, -1, 121, 129, 133, 
	-1, -1, -1, -1, 132, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	143, 134, 128, 123, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 838, 839, 839, 839, 839, 
	-1, -1, 839, 839, 839, 839, 839, 839, 
	-1, -1, -1, -1, 839, 839, 839, 839, 
	839, 839, 839, -1, -1, -1, -1, 839, 
	-1, -1, -1, -1, 839, 839, -1, -1, 
	839, 839, 839, -1, 839, 839, -1, -1, 
	839, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 839, -1, -1, -1, 
	-1, 27, 28, 1125, 25, 23, 26, -1, 
	839, 839, -1, -1, -1, -1, -1, -1, 
	-1, -1, 839, 839, -1, -1, -1, -1, 
	839, -1, -1, -1, 853, 853, 853, 853, 
	853, -1, 32, -1, 47, -1, -1, -1, 
	-1, 50, -1, -1, 48, -1, -1, 839, 
	839, 839, -1, 853, 853, 853, -1, 839, 
	839, 24, 54, 53, -1, -1, -1, -1, 
	77, 78, 79, 839, 58, 839, -1, -1, 
	839, -1, -1, 795, 795, 795, 795, 795, 
	795, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 795, 795, 
	795, 795, 795, -1, 795, -1, 795, -1, 
	-1, -1, -1, 795, -1, -1, 795, -1, 
	-1, -1, -1, -1, -1, 795, 795, 795, 
	-1, -1, -1, 795, 795, 795, -1, -1, 
	-1, -1, 795, 795, 795, -1, 795, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 355, 
	49, -1, -1, 354, 356, 340, 353, -1, 
	352, -1, -1, -1, -1, 31, 350, 351, 
	341, 29, 349, 342, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 347, 348, 343, -1, 344, 345, -1, 
	-1, 346, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 357, -1, -1, -1, -1, 839, -1, 
	-1, 795, 795, 853, 853, 795, 795, 795, 
	795, -1, 795, -1, -1, -1, -1, 795, 
	795, 795, 795, 795, 795, 795, -1, -1, 
	-1, -1, -1, -1, -1, 796, 796, 796, 
	796, 796, 796, 795, 795, 795, -1, 795, 
	795, -1, -1, 795, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 495, -1, 
	796, 796, 796, 796, 796, -1, 796, -1, 
	796, -1, -1, 795, -1, 796, -1, -1, 
	796, -1, -1, -1, -1, 795, 795, 796, 
	796, 796, -1, -1, -1, 796, 796, 796, 
	-1, -1, -1, -1, 796, 796, 796, -1, 
	796, -1, -1, -1, -1, -1, -1, 797, 
	797, 797, 797, 797, 797, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	795, -1, 797, 797, 797, 797, 797, -1, 
	797, -1, 797, -1, -1, -1, -1, 797, 
	-1, -1, 797, -1, -1, -1, -1, -1, 
	-1, 797, 797, 797, -1, -1, -1, 797, 
	797, 797, -1, -1, -1, -1, 797, 797, 
	797, -1, 797, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 796, 796, -1, -1, 796, 
	796, 796, 796, -1, 796, -1, -1, -1, 
	-1, 796, 796, 796, 796, 796, 796, 796, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 796, 796, 796, 
	-1, 796, 796, -1, -1, 796, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 796, -1, -1, 
	-1, -1, -1, -1, -1, 797, 797, 796, 
	796, 797, 797, 797, 797, -1, 797, -1, 
	-1, -1, -1, 797, 797, 797, 797, 797, 
	797, 797, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 797, 
	797, 797, -1, 797, 797, -1, -1, 797, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 796, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 797, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 797, 797, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 797, 798, 798, 798, 
	798, 798, 798, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	798, 798, 798, 798, 798, -1, 798, -1, 
	798, -1, -1, -1, -1, 798, -1, -1, 
	798, 799, 799, 799, 799, 799, 799, 798, 
	798, 798, -1, -1, -1, 798, 798, 798, 
	-1, -1, -1, -1, 798, 798, 798, -1, 
	798, -1, -1, -1, 799, 799, 799, 799, 
	799, -1, 799, -1, 799, -1, -1, -1, 
	-1, 799, -1, -1, 799, -1, -1, -1, 
	-1, -1, -1, 799, 799, 799, -1, -1, 
	-1, 799, 799, 799, -1, -1, -1, -1, 
	799, 799, 799, -1, 799, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 355, 49, -1, -1, 354, 
	356, 340, 353, -1, 352, -1, -1, -1, 
	-1, 31, 350, 351, 341, 29, 349, 342, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 347, 348, 343, 
	-1, 344, 345, 798, 798, 346, -1, 798, 
	798, 798, 798, -1, 798, -1, -1, -1, 
	-1, 798, 798, 798, 798, 798, 798, 798, 
	-1, -1, -1, -1, -1, 357, -1, -1, 
	-1, -1, -1, -1, -1, 798, 798, 798, 
	-1, 798, 798, -1, -1, 798, -1, 799, 
	799, -1, -1, 799, 799, 799, 799, -1, 
	799, -1, -1, -1, -1, 799, 799, 799, 
	799, 799, 799, 799, -1, 798, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 798, 
	798, 799, 799, 799, -1, 799, 799, -1, 
	-1, 799, 495, -1, -1, -1, -1, -1, 
	-1, -1, 800, 800, 800, 800, 800, 800, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 799, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 799, 799, 800, 800, 800, 
	800, 800, 798, 800, -1, 800, -1, -1, 
	-1, -1, 800, -1, -1, 800, 801, 801, 
	801, 801, 801, 801, 800, 800, 800, -1, 
	-1, -1, 800, 800, 800, -1, -1, -1, 
	-1, 800, 800, 800, -1, 800, -1, -1, 
	-1, 801, 801, 801, 801, 801, 799, 801, 
	-1, 801, -1, -1, -1, -1, 801, -1, 
	-1, 801, -1, -1, -1, -1, -1, -1, 
	801, 801, 801, -1, -1, -1, 801, 801, 
	801, -1, -1, -1, -1, 801, 801, 801, 
	-1, 801, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	800, 800, -1, -1, 800, 800, 800, 800, 
	-1, 800, -1, -1, -1, -1, 800, 800, 
	800, 800, 800, 800, 800, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 800, 800, 800, -1, 800, 800, 
	-1, -1, 800, -1, 801, 801, -1, -1, 
	801, 801, 801, 801, -1, 801, -1, -1, 
	-1, -1, 801, 801, 801, 801, 801, 801, 
	801, -1, 800, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 800, 800, 801, 801, 
	801, -1, 801, 801, -1, -1, 801, -1, 
	-1, -1, -1, -1, -1, -1, -1, 802, 
	802, 802, 802, 802, 802, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 801, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	801, 801, 802, 802, 802, 802, 802, 800, 
	802, -1, 802, -1, -1, -1, -1, 802, 
	-1, -1, 802, 803, 803, 803, 803, 803, 
	803, 802, 802, 802, -1, -1, -1, 802, 
	802, 802, -1, -1, -1, -1, 802, 802, 
	802, -1, 802, -1, -1, -1, 803, 803, 
	803, 803, 803, 801, 803, -1, 803, -1, 
	-1, -1, -1, 803, -1, -1, 803, -1, 
	-1, -1, -1, -1, -1, 803, 803, 803, 
	-1, -1, -1, 803, 803, 803, -1, -1, 
	-1, -1, 803, 803, 803, -1, 803, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 802, 802, -1, 
	-1, 802, 802, 802, 802, -1, 802, -1, 
	-1, -1, -1, 802, 802, 802, 802, 802, 
	802, 802, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 802, 
	802, 802, -1, 802, 802, -1, -1, 802, 
	-1, 803, 803, -1, -1, 803, 803, 803, 
	803, -1, 803, -1, -1, -1, -1, 803, 
	803, 803, 803, 803, 803, 803, -1, 802, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 802, 802, 803, 803, 803, -1, 803, 
	803, -1, -1, 803, -1, -1, -1, -1, 
	-1, -1, -1, -1, 804, 804, 804, 804, 
	804, 804, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 803, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 803, 803, 804, 
	804, 804, 804, 804, 802, 804, -1, 804, 
	-1, -1, -1, -1, 804, -1, -1, 804, 
	805, 805, 805, 805, 805, 805, 804, 804, 
	804, -1, -1, -1, 804, 804, 804, -1, 
	-1, -1, -1, 804, 804, 804, -1, 804, 
	-1, -1, -1, 805, 805, 805, 805, 805, 
	803, 805, -1, 805, -1, -1, -1, -1, 
	805, -1, -1, 805, -1, -1, -1, -1, 
	-1, -1, 805, 805, 805, -1, -1, -1, 
	805, 805, 805, -1, -1, -1, -1, 805, 
	805, 805, -1, 805, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 804, 804, -1, -1, 804, 804, 
	804, 804, -1, 804, -1, -1, -1, -1, 
	804, 804, 804, 804, 804, 804, 804, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 804, 804, 804, -1, 
	804, 804, -1, -1, 804, -1, 805, 805, 
	-1, -1, 805, 805, 805, 805, -1, 805, 
	-1, -1, -1, -1, 805, 805, 805, 805, 
	805, 805, 805, -1, 804, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 804, 804, 
	805, 805, 805, -1, 805, 805, -1, -1, 
	805, -1, -1, -1, -1, -1, -1, -1, 
	-1, 806, 806, 806, 806, 806, 806, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	805, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 805, 805, 806, 806, 806, 806, 
	806, 804, 806, -1, 806, -1, -1, -1, 
	-1, 806, -1, -1, 806, 856, 856, 856, 
	856, 856, 856, 806, 806, 806, -1, -1, 
	-1, 806, 806, 806, -1, -1, -1, -1, 
	806, 806, 806, -1, 806, -1, -1, -1, 
	856, 856, 856, 856, 856, 805, 856, -1, 
	856, -1, -1, -1, -1, 856, -1, -1, 
	856, -1, -1, -1, -1, -1, -1, 856, 
	856, 856, -1, -1, -1, 856, 856, 856, 
	-1, -1, -1, -1, 856, 856, 856, -1, 
	856, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 806, 
	806, -1, -1, 806, 806, 806, 806, -1, 
	806, -1, -1, -1, -1, 806, 806, 806, 
	806, 806, 806, 806, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 806, 806, 806, -1, 806, 806, -1, 
	-1, 806, -1, 856, 856, -1, -1, 856, 
	856, 856, 856, -1, 856, -1, -1, -1, 
	-1, 856, 856, 856, 856, 856, 856, 856, 
	-1, 806, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 806, 806, 856, 856, 856, 
	-1, 856, 856, -1, -1, 856, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 856, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 856, 
	856, -1, -1, -1, -1, -1, 806, -1, 
	-1, 940, 940, 940, 940, 940, 940, 940, 
	940, 940, 940, 940, 940, 940, 940, 940, 
	940, 940, 940, 940, 940, 940, 940, 940, 
	940, 940, 940, -1, 940, 940, 940, 940, 
	940, -1, 940, -1, 940, 940, 940, 940, 
	-1, 940, 856, 940, 940, 940, -1, -1, 
	940, 940, 940, 940, 940, 940, 940, 940, 
	-1, 940, 940, 940, -1, -1, -1, -1, 
	940, 940, 940, 940, 940, -1, -1, 940, 
	940, 940, 940, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 940, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 274, 
	275, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 940, 940, 940, 
	940, -1, -1, 940, 940, 940, 940, 940, 
	940, -1, -1, -1, -1, 940, 940, 940, 
	940, 940, 940, 940, -1, -1, -1, -1, 
	940, -1, -1, -1, -1, 940, 940, -1, 
	-1, 940, 940, 940, -1, 940, 940, -1, 
	-1, 940, -1, -1, -1, -1, -1, -1, 
	-1, -1, 940, 940, 940, 940, 940, 940, 
	940, -1, -1, -1, -1, 940, 940, -1, 
	-1, 940, 940, -1, -1, -1, -1, -1, 
	-1, -1, -1, 940, 940, -1, -1, -1, 
	-1, 940, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	940, 940, 940, -1, -1, -1, -1, -1, 
	940, 940, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 940, -1, 940, -1, 
	-1, 940, -1, 940, 1080, 1080, 1080, 1080, 
	1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 
	1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 
	1080, 1080, 1080, 1080, 1080, 1080, -1, 1080, 
	1080, 1080, 1080, 1080, -1, 1080, -1, 1080, 
	1080, 1080, 1080, -1, 1080, -1, 1080, 1080, 
	1080, -1, 1080, 1080, 1080, 1080, 1080, 1080, 
	1080, 1080, 1080, 1080, 1080, 1080, 1080, -1, 
	1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 
	1080, 1080, 1080, 1080, 1080, 1080, 1080, -1, 
	1080, -1, -1, 497, 498, 1080, 1080, 1080, 
	1080, 1080, -1, 1080, 1080, 1080, 1080, 1080, 
	1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 
	1080, 1080, 1080, 1080, -1, -1, -1, -1, 
	-1, 1080, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 940, 
	1080, 1080, 1080, 1080, -1, -1, 1080, 1080, 
	1080, 1080, 1080, 1080, -1, -1, -1, -1, 
	1080, 1080, 1080, 1080, 1080, 1080, 1080, -1, 
	-1, -1, -1, 1080, -1, -1, -1, -1, 
	1080, 1080, -1, -1, 1080, 1080, 1080, -1, 
	1080, 1080, -1, -1, 1080, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1080, 1080, 1080, 
	1080, 1080, 1080, 1080, -1, -1, -1, 1080, 
	1080, 1080, -1, -1, 1080, 1080, -1, 1080, 
	1080, 1080, 1080, 1080, -1, 1080, 1080, 1080, 
	-1, -1, -1, 1080, 1080, -1, -1, -1, 
	-1, -1, -1, -1, 1080, 1080, 1080, 1080, 
	1080, 1080, -1, -1, 1080, -1, -1, -1, 
	-1, 1080, -1, 1080, 1080, 1080, 1080, -1, 
	1080, 1080, 1080, 1080, 1080, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1080, 
	-1, 1080, -1, -1, 1080, -1, 1080, 1080, 
	-1, -1, -1, 1080, -1, 1080, -1, 1080, 
	766, 766, 766, 766, 766, 766, 766, 766, 
	766, 766, 766, 766, 766, 766, 766, 766, 
	766, 766, 766, 766, 766, 766, 766, 766, 
	766, 766, -1, 766, 766, 766, 766, 766, 
	-1, 766, -1, 766, 766, 766, 766, -1, 
	766, -1, 766, 766, 766, -1, -1, 766, 
	766, 766, 766, 766, 766, 766, 766, -1, 
	766, 766, 766, -1, -1, -1, -1, 766, 
	766, 766, 766, 766, -1, -1, 766, 766, 
	766, 766, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 766, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 274, 275, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1080, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 766, 766, 766, 766, 
	-1, -1, 766, 766, -1, 766, 766, 766, 
	-1, -1, -1, -1, 766, 766, 766, -1, 
	766, 766, 766, -1, -1, -1, -1, 766, 
	-1, -1, -1, -1, 766, -1, -1, -1, 
	766, 766, 766, -1, 766, 766, -1, -1, 
	766, -1, -1, -1, -1, -1, -1, -1, 
	-1, 766, 766, 766, 766, 766, 766, 766, 
	-1, -1, -1, -1, 766, 766, -1, -1, 
	766, 766, -1, -1, -1, -1, -1, -1, 
	-1, -1, 766, 766, -1, -1, -1, -1, 
	766, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 766, 
	766, 766, -1, -1, -1, -1, -1, 766, 
	766, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 766, -1, -1, -1, -1, 
	-1, -1, 766, 943, 943, 943, 943, 943, 
	943, 943, 943, 943, 943, 943, 943, 943, 
	943, 943, 943, 943, 943, 943, 943, 943, 
	943, 943, 943, 943, 943, -1, 943, 943, 
	943, 943, 943, -1, 943, -1, 943, 943, 
	943, 943, -1, 943, -1, 943, 943, 943, 
	-1, -1, 943, 943, 943, 943, 943, 943, 
	943, 943, -1, 943, 943, 943, -1, -1, 
	-1, -1, 943, 943, 943, 943, 943, -1, 
	-1, 943, 943, 943, 943, 64, 67, 68, 
	65, 66, 73, 74, -1, 69, 70, 943, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	138, 139, 141, 140, 142, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 75, 
	-1, -1, -1, 131, -1, -1, -1, 135, 
	136, 137, 72, 71, 130, -1, -1, -1, 
	-1, 124, 125, 126, -1, -1, -1, -1, 
	993, 122, -1, 144, 145, 146, 147, -1, 
	-1, -1, -1, -1, -1, -1, 127, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 117, 118, 119, -1, 
	120, -1, -1, -1, -1, -1, 766, 943, 
	943, 943, 943, -1, -1, 943, 943, -1, 
	943, 943, 943, -1, -1, -1, -1, 943, 
	943, 943, -1, 943, 943, 943, -1, -1, 
	-1, -1, 943, -1, -1, -1, -1, 943, 
	-1, -1, -1, 943, 943, 943, -1, 943, 
	943, -1, -1, 943, -1, -1, -1, -1, 
	-1, -1, -1, -1, 943, 943, 943, 943, 
	943, 943, 943, -1, -1, -1, -1, 943, 
	943, -1, -1, 943, 943, -1, -1, -1, 
	-1, -1, -1, -1, -1, 943, 943, -1, 
	-1, -1, -1, 943, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 943, 943, 943, -1, -1, -1, 
	-1, -1, 943, 943, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 525, 943, -1, 
	-1, -1, -1, -1, -1, 943, -1, -1, 
	206, 113, 114, 115, 116, -1, 121, 129, 
	133, -1, -1, -1, -1, 132, 64, 67, 
	68, 65, 66, 73, 74, -1, 69, 70, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 138, 139, 141, 140, 142, -1, -1, 
	-1, 143, 134, 128, 123, 993, -1, -1, 
	75, -1, -1, -1, 131, -1, -1, -1, 
	135, 136, 137, 72, 71, 130, -1, -1, 
	-1, -1, 124, 125, 126, -1, -1, -1, 
	-1, 993, 122, -1, 144, 145, 146, 147, 
	-1, -1, -1, -1, -1, -1, -1, 127, 
	930, 64, 67, 68, 65, 66, 73, 74, 
	-1, 69, 70, -1, -1, 117, 118, 119, 
	-1, 120, -1, -1, 138, 139, 141, 140, 
	142, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 75, -1, -1, -1, 131, 
	-1, -1, -1, 135, 136, 137, 72, 71, 
	130, -1, -1, -1, -1, 124, 125, 126, 
	-1, -1, -1, -1, 993, 122, -1, 144, 
	145, 146, 147, -1, -1, -1, -1, -1, 
	-1, -1, 127, 1137, -1, -1, -1, -1, 
	-1, 943, -1, -1, -1, -1, -1, -1, 
	117, 118, 119, -1, 120, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 205, 526, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 206, 113, 114, 115, 116, -1, 121, 
	129, 133, -1, -1, -1, -1, 132, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 143, 134, 128, 123, 993, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 529, 113, 114, 115, 
	116, -1, 121, 129, 133, -1, -1, -1, 
	528, 132, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1038, 
	1038, 1038, 1038, 1038, 1038, 1038, -1, 1038, 
	1038, -1, -1, -1, -1, 143, 134, 128, 
	123, 993, 1038, 1038, 1038, 1038, 1038, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1038, -1, -1, 527, 1038, -1, -1, 
	-1, 1038, 1038, 1038, 1038, 1038, 1038, -1, 
	-1, -1, -1, 1038, 1038, 1038, -1, -1, 
	-1, -1, 1038, 1038, -1, 1038, 1038, 1038, 
	1038, -1, -1, -1, -1, -1, -1, -1, 
	1038, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1038, 1038, 
	1038, 332, 1038, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1008, 1008, 1008, 
	1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 
	1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 
	1008, 1008, 1008, 1008, 1008, 1008, 1008, -1, 
	1008, 1008, 1008, 1008, 1008, -1, 1008, -1, 
	1008, 1008, 1008, 1008, -1, 1008, -1, 1008, 
	1008, 1008, -1, 1008, 1008, 1008, 1008, 1008, 
	1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 
	-1, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 
	1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 
	-1, 1008, -1, -1, -1, -1, 1008, 1008, 
	1008, 1008, 1008, -1, -1, 1008, 1008, 1008, 
	1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 
	1008, 1008, 1008, 1008, 1008, -1, -1, -1, 
	-1, -1, 1008, -1, -1, -1, -1, -1, 
	-1, -1, 1038, 1038, 1038, 1038, 1038, -1, 
	1038, 1038, 1038, -1, -1, -1, -1, 1038, 
	-1, 525, -1, -1, -1, -1, -1, -1, 
	-1, -1, 697, -1, 206, 113, 114, 115, 
	116, -1, 121, 129, 133, -1, -1, -1, 
	-1, 132, -1, 1038, 1038, 1038, 1038, 1038, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1008, 1008, 1008, 1008, -1, -1, 1008, 
	1008, 1008, 1008, 1008, 1008, 143, 134, 128, 
	123, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 
	-1, -1, -1, -1, 1008, -1, -1, -1, 
	-1, 1008, 1008, -1, -1, 1008, 1008, 1008, 
	-1, 1008, 1008, -1, -1, 1008, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1008, 1008, 
	1008, 1008, 1008, 1008, 1008, -1, -1, -1, 
	1008, 1008, 1008, -1, -1, 1008, 1008, -1, 
	1008, 1008, 1008, 1008, 1008, -1, 1008, 1008, 
	1008, -1, -1, -1, 1008, 1008, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1008, 1008, 1008, -1, -1, 1008, -1, -1, 
	-1, -1, 1008, -1, 1008, 1008, 1008, 1008, 
	-1, 1008, 1008, 1008, 1008, 1008, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1008, -1, 1008, -1, -1, 1008, -1, 1008, 
	1008, -1, -1, -1, 1008, -1, 1008, -1, 
	1008, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 205, 526, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 206, 113, 114, 
	115, 116, -1, 121, 129, 133, -1, -1, 
	-1, -1, 132, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 143, 134, 
	128, 123, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	529, 113, 114, 115, 116, -1, 121, 129, 
	133, -1, -1, 1008, 528, 132, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 143, 134, 128, 123, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	527, 1009, 1009, 1009, 1009, 1009, 1009, 1009, 
	1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009, 
	1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009, 
	1009, 1009, 1009, -1, 1009, 1009, 1009, 1009, 
	1009, -1, 1009, -1, 1009, 1009, 1009, 1009, 
	-1, 1009, -1, 1009, 1009, 1009, -1, 1009, 
	1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009, 
	1009, 1009, 1009, 1009, -1, 1009, 1009, 1009, 
	1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009, 
	1009, 1009, 1009, 1009, -1, 1009, -1, -1, 
	-1, -1, 1009, 1009, 1009, 1009, 1009, -1, 
	-1, 1009, 1009, 1009, 1009, 1009, 1009, 1009, 
	1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009, 
	1009, -1, -1, -1, -1, -1, 1009, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1009, 1009, 1009, 
	1009, -1, -1, 1009, 1009, 1009, 1009, 1009, 
	1009, -1, -1, -1, -1, 1009, 1009, 1009, 
	1009, 1009, 1009, 1009, -1, -1, -1, -1, 
	1009, -1, -1, -1, -1, 1009, 1009, -1, 
	-1, 1009, 1009, 1009, -1, 1009, 1009, -1, 
	-1, 1009, -1, -1, -1, -1, 697, -1, 
	-1, -1, 1009, 1009, 1009, 1009, 1009, 1009, 
	1009, -1, -1, -1, 1009, 1009, 1009, -1, 
	-1, 1009, 1009, -1, 1009, 1009, 1009, 1009, 
	1009, -1, 1009, 1009, 1009, -1, -1, -1, 
	1009, 1009, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1009, 1009, 1009, -1, 
	-1, 1009, -1, -1, -1, -1, 1009, -1, 
	1009, 1009, 1009, 1009, -1, 1009, 1009, 1009, 
	1009, 1009, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1009, -1, 1009, -1, 
	-1, 1009, -1, 1009, 1009, -1, -1, -1, 
	1009, -1, 1009, -1, 1009, 884, 884, 884, 
	884, 884, 884, 884, 884, 884, 884, 884, 
	884, 884, 884, 884, -1, 884, 884, 884, 
	884, 884, 884, 884, 884, -1, -1, -1, 
	884, 884, 884, 884, 884, -1, 884, -1, 
	884, 884, 884, 884, -1, 884, -1, 884, 
	884, 884, -1, -1, 884, -1, -1, 884, 
	884, 884, 884, 884, -1, 884, 884, 884, 
	-1, -1, -1, -1, 884, 884, 884, 884, 
	884, -1, -1, 884, 884, 884, 884, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1009, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 884, 884, 884, 884, -1, -1, 884, 
	884, -1, 884, 884, 884, -1, -1, -1, 
	-1, 884, 884, 884, -1, 884, 884, 884, 
	-1, -1, -1, -1, 884, -1, -1, -1, 
	-1, 884, 884, -1, -1, 884, 884, 884, 
	-1, 884, 884, -1, -1, 884, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 884, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 884, 884, -1, 
	-1, -1, -1, -1, -1, -1, -1, 884, 
	884, -1, -1, -1, -1, 884, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 884, 884, 884, -1, 
	-1, -1, -1, -1, 884, 884, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	884, -1, -1, -1, -1, 884, -1, -1, 
	868, 868, 868, 868, 868, 868, 868, 868, 
	868, 868, 868, 868, 868, 868, 868, -1, 
	868, 868, 868, 868, 868, 868, 868, 868, 
	-1, -1, -1, 868, 868, 868, 868, 868, 
	-1, 868, -1, 868, 868, 868, 868, -1, 
	868, -1, 868, 868, 868, -1, -1, 868, 
	-1, -1, 868, 868, 868, 868, 868, -1, 
	868, 868, 868, -1, -1, -1, -1, 868, 
	868, 868, 868, 868, -1, -1, 868, 868, 
	868, 868, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 884, 868, 868, 868, 868, 
	-1, -1, 868, 868, -1, 868, 868, 868, 
	-1, -1, -1, -1, 868, 868, 868, -1, 
	868, 868, 868, -1, -1, -1, -1, 868, 
	-1, -1, -1, -1, 868, -1, -1, -1, 
	868, 868, 868, -1, 868, 868, -1, -1, 
	868, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 868, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	868, 868, -1, -1, -1, -1, -1, -1, 
	-1, -1, 868, 868, -1, -1, -1, -1, 
	868, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 868, 
	868, 868, -1, -1, -1, -1, -1, 868, 
	868, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 868, -1, 1074, 1074, 1074, 
	1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 
	1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 
	1074, 1074, 1074, 1074, 1074, 1074, 1074, -1, 
	1074, 1074, 1074, 1074, 1074, -1, 1074, -1, 
	1074, 1074, 1074, 1074, -1, 1074, -1, 1074, 
	1074, 1074, -1, 1074, 1074, 1074, 1074, 1074, 
	1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 
	-1, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 
	1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 
	-1, 1074, -1, -1, -1, -1, 1074, 1074, 
	1074, 1074, 1074, -1, -1, 1074, 1074, 1074, 
	1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 
	1074, 1074, 1074, 1074, 1074, -1, -1, -1, 
	-1, -1, 1074, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1074, 1074, 1074, 1074, -1, 868, 1074, 
	1074, 1074, 1074, 1074, 1074, -1, -1, -1, 
	-1, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 
	-1, -1, -1, -1, 1074, -1, -1, -1, 
	-1, 1074, 1074, -1, -1, 1074, 1074, 1074, 
	-1, 1074, 1074, -1, -1, 1074, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1074, 1074, 
	1074, 1074, 1074, 1074, 1074, -1, -1, -1, 
	1074, 1074, 1074, -1, -1, 1074, 1074, -1, 
	1074, 1074, 1074, 1074, 1074, -1, 1074, 1074, 
	1074, -1, -1, -1, 1074, 1074, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1074, 1074, 1074, -1, -1, 1074, -1, -1, 
	-1, -1, 1074, -1, 1074, 1074, 1074, 1074, 
	-1, 1074, 1074, 1074, 1074, 1074, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1074, -1, 1074, -1, -1, 1074, -1, 1074, 
	1074, -1, -1, -1, 1074, -1, 1074, -1, 
	1074, 1075, 1075, 1075, 1075, 1075, 1075, 1075, 
	1075, 1075, 1075, 1075, 1075, 1075, 1075, 1075, 
	1075, 1075, 1075, 1075, 1075, 1075, 1075, 1075, 
	1075, 1075, 1075, -1, 1075, 1075, 1075, 1075, 
	1075, -1, 1075, -1, 1075, 1075, 1075, 1075, 
	-1, 1075, -1, 1075, 1075, 1075, -1, 1075, 
	1075, 1075, 1075, 1075, 1075, 1075, 1075, 1075, 
	1075, 1075, 1075, 1075, -1, 1075, 1075, 1075, 
	1075, 1075, 1075, 1075, 1075, 1075, 1075, 1075, 
	1075, 1075, 1075, 1075, -1, 1075, -1, -1, 
	-1, -1, 1075, 1075, 1075, 1075, 1075, -1, 
	-1, 1075, 1075, 1075, 1075, 1075, 1075, 1075, 
	1075, 1075, 1075, 1075, 1075, 1075, 1075, 1075, 
	1075, -1, -1, -1, -1, -1, 1075, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1074, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1075, 1075, 1075, 
	1075, -1, -1, 1075, 1075, 1075, 1075, 1075, 
	1075, -1, -1, -1, -1, 1075, 1075, 1075, 
	1075, 1075, 1075, 1075, -1, -1, -1, -1, 
	1075, -1, -1, -1, -1, 1075, 1075, -1, 
	-1, 1075, 1075, 1075, -1, 1075, 1075, -1, 
	-1, 1075, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1075, 1075, 1075, 1075, 1075, 1075, 
	1075, -1, -1, -1, 1075, 1075, 1075, -1, 
	-1, 1075, 1075, -1, 1075, 1075, 1075, 1075, 
	1075, -1, 1075, 1075, 1075, -1, -1, -1, 
	1075, 1075, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1075, 1075, 1075, -1, 
	-1, 1075, -1, -1, -1, -1, 1075, -1, 
	1075, 1075, 1075, 1075, -1, 1075, 1075, 1075, 
	1075, 1075, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1075, -1, 1075, -1, 
	-1, 1075, -1, 1075, 1075, -1, -1, -1, 
	1075, -1, 1075, -1, 1075, 1076, 1076, 1076, 
	1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 
	1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 
	1076, 1076, 1076, 1076, 1076, 1076, 1076, -1, 
	1076, 1076, 1076, 1076, 1076, -1, 1076, -1, 
	1076, 1076, 1076, 1076, -1, 1076, -1, 1076, 
	1076, 1076, -1, 1076, 1076, 1076, 1076, 1076, 
	1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 
	-1, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 
	1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 
	-1, 1076, -1, -1, -1, -1, 1076, 1076, 
	1076, 1076, 1076, -1, -1, 1076, 1076, 1076, 
	1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 
	1076, 1076, 1076, 1076, 1076, -1, -1, -1, 
	-1, -1, 1076, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1075, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1076, 1076, 1076, 1076, -1, -1, 1076, 
	1076, 1076, 1076, 1076, 1076, -1, -1, -1, 
	-1, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 
	-1, -1, -1, -1, 1076, -1, -1, -1, 
	-1, 1076, 1076, -1, -1, 1076, 1076, 1076, 
	-1, 1076, 1076, -1, -1, 1076, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1076, 1076, 
	1076, 1076, 1076, 1076, 1076, -1, -1, -1, 
	1076, 1076, 1076, -1, -1, 1076, 1076, -1, 
	1076, 1076, 1076, 1076, 1076, -1, 1076, 1076, 
	1076, -1, -1, -1, 1076, 1076, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1076, 1076, 1076, -1, -1, 1076, -1, -1, 
	-1, -1, 1076, -1, 1076, 1076, 1076, 1076, 
	-1, 1076, 1076, 1076, 1076, 1076, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1076, -1, 1076, -1, -1, 1076, -1, 1076, 
	1076, -1, -1, -1, 1076, -1, 1076, -1, 
	1076, 64, 67, 68, 65, 66, 73, 74, 
	-1, 69, 70, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 138, 139, 141, 140, 
	142, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 75, -1, -1, -1, 131, 
	-1, -1, -1, 135, 136, 137, 72, 71, 
	130, -1, -1, -1, -1, 124, 125, 126, 
	-1, -1, -1, -1, 993, 122, -1, 144, 
	145, 146, 147, -1, -1, -1, -1, -1, 
	-1, -1, 127, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	117, 118, 119, -1, 120, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1077, 1077, 
	1077, 1077, 1077, 1077, 1077, 1077, 1077, 1077, 
	1077, 1077, 1077, 1077, 1077, 1077, 1077, 1077, 
	1077, 1077, 1077, 1077, 1077, 1077, 1077, 1077, 
	-1, 1077, 1077, 1077, 1077, 1077, -1, 1077, 
	-1, 1077, 1077, 1077, 1077, -1, 1077, -1, 
	1077, 1077, 1077, 1076, 1077, 1077, 1077, 1077, 
	1077, 1077, 1077, 1077, 1077, 1077, 1077, 1077, 
	1077, -1, 1077, 1077, 1077, 1077, 1077, 1077, 
	1077, 1077, 1077, 1077, 1077, 1077, 1077, 1077, 
	1077, -1, 1077, -1, -1, -1, -1, 1077, 
	1077, 1077, 1077, 1077, -1, -1, 1077, 1077, 
	1077, 1077, 1077, 1077, 1077, 1077, 1077, 1077, 
	1077, 1077, 1077, 1077, 1077, 1077, -1, -1, 
	-1, -1, -1, 1077, -1, -1, -1, -1, 
	-1, -1, -1, -1, 583, 113, 114, 115, 
	116, -1, 121, 129, 133, -1, -1, -1, 
	-1, 132, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 143, 134, 128, 
	123, 993, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1077, 1077, 1077, 1077, -1, -1, 
	1077, 1077, 1077, 1077, 1077, 1077, -1, -1, 
	-1, -1, 1077, 1077, 1077, 1077, 1077, 1077, 
	1077, -1, -1, -1, -1, 1077, -1, -1, 
	-1, -1, 1077, 1077, -1, -1, 1077, 1077, 
	1077, -1, 1077, 1077, -1, -1, 1077, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1077, 
	1077, 1077, 1077, 1077, 1077, 1077, -1, -1, 
	-1, 1077, 1077, 1077, -1, -1, 1077, 1077, 
	-1, 1077, 1077, 1077, 1077, 1077, -1, 1077, 
	1077, 1077, -1, -1, -1, 1077, 1077, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1077, 1077, 1077, -1, -1, 1077, -1, 
	-1, -1, -1, 1077, -1, 1077, 1077, 1077, 
	1077, -1, 1077, 1077, 1077, 1077, 1077, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1077, -1, 1077, -1, -1, 1077, -1, 
	1077, 1077, -1, -1, -1, 1077, -1, 1077, 
	-1, 1077, 977, 977, 977, 977, 977, 977, 
	977, 977, 977, 977, 977, 977, 977, 977, 
	977, 977, 977, 977, 977, 977, 977, 977, 
	977, 977, 977, 977, -1, 977, 977, 977, 
	977, 977, -1, 977, -1, 977, 977, 977, 
	977, -1, 977, -1, 977, 977, 977, -1, 
	977, 977, 977, 977, 977, 977, 977, 977, 
	977, 977, 977, 977, 977, -1, 977, 977, 
	977, 977, 977, 977, 977, 977, 977, 977, 
	977, 977, 977, 977, 977, -1, 977, -1, 
	-1, -1, -1, 977, 977, 977, 977, 977, 
	-1, -1, 977, 977, 977, 977, 977, 977, 
	977, 977, 977, 977, 977, 977, 977, 977, 
	977, 977, -1, -1, -1, -1, -1, 977, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1077, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 977, 977, 
	977, 977, -1, -1, 977, 977, 977, 977, 
	977, 977, -1, -1, -1, -1, 977, 977, 
	977, 977, 977, 977, 977, -1, -1, -1, 
	-1, 977, -1, -1, -1, -1, 977, 977, 
	-1, -1, 977, 977, 977, -1, 977, 977, 
	-1, -1, 977, -1, -1, -1, -1, -1, 
	-1, -1, -1, 977, 977, 977, 977, 977, 
	977, 977, -1, -1, -1, 977, 977, 977, 
	-1, -1, 977, 977, -1, 977, 977, 977, 
	977, 977, -1, 977, 977, 977, -1, -1, 
	-1, 977, 977, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 977, 977, 977, 
	-1, -1, 977, -1, -1, -1, -1, 977, 
	-1, 977, 977, 977, 977, -1, 977, 977, 
	977, 977, 977, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 977, -1, 977, 
	-1, -1, 977, -1, 977, 977, -1, -1, 
	-1, 977, -1, 977, -1, 977, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 936, 936, 
	936, 936, 936, 936, 936, 936, 936, 936, 
	936, 936, -1, -1, 936, 936, 936, 936, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 936, 936, 936, -1, 
	-1, -1, 936, -1, -1, -1, -1, 936, 
	-1, -1, -1, -1, -1, 936, 936, -1, 
	583, 113, 114, 115, 116, -1, 121, 129, 
	133, -1, -1, 936, -1, 132, 936, 936, 
	936, 936, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 936, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 143, 134, 128, 123, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	977, 964, 964, 964, 964, 964, 964, 964, 
	964, 964, 964, 964, 964, 964, 964, 964, 
	964, 964, 964, 964, 964, 964, 964, 964, 
	964, 964, 964, -1, 964, 964, 964, 964, 
	964, -1, 964, -1, 964, 964, 964, 964, 
	-1, 964, -1, 964, 964, 964, -1, 964, 
	964, 964, 964, 964, 964, 964, 964, 964, 
	964, 964, 964, 964, -1, 964, 964, 964, 
	964, 964, 964, 964, 964, 964, 964, 964, 
	964, 964, 964, 964, -1, 964, -1, -1, 
	-1, -1, 964, 964, 964, 964, 964, -1, 
	-1, 964, 964, 964, 964, 964, 964, 964, 
	964, 964, 964, 964, 964, 964, 964, 964, 
	964, -1, -1, -1, 936, -1, 964, -1, 
	-1, -1, -1, -1, 936, 936, 936, -1, 
	936, 936, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 936, -1, -1, -1, -1, 
	936, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 936, 
	936, 936, -1, -1, -1, -1, -1, 936, 
	936, -1, -1, -1, -1, 964, 964, 964, 
	964, -1, -1, 964, 964, 964, 964, 964, 
	964, -1, 936, -1, -1, 964, 964, 964, 
	964, 964, 964, 964, -1, -1, -1, -1, 
	964, -1, -1, -1, -1, 964, 964, -1, 
	-1, 964, 964, 964, -1, 964, 964, -1, 
	-1, 964, -1, -1, -1, -1, -1, -1, 
	-1, -1, 964, 964, 964, 964, 964, 964, 
	964, -1, -1, -1, 964, 964, 964, -1, 
	-1, 964, 964, -1, 964, 964, 964, 964, 
	964, -1, 964, 964, 964, -1, -1, -1, 
	964, 964, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 964, 964, 964, -1, 
	-1, 964, -1, -1, -1, -1, 964, -1, 
	964, 964, 964, 964, -1, 964, 964, 964, 
	964, 964, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 964, -1, 964, -1, 
	-1, 964, -1, 964, 964, -1, -1, -1, 
	964, -1, 964, -1, 964, 946, 946, 946, 
	946, 946, 946, 946, 946, 946, 946, 946, 
	946, 946, 946, 946, 946, 946, 946, 946, 
	946, 946, 946, 946, 946, 946, 946, -1, 
	946, 946, 946, 946, 946, -1, 946, -1, 
	946, 946, 946, 946, -1, 946, -1, 946, 
	946, 946, -1, 946, 946, 946, 946, 946, 
	946, 946, 946, 946, 946, 946, 946, 946, 
	-1, 946, 946, 946, 946, 946, 946, 946, 
	946, 946, 946, 946, 946, 946, 946, 946, 
	-1, -1, -1, -1, -1, -1, 946, 946, 
	946, 946, -1, -1, -1, 278, 279, 946, 
	280, 281, 282, 283, 946, 946, 946, 946, 
	946, -1, -1, 946, 946, -1, -1, -1, 
	-1, -1, 946, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 964, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 946, 946, 946, 946, -1, -1, 946, 
	946, 946, 946, 946, 946, -1, -1, -1, 
	-1, 946, 946, 946, 946, 946, 946, 946, 
	-1, -1, -1, -1, 946, -1, -1, -1, 
	-1, 946, 946, -1, -1, 946, 946, 946, 
	-1, 946, 946, -1, -1, 946, -1, -1, 
	-1, -1, -1, -1, -1, -1, 946, 946, 
	946, 946, 946, 946, 946, -1, -1, -1, 
	946, 946, 946, -1, -1, 946, 946, -1, 
	946, 946, 946, 946, 946, -1, 946, 946, 
	946, -1, -1, -1, 946, 946, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	946, 946, 946, -1, -1, 946, -1, -1, 
	-1, -1, 946, -1, 946, 946, 946, 946, 
	-1, 946, 946, 946, 946, 946, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	946, -1, 946, -1, -1, 946, -1, 946, 
	946, -1, -1, -1, 946, -1, 946, -1, 
	946, 947, 947, 947, 947, 947, 947, 947, 
	947, 947, 947, 947, 947, 947, 947, 947, 
	947, 947, 947, 947, 947, 947, 947, 947, 
	947, 947, 947, -1, 947, 947, 947, 947, 
	947, -1, 947, -1, 947, 947, 947, 947, 
	-1, 947, -1, 947, 947, 947, -1, 947, 
	947, 947, 947, 947, 947, 947, 947, 947, 
	947, 947, 947, 947, -1, 947, 947, 947, 
	947, 947, 947, 947, 947, 947, 947, 947, 
	947, 947, 947, 947, -1, -1, -1, -1, 
	-1, -1, 947, 947, 947, 947, -1, -1, 
	-1, 278, 279, 947, 280, 281, 282, 283, 
	947, 947, 947, 947, 947, -1, -1, 947, 
	947, -1, -1, -1, -1, -1, 947, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 946, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 947, 947, 947, 
	947, -1, -1, 947, 947, 947, 947, 947, 
	947, -1, -1, -1, -1, 947, 947, 947, 
	947, 947, 947, 947, -1, -1, -1, -1, 
	947, -1, -1, -1, -1, 947, 947, -1, 
	-1, 947, 947, 947, -1, 947, 947, -1, 
	-1, 947, -1, -1, -1, -1, -1, -1, 
	-1, -1, 947, 947, 947, 947, 947, 947, 
	947, -1, -1, -1, 947, 947, 947, -1, 
	-1, 947, 947, -1, 947, 947, 947, 947, 
	947, -1, 947, 947, 947, -1, -1, -1, 
	947, 947, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 947, 947, 947, -1, 
	-1, 947, -1, -1, -1, -1, 947, -1, 
	947, 947, 947, 947, -1, 947, 947, 947, 
	947, 947, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 947, -1, 947, -1, 
	-1, 947, -1, 947, 947, -1, -1, -1, 
	947, -1, 947, -1, 947, 762, 762, 762, 
	762, 762, 762, 762, 762, 762, 762, 762, 
	762, 762, 762, 762, 762, 762, 762, 762, 
	762, 762, 762, 762, 762, 762, 762, -1, 
	762, 762, 762, 762, 762, -1, 762, -1, 
	762, 762, 762, 762, -1, 762, -1, 762, 
	762, 762, -1, -1, 762, 762, 762, 762, 
	762, 762, 762, 762, -1, 762, 762, 762, 
	-1, -1, -1, -1, 762, 762, 762, 762, 
	762, -1, -1, 762, 762, 762, 762, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 762, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 947, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 762, 762, 762, 762, -1, -1, 762, 
	762, -1, 762, 762, 762, -1, -1, -1, 
	-1, 762, 762, 762, -1, 762, 762, 762, 
	-1, -1, -1, -1, 762, -1, -1, -1, 
	-1, 762, -1, -1, -1, 762, 762, 762, 
	-1, 762, 762, -1, -1, 762, -1, -1, 
	-1, -1, -1, -1, -1, -1, 762, 762, 
	762, 762, 762, 762, 762, -1, -1, -1, 
	-1, 762, 762, -1, -1, 762, 762, -1, 
	-1, -1, -1, -1, -1, -1, -1, 762, 
	762, -1, -1, -1, -1, 762, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 762, 762, 762, -1, 
	-1, -1, -1, -1, 762, 762, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	762, -1, -1, -1, -1, -1, -1, 762, 
	926, 926, 926, 926, 926, 926, 926, 926, 
	926, 926, 926, 926, 926, 926, 926, 926, 
	926, 926, 926, 926, 926, 926, 926, 926, 
	449, 450, -1, 926, 926, 926, 926, 926, 
	-1, 926, -1, 926, 926, 926, 926, -1, 
	926, -1, 926, 926, 926, -1, -1, 926, 
	926, 926, 926, 926, 926, 926, 926, -1, 
	926, 926, 926, -1, -1, -1, -1, 926, 
	926, 926, 926, 926, -1, -1, 926, 926, 
	926, 926, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 926, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 762, 926, 926, 926, 926, 
	-1, -1, 926, 926, -1, 926, 926, 926, 
	-1, -1, -1, -1, 926, 926, 926, -1, 
	926, 926, 926, -1, -1, -1, -1, 926, 
	-1, -1, -1, -1, 926, -1, -1, -1, 
	926, 926, 926, -1, 926, 926, -1, -1, 
	926, -1, -1, -1, -1, -1, -1, -1, 
	-1, 926, 926, 926, 926, 588, 446, 448, 
	-1, -1, -1, -1, 926, 926, -1, -1, 
	926, 926, -1, -1, -1, -1, -1, -1, 
	-1, -1, 926, 926, -1, -1, -1, -1, 
	926, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 926, 
	926, 926, -1, -1, -1, -1, -1, 926, 
	926, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 926, -1, -1, -1, -1, 
	-1, -1, 926, 923, 923, 923, 923, 923, 
	923, 923, 923, 923, 923, 923, 923, 923, 
	923, 923, 923, 923, 923, 923, 923, 923, 
	923, 923, 923, 923, 923, -1, 923, 923, 
	923, 923, 923, -1, 923, -1, 923, 923, 
	923, 923, -1, 923, -1, 923, 923, 923, 
	-1, -1, 923, 923, 923, 923, 923, 923, 
	923, 923, -1, 923, 923, 923, -1, -1, 
	-1, -1, 923, 923, 923, 923, 923, -1, 
	-1, 923, 923, 923, 923, 64, 67, 68, 
	65, 66, 73, 74, -1, 69, 70, 923, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	138, 139, 141, 140, 142, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 75, 
	-1, -1, -1, 131, -1, -1, -1, 135, 
	136, 137, 72, 71, 130, -1, -1, -1, 
	-1, 124, 125, 126, -1, -1, -1, -1, 
	993, 122, -1, 144, 145, 146, 147, -1, 
	-1, -1, -1, -1, -1, -1, 127, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 117, 118, 119, -1, 
	120, -1, -1, -1, -1, -1, 926, 923, 
	923, 923, 923, -1, -1, 923, 923, -1, 
	923, 923, 923, -1, -1, -1, -1, 923, 
	923, 923, -1, 923, 923, 923, -1, -1, 
	-1, -1, 923, -1, -1, -1, -1, 923, 
	-1, -1, -1, 923, 923, 923, -1, 923, 
	923, -1, -1, 923, -1, -1, -1, -1, 
	-1, -1, -1, -1, 923, 923, 923, 923, 
	923, 923, 923, -1, -1, -1, -1, 923, 
	923, -1, -1, 923, 923, -1, -1, -1, 
	-1, -1, -1, -1, -1, 923, 923, -1, 
	-1, -1, -1, 923, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 923, 923, 923, -1, -1, -1, 
	-1, -1, 923, 923, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 923, -1, 
	-1, -1, -1, -1, -1, 923, -1, -1, 
	585, 113, 114, 115, 116, -1, 121, 129, 
	133, -1, -1, -1, -1, 132, -1, -1, 
	55, 56, 64, 67, 68, 65, 66, 73, 
	74, -1, 69, 70, -1, -1, 35, 36, 
	40, 38, -1, -1, -1, -1, -1, -1, 
	-1, 143, 134, 128, 123, 993, 41, 42, 
	43, -1, -1, -1, 75, -1, -1, -1, 
	-1, 37, -1, -1, -1, -1, -1, 72, 
	71, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 59, -1, -1, 
	82, 84, 86, 88, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 276, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 923, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 587, 445, 447, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 277, -1, 
	-1, -1, -1, -1, -1, 586, -1, -1, 
	-1, -1, 34, 33, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 62, -1, -1, 
	-1, -1, 44, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 80, 76, 45, -1, -1, -1, -1, 
	-1, 39, 993, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 949, 949, 949, 949, 949, 949, 
	949, 949, 949, 949, 949, 949, 949, 949, 
	949, 949, 949, 949, 949, 949, 949, 949, 
	949, 949, 949, 949, -1, 949, 949, 949, 
	949, 949, -1, 949, -1, 949, 949, 949, 
	949, -1, 949, -1, 949, 949, 949, -1, 
	949, 949, 949, 949, 949, 949, 949, 949, 
	949, 949, 949, 949, 949, -1, 949, 949, 
	949, 949, 949, 949, 949, 949, 949, 949, 
	949, 949, 949, 949, 949, -1, -1, -1, 
	-1, -1, -1, 949, 949, 949, 949, -1, 
	-1, -1, 949, 949, 949, 949, 949, 949, 
	949, 949, 949, 949, 949, 949, 284, 285, 
	949, 949, -1, -1, -1, -1, -1, 949, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 949, 949, 
	949, 949, -1, -1, 949, 949, 949, 949, 
	949, 949, -1, -1, -1, -1, 949, 949, 
	949, 949, 949, 949, 949, -1, -1, -1, 
	-1, 949, -1, -1, -1, -1, 949, 949, 
	-1, -1, 949, 949, 949, -1, 949, 949, 
	-1, -1, 949, -1, -1, -1, -1, -1, 
	-1, -1, -1, 949, 949, 949, 949, 949, 
	949, 949, -1, -1, -1, 949, 949, 949, 
	-1, -1, 949, 949, -1, 949, 949, 949, 
	949, 949, -1, 949, 949, 949, -1, -1, 
	-1, 949, 949, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 949, 949, 949, 
	-1, -1, 949, -1, -1, -1, -1, 949, 
	-1, 949, 949, 949, 949, -1, 949, 949, 
	949, 949, 949, -1, 585, 113, 114, 115, 
	116, -1, 121, 129, 133, 949, -1, 949, 
	-1, 132, 949, -1, 949, 949, -1, -1, 
	-1, 949, -1, 949, -1, 949, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 143, 134, 128, 
	123, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	949, -1, -1, -1, -1, 931, 931, 931, 
	931, 931, 931, 931, 931, 931, -1, 931, 
	931, -1, -1, 931, 931, 931, 931, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 931, 931, 931, -1, -1, 
	-1, 931, -1, -1, -1, -1, 931, -1, 
	-1, -1, 277, -1, 931, 931, -1, -1, 
	-1, 586, -1, -1, -1, -1, 34, 33, 
	-1, -1, 931, -1, -1, 931, 931, 931, 
	931, 62, -1, -1, -1, -1, 44, -1, 
	-1, -1, 931, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 80, 76, 45, 
	-1, -1, -1, -1, -1, 39, 950, 950, 
	950, 950, 950, 950, 950, 950, 950, 950, 
	950, 950, 950, 950, 950, 950, 950, 950, 
	950, 950, 950, 950, 950, 950, 950, 950, 
	-1, 950, 950, 950, 950, 950, -1, 950, 
	-1, 950, 950, 950, 950, -1, 950, -1, 
	950, 950, 950, -1, 950, 950, 950, 950, 
	950, 950, 950, 950, 950, 950, 950, 950, 
	950, -1, 950, 950, 950, 950, 950, 950, 
	950, 950, 950, 950, 950, 950, 950, 950, 
	950, -1, -1, -1, -1, -1, -1, 950, 
	950, 950, 950, -1, -1, -1, 950, 950, 
	950, 950, 950, 950, 950, 950, 950, 950, 
	950, 950, 284, 285, 950, 950, -1, -1, 
	-1, -1, -1, 950, -1, -1, -1, -1, 
	-1, -1, -1, 931, -1, -1, -1, -1, 
	-1, -1, 931, -1, -1, -1, -1, 931, 
	931, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 931, -1, -1, -1, -1, 931, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 931, 931, 
	931, -1, 950, 950, 950, 950, 931, 931, 
	950, 950, 950, 950, 950, 950, -1, -1, 
	-1, -1, 950, 950, 950, 950, 950, 950, 
	950, -1, -1, -1, -1, 950, -1, -1, 
	-1, -1, 950, 950, -1, -1, 950, 950, 
	950, -1, 950, 950, -1, -1, 950, -1, 
	-1, -1, -1, -1, -1, -1, -1, 950, 
	950, 950, 950, 950, 950, 950, -1, -1, 
	-1, 950, 950, 950, -1, -1, 950, 950, 
	-1, 950, 950, 950, 950, 950, -1, 950, 
	950, 950, -1, -1, -1, 950, 950, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 950, 950, 950, -1, -1, 950, -1, 
	-1, -1, -1, 950, -1, 950, 950, 950, 
	950, -1, 950, 950, 950, 950, 950, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 950, -1, 950, -1, -1, 950, -1, 
	950, 950, -1, -1, -1, 950, -1, 950, 
	-1, 950, 951, 951, 951, 951, 951, 951, 
	951, 951, 951, 951, 951, 951, 951, 951, 
	951, 951, 951, 951, 951, 951, 951, 951, 
	951, 951, 951, 951, -1, 951, 951, 951, 
	951, 951, -1, 951, -1, 951, 951, 951, 
	951, -1, 951, -1, 951, 951, 951, -1, 
	951, 951, 951, 951, 951, 951, 951, 951, 
	951, 951, 951, 951, 951, -1, 951, 951, 
	951, 951, 951, 951, 951, 951, 951, 951, 
	951, 951, 951, 951, 951, -1, -1, -1, 
	-1, -1, -1, 951, 951, 951, 951, -1, 
	-1, -1, 951, 951, 951, 951, 951, 951, 
	951, 951, 951, 951, 951, 951, 284, 285, 
	951, 951, -1, -1, -1, -1, -1, 951, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 950, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 951, 951, 
	951, 951, -1, -1, 951, 951, 951, 951, 
	951, 951, -1, -1, -1, -1, 951, 951, 
	951, 951, 951, 951, 951, -1, -1, -1, 
	-1, 951, -1, -1, -1, -1, 951, 951, 
	-1, -1, 951, 951, 951, -1, 951, 951, 
	-1, -1, 951, -1, -1, -1, -1, -1, 
	-1, -1, -1, 951, 951, 951, 951, 951, 
	951, 951, -1, -1, -1, 951, 951, 951, 
	-1, -1, 951, 951, -1, 951, 951, 951, 
	951, 951, -1, 951, 951, 951, -1, -1, 
	-1, 951, 951, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 951, 951, 951, 
	-1, -1, 951, -1, -1, -1, -1, 951, 
	-1, 951, 951, 951, 951, -1, 951, 951, 
	951, 951, 951, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 951, -1, 951, 
	-1, -1, 951, -1, 951, 951, -1, -1, 
	-1, 951, -1, 951, -1, 951, 952, 952, 
	952, 952, 952, 952, 952, 952, 952, 952, 
	952, 952, 952, 952, 952, 952, 952, 952, 
	952, 952, 952, 952, 952, 952, 952, 952, 
	-1, 952, 952, 952, 952, 952, -1, 952, 
	-1, 952, 952, 952, 952, -1, 952, -1, 
	952, 952, 952, -1, 952, 952, 952, 952, 
	952, 952, 952, 952, 952, 952, 952, 952, 
	952, -1, 952, 952, 952, 952, 952, 952, 
	952, 952, 952, 952, 952, 952, 952, 952, 
	952, -1, -1, -1, -1, -1, -1, 952, 
	952, 952, 952, -1, -1, -1, 952, 952, 
	952, 952, 952, 952, 952, 952, 952, 952, 
	952, 952, 284, 285, 952, 952, -1, -1, 
	-1, -1, -1, 952, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	951, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 952, 952, 952, 952, -1, -1, 
	952, 952, 952, 952, 952, 952, -1, -1, 
	-1, -1, 952, 952, 952, 952, 952, 952, 
	952, -1, -1, -1, -1, 952, -1, -1, 
	-1, -1, 952, 952, -1, -1, 952, 952, 
	952, -1, 952, 952, -1, -1, 952, -1, 
	-1, -1, -1, -1, -1, -1, -1, 952, 
	952, 952, 952, 952, 952, 952, -1, -1, 
	-1, 952, 952, 952, -1, -1, 952, 952, 
	-1, 952, 952, 952, 952, 952, -1, 952, 
	952, 952, -1, -1, -1, 952, 952, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 952, 952, 952, -1, -1, 952, -1, 
	-1, -1, -1, 952, -1, 952, 952, 952, 
	952, -1, 952, 952, 952, 952, 952, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 952, -1, 952, -1, -1, 952, -1, 
	952, 952, -1, -1, -1, 952, -1, 952, 
	-1, 952, 953, 953, 953, 953, 953, 953, 
	953, 953, 953, 953, 953, 953, 953, 953, 
	953, 953, 953, 953, 953, 953, 953, 953, 
	953, 953, 953, 953, -1, 953, 953, 953, 
	953, 953, -1, 953, -1, 953, 953, 953, 
	953, -1, 953, -1, 953, 953, 953, -1, 
	953, 953, 953, 953, 953, 953, 953, 953, 
	953, 953, 953, 953, 953, -1, 953, 953, 
	953, 953, 953, 953, 953, 953, 953, 953, 
	953, 953, 953, 953, 953, -1, -1, -1, 
	-1, -1, -1, 953, 953, 953, 953, -1, 
	-1, -1, 953, 953, 953, 953, 953, 953, 
	953, 953, 953, 953, 953, 953, 284, 285, 
	953, 953, -1, -1, -1, -1, -1, 953, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 952, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 953, 953, 
	953, 953, -1, -1, 953, 953, 953, 953, 
	953, 953, -1, -1, -1, -1, 953, 953, 
	953, 953, 953, 953, 953, -1, -1, -1, 
	-1, 953, -1, -1, -1, -1, 953, 953, 
	-1, -1, 953, 953, 953, -1, 953, 953, 
	-1, -1, 953, -1, -1, -1, -1, -1, 
	-1, -1, -1, 953, 953, 953, 953, 953, 
	953, 953, -1, -1, -1, 953, 953, 953, 
	-1, -1, 953, 953, -1, 953, 953, 953, 
	953, 953, -1, 953, 953, 953, -1, -1, 
	-1, 953, 953, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 953, 953, 953, 
	-1, -1, 953, -1, -1, -1, -1, 953, 
	-1, 953, 953, 953, 953, -1, 953, 953, 
	953, 953, 953, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 953, -1, 953, 
	-1, -1, 953, -1, 953, 953, -1, -1, 
	-1, 953, -1, 953, -1, 953, 954, 954, 
	954, 954, 954, 954, 954, 954, 954, 954, 
	954, 954, 954, 954, 954, 954, 954, 954, 
	954, 954, 954, 954, 954, 954, 954, 954, 
	-1, 954, 954, 954, 954, 954, -1, 954, 
	-1, 954, 954, 954, 954, -1, 954, -1, 
	954, 954, 954, -1, 954, 954, 954, 954, 
	954, 954, 954, 954, 954, 954, 954, 954, 
	954, -1, 954, 954, 954, 954, 954, 954, 
	954, 954, 954, 954, 954, 954, 954, 954, 
	954, -1, -1, -1, -1, -1, -1, 954, 
	954, 954, 954, -1, -1, -1, 954, 954, 
	954, 954, 954, 954, 954, 954, 954, 954, 
	954, 954, 284, 285, 954, 954, -1, -1, 
	-1, -1, -1, 954, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	953, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 954, 954, 954, 954, -1, -1, 
	954, 954, 954, 954, 954, 954, -1, -1, 
	-1, -1, 954, 954, 954, 954, 954, 954, 
	954, -1, -1, -1, -1, 954, -1, -1, 
	-1, -1, 954, 954, -1, -1, 954, 954, 
	954, -1, 954, 954, -1, -1, 954, -1, 
	-1, -1, -1, -1, -1, -1, -1, 954, 
	954, 954, 954, 954, 954, 954, -1, -1, 
	-1, 954, 954, 954, -1, -1, 954, 954, 
	-1, 954, 954, 954, 954, 954, -1, 954, 
	954, 954, -1, -1, -1, 954, 954, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 954, 954, 954, -1, -1, 954, -1, 
	-1, -1, -1, 954, -1, 954, 954, 954, 
	954, -1, 954, 954, 954, 954, 954, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 954, -1, 954, -1, -1, 954, -1, 
	954, 954, -1, -1, -1, 954, -1, 954, 
	-1, 954, 956, 956, 956, 956, 956, 956, 
	956, 956, 956, 956, 956, 956, 956, 956, 
	956, 956, 956, 956, 956, 956, 956, 956, 
	956, 956, 956, 956, -1, 956, 956, 956, 
	956, 956, -1, 956, -1, 956, 956, 956, 
	956, -1, 956, -1, 956, 956, 956, -1, 
	956, 956, 956, 956, 956, 956, 956, 956, 
	956, 956, 956, 956, 956, -1, 956, 956, 
	956, 956, 956, 956, 956, 956, 956, 956, 
	956, 956, 956, 956, 956, -1, 287, -1, 
	-1, -1, -1, 956, 956, 956, 956, 286, 
	-1, -1, 956, 956, 956, 956, 956, 956, 
	956, 956, 956, 956, 956, 956, 956, 956, 
	956, 956, -1, -1, -1, -1, -1, 956, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 954, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 956, 956, 
	956, 956, -1, -1, 956, 956, 956, 956, 
	956, 956, -1, -1, -1, -1, 956, 956, 
	956, 956, 956, 956, 956, -1, -1, -1, 
	-1, 956, -1, -1, -1, -1, 956, 956, 
	-1, -1, 956, 956, 956, -1, 956, 956, 
	-1, -1, 956, -1, -1, -1, -1, -1, 
	-1, -1, -1, 956, 956, 956, 956, 956, 
	956, 956, -1, -1, -1, 956, 956, 956, 
	-1, -1, 956, 956, -1, 956, 956, 956, 
	956, 956, -1, 956, 956, 956, -1, -1, 
	-1, 956, 956, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 956, 956, 956, 
	-1, -1, 956, -1, -1, -1, -1, 956, 
	-1, 956, 956, 956, 956, -1, 956, 956, 
	956, 956, 956, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 956, -1, 956, 
	-1, -1, 956, -1, 956, 956, -1, -1, 
	-1, 956, -1, 956, -1, 956, 957, 957, 
	957, 957, 957, 957, 957, 957, 957, 957, 
	957, 957, 957, 957, 957, 957, 957, 957, 
	957, 957, 957, 957, 957, 957, 957, 957, 
	-1, 957, 957, 957, 957, 957, -1, 957, 
	-1, 957, 957, 957, 957, -1, 957, -1, 
	957, 957, 957, -1, 957, 957, 957, 957, 
	957, 957, 957, 957, 957, 957, 957, 957, 
	957, -1, 957, 957, 957, 957, 957, 957, 
	957, 957, 957, 957, 957, 957, 957, 957, 
	957, -1, 287, -1, -1, -1, -1, 957, 
	957, 957, 957, 286, -1, -1, 957, 957, 
	957, 957, 957, 957, 957, 957, 957, 957, 
	957, 957, 957, 957, 957, 957, -1, -1, 
	-1, -1, -1, 957, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	956, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 957, 957, 957, 957, -1, -1, 
	957, 957, 957, 957, 957, 957, -1, -1, 
	-1, -1, 957, 957, 957, 957, 957, 957, 
	957, -1, -1, -1, -1, 957, -1, -1, 
	-1, -1, 957, 957, -1, -1, 957, 957, 
	957, -1, 957, 957, -1, -1, 957, -1, 
	-1, -1, -1, -1, -1, -1, -1, 957, 
	957, 957, 957, 957, 957, 957, -1, -1, 
	-1, 957, 957, 957, -1, -1, 957, 957, 
	-1, 957, 957, 957, 957, 957, -1, 957, 
	957, 957, -1, -1, -1, 957, 957, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 957, 957, 957, -1, -1, 957, -1, 
	-1, -1, -1, 957, -1, 957, 957, 957, 
	957, -1, 957, 957, 957, 957, 957, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 957, -1, 957, -1, -1, 957, -1, 
	957, 957, -1, -1, -1, 957, -1, 957, 
	-1, 957, 960, 960, 960, 960, 960, 960, 
	960, 960, 960, 960, 960, 960, 960, 960, 
	960, 960, 960, 960, 960, 960, 960, 960, 
	960, 960, 960, 960, -1, 960, 960, 960, 
	960, 960, -1, 960, -1, 960, 960, 960, 
	960, -1, 960, -1, 960, 960, 960, -1, 
	960, 960, 960, 960, 960, 960, 960, 960, 
	960, 960, 960, 960, 960, -1, 960, 960, 
	960, 960, 960, 960, 960, 960, 960, 960, 
	960, 960, 960, 960, 960, -1, 960, -1, 
	-1, -1, -1, 960, 960, 960, 960, 960, 
	-1, -1, 960, 960, 960, 960, 960, 960, 
	960, 960, 960, 960, 960, 960, 960, 960, 
	960, 960, -1, -1, -1, -1, -1, 960, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 957, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 960, 960, 
	960, 960, -1, -1, 960, 960, 960, 960, 
	960, 960, -1, -1, -1, -1, 960, 960, 
	960, 960, 960, 960, 960, -1, -1, -1, 
	-1, 960, -1, -1, -1, -1, 960, 960, 
	-1, -1, 960, 960, 960, -1, 960, 960, 
	-1, -1, 960, -1, -1, -1, -1, -1, 
	-1, -1, -1, 960, 960, 960, 960, 960, 
	960, 960, -1, -1, -1, 960, 960, 960, 
	-1, -1, 960, 960, -1, 960, 960, 960, 
	960, 960, -1, 960, 960, 960, -1, -1, 
	-1, 960, 960, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 960, 960, 960, 
	-1, -1, 960, -1, -1, -1, -1, 960, 
	-1, 960, 960, 960, 960, -1, 960, 960, 
	960, 960, 960, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 960, -1, 960, 
	-1, -1, 960, -1, 960, 960, -1, -1, 
	-1, 960, -1, 960, -1, 960, 959, 959, 
	959, 959, 959, 959, 959, 959, 959, 959, 
	959, 959, 959, 959, 959, 959, 959, 959, 
	959, 959, 959, 959, 959, 959, 959, 959, 
	-1, 959, 959, 959, 959, 959, -1, 959, 
	-1, 959, 959, 959, 959, -1, 959, -1, 
	959, 959, 959, -1, 959, 959, 959, 959, 
	959, 959, 959, 959, 959, 959, 959, 959, 
	959, -1, 959, 959, 959, 959, 959, 959, 
	959, 959, 959, 959, 959, 959, 959, 959, 
	959, -1, 959, -1, -1, -1, -1, 959, 
	959, 959, 959, 959, -1, -1, 959, 959, 
	959, 959, 959, 959, 959, 959, 959, 959, 
	959, 959, 959, 959, 959, 959, -1, -1, 
	-1, -1, -1, 959, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	960, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 959, 959, 959, 959, -1, -1, 
	959, 959, 959, 959, 959, 959, -1, -1, 
	-1, -1, 959, 959, 959, 959, 959, 959, 
	959, -1, -1, -1, -1, 959, -1, -1, 
	-1, -1, 959, 959, -1, -1, 959, 959, 
	959, -1, 959, 959, -1, -1, 959, -1, 
	-1, -1, -1, -1, -1, -1, -1, 959, 
	959, 959, 959, 959, 959, 959, -1, -1, 
	-1, 959, 959, 959, -1, -1, 959, 959, 
	-1, 959, 959, 959, 959, 959, -1, 959, 
	959, 959, -1, -1, -1, 959, 959, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 959, 959, 959, -1, -1, 959, -1, 
	-1, -1, -1, 959, -1, 959, 959, 959, 
	959, -1, 959, 959, 959, 959, 959, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 959, -1, 959, -1, -1, 959, -1, 
	959, 959, -1, -1, -1, 959, -1, 959, 
	-1, 959, 979, 979, 979, 979, 979, 979, 
	979, 979, 979, 979, 979, 979, 979, 979, 
	979, 979, 979, 979, 979, 979, 979, 979, 
	979, 979, 979, 979, -1, 979, 979, 979, 
	979, 979, -1, 979, -1, 979, 979, 979, 
	979, -1, 979, -1, 979, 979, 979, -1, 
	979, 979, 979, 979, 979, 979, 979, 979, 
	979, 979, 979, 979, 979, -1, 979, 979, 
	979, 979, 979, 979, 979, 979, 979, 979, 
	979, 979, 979, 979, 979, -1, 979, -1, 
	-1, -1, -1, 979, 979, 979, 979, 979, 
	-1, -1, 979, 979, 979, 979, 979, 979, 
	979, 979, 979, 979, 979, 979, 979, 979, 
	979, 979, -1, -1, -1, -1, -1, 979, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 959, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 979, 979, 
	979, 979, -1, -1, 979, 979, 979, 979, 
	979, 979, -1, -1, -1, -1, 979, 979, 
	979, 979, 979, 979, 979, -1, -1, -1, 
	-1, 979, -1, -1, -1, -1, 979, 979, 
	-1, -1, 979, 979, 979, -1, 979, 979, 
	-1, -1, 979, -1, -1, -1, -1, -1, 
	-1, -1, -1, 979, 979, 979, 979, 979, 
	979, 979, -1, -1, -1, 979, 979, 979, 
	-1, -1, 979, 979, -1, 979, 979, 979, 
	979, 979, -1, 979, 979, 979, -1, -1, 
	-1, 979, 979, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 979, 979, 979, 
	-1, -1, 979, -1, -1, -1, -1, 979, 
	-1, 979, 979, 979, 979, -1, 979, 979, 
	979, 979, 979, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 979, -1, 979, 
	-1, -1, 979, -1, 979, 979, -1, -1, 
	-1, 979, -1, 979, -1, 979, 983, 983, 
	983, 983, 983, 983, 983, 983, 983, 983, 
	983, 983, 983, 983, 983, 983, 983, 983, 
	983, 983, 983, 983, 983, 983, 983, 983, 
	983, 983, 983, 983, 983, 983, -1, 983, 
	-1, 983, 983, 983, 983, 983, 983, -1, 
	983, 983, 983, -1, -1, 983, 983, 983, 
	983, 983, 983, 983, 983, -1, 983, 983, 
	983, 983, -1, -1, -1, 983, 983, 983, 
	983, 983, -1, -1, 983, 983, 983, 983, 
	-1, -1, -1, 983, -1, -1, -1, 983, 
	983, -1, 983, -1, -1, 983, -1, -1, 
	983, -1, 983, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 983, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 983, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	979, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 983, 983, 983, 983, -1, -1, 
	983, 983, 983, 983, 983, 983, -1, -1, 
	-1, -1, 983, 983, 983, 983, 983, 983, 
	983, -1, -1, 983, -1, 983, -1, -1, 
	-1, -1, 983, 983, -1, 983, 983, 983, 
	983, -1, 983, 983, -1, -1, 983, -1, 
	-1, -1, -1, -1, 983, -1, 983, 983, 
	983, 983, 983, 983, 983, 983, -1, -1, 
	-1, -1, 983, 983, -1, 983, 983, 983, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	983, 983, -1, -1, 983, -1, 983, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	983, 983, 983, -1, -1, 983, 983, 983, 
	-1, -1, -1, -1, -1, 983, 983, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 983, -1, 983, -1, -1, 983, 983, 
	983, 994, 994, 994, 994, 994, 994, 994, 
	994, 994, 994, 994, 994, 994, 994, 994, 
	994, 994, 994, 994, 994, 994, 994, 994, 
	994, 994, 994, 994, 994, 994, 994, 994, 
	994, -1, 994, -1, 994, 994, 994, 994, 
	994, 994, -1, 994, 994, 994, -1, -1, 
	994, 994, 994, 994, 994, 994, 994, 994, 
	-1, 994, 994, 994, 994, -1, -1, -1, 
	994, 994, 994, 994, 994, -1, 994, 994, 
	994, 994, 994, 994, -1, -1, 994, -1, 
	-1, -1, 994, 994, -1, 994, -1, -1, 
	994, -1, -1, 994, -1, 994, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 994, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 994, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 994, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 983, 994, 994, 994, 
	994, -1, -1, 994, 994, 994, 994, 994, 
	994, -1, -1, -1, -1, 994, 994, 994, 
	994, 994, 994, 994, -1, -1, 994, -1, 
	994, -1, -1, -1, -1, 994, 994, -1, 
	994, 994, 994, 994, -1, 994, 994, -1, 
	-1, 994, 994, 994, -1, -1, -1, 994, 
	-1, 994, 994, 994, 994, 994, 994, 994, 
	994, -1, -1, -1, -1, 994, 994, -1, 
	994, 994, 994, -1, -1, -1, -1, -1, 
	-1, -1, -1, 994, 994, -1, -1, 994, 
	-1, 994, 994, -1, -1, -1, 994, 994, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 994, 994, 994, -1, -1, 
	994, 994, 994, -1, -1, -1, -1, -1, 
	994, 994, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 994, -1, 994, -1, 
	-1, 994, 994, 994, -1, -1, 994, 995, 
	995, 995, 995, 995, 995, 995, 995, 995, 
	995, 995, 995, 995, 995, 995, 995, 995, 
	995, 995, 995, 995, 995, 995, 995, 995, 
	995, 995, 995, 995, 995, 995, 995, -1, 
	995, -1, 995, 995, 995, 995, 995, 995, 
	-1, 995, 995, 995, -1, -1, 995, 995, 
	995, 995, 995, 995, 995, 995, -1, 995, 
	995, 995, 995, -1, -1, -1, 995, 995, 
	995, 995, 995, -1, 995, 995, 995, 995, 
	995, 995, -1, -1, 995, -1, -1, -1, 
	995, 995, -1, 995, -1, -1, 995, -1, 
	-1, 995, -1, 995, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 995, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 995, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 995, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 994, 
	-1, -1, -1, 995, 995, 995, 995, -1, 
	-1, 995, 995, 995, 995, 995, 995, -1, 
	-1, -1, -1, 995, 995, 995, 995, 995, 
	995, 995, -1, -1, 995, -1, 995, -1, 
	-1, -1, -1, 995, 995, -1, 995, 995, 
	995, 995, -1, 995, 995, -1, -1, 995, 
	995, 995, -1, -1, -1, 995, -1, 995, 
	995, 995, 995, 995, 995, 995, 995, -1, 
	-1, -1, -1, 995, 995, -1, 995, 995, 
	995, -1, -1, -1, -1, -1, -1, -1, 
	-1, 995, 995, -1, -1, 995, -1, 995, 
	995, -1, -1, -1, 995, 995, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 995, 995, 995, -1, -1, 995, 995, 
	995, -1, -1, -1, -1, -1, 995, 995, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 995, -1, 995, -1, -1, 995, 
	995, 995, -1, -1, 995, 996, 996, 996, 
	996, 996, 996, 996, 996, 996, 996, 996, 
	996, 996, 996, 996, 996, 996, 996, 996, 
	996, 996, 996, 996, 996, 996, 996, 996, 
	996, 996, 996, 996, 996, -1, 996, -1, 
	996, 996, 996, 996, 996, 996, -1, 996, 
	996, 996, -1, -1, 996, 996, 996, 996, 
	996, 996, 996, 996, -1, 996, 996, 996, 
	996, -1, -1, -1, 996, 996, 996, 996, 
	996, -1, 996, 996, 996, 996, 996, 996, 
	-1, -1, 996, -1, -1, -1, 996, 996, 
	-1, 996, -1, -1, 996, -1, -1, 996, 
	-1, 996, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 996, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 996, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 996, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 995, -1, -1, 
	-1, 996, 996, 996, 996, -1, -1, 996, 
	996, 996, 996, 996, 996, -1, -1, -1, 
	-1, 996, 996, 996, 996, 996, 996, 996, 
	-1, -1, 996, -1, 996, -1, -1, -1, 
	-1, 996, 996, -1, 996, 996, 996, 996, 
	-1, 996, 996, -1, -1, 996, 996, 996, 
	-1, -1, -1, 996, -1, 996, 996, 996, 
	996, 996, 996, 996, 996, -1, -1, -1, 
	-1, 996, 996, -1, 996, 996, 996, -1, 
	-1, -1, -1, -1, -1, -1, -1, 996, 
	996, -1, -1, 996, -1, 996, 996, -1, 
	-1, -1, 996, 996, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 996, 
	996, 996, -1, -1, 996, 996, 996, -1, 
	-1, -1, -1, -1, 996, 996, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	996, -1, 996, -1, -1, 996, 996, 996, 
	-1, -1, 996, 64, 67, 68, 65, 66, 
	73, 74, -1, 69, 70, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 138, 139, 
	141, 140, 142, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 75, -1, -1, 
	-1, 131, -1, -1, -1, 135, 136, 137, 
	72, 71, 130, -1, -1, -1, -1, 124, 
	125, 126, -1, -1, -1, -1, 993, 122, 
	-1, 144, 145, 146, 147, -1, -1, -1, 
	-1, -1, -1, -1, 127, 1137, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 117, 118, 119, -1, 120, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 840, 840, 840, 840, 
	840, 840, 840, 840, 840, 840, 840, 840, 
	840, 840, 840, -1, 840, 840, 840, 840, 
	840, 840, 840, 840, -1, -1, -1, 840, 
	840, 840, 840, 840, -1, 840, -1, 840, 
	840, 840, 840, -1, 840, -1, 840, 840, 
	840, -1, -1, 840, -1, -1, 840, 840, 
	840, 840, 840, 996, 840, 840, 840, -1, 
	-1, -1, -1, 840, 840, 840, 840, 840, 
	-1, -1, 840, 840, 840, 840, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 529, 113, 
	114, 115, 116, -1, 121, 129, 133, -1, 
	-1, -1, 528, 132, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 143, 
	134, 128, 123, 993, -1, -1, -1, -1, 
	840, 840, 840, 840, -1, -1, 840, 840, 
	840, 840, 840, 840, -1, -1, 593, -1, 
	840, 840, 840, 840, 840, 840, 840, -1, 
	-1, -1, -1, 840, -1, -1, -1, -1, 
	840, 840, -1, -1, 840, 840, 840, -1, 
	840, 840, -1, -1, 840, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	840, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 840, 840, -1, -1, 
	-1, -1, -1, -1, -1, -1, 840, 840, 
	-1, -1, -1, -1, 840, -1, -1, 55, 
	56, 64, 67, 68, 65, 66, 73, 74, 
	1135, 69, 70, -1, -1, 35, 36, 40, 
	38, -1, -1, 840, 840, 840, -1, -1, 
	-1, -1, -1, 840, 840, 41, 42, 43, 
	-1, -1, -1, 75, -1, -1, -1, 840, 
	37, 840, -1, -1, 840, -1, 72, 71, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 59, -1, -1, 82, 
	84, 86, 88, -1, 55, 56, 64, 67, 
	68, 65, 66, 73, 74, 1135, 69, 70, 
	-1, -1, 35, 36, 40, 38, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 41, 42, 43, -1, -1, -1, 
	75, -1, -1, -1, -1, 37, -1, -1, 
	-1, -1, -1, 72, 71, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 59, -1, -1, 82, 84, 86, 88, 
	55, 56, 64, 67, 68, 65, 66, 73, 
	74, 276, 69, 70, -1, -1, 35, 36, 
	40, 38, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 41, 42, 
	43, -1, -1, -1, 75, -1, -1, -1, 
	-1, 37, -1, -1, -1, -1, -1, 72, 
	71, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 59, -1, -1, 
	598, 599, 600, 601, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 276, -1, -1, 
	-1, -1, 840, -1, -1, 299, -1, -1, 
	-1, -1, -1, -1, -1, 1135, 1135, 595, 
	-1, 34, 33, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 62, -1, -1, -1, 
	-1, 44, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	80, 76, 45, -1, -1, -1, -1, -1, 
	39, 993, -1, -1, -1, -1, -1, -1, 
	-1, -1, 277, -1, -1, -1, -1, -1, 
	-1, 602, -1, 298, -1, -1, 34, 33, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 62, -1, -1, -1, -1, 44, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 80, 76, 45, 
	-1, -1, -1, -1, -1, 39, 993, -1, 
	-1, -1, -1, -1, -1, -1, 277, -1, 
	-1, -1, -1, -1, -1, 596, -1, -1, 
	-1, -1, 34, 33, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 62, -1, -1, 
	-1, -1, 44, -1, -1, -1, -1, -1, 
	-1, -1, 217, 216, 597, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 80, 76, 45, -1, -1, -1, -1, 
	-1, 39, 993, -1, -1, -1, -1, -1, 
	933, 933, 933, 933, 933, 933, 933, 933, 
	933, -1, 933, 933, -1, -1, 933, 933, 
	933, 933, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 933, 933, 
	933, -1, -1, -1, 933, -1, -1, -1, 
	-1, 933, -1, -1, -1, -1, -1, 933, 
	933, -1, 529, 113, 114, 115, 116, -1, 
	121, 129, 133, -1, -1, 933, 528, 132, 
	933, 933, 933, 933, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 933, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 143, 134, 128, 123, -1, 
	274, 275, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 593, -1, -1, 767, 767, 767, 
	767, 767, 767, 767, 767, 767, 767, 767, 
	767, 767, 767, 767, 767, 767, 767, 767, 
	767, 767, 767, 767, 767, 767, 767, -1, 
	767, 767, 767, 767, 767, -1, 767, -1, 
	767, 767, 767, 767, -1, 767, -1, 767, 
	767, 767, -1, -1, 767, 767, 767, 767, 
	767, 767, 767, 767, -1, 767, 767, 767, 
	-1, -1, -1, -1, 767, 767, 767, 767, 
	767, -1, -1, 767, 767, 767, 767, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 767, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 933, -1, 
	-1, -1, -1, -1, -1, 933, -1, -1, 
	-1, -1, 933, 933, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 933, -1, -1, 
	-1, -1, 933, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 933, 933, 933, -1, -1, -1, -1, 
	-1, 933, 933, -1, -1, -1, -1, -1, 
	-1, 767, 767, 767, 767, -1, -1, 767, 
	767, -1, 767, 767, 767, -1, -1, -1, 
	-1, 767, 767, 767, -1, 767, 767, 767, 
	-1, -1, -1, -1, 767, -1, -1, -1, 
	-1, 767, -1, -1, -1, 767, 767, 767, 
	-1, 767, 767, -1, -1, 767, -1, -1, 
	-1, -1, -1, -1, -1, -1, 767, 767, 
	767, 767, 767, 767, 767, -1, -1, -1, 
	-1, 767, 767, -1, -1, 767, 767, -1, 
	-1, -1, -1, -1, -1, -1, -1, 767, 
	767, -1, -1, -1, -1, 767, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 767, 767, 767, -1, 
	-1, -1, -1, -1, 767, 767, -1, -1, 
	-1, 299, -1, -1, -1, -1, -1, -1, 
	767, -1, -1, 595, -1, 34, 33, 767, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	62, -1, -1, -1, -1, 44, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 80, 76, 45, -1, 
	-1, -1, -1, -1, 39, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 277, -1, 
	-1, -1, -1, -1, -1, 602, -1, 298, 
	-1, -1, 34, 33, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 62, -1, -1, 
	-1, -1, 44, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 80, 76, 45, -1, -1, -1, -1, 
	-1, 39, -1, -1, -1, -1, -1, -1, 
	-1, -1, 277, -1, -1, -1, -1, -1, 
	-1, 596, -1, -1, -1, -1, 34, 33, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 62, -1, -1, -1, -1, 44, -1, 
	-1, -1, -1, -1, -1, -1, 217, 216, 
	597, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 767, -1, 80, 76, 45, 
	-1, -1, -1, -1, -1, 39, 914, 914, 
	914, 914, 914, 914, 914, 914, 914, 914, 
	914, 914, 914, 914, 914, 914, 914, 914, 
	914, 914, 914, 914, 914, 914, 914, 914, 
	-1, 914, 914, 914, 914, 914, -1, 914, 
	-1, 914, 914, 914, 914, -1, 914, -1, 
	914, 914, 914, -1, -1, 914, 914, 914, 
	914, 914, 914, 914, 914, -1, 914, 914, 
	914, -1, -1, -1, -1, 914, 914, 914, 
	914, 914, -1, -1, 914, 914, 914, 914, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 914, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 914, 914, 914, 914, -1, -1, 
	914, 914, -1, 914, 914, 914, -1, -1, 
	-1, -1, 914, 914, 914, -1, 914, 914, 
	914, -1, -1, -1, -1, 914, -1, -1, 
	-1, -1, 914, -1, -1, -1, 914, 914, 
	914, -1, 914, 914, -1, -1, 914, -1, 
	-1, -1, -1, -1, -1, -1, -1, 914, 
	914, 914, 914, 914, 914, 914, -1, -1, 
	-1, -1, 914, 914, -1, -1, 914, 914, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	914, 914, -1, -1, -1, -1, 914, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 914, 914, 914, 
	-1, -1, -1, -1, -1, 914, 914, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 914, -1, -1, -1, -1, -1, -1, 
	914, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 
	1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 
	1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 
	1011, 1011, 1011, -1, 1011, 1011, 1011, 1011, 
	1011, -1, 1011, -1, 1011, 1011, 1011, 1011, 
	-1, 1011, -1, 1011, 1011, 1011, -1, 1011, 
	1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 
	1011, 1011, 1011, 1011, -1, 1011, 1011, 1011, 
	1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 
	1011, 1011, 1011, 1011, -1, 1011, -1, -1, 
	-1, -1, 1011, 1011, 1011, 1011, 1011, -1, 
	-1, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 
	1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 
	1011, -1, -1, -1, -1, -1, 1011, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 914, 1011, 1011, 1011, 
	1011, -1, -1, 1011, 1011, 1011, 1011, 1011, 
	1011, -1, -1, -1, -1, 1011, 1011, 1011, 
	1011, 1011, 1011, 1011, -1, -1, -1, -1, 
	1011, -1, -1, -1, -1, 1011, 1011, -1, 
	-1, 1011, 1011, 1011, -1, 1011, 1011, -1, 
	-1, 1011, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1011, 1011, 1011, 1011, 1011, 1011, 
	1011, -1, -1, -1, 1011, 1011, 1011, -1, 
	-1, 1011, 1011, -1, 1011, 1011, 1011, 1011, 
	1011, -1, 1011, 1011, 1011, -1, -1, -1, 
	1011, 1011, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1011, 1011, 1011, -1, 
	-1, 1011, -1, -1, -1, -1, 1011, -1, 
	1011, 1011, 1011, 1011, -1, 1011, 1011, 1011, 
	1011, 1011, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1011, -1, 1011, -1, 
	-1, 1011, -1, 1011, 1011, -1, -1, -1, 
	1011, -1, 1011, -1, 1011, 1010, 1010, 1010, 
	1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 
	1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 
	1010, 1010, 1010, 1010, 1010, 1010, 1010, -1, 
	1010, 1010, 1010, 1010, 1010, -1, 1010, -1, 
	1010, 1010, 1010, 1010, -1, 1010, -1, 1010, 
	1010, 1010, -1, 1010, 1010, 1010, 1010, 1010, 
	1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 
	-1, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 
	1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 
	-1, 1010, -1, -1, -1, -1, 1010, 1010, 
	1010, 1010, 1010, -1, -1, 1010, 1010, 1010, 
	1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 
	1010, 1010, 1010, 1010, 1010, -1, -1, -1, 
	-1, -1, 1010, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1011, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1010, 1010, 1010, 1010, -1, -1, 1010, 
	1010, 1010, 1010, 1010, 1010, -1, -1, -1, 
	-1, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 
	-1, -1, -1, -1, 1010, -1, -1, -1, 
	-1, 1010, 1010, -1, -1, 1010, 1010, 1010, 
	-1, 1010, 1010, -1, -1, 1010, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1010, 1010, 
	1010, 1010, 1010, 1010, 1010, -1, -1, -1, 
	1010, 1010, 1010, -1, -1, 1010, 1010, -1, 
	1010, 1010, 1010, 1010, 1010, -1, 1010, 1010, 
	1010, -1, -1, -1, 1010, 1010, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1010, 1010, 1010, -1, -1, 1010, -1, -1, 
	-1, -1, 1010, -1, 1010, 1010, 1010, 1010, 
	-1, 1010, 1010, 1010, 1010, 1010, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1010, -1, 1010, -1, -1, 1010, -1, 1010, 
	1010, -1, -1, -1, 1010, -1, 1010, -1, 
	1010, 863, 863, 863, 863, 863, 863, 863, 
	863, 863, 863, 863, 863, 863, 863, 863, 
	-1, 863, 863, 863, 863, 863, 863, 863, 
	863, -1, -1, -1, 863, 863, 863, 863, 
	863, -1, 863, -1, 863, 863, 863, 863, 
	-1, 863, -1, 863, 863, 863, -1, -1, 
	863, -1, -1, 863, 863, 863, 863, 863, 
	-1, 863, 863, 863, 863, -1, -1, -1, 
	863, 863, 863, 863, 863, -1, 863, 863, 
	863, 863, 863, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1010, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 863, 863, 863, 
	863, -1, -1, 863, 863, 863, 863, 863, 
	863, -1, -1, -1, -1, 863, 863, 863, 
	863, 863, 863, 863, -1, 863, 863, -1, 
	863, -1, -1, -1, -1, 863, 863, -1, 
	-1, 863, 863, 863, -1, 863, 863, -1, 
	-1, 863, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 863, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 863, 863, -1, -1, -1, -1, -1, 
	-1, -1, -1, 863, 863, -1, -1, -1, 
	-1, 863, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	863, 863, 863, -1, -1, -1, -1, -1, 
	863, 863, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 863, -1, 863, -1, 
	-1, 863, -1, -1, 831, 831, 831, 831, 
	831, 831, 831, 831, 831, 831, 831, 831, 
	831, 831, 831, -1, 831, 831, 831, 831, 
	831, 831, 831, 831, -1, -1, -1, 831, 
	831, 831, 831, 831, -1, 831, -1, 831, 
	831, 831, 831, -1, 831, -1, 831, 831, 
	831, -1, -1, 831, -1, -1, 831, 831, 
	831, 831, 831, -1, 831, 831, 831, -1, 
	-1, -1, -1, 831, 831, 831, 831, 831, 
	-1, -1, 831, 831, 831, 831, -1, 1058, 
	1058, 1058, 1058, 1058, 1058, 1058, -1, 1058, 
	1058, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1058, 1058, 1058, 1058, 1058, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1058, -1, -1, -1, 1058, -1, -1, 
	-1, 1058, 1058, 1058, 1058, 1058, 1058, -1, 
	-1, -1, -1, 1058, 1058, 1058, -1, -1, 
	-1, -1, 1058, 1058, -1, 1058, 1058, 1058, 
	1058, 1058, -1, -1, -1, -1, -1, -1, 
	1058, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1058, 1058, 
	1058, 1058, 1058, -1, -1, 274, 275, 863, 
	831, 831, 831, 831, 1058, -1, 831, 831, 
	-1, 831, 831, 831, -1, -1, -1, -1, 
	831, 831, 831, -1, 831, 831, 831, -1, 
	-1, -1, -1, 831, -1, -1, -1, -1, 
	831, 831, -1, -1, 831, 831, 831, -1, 
	831, 831, -1, -1, 831, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	831, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 831, 831, -1, -1, 
	-1, -1, -1, -1, -1, -1, 831, 831, 
	-1, -1, -1, -1, 831, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 831, 831, 831, -1, -1, 
	-1, -1, -1, 831, 831, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 831, 
	-1, -1, -1, -1, 831, -1, -1, -1, 
	-1, -1, 1058, 1058, 1058, 1058, 1058, -1, 
	1058, 1058, 1058, -1, -1, -1, -1, 1058, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1058, 1058, 1058, -1, -1, -1, 
	-1, -1, -1, -1, 1058, -1, -1, -1, 
	-1, -1, -1, 1058, 1058, 1058, 1058, 1058, 
	836, 836, 836, 836, 836, 836, 836, 836, 
	836, 836, 836, 836, 836, 836, 836, -1, 
	836, 836, 836, 836, 836, 836, 836, 836, 
	1058, -1, -1, 836, 836, 836, 836, 836, 
	-1, 836, -1, 836, 836, 836, 836, -1, 
	836, -1, 836, 836, 836, -1, -1, 836, 
	-1, -1, 836, 836, 836, 836, 836, -1, 
	836, 836, 836, -1, -1, -1, -1, 836, 
	836, 836, 836, 836, -1, -1, 836, 836, 
	836, 836, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 836, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 831, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 836, 836, 836, 836, 
	-1, -1, 836, 836, 836, 836, 836, 836, 
	-1, -1, -1, -1, 836, 836, 836, 836, 
	836, 836, 836, -1, -1, -1, -1, 836, 
	-1, -1, -1, -1, 836, 836, -1, -1, 
	836, 836, 836, -1, 836, 836, -1, -1, 
	836, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 836, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	836, 836, -1, -1, -1, -1, -1, -1, 
	-1, -1, 836, 836, -1, -1, -1, -1, 
	836, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 836, 
	836, 836, -1, -1, -1, -1, -1, 836, 
	836, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 836, -1, 836, -1, -1, 
	836, -1, -1, 859, 859, 859, 859, 859, 
	859, 859, 859, 859, 859, 859, 859, 859, 
	859, 859, -1, 859, 859, 859, 859, 859, 
	859, 859, 859, -1, -1, -1, 859, 859, 
	859, 859, 859, -1, 859, -1, 859, 859, 
	859, 859, -1, 859, -1, 859, 859, 859, 
	-1, -1, 859, -1, -1, 859, 859, 859, 
	859, 859, -1, 859, 859, 859, -1, -1, 
	-1, -1, 859, 859, 859, 859, 859, -1, 
	-1, 859, 859, 859, 859, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 836, 859, 
	859, 859, 859, -1, -1, 859, 859, 859, 
	859, 859, 859, -1, -1, -1, -1, 859, 
	859, 859, 859, 859, 859, 859, -1, -1, 
	-1, -1, 859, -1, -1, -1, -1, 859, 
	859, -1, -1, 859, 859, 859, -1, 859, 
	859, -1, -1, 859, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 859, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 859, 859, -1, -1, -1, 
	-1, -1, -1, -1, -1, 859, 859, -1, 
	-1, -1, -1, 859, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 859, 859, 859, -1, -1, -1, 
	-1, -1, 859, 859, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 859, -1, 
	859, -1, -1, 859, -1, -1, 919, 919, 
	919, 919, 919, 919, 919, 919, 919, 919, 
	919, 919, 919, 919, 919, 919, 919, 919, 
	919, 919, 919, 919, 919, 919, 919, 919, 
	-1, 919, 919, 919, 919, 919, -1, 919, 
	-1, 919, 919, 919, 919, -1, 919, -1, 
	919, 919, 919, -1, -1, 919, 919, 919, 
	919, 919, 919, 919, 919, -1, 919, 919, 
	919, -1, -1, -1, -1, 919, 919, 919, 
	919, 919, -1, -1, 919, 919, 919, 919, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 919, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 859, 919, 919, 919, 919, -1, -1, 
	919, 919, -1, 919, 919, 919, -1, -1, 
	-1, -1, 919, 919, 919, -1, 919, 919, 
	919, -1, -1, -1, -1, 919, -1, -1, 
	-1, -1, 919, -1, -1, -1, 919, 919, 
	919, -1, 919, 919, -1, -1, 919, -1, 
	-1, -1, -1, -1, -1, -1, -1, 919, 
	919, 919, 919, 919, 919, 919, -1, -1, 
	-1, -1, 919, 919, -1, -1, 919, 919, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	919, 919, -1, -1, -1, -1, 919, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 919, 919, 919, 
	-1, -1, -1, -1, -1, 919, 919, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 919, -1, -1, -1, -1, -1, -1, 
	919, 887, 887, 887, 887, 887, 887, 887, 
	887, 887, 887, 887, 887, 887, 887, 887, 
	-1, 887, 887, 887, 887, 887, 887, 887, 
	887, -1, -1, -1, 887, 887, 887, 887, 
	887, -1, 887, -1, 887, 887, 887, 887, 
	-1, 887, -1, 887, 887, 887, -1, -1, 
	887, -1, -1, 887, 887, 887, 887, 887, 
	-1, 887, 887, 887, -1, -1, -1, -1, 
	887, 887, 887, 887, 887, -1, -1, 887, 
	887, 887, 887, -1, 610, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 919, 887, 887, 887, 
	887, -1, -1, 887, 887, 887, 887, 887, 
	887, -1, -1, -1, -1, 887, 887, 887, 
	887, 887, 887, 887, -1, -1, -1, -1, 
	887, -1, -1, -1, -1, 887, 887, -1, 
	-1, 887, 887, 887, -1, 887, 887, -1, 
	-1, 887, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 887, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 887, 887, -1, -1, -1, -1, -1, 
	-1, -1, -1, 887, 887, -1, -1, -1, 
	-1, 887, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	887, 887, 887, -1, -1, -1, -1, -1, 
	887, 887, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 887, -1, 887, -1, 
	-1, 887, -1, -1, 913, 913, 913, 913, 
	913, 913, 913, 913, 913, 913, 913, 913, 
	913, 913, 913, -1, 913, 913, 913, 913, 
	913, 913, 913, 913, -1, -1, -1, 913, 
	913, 913, 913, 913, -1, 913, -1, 913, 
	913, 913, 913, -1, 913, -1, 913, 913, 
	913, -1, -1, 913, -1, -1, 913, 913, 
	913, 913, 913, -1, 913, 913, 913, -1, 
	-1, -1, -1, 913, 913, 913, 913, 913, 
	-1, -1, 913, 913, 913, 913, -1, 913, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 887, 
	913, 913, 913, 913, -1, -1, 913, 913, 
	913, 913, 913, 913, -1, -1, -1, -1, 
	913, 913, 913, 913, 913, 913, 913, -1, 
	-1, -1, -1, 913, -1, -1, -1, -1, 
	913, 913, -1, -1, 913, 913, 913, -1, 
	913, 913, -1, -1, 913, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	913, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 913, 913, -1, -1, 
	-1, -1, -1, -1, -1, -1, 913, 913, 
	-1, -1, -1, -1, 913, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 913, 913, 913, -1, -1, 
	-1, -1, -1, 913, 913, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 913, 
	-1, 913, -1, -1, 913, -1, -1, 889, 
	889, 889, 889, 889, 889, 889, 889, 889, 
	889, 889, 889, 889, 889, 889, -1, 889, 
	889, 889, 889, 889, 889, 889, 889, -1, 
	-1, -1, 889, 889, 889, 889, 889, -1, 
	889, -1, 889, 889, 889, 889, -1, 889, 
	-1, 889, 889, 889, -1, -1, 889, -1, 
	-1, 889, 889, 889, 889, 889, -1, 889, 
	889, 889, -1, -1, -1, -1, 889, 889, 
	889, 889, 889, -1, -1, 889, 889, 889, 
	889, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 913, 889, 889, 889, 889, -1, 
	-1, 889, 889, 889, 889, 889, 889, -1, 
	-1, -1, -1, 889, 889, 889, 889, 889, 
	889, 889, -1, -1, -1, -1, 889, -1, 
	-1, -1, -1, 889, 889, -1, -1, 889, 
	889, 889, -1, 889, 889, -1, -1, 889, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 889, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 889, 
	889, -1, -1, -1, -1, -1, -1, -1, 
	-1, 889, 889, -1, -1, -1, -1, 889, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 889, 889, 
	889, -1, -1, -1, -1, -1, 889, 889, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 889, -1, 889, -1, -1, 889, 
	-1, -1, 898, 898, 898, 898, 898, 898, 
	898, 898, 898, 898, 898, 898, 898, 898, 
	898, -1, 898, 898, 898, 898, 898, 898, 
	898, 898, -1, -1, -1, 898, 898, 898, 
	898, 898, -1, 898, -1, 898, 898, 898, 
	898, -1, 898, -1, 898, 898, 898, -1, 
	-1, 898, -1, -1, 898, 898, 898, 898, 
	898, -1, 898, 898, 898, -1, -1, -1, 
	-1, 898, 898, 898, 898, 898, -1, -1, 
	898, 898, 898, 898, 64, 67, 68, 65, 
	66, 73, 74, -1, 69, 70, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 138, 
	139, 141, 140, 142, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 75, -1, 
	-1, -1, 131, -1, -1, -1, 135, 136, 
	137, 72, 71, 130, -1, -1, -1, -1, 
	124, 125, 126, -1, -1, -1, -1, 993, 
	122, -1, 144, 145, 146, 147, -1, -1, 
	-1, -1, -1, -1, -1, 127, 1137, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 117, 118, 119, -1, 120, 
	-1, -1, -1, -1, -1, 889, 898, 898, 
	898, 898, -1, -1, 898, 898, 898, 898, 
	898, 898, -1, -1, -1, -1, 898, 898, 
	898, 898, 898, 898, 898, -1, -1, -1, 
	-1, 898, -1, -1, -1, -1, 898, 898, 
	-1, -1, 898, 898, 898, -1, 898, 898, 
	-1, -1, 898, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 898, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 898, 898, -1, -1, -1, -1, 
	-1, -1, -1, -1, 898, 898, -1, -1, 
	-1, -1, 898, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 898, 898, 898, -1, -1, -1, -1, 
	-1, 898, 898, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 898, -1, 898, 
	-1, -1, 898, -1, -1, -1, -1, 529, 
	113, 114, 115, 116, -1, 121, 129, 133, 
	-1, -1, -1, 528, 132, 1002, 1002, 1002, 
	1002, 1002, 1002, 1002, -1, 1002, 1002, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1002, 1002, 1002, 1002, 1002, -1, -1, -1, 
	143, 134, 128, 123, 993, -1, -1, 1002, 
	-1, -1, -1, 1002, -1, -1, -1, 1002, 
	1002, 1002, 1002, 1002, 1002, -1, -1, 632, 
	-1, 1002, 1002, 1002, -1, -1, -1, -1, 
	1002, 1002, -1, 1002, 1002, 1002, 1002, -1, 
	-1, -1, -1, -1, -1, -1, 1002, 1002, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1002, 1002, 1002, -1, 
	1002, -1, -1, 274, 275, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1003, 
	1003, 1003, 1003, 1003, 1003, 1003, 1003, 1003, 
	1003, 1003, 1003, 1003, 1003, 1003, 1003, 1003, 
	1003, 1003, 1003, 1003, 1003, 1003, 1003, 1003, 
	1003, -1, 1003, 1003, 1003, 1003, 1003, -1, 
	1003, -1, 1003, 1003, 1003, 1003, -1, 1003, 
	898, 1003, 1003, 1003, -1, 1003, 1003, 1003, 
	1003, 1003, 1003, 1003, 1003, 1003, 1003, 1003, 
	1003, 1003, -1, 1003, 1003, 1003, 1003, 1003, 
	1003, 1003, 1003, 1003, 1003, 1003, 1003, 1003, 
	1003, 1003, -1, 1003, -1, -1, -1, -1, 
	1003, 1003, 1003, 1003, 1003, -1, -1, 1003, 
	1003, 1003, 1003, 1003, 1003, 1003, 1003, 1003, 
	1003, 1003, 1003, 1003, 1003, 1003, 1003, -1, 
	-1, -1, -1, -1, 1003, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1002, 1002, 1002, 1002, 1002, -1, 1002, 1002, 
	1002, -1, -1, -1, 1002, 1002, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1002, 1002, 1002, 1002, 1002, -1, -1, 
	-1, -1, -1, 1003, 1003, 1003, 1003, -1, 
	-1, 1003, 1003, 1003, 1003, 1003, 1003, -1, 
	1002, -1, -1, 1003, 1003, 1003, 1003, 1003, 
	1003, 1003, -1, -1, -1, -1, 1003, -1, 
	-1, -1, -1, 1003, 1003, -1, -1, 1003, 
	1003, 1003, -1, 1003, 1003, -1, -1, 1003, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1003, 1003, 1003, 1003, 1003, 1003, 1003, -1, 
	-1, -1, 1003, 1003, 1003, -1, -1, 1003, 
	1003, -1, 1003, 1003, 1003, 1003, 1003, -1, 
	1003, 1003, 1003, -1, -1, -1, 1003, 1003, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1003, 1003, 1003, -1, -1, 1003, 
	-1, -1, -1, -1, 1003, -1, 1003, 1003, 
	1003, 1003, -1, 1003, 1003, 1003, 1003, 1003, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1003, -1, 1003, -1, -1, 1003, 
	-1, 1003, 1003, -1, -1, -1, 1003, -1, 
	1003, -1, 1003, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 
	1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 
	1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 
	1006, 1006, 1006, -1, 1006, 1006, 1006, 1006, 
	1006, -1, 1006, -1, 1006, 1006, 1006, 1006, 
	-1, 1006, -1, 1006, 1006, 1006, -1, 1006, 
	1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 
	1006, 1006, 1006, 1006, -1, 1006, 1006, 1006, 
	1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 
	1006, 1006, 1006, 1006, -1, 1006, -1, -1, 
	-1, -1, 1006, 1006, 1006, 1006, 1006, -1, 
	-1, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 
	1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 
	1006, -1, -1, -1, -1, -1, 1006, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1003, -1, -1, 
	-1, -1, -1, 529, 113, 114, 115, 116, 
	-1, 121, 129, 133, -1, -1, -1, 528, 
	132, -1, -1, -1, -1, 1006, 1006, 1006, 
	1006, -1, -1, 1006, 1006, 1006, 1006, 1006, 
	1006, -1, -1, -1, -1, 1006, 1006, 1006, 
	1006, 1006, 1006, 1006, 143, 134, 128, 123, 
	1006, -1, -1, -1, -1, 1006, 1006, -1, 
	-1, 1006, 1006, 1006, -1, 1006, 1006, -1, 
	-1, 1006, -1, 632, -1, -1, -1, -1, 
	-1, -1, 1006, 1006, 1006, 1006, 1006, 1006, 
	1006, -1, -1, -1, 1006, 1006, 1006, -1, 
	-1, 1006, 1006, -1, 1006, 1006, 1006, 1006, 
	1006, -1, 1006, 1006, 1006, -1, -1, -1, 
	1006, 1006, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1006, 1006, 1006, -1, 
	-1, 1006, -1, -1, -1, -1, 1006, -1, 
	1006, 1006, 1006, 1006, -1, 1006, 1006, 1006, 
	1006, 1006, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1006, -1, 1006, -1, 
	-1, 1006, -1, 1006, 1006, -1, -1, -1, 
	1006, -1, 1006, -1, 1006, 1007, 1007, 1007, 
	1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 
	1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 
	1007, 1007, 1007, 1007, 1007, 1007, 1007, -1, 
	1007, 1007, 1007, 1007, 1007, -1, 1007, -1, 
	1007, 1007, 1007, 1007, -1, 1007, -1, 1007, 
	1007, 1007, -1, 1007, 1007, 1007, 1007, 1007, 
	1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 
	-1, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 
	1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 
	-1, 1007, -1, -1, -1, -1, 1007, 1007, 
	1007, 1007, 1007, -1, -1, 1007, 1007, 1007, 
	1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 
	1007, 1007, 1007, 1007, 1007, -1, -1, -1, 
	-1, -1, 1007, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1006, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1007, 1007, 1007, 1007, -1, -1, 1007, 
	1007, 1007, 1007, 1007, 1007, -1, -1, -1, 
	-1, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 
	-1, -1, -1, -1, 1007, -1, -1, -1, 
	-1, 1007, 1007, -1, -1, 1007, 1007, 1007, 
	-1, 1007, 1007, -1, -1, 1007, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1007, 1007, 
	1007, 1007, 1007, 1007, 1007, -1, -1, -1, 
	1007, 1007, 1007, -1, -1, 1007, 1007, -1, 
	1007, 1007, 1007, 1007, 1007, -1, 1007, 1007, 
	1007, -1, -1, -1, 1007, 1007, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1007, 1007, 1007, -1, -1, 1007, -1, -1, 
	-1, -1, 1007, -1, 1007, 1007, 1007, 1007, 
	-1, 1007, 1007, 1007, 1007, 1007, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1007, -1, 1007, -1, -1, 1007, -1, 1007, 
	1007, -1, -1, -1, 1007, -1, 1007, -1, 
	1007, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 
	1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 
	1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 
	1004, 1004, 1004, -1, 1004, 1004, 1004, 1004, 
	1004, -1, 1004, -1, 1004, 1004, 1004, 1004, 
	-1, 1004, -1, 1004, 1004, 1004, -1, 1004, 
	1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 
	1004, 1004, 1004, 1004, -1, 1004, 1004, 1004, 
	1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 
	1004, 1004, 1004, 1004, -1, 1004, -1, -1, 
	-1, -1, 1004, 1004, 1004, 1004, 1004, -1, 
	-1, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 
	1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 
	1004, -1, -1, -1, -1, -1, 1004, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1007, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1004, 1004, 1004, 
	1004, -1, -1, 1004, 1004, 1004, 1004, 1004, 
	1004, -1, -1, -1, -1, 1004, 1004, 1004, 
	1004, 1004, 1004, 1004, -1, -1, -1, -1, 
	1004, -1, -1, -1, -1, 1004, 1004, -1, 
	-1, 1004, 1004, 1004, -1, 1004, 1004, -1, 
	-1, 1004, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1004, 1004, 1004, 1004, 1004, 1004, 
	1004, -1, -1, -1, 1004, 1004, 1004, -1, 
	-1, 1004, 1004, -1, 1004, 1004, 1004, 1004, 
	1004, -1, 1004, 1004, 1004, -1, -1, -1, 
	1004, 1004, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1004, 1004, 1004, -1, 
	-1, 1004, -1, -1, -1, -1, 1004, -1, 
	1004, 1004, 1004, 1004, -1, 1004, 1004, 1004, 
	1004, 1004, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1004, -1, 1004, -1, 
	-1, 1004, -1, 1004, 1004, -1, -1, -1, 
	1004, -1, 1004, -1, 1004, 1005, 1005, 1005, 
	1005, 1005, 1005, 1005, 1005, 1005, 1005, 1005, 
	1005, 1005, 1005, 1005, 1005, 1005, 1005, 1005, 
	1005, 1005, 1005, 1005, 1005, 1005, 1005, -1, 
	1005, 1005, 1005, 1005, 1005, -1, 1005, -1, 
	1005, 1005, 1005, 1005, -1, 1005, -1, 1005, 
	1005, 1005, -1, 1005, 1005, 1005, 1005, 1005, 
	1005, 1005, 1005, 1005, 1005, 1005, 1005, 1005, 
	-1, 1005, 1005, 1005, 1005, 1005, 1005, 1005, 
	1005, 1005, 1005, 1005, 1005, 1005, 1005, 1005, 
	-1, 1005, -1, -1, -1, -1, 1005, 1005, 
	1005, 1005, 1005, -1, -1, 1005, 1005, 1005, 
	1005, 1005, 1005, 1005, 1005, 1005, 1005, 1005, 
	1005, 1005, 1005, 1005, 1005, -1, -1, -1, 
	-1, -1, 1005, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1004, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1005, 1005, 1005, 1005, -1, -1, 1005, 
	1005, 1005, 1005, 1005, 1005, -1, -1, -1, 
	-1, 1005, 1005, 1005, 1005, 1005, 1005, 1005, 
	-1, -1, -1, -1, 1005, -1, -1, -1, 
	-1, 1005, 1005, -1, -1, 1005, 1005, 1005, 
	-1, 1005, 1005, -1, -1, 1005, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1005, 1005, 
	1005, 1005, 1005, 1005, 1005, -1, -1, -1, 
	1005, 1005, 1005, -1, -1, 1005, 1005, -1, 
	1005, 1005, 1005, 1005, 1005, -1, 1005, 1005, 
	1005, -1, -1, -1, 1005, 1005, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1005, 1005, 1005, -1, -1, 1005, -1, -1, 
	-1, -1, 1005, -1, 1005, 1005, 1005, 1005, 
	-1, 1005, 1005, 1005, 1005, 1005, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1005, -1, 1005, -1, -1, 1005, -1, 1005, 
	1005, -1, -1, -1, 1005, -1, 1005, -1, 
	1005, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 
	1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 
	1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 
	1012, 1012, 1012, -1, 1012, 1012, 1012, 1012, 
	1012, -1, 1012, -1, 1012, 1012, 1012, 1012, 
	-1, 1012, -1, 1012, 1012, 1012, -1, 1012, 
	1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 
	1012, 1012, 1012, 1012, -1, 1012, 1012, 1012, 
	1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 
	1012, 1012, 1012, 1012, -1, 1012, -1, -1, 
	-1, -1, 1012, 1012, 1012, 1012, 1012, -1, 
	-1, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 
	1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 
	1012, -1, -1, -1, -1, -1, 1012, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1005, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1012, 1012, 1012, 
	1012, -1, -1, 1012, 1012, 1012, 1012, 1012, 
	1012, -1, -1, -1, -1, 1012, 1012, 1012, 
	1012, 1012, 1012, 1012, -1, -1, -1, -1, 
	1012, -1, -1, -1, -1, 1012, 1012, -1, 
	-1, 1012, 1012, 1012, -1, 1012, 1012, -1, 
	-1, 1012, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1012, 1012, 1012, 1012, 1012, 1012, 
	1012, -1, -1, -1, 1012, 1012, 1012, -1, 
	-1, 1012, 1012, -1, 1012, 1012, 1012, 1012, 
	1012, -1, 1012, 1012, 1012, -1, -1, -1, 
	1012, 1012, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1012, 1012, 1012, -1, 
	-1, 1012, -1, -1, -1, -1, 1012, -1, 
	1012, 1012, 1012, 1012, -1, 1012, 1012, 1012, 
	1012, 1012, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1012, -1, 1012, -1, 
	-1, 1012, -1, 1012, 1012, -1, -1, -1, 
	1012, -1, 1012, -1, 1012, 1054, 1054, 1054, 
	1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 
	1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 
	1054, 1054, 1054, 1054, 1054, 1054, 1054, -1, 
	1054, 1054, 1054, 1054, 1054, -1, 1054, -1, 
	1054, 1054, 1054, 1054, -1, 1054, -1, 1054, 
	1054, 1054, -1, 1054, 1054, 1054, 1054, 1054, 
	1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 
	-1, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 
	1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 
	-1, 1054, -1, -1, -1, -1, 1054, 1054, 
	1054, 1054, 1054, -1, -1, 1054, 1054, 1054, 
	1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 
	1054, 1054, 1054, 1054, 1054, -1, -1, -1, 
	-1, -1, 1054, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1012, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1054, 1054, 1054, 1054, -1, -1, 1054, 
	1054, 1054, 1054, 1054, 1054, -1, -1, -1, 
	-1, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 
	-1, -1, -1, -1, 1054, -1, -1, -1, 
	-1, 1054, 1054, -1, -1, 1054, 1054, 1054, 
	-1, 1054, 1054, -1, -1, 1054, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1054, 1054, 
	1054, 1054, 1054, 1054, 1054, -1, -1, -1, 
	1054, 1054, 1054, -1, -1, 1054, 1054, -1, 
	1054, 1054, 1054, 1054, 1054, -1, 1054, 1054, 
	1054, -1, -1, -1, 1054, 1054, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1054, 1054, 1054, -1, -1, 1054, -1, -1, 
	-1, -1, 1054, -1, 1054, 1054, 1054, 1054, 
	-1, 1054, 1054, 1054, 1054, 1054, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1054, -1, 1054, -1, -1, 1054, -1, 1054, 
	1054, -1, -1, -1, 1054, -1, 1054, -1, 
	1054, 1053, 1053, 1053, 1053, 1053, 1053, 1053, 
	1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053, 
	1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053, 
	1053, 1053, 1053, -1, 1053, 1053, 1053, 1053, 
	1053, -1, 1053, -1, 1053, 1053, 1053, 1053, 
	-1, 1053, -1, 1053, 1053, 1053, -1, 1053, 
	1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053, 
	1053, 1053, 1053, 1053, -1, 1053, 1053, 1053, 
	1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053, 
	1053, 1053, 1053, 1053, -1, 1053, -1, -1, 
	-1, -1, 1053, 1053, 1053, 1053, 1053, -1, 
	-1, 1053, 1053, 1053, 1053, 1053, 1053, 1053, 
	1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053, 
	1053, -1, -1, -1, -1, -1, 1053, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1054, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1053, 1053, 1053, 
	1053, -1, -1, 1053, 1053, 1053, 1053, 1053, 
	1053, -1, -1, -1, -1, 1053, 1053, 1053, 
	1053, 1053, 1053, 1053, -1, -1, -1, -1, 
	1053, -1, -1, -1, -1, 1053, 1053, -1, 
	-1, 1053, 1053, 1053, -1, 1053, 1053, -1, 
	-1, 1053, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1053, 1053, 1053, 1053, 1053, 1053, 
	1053, -1, -1, -1, 1053, 1053, 1053, -1, 
	-1, 1053, 1053, -1, 1053, 1053, 1053, 1053, 
	1053, -1, 1053, 1053, 1053, -1, -1, -1, 
	1053, 1053, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1053, 1053, 1053, -1, 
	-1, 1053, -1, -1, -1, -1, 1053, -1, 
	1053, 1053, 1053, 1053, -1, 1053, 1053, 1053, 
	1053, 1053, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1053, -1, 1053, -1, 
	-1, 1053, -1, 1053, 1053, -1, -1, -1, 
	1053, -1, 1053, -1, 1053, 1040, 1040, 1040, 
	1040, 1040, 1040, 1040, -1, 1040, 1040, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1040, 1040, 1040, 1040, 1040, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1040, 
	-1, -1, -1, 1040, -1, -1, -1, 1040, 
	1040, 1040, 1040, 1040, 1040, -1, -1, -1, 
	-1, 1040, 1040, 1040, -1, -1, -1, -1, 
	1154, 1040, 1039, 1154, 1154, 1154, 1040, 1145, 
	-1, -1, -1, -1, -1, -1, 1040, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1040, 1040, 1040, 1040, 
	1040, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1031, 1031, 1031, 1031, 1031, 1031, 
	1031, 1031, 1031, 1031, 1031, 1031, 1031, 1031, 
	1031, 1031, 1031, 1031, 1031, 1031, 1031, 1031, 
	1031, 1031, 1031, 1031, -1, 1031, 1031, 1031, 
	1031, 1031, -1, 1031, -1, 1031, 1031, 1031, 
	1031, -1, 1031, -1, 1031, 1031, 1031, 1053, 
	1031, 1031, 1031, 1031, 1031, 1031, 1031, 1031, 
	1031, 1031, 1031, 1031, 1031, -1, 1031, 1031, 
	1031, 1031, 1031, 1031, 1031, 1031, 1031, 1031, 
	1031, 1031, 1031, 1031, 1031, -1, 1031, -1, 
	-1, -1, -1, 1031, 1031, 1031, 1031, 1031, 
	-1, -1, 1031, 1031, 1031, 1031, 1031, 1031, 
	1031, 1031, 1031, 1031, 1031, 1031, 1031, 1031, 
	1031, 1031, -1, -1, -1, -1, -1, 1031, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1040, 1040, 1040, 1040, 1040, -1, 1040, 1040, 
	1154, -1, -1, -1, -1, 1040, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1040, 642, 643, -1, -1, 641, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1040, 1040, 1040, 1040, 1040, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1031, 1031, 
	1031, 1031, -1, -1, 1031, 1031, 1031, 1031, 
	1031, 1031, -1, -1, 640, -1, 1031, 1031, 
	1031, 1031, 1031, 1031, 1031, -1, -1, -1, 
	-1, 1031, -1, -1, -1, -1, 1031, 1031, 
	-1, -1, 1031, 1031, 1031, -1, 1031, 1031, 
	-1, -1, 1031, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1031, 1031, 1031, 1031, 1031, 
	1031, 1031, -1, -1, -1, 1031, 1031, 1031, 
	1031, -1, 1031, 1031, -1, 1031, 1031, 1031, 
	1031, 1031, -1, 1031, 1031, 1031, -1, -1, 
	-1, 1031, 1031, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1031, 1031, 1031, 
	-1, -1, 1031, -1, -1, -1, -1, 1031, 
	-1, 1031, 1031, 1031, 1031, -1, 1031, 1031, 
	1031, 1031, 1031, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1031, -1, 1031, 
	-1, -1, 1031, -1, 1031, 1031, -1, -1, 
	-1, 1031, -1, 1031, -1, 1031, 1032, 1032, 
	1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 
	1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 
	1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 
	-1, 1032, 1032, 1032, 1032, 1032, -1, 1032, 
	-1, 1032, 1032, 1032, 1032, -1, 1032, -1, 
	1032, 1032, 1032, -1, 1032, 1032, 1032, 1032, 
	1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 
	1032, -1, 1032, 1032, 1032, 1032, 1032, 1032, 
	1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 
	1032, -1, 1032, -1, -1, -1, -1, 1032, 
	1032, 1032, 1032, 1032, -1, -1, 1032, 1032, 
	1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 
	1032, 1032, 1032, 1032, 1032, 1032, -1, -1, 
	-1, -1, -1, 1032, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1031, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1032, 1032, 1032, 1032, -1, -1, 
	1032, 1032, 1032, 1032, 1032, 1032, -1, -1, 
	-1, -1, 1032, 1032, 1032, 1032, 1032, 1032, 
	1032, -1, -1, -1, -1, 1032, -1, -1, 
	-1, -1, 1032, 1032, -1, -1, 1032, 1032, 
	1032, -1, 1032, 1032, -1, -1, 1032, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1032, 
	1032, 1032, 1032, 1032, 1032, 1032, -1, -1, 
	-1, 1032, 1032, 1032, 1032, -1, 1032, 1032, 
	-1, 1032, 1032, 1032, 1032, 1032, -1, 1032, 
	1032, 1032, -1, -1, -1, 1032, 1032, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1032, 1032, 1032, -1, -1, 1032, -1, 
	-1, -1, -1, 1032, -1, 1032, 1032, 1032, 
	1032, -1, 1032, 1032, 1032, 1032, 1032, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1032, -1, 1032, -1, -1, 1032, -1, 
	1032, 1032, -1, -1, -1, 1032, -1, 1032, 
	-1, 1032, 1033, 1033, 1033, 1033, 1033, 1033, 
	1033, 1033, 1033, 1033, 1033, 1033, 1033, 1033, 
	1033, 1033, 1033, 1033, 1033, 1033, 1033, 1033, 
	1033, 1033, 1033, 1033, -1, 1033, 1033, 1033, 
	1033, 1033, -1, 1033, -1, 1033, 1033, 1033, 
	1033, -1, 1033, -1, 1033, 1033, 1033, -1, 
	1033, 1033, 1033, 1033, 1033, 1033, 1033, 1033, 
	1033, 1033, 1033, 1033, 1033, -1, 1033, 1033, 
	1033, 1033, 1033, 1033, 1033, 1033, 1033, 1033, 
	1033, 1033, 1033, 1033, 1033, -1, 1033, -1, 
	-1, -1, -1, 1033, 1033, 1033, 1033, 1033, 
	-1, -1, 1033, 1033, 1033, 1033, 1033, 1033, 
	1033, 1033, 1033, 1033, 1033, 1033, 1033, 1033, 
	1033, 1033, -1, -1, -1, -1, -1, 1033, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 642, 643, -1, 
	-1, 641, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1032, -1, -1, -1, 
	640, -1, -1, -1, -1, -1, 1033, 1033, 
	1033, 1033, -1, -1, 1033, 1033, 1033, 1033, 
	1033, 1033, -1, -1, -1, -1, 1033, 1033, 
	1033, 1033, 1033, 1033, 1033, -1, -1, -1, 
	-1, 1033, -1, -1, -1, -1, 1033, 1033, 
	-1, -1, 1033, 1033, 1033, -1, 1033, 1033, 
	-1, -1, 1033, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1033, 1033, 1033, 1033, 1033, 
	1033, 1033, -1, -1, -1, 1033, 1033, 1033, 
	1033, -1, 1033, 1033, -1, 1033, 1033, 1033, 
	1033, 1033, -1, 1033, 1033, 1033, -1, -1, 
	-1, 1033, 1033, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1033, 1033, 1033, 
	-1, -1, 1033, -1, -1, -1, -1, 1033, 
	-1, 1033, 1033, 1033, 1033, -1, 1033, 1033, 
	1033, 1033, 1033, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1033, -1, 1033, 
	-1, -1, 1033, -1, 1033, 1033, -1, -1, 
	-1, 1033, -1, 1033, -1, 1033, 1034, 1034, 
	1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 
	1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 
	1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 
	-1, 1034, 1034, 1034, 1034, 1034, -1, 1034, 
	-1, 1034, 1034, 1034, 1034, -1, 1034, -1, 
	1034, 1034, 1034, -1, 1034, 1034, 1034, 1034, 
	1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 
	1034, -1, 1034, 1034, 1034, 1034, 1034, 1034, 
	1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 
	1034, -1, 1034, -1, -1, -1, -1, 1034, 
	1034, 1034, 1034, 1034, -1, -1, 1034, 1034, 
	1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 
	1034, 1034, 1034, 1034, 1034, 1034, -1, -1, 
	-1, -1, -1, 1034, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1033, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1034, 1034, 1034, 1034, -1, -1, 
	1034, 1034, 1034, 1034, 1034, 1034, -1, -1, 
	-1, -1, 1034, 1034, 1034, 1034, 1034, 1034, 
	1034, -1, -1, -1, -1, 1034, -1, -1, 
	-1, -1, 1034, 1034, -1, -1, 1034, 1034, 
	1034, -1, 1034, 1034, -1, -1, 1034, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1034, 
	1034, 1034, 1034, 1034, 1034, 1034, -1, -1, 
	-1, 1034, 1034, 1034, 1034, -1, 1034, 1034, 
	-1, 1034, 1034, 1034, 1034, 1034, -1, 1034, 
	1034, 1034, -1, -1, -1, 1034, 1034, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1034, 1034, 1034, -1, -1, 1034, -1, 
	-1, -1, -1, 1034, -1, 1034, 1034, 1034, 
	1034, -1, 1034, 1034, 1034, 1034, 1034, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1034, -1, 1034, -1, -1, 1034, -1, 
	1034, 1034, -1, -1, -1, 1034, -1, 1034, 
	-1, 1034, 1041, 1041, 1041, 1041, 1041, 1041, 
	1041, -1, 1041, 1041, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1041, 1041, 1041, 
	1041, 1041, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1041, -1, -1, -1, 
	1041, -1, -1, -1, 1041, 1041, 1041, 1041, 
	1041, 1041, -1, -1, -1, -1, 1041, 1041, 
	1041, -1, -1, -1, -1, 1164, 1041, -1, 
	1041, 1041, 1041, 1041, -1, -1, -1, -1, 
	-1, -1, -1, 1041, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1041, 1041, 1041, -1, 1041, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 987, 987, 987, 987, 987, 
	987, 987, 987, 987, 987, 987, 987, 987, 
	987, 987, 987, 987, 987, 987, 987, 987, 
	987, 987, 987, 987, 987, 987, 987, 987, 
	987, 987, 987, -1, 987, -1, 987, 987, 
	987, 987, 987, 987, 1034, 987, 987, 987, 
	-1, -1, 987, 987, 987, 987, 987, 987, 
	987, 987, -1, 987, 987, 987, 987, -1, 
	-1, -1, 987, 987, 987, 987, 987, -1, 
	-1, 987, 987, 987, 987, -1, -1, -1, 
	987, -1, -1, -1, 987, 987, -1, 987, 
	-1, -1, 987, -1, -1, 987, -1, 987, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 654, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1041, 1041, 1041, 
	1041, 1041, -1, 1041, 1041, 1155, -1, -1, 
	-1, -1, 1041, -1, -1, -1, -1, -1, 
	-1, 987, -1, -1, -1, -1, 655, 656, 
	657, -1, -1, 987, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1041, 1041, 
	1041, 1155, 1155, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 987, 
	987, 987, 987, -1, -1, 987, 987, 987, 
	987, 987, 987, -1, -1, -1, -1, 987, 
	987, 987, 987, 987, 987, 987, -1, -1, 
	987, -1, 987, -1, -1, -1, -1, 987, 
	987, -1, 987, 987, 987, 987, -1, 987, 
	987, -1, -1, 987, -1, -1, -1, -1, 
	-1, 987, -1, 987, 987, 987, 987, 987, 
	987, 987, 987, -1, -1, -1, -1, 987, 
	987, -1, 987, 987, 987, -1, -1, -1, 
	-1, -1, -1, -1, -1, 987, 987, -1, 
	-1, 987, -1, 987, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 987, 987, 987, 
	-1, -1, 987, 987, 987, -1, -1, -1, 
	-1, -1, 987, 987, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 987, -1, 
	987, -1, -1, 987, 987, 987, 988, 988, 
	988, 988, 988, 988, 988, 988, 988, 988, 
	988, 988, 988, 988, 988, 988, 988, 988, 
	988, 988, 988, 988, 988, 988, 988, 988, 
	988, 988, 988, 988, 988, 988, -1, 988, 
	-1, 988, 988, 988, 988, 988, 988, -1, 
	988, 988, 988, -1, -1, 988, 988, 988, 
	988, 988, 988, 988, 988, -1, 988, 988, 
	988, 988, -1, -1, -1, 988, 988, 988, 
	988, 988, -1, -1, 988, 988, 988, 988, 
	-1, -1, -1, 988, -1, -1, -1, 988, 
	988, -1, 988, -1, -1, 988, -1, -1, 
	988, -1, 988, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 988, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 988, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 987, 988, 988, 988, 988, -1, -1, 
	988, 988, 988, 988, 988, 988, -1, -1, 
	-1, -1, 988, 988, 988, 988, 988, 988, 
	988, -1, -1, 988, -1, 988, -1, -1, 
	-1, -1, 988, 988, -1, 988, 988, 988, 
	988, -1, 988, 988, -1, -1, 988, -1, 
	-1, -1, -1, -1, 988, -1, 988, 988, 
	988, 988, 988, 988, 988, 988, -1, -1, 
	-1, -1, 988, 988, -1, 988, 988, 988, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	988, 988, -1, -1, 988, -1, 988, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	988, 988, 988, -1, -1, 988, 988, 988, 
	-1, -1, -1, -1, -1, 988, 988, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 988, -1, 988, -1, -1, 988, 988, 
	988, 990, 990, 990, 990, 990, 990, 990, 
	990, 990, 990, 990, 990, 990, 990, 990, 
	990, 990, 990, 990, 990, 990, 990, 990, 
	990, 990, 990, 990, 990, 990, 990, 990, 
	990, -1, 990, -1, 990, 990, 990, 990, 
	990, 990, -1, 990, 990, 990, -1, -1, 
	990, 990, 990, 990, 990, 990, 990, 990, 
	-1, 990, 990, 990, 990, -1, -1, -1, 
	990, 990, 990, 990, 990, -1, -1, 990, 
	990, 990, 990, -1, -1, -1, 990, -1, 
	-1, -1, 990, 990, -1, 990, -1, -1, 
	990, -1, -1, 990, -1, 990, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	654, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 990, 
	-1, -1, 655, 656, 657, -1, -1, -1, 
	-1, 990, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 988, 990, 990, 990, 
	990, -1, -1, 990, 990, 990, 990, 990, 
	990, -1, -1, -1, -1, 990, 990, 990, 
	990, 990, 990, 990, -1, -1, 990, -1, 
	990, -1, -1, -1, -1, 990, 990, -1, 
	990, 990, 990, 990, -1, 990, 990, -1, 
	-1, 990, -1, -1, -1, -1, -1, 990, 
	-1, 990, 990, 990, 990, 990, 990, 990, 
	990, -1, -1, -1, -1, 990, 990, -1, 
	990, 990, 990, -1, -1, -1, -1, -1, 
	-1, -1, -1, 990, 990, -1, -1, 990, 
	-1, 990, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 990, 990, 990, -1, -1, 
	990, 990, 990, -1, -1, -1, -1, -1, 
	990, 990, 64, 67, 68, 65, 66, 73, 
	74, -1, 69, 70, 990, -1, 990, -1, 
	-1, 990, 990, 990, -1, 138, 139, 141, 
	140, 142, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 75, -1, -1, -1, 
	131, -1, -1, -1, 135, 136, 137, 72, 
	71, 130, -1, -1, -1, -1, 124, 125, 
	126, -1, -1, -1, -1, 993, 122, -1, 
	144, 145, 146, 147, -1, -1, -1, -1, 
	-1, -1, -1, 127, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 980, 
	980, 980, 980, 980, 980, 980, 980, 980, 
	980, 980, 980, 980, 980, 980, 980, 980, 
	980, 980, 980, 980, 980, 980, 980, 980, 
	980, -1, 980, 980, 980, 980, 980, -1, 
	980, -1, 980, 980, 980, 980, -1, 980, 
	-1, 980, 980, 980, -1, 980, 980, 980, 
	980, 980, 980, 980, 980, 980, 980, 980, 
	980, 980, -1, 980, 980, 980, 980, 980, 
	980, 980, 980, 980, 980, 980, 980, 980, 
	980, 980, -1, 980, -1, -1, -1, 990, 
	980, 980, 980, 980, 980, -1, -1, 980, 
	980, 980, 980, 980, 980, 980, 980, 980, 
	980, 980, 980, 980, 980, 980, 980, -1, 
	-1, -1, -1, -1, 980, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 660, 129, 133, -1, -1, 
	-1, -1, 132, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 143, 134, 
	128, 123, 993, 980, 980, 980, 980, -1, 
	-1, 980, 980, 980, 980, 980, 980, -1, 
	-1, -1, -1, 980, 980, 980, 980, 980, 
	980, 980, -1, -1, -1, -1, 980, -1, 
	-1, -1, -1, 980, 980, -1, -1, 980, 
	980, 980, -1, 980, 980, -1, -1, 980, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	980, 980, 980, 980, 980, 980, 980, -1, 
	-1, -1, 980, 980, 980, -1, -1, 980, 
	980, -1, 980, 980, 980, 980, 980, -1, 
	980, 980, 980, -1, -1, -1, 980, 980, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 980, 980, 980, -1, -1, 980, 
	-1, -1, -1, -1, 980, -1, 980, 980, 
	980, 980, -1, 980, 980, 980, 980, 980, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 980, -1, 980, -1, -1, 980, 
	-1, 980, 980, -1, -1, -1, 980, -1, 
	980, -1, 980, 1071, 1071, 1071, 1071, 1071, 
	1071, 1071, -1, 1071, 1071, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1071, 1071, 
	1071, 1071, 1071, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1071, -1, -1, 
	-1, 1071, -1, -1, -1, 1071, 1071, 1071, 
	1071, 1071, 1071, -1, -1, -1, -1, 1071, 
	1071, 1071, -1, -1, -1, -1, 1071, 1071, 
	-1, 1071, 1071, 1071, 1071, 1071, -1, -1, 
	-1, -1, -1, -1, 1071, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1071, 1071, 1071, 1071, 1071, -1, 
	-1, 274, 275, -1, -1, -1, -1, -1, 
	1071, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 934, 
	934, 934, 934, 934, 934, 934, 934, 934, 
	934, 934, 934, 934, 934, 934, 934, 934, 
	934, 934, 934, 934, 934, 934, 934, 934, 
	934, -1, 934, 934, 934, 934, 934, -1, 
	934, -1, 934, 934, 934, 934, -1, 934, 
	-1, 934, 934, 934, -1, 980, 934, 934, 
	934, 934, 934, 934, 934, 934, -1, 934, 
	934, 934, -1, -1, -1, -1, 934, 934, 
	934, 934, 934, -1, -1, 934, 934, 934, 
	934, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 934, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1071, 1071, 
	1071, 1071, 1071, -1, 1071, 1071, 1071, -1, 
	-1, -1, -1, 1071, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1071, 1071, 
	1071, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1071, -1, 1071, 
	1071, 1071, 1071, 1071, -1, -1, -1, -1, 
	-1, -1, -1, 934, 934, 934, 934, -1, 
	-1, 934, 934, -1, 934, 934, 934, -1, 
	-1, -1, -1, 934, 934, 934, 1071, 934, 
	934, 934, -1, -1, -1, -1, 934, -1, 
	-1, -1, -1, 934, -1, -1, -1, 934, 
	934, 934, -1, 934, 934, -1, -1, 934, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	934, 934, 934, 934, 934, 934, 934, -1, 
	-1, -1, -1, 934, 934, -1, -1, 934, 
	934, -1, -1, -1, -1, -1, -1, -1, 
	-1, 934, 934, -1, -1, -1, -1, 934, 
	-1, -1, -1, 55, 56, 64, 67, 68, 
	65, 66, 73, 74, -1, 69, 70, -1, 
	-1, 35, 36, 40, 38, -1, 934, 934, 
	934, -1, -1, -1, -1, -1, 934, 934, 
	-1, 41, 42, 43, -1, -1, -1, 75, 
	-1, -1, 934, -1, 37, -1, -1, -1, 
	-1, 934, 72, 71, -1, -1, -1, 660, 
	129, 133, -1, -1, -1, -1, 132, -1, 
	59, -1, -1, 82, 84, 86, 88, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	276, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 143, 134, 128, 123, -1, -1, 
	-1, -1, -1, 274, 275, -1, -1, -1, 
	-1, -1, -1, -1, 925, 925, 925, 925, 
	925, 925, 925, 925, 925, 925, 925, 925, 
	925, 925, 925, 925, 925, 925, 925, 925, 
	925, 925, 925, 925, 925, 925, -1, 925, 
	925, 925, 925, 925, -1, 925, -1, 925, 
	925, 925, 925, -1, 925, -1, 925, 925, 
	925, -1, -1, 925, 925, 925, 925, 925, 
	925, 925, 925, -1, 925, 925, 925, -1, 
	-1, -1, -1, 925, 925, 925, 925, 925, 
	-1, -1, 925, 925, 925, 925, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	925, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 934, -1, -1, 
	-1, 277, -1, -1, -1, -1, -1, -1, 
	664, -1, -1, -1, -1, 34, 33, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	62, -1, -1, -1, -1, 44, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 80, 76, 45, -1, 
	925, 925, 925, 925, 39, 993, 925, 925, 
	-1, 925, 925, 925, -1, -1, -1, -1, 
	925, 925, 925, -1, 925, 925, 925, -1, 
	-1, -1, -1, 925, -1, -1, -1, -1, 
	925, -1, -1, -1, 925, 925, 925, -1, 
	925, 925, -1, -1, 925, -1, -1, -1, 
	-1, -1, -1, -1, -1, 925, 925, 925, 
	925, 925, 925, 925, -1, -1, -1, -1, 
	925, 925, -1, -1, 925, 925, -1, -1, 
	-1, -1, -1, -1, -1, -1, 925, 925, 
	-1, -1, -1, -1, 925, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 925, 925, 925, -1, -1, 
	-1, -1, -1, 925, 925, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 925, 
	-1, -1, -1, -1, -1, -1, 925, 922, 
	922, 922, 922, 922, 922, 922, 922, 922, 
	922, 922, 922, 922, 922, 922, 922, 922, 
	922, 922, 922, 922, 922, 922, 922, 922, 
	922, -1, 922, 922, 922, 922, 922, -1, 
	922, -1, 922, 922, 922, 922, -1, 922, 
	-1, 922, 922, 922, -1, -1, 922, 922, 
	922, 922, 922, 922, 922, 922, -1, 922, 
	922, 922, -1, -1, -1, -1, 922, 922, 
	922, 922, 922, -1, -1, 922, 922, 922, 
	922, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 922, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 925, 922, 922, 922, 922, -1, 
	-1, 922, 922, -1, 922, 922, 922, -1, 
	-1, -1, -1, 922, 922, 922, -1, 922, 
	922, 922, -1, -1, -1, -1, 922, -1, 
	-1, -1, -1, 922, -1, -1, -1, 922, 
	922, 922, -1, 922, 922, -1, -1, 922, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	922, 922, 922, 922, 922, 922, 922, -1, 
	-1, -1, -1, 922, 922, -1, -1, 922, 
	922, -1, -1, -1, -1, -1, -1, -1, 
	-1, 922, 922, -1, -1, -1, -1, 922, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 922, 922, 
	922, -1, -1, -1, -1, -1, 922, 922, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 922, -1, -1, -1, -1, -1, 
	-1, 922, -1, -1, -1, 972, 972, 972, 
	972, 972, 972, 972, 972, 972, 972, 972, 
	972, 972, 972, 972, 972, 972, 972, 972, 
	972, 972, 972, 972, 972, 972, 972, -1, 
	972, 972, 972, 972, 972, -1, 972, -1, 
	972, 972, 972, 972, -1, 972, -1, 972, 
	972, 972, -1, 972, 972, 972, 972, 972, 
	972, 972, 972, 972, 972, 972, 972, 972, 
	-1, 972, 972, 972, 972, 972, 972, 972, 
	972, 972, 972, 972, 972, 972, 972, 972, 
	-1, 972, -1, -1, -1, -1, 972, 972, 
	972, 972, 972, -1, -1, 972, 972, 972, 
	972, 972, 972, 972, 972, 972, 972, 972, 
	972, 972, 972, 972, 972, -1, -1, -1, 
	-1, -1, 972, -1, -1, 277, -1, -1, 
	-1, -1, -1, -1, 664, -1, -1, -1, 
	-1, 34, 33, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 62, -1, -1, -1, 
	-1, 44, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	80, 76, 45, -1, -1, 922, -1, -1, 
	39, 972, 972, 972, 972, -1, -1, 972, 
	972, 972, 972, 972, 972, -1, -1, -1, 
	-1, 972, 972, 972, 972, 972, 972, 972, 
	-1, -1, -1, -1, 972, -1, -1, -1, 
	-1, 972, 972, -1, -1, 972, 972, 972, 
	-1, 972, 972, -1, -1, 972, -1, -1, 
	-1, -1, -1, -1, -1, -1, 972, 972, 
	972, 972, 972, 972, 972, -1, -1, -1, 
	972, 972, 972, -1, -1, 972, 972, -1, 
	972, 972, 972, 972, 972, -1, 972, 972, 
	972, -1, -1, -1, 972, 972, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	972, 972, 972, -1, -1, 972, -1, -1, 
	-1, -1, 972, -1, 972, 972, 972, 972, 
	-1, 972, 972, 972, 972, 972, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	972, -1, 972, -1, -1, 972, -1, 972, 
	972, -1, -1, -1, 972, -1, 972, -1, 
	972, 764, 764, 764, 764, 764, 764, 764, 
	764, 764, 764, 764, 764, 764, 764, 764, 
	764, 764, 764, 764, 764, 764, 764, 764, 
	764, 764, 764, -1, 764, 764, 764, 764, 
	764, -1, 764, -1, 764, 764, 764, 764, 
	-1, 764, -1, 764, 764, 764, -1, -1, 
	764, 764, 764, 764, 764, 764, 764, 764, 
	-1, 764, 764, 764, -1, -1, -1, -1, 
	764, 764, 764, 764, 764, -1, -1, 764, 
	764, 764, 764, -1, 55, 56, 64, 67, 
	68, 65, 66, 73, 74, 764, 69, 70, 
	-1, -1, 35, 36, 40, 38, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 41, 42, 43, -1, -1, -1, 
	75, -1, -1, -1, -1, 37, -1, -1, 
	-1, -1, -1, 72, 71, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 59, -1, -1, 82, 84, 86, 88, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 276, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 972, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 764, 764, 764, 
	764, -1, -1, 764, 764, -1, 764, 764, 
	764, -1, -1, -1, -1, 764, 764, 764, 
	-1, 764, 764, 764, -1, -1, -1, -1, 
	764, -1, -1, -1, -1, 764, -1, -1, 
	-1, 764, 764, 764, -1, 764, 764, -1, 
	-1, 764, -1, -1, -1, -1, -1, -1, 
	-1, -1, 764, 764, 764, 764, 764, 764, 
	764, -1, -1, -1, -1, 764, 764, -1, 
	-1, 764, 764, -1, -1, -1, -1, -1, 
	-1, -1, -1, 764, 764, -1, -1, -1, 
	-1, 764, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	764, 764, 764, -1, -1, -1, -1, -1, 
	764, 764, -1, -1, -1, -1, -1, -1, 
	-1, -1, 277, -1, 764, -1, -1, -1, 
	-1, 676, -1, 764, -1, -1, 34, 33, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 62, -1, -1, -1, -1, 44, -1, 
	-1, -1, -1, -1, -1, 1040, 1040, 1040, 
	1040, 1040, 1040, 1040, -1, 1040, 1040, -1, 
	-1, -1, -1, -1, -1, 80, 76, 45, 
	1040, 1040, 1040, 1040, 1040, 39, 993, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1040, 
	-1, -1, -1, 1040, -1, -1, -1, 1040, 
	1040, 1040, 1040, 1040, 1040, -1, -1, -1, 
	-1, 1040, 1040, 1040, -1, -1, -1, -1, 
	410, 1040, 1016, 404, 406, 408, 1040, 1163, 
	-1, -1, -1, -1, -1, -1, 1040, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1040, 1040, 1040, 1040, 
	1040, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 763, 
	763, 763, 763, 763, 763, 763, 763, 763, 
	763, 763, 763, 763, 763, 763, 763, 763, 
	763, 763, 763, 763, 763, 763, 763, 763, 
	763, -1, 763, 763, 763, 763, 763, 764, 
	763, -1, 763, 763, 763, 763, -1, 763, 
	-1, 763, 763, 763, -1, -1, 763, 763, 
	763, 763, 763, 763, 763, 763, -1, 763, 
	763, 763, -1, -1, -1, -1, 763, 763, 
	763, 763, 763, -1, -1, 763, 763, 763, 
	763, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 763, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1040, 1040, 1040, 1040, 1040, -1, 1040, 1040, 
	1156, -1, -1, -1, -1, 1040, 402, -1, 
	-1, -1, 1016, 401, -1, -1, -1, -1, 
	1040, 176, 177, -1, -1, -1, -1, -1, 
	-1, -1, 175, -1, -1, -1, -1, -1, 
	-1, 1040, 1040, 1040, 1040, 1040, -1, -1, 
	-1, -1, -1, 763, 763, 763, 763, -1, 
	-1, 763, 763, -1, 763, 763, 763, -1, 
	-1, -1, 400, 763, 763, 763, 174, 763, 
	763, 763, -1, -1, -1, -1, 763, -1, 
	-1, -1, -1, 763, -1, -1, -1, 763, 
	763, 763, -1, 763, 763, -1, -1, 763, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	763, 763, 763, 763, 763, 763, 763, -1, 
	-1, -1, -1, 763, 763, -1, -1, 763, 
	763, -1, -1, -1, -1, -1, -1, -1, 
	-1, 763, 763, -1, -1, -1, -1, 763, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 763, 763, 
	763, -1, -1, -1, -1, -1, 763, 763, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 763, -1, -1, -1, -1, -1, 
	-1, 763, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	918, 918, 918, 918, 918, 918, 918, 918, 
	918, 918, 918, 918, 918, 918, 918, 918, 
	918, 918, 918, 918, 918, 918, 918, 918, 
	918, 918, -1, 918, 918, 918, 918, 918, 
	-1, 918, -1, 918, 918, 918, 918, -1, 
	918, -1, 918, 918, 918, -1, -1, 918, 
	918, 918, 918, 918, 918, 918, 918, -1, 
	918, 918, 918, -1, -1, -1, -1, 918, 
	918, 918, 918, 918, -1, -1, 918, 918, 
	918, 918, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 918, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 277, -1, 
	-1, -1, -1, -1, -1, 676, -1, -1, 
	-1, -1, 34, 33, -1, 763, -1, -1, 
	-1, -1, -1, -1, -1, 62, -1, -1, 
	-1, -1, 44, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 80, 76, 45, 918, 918, 918, 918, 
	-1, 39, 918, 918, -1, 918, 918, 918, 
	-1, -1, -1, -1, 918, 918, 918, -1, 
	918, 918, 918, -1, -1, -1, -1, 918, 
	-1, -1, -1, -1, 918, -1, -1, -1, 
	918, 918, 918, -1, 918, 918, -1, -1, 
	918, -1, -1, -1, -1, -1, -1, -1, 
	-1, 918, 918, 918, 918, 918, 918, 918, 
	-1, -1, -1, -1, 918, 918, -1, -1, 
	918, 918, -1, -1, -1, -1, -1, -1, 
	-1, -1, 918, 918, -1, -1, -1, -1, 
	918, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 918, 
	918, 918, -1, -1, -1, -1, -1, 918, 
	918, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 918, -1, -1, -1, -1, 
	-1, -1, 918, 866, 866, 866, 866, 866, 
	866, 866, 866, 866, 866, 866, 866, 866, 
	866, 866, -1, 866, 866, 866, 866, 866, 
	866, 866, 866, -1, -1, -1, 866, 866, 
	866, 866, 866, -1, 866, -1, 866, 866, 
	866, 866, -1, 866, -1, 866, 866, 866, 
	-1, -1, 866, -1, -1, 866, 866, 866, 
	866, 866, -1, 866, 866, 866, 866, -1, 
	-1, -1, 866, 866, 866, 866, 866, -1, 
	866, 866, 866, 866, 866, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 866, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 402, -1, -1, -1, -1, 401, 
	-1, -1, -1, -1, -1, 176, 177, -1, 
	-1, -1, -1, -1, -1, -1, 175, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 400, -1, 
	-1, -1, 174, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 918, 866, 
	866, 866, 866, -1, -1, 866, 866, 866, 
	866, 866, 866, -1, -1, -1, -1, 866, 
	866, 866, 866, 866, 866, 866, -1, 866, 
	866, -1, 866, -1, -1, -1, -1, 866, 
	866, -1, -1, 866, 866, 866, -1, 866, 
	866, 866, -1, 866, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 866, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 866, 866, -1, -1, -1, 
	-1, -1, -1, -1, -1, 866, 866, -1, 
	-1, -1, -1, 866, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 866, 866, 866, -1, -1, -1, 
	-1, -1, 866, 866, 1055, 1055, 1055, 1055, 
	1055, 1055, 1055, -1, 1055, 1055, 866, -1, 
	866, -1, -1, 866, -1, -1, -1, 1055, 
	1055, 1055, 1055, 1055, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1055, -1, 
	-1, -1, 1055, -1, -1, -1, 1055, 1055, 
	1055, 1055, 1055, 1055, -1, -1, -1, -1, 
	1055, 1055, 1055, -1, -1, -1, -1, 1055, 
	1055, -1, 1055, 1055, 1055, 1055, 1055, -1, 
	-1, -1, -1, -1, -1, 1055, 1056, 1056, 
	1056, 1056, 1056, 1056, 1056, -1, 1056, 1056, 
	-1, -1, -1, 1055, 1055, 1055, 1055, 1055, 
	-1, 1056, 1056, 1056, 1056, 1056, -1, -1, 
	-1, 1055, -1, -1, -1, -1, -1, -1, 
	1056, -1, -1, -1, 1056, -1, -1, -1, 
	1056, 1056, 1056, 1056, 1056, 1056, -1, -1, 
	-1, -1, 1056, 1056, 1056, -1, -1, -1, 
	-1, 1056, 1056, -1, 1056, 1056, 1056, 1056, 
	1056, -1, -1, -1, -1, -1, -1, 1056, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1056, 1056, 1056, 
	1056, 1056, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1056, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 866, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1055, 
	1055, 1055, 1055, 1055, -1, 1055, 1055, 1055, 
	-1, -1, -1, -1, 1055, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1055, 
	1055, 1055, -1, -1, -1, -1, -1, -1, 
	-1, 1055, -1, -1, -1, -1, -1, -1, 
	1055, 1055, 1055, 1055, 1055, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1055, -1, -1, 
	-1, 1056, 1056, 1056, 1056, 1056, -1, 1056, 
	1056, 1056, -1, -1, -1, -1, 1056, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1056, 1056, 1056, -1, -1, -1, -1, 
	-1, -1, -1, 1056, -1, -1, -1, -1, 
	-1, -1, 1056, 1056, 1056, 1056, 1056, 1057, 
	1057, 1057, 1057, 1057, 1057, 1057, -1, 1057, 
	1057, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1057, 1057, 1057, 1057, 1057, 1056, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1057, -1, -1, -1, 1057, -1, -1, 
	-1, 1057, 1057, 1057, 1057, 1057, 1057, -1, 
	-1, -1, -1, 1057, 1057, 1057, -1, -1, 
	-1, -1, 1057, 1057, -1, 1057, 1057, 1057, 
	1057, 1057, -1, -1, -1, -1, -1, -1, 
	1057, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1057, 1057, 
	1057, 1057, 1057, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1057, -1, -1, -1, 
	-1, -1, -1, -1, 944, 944, 944, 944, 
	944, 944, 944, 944, 944, 944, 944, 944, 
	944, 944, 944, 944, 944, 944, 944, 944, 
	944, 944, 944, 944, 944, 944, -1, 944, 
	944, 944, 944, 944, -1, 944, -1, 944, 
	944, 944, 944, -1, 944, -1, 944, 944, 
	944, -1, -1, 944, 944, 944, 944, 944, 
	944, 944, 944, -1, 944, 944, 944, -1, 
	-1, -1, -1, 944, 944, 944, 944, 944, 
	-1, -1, 944, 944, 944, 944, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	944, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1057, 1057, 1057, 1057, 1057, -1, 
	1057, 1057, 1057, -1, -1, -1, -1, 1057, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1057, 1057, 1057, -1, -1, -1, 
	-1, -1, -1, -1, 1057, -1, -1, -1, 
	-1, -1, -1, 1057, 1057, 1057, 1057, 1057, 
	944, 944, 944, 944, -1, -1, 944, 944, 
	-1, 944, 944, 944, -1, -1, -1, -1, 
	944, 944, 944, -1, 944, 944, 944, -1, 
	1057, -1, -1, 944, -1, -1, -1, -1, 
	944, -1, -1, -1, 944, 944, 944, -1, 
	944, 944, -1, -1, 944, -1, -1, -1, 
	-1, -1, -1, -1, -1, 944, 944, 944, 
	944, 944, 944, 944, -1, -1, -1, -1, 
	944, 944, -1, -1, 944, 944, -1, -1, 
	-1, -1, -1, -1, -1, -1, 944, 944, 
	-1, -1, -1, -1, 944, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 944, 944, 944, -1, -1, 
	-1, -1, -1, 944, 944, 1040, 1040, 1040, 
	1040, 1040, 1040, 1040, -1, 1040, 1040, 944, 
	-1, -1, -1, -1, -1, -1, 944, -1, 
	1040, 1040, 1040, 1040, 1040, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1040, 
	-1, -1, -1, 1040, -1, -1, -1, 1040, 
	1040, 1040, 1040, 1040, 1040, -1, -1, -1, 
	-1, 1040, 1040, 1040, -1, -1, -1, -1, 
	1154, 1040, 1039, 1154, 1154, 1154, 1040, -1, 
	-1, -1, -1, -1, -1, -1, 1040, 1040, 
	1040, 1040, 1040, 1040, 1040, 1040, -1, 1040, 
	1040, -1, -1, -1, 1040, 1040, 1040, 1040, 
	1040, -1, 1040, 1040, 1040, 1040, 1040, -1, 
	-1, -1, 1145, -1, -1, -1, -1, -1, 
	-1, 1040, -1, -1, -1, 1040, -1, -1, 
	-1, 1040, 1040, 1040, 1040, 1040, 1040, -1, 
	-1, -1, -1, 1040, 1040, 1040, -1, -1, 
	-1, -1, 1154, 1040, 1039, 1154, 1154, 1154, 
	1040, 1145, -1, -1, -1, -1, -1, -1, 
	1040, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1040, 1040, 
	1040, 1040, 1040, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1145, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 944, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1040, 1040, 1040, 1040, 1040, -1, 1040, 1040, 
	1154, -1, -1, -1, -1, 1040, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1040, 642, 643, -1, -1, 641, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1040, 1040, 1040, 1040, 1040, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 688, -1, -1, -1, 
	-1, -1, 1040, 1040, 1040, 1040, 1040, -1, 
	1040, 1040, 1154, -1, -1, -1, -1, 1040, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1040, 642, 643, -1, -1, 641, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1040, 1040, 1040, 1040, 1040, 
	55, 56, 64, 67, 68, 65, 66, 73, 
	74, -1, 69, 70, -1, -1, 35, 36, 
	40, 38, -1, -1, -1, -1, 698, -1, 
	-1, -1, -1, -1, -1, -1, 41, 42, 
	43, -1, -1, -1, 75, -1, -1, -1, 
	-1, 37, -1, -1, -1, -1, -1, 72, 
	71, 64, 67, 68, 65, 66, 73, 74, 
	-1, 69, 70, -1, -1, 59, -1, -1, 
	82, 84, 86, 88, 138, 139, 141, 140, 
	142, -1, -1, -1, -1, 276, -1, -1, 
	-1, -1, -1, 75, -1, -1, -1, 131, 
	-1, -1, -1, 135, 136, 137, 72, 71, 
	130, -1, -1, -1, -1, 124, 125, 126, 
	-1, -1, -1, -1, 993, 122, -1, 144, 
	145, 146, 147, -1, -1, -1, -1, -1, 
	-1, -1, 127, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	117, 118, 119, -1, 120, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 277, -1, 
	-1, -1, -1, -1, -1, 704, -1, -1, 
	-1, -1, 34, 33, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 62, -1, -1, 
	-1, -1, 44, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 80, 76, 45, -1, -1, -1, -1, 
	-1, 39, 993, -1, 707, 113, 114, 115, 
	116, -1, 121, 129, 133, -1, -1, -1, 
	-1, 132, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 143, 134, 128, 
	123, 993, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 981, 981, 981, 
	981, 981, 981, 981, 981, 981, 981, 981, 
	981, 981, 981, 981, 981, 981, 981, 981, 
	981, 981, 981, 981, 981, 981, 981, -1, 
	981, 981, 981, 981, 981, -1, 981, -1, 
	981, 981, 981, 981, -1, 981, -1, 981, 
	981, 981, -1, 981, 981, 981, 981, 981, 
	981, 981, 981, 981, 981, 981, 981, 981, 
	-1, 981, 981, 981, 981, 981, 981, 981, 
	981, 981, 981, 981, 981, 981, 981, 981, 
	-1, 981, -1, -1, -1, -1, 981, 981, 
	981, 981, 981, -1, -1, 981, 981, 981, 
	981, 981, 981, 981, 981, 981, 981, 981, 
	981, 981, 981, 981, 981, -1, -1, -1, 
	-1, -1, 981, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 642, 643, -1, 
	-1, 641, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 981, 981, 981, 981, -1, -1, 981, 
	981, 981, 981, 981, 981, -1, -1, -1, 
	688, 981, 981, 981, 981, 981, 981, 981, 
	-1, -1, -1, -1, 981, -1, -1, -1, 
	-1, 981, 981, -1, -1, 981, 981, 981, 
	-1, 981, 981, -1, -1, 981, -1, 642, 
	643, -1, -1, 641, -1, -1, 981, 981, 
	981, 981, 981, 981, 981, -1, -1, -1, 
	981, 981, 981, -1, -1, 981, 981, -1, 
	981, 981, 981, 981, 981, -1, 981, 981, 
	981, -1, -1, -1, 981, 981, -1, -1, 
	-1, -1, 698, -1, -1, -1, -1, -1, 
	981, 981, 981, -1, -1, 981, -1, -1, 
	-1, -1, 981, -1, 981, 981, 981, 981, 
	-1, 981, 981, 981, 981, 981, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	981, -1, 981, -1, -1, 981, -1, 981, 
	981, -1, -1, -1, 981, -1, 981, -1, 
	981, -1, -1, -1, -1, 1068, 1068, 1068, 
	1068, 1068, 1068, 1068, -1, 1068, 1068, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1068, 1068, 1068, 1068, 1068, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1068, 
	-1, -1, -1, 1068, -1, -1, -1, 1068, 
	1068, 1068, 1068, 1068, 1068, -1, -1, -1, 
	-1, 1068, 1068, 1068, -1, -1, -1, -1, 
	1068, 1068, -1, 1068, 1068, 1068, 1068, 1068, 
	-1, -1, -1, -1, -1, -1, 1068, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1068, 1068, 1068, 1068, 
	1068, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1068, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 277, -1, -1, -1, -1, -1, 
	-1, 704, -1, -1, -1, -1, 34, 33, 
	-1, -1, -1, 981, -1, -1, -1, -1, 
	-1, 62, -1, -1, -1, -1, 44, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 80, 76, 45, 
	-1, -1, -1, -1, -1, 39, -1, -1, 
	707, 113, 114, 115, 116, -1, 121, 129, 
	133, -1, -1, -1, -1, 132, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1068, 1068, 1068, 1068, 1068, -1, 1068, 1068, 
	1068, 143, 134, 128, 123, 1068, 1069, 1069, 
	1069, 1069, 1069, 1069, 1069, -1, 1069, 1069, 
	1068, 1068, 1068, -1, -1, -1, -1, -1, 
	-1, 1069, 1069, 1069, 1069, 1069, -1, 1068, 
	-1, 1068, 1068, 1068, 1068, 1068, -1, -1, 
	1069, -1, -1, -1, 1069, -1, -1, -1, 
	1069, 1069, 1069, 1069, 1069, 1069, -1, -1, 
	-1, -1, 1069, 1069, 1069, -1, -1, -1, 
	1068, 1069, 1069, -1, 1069, 1069, 1069, 1069, 
	1069, -1, -1, -1, -1, -1, -1, 1069, 
	1070, 1070, 1070, 1070, 1070, 1070, 1070, -1, 
	1070, 1070, -1, -1, -1, 1069, 1069, 1069, 
	1069, 1069, -1, 1070, 1070, 1070, 1070, 1070, 
	-1, -1, -1, 1069, -1, -1, -1, -1, 
	-1, -1, 1070, -1, -1, -1, 1070, -1, 
	-1, -1, 1070, 1070, 1070, 1070, 1070, 1070, 
	-1, -1, -1, -1, 1070, 1070, 1070, -1, 
	-1, -1, -1, 1070, 1070, -1, 1070, 1070, 
	1070, 1070, 1070, -1, -1, -1, -1, -1, 
	-1, 1070, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1070, 
	1070, 1070, 1070, 1070, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1070, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1069, 1069, 1069, 1069, 1069, -1, 1069, 
	1069, 1069, -1, -1, -1, -1, 1069, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1069, 1069, 1069, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1069, -1, 1069, 1069, 1069, 1069, 1069, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1069, -1, 1070, 1070, 1070, 1070, 1070, 
	-1, 1070, 1070, 1070, -1, -1, -1, -1, 
	1070, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1070, 1070, 1070, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1070, -1, 1070, 1070, 1070, 1070, 
	1070, 924, 924, 924, 924, 924, 924, 924, 
	924, 924, 924, 924, 924, 924, 924, 924, 
	924, 924, 924, 924, 924, 924, 924, 924, 
	924, 924, 924, 1070, 924, 924, 924, 924, 
	924, -1, 924, -1, 924, 924, 924, 924, 
	-1, 924, -1, 924, 924, 924, -1, -1, 
	924, 924, 924, 924, 924, 924, 924, 924, 
	-1, 924, 924, 924, -1, -1, -1, -1, 
	924, 924, 924, 924, 924, -1, -1, 924, 
	924, 924, 924, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 924, 55, 56, 
	64, 67, 68, 65, 66, 73, 74, 1135, 
	69, 70, -1, -1, 35, 36, 40, 38, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 41, 42, 43, -1, 
	-1, -1, 75, -1, -1, -1, -1, 37, 
	-1, -1, -1, -1, -1, 72, 71, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 59, -1, -1, 82, 84, 
	86, 88, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1135, -1, -1, -1, 
	-1, -1, -1, -1, -1, 924, 924, 924, 
	924, -1, -1, 924, 924, -1, 924, 924, 
	924, -1, -1, -1, -1, 924, 924, 924, 
	-1, 924, 924, 924, -1, -1, -1, -1, 
	924, -1, -1, -1, -1, 924, -1, -1, 
	-1, 924, 924, 924, -1, 924, 924, -1, 
	-1, 924, -1, -1, -1, -1, -1, -1, 
	-1, -1, 924, 924, 924, 924, 924, 924, 
	924, -1, -1, -1, -1, 924, 924, -1, 
	-1, 924, 924, -1, -1, -1, -1, -1, 
	-1, -1, -1, 924, 924, -1, -1, -1, 
	-1, 924, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	924, 924, 924, -1, -1, -1, -1, -1, 
	924, 924, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 924, -1, -1, -1, 
	-1, -1, -1, 924, 299, -1, -1, -1, 
	-1, -1, -1, -1, 1135, 1135, 711, -1, 
	34, 33, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 62, -1, -1, -1, -1, 
	44, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 80, 
	76, 45, -1, -1, -1, -1, -1, 39, 
	993, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 298, -1, -1, -1, -1, -1, 
	1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 
	1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 
	1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 
	1014, 1014, -1, 1014, 1014, 1014, 1014, 1014, 
	-1, 1014, -1, 1014, 1014, 1014, 1014, -1, 
	1014, -1, 1014, 1014, 1014, -1, 1014, 1014, 
	1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 
	1014, 1014, 1014, -1, 1014, 1014, 1014, 1014, 
	1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 
	1014, 1014, 1014, -1, 1014, -1, -1, -1, 
	-1, 1014, 1014, 1014, 1014, 1014, -1, 924, 
	1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 
	1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 
	-1, -1, -1, -1, -1, 1014, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1014, 1014, 1014, 1014, 
	-1, -1, 1014, 1014, 1014, 1014, 1014, 1014, 
	-1, -1, -1, -1, 1014, 1014, 1014, 1014, 
	1014, 1014, 1014, -1, -1, -1, -1, 1014, 
	-1, -1, -1, -1, 1014, 1014, -1, -1, 
	1014, 1014, 1014, -1, 1014, 1014, -1, -1, 
	1014, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 
	-1, -1, -1, 1014, 1014, 1014, -1, -1, 
	1014, 1014, -1, 1014, 1014, 1014, 1014, 1014, 
	-1, 1014, 1014, 1014, -1, -1, -1, 1014, 
	1014, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1014, 1014, 1014, -1, -1, 
	1014, -1, -1, -1, -1, 1014, -1, 1014, 
	1014, 1014, 1014, -1, 1014, 1014, 1014, 1014, 
	1014, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1014, -1, 1014, -1, -1, 
	1014, -1, 1014, 1014, -1, -1, -1, 1014, 
	-1, 1014, -1, 1014, -1, -1, -1, -1, 
	-1, -1, -1, 1040, 1040, 1040, 1040, 1040, 
	1040, 1040, -1, 1040, 1040, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1040, 1040, 
	1040, 1040, 1040, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1040, -1, -1, 
	-1, 1040, -1, -1, -1, 1040, 1040, 1040, 
	1040, 1040, 1040, -1, -1, -1, -1, 1040, 
	1040, 1040, -1, -1, -1, -1, 410, 1040, 
	1016, 404, 406, 408, 1040, -1, -1, -1, 
	-1, -1, -1, -1, 1040, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1040, 1040, 1040, 1040, 1040, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1163, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 761, 761, 761, 
	761, 761, 761, 761, 761, 761, 761, 761, 
	761, 761, 761, 761, 761, 761, 761, 761, 
	761, 761, 761, 761, 761, 761, 761, -1, 
	761, 761, 761, 761, 761, -1, 761, -1, 
	761, 761, 761, 761, -1, 761, 1014, 761, 
	761, 761, -1, -1, 761, 761, 761, 761, 
	761, 761, 761, 761, -1, 761, 761, 761, 
	-1, -1, -1, -1, 761, 761, 761, 761, 
	761, -1, -1, 761, 761, 761, 761, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 761, -1, -1, -1, -1, -1, -1, 
	299, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 711, -1, 34, 33, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 62, 
	-1, -1, -1, -1, 44, -1, 1040, 1040, 
	1040, 1040, 1040, -1, 1040, 1040, 1156, -1, 
	-1, -1, -1, 1040, 402, -1, -1, -1, 
	1016, 401, -1, 80, 76, 45, 1040, 176, 
	177, -1, -1, 39, -1, -1, -1, -1, 
	175, -1, -1, -1, -1, -1, -1, 1040, 
	1040, 1040, 1040, 1040, -1, -1, 298, -1, 
	-1, 761, 761, 761, 761, -1, -1, 761, 
	761, -1, 761, 761, 761, -1, -1, -1, 
	542, 761, 761, 761, 318, 761, 761, 761, 
	-1, -1, -1, -1, 761, -1, -1, -1, 
	-1, 761, -1, -1, -1, 761, 761, 761, 
	-1, 761, 761, -1, -1, 761, -1, -1, 
	-1, -1, -1, -1, -1, -1, 761, 761, 
	761, 761, 761, 761, 761, -1, -1, -1, 
	-1, 761, 761, -1, -1, 761, 761, -1, 
	-1, -1, -1, -1, -1, -1, -1, 761, 
	761, -1, -1, -1, -1, 761, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 761, 761, 761, -1, 
	-1, -1, -1, -1, 761, 761, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	761, -1, -1, -1, -1, -1, -1, 761, 
	908, 908, 908, 908, 908, 908, 908, 908, 
	908, 908, 908, 908, 908, 908, 908, -1, 
	908, 908, 908, 908, 908, 908, 908, 908, 
	-1, -1, -1, 908, 908, 908, 908, 908, 
	-1, 908, -1, 908, 908, 908, 908, -1, 
	908, 908, 908, 908, 908, -1, -1, 908, 
	-1, -1, 908, 908, 908, 908, 908, -1, 
	908, 908, 908, -1, -1, -1, -1, 908, 
	908, 908, 908, 908, -1, -1, 908, 908, 
	908, 908, -1, 908, -1, 718, -1, -1, 
	-1, -1, -1, 908, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 761, 908, 908, 908, 908, 
	-1, -1, 908, 908, 908, 908, 908, 908, 
	-1, -1, -1, -1, 908, 908, 908, 908, 
	908, 908, 908, -1, -1, -1, -1, 908, 
	-1, -1, -1, -1, 908, 908, -1, -1, 
	908, 908, 908, -1, 908, 908, -1, -1, 
	908, -1, -1, -1, 908, 717, -1, 908, 
	-1, -1, -1, -1, 908, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	908, 908, -1, -1, -1, -1, -1, -1, 
	-1, -1, 908, 908, -1, -1, -1, -1, 
	908, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 908, 
	908, 908, -1, -1, -1, -1, -1, 908, 
	908, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 908, -1, 908, -1, -1, 
	908, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 912, 912, 912, 
	912, 912, 912, 912, 912, 912, 912, 912, 
	912, 912, 912, 912, -1, 912, 912, 912, 
	912, 912, 912, 912, 912, -1, -1, -1, 
	912, 912, 912, 912, 912, -1, 912, -1, 
	912, 912, 912, 912, -1, 912, -1, 912, 
	912, 912, -1, -1, 912, -1, -1, 912, 
	912, 912, 912, 912, -1, 912, 912, 912, 
	-1, -1, -1, -1, 912, 912, 912, 912, 
	912, -1, -1, 912, 912, 912, 912, -1, 
	912, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	402, -1, -1, -1, -1, 401, -1, -1, 
	-1, -1, -1, 176, 177, -1, -1, -1, 
	-1, -1, -1, -1, 175, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 908, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 542, -1, -1, -1, 
	318, 912, 912, 912, 912, -1, -1, 912, 
	912, 912, 912, 912, 912, -1, -1, -1, 
	-1, 912, 912, 912, 912, 912, 912, 912, 
	-1, -1, -1, -1, 912, -1, -1, -1, 
	-1, 912, 912, -1, -1, 912, 912, 912, 
	-1, 912, 912, -1, -1, 912, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 912, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 912, 912, -1, 
	-1, -1, -1, -1, -1, -1, -1, 912, 
	912, -1, -1, -1, -1, 912, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 912, 912, 912, -1, 
	-1, -1, -1, -1, 912, 912, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	912, -1, 912, -1, -1, 912, -1, -1, 
	867, 867, 867, 867, 867, 867, 867, 867, 
	867, 867, 867, 867, 867, 867, 867, -1, 
	867, 867, 867, 867, 867, 867, 867, 867, 
	-1, -1, -1, 867, 867, 867, 867, 867, 
	-1, 867, -1, 867, 867, 867, 867, -1, 
	867, -1, 867, 867, 867, -1, -1, 867, 
	-1, -1, 867, 867, 867, 867, 867, -1, 
	867, 867, 867, -1, -1, -1, -1, 867, 
	867, 867, 867, 867, -1, -1, 867, 867, 
	867, 867, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 867, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 486, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 912, 867, 867, 867, 867, 
	-1, -1, 867, 867, 867, 867, 867, 867, 
	-1, -1, -1, -1, 867, 867, 867, 867, 
	867, 867, 867, -1, -1, -1, 720, 867, 
	-1, 717, -1, -1, 867, 867, -1, -1, 
	867, 867, 867, -1, 867, 867, 867, -1, 
	867, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 867, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	867, 867, -1, -1, -1, -1, -1, -1, 
	-1, -1, 867, 867, -1, -1, -1, -1, 
	867, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 867, 
	867, 867, -1, -1, -1, -1, -1, 867, 
	867, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 867, -1, 867, -1, -1, 
	867, -1, -1, 1049, 1049, 1049, 1049, 1049, 
	1049, 1049, 1049, 1049, 1049, 1049, 1049, 1049, 
	1049, 1049, 1049, 1049, 1049, 1049, 1049, 1049, 
	1049, 1049, 1049, 1049, 1049, -1, 1049, 1049, 
	1049, 1049, 1049, -1, 1049, -1, 1049, 1049, 
	1049, 1049, -1, 1049, -1, 1049, 1049, 1049, 
	-1, 1049, 1049, 1049, 1049, 1049, 1049, 1049, 
	1049, 1049, 1049, 1049, 1049, 1049, -1, 1049, 
	1049, 1049, 1049, 1049, 1049, 1049, 1049, 1049, 
	1049, 1049, 1049, 1049, 1049, 1049, -1, 1049, 
	-1, -1, -1, -1, 1049, 1049, 1049, 1049, 
	1049, -1, -1, 1049, 1049, 1049, 1049, 1049, 
	1049, 1049, 1049, 1049, 1049, 1049, 1049, 1049, 
	1049, 1049, 1049, -1, -1, -1, -1, -1, 
	1049, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 867, 1049, 
	1049, 1049, 1049, -1, -1, 1049, 1049, 1049, 
	1049, 1049, 1049, -1, -1, -1, -1, 1049, 
	1049, 1049, 1049, 1049, 1049, 1049, -1, -1, 
	-1, -1, 1049, -1, -1, -1, -1, 1049, 
	1049, -1, -1, 1049, 1049, 1049, -1, 1049, 
	1049, -1, -1, 1049, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1049, 1049, 1049, 1049, 
	1049, 1049, 1049, -1, -1, -1, 1049, 1049, 
	1049, -1, -1, 1049, 1049, -1, 1049, 1049, 
	1049, 1049, 1049, -1, 1049, 1049, 1049, -1, 
	-1, -1, 1049, 1049, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1049, 1049, 
	1049, -1, -1, 1049, -1, -1, -1, -1, 
	1049, -1, 1049, 1049, 1049, 1049, -1, 1049, 
	1049, 1049, 1049, 1049, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1049, -1, 
	1049, -1, -1, 1049, -1, 1049, 1049, -1, 
	-1, -1, 1049, -1, 1049, -1, 1049, 1050, 
	1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 
	1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 
	1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 
	1050, -1, 1050, 1050, 1050, 1050, 1050, -1, 
	1050, -1, 1050, 1050, 1050, 1050, -1, 1050, 
	-1, 1050, 1050, 1050, -1, 1050, 1050, 1050, 
	1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 
	1050, 1050, -1, 1050, 1050, 1050, 1050, 1050, 
	1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 
	1050, 1050, -1, 1050, -1, -1, -1, -1, 
	1050, 1050, 1050, 1050, 1050, -1, -1, 1050, 
	1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 
	1050, 1050, 1050, 1050, 1050, 1050, 1050, -1, 
	-1, -1, -1, -1, 1050, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1049, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1050, 1050, 1050, 1050, -1, 
	-1, 1050, 1050, 1050, 1050, 1050, 1050, -1, 
	-1, -1, 720, 1050, 1050, 1050, 1050, 1050, 
	1050, 1050, -1, -1, -1, -1, 1050, -1, 
	-1, -1, -1, 1050, 1050, -1, -1, 1050, 
	1050, 1050, -1, 1050, 1050, -1, -1, 1050, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1050, 1050, 1050, 1050, 1050, 1050, 1050, -1, 
	-1, -1, 1050, 1050, 1050, -1, -1, 1050, 
	1050, -1, 1050, 1050, 1050, 1050, 1050, -1, 
	1050, 1050, 1050, -1, -1, -1, 1050, 1050, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1050, 1050, 1050, -1, -1, 1050, 
	-1, -1, -1, -1, 1050, -1, 1050, 1050, 
	1050, 1050, -1, 1050, 1050, 1050, 1050, 1050, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1050, -1, 1050, -1, -1, 1050, 
	-1, 1050, 1050, -1, -1, -1, 1050, -1, 
	1050, -1, 1050, 1051, 1051, 1051, 1051, 1051, 
	1051, 1051, 1051, 1051, 1051, 1051, 1051, 1051, 
	1051, 1051, 1051, 1051, 1051, 1051, 1051, 1051, 
	1051, 1051, 1051, 1051, 1051, -1, 1051, 1051, 
	1051, 1051, 1051, -1, 1051, -1, 1051, 1051, 
	1051, 1051, -1, 1051, -1, 1051, 1051, 1051, 
	-1, 1051, 1051, 1051, 1051, 1051, 1051, 1051, 
	1051, 1051, 1051, 1051, 1051, 1051, -1, 1051, 
	1051, 1051, 1051, 1051, 1051, 1051, 1051, 1051, 
	1051, 1051, 1051, 1051, 1051, 1051, -1, 1051, 
	-1, -1, -1, -1, 1051, 1051, 1051, 1051, 
	1051, -1, -1, 1051, 1051, 1051, 1051, 1051, 
	1051, 1051, 1051, 1051, 1051, 1051, 1051, 1051, 
	1051, 1051, 1051, -1, -1, -1, -1, -1, 
	1051, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1050, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1051, 
	1051, 1051, 1051, -1, -1, 1051, 1051, 1051, 
	1051, 1051, 1051, -1, -1, -1, -1, 1051, 
	1051, 1051, 1051, 1051, 1051, 1051, -1, -1, 
	-1, -1, 1051, -1, -1, -1, -1, 1051, 
	1051, -1, -1, 1051, 1051, 1051, -1, 1051, 
	1051, -1, -1, 1051, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1051, 1051, 1051, 1051, 
	1051, 1051, 1051, -1, -1, -1, 1051, 1051, 
	1051, -1, -1, 1051, 1051, -1, 1051, 1051, 
	1051, 1051, 1051, -1, 1051, 1051, 1051, -1, 
	-1, -1, 1051, 1051, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1051, 1051, 
	1051, -1, -1, 1051, -1, -1, -1, -1, 
	1051, -1, 1051, 1051, 1051, 1051, -1, 1051, 
	1051, 1051, 1051, 1051, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1051, -1, 
	1051, -1, -1, 1051, -1, 1051, 1051, -1, 
	-1, -1, 1051, -1, 1051, -1, 1051, 64, 
	67, 68, 65, 66, 73, 74, -1, 69, 
	70, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 138, 139, 141, 140, 142, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 75, -1, -1, -1, 131, -1, -1, 
	-1, 135, 136, 137, 72, 71, 130, -1, 
	-1, -1, -1, 124, 125, 126, -1, -1, 
	-1, -1, 993, 122, -1, 144, 145, 146, 
	147, -1, -1, -1, -1, -1, -1, -1, 
	127, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 117, 118, 
	119, -1, 120, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1052, 1052, 1052, 1052, 
	1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 
	1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 
	1052, 1052, 1052, 1052, 1052, 1052, -1, 1052, 
	1052, 1052, 1052, 1052, -1, 1052, -1, 1052, 
	1052, 1052, 1052, -1, 1052, -1, 1052, 1052, 
	1052, 1051, 1052, 1052, 1052, 1052, 1052, 1052, 
	1052, 1052, 1052, 1052, 1052, 1052, 1052, -1, 
	1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 
	1052, 1052, 1052, 1052, 1052, 1052, 1052, -1, 
	1052, -1, -1, -1, -1, 1052, 1052, 1052, 
	1052, 1052, -1, -1, 1052, 1052, 1052, 1052, 
	1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 
	1052, 1052, 1052, 1052, -1, -1, -1, -1, 
	-1, 1052, -1, -1, -1, -1, -1, -1, 
	-1, -1, 730, 113, 114, 115, 116, -1, 
	121, 129, 133, -1, -1, -1, -1, 132, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 143, 134, 128, 123, 993, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1052, 1052, 1052, 1052, -1, -1, 1052, 1052, 
	1052, 1052, 1052, 1052, -1, -1, -1, -1, 
	1052, 1052, 1052, 1052, 1052, 1052, 1052, -1, 
	-1, -1, -1, 1052, -1, -1, -1, -1, 
	1052, 1052, -1, -1, 1052, 1052, 1052, -1, 
	1052, 1052, -1, -1, 1052, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1052, 1052, 1052, 
	1052, 1052, 1052, 1052, -1, -1, -1, 1052, 
	1052, 1052, -1, -1, 1052, 1052, -1, 1052, 
	1052, 1052, 1052, 1052, -1, 1052, 1052, 1052, 
	-1, -1, -1, 1052, 1052, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1052, 
	1052, 1052, -1, -1, 1052, -1, -1, -1, 
	-1, 1052, -1, 1052, 1052, 1052, 1052, -1, 
	1052, 1052, 1052, 1052, 1052, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1052, 
	-1, 1052, -1, -1, 1052, -1, 1052, 1052, 
	-1, -1, -1, 1052, -1, 1052, -1, 1052, 
	760, 760, 760, 760, 760, 760, 760, 760, 
	760, 760, 760, 760, 760, 760, 760, 760, 
	760, 760, 760, 760, 760, 760, 760, 760, 
	760, 760, -1, 760, 760, 760, 760, 760, 
	-1, 760, -1, 760, 760, 760, 760, -1, 
	760, -1, 760, 760, 760, -1, -1, 760, 
	760, 760, 760, 760, 760, 760, 760, -1, 
	760, 760, 760, -1, -1, -1, -1, 760, 
	760, 760, 760, 760, -1, -1, 760, 760, 
	760, 760, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 760, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1052, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 760, 760, 760, 760, 
	-1, -1, 760, 760, -1, 760, 760, 760, 
	-1, -1, -1, -1, 760, 760, 760, -1, 
	760, 760, 760, -1, -1, -1, -1, 760, 
	-1, -1, -1, -1, 760, -1, -1, -1, 
	760, 760, 760, -1, 760, 760, -1, -1, 
	760, -1, -1, -1, -1, -1, -1, -1, 
	-1, 760, 760, 760, 760, 760, 760, 760, 
	-1, -1, -1, -1, 760, 760, -1, -1, 
	760, 760, -1, -1, -1, -1, -1, -1, 
	-1, -1, 760, 760, -1, -1, -1, -1, 
	760, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 760, 
	760, 760, -1, -1, -1, -1, -1, 760, 
	760, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 760, -1, -1, -1, -1, 
	-1, -1, 760, 989, 989, 989, 989, 989, 
	989, 989, 989, 989, 989, 989, 989, 989, 
	989, 989, 989, 989, 989, 989, 989, 989, 
	989, 989, 989, 989, 989, 989, 989, 989, 
	989, 989, 989, -1, 989, -1, 989, 989, 
	989, 989, 989, 989, -1, 989, 989, 989, 
	-1, -1, 989, 989, 989, 989, 989, 989, 
	989, 989, -1, 989, 989, 989, 989, -1, 
	-1, -1, 989, 989, 989, 989, 989, -1, 
	-1, 989, 989, 989, 989, -1, -1, -1, 
	989, -1, -1, -1, 989, 989, -1, 989, 
	-1, -1, 989, -1, -1, 989, -1, 989, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 730, 113, 
	114, 115, 116, -1, 121, 129, 133, -1, 
	-1, -1, -1, 132, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 989, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 989, -1, -1, -1, 143, 
	134, 128, 123, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 760, 989, 
	989, 989, 989, -1, -1, 989, 989, 989, 
	989, 989, 989, -1, -1, -1, -1, 989, 
	989, 989, 989, 989, 989, 989, -1, -1, 
	989, -1, 989, -1, -1, -1, -1, 989, 
	989, -1, 989, 989, 989, 989, -1, 989, 
	989, -1, -1, 989, -1, -1, -1, -1, 
	-1, 989, -1, 989, 989, 989, 989, 989, 
	989, 989, 989, -1, -1, -1, -1, 989, 
	989, -1, 989, 989, 989, -1, -1, -1, 
	-1, -1, -1, -1, -1, 989, 989, -1, 
	-1, 989, -1, 989, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 989, 989, 989, 
	-1, -1, 989, 989, 989, -1, -1, -1, 
	-1, -1, 989, 989, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 989, -1, 
	989, -1, -1, 989, 989, 989, 991, 991, 
	991, 991, 991, 991, 991, 991, 991, 991, 
	991, 991, 991, 991, 991, 991, 991, 991, 
	991, 991, 991, 991, 991, 991, 991, 991, 
	991, 991, 991, 991, 991, 991, -1, 991, 
	-1, 991, 991, 991, 991, 991, 991, -1, 
	991, 991, 991, -1, -1, 991, 991, 991, 
	991, 991, 991, 991, 991, -1, 991, 991, 
	991, 991, -1, -1, -1, 991, 991, 991, 
	991, 991, -1, -1, 991, 991, 991, 991, 
	-1, -1, -1, 991, -1, -1, -1, 991, 
	991, -1, 991, -1, -1, 991, -1, -1, 
	991, -1, 991, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 991, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 991, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 989, 991, 991, 991, 991, -1, -1, 
	991, 991, 991, 991, 991, 991, -1, -1, 
	-1, -1, 991, 991, 991, 991, 991, 991, 
	991, -1, -1, 991, -1, 991, -1, -1, 
	-1, -1, 991, 991, -1, 991, 991, 991, 
	991, -1, 991, 991, -1, -1, 991, -1, 
	-1, -1, -1, -1, 991, -1, 991, 991, 
	991, 991, 991, 991, 991, 991, -1, -1, 
	-1, -1, 991, 991, -1, 991, 991, 991, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	991, 991, -1, -1, 991, -1, 991, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	991, 991, 991, -1, -1, 991, 991, 991, 
	-1, -1, -1, -1, -1, 991, 991, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 991, -1, 991, -1, -1, 991, 991, 
	991, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 
	1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 
	1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 
	1158, 1158, 1158, -1, 1158, 1158, 1158, 1158, 
	1158, -1, 1158, -1, 1158, 1158, 1158, 1158, 
	-1, 1158, -1, 1158, 1158, 1158, 1062, 1158, 
	1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 
	1158, 1158, 1158, 1158, -1, 1158, 1158, 1158, 
	1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 
	1158, 1158, 1158, 1158, -1, 1158, -1, -1, 
	1062, -1, 1158, 1158, 1158, 1158, 1158, -1, 
	-1, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 
	1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 
	1158, -1, -1, -1, -1, -1, 1158, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 991, 1158, 1158, 1158, 
	1158, -1, -1, 1158, 1158, 1158, 1158, 1158, 
	1158, -1, -1, -1, -1, 1158, 1158, 1158, 
	1158, 1158, 1158, 1158, -1, -1, -1, -1, 
	1158, -1, -1, -1, -1, 1158, 1158, -1, 
	-1, 1158, 1158, 1158, -1, 1158, 1158, -1, 
	-1, 1158, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1158, 1158, 1158, 1158, 1158, 1158, 
	1158, -1, -1, -1, 1158, 1158, 1158, 1032, 
	-1, 1158, 1158, -1, 1158, 1158, 1158, 1158, 
	1158, 1062, 1158, 1158, 1158, -1, -1, -1, 
	1158, 1158, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1158, 1158, 1158, -1, 
	-1, 1158, -1, -1, -1, -1, 1158, -1, 
	1158, 1158, 1158, 1158, -1, 1158, 1158, 1158, 
	1158, 1158, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1158, -1, 1158, -1, 
	-1, 1158, -1, 1158, 1158, -1, -1, -1, 
	1158, -1, 1158, -1, 1158, 1159, 1159, 1159, 
	1159, 1159, 1159, 1159, 1159, 1159, 1159, 1159, 
	1159, 1159, 1159, 1159, 1159, 1159, 1159, 1159, 
	1159, 1159, 1159, 1159, 1159, 1159, 1159, -1, 
	1159, 1159, 1159, 1159, 1159, -1, 1159, -1, 
	1159, 1159, 1159, 1159, -1, 1159, -1, 1159, 
	1159, 1159, 1063, 1159, 1159, 1159, 1159, 1159, 
	1159, 1159, 1159, 1159, 1159, 1159, 1159, 1159, 
	-1, 1159, 1159, 1159, 1159, 1159, 1159, 1159, 
	1159, 1159, 1159, 1159, 1159, 1159, 1159, 1159, 
	-1, 1159, -1, -1, 1063, -1, 1159, 1159, 
	1159, 1159, 1159, -1, -1, 1159, 1159, 1159, 
	1159, 1159, 1159, 1159, 1159, 1159, 1159, 1159, 
	1159, 1159, 1159, 1159, 1159, -1, -1, -1, 
	-1, -1, 1159, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1158, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1159, 1159, 1159, 1159, -1, -1, 1159, 
	1159, 1159, 1159, 1159, 1159, -1, -1, -1, 
	-1, 1159, 1159, 1159, 1159, 1159, 1159, 1159, 
	-1, -1, -1, -1, 1159, -1, -1, -1, 
	-1, 1159, 1159, -1, -1, 1159, 1159, 1159, 
	-1, 1159, 1159, -1, -1, 1159, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1159, 1159, 
	1159, 1159, 1159, 1159, 1159, -1, -1, -1, 
	1159, 1159, 1159, 1033, -1, 1159, 1159, -1, 
	1159, 1159, 1159, 1159, 1159, 1063, 1159, 1159, 
	1159, -1, -1, -1, 1159, 1159, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1159, 1159, 1159, -1, -1, 1159, -1, -1, 
	-1, -1, 1159, -1, 1159, 1159, 1159, 1159, 
	-1, 1159, 1159, 1159, 1159, 1159, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1159, -1, 1159, -1, -1, 1159, -1, 1159, 
	1159, -1, -1, -1, 1159, -1, 1159, -1, 
	1159, 55, 56, 64, 67, 68, 65, 66, 
	73, 74, 1135, 69, 70, -1, -1, 35, 
	36, 40, 38, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 41, 
	42, 43, -1, -1, -1, 75, -1, -1, 
	-1, -1, 37, -1, -1, -1, -1, -1, 
	72, 71, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 59, -1, 
	-1, 82, 84, 86, 88, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1135, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 906, 906, 906, 906, 906, 906, 
	906, 906, 906, 906, 906, 906, 906, 906, 
	906, -1, 906, 906, 906, 906, 906, 906, 
	906, 906, -1, -1, -1, 906, 906, 906, 
	906, 906, -1, 906, -1, 906, 906, 906, 
	906, -1, 906, 739, 906, 906, 906, -1, 
	-1, 906, -1, 1159, 906, 906, 906, 906, 
	906, -1, 906, 906, 906, -1, -1, -1, 
	-1, 906, 906, 906, 906, 906, -1, -1, 
	906, 906, 906, 906, -1, 906, -1, -1, 
	-1, -1, -1, -1, -1, 906, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 299, 
	-1, -1, -1, -1, -1, -1, -1, 1135, 
	1135, 735, -1, 34, 33, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 62, -1, 
	-1, -1, -1, 44, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 80, 76, 45, -1, -1, -1, 
	-1, -1, 39, 993, -1, -1, 906, 906, 
	906, 906, -1, -1, 906, 906, 906, 906, 
	906, 906, -1, -1, -1, 298, 906, 906, 
	906, 906, 906, 906, 906, -1, -1, -1, 
	-1, 906, -1, -1, -1, -1, 906, 906, 
	-1, -1, 906, 906, 906, -1, 906, 906, 
	-1, -1, 906, -1, -1, -1, 738, -1, 
	-1, 906, -1, -1, -1, -1, 906, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 906, 906, -1, -1, -1, -1, 
	-1, -1, -1, -1, 906, 906, -1, -1, 
	-1, -1, 906, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 906, 906, 906, -1, -1, -1, -1, 
	-1, 906, 906, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 906, -1, 906, 
	-1, -1, 906, -1, -1, 895, 895, 895, 
	895, 895, 895, 895, 895, 895, 895, 895, 
	895, 895, 895, 895, -1, 895, 895, 895, 
	895, 895, 895, 895, 895, -1, -1, -1, 
	895, 895, 895, 895, 895, -1, 895, -1, 
	895, 895, 895, 895, -1, 895, -1, 895, 
	895, 895, -1, -1, 895, -1, -1, 895, 
	895, 895, 895, 895, -1, 895, 895, 895, 
	-1, -1, -1, -1, 895, 895, 895, 895, 
	895, -1, -1, 895, 895, 895, 895, -1, 
	-1, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 
	743, 1042, 1042, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1042, 1042, 1042, 1042, 
	1042, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1042, -1, -1, -1, 1042, 
	-1, -1, -1, 1042, 1042, 1042, 1042, 1042, 
	1042, -1, -1, -1, -1, 1042, 1042, 1042, 
	-1, -1, -1, -1, 1042, 1042, 1042, 1042, 
	1042, 1042, 1042, 1042, -1, -1, -1, -1, 
	-1, -1, 1042, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1042, 1042, 1042, 1042, 1042, -1, -1, -1, 
	906, 895, 895, 895, 895, -1, 1042, 895, 
	895, 895, 895, 895, 895, -1, -1, -1, 
	-1, 895, 895, 895, 895, 895, 895, 895, 
	-1, -1, -1, -1, 895, -1, -1, -1, 
	-1, 895, 895, -1, -1, 895, 895, 895, 
	-1, 895, 895, 742, -1, 895, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 895, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 895, 895, -1, 
	-1, -1, -1, -1, -1, -1, -1, 895, 
	895, -1, -1, -1, -1, 895, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 895, 895, 895, -1, 
	-1, -1, -1, -1, 895, 895, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	895, -1, 895, -1, -1, 895, -1, -1, 
	-1, -1, -1, -1, 1042, 1042, 1042, 1042, 
	1042, -1, 1042, 1042, 1042, -1, -1, -1, 
	-1, 1042, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1042, 1042, 1042, -1, 
	-1, 1042, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1042, 1042, 1042, 
	1042, 1042, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1042, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 299, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 735, -1, 34, 
	33, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 62, -1, -1, -1, -1, 44, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 80, 76, 
	45, -1, -1, -1, -1, -1, 39, -1, 
	-1, -1, -1, 895, -1, -1, -1, -1, 
	-1, -1, 1046, 1046, 1046, 1046, 1046, 1046, 
	1046, 298, 1046, 1046, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1046, 1046, 1046, 
	1046, 1046, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1046, -1, -1, -1, 
	1046, -1, 738, -1, 1046, 1046, 1046, 1046, 
	1046, 1046, -1, -1, -1, -1, 1046, 1046, 
	1046, -1, -1, -1, -1, 1046, 1046, 1046, 
	1046, 1046, 1046, 1046, 1046, -1, -1, -1, 
	-1, -1, -1, 1046, -1, -1, -1, 64, 
	67, 68, 65, 66, 73, 74, -1, 69, 
	70, 1046, 1046, 1046, 1046, 1046, -1, -1, 
	274, 275, 138, 139, 141, 140, 142, 1046, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 75, -1, -1, -1, 131, -1, -1, 
	-1, 135, 136, 137, 72, 71, 130, -1, 
	-1, -1, -1, 124, 125, 126, -1, -1, 
	-1, -1, 993, 122, -1, 144, 145, 146, 
	147, -1, -1, -1, -1, -1, -1, -1, 
	127, 930, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 117, 118, 
	119, -1, 120, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1046, 1046, 1046, 
	1046, 1046, -1, 1046, 1046, 1046, -1, -1, 
	-1, -1, 1046, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1046, 1046, 1046, 
	-1, -1, 1046, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1046, 1046, 
	1046, 1046, 1046, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 205, 
	748, 1046, -1, -1, -1, -1, -1, -1, 
	-1, -1, 206, 113, 114, 115, 116, -1, 
	121, 129, 133, -1, -1, -1, -1, 132, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 742, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 143, 134, 128, 123, 993, 
	844, 844, 844, 844, 844, 844, 844, 844, 
	844, 844, 844, 844, 844, 844, 844, -1, 
	844, 844, 844, 844, 844, 844, 844, 844, 
	-1, -1, -1, 844, 844, 844, 844, 844, 
	-1, 844, -1, 844, 844, 844, 844, -1, 
	844, -1, 844, 844, 844, -1, -1, 844, 
	-1, -1, 844, 844, 844, 844, 844, -1, 
	844, 844, 844, -1, -1, -1, -1, 844, 
	844, 844, 844, 844, -1, -1, 844, 844, 
	844, 844, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 844, 844, 844, 844, 
	-1, -1, 844, 844, 844, 844, 844, 844, 
	-1, -1, -1, -1, 844, 844, 844, 844, 
	844, 844, 844, -1, -1, -1, -1, 844, 
	-1, -1, -1, -1, 844, 844, -1, -1, 
	844, 844, 844, -1, 844, 844, -1, -1, 
	844, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 844, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	844, 844, -1, -1, -1, -1, -1, -1, 
	-1, -1, 844, 844, -1, -1, -1, -1, 
	844, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 844, 
	844, 844, -1, -1, -1, -1, -1, 844, 
	844, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 844, -1, 844, -1, -1, 
	844, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 855, 
	855, 855, 855, 855, 855, 855, 855, 855, 
	855, 855, 855, 855, 855, 855, -1, 855, 
	855, 855, 855, 855, 855, 855, 855, -1, 
	-1, -1, 855, 855, 855, 855, 855, -1, 
	855, -1, 855, 855, 855, 855, -1, 855, 
	-1, 855, 855, 855, -1, -1, 855, -1, 
	-1, 855, 855, 855, 855, 855, -1, 855, 
	855, 855, -1, -1, -1, -1, 855, 855, 
	855, 855, 855, -1, -1, 855, 855, 855, 
	855, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 844, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 855, 855, 855, 855, -1, 
	-1, 855, 855, 855, 855, 855, 855, -1, 
	-1, -1, -1, 855, 855, 855, 855, 855, 
	855, 855, -1, -1, -1, -1, 855, -1, 
	-1, -1, -1, 855, 855, -1, -1, 855, 
	855, 855, -1, 855, 855, -1, -1, 855, 
	-1, -1, -1, 205, 748, -1, -1, -1, 
	-1, -1, -1, 855, -1, -1, 206, 113, 
	114, 115, 116, -1, 121, 129, 133, 855, 
	855, -1, -1, 132, -1, -1, -1, -1, 
	-1, 855, 855, -1, -1, -1, -1, 855, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 143, 
	134, 128, 123, -1, -1, -1, 855, 855, 
	855, -1, -1, -1, -1, -1, 855, 855, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 855, -1, 855, -1, -1, 855, 
	-1, -1, 907, 907, 907, 907, 907, 907, 
	907, 907, 907, 907, 907, 907, 907, 907, 
	907, -1, 907, 907, 907, 907, 907, 907, 
	907, 907, -1, -1, -1, 907, 907, 907, 
	907, 907, -1, 907, -1, 907, 907, 907, 
	907, -1, 907, 907, 907, 907, 907, -1, 
	-1, 907, -1, -1, 907, 907, 907, 907, 
	907, -1, 907, 907, 907, -1, -1, -1, 
	-1, 907, 907, 907, 907, 907, -1, -1, 
	907, 907, 907, 907, -1, 907, -1, -1, 
	-1, -1, -1, -1, -1, 907, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 855, 907, 907, 
	907, 907, -1, -1, 907, 907, 907, 907, 
	907, 907, -1, -1, -1, -1, 907, 907, 
	907, 907, 907, 907, 907, -1, -1, -1, 
	-1, 907, -1, -1, -1, -1, 907, 907, 
	-1, -1, 907, 907, 907, -1, 907, 907, 
	-1, -1, 907, -1, -1, -1, 907, -1, 
	-1, 907, -1, -1, -1, -1, 907, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 907, 907, -1, -1, -1, -1, 
	-1, -1, -1, -1, 907, 907, -1, -1, 
	-1, -1, 907, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 907, 907, 907, -1, -1, -1, -1, 
	-1, 907, 907, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 907, -1, 907, 
	-1, -1, 907, -1, -1, 911, 911, 911, 
	911, 911, 911, 911, 911, 911, 911, 911, 
	911, 911, 911, 911, -1, 911, 911, 911, 
	911, 911, 911, 911, 911, -1, -1, -1, 
	911, 911, 911, 911, 911, -1, 911, -1, 
	911, 911, 911, 911, -1, 911, -1, 911, 
	911, 911, -1, -1, 911, -1, -1, 911, 
	911, 911, 911, 911, -1, 911, 911, 911, 
	-1, -1, -1, -1, 911, 911, 911, 911, 
	911, -1, -1, 911, 911, 911, 911, -1, 
	911, -1, -1, -1, -1, -1, -1, -1, 
	752, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	907, 911, 911, 911, 911, -1, -1, 911, 
	911, 911, 911, 911, 911, -1, -1, -1, 
	-1, 911, 911, 911, 911, 911, 911, 911, 
	-1, -1, -1, -1, 911, -1, -1, -1, 
	-1, 911, 911, -1, -1, 911, 911, 911, 
	-1, 911, 911, -1, -1, 911, -1, -1, 
	-1, -1, -1, -1, 751, -1, -1, -1, 
	-1, 911, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 911, 911, -1, 
	-1, -1, -1, -1, -1, -1, -1, 911, 
	911, -1, -1, -1, -1, 911, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 911, 911, 911, -1, 
	-1, -1, -1, -1, 911, 911, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	911, -1, 911, -1, -1, 911, -1, -1, 
	905, 905, 905, 905, 905, 905, 905, 905, 
	905, 905, 905, 905, 905, 905, 905, -1, 
	905, 905, 905, 905, 905, 905, 905, 905, 
	-1, -1, -1, 905, 905, 905, 905, 905, 
	-1, 905, -1, 905, 905, 905, 905, -1, 
	905, -1, 905, 905, 905, -1, -1, 905, 
	-1, -1, 905, 905, 905, 905, 905, -1, 
	905, 905, 905, -1, -1, -1, -1, 905, 
	905, 905, 905, 905, -1, -1, 905, 905, 
	905, 905, -1, 905, -1, -1, -1, -1, 
	-1, -1, -1, 905, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 911, 905, 905, 905, 905, 
	-1, -1, 905, 905, 905, 905, 905, 905, 
	-1, -1, -1, -1, 905, 905, 905, 905, 
	905, 905, 905, -1, -1, -1, -1, 905, 
	-1, -1, -1, -1, 905, 905, -1, -1, 
	905, 905, 905, -1, 905, 905, -1, -1, 
	905, -1, -1, -1, -1, -1, -1, 905, 
	-1, -1, -1, -1, 905, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	905, 905, -1, -1, -1, -1, -1, -1, 
	-1, -1, 905, 905, -1, -1, -1, -1, 
	905, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 905, 
	905, 905, -1, -1, -1, -1, -1, 905, 
	905, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 905, -1, 905, -1, -1, 
	905, -1, -1, 892, 892, 892, 892, 892, 
	892, 892, 892, 892, 892, 892, 892, 892, 
	892, 892, -1, 892, 892, 892, 892, 892, 
	892, 892, 892, -1, -1, -1, 892, 892, 
	892, 892, 892, -1, 892, -1, 892, 892, 
	892, 892, -1, 892, -1, 892, 892, 892, 
	-1, -1, 892, -1, -1, 892, 892, 892, 
	892, 892, -1, 892, 892, 892, -1, -1, 
	-1, -1, 892, 892, 892, 892, 892, -1, 
	-1, 892, 892, 892, 892, -1, 55, 56, 
	64, 67, 68, 65, 66, 73, 74, 1135, 
	69, 70, -1, -1, 35, 36, 40, 38, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 41, 42, 43, -1, 
	-1, -1, 75, -1, -1, -1, -1, 37, 
	-1, -1, -1, -1, -1, 72, 71, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 59, -1, -1, 82, 84, 
	86, 88, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1135, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 905, 892, 
	892, 892, 892, -1, -1, 892, 892, 892, 
	892, 892, 892, -1, -1, -1, -1, 892, 
	892, 892, 892, 892, 892, 892, -1, -1, 
	-1, -1, 892, -1, -1, -1, -1, 892, 
	892, -1, -1, 892, 892, 892, -1, 892, 
	892, -1, -1, 892, -1, -1, -1, -1, 
	751, -1, -1, -1, -1, -1, -1, 892, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 892, 892, -1, -1, -1, 
	-1, -1, -1, -1, -1, 892, 892, -1, 
	-1, -1, -1, 892, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 892, 892, 892, -1, -1, -1, 
	-1, -1, 892, 892, -1, -1, -1, -1, 
	-1, -1, -1, -1, 299, -1, 892, -1, 
	892, -1, -1, 892, 1135, 1135, 755, -1, 
	34, 33, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 62, -1, -1, -1, -1, 
	44, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 80, 
	76, 45, -1, -1, -1, -1, -1, 39, 
	993, 1043, 1043, 1043, 1043, 1043, 1043, 1043, 
	-1, 1043, 1043, -1, -1, -1, -1, -1, 
	-1, -1, 298, -1, 1043, 1043, 1043, 1043, 
	1043, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1043, -1, -1, -1, 1043, 
	-1, -1, -1, 1043, 1043, 1043, 1043, 1043, 
	1043, -1, -1, -1, -1, 1043, 1043, 1043, 
	-1, -1, -1, -1, 1043, 1043, 1043, 1043, 
	1043, 1043, 1043, 1043, -1, -1, -1, -1, 
	-1, -1, 1043, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1043, 1043, 1043, 1043, 1043, -1, -1, 1044, 
	1044, 1044, 1044, 1044, 1044, 1044, 1043, 1044, 
	1044, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1044, 1044, 1044, 1044, 1044, -1, 
	-1, 892, -1, -1, -1, -1, -1, -1, 
	-1, 1044, -1, -1, -1, 1044, -1, -1, 
	-1, 1044, 1044, 1044, 1044, 1044, 1044, -1, 
	-1, -1, -1, 1044, 1044, 1044, -1, -1, 
	-1, -1, 1044, 1044, 1044, 1044, 1044, 1044, 
	1044, 1044, -1, -1, -1, -1, -1, -1, 
	1044, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1044, 1044, 
	1044, 1044, 1044, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1044, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1043, 1043, 1043, 1043, 
	1043, -1, 1043, 1043, 1043, -1, -1, -1, 
	-1, 1043, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1043, 1043, 1043, -1, 
	-1, 1043, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1043, 1043, 1043, 
	1043, 1043, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1043, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1044, 1044, 1044, 1044, 1044, -1, 
	1044, 1044, 1044, -1, -1, -1, -1, 1044, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1044, 1044, 1044, -1, -1, 1044, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1044, 1044, 1044, 1044, 1044, 
	-1, -1, -1, -1, 1045, 1045, 1045, 1045, 
	1045, 1045, 1045, -1, 1045, 1045, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1044, 1045, 
	1045, 1045, 1045, 1045, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1045, -1, 
	-1, -1, 1045, -1, -1, -1, 1045, 1045, 
	1045, 1045, 1045, 1045, -1, -1, -1, -1, 
	1045, 1045, 1045, -1, -1, -1, -1, 1045, 
	1045, 1045, 1045, 1045, 1045, 1045, 1045, -1, 
	-1, -1, -1, -1, -1, 1045, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1045, 1045, 1045, 1045, 1045, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1045, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	299, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 755, -1, 34, 33, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 62, 
	-1, -1, -1, -1, 44, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 80, 76, 45, -1, -1, 
	-1, -1, -1, 39, -1, -1, -1, 1045, 
	1045, 1045, 1045, 1045, -1, 1045, 1045, 1045, 
	-1, -1, -1, -1, 1045, -1, 298, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1045, 
	1045, 1045, -1, -1, 1045, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1045, 1045, 1045, 1045, 1045, -1, -1, -1, 
	-1, -1, -1, -1, 854, 854, 854, 854, 
	854, 854, 854, 854, 854, 854, 854, 854, 
	854, 854, 854, 1045, 854, 854, 854, 854, 
	854, 854, 854, 854, -1, -1, -1, 854, 
	854, 854, 854, 854, -1, 854, -1, 854, 
	854, 854, 854, -1, 854, -1, 854, 854, 
	854, -1, -1, 854, -1, -1, 854, 854, 
	854, 854, 854, -1, 854, 854, 854, -1, 
	-1, -1, -1, 854, 854, 854, 854, 854, 
	-1, -1, 854, 854, 854, 854, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	854, 854, 854, 854, -1, -1, 854, 854, 
	854, 854, 854, 854, -1, -1, -1, -1, 
	854, 854, 854, 854, 854, 854, 854, -1, 
	-1, -1, -1, 854, -1, -1, -1, -1, 
	854, 854, -1, -1, 854, 854, 854, -1, 
	854, 854, -1, -1, 854, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	854, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 854, 854, -1, -1, 
	-1, -1, -1, -1, -1, -1, 854, 854, 
	-1, -1, -1, -1, 854, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 854, 854, 854, -1, -1, 
	-1, -1, -1, 854, 854, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 854, 
	-1, 854, -1, -1, 854, -1, -1, 909, 
	909, 909, 909, 909, 909, 909, 909, 909, 
	909, 909, 909, 909, 909, 909, -1, 909, 
	909, 909, 909, 909, 909, 909, 909, -1, 
	-1, -1, 909, 909, 909, 909, 909, -1, 
	909, -1, 909, 909, 909, 909, -1, 909, 
	-1, 909, 909, 909, -1, -1, 909, -1, 
	-1, 909, 909, 909, 909, 909, -1, 909, 
	909, 909, -1, -1, -1, -1, 909, 909, 
	909, 909, 909, -1, -1, 909, 909, 909, 
	909, -1, 909, 55, 56, 64, 67, 68, 
	65, 66, 73, 74, 1135, 69, 70, -1, 
	-1, 35, 36, 40, 38, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 41, 42, 43, -1, -1, -1, 75, 
	-1, -1, -1, -1, 37, -1, -1, -1, 
	-1, -1, 72, 71, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	59, -1, -1, 82, 84, 86, 88, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1135, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 854, 909, 909, 909, 909, -1, 
	-1, 909, 909, 909, 909, 909, 909, -1, 
	-1, -1, -1, 909, 909, 909, 909, 909, 
	909, 909, -1, -1, -1, -1, 909, -1, 
	-1, -1, -1, 909, 909, -1, -1, 909, 
	909, 909, -1, 909, 909, -1, -1, 909, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 909, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 909, 
	909, -1, -1, -1, -1, -1, -1, -1, 
	-1, 909, 909, -1, -1, -1, -1, 909, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 909, 909, 
	909, -1, -1, -1, -1, -1, 909, 909, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 299, 909, -1, 909, -1, -1, 909, 
	-1, 1135, 1135, 757, -1, 34, 33, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	62, -1, -1, -1, -1, 44, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 80, 76, 45, -1, 
	-1, -1, -1, -1, 39, 993, -1, -1, 
	894, 894, 894, 894, 894, 894, 894, 894, 
	894, 894, 894, 894, 894, 894, 894, 298, 
	894, 894, 894, 894, 894, 894, 894, 894, 
	-1, -1, -1, 894, 894, 894, 894, 894, 
	-1, 894, -1, 894, 894, 894, 894, -1, 
	894, -1, 894, 894, 894, -1, -1, 894, 
	-1, -1, 894, 894, 894, 894, 894, -1, 
	894, 894, 894, -1, -1, -1, -1, 894, 
	894, 894, 894, 894, -1, -1, 894, 894, 
	894, 894, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 909, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 894, 894, 894, 894, 
	-1, -1, 894, 894, 894, 894, 894, 894, 
	-1, -1, -1, -1, 894, 894, 894, 894, 
	894, 894, 894, -1, -1, -1, -1, 894, 
	-1, -1, -1, -1, 894, 894, -1, -1, 
	894, 894, 894, -1, 894, 894, -1, -1, 
	894, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 894, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	894, 894, -1, -1, -1, -1, -1, -1, 
	-1, -1, 894, 894, -1, -1, -1, -1, 
	894, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 894, 
	894, 894, -1, -1, -1, -1, -1, 894, 
	894, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 894, -1, 894, -1, -1, 
	894, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 910, 910, 910, 
	910, 910, 910, 910, 910, 910, 910, 910, 
	910, 910, 910, 910, -1, 910, 910, 910, 
	910, 910, 910, 910, 910, -1, -1, -1, 
	910, 910, 910, 910, 910, -1, 910, -1, 
	910, 910, 910, 910, -1, 910, -1, 910, 
	910, 910, -1, -1, 910, -1, -1, 910, 
	910, 910, 910, 910, -1, 910, 910, 910, 
	-1, -1, -1, -1, 910, 910, 910, 910, 
	910, -1, -1, 910, 910, 910, 910, -1, 
	910, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 894, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 910, 910, 910, 910, -1, -1, 910, 
	910, 910, 910, 910, 910, -1, -1, -1, 
	-1, 910, 910, 910, 910, 910, 910, 910, 
	-1, -1, -1, -1, 910, -1, -1, -1, 
	-1, 910, 910, -1, -1, 910, 910, 910, 
	-1, 910, 910, -1, -1, 910, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 910, -1, -1, -1, 299, -1, -1, 
	-1, -1, -1, -1, -1, 910, 910, 757, 
	-1, 34, 33, -1, -1, -1, -1, 910, 
	910, -1, -1, -1, 62, 910, -1, -1, 
	-1, 44, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 910, 910, 910, -1, 
	80, 76, 45, -1, 910, 910, -1, -1, 
	39, -1, -1, -1, -1, -1, -1, -1, 
	910, -1, 910, -1, -1, 910, -1, -1, 
	-1, -1, -1, 298, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 910
};

static int pid_0_parser_owners[] = {
	0, 0, 1, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 2, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	24, 26, 28, 0, 0, 0, 0, 0, 
	27, 0, 30, 0, 0, 0, 0, 31, 
	0, 33, 0, 0, 0, 36, 38, 0, 
	41, 25, 0, 0, 0, 0, 0, 40, 
	0, 0, 0, 25, 47, 40, 49, 0, 
	0, 0, 0, 0, 51, 52, 0, 0, 
	0, 0, 53, 54, 55, 57, 58, 59, 
	56, 56, 56, 56, 63, 64, 50, 67, 
	50, 68, 82, 56, 73, 84, 73, 85, 
	86, 91, 102, 27, 79, 79, 32, 32, 
	32, 32, 32, 120, 74, 121, 74, 122, 
	129, 130, 131, 132, 133, 137, 137, 141, 
	153, 154, 163, 157, 157, 32, 32, 32, 
	124, 164, 161, 161, 165, 167, 167, 167, 
	173, 48, 48, 48, 48, 48, 32, 75, 
	174, 75, 78, 78, 78, 65, 172, 178, 
	172, 169, 179, 193, 66, 194, 70, 196, 
	48, 48, 48, 89, 213, 233, 251, 252, 
	254, 254, 254, 0, 0, 0, 0, 0, 
	284, 48, 0, 0, 27, 0, 0, 0, 
	285, 25, 25, 25, 0, 0, 0, 295, 
	0, 0, 0, 50, 50, 296, 237, 0, 
	302, 73, 73, 322, 0, 323, 345, 297, 
	0, 0, 0, 350, 0, 0, 307, 307, 
	0, 74, 74, 60, 60, 60, 60, 60, 
	97, 97, 97, 97, 0, 361, 38, 366, 
	41, 47, 77, 77, 77, 195, 77, 383, 
	0, 0, 60, 60, 60, 195, 79, 384, 
	186, 81, 0, 0, 75, 75, 390, 393, 
	0, 195, 195, 60, 135, 135, 135, 137, 
	135, 237, 38, 38, 41, 41, 50, 189, 
	297, 250, 250, 157, 73, 81, 161, 0, 
	0, 0, 186, 81, 246, 246, 277, 0, 
	0, 56, 56, 56, 74, 395, 78, 209, 
	209, 303, 303, 0, 59, 3, 3, 3, 
	3, 3, 3, 3, 3, 3, 3, 3, 
	3, 3, 3, 3, 397, 3, 3, 3, 
	3, 3, 3, 3, 3, 32, 32, 75, 
	3, 3, 3, 3, 3, 65, 3, 78, 
	3, 3, 3, 3, 66, 3, 70, 3, 
	3, 3, 189, 89, 3, 124, 48, 3, 
	3, 3, 3, 3, 399, 3, 3, 3, 
	48, 48, 307, 317, 3, 3, 3, 3, 
	3, 65, 65, 3, 3, 3, 3, 400, 
	66, 66, 70, 70, 343, 401, 343, 89, 
	89, 402, 77, 136, 136, 136, 61, 61, 
	61, 61, 61, 403, 83, 404, 317, 62, 
	62, 62, 62, 62, 83, 256, 77, 378, 
	378, 189, 300, 300, 135, 61, 61, 61, 
	186, 81, 97, 97, 97, 250, 62, 62, 
	62, 256, 256, 405, 406, 407, 61, 186, 
	81, 186, 81, 420, 246, 135, 83, 62, 
	77, 209, 60, 60, 443, 60, 416, 314, 
	314, 303, 81, 444, 445, 446, 447, 451, 
	457, 462, 467, 471, 473, 446, 69, 69, 
	69, 69, 69, 474, 135, 501, 277, 83, 
	502, 3, 3, 3, 3, 503, 0, 3, 
	3, 416, 3, 3, 3, 69, 69, 69, 
	518, 3, 3, 3, 526, 3, 3, 3, 
	98, 98, 98, 98, 3, 531, 69, 148, 
	148, 3, 277, 277, 532, 3, 3, 3, 
	558, 3, 3, 81, 286, 3, 529, 349, 
	71, 71, 71, 71, 71, 99, 99, 99, 
	99, 3, 155, 155, 155, 449, 83, 136, 
	382, 382, 148, 466, 466, 3, 3, 71, 
	71, 71, 90, 90, 90, 90, 90, 3, 
	3, 529, 351, 351, 351, 3, 300, 378, 
	71, 566, 290, 290, 162, 162, 162, 351, 
	351, 90, 90, 90, 203, 203, 203, 203, 
	136, 83, 568, 570, 3, 3, 3, 203, 
	583, 286, 90, 586, 3, 3, 159, 159, 
	159, 314, 159, 92, 92, 92, 92, 92, 
	3, 343, 449, 93, 93, 93, 93, 93, 
	94, 94, 94, 94, 94, 61, 61, 348, 
	61, 601, 92, 92, 92, 607, 62, 62, 
	600, 62, 93, 93, 93, 169, 600, 94, 
	94, 94, 614, 92, 95, 95, 95, 95, 
	95, 281, 83, 93, 367, 367, 367, 615, 
	94, 96, 96, 96, 96, 96, 626, 627, 
	281, 367, 367, 95, 95, 95, 631, 408, 
	408, 208, 208, 208, 349, 633, 349, 498, 
	96, 96, 96, 528, 95, 528, 155, 634, 
	148, 148, 148, 642, 382, 69, 69, 466, 
	69, 96, 313, 313, 313, 644, 650, 388, 
	388, 388, 498, 198, 198, 198, 198, 465, 
	465, 98, 98, 98, 589, 589, 198, 656, 
	162, 640, 199, 199, 199, 199, 659, 155, 
	660, 640, 158, 158, 158, 199, 158, 144, 
	144, 144, 144, 144, 663, 673, 99, 99, 
	99, 286, 286, 290, 290, 290, 159, 71, 
	71, 677, 71, 413, 413, 413, 144, 144, 
	144, 162, 449, 449, 203, 641, 680, 281, 
	281, 281, 159, 686, 348, 641, 348, 144, 
	673, 90, 90, 362, 362, 668, 690, 668, 
	203, 203, 203, 3, 693, 519, 519, 0, 
	0, 0, 0, 0, 363, 363, 0, 0, 
	27, 0, 0, 0, 159, 25, 25, 25, 
	0, 0, 0, 662, 0, 0, 0, 50, 
	50, 525, 525, 0, 386, 208, 386, 408, 
	0, 699, 92, 92, 0, 0, 0, 703, 
	0, 0, 93, 93, 0, 708, 710, 94, 
	94, 248, 248, 248, 662, 248, 313, 694, 
	0, 694, 38, 388, 41, 47, 145, 145, 
	145, 145, 145, 723, 0, 0, 208, 465, 
	524, 524, 79, 95, 95, 482, 482, 0, 
	589, 730, 557, 557, 0, 145, 145, 145, 
	96, 96, 158, 137, 389, 389, 38, 313, 
	41, 732, 50, 198, 388, 470, 145, 157, 
	414, 414, 161, 0, 0, 0, 158, 413, 
	724, -1, 199, 0, 470, 56, 56, 56, 
	724, 483, 483, -1, 198, 198, 198, 0, 
	59, 319, 585, 319, 156, 156, 156, 156, 
	156, 516, 516, 199, 199, 199, 362, 362, 
	158, -1, 515, 515, 515, 519, 696, 696, 
	413, 32, 32, 156, 156, 156, -1, 363, 
	363, 65, 567, 78, 556, 556, 144, 144, 
	66, -1, 70, -1, 156, 525, 523, 89, 
	523, 124, 48, 207, 207, 207, 652, 207, 
	613, 613, 652, 200, 200, 200, 200, 201, 
	201, 201, 201, -1, -1, 65, 200, -1, 
	-1, 248, 201, -1, 66, -1, 70, 377, 
	377, 377, 377, 89, 386, -1, -1, 191, 
	191, 191, 191, 470, 470, 470, 386, 191, 
	524, -1, 248, -1, -1, 191, 557, 191, 
	191, 482, 77, -1, -1, 189, 389, 319, 
	-1, -1, -1, -1, 186, -1, 97, 97, 
	97, 250, 414, 197, 197, 197, 197, 197, 
	-1, 248, 480, 480, 480, -1, 480, -1, 
	246, 135, 649, 649, 77, 209, -1, -1, 
	480, 60, 197, 197, 197, 483, 81, 585, 
	567, -1, 567, 516, -1, 145, 145, -1, 
	-1, -1, -1, 197, -1, -1, 515, -1, 
	135, -1, 277, -1, -1, 3, 3, 3, 
	3, -1, 696, 3, 3, -1, 3, 3, 
	3, 319, -1, -1, 556, 3, 3, 3, 
	187, 3, 3, 3, 101, 312, 312, 312, 
	3, 312, -1, 207, 613, 3, 277, 515, 
	207, 3, 3, 3, 187, 3, 3, 81, 
	-1, 3, 609, 609, 187, 101, 101, 101, 
	101, 101, 187, 156, 156, 3, 523, 232, 
	232, 232, 232, 232, 569, 569, 569, 569, 
	523, 3, 3, 200, 101, 101, 101, 201, 
	664, 664, 575, 575, 3, 207, 232, 232, 
	232, 3, 300, 378, 191, 101, 191, 191, 
	191, 191, 191, 191, 200, 200, 200, 232, 
	201, 201, 201, -1, 136, 83, -1, -1, 
	3, 3, 3, 377, 377, 377, 649, 187, 
	3, -1, 247, 247, 247, 314, 247, 379, 
	379, 379, -1, 379, 3, 4, 4, 4, 
	4, 4, 4, 4, 4, 4, 4, 4, 
	4, 4, 4, 4, 61, 4, 4, 4, 
	4, 4, 4, 4, 4, 62, 701, 701, 
	4, 4, 4, 4, 4, -1, 4, -1, 
	4, 4, 4, 4, -1, 4, 83, 4, 
	4, 4, 197, 197, 4, 312, 187, 4, 
	4, 4, 4, 4, -1, 4, 4, 4, 
	187, -1, -1, -1, 4, 4, 4, 4, 
	4, 312, 609, 4, 4, 4, 4, 187, 
	-1, 187, -1, -1, 148, 148, 148, -1, 
	382, 702, 702, 466, 69, 590, 590, 590, 
	-1, 187, 101, 101, 575, 101, -1, -1, 
	664, -1, 691, 312, 691, 98, 98, 98, 
	-1, -1, -1, -1, 671, 671, -1, -1, 
	-1, -1, -1, 155, -1, -1, -1, 611, 
	611, 611, -1, 611, -1, -1, 569, 569, 
	569, -1, 99, 99, 99, 286, 286, 290, 
	290, 290, 247, -1, 101, 101, 71, 379, 
	-1, -1, -1, -1, 379, 162, 232, 232, 
	203, 453, 187, 281, 281, 281, -1, 655, 
	348, 655, 348, 247, -1, 90, 90, -1, 
	-1, 4, 4, 4, 4, -1, 701, 4, 
	4, -1, 4, 4, 4, -1, -1, -1, 
	-1, 4, 4, 4, -1, 4, 4, 4, 
	101, 379, 247, -1, 4, 202, 202, 202, 
	202, 4, -1, -1, -1, 4, 4, 4, 
	202, 4, 4, -1, -1, 4, 92, 92, 
	-1, -1, 192, 192, 192, 192, 93, 93, 
	-1, 4, 192, 94, 94, 702, -1, -1, 
	192, -1, 192, 192, 192, 4, 4, -1, 
	-1, 617, 590, 617, 617, 617, 617, 4, 
	4, -1, 208, 465, -1, 4, 671, 95, 
	95, 210, -1, 210, 210, 210, 210, 347, 
	210, 478, -1, 478, 96, 96, -1, 611, 
	478, -1, -1, 313, 4, 4, 4, 198, 
	388, -1, 691, 347, 4, 4, 611, 380, 
	380, 380, 158, 380, -1, -1, 199, -1, 
	4, 347, 5, 5, 5, 5, 5, 5, 
	5, 5, 5, 5, 5, 5, 5, 5, 
	5, 192, 5, 5, 5, 5, 5, 5, 
	5, 5, 362, 611, 158, 5, 5, 5, 
	5, 5, -1, 5, 413, 5, 5, 5, 
	5, 453, 5, 363, 5, 5, 5, 655, 
	-1, 5, 144, 144, 5, 5, 5, 5, 
	5, 525, 5, 5, 5, -1, 347, -1, 
	-1, 5, 5, 5, 5, 5, -1, -1, 
	5, 5, 5, 5, -1, 453, 453, 412, 
	412, 412, -1, 412, -1, 202, -1, 293, 
	-1, -1, 293, 293, 293, 293, -1, 192, 
	386, 192, 192, 192, 192, 192, 192, 470, 
	470, 470, 386, -1, 524, -1, 202, 202, 
	202, -1, 557, -1, -1, 482, -1, 478, 
	478, 478, 389, 319, -1, 347, -1, -1, 
	-1, 617, -1, -1, -1, -1, 414, 347, 
	-1, -1, -1, -1, -1, -1, -1, 380, 
	-1, 210, -1, -1, 380, -1, 347, 210, 
	347, 478, -1, 210, 210, -1, -1, -1, 
	-1, 483, -1, 585, 567, -1, 567, 516, 
	-1, 145, 145, -1, -1, -1, 5, 5, 
	5, 5, -1, 4, 5, 5, -1, 5, 
	5, 5, -1, -1, -1, -1, 5, 5, 
	5, 380, 5, 5, 5, 319, 234, -1, 
	556, 5, -1, 210, -1, -1, 5, -1, 
	-1, -1, 5, 5, 5, -1, 5, 5, 
	613, -1, 5, 515, 207, -1, -1, 234, 
	234, 234, 234, 234, -1, -1, 5, 412, 
	387, 387, 387, -1, 387, -1, -1, 156, 
	156, -1, 5, 5, -1, -1, 234, 234, 
	234, -1, -1, -1, 5, 5, -1, 200, 
	412, -1, 5, 201, 464, 464, 464, 234, 
	464, 207, 574, 574, 574, 670, 670, 670, 
	191, -1, 191, 191, 191, 191, 191, 191, 
	-1, 5, 5, 5, 293, 293, 293, 412, 
	-1, 5, 5, -1, -1, -1, -1, 377, 
	377, 377, 649, -1, -1, 5, -1, 6, 
	6, 6, 6, 6, 6, 6, 6, 6, 
	6, 6, 6, 6, 6, 6, -1, 6, 
	6, 6, 6, 6, 6, 6, 6, -1, 
	-1, -1, 6, 6, 6, 6, 6, -1, 
	6, -1, 6, 6, 6, 6, -1, 6, 
	-1, 6, 6, 6, -1, -1, 6, -1, 
	-1, 6, 6, 6, 6, 6, -1, 6, 
	6, 6, -1, -1, -1, -1, 6, 6, 
	6, 6, 6, -1, -1, 6, 6, 6, 
	6, -1, -1, -1, -1, 312, 609, -1, 
	387, -1, -1, -1, -1, 387, 499, 499, 
	499, -1, -1, -1, 234, 234, -1, 234, 
	-1, -1, -1, -1, -1, 187, 101, 101, 
	575, 101, -1, -1, 464, -1, 574, 312, 
	-1, 670, -1, 352, 352, 352, 352, 352, 
	352, 352, 352, 352, 352, -1, -1, -1, 
	464, 352, 387, 352, 352, 352, 352, 352, 
	352, 352, 569, 569, 569, -1, 234, 234, 
	-1, 238, 238, 238, 238, 238, -1, 574, 
	101, 101, 670, -1, -1, -1, -1, -1, 
	379, -1, 464, -1, -1, -1, 187, -1, 
	238, 238, 238, 6, 6, 6, 6, 247, 
	5, 6, 6, -1, 6, 6, 6, -1, 
	-1, 238, 701, 6, 6, 6, -1, 6, 
	6, 6, 234, 653, 235, 653, 6, -1, 
	-1, -1, 653, 6, 101, 379, 247, 6, 
	6, 6, -1, 6, 6, -1, -1, 6, 
	371, 371, 371, 371, 630, 235, 235, 235, 
	235, 235, -1, 6, 239, 239, 239, 239, 
	239, 240, 240, 240, 240, 240, -1, 6, 
	6, 702, -1, -1, 235, 235, 235, -1, 
	-1, 6, 6, 239, 239, 239, -1, 6, 
	240, 240, 240, -1, -1, 235, -1, 499, 
	499, -1, 671, -1, 239, -1, -1, -1, 
	-1, 240, -1, -1, -1, -1, 6, 6, 
	6, -1, -1, 584, -1, 584, 6, 6, 
	-1, 352, 584, 352, 352, 352, 352, 352, 
	-1, -1, 6, -1, 7, 7, 7, 7, 
	7, 7, 7, 7, 7, 7, 7, 7, 
	7, 7, 7, -1, 7, 7, 7, 7, 
	7, 7, 7, 7, -1, 192, -1, 7, 
	7, 7, 7, 7, -1, 7, -1, 7, 
	7, 7, 7, -1, 7, -1, 7, 7, 
	7, 653, 653, 7, -1, 453, 7, 7, 
	7, 7, 7, 655, 7, 7, 7, -1, 
	-1, -1, -1, 7, 7, 7, 7, 7, 
	238, 238, 7, 7, 7, 7, 373, 373, 
	373, 373, -1, 653, -1, -1, -1, -1, 
	-1, 453, -1, 619, 619, 619, -1, 619, 
	-1, 202, 235, 235, -1, 235, -1, -1, 
	-1, -1, -1, 192, 630, 192, 192, 192, 
	192, 192, 192, -1, -1, -1, -1, -1, 
	-1, -1, -1, 555, 555, 555, -1, 555, 
	-1, 371, 371, 371, -1, 478, -1, -1, 
	-1, 584, 584, -1, -1, 617, -1, -1, 
	630, 630, -1, -1, 235, 235, 241, 241, 
	241, 241, 241, 239, 239, -1, -1, -1, 
	240, 240, -1, 210, -1, -1, -1, -1, 
	210, -1, -1, 584, -1, 241, 241, 241, 
	7, 7, 7, 7, -1, 6, 7, 7, 
	-1, 7, 7, 7, -1, -1, 241, -1, 
	7, 7, 7, -1, 7, 7, 7, -1, 
	235, 236, -1, 7, 374, 374, 374, 374, 
	7, -1, -1, -1, 7, 7, 7, 210, 
	7, 7, -1, -1, 7, -1, -1, -1, 
	-1, -1, 236, 236, 236, 236, 236, -1, 
	7, 242, 242, 242, 242, 242, 243, 243, 
	243, 243, 243, 619, 7, 7, -1, -1, 
	619, 236, 236, 236, -1, -1, 7, 7, 
	242, 242, 242, -1, 7, 243, 243, 243, 
	-1, -1, 236, -1, 412, -1, -1, -1, 
	-1, 242, -1, 555, -1, -1, 243, -1, 
	-1, -1, -1, 7, 7, 7, -1, 373, 
	373, 373, -1, 7, 7, 619, -1, -1, 
	293, 293, 293, 412, 555, -1, -1, 7, 
	-1, 8, 8, 8, 8, 8, 8, 8, 
	8, 8, 8, 8, 8, 8, 8, 8, 
	-1, 8, 8, 8, 8, 8, 8, 8, 
	8, -1, -1, 555, 8, 8, 8, 8, 
	8, -1, 8, -1, 8, 8, 8, 8, 
	-1, 8, -1, 8, 8, 8, -1, -1, 
	8, -1, -1, 8, 8, 8, 8, 8, 
	-1, 8, 8, 8, -1, -1, -1, -1, 
	8, 8, 8, 8, 8, 241, 241, 8, 
	8, 8, 8, -1, 355, 355, 355, 355, 
	-1, -1, -1, 353, 355, -1, 364, 364, 
	364, 364, 355, -1, 355, 355, 364, 236, 
	236, 387, 236, -1, 364, -1, 364, 364, 
	234, 234, -1, 234, -1, 374, 374, 374, 
	-1, -1, -1, -1, 353, 353, 353, 353, 
	353, 353, 353, 353, 353, 353, 353, 353, 
	353, 353, 353, -1, 353, 353, 353, 353, 
	353, 353, 353, -1, -1, -1, 387, -1, 
	-1, 236, 236, 244, 244, 244, 244, 244, 
	242, 242, 234, 234, -1, 243, 243, -1, 
	-1, -1, -1, 574, -1, -1, 670, -1, 
	-1, -1, 244, 244, 244, 8, 8, 8, 
	8, -1, 7, 8, 8, -1, 8, 8, 
	8, -1, -1, 244, -1, 8, 8, 8, 
	-1, 8, 8, 8, -1, 236, -1, -1, 
	8, 375, 375, 375, 375, 8, 234, -1, 
	-1, 8, 8, 8, -1, 8, 8, -1, 
	-1, 8, -1, -1, 245, 245, 245, 245, 
	245, 376, 376, 376, 376, 8, 381, -1, 
	381, 381, 381, 381, -1, -1, -1, -1, 
	-1, 8, 8, 245, 245, 245, 514, 514, 
	514, -1, 514, 8, 8, 355, 355, 355, 
	355, 8, -1, 364, 245, 364, 364, 364, 
	364, 364, 364, 728, -1, 728, -1, 729, 
	381, 729, 728, 499, 499, -1, 729, -1, 
	8, 8, 8, -1, -1, -1, -1, -1, 
	8, 8, 353, -1, 353, 353, 353, 353, 
	353, -1, -1, -1, 8, 352, 9, 9, 
	9, 9, 9, 9, 9, 9, 9, 9, 
	9, 9, 9, 9, 9, -1, 9, 9, 
	9, 9, 9, 9, 9, 9, -1, -1, 
	-1, 9, 9, 9, 9, 9, -1, 9, 
	-1, 9, 9, 9, 9, -1, 9, -1, 
	9, 9, 9, -1, -1, 9, 354, -1, 
	9, 9, 9, 9, 9, -1, 9, 9, 
	9, 608, 608, 608, 608, 9, 9, 9, 
	9, 9, 244, 244, 9, 9, 9, 9, 
	-1, -1, -1, -1, 238, 238, -1, 354, 
	354, 354, 354, 354, 354, 354, 354, 354, 
	354, 354, 354, 354, 354, 354, 514, 354, 
	354, 354, 354, 354, 354, 354, -1, -1, 
	-1, -1, 375, 375, 375, 514, 381, -1, 
	630, 728, 728, -1, 381, 729, 729, -1, 
	381, 381, -1, -1, -1, -1, -1, -1, 
	-1, -1, 376, 376, 376, 371, 371, 371, 
	-1, -1, -1, 245, 245, 584, 584, -1, 
	-1, -1, 514, 728, 630, -1, -1, 729, 
	-1, -1, -1, -1, -1, -1, -1, 239, 
	239, -1, -1, -1, 240, 240, -1, -1, 
	381, -1, 9, 9, 9, 9, -1, 8, 
	9, 9, -1, 9, 9, 9, -1, -1, 
	-1, -1, 9, 9, 9, -1, 9, 9, 
	9, -1, -1, -1, -1, 9, -1, -1, 
	-1, -1, 9, -1, -1, -1, 9, 9, 
	9, -1, 9, 9, -1, -1, 9, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 9, 493, 493, 493, 493, -1, 
	-1, -1, -1, 493, -1, -1, 9, 9, 
	-1, 493, -1, 493, 493, -1, -1, -1, 
	9, 9, -1, -1, -1, 354, 9, 354, 
	354, 354, 354, 354, -1, 608, 608, 608, 
	-1, -1, 608, 608, 608, -1, -1, -1, 
	-1, 485, 485, 485, 485, 9, 9, 9, 
	-1, 485, -1, -1, -1, 9, 9, 485, 
	-1, 485, 485, 373, 373, 373, -1, -1, 
	-1, 9, -1, 10, 10, 10, 10, 10, 
	10, 10, 10, 10, 10, 10, 10, 10, 
	10, 10, -1, 10, 10, 10, 10, 10, 
	10, 10, 10, -1, -1, -1, 10, 10, 
	10, 10, 10, -1, 10, -1, 10, 10, 
	10, 10, -1, 10, -1, 10, 10, 10, 
	-1, -1, 10, 356, -1, 10, 10, 10, 
	10, 10, -1, 10, 10, 10, -1, -1, 
	-1, -1, 10, 10, 10, 10, 10, -1, 
	-1, 10, 10, 10, 10, -1, -1, -1, 
	-1, 241, 241, -1, 356, 356, 356, 356, 
	356, 356, 356, 356, 356, 356, 356, 356, 
	356, 356, 356, -1, 356, 356, 356, 356, 
	356, 356, 356, 493, 493, 493, 493, 493, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 374, 374, 374, -1, -1, -1, -1, 
	-1, -1, 396, 396, 396, 396, 396, 396, 
	396, 396, 396, 396, 396, 396, 396, 396, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	485, 485, 485, 485, 485, 485, -1, -1, 
	-1, -1, -1, -1, 242, 242, -1, -1, 
	-1, 243, 243, -1, -1, -1, -1, 10, 
	10, 10, 10, -1, 9, 10, 10, -1, 
	10, 10, 10, -1, 396, -1, -1, 10, 
	10, 10, -1, 10, 10, 10, -1, -1, 
	-1, -1, 10, -1, -1, -1, -1, 10, 
	-1, -1, -1, 10, 10, 10, -1, 10, 
	10, -1, -1, 10, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 10, 
	-1, 486, 486, 486, 486, -1, -1, -1, 
	-1, 486, -1, 10, 10, -1, -1, 486, 
	-1, 486, 486, -1, -1, 10, 10, -1, 
	-1, -1, 356, 10, 356, 356, 356, 356, 
	356, 355, 355, 355, 355, -1, -1, 364, 
	-1, 364, 364, 364, 364, 364, 364, -1, 
	-1, -1, 10, 10, 10, -1, -1, -1, 
	-1, 396, 10, 10, -1, 573, 573, 573, 
	-1, 573, -1, -1, -1, -1, 10, -1, 
	11, 11, 11, 11, 11, 11, 11, 11, 
	11, 11, 11, 11, 11, 11, 11, -1, 
	11, 11, 11, 11, 11, 11, 11, 11, 
	-1, -1, -1, 11, 11, 11, 11, 11, 
	-1, 11, -1, 11, 11, 11, 11, -1, 
	11, -1, 11, 11, 11, -1, -1, 11, 
	357, -1, 11, 11, 11, 11, 11, -1, 
	11, 11, 11, -1, -1, -1, -1, 11, 
	11, 11, 11, 11, -1, -1, 11, 11, 
	11, 11, -1, -1, -1, -1, 244, 244, 
	-1, 357, 357, 357, 357, 357, 357, 357, 
	357, 357, 357, 357, 357, 357, 357, 357, 
	357, 357, 357, 357, 357, 357, 357, 357, 
	486, 486, 486, 486, 486, 486, -1, -1, 
	-1, -1, -1, -1, -1, -1, 375, 375, 
	375, 514, -1, -1, -1, -1, -1, -1, 
	381, -1, -1, -1, -1, 381, -1, -1, 
	-1, -1, -1, -1, -1, 573, 376, 376, 
	376, -1, 573, -1, -1, -1, -1, 245, 
	245, -1, -1, -1, -1, -1, 514, -1, 
	-1, 573, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 11, 11, 11, 11, 
	-1, 10, 11, 11, 381, 11, 11, 11, 
	-1, -1, -1, -1, 11, 11, 11, 573, 
	11, 11, 11, 573, -1, -1, -1, 11, 
	-1, -1, -1, -1, 11, -1, -1, -1, 
	11, 11, 11, -1, 11, 11, -1, -1, 
	11, -1, -1, -1, -1, -1, 551, 551, 
	551, 551, 551, -1, 11, 385, -1, 385, 
	385, 385, 385, -1, 385, -1, -1, -1, 
	11, 11, -1, -1, -1, 551, 551, 551, 
	-1, -1, 11, 11, -1, -1, -1, 357, 
	11, 357, 357, 357, 357, 357, 551, -1, 
	-1, -1, -1, -1, -1, -1, -1, 385, 
	-1, -1, -1, 479, 479, 479, 479, 11, 
	11, 11, -1, 479, -1, -1, -1, 11, 
	11, 479, -1, 479, 479, 479, -1, -1, 
	-1, -1, -1, 11, -1, 12, 12, 12, 
	12, 12, 12, 12, 12, 12, 12, 12, 
	12, 12, 12, 12, -1, 12, 12, 12, 
	12, 12, 12, 12, 12, -1, -1, -1, 
	12, 12, 12, 12, 12, -1, 12, -1, 
	12, 12, 12, 12, -1, 12, -1, 12, 
	12, 12, -1, -1, 12, 358, -1, 12, 
	12, 12, 12, 12, -1, 12, 12, 12, 
	-1, -1, -1, -1, 12, 12, 12, 12, 
	12, -1, 479, 12, 12, 12, 12, -1, 
	-1, -1, -1, -1, -1, -1, 358, 358, 
	358, 358, 358, 358, 358, 358, 358, 358, 
	358, 358, 358, 358, 358, -1, 358, 358, 
	358, 358, 358, 358, 358, -1, -1, -1, 
	-1, -1, -1, -1, -1, 385, -1, -1, 
	-1, -1, -1, 385, -1, -1, -1, 385, 
	385, -1, -1, -1, 533, 533, 533, 533, 
	533, 533, 533, 533, 533, 533, 533, 533, 
	533, 533, -1, -1, -1, 551, 551, -1, 
	479, -1, 479, 479, 479, 479, 479, 479, 
	-1, -1, -1, -1, 485, 485, 485, 485, 
	485, 485, -1, -1, -1, -1, -1, 385, 
	-1, 12, 12, 12, 12, -1, 11, 12, 
	12, -1, 12, 12, 12, -1, 533, -1, 
	-1, 12, 12, 12, -1, 12, 12, 12, 
	396, -1, -1, -1, 12, -1, -1, -1, 
	-1, 12, -1, -1, -1, 12, 12, 12, 
	-1, 12, 12, -1, -1, 12, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 12, -1, 487, 487, 487, 487, -1, 
	-1, -1, -1, 487, -1, 12, 12, -1, 
	-1, 487, -1, 487, 487, -1, -1, 12, 
	12, -1, -1, -1, 358, 12, 358, 358, 
	358, 358, 358, -1, -1, -1, -1, -1, 
	-1, 488, 488, 488, 488, -1, -1, -1, 
	-1, 488, -1, -1, 12, 12, 12, 488, 
	-1, 488, 488, 533, 12, 12, -1, -1, 
	-1, -1, -1, -1, -1, 396, -1, -1, 
	12, -1, 13, 13, 13, 13, 13, 13, 
	13, 13, 13, 13, 13, 13, 13, 13, 
	13, -1, 13, 13, 13, 13, 13, 13, 
	13, 13, -1, -1, -1, 13, 13, 13, 
	13, 13, -1, 13, -1, 13, 13, 13, 
	13, -1, 13, -1, 13, 13, 13, -1, 
	-1, 13, 359, -1, 13, 13, 13, 13, 
	13, -1, 13, 13, 13, -1, -1, -1, 
	-1, 13, 13, 13, 13, 13, -1, -1, 
	13, 13, 13, 13, -1, -1, -1, -1, 
	-1, -1, -1, 359, 359, 359, 359, 359, 
	359, 359, 359, 359, 359, 359, 359, 359, 
	359, 359, 359, 359, 359, 359, 359, 359, 
	359, 359, 487, 487, 487, 487, 487, 487, 
	-1, -1, -1, -1, 486, 486, 486, 486, 
	486, 486, -1, -1, 700, 700, 700, -1, 
	700, 534, 534, 534, 534, 534, 534, 534, 
	534, 534, 534, 534, 534, 534, 534, -1, 
	488, 488, 488, 488, 488, 488, -1, -1, 
	-1, -1, -1, -1, -1, -1, 573, 535, 
	535, 535, 535, 535, 535, 535, 535, 535, 
	535, 535, 535, 535, 535, 573, 13, 13, 
	13, 13, -1, 12, 13, 13, -1, 13, 
	13, 13, -1, 534, -1, -1, 13, 13, 
	13, -1, 13, 13, 13, -1, -1, -1, 
	-1, 13, -1, 573, -1, -1, 13, 573, 
	-1, -1, 13, 13, 13, -1, 13, 13, 
	-1, 535, 13, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 13, 489, 
	489, 489, 489, -1, -1, -1, -1, 489, 
	-1, -1, 13, 13, -1, 489, -1, 489, 
	489, -1, -1, -1, 13, 13, -1, -1, 
	-1, 359, 13, 359, 359, 359, 359, 359, 
	-1, -1, -1, -1, -1, -1, 490, 490, 
	490, 490, -1, -1, 700, -1, 490, -1, 
	-1, 13, 13, 13, 490, -1, 490, 490, 
	534, 13, 13, 700, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 13, -1, 14, 
	14, 14, 14, 14, 14, 14, 14, 14, 
	14, 14, 14, 14, 14, 14, 535, 14, 
	14, 14, 14, 14, 14, 14, 14, -1, 
	700, -1, 14, 14, 14, 14, 14, -1, 
	14, -1, 14, 14, 14, 14, -1, 14, 
	-1, 14, 14, 14, -1, -1, 14, 360, 
	-1, 14, 14, 14, 14, 14, -1, 14, 
	14, 14, -1, -1, -1, -1, 14, 14, 
	14, 14, 14, -1, -1, 14, 14, 14, 
	14, -1, -1, -1, -1, -1, 479, -1, 
	360, 360, 360, 360, 360, 360, 360, 360, 
	360, 360, 360, 360, 360, 360, 360, 360, 
	360, 360, 360, 360, 360, 360, 360, 489, 
	489, 489, 489, 489, -1, -1, -1, -1, 
	536, 536, 536, 536, 536, 536, 536, 536, 
	536, 536, 536, 536, 536, 536, -1, 385, 
	-1, -1, -1, -1, 385, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 490, 490, 
	490, 490, 490, -1, -1, -1, -1, -1, 
	-1, 551, 551, -1, 479, -1, 479, 479, 
	479, 479, 479, 479, -1, -1, -1, -1, 
	-1, -1, 536, 14, 14, 14, 14, -1, 
	13, 14, 14, 385, 14, 14, 14, -1, 
	-1, -1, -1, 14, 14, 14, -1, 14, 
	14, 14, 533, -1, -1, -1, 14, -1, 
	-1, -1, -1, 14, -1, -1, -1, 14, 
	14, 14, -1, 14, 14, -1, -1, 14, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 14, 491, 491, 491, 491, 
	-1, -1, -1, -1, 491, -1, -1, 14, 
	14, -1, 491, -1, 491, 491, -1, -1, 
	-1, 14, 14, -1, -1, -1, 360, 14, 
	360, 360, 360, 360, 360, -1, -1, -1, 
	-1, -1, -1, 492, 492, 492, 492, 536, 
	-1, -1, -1, 492, -1, -1, 14, 14, 
	14, 492, -1, 492, 492, -1, 14, 14, 
	-1, -1, -1, -1, -1, -1, -1, 533, 
	-1, -1, 14, -1, 15, 15, 15, 15, 
	15, 15, 15, 15, 15, 15, 15, 15, 
	15, 15, 15, -1, 15, 15, 15, 15, 
	15, 15, 15, 15, -1, -1, -1, 15, 
	15, 15, 15, 15, -1, 15, -1, 15, 
	15, 15, 15, -1, 15, -1, 15, 15, 
	15, -1, -1, 15, 365, -1, 15, 15, 
	15, 15, 15, -1, 15, 15, 15, -1, 
	-1, -1, -1, 15, 15, 15, 15, 15, 
	-1, -1, 15, 15, 15, 15, -1, -1, 
	-1, -1, -1, -1, -1, 365, 365, 365, 
	365, 365, 365, 365, 365, 365, 365, 365, 
	365, 365, 365, 365, 365, 365, 365, 365, 
	365, 365, 365, 365, 491, 491, 491, 491, 
	491, -1, -1, -1, -1, -1, 487, 487, 
	487, 487, 487, 487, -1, -1, -1, -1, 
	-1, -1, 537, 537, 537, 537, 537, 537, 
	537, 537, 537, 537, 537, 537, 537, 537, 
	-1, -1, -1, 492, 492, 492, 492, 492, 
	-1, -1, -1, -1, 488, 488, 488, 488, 
	488, 488, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	15, 15, 15, 15, -1, 14, 15, 15, 
	-1, 15, 15, 15, 537, -1, -1, -1, 
	15, 15, 15, -1, 15, 15, 15, -1, 
	-1, -1, -1, 15, -1, -1, -1, -1, 
	15, -1, -1, -1, 15, 15, 15, -1, 
	15, 15, -1, -1, 15, -1, -1, -1, 
	-1, -1, 552, 552, 552, 552, 552, -1, 
	15, -1, 527, -1, 527, 527, 527, 527, 
	-1, 527, -1, -1, 15, 15, -1, -1, 
	-1, 552, 552, 552, -1, -1, 15, 15, 
	-1, -1, -1, 365, 15, 365, 365, 365, 
	365, 365, 552, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 527, -1, -1, -1, 
	-1, -1, -1, 15, 15, 15, -1, -1, 
	-1, 537, -1, 15, 15, -1, -1, -1, 
	610, 610, 610, -1, 610, -1, -1, 15, 
	-1, 16, 16, 16, 16, 16, 16, 16, 
	16, 16, 16, 16, 16, 16, 16, 16, 
	-1, 16, 16, 16, 16, 16, 16, 16, 
	16, -1, -1, -1, 16, 16, 16, 16, 
	16, -1, 16, -1, 16, 16, 16, 16, 
	-1, 16, -1, 16, 16, 16, -1, -1, 
	16, 481, -1, 16, 16, 16, 16, 16, 
	-1, 16, 16, 16, -1, -1, -1, -1, 
	16, 16, 16, 16, 16, -1, -1, 16, 
	16, 16, 16, -1, -1, -1, -1, -1, 
	-1, -1, 481, 481, 481, 481, 481, 481, 
	481, 481, 481, 481, 481, 481, 481, 481, 
	481, -1, 481, 481, 481, 481, 481, 481, 
	481, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 527, 489, 489, 489, 489, 489, 
	527, -1, -1, -1, 527, 527, -1, 538, 
	538, 538, 538, 538, 538, 538, 538, 538, 
	538, 538, 538, 538, 538, -1, -1, -1, 
	610, 552, 552, -1, -1, -1, -1, -1, 
	-1, -1, 490, 490, 490, 490, 490, 610, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 527, 16, 16, 16, 
	16, -1, 15, 16, 16, -1, 16, 16, 
	16, 538, -1, -1, -1, 16, 16, 16, 
	-1, 16, 16, 16, 610, -1, -1, -1, 
	16, -1, -1, -1, -1, 16, -1, -1, 
	-1, 16, 16, 16, -1, 16, 16, -1, 
	-1, 16, -1, -1, -1, -1, -1, 685, 
	685, 685, 685, 685, -1, 16, -1, 620, 
	-1, 620, 620, 620, 620, -1, 620, -1, 
	-1, 16, 16, -1, -1, -1, 685, 685, 
	685, -1, -1, 16, 16, -1, -1, -1, 
	481, 16, 481, 481, 481, 481, 481, 685, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 620, -1, -1, -1, -1, -1, -1, 
	16, 16, 16, -1, -1, -1, 538, -1, 
	16, 16, -1, 647, 647, 647, -1, 647, 
	-1, -1, -1, -1, 16, -1, 17, 17, 
	17, 17, 17, 17, 17, 17, 17, 17, 
	17, 17, 17, 17, 17, -1, 17, 17, 
	17, 17, 17, 17, 17, 17, -1, -1, 
	-1, 17, 17, 17, 17, 17, -1, 17, 
	-1, 17, 17, 17, 17, -1, 17, -1, 
	17, 17, 17, -1, -1, 17, 494, -1, 
	17, 17, 17, 17, 17, -1, 17, 17, 
	17, -1, -1, -1, -1, 17, 17, 17, 
	17, 17, -1, -1, 17, 17, 17, 17, 
	-1, -1, -1, -1, -1, -1, -1, 494, 
	494, 494, 494, 494, 494, 494, 494, 494, 
	494, 494, 494, 494, 494, 494, -1, 494, 
	494, 494, 494, 494, 494, 494, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 620, 
	491, 491, 491, 491, 491, 620, -1, -1, 
	-1, 620, 620, -1, 539, 539, 539, 539, 
	539, 539, 539, 539, 539, 539, 539, 539, 
	539, 539, -1, 647, -1, -1, 685, 685, 
	647, -1, -1, -1, -1, -1, -1, 492, 
	492, 492, 492, 492, -1, -1, -1, 647, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 620, 17, 17, 17, 17, -1, 16, 
	17, 17, -1, 17, 17, 17, 539, -1, 
	-1, -1, 17, 17, 17, 647, 17, 17, 
	17, 647, -1, -1, -1, 17, -1, -1, 
	-1, -1, 17, -1, -1, -1, 17, 17, 
	17, -1, 17, 17, -1, -1, 17, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 17, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 17, 17, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	17, 17, -1, -1, -1, 494, 17, 494, 
	494, 494, 494, 494, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 17, 17, 17, 
	-1, -1, -1, 539, -1, 17, 17, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 17, -1, 18, 18, 18, 18, 18, 
	18, 18, 18, 18, 18, 18, 18, 18, 
	18, 18, -1, 18, 18, 18, 18, 18, 
	18, 18, 18, -1, -1, -1, 18, 18, 
	18, 18, 18, -1, 18, -1, 18, 18, 
	18, 18, -1, 18, -1, 18, 18, 18, 
	-1, -1, 18, 495, -1, 18, 18, 18, 
	18, 18, -1, 18, 18, 18, -1, -1, 
	-1, -1, 18, 18, 18, 18, 18, -1, 
	-1, 18, 18, 18, 18, -1, -1, -1, 
	-1, -1, -1, -1, 495, 495, 495, 495, 
	495, 495, 495, 495, 495, 495, 495, 495, 
	495, 495, 495, -1, 495, 495, 495, 495, 
	495, 495, 495, 540, 540, 540, 540, 540, 
	540, 540, 540, 540, 540, 540, 540, 540, 
	540, 541, 541, 541, 541, 541, 541, 541, 
	541, 541, 541, 541, 541, 541, 541, -1, 
	542, 542, 542, 542, 542, 542, 542, 542, 
	542, 542, 542, 542, 542, 542, -1, -1, 
	-1, -1, -1, -1, -1, 552, 552, -1, 
	-1, -1, -1, -1, -1, 540, -1, -1, 
	-1, -1, -1, 610, -1, -1, -1, 18, 
	18, 18, 18, 541, 17, 18, 18, -1, 
	18, 18, 18, -1, -1, -1, -1, 18, 
	18, 18, 542, 18, 18, 18, -1, -1, 
	-1, -1, 18, -1, -1, -1, -1, 18, 
	610, -1, -1, 18, 18, 18, -1, 18, 
	18, -1, -1, 18, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 18, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 18, 18, -1, -1, -1, 
	-1, -1, -1, -1, -1, 18, 18, -1, 
	-1, -1, 495, 18, 495, 495, 495, 495, 
	495, -1, 540, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	541, -1, 18, 18, 18, -1, -1, -1, 
	-1, -1, 18, 18, -1, -1, -1, 542, 
	-1, -1, -1, -1, -1, -1, 18, -1, 
	19, 19, 19, 19, 19, 19, 19, 19, 
	19, 19, 19, 19, 19, 19, 19, -1, 
	19, 19, 19, 19, 19, 19, 19, 19, 
	-1, -1, -1, 19, 19, 19, 19, 19, 
	-1, 19, -1, 19, 19, 19, 19, -1, 
	19, -1, 19, 19, 19, -1, -1, 19, 
	496, -1, 19, 19, 19, 19, 19, -1, 
	19, 19, 19, -1, -1, -1, -1, 19, 
	19, 19, 19, 19, -1, -1, 19, 19, 
	19, 19, -1, -1, -1, -1, -1, -1, 
	-1, 496, 496, 496, 496, 496, 496, 496, 
	496, 496, 496, 496, 496, 496, 496, 496, 
	-1, 496, 496, 496, 496, 496, 496, 496, 
	543, 543, 543, 543, 543, 543, 543, 543, 
	543, 543, 543, 543, 543, 543, 544, 544, 
	544, 544, 544, 544, 544, 544, 544, 544, 
	544, 544, 544, 544, -1, 545, 545, 545, 
	545, 545, 545, 545, 545, 545, 545, 545, 
	545, 545, 545, -1, -1, -1, -1, -1, 
	-1, -1, 685, 685, -1, -1, -1, -1, 
	-1, -1, 543, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 19, 19, 19, 19, 
	544, 18, 19, 19, -1, 19, 19, 19, 
	-1, -1, -1, -1, 19, 19, 19, 545, 
	19, 19, 19, -1, -1, -1, -1, 19, 
	-1, -1, -1, -1, 19, -1, -1, -1, 
	19, 19, 19, -1, 19, 19, -1, -1, 
	19, -1, -1, -1, -1, -1, 565, 565, 
	565, 565, 565, -1, 19, 565, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	19, 19, -1, -1, -1, 565, 565, 565, 
	-1, -1, 19, 19, -1, -1, -1, 496, 
	19, 496, 496, 496, 496, 496, 565, 543, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 544, -1, 19, 
	19, 19, -1, -1, -1, -1, -1, 19, 
	19, -1, -1, -1, 545, -1, -1, -1, 
	-1, -1, -1, 19, -1, 20, 20, 20, 
	20, 20, 20, 20, 20, 20, 20, 20, 
	20, 20, 20, 20, -1, 20, 20, 20, 
	20, 20, 20, 20, 20, -1, -1, -1, 
	20, 20, 20, 20, 20, -1, 20, -1, 
	20, 20, 20, 20, -1, 20, -1, 20, 
	20, 20, -1, -1, 20, 497, -1, 20, 
	20, 20, 20, 20, -1, 20, 20, 20, 
	-1, -1, -1, -1, 20, 20, 20, 20, 
	20, -1, -1, 20, 20, 20, 20, -1, 
	-1, -1, -1, 565, -1, -1, 497, 497, 
	497, 497, 497, 497, 497, 497, 497, 497, 
	497, 497, 497, 497, 497, -1, 497, 497, 
	497, 497, 497, 497, 497, -1, -1, -1, 
	-1, 546, 546, 546, 546, 546, 546, 546, 
	546, 546, 546, 546, 546, 546, 546, -1, 
	-1, -1, -1, -1, 625, 625, 625, 625, 
	625, 625, 625, 625, 625, 625, 625, 625, 
	625, 625, -1, -1, -1, 565, 565, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 546, -1, -1, -1, -1, 
	-1, 20, 20, 20, 20, -1, 19, 20, 
	20, -1, 20, 20, 20, -1, 625, -1, 
	-1, 20, 20, 20, -1, 20, 20, 20, 
	-1, -1, -1, -1, 20, -1, -1, -1, 
	-1, 20, -1, -1, -1, 20, 20, 20, 
	-1, 20, 20, -1, -1, 20, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 20, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 20, 20, -1, 
	-1, -1, 669, 669, 669, -1, 669, 20, 
	20, -1, -1, -1, 497, 20, 497, 497, 
	497, 497, 497, -1, -1, -1, -1, -1, 
	546, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 20, 20, 20, -1, 
	-1, -1, -1, 625, 20, 20, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	20, -1, 21, 21, 21, 21, 21, 21, 
	21, 21, 21, 21, 21, 21, 21, 21, 
	21, -1, 21, 21, 21, 21, 21, 21, 
	21, 21, -1, -1, -1, 21, 21, 21, 
	21, 21, -1, 21, -1, 21, 21, 21, 
	21, -1, 21, -1, 21, 21, 21, -1, 
	-1, 21, 587, -1, 21, 21, 21, 21, 
	21, -1, 21, 21, 21, -1, -1, -1, 
	-1, 21, 21, 21, 21, 21, -1, -1, 
	21, 21, 21, 21, -1, -1, -1, -1, 
	-1, -1, -1, 587, 587, 587, 587, 587, 
	587, 587, 587, 587, 587, 587, 587, 587, 
	587, 587, 669, 587, 587, 587, 587, 587, 
	587, 587, -1, -1, -1, -1, -1, -1, 
	-1, 669, -1, -1, -1, -1, 592, 592, 
	592, 592, 592, 592, 592, 592, 592, 592, 
	-1, -1, -1, -1, 592, -1, 592, 592, 
	592, 592, 592, 592, 592, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 669, -1, 
	-1, -1, -1, -1, -1, -1, -1, 678, 
	678, 678, 678, 678, 678, 678, 678, 678, 
	678, 678, 678, 678, 678, -1, 21, 21, 
	21, 21, -1, 20, 21, 21, -1, 21, 
	21, 21, -1, -1, -1, -1, 21, 21, 
	21, -1, 21, 21, 21, -1, -1, -1, 
	-1, 21, -1, -1, -1, -1, 21, -1, 
	-1, -1, 21, 21, 21, -1, 21, 21, 
	-1, 678, 21, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 21, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 21, 21, -1, -1, -1, -1, 
	-1, -1, -1, -1, 21, 21, -1, -1, 
	-1, 587, 21, 587, 587, 587, 587, 587, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 21, 21, 21, -1, -1, -1, -1, 
	-1, 21, 21, -1, 592, -1, 592, 592, 
	592, 592, 592, -1, -1, 21, -1, 22, 
	22, 22, 22, 22, 22, 22, 22, 22, 
	22, 22, 22, 22, 22, 22, 678, 22, 
	22, 22, 22, 22, 22, 22, 22, -1, 
	-1, -1, 22, 22, 22, 22, 22, -1, 
	22, -1, 22, 22, 22, 22, -1, 22, 
	-1, 22, 22, 22, -1, -1, 22, -1, 
	-1, 22, 22, 22, 22, 22, -1, 22, 
	22, 22, 588, -1, -1, -1, 22, 22, 
	22, 22, 22, -1, -1, 22, 22, 22, 
	22, -1, -1, -1, -1, -1, -1, -1, 
	-1, 591, -1, -1, -1, -1, -1, 565, 
	-1, -1, -1, 588, 588, 588, 588, 588, 
	588, 588, 588, 588, 588, 588, 588, 588, 
	588, 588, -1, 588, 588, 588, 588, 588, 
	588, 588, 591, 591, 591, 591, 591, 591, 
	591, 591, 591, 591, 591, 591, 591, 591, 
	591, -1, 591, 591, 591, 591, 591, 591, 
	591, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 565, 565, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 22, 22, 22, 22, 546, 
	21, 22, 22, -1, 22, 22, 22, -1, 
	-1, -1, -1, 22, 22, 22, -1, 22, 
	22, 22, 625, 715, -1, 715, 22, -1, 
	-1, -1, 715, 22, -1, -1, 715, 22, 
	22, 22, -1, 22, 22, 715, 715, 22, 
	593, 593, 593, 593, 593, 593, 593, 593, 
	593, 593, -1, 22, 715, -1, 593, -1, 
	593, 593, 593, 593, 593, 593, 593, 22, 
	22, -1, -1, -1, -1, -1, -1, -1, 
	-1, 22, 22, -1, -1, -1, 621, 22, 
	621, 621, 621, 621, -1, 621, -1, -1, 
	-1, 588, -1, 588, 588, 588, 588, 588, 
	-1, -1, -1, -1, 546, -1, 22, 22, 
	22, -1, -1, -1, -1, -1, 22, 22, 
	591, -1, 591, 591, 591, 591, 591, 625, 
	621, -1, 22, -1, 23, 23, 23, 23, 
	23, 23, 23, 23, 23, 23, 23, 23, 
	23, 23, 23, -1, 23, 23, 23, 23, 
	23, 23, 23, 23, -1, -1, -1, 23, 
	23, 23, 23, 23, -1, 23, -1, 23, 
	23, 23, 23, -1, 23, -1, 23, 23, 
	23, 715, 715, 23, -1, -1, 23, 23, 
	23, 23, 23, -1, 23, 23, 23, -1, 
	-1, -1, -1, 23, 23, 23, 23, 23, 
	-1, -1, 23, 23, 23, 23, -1, -1, 
	-1, -1, -1, 715, 715, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 593, -1, 
	593, 593, 593, 593, 593, 594, 594, 594, 
	594, 594, 594, 594, 594, 594, 594, -1, 
	-1, -1, -1, 594, -1, 594, 594, 594, 
	594, 594, 594, 594, -1, 669, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 621, -1, 
	-1, -1, -1, -1, 621, -1, -1, -1, 
	621, 621, -1, -1, -1, -1, -1, -1, 
	-1, -1, 669, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	23, 23, 23, 23, -1, 22, 23, 23, 
	-1, 23, 23, 23, -1, -1, -1, -1, 
	23, 23, 23, -1, 23, 23, 23, -1, 
	621, -1, -1, 23, -1, -1, -1, -1, 
	23, -1, -1, -1, 23, 23, 23, -1, 
	23, 23, -1, -1, 23, 595, 595, 595, 
	595, 595, 595, 595, 595, 595, 595, -1, 
	23, -1, -1, 595, -1, 595, 595, 595, 
	595, 595, 595, 595, 23, 23, -1, -1, 
	-1, -1, -1, -1, -1, -1, 23, 23, 
	-1, -1, -1, 622, 23, 622, 622, 622, 
	622, -1, 622, -1, -1, -1, -1, -1, 
	-1, -1, -1, 594, -1, 594, 594, 594, 
	594, 594, -1, 23, 23, 23, -1, -1, 
	-1, -1, -1, 23, 23, -1, -1, -1, 
	-1, -1, -1, -1, -1, 622, -1, 23, 
	592, 29, 29, 29, 29, 29, 29, 29, 
	29, 29, 29, 29, 29, 29, 29, 29, 
	-1, 29, 29, 29, 29, 29, 29, 29, 
	29, -1, -1, -1, 29, 29, 29, 29, 
	29, -1, 29, -1, 29, 29, 29, 29, 
	-1, 29, -1, 29, 29, 29, -1, -1, 
	29, -1, -1, 29, 29, 29, 29, 29, 
	-1, 29, 29, 29, -1, -1, -1, -1, 
	29, 29, 29, 29, 29, -1, -1, 29, 
	29, 29, 29, -1, -1, -1, -1, -1, 
	716, -1, 716, 596, -1, -1, -1, 716, 
	-1, -1, -1, 595, -1, 595, 595, 595, 
	595, 595, 716, 716, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 716, -1, -1, 596, 596, 596, 596, 
	596, 596, 596, 596, 596, 596, 596, 596, 
	596, 596, 596, -1, 596, 596, 596, 596, 
	596, 596, 596, 622, -1, -1, -1, -1, 
	-1, 622, -1, -1, -1, 622, 622, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 29, 29, 29, 
	29, -1, 23, 29, 29, -1, 29, 29, 
	29, -1, -1, -1, -1, 29, 29, 29, 
	-1, 29, 29, 29, -1, 622, -1, -1, 
	29, -1, -1, -1, -1, 29, -1, -1, 
	-1, 29, 29, 29, -1, 29, 29, -1, 
	623, 29, 623, 623, 623, 623, -1, 623, 
	-1, -1, -1, 623, -1, 29, 716, 716, 
	-1, -1, 623, 623, -1, -1, -1, -1, 
	-1, 29, 29, -1, -1, -1, -1, -1, 
	-1, 623, -1, 29, 29, -1, -1, -1, 
	-1, 29, 623, -1, -1, -1, -1, -1, 
	716, 716, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	29, 29, 29, -1, -1, -1, -1, -1, 
	29, 29, 596, -1, 596, 596, 596, 596, 
	596, -1, -1, -1, 29, 34, 34, 34, 
	34, 34, 34, 34, 34, 34, 34, 34, 
	34, 34, 34, 34, 34, 34, 34, 34, 
	34, 34, 34, 34, 34, 34, 34, -1, 
	34, 34, 34, 34, 34, -1, 34, -1, 
	34, 34, 34, 34, -1, 34, -1, 34, 
	34, 34, -1, -1, 34, 34, 34, 34, 
	34, 34, 34, 34, -1, 34, 34, 34, 
	-1, -1, -1, -1, 34, 34, 34, 34, 
	34, -1, -1, 34, 34, 34, 34, 37, 
	37, 37, 37, 37, 37, 37, -1, 37, 
	37, 34, -1, -1, -1, -1, -1, -1, 
	715, -1, 37, 37, 37, 37, 37, -1, 
	623, 623, 593, -1, -1, -1, 623, -1, 
	-1, 37, 623, 623, -1, 37, -1, -1, 
	-1, 37, 37, 37, 37, 37, 37, -1, 
	-1, -1, -1, 37, 37, 37, -1, -1, 
	-1, -1, 37, 37, -1, 37, 37, 37, 
	37, -1, -1, -1, -1, -1, -1, -1, 
	37, -1, 675, -1, 675, 675, 675, 675, 
	-1, 675, 623, -1, -1, -1, 37, 37, 
	37, -1, 37, -1, -1, -1, -1, -1, 
	-1, 34, 34, 34, 34, -1, -1, 34, 
	34, -1, 34, 34, 34, -1, -1, -1, 
	-1, 34, 34, 34, 675, 34, 34, 34, 
	-1, -1, -1, -1, 34, -1, -1, -1, 
	-1, 34, -1, -1, -1, 34, 34, 34, 
	-1, 34, 34, -1, -1, 34, 676, 628, 
	676, 676, 676, 676, -1, 676, 34, 34, 
	34, 34, 34, 34, 34, -1, -1, -1, 
	-1, 34, 34, -1, -1, 34, 34, -1, 
	628, 628, 628, 628, 628, -1, -1, 34, 
	34, -1, -1, -1, -1, 34, -1, -1, 
	676, -1, -1, -1, -1, -1, -1, 628, 
	628, 628, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 34, 34, 34, 594, 
	628, -1, -1, -1, 34, 34, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	34, -1, -1, -1, -1, -1, -1, 34, 
	-1, -1, 37, 37, 37, 37, 37, -1, 
	37, 37, 37, -1, -1, -1, -1, 37, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 597, 675, -1, -1, -1, -1, -1, 
	675, -1, -1, -1, 675, 675, -1, -1, 
	-1, -1, -1, 37, 37, 37, 37, 37, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 597, 597, 597, 597, 597, 597, 
	597, 597, 597, 597, 597, 597, 597, 597, 
	597, -1, 597, 597, 597, 597, 597, 597, 
	597, -1, -1, -1, 675, -1, 598, -1, 
	-1, -1, -1, -1, -1, -1, 676, 595, 
	-1, -1, -1, -1, 676, -1, -1, -1, 
	676, 676, -1, -1, -1, 628, 628, -1, 
	628, -1, -1, -1, -1, -1, -1, 598, 
	598, 598, 598, 598, 598, 598, 598, 598, 
	598, 598, 598, 598, 598, 598, -1, 598, 
	598, 598, 598, 598, 598, 598, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	676, -1, -1, -1, -1, -1, -1, 628, 
	628, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 34, -1, -1, -1, -1, 
	-1, 29, 29, 29, 29, -1, -1, 29, 
	29, -1, 29, 29, 29, -1, -1, -1, 
	-1, 29, 29, 29, -1, 29, 29, 29, 
	-1, -1, -1, -1, 29, -1, -1, -1, 
	-1, 29, -1, 628, -1, 29, 29, 29, 
	-1, 29, 29, -1, -1, 29, -1, -1, 
	215, 215, 215, 215, 215, 215, -1, -1, 
	597, 29, 597, 597, 597, 597, 597, -1, 
	-1, -1, 215, -1, -1, 29, 29, -1, 
	-1, -1, -1, 215, 215, 215, 215, 215, 
	29, 215, -1, 215, -1, 29, -1, -1, 
	215, -1, -1, 215, 215, 716, -1, -1, 
	-1, -1, 215, 215, 215, -1, -1, -1, 
	215, 215, 215, -1, 29, 29, 29, 215, 
	215, 215, 215, 215, 29, 598, -1, 598, 
	598, 598, 598, 598, -1, -1, -1, -1, 
	29, 35, 35, 35, 35, 35, 35, 35, 
	35, 35, 35, 35, 35, 35, 35, 35, 
	35, 35, 35, 35, 35, 35, 35, 35, 
	35, 35, 35, -1, 35, 35, 35, 35, 
	35, -1, 35, -1, 35, 35, 35, 35, 
	-1, 35, -1, 35, 35, 35, -1, -1, 
	35, 35, 35, 35, 35, 35, 35, 35, 
	-1, 35, 35, 35, -1, -1, -1, -1, 
	35, 35, 35, 35, 35, -1, -1, 35, 
	35, 35, 35, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 35, -1, -1, 
	35, -1, -1, -1, 706, 215, 215, 215, 
	-1, -1, 215, 215, -1, 623, 215, 215, 
	-1, -1, -1, -1, 215, 215, 215, -1, 
	215, 215, 215, -1, -1, 706, 706, 706, 
	706, 706, -1, -1, 215, 215, -1, -1, 
	215, 215, 215, -1, 215, 215, -1, -1, 
	215, -1, -1, -1, 706, 706, 706, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 706, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 215, 215, -1, 35, 35, 35, 
	35, -1, -1, 35, 35, -1, 35, 35, 
	35, -1, -1, -1, -1, 35, 35, 35, 
	-1, 35, 35, 35, -1, -1, -1, -1, 
	35, -1, -1, -1, -1, 35, -1, -1, 
	-1, 35, 35, 35, -1, 35, 35, -1, 
	-1, 35, -1, -1, -1, -1, -1, -1, 
	215, -1, 35, 35, 35, 35, 35, 35, 
	35, -1, -1, -1, -1, 35, 35, -1, 
	35, 35, 35, -1, -1, -1, -1, -1, 
	-1, -1, -1, 35, 35, -1, -1, -1, 
	-1, 35, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	35, 35, 35, -1, -1, -1, -1, -1, 
	35, 35, 706, 706, -1, 706, -1, -1, 
	-1, -1, -1, -1, 35, -1, -1, -1, 
	-1, -1, -1, 35, -1, -1, 37, 37, 
	37, 37, 37, -1, 37, 37, 37, -1, 
	-1, -1, -1, 37, 39, 39, 39, 39, 
	39, 39, 39, -1, 39, 39, -1, -1, 
	-1, -1, -1, -1, 706, 706, -1, 39, 
	39, 39, 39, 39, -1, -1, -1, 37, 
	37, 37, 37, -1, -1, -1, 39, -1, 
	-1, -1, 39, -1, -1, -1, 39, 39, 
	39, 39, 39, 39, -1, -1, -1, -1, 
	39, 39, 39, -1, -1, -1, -1, 39, 
	39, -1, 39, 39, 39, 39, -1, -1, 
	706, -1, -1, -1, -1, 39, 42, 42, 
	42, 42, 42, 42, 42, -1, 42, 42, 
	-1, -1, -1, 39, 39, 39, -1, 39, 
	-1, 42, 42, 42, 42, 42, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	42, -1, -1, -1, 42, -1, -1, -1, 
	42, 42, 42, 42, 42, 42, -1, -1, 
	-1, -1, 42, 42, 42, -1, -1, -1, 
	-1, 42, 42, 599, 42, 42, 42, 42, 
	-1, -1, -1, -1, -1, -1, -1, 42, 
	-1, -1, -1, -1, -1, -1, -1, 35, 
	-1, -1, -1, -1, -1, 42, 42, 42, 
	-1, 42, -1, -1, 599, 599, 599, 599, 
	599, 599, 599, 599, 599, 599, 599, 599, 
	599, 599, 599, -1, 599, 599, 599, 599, 
	599, 599, 599, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 39, 
	39, 39, 39, 39, -1, 39, 39, 39, 
	-1, -1, -1, -1, 39, 602, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	39, 39, 39, 39, 39, -1, 602, 602, 
	602, 602, 602, 602, 602, 602, 602, 602, 
	602, 602, 602, 602, 602, -1, 602, 602, 
	602, 602, 602, 602, 602, -1, -1, -1, 
	-1, 42, 42, 42, 42, 42, -1, 42, 
	42, 42, -1, -1, -1, -1, 42, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 599, -1, 599, 599, 599, 599, 
	599, -1, 42, 42, 42, 42, 42, -1, 
	-1, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, -1, 43, 43, 43, 43, 
	43, -1, 43, -1, 43, 43, 43, 43, 
	-1, 43, -1, 43, 43, 43, -1, -1, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	-1, 43, 43, 43, -1, -1, -1, -1, 
	43, 43, 43, 43, 43, -1, -1, 43, 
	43, 43, 43, -1, -1, -1, -1, -1, 
	-1, -1, -1, 603, -1, 43, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 602, -1, 602, 602, 
	602, 602, 602, -1, -1, -1, -1, -1, 
	-1, -1, 604, -1, 603, 603, 603, 603, 
	603, 603, 603, 603, 603, 603, 603, 603, 
	603, 603, 603, -1, 603, 603, 603, 603, 
	603, 603, 603, -1, -1, -1, -1, -1, 
	-1, -1, -1, 604, 604, 604, 604, 604, 
	604, 604, 604, 604, 604, 604, 604, 604, 
	604, 604, 604, 604, 604, 604, 604, 604, 
	604, 604, -1, -1, 35, 43, 43, 43, 
	43, -1, -1, 43, 43, -1, 43, 43, 
	43, -1, -1, -1, -1, 43, 43, 43, 
	-1, 43, 43, 43, -1, -1, -1, -1, 
	43, -1, -1, -1, -1, 43, -1, -1, 
	-1, 43, 43, 43, -1, 43, 43, -1, 
	-1, 43, -1, -1, -1, -1, -1, -1, 
	-1, -1, 43, 43, 43, 43, 43, 43, 
	43, -1, -1, -1, -1, 43, 43, -1, 
	-1, 43, 43, -1, -1, -1, -1, -1, 
	-1, -1, -1, 43, 43, -1, -1, -1, 
	-1, 43, -1, -1, -1, -1, -1, -1, 
	-1, -1, 624, -1, 624, 624, 624, 624, 
	-1, 624, -1, -1, -1, -1, -1, -1, 
	43, 43, 43, -1, 624, 624, -1, -1, 
	43, 43, 603, -1, 603, 603, 603, 603, 
	603, -1, -1, 624, 43, -1, -1, -1, 
	-1, -1, -1, 43, 624, -1, -1, 108, 
	108, 108, 108, 108, 108, 108, -1, 108, 
	108, 604, -1, 604, 604, 604, 604, 604, 
	-1, -1, 108, 108, 108, 108, 108, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 108, -1, -1, -1, 108, -1, -1, 
	-1, 108, 108, 108, 108, 108, 108, -1, 
	-1, -1, -1, 108, 108, 108, -1, -1, 
	-1, -1, 108, 108, 605, 108, 108, 108, 
	108, -1, -1, -1, -1, -1, -1, -1, 
	108, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 605, 605, 605, 
	605, 605, 605, 605, 605, 605, 605, 605, 
	605, 605, 605, 605, 605, 605, 605, 605, 
	605, 605, 605, 605, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 624, 624, -1, -1, -1, -1, 
	624, -1, -1, -1, 624, 624, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 43, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 39, 39, 39, 39, 39, 
	-1, 39, 39, 39, -1, -1, -1, -1, 
	39, -1, -1, -1, 624, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 39, 39, 39, 39, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	108, 108, 108, -1, -1, -1, -1, 108, 
	-1, -1, -1, -1, -1, 42, 42, 42, 
	42, 42, -1, 42, 42, 42, -1, -1, 
	-1, -1, 42, 605, -1, 605, 605, 605, 
	605, 605, -1, 108, 108, 108, 108, 108, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 42, 42, 
	42, 42, 44, 44, 44, 44, 44, 44, 
	44, 44, 44, 44, 44, 44, 44, 44, 
	44, 44, 44, 44, 44, 44, 44, 44, 
	44, 44, 44, 44, -1, 44, 44, 44, 
	44, 44, -1, 44, -1, 44, 44, 44, 
	44, -1, 44, -1, 44, 44, 44, -1, 
	-1, 44, 44, 44, 44, 44, 44, 44, 
	44, 661, 44, 44, 44, -1, -1, -1, 
	-1, 44, 44, 44, 44, 44, -1, -1, 
	44, 44, 44, 44, -1, -1, -1, -1, 
	-1, -1, -1, -1, 697, -1, 44, -1, 
	-1, -1, 661, 661, 661, 661, 661, 661, 
	661, 661, 661, 661, 661, 661, 661, 661, 
	661, -1, 661, 661, 661, 661, 661, 661, 
	661, -1, -1, -1, -1, 697, 697, 697, 
	697, 697, 697, 697, 697, 697, 697, 697, 
	697, 697, 697, 697, -1, 697, 697, 697, 
	697, 697, 697, 697, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 44, 44, 
	44, 44, -1, -1, 44, 44, -1, 44, 
	44, 44, -1, -1, -1, -1, 44, 44, 
	44, -1, 44, 44, 44, -1, -1, -1, 
	-1, 44, -1, -1, -1, -1, 44, -1, 
	-1, -1, 44, 44, 44, -1, 44, 44, 
	-1, -1, 44, -1, -1, -1, -1, -1, 
	-1, -1, -1, 44, 44, 44, 44, 44, 
	44, 44, -1, -1, -1, -1, 44, 44, 
	-1, -1, 44, 44, -1, -1, -1, -1, 
	-1, -1, -1, -1, 44, 44, -1, -1, 
	-1, -1, 44, -1, -1, -1, -1, -1, 
	661, -1, 661, 661, 661, 661, 661, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 44, 44, 44, -1, -1, -1, -1, 
	-1, 44, 44, 697, -1, 697, 697, 697, 
	697, 697, -1, -1, -1, 44, -1, -1, 
	-1, -1, -1, -1, 44, 45, 45, 45, 
	45, 45, 45, 45, 45, 45, 45, 45, 
	45, 45, 45, 45, 45, 45, 45, 45, 
	45, 45, 45, 45, 45, 45, 45, -1, 
	45, 45, 45, 45, 45, -1, 45, -1, 
	45, 45, 45, 45, -1, 45, -1, 45, 
	45, 45, -1, -1, 45, 45, 45, 45, 
	45, 45, 45, 45, 698, 45, 45, 45, 
	-1, -1, -1, -1, 45, 45, 45, 45, 
	45, -1, -1, 45, 45, 45, 45, -1, 
	-1, -1, -1, -1, -1, -1, -1, 719, 
	-1, 45, -1, -1, -1, 698, 698, 698, 
	698, 698, 698, 698, 698, 698, 698, 698, 
	698, 698, 698, 698, -1, 698, 698, 698, 
	698, 698, 698, 698, -1, -1, -1, -1, 
	719, 719, 719, 719, 719, 719, 719, 719, 
	719, 719, 719, 719, 719, 719, 719, -1, 
	719, 719, 719, 719, 719, 719, 719, -1, 
	-1, -1, -1, -1, -1, -1, -1, 624, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	44, 45, 45, 45, 45, -1, -1, 45, 
	45, -1, 45, 45, 45, -1, -1, -1, 
	-1, 45, 45, 45, -1, 45, 45, 45, 
	-1, -1, -1, -1, 45, -1, -1, -1, 
	-1, 45, -1, -1, -1, 45, 45, 45, 
	-1, 45, 45, -1, -1, 45, -1, -1, 
	-1, -1, -1, -1, -1, -1, 45, 45, 
	45, 45, 45, 45, 45, -1, -1, -1, 
	-1, 45, 45, -1, -1, 45, 45, -1, 
	-1, -1, -1, -1, 108, 108, 108, 45, 
	45, -1, -1, 108, -1, 45, -1, -1, 
	-1, -1, -1, 698, -1, 698, 698, 698, 
	698, 698, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 45, 45, 45, 108, 
	108, 108, 108, -1, 45, 45, 719, -1, 
	719, 719, 719, 719, 719, -1, -1, -1, 
	45, -1, -1, -1, -1, -1, -1, 45, 
	46, 46, 46, 46, 46, 46, 46, 46, 
	46, 46, 46, 46, 46, 46, 46, 46, 
	46, 46, 46, 46, 46, 46, 46, 46, 
	46, 46, -1, 46, 46, 46, 46, 46, 
	-1, 46, -1, 46, 46, 46, 46, -1, 
	46, -1, 46, 46, 46, 46, -1, 46, 
	46, 46, 46, 46, 46, 46, 46, -1, 
	46, 46, 46, -1, -1, -1, -1, 46, 
	46, 46, 46, 46, -1, -1, 46, 46, 
	46, 46, -1, -1, -1, -1, -1, 46, 
	-1, -1, -1, -1, 46, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 45, 46, 46, 46, 46, 
	-1, -1, 46, 46, -1, 46, 46, 46, 
	-1, -1, -1, -1, 46, 46, 46, -1, 
	46, 46, 46, -1, -1, -1, -1, 46, 
	-1, -1, -1, -1, 46, -1, -1, -1, 
	46, 46, 46, -1, 46, 46, -1, -1, 
	46, -1, -1, -1, -1, -1, -1, -1, 
	-1, 46, 46, 46, 46, 46, 46, 46, 
	-1, -1, -1, -1, 46, 46, -1, -1, 
	46, 46, -1, -1, -1, -1, -1, -1, 
	46, -1, 46, 46, -1, -1, -1, -1, 
	46, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 46, 
	46, 46, -1, -1, -1, -1, -1, 46, 
	46, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 46, -1, -1, -1, -1, 
	-1, -1, 46, 72, 72, 72, 72, 72, 
	72, 72, 72, 72, 72, 72, 72, 72, 
	72, 72, 72, 72, 72, 72, 72, 72, 
	72, 72, 72, 72, 72, -1, 72, 72, 
	72, 72, 72, -1, 72, -1, 72, 72, 
	72, 72, -1, 72, -1, 72, 72, 72, 
	72, 72, 72, 72, 72, 72, 72, 72, 
	72, 72, 72, 72, 72, 72, -1, 72, 
	72, 72, 72, 72, 72, 72, 72, 72, 
	72, 72, 72, 72, 72, 72, -1, 72, 
	-1, -1, 72, -1, 72, 72, 72, 72, 
	72, -1, -1, 72, 72, 72, 72, 72, 
	72, 72, 72, 72, 72, 72, 72, 72, 
	72, 72, 72, -1, -1, -1, -1, -1, 
	72, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 46, 72, 
	72, 72, 72, -1, -1, 72, 72, 72, 
	72, 72, 72, -1, -1, -1, -1, 72, 
	72, 72, 72, 72, 72, 72, -1, -1, 
	-1, -1, 72, -1, -1, -1, -1, 72, 
	72, -1, -1, 72, 72, 72, -1, 72, 
	72, -1, -1, 72, -1, -1, -1, -1, 
	-1, -1, -1, -1, 72, 72, 72, 72, 
	72, 72, 72, -1, -1, -1, 72, 72, 
	72, -1, -1, 72, 72, -1, 72, 72, 
	72, 72, 72, 72, 72, 72, 72, -1, 
	-1, -1, 72, 72, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 72, 72, 
	72, -1, -1, 72, -1, -1, -1, -1, 
	72, -1, 72, 72, 72, 72, -1, 72, 
	72, 72, 72, 72, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 72, -1, 
	72, -1, -1, 72, -1, 72, 72, -1, 
	-1, -1, 72, -1, 72, -1, 72, -1, 
	-1, -1, 76, 76, 76, 76, 76, 76, 
	76, 76, 76, 76, 76, 76, 76, 76, 
	76, 76, 76, 76, 76, 76, 76, 76, 
	76, 76, 76, 76, -1, 76, 76, 76, 
	76, 76, -1, 76, -1, 76, 76, 76, 
	76, -1, 76, -1, 76, 76, 76, 76, 
	76, 76, 76, 76, 76, 76, 76, 76, 
	76, 76, 76, 76, 76, -1, 76, 76, 
	76, 76, 76, 76, 76, 76, 76, 76, 
	76, 76, 76, 76, 76, -1, 76, -1, 
	-1, 76, -1, 76, 76, 76, 76, 76, 
	-1, -1, 76, 76, 76, 76, 76, 76, 
	76, 76, 76, 76, 76, 76, 76, 76, 
	76, 76, -1, -1, -1, -1, -1, 76, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 72, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 76, 76, 
	76, 76, -1, -1, 76, 76, 76, 76, 
	76, 76, -1, -1, -1, -1, 76, 76, 
	76, 76, 76, 76, 76, -1, -1, -1, 
	-1, 76, -1, -1, -1, -1, 76, 76, 
	-1, -1, 76, 76, 76, -1, 76, 76, 
	-1, -1, 76, -1, -1, -1, -1, -1, 
	-1, -1, -1, 76, 76, 76, 76, 76, 
	76, 76, -1, -1, 46, 76, 76, 76, 
	-1, -1, 76, 76, -1, 76, 76, 76, 
	76, 76, 76, 76, 76, 76, -1, -1, 
	-1, 76, 76, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 76, 76, 76, 
	-1, -1, 76, -1, -1, -1, -1, 76, 
	-1, 76, 76, 76, 76, -1, 76, 76, 
	76, 76, 76, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 76, -1, 76, 
	-1, -1, 76, -1, 76, 76, -1, -1, 
	-1, 76, -1, 76, -1, 76, 80, 80, 
	80, 80, 80, 80, 80, -1, 80, 80, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 80, 80, 80, 80, 80, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	80, -1, -1, -1, 80, -1, -1, -1, 
	80, 80, 80, 80, 80, 80, -1, -1, 
	-1, -1, 80, 80, 80, -1, -1, -1, 
	-1, 80, 80, -1, 80, 80, 80, 80, 
	80, -1, -1, -1, -1, -1, -1, 80, 
	-1, -1, 87, 87, 87, 87, 87, 87, 
	87, -1, 87, 87, -1, 80, 80, 80, 
	80, 80, -1, -1, -1, 87, 87, 87, 
	87, 87, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 87, -1, -1, -1, 
	87, -1, -1, -1, 87, 87, 87, 87, 
	87, 87, -1, -1, -1, -1, 87, 87, 
	87, -1, -1, -1, -1, 87, 87, -1, 
	87, 87, 87, 87, -1, -1, -1, -1, 
	-1, -1, -1, 87, 87, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	76, 87, 87, 87, -1, 87, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 80, 80, 80, 80, 80, -1, 80, 
	80, 80, -1, -1, -1, -1, 80, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 80, 80, 80, -1, -1, -1, -1, 
	-1, -1, -1, 80, -1, -1, -1, -1, 
	-1, -1, 80, 80, 80, 80, 80, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 87, 87, -1, -1, -1, 80, 
	-1, -1, -1, -1, -1, 87, 87, 87, 
	87, 87, -1, 87, 87, 87, -1, -1, 
	-1, -1, 87, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 87, 87, 
	87, 87, 87, 88, 88, 88, 88, 88, 
	88, 88, 88, 88, 88, 88, 88, 88, 
	88, 88, 88, 88, 88, 88, 88, 88, 
	88, 88, 88, 88, 88, -1, 88, 88, 
	88, 88, 88, -1, 88, -1, 88, 88, 
	88, 88, -1, 88, -1, 88, 88, 88, 
	-1, -1, 88, 88, 88, 88, 88, 88, 
	88, 88, -1, 88, 88, 88, -1, -1, 
	-1, -1, 88, 88, 88, 88, 88, -1, 
	-1, 88, 88, 88, 88, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 88, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 109, 109, 109, 109, 109, 109, 
	109, -1, 109, 109, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 109, 109, 109, 
	109, 109, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 109, -1, -1, -1, 
	109, -1, -1, -1, 109, 109, 109, 109, 
	109, 109, -1, -1, -1, -1, 109, 109, 
	109, -1, -1, -1, -1, 109, 109, -1, 
	109, 109, 109, 109, -1, -1, -1, 88, 
	88, 88, 88, 109, -1, 88, 88, -1, 
	88, 88, 88, -1, -1, -1, -1, 88, 
	88, 88, 109, 88, 88, 88, -1, -1, 
	-1, -1, 88, -1, -1, -1, -1, 88, 
	-1, -1, -1, 88, 88, 88, -1, 88, 
	88, -1, -1, 88, -1, 76, 76, -1, 
	-1, -1, -1, -1, 88, 88, 88, 88, 
	88, 88, 88, -1, -1, -1, -1, 88, 
	88, -1, -1, 88, 88, -1, -1, -1, 
	-1, -1, -1, -1, -1, 88, 88, -1, 
	-1, -1, -1, 88, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 100, 100, 
	100, 100, 100, 100, -1, -1, -1, -1, 
	-1, -1, 88, 88, 88, -1, -1, -1, 
	100, -1, 88, 88, -1, -1, -1, -1, 
	-1, 100, 100, 100, 100, 100, 88, 100, 
	-1, 100, -1, -1, -1, 88, 100, -1, 
	-1, 100, 100, -1, -1, -1, -1, -1, 
	100, 100, 100, -1, -1, -1, 100, 100, 
	100, -1, -1, -1, -1, 100, 100, 100, 
	100, 100, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 109, 109, 109, -1, -1, 
	-1, -1, 109, -1, -1, -1, 103, 103, 
	103, 103, 103, 103, 103, 103, 103, -1, 
	103, 103, -1, -1, 103, 103, 103, 103, 
	-1, -1, -1, -1, -1, -1, 109, 109, 
	109, 109, 109, -1, 103, 103, 103, -1, 
	-1, -1, 103, -1, -1, -1, -1, 103, 
	-1, -1, -1, -1, -1, 103, 103, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 103, -1, -1, 103, 103, 
	103, 103, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 103, -1, -1, -1, -1, 
	-1, -1, -1, 100, 100, 100, -1, -1, 
	100, 100, -1, -1, 100, 100, 103, 103, 
	-1, -1, 100, 100, 100, -1, 100, 100, 
	100, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 100, 100, -1, -1, 100, 100, 
	100, 88, 100, 100, -1, -1, 100, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 80, 80, 
	100, 100, -1, -1, -1, -1, -1, 80, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 87, 87, 
	-1, -1, -1, 80, -1, -1, -1, -1, 
	-1, 87, 87, 87, 87, 87, 100, 87, 
	87, 87, -1, -1, 103, -1, 87, -1, 
	-1, -1, -1, 103, -1, -1, -1, -1, 
	103, 103, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 103, -1, -1, -1, -1, 
	103, -1, 87, 87, 87, 87, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 103, 
	103, 103, -1, -1, -1, -1, -1, 103, 
	103, 104, 104, 104, 104, 104, 104, 104, 
	104, 104, 104, 104, 104, 104, 104, 104, 
	104, 104, 104, 104, 104, 104, 104, 104, 
	104, 104, 104, -1, 104, 104, 104, 104, 
	104, -1, 104, -1, 104, 104, 104, 104, 
	-1, 104, -1, 104, 104, 104, -1, 104, 
	104, 104, 104, 104, 104, 104, 104, 104, 
	104, 104, 104, 104, -1, 104, 104, 104, 
	104, 104, 104, 104, 104, 104, 104, 104, 
	104, 104, 104, 104, -1, -1, -1, -1, 
	-1, -1, 104, 104, 104, 104, -1, -1, 
	-1, 104, 104, 104, 104, 104, 104, 104, 
	104, 104, 104, 104, 104, -1, -1, 104, 
	104, -1, -1, -1, -1, -1, 104, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 104, 104, 104, 
	104, -1, -1, 104, 104, 104, 104, 104, 
	104, -1, -1, -1, -1, 104, 104, 104, 
	104, 104, 104, 104, -1, -1, -1, -1, 
	104, -1, -1, -1, -1, 104, 104, -1, 
	-1, 104, 104, 104, -1, 104, 104, -1, 
	-1, 104, -1, -1, -1, -1, -1, -1, 
	-1, -1, 104, 104, 104, 104, 104, 104, 
	104, -1, -1, -1, 104, 104, 104, -1, 
	-1, 104, 104, -1, 104, 104, 104, 104, 
	104, -1, 104, 104, 104, -1, -1, -1, 
	104, 104, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 104, 104, 104, -1, 
	-1, 104, -1, -1, -1, -1, 104, -1, 
	104, 104, 104, 104, -1, 104, 104, 104, 
	104, 104, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 104, -1, 104, -1, 
	-1, 104, -1, 104, 104, -1, -1, -1, 
	104, -1, 104, -1, 104, -1, -1, 109, 
	109, 109, -1, -1, -1, -1, 109, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 325, 325, 325, 325, 325, 325, -1, 
	-1, -1, 109, 109, 109, 109, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 325, 325, 325, 325, 
	325, -1, 325, -1, 325, -1, -1, -1, 
	-1, 325, -1, -1, 325, -1, -1, -1, 
	-1, -1, -1, 325, 325, 325, -1, -1, 
	-1, 325, 325, 325, -1, -1, -1, -1, 
	325, 325, 325, -1, 325, -1, -1, 100, 
	100, 100, -1, -1, 100, 100, -1, -1, 
	100, 100, -1, -1, -1, -1, 100, 100, 
	100, -1, 100, 100, 100, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 100, 100, 
	-1, -1, 100, 100, 100, -1, 100, 100, 
	-1, -1, 100, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 104, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 325, 
	325, -1, -1, 325, 325, 325, 325, -1, 
	325, -1, -1, -1, -1, 325, 325, 325, 
	325, 325, 325, 325, -1, -1, -1, -1, 
	-1, -1, 100, -1, -1, -1, -1, -1, 
	103, 325, 325, 325, -1, 325, 325, 103, 
	-1, 325, -1, -1, 103, 103, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 103, 
	-1, -1, -1, -1, 103, -1, -1, -1, 
	-1, 325, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 325, 325, -1, -1, -1, 
	-1, -1, -1, 103, 103, 103, -1, -1, 
	-1, -1, -1, 103, 105, 105, 105, 105, 
	105, 105, 105, 105, 105, 105, 105, 105, 
	105, 105, 105, 105, 105, 105, 105, 105, 
	105, 105, 105, 105, 105, 105, -1, 105, 
	105, 105, 105, 105, -1, 105, 325, 105, 
	105, 105, 105, -1, 105, -1, 105, 105, 
	105, -1, 105, 105, 105, 105, 105, 105, 
	105, 105, 105, 105, 105, 105, 105, -1, 
	105, 105, 105, 105, 105, 105, 105, 105, 
	105, 105, 105, 105, 105, 105, 105, -1, 
	-1, -1, -1, -1, -1, 105, 105, 105, 
	105, -1, -1, -1, 105, 105, 105, 105, 
	105, 105, 105, 105, 105, 105, 105, 105, 
	105, 105, 105, 105, -1, -1, -1, -1, 
	-1, 105, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	105, 105, 105, 105, -1, -1, 105, 105, 
	105, 105, 105, 105, -1, -1, -1, -1, 
	105, 105, 105, 105, 105, 105, 105, -1, 
	-1, -1, -1, 105, -1, -1, -1, -1, 
	105, 105, -1, -1, 105, 105, 105, -1, 
	105, 105, -1, -1, 105, -1, -1, -1, 
	-1, -1, -1, -1, -1, 105, 105, 105, 
	105, 105, 105, 105, -1, -1, -1, 105, 
	105, 105, -1, -1, 105, 105, -1, 105, 
	105, 105, 105, 105, -1, 105, 105, 105, 
	-1, -1, -1, 105, 105, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 105, 
	105, 105, -1, -1, 105, -1, -1, -1, 
	-1, 105, -1, 105, 105, 105, 105, -1, 
	105, 105, 105, 105, 105, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 105, 
	-1, 105, -1, -1, 105, -1, 105, 105, 
	-1, -1, -1, 105, -1, 105, -1, 105, 
	106, 106, 106, 106, 106, 106, 106, 106, 
	106, 106, 106, 106, 106, 106, 106, 106, 
	106, 106, 106, 106, 106, 106, 106, 106, 
	106, 106, -1, 106, 106, 106, 106, 106, 
	-1, 106, -1, 106, 106, 106, 106, -1, 
	106, -1, 106, 106, 106, -1, 106, 106, 
	106, 106, 106, 106, 106, 106, 106, 106, 
	106, 106, 106, -1, 106, 106, 106, 106, 
	106, 106, 106, 106, 106, 106, 106, 106, 
	106, 106, 106, -1, 106, -1, -1, -1, 
	-1, 106, 106, 106, 106, 106, -1, -1, 
	106, 106, 106, 106, 106, 106, 106, 106, 
	106, 106, 106, 106, 106, 106, 106, 106, 
	-1, -1, -1, -1, -1, 106, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 105, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 106, 106, 106, 106, 
	-1, -1, 106, 106, 106, 106, 106, 106, 
	-1, -1, -1, -1, 106, 106, 106, 106, 
	106, 106, 106, -1, -1, -1, -1, 106, 
	-1, -1, -1, -1, 106, 106, -1, -1, 
	106, 106, 106, -1, 106, 106, -1, -1, 
	106, -1, -1, -1, -1, -1, -1, -1, 
	-1, 106, 106, 106, 106, 106, 106, 106, 
	-1, -1, -1, 106, 106, 106, -1, -1, 
	106, 106, -1, 106, 106, 106, 106, 106, 
	-1, 106, 106, 106, -1, -1, -1, 106, 
	106, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 106, 106, 106, -1, -1, 
	106, -1, -1, -1, -1, 106, -1, 106, 
	106, 106, 106, -1, 106, 106, 106, 106, 
	106, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 106, -1, 106, -1, -1, 
	106, -1, 106, 106, -1, -1, -1, 106, 
	-1, 106, -1, 106, 107, 107, 107, 107, 
	107, 107, 107, 107, 107, 107, 107, 107, 
	107, 107, 107, 107, 107, 107, 107, 107, 
	107, 107, 107, 107, 107, 107, -1, 107, 
	107, 107, 107, 107, -1, 107, -1, 107, 
	107, 107, 107, -1, 107, -1, 107, 107, 
	107, -1, 107, 107, 107, 107, 107, 107, 
	107, 107, 107, 107, 107, 107, 107, -1, 
	107, 107, 107, 107, 107, 107, 107, 107, 
	107, 107, 107, 107, 107, 107, 107, -1, 
	107, -1, -1, -1, -1, 107, 107, 107, 
	107, 107, -1, -1, 107, 107, 107, 107, 
	107, 107, 107, 107, 107, 107, 107, 107, 
	107, 107, 107, 107, -1, -1, -1, -1, 
	-1, 107, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 106, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	107, 107, 107, 107, -1, -1, 107, 107, 
	107, 107, 107, 107, -1, -1, -1, -1, 
	107, 107, 107, 107, 107, 107, 107, -1, 
	-1, -1, -1, 107, -1, -1, -1, -1, 
	107, 107, -1, -1, 107, 107, 107, -1, 
	107, 107, -1, -1, 107, -1, -1, -1, 
	-1, -1, -1, -1, -1, 107, 107, 107, 
	107, 107, 107, 107, -1, -1, -1, 107, 
	107, 107, -1, -1, 107, 107, -1, 107, 
	107, 107, 107, 107, -1, 107, 107, 107, 
	-1, -1, -1, 107, 107, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 107, 
	107, 107, -1, -1, 107, -1, -1, -1, 
	-1, 107, -1, 107, 107, 107, 107, -1, 
	107, 107, 107, 107, 107, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 107, 
	-1, 107, -1, -1, 107, -1, 107, 107, 
	-1, -1, -1, 107, -1, 107, -1, 107, 
	110, 110, 110, 110, 110, 110, 110, -1, 
	110, 110, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 110, 110, 110, 110, 110, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 110, -1, -1, -1, 110, -1, 
	-1, -1, 110, 110, 110, 110, 110, 110, 
	-1, -1, -1, -1, 110, 110, 110, -1, 
	-1, -1, -1, 110, 110, -1, 110, 110, 
	110, 110, 111, 111, 111, 111, 111, 111, 
	111, 110, 111, 111, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 111, 111, 111, 
	111, 111, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 111, -1, -1, -1, 
	111, -1, -1, -1, 111, 111, 111, 111, 
	111, 111, -1, -1, -1, -1, 111, 111, 
	111, -1, -1, -1, -1, 111, 111, -1, 
	111, 111, 111, 111, -1, -1, -1, -1, 
	-1, -1, -1, 111, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 107, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 110, 110, 110, -1, -1, -1, -1, 
	110, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 110, 110, 110, 110, 
	110, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 111, 111, 111, -1, -1, 
	-1, -1, 111, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 111, 111, 
	111, 111, 111, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, -1, 112, 112, 
	112, 112, 112, -1, 112, -1, 112, 112, 
	112, 112, -1, 112, -1, 112, 112, 112, 
	-1, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, -1, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, -1, 112, 
	-1, -1, -1, -1, 112, 112, 112, 112, 
	112, -1, -1, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, -1, -1, -1, -1, -1, 
	112, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 112, 
	112, 112, 112, -1, -1, 112, 112, 112, 
	112, 112, 112, -1, -1, -1, -1, 112, 
	112, 112, 112, 112, 112, 112, -1, -1, 
	-1, -1, 112, -1, -1, -1, -1, 112, 
	112, -1, -1, 112, 112, 112, -1, 112, 
	112, -1, -1, 112, -1, -1, -1, -1, 
	-1, -1, -1, -1, 112, 112, 112, 112, 
	112, 112, 112, -1, -1, -1, 112, 112, 
	112, -1, -1, 112, 112, -1, 112, 112, 
	112, 112, 112, -1, 112, 112, 112, -1, 
	-1, -1, 112, 112, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 112, 112, 
	112, -1, -1, 112, -1, -1, -1, -1, 
	112, -1, 112, 112, 112, 112, -1, 112, 
	112, 112, 112, 112, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 112, -1, 
	112, -1, -1, 112, -1, 112, 112, -1, 
	-1, -1, 112, -1, 112, -1, 112, 168, 
	168, 168, 168, 168, 168, 168, -1, 168, 
	168, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 168, 168, 168, 168, 168, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 168, -1, -1, -1, 168, -1, -1, 
	-1, 168, 168, 168, 168, 168, 168, -1, 
	-1, -1, -1, 168, 168, 168, -1, -1, 
	-1, -1, 168, 168, -1, 168, 168, 168, 
	168, -1, -1, -1, -1, -1, -1, -1, 
	168, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 168, 168, 
	168, 168, 168, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 112, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 110, 110, 110, 
	-1, -1, -1, -1, 110, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	110, 110, 110, 110, -1, -1, -1, -1, 
	-1, -1, 168, 168, 168, 168, 168, -1, 
	168, 168, 168, -1, -1, -1, -1, 168, 
	-1, -1, -1, -1, -1, -1, -1, 111, 
	111, 111, 168, -1, -1, -1, 111, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 168, 168, 168, 168, 168, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 111, 111, 111, 111, 113, 113, 
	113, 113, 113, 113, 113, 113, 113, 113, 
	113, 113, 113, 113, 113, 113, 113, 113, 
	113, 113, 113, 113, 113, 113, 113, 113, 
	-1, 113, 113, 113, 113, 113, -1, 113, 
	-1, 113, 113, 113, 113, -1, 113, -1, 
	113, 113, 113, -1, 113, 113, 113, 113, 
	113, 113, 113, 113, 113, 113, 113, 113, 
	113, -1, 113, 113, 113, 113, 113, 113, 
	113, 113, 113, 113, 113, 113, 113, 113, 
	113, -1, 113, -1, -1, -1, -1, 113, 
	113, 113, 113, 113, -1, -1, 113, 113, 
	113, 113, 113, 113, 113, 113, 113, 113, 
	113, 113, 113, 113, 113, 113, -1, -1, 
	-1, -1, -1, 113, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 113, 113, 113, 113, -1, -1, 
	113, 113, 113, 113, 113, 113, -1, -1, 
	-1, -1, 113, 113, 113, 113, 113, 113, 
	113, -1, -1, -1, -1, 113, -1, -1, 
	-1, -1, 113, 113, -1, -1, 113, 113, 
	113, -1, 113, 113, -1, -1, 113, -1, 
	-1, -1, -1, -1, -1, -1, -1, 113, 
	113, 113, 113, 113, 113, 113, -1, -1, 
	-1, 113, 113, 113, -1, -1, 113, 113, 
	-1, 113, 113, 113, 113, 113, -1, 113, 
	113, 113, -1, -1, -1, 113, 113, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 113, 113, 113, -1, -1, 113, -1, 
	-1, -1, -1, 113, -1, 113, 113, 113, 
	113, -1, 113, 113, 113, 113, 113, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 113, -1, 113, -1, -1, 113, -1, 
	113, 113, -1, -1, -1, 113, -1, 113, 
	-1, 113, 114, 114, 114, 114, 114, 114, 
	114, 114, 114, 114, 114, 114, 114, 114, 
	114, 114, 114, 114, 114, 114, 114, 114, 
	114, 114, 114, 114, -1, 114, 114, 114, 
	114, 114, -1, 114, -1, 114, 114, 114, 
	114, -1, 114, -1, 114, 114, 114, -1, 
	114, 114, 114, 114, 114, 114, 114, 114, 
	114, 114, 114, 114, 114, -1, 114, 114, 
	114, 114, 114, 114, 114, 114, 114, 114, 
	114, 114, 114, 114, 114, -1, 114, -1, 
	-1, -1, -1, 114, 114, 114, 114, 114, 
	-1, -1, 114, 114, 114, 114, 114, 114, 
	114, 114, 114, 114, 114, 114, 114, 114, 
	114, 114, -1, -1, -1, -1, -1, 114, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 113, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 114, 114, 
	114, 114, -1, -1, 114, 114, 114, 114, 
	114, 114, -1, -1, -1, -1, 114, 114, 
	114, 114, 114, 114, 114, -1, -1, -1, 
	-1, 114, -1, -1, -1, -1, 114, 114, 
	-1, -1, 114, 114, 114, -1, 114, 114, 
	-1, -1, 114, -1, -1, -1, -1, -1, 
	-1, -1, -1, 114, 114, 114, 114, 114, 
	114, 114, -1, -1, -1, 114, 114, 114, 
	-1, -1, 114, 114, -1, 114, 114, 114, 
	114, 114, -1, 114, 114, 114, -1, -1, 
	-1, 114, 114, -1, -1, -1, 168, -1, 
	-1, -1, -1, -1, -1, 114, 114, 114, 
	-1, -1, 114, -1, -1, -1, -1, 114, 
	-1, 114, 114, 114, 114, -1, 114, 114, 
	114, 114, 114, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 114, -1, 114, 
	-1, -1, 114, -1, 114, 114, -1, -1, 
	-1, 114, -1, 114, -1, 114, 115, 115, 
	115, 115, 115, 115, 115, 115, 115, 115, 
	115, 115, 115, 115, 115, 115, 115, 115, 
	115, 115, 115, 115, 115, 115, 115, 115, 
	-1, 115, 115, 115, 115, 115, -1, 115, 
	-1, 115, 115, 115, 115, -1, 115, -1, 
	115, 115, 115, -1, 115, 115, 115, 115, 
	115, 115, 115, 115, 115, 115, 115, 115, 
	115, -1, 115, 115, 115, 115, 115, 115, 
	115, 115, 115, 115, 115, 115, 115, 115, 
	115, -1, 115, -1, -1, -1, -1, 115, 
	115, 115, 115, 115, -1, -1, 115, 115, 
	115, 115, 115, 115, 115, 115, 115, 115, 
	115, 115, 115, 115, 115, 115, -1, -1, 
	-1, -1, -1, 115, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	114, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 115, 115, 115, 115, -1, -1, 
	115, 115, 115, 115, 115, 115, -1, -1, 
	-1, -1, 115, 115, 115, 115, 115, 115, 
	115, -1, -1, -1, -1, 115, -1, -1, 
	-1, -1, 115, 115, -1, -1, 115, 115, 
	115, -1, 115, 115, -1, -1, 115, -1, 
	-1, -1, -1, -1, -1, -1, -1, 115, 
	115, 115, 115, 115, 115, 115, -1, -1, 
	-1, 115, 115, 115, -1, -1, 115, 115, 
	-1, 115, 115, 115, 115, 115, -1, 115, 
	115, 115, -1, -1, -1, 115, 115, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 115, 115, 115, -1, -1, 115, -1, 
	-1, -1, -1, 115, -1, 115, 115, 115, 
	115, -1, 115, 115, 115, 115, 115, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 115, -1, 115, -1, -1, 115, -1, 
	115, 115, -1, -1, -1, 115, -1, 115, 
	-1, 115, 116, 116, 116, 116, 116, 116, 
	116, 116, 116, 116, 116, 116, 116, 116, 
	116, 116, 116, 116, 116, 116, 116, 116, 
	116, 116, 116, 116, -1, 116, 116, 116, 
	116, 116, -1, 116, -1, 116, 116, 116, 
	116, -1, 116, -1, 116, 116, 116, -1, 
	116, 116, 116, 116, 116, 116, 116, 116, 
	116, 116, 116, 116, 116, -1, 116, 116, 
	116, 116, 116, 116, 116, 116, 116, 116, 
	116, 116, 116, 116, 116, -1, 116, -1, 
	-1, -1, -1, 116, 116, 116, 116, 116, 
	-1, -1, 116, 116, 116, 116, 116, 116, 
	116, 116, 116, 116, 116, 116, 116, 116, 
	116, 116, -1, -1, -1, -1, -1, 116, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 115, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 116, 116, 
	116, 116, -1, -1, 116, 116, 116, 116, 
	116, 116, -1, -1, -1, -1, 116, 116, 
	116, 116, 116, 116, 116, -1, -1, -1, 
	-1, 116, -1, -1, -1, -1, 116, 116, 
	-1, -1, 116, 116, 116, -1, 116, 116, 
	-1, -1, 116, -1, -1, -1, -1, -1, 
	-1, -1, -1, 116, 116, 116, 116, 116, 
	116, 116, -1, -1, -1, 116, 116, 116, 
	-1, -1, 116, 116, -1, 116, 116, 116, 
	116, 116, -1, 116, 116, 116, -1, -1, 
	-1, 116, 116, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 116, 116, 116, 
	-1, -1, 116, -1, -1, -1, -1, 116, 
	-1, 116, 116, 116, 116, -1, 116, 116, 
	116, 116, 116, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 116, -1, 116, 
	-1, -1, 116, -1, 116, 116, -1, -1, 
	-1, 116, -1, 116, -1, 116, 117, 117, 
	117, 117, 117, 117, 117, 117, 117, 117, 
	117, 117, 117, 117, 117, 117, 117, 117, 
	117, 117, 117, 117, 117, 117, 117, 117, 
	-1, 117, 117, 117, 117, 117, -1, 117, 
	-1, 117, 117, 117, 117, -1, 117, -1, 
	117, 117, 117, -1, 117, 117, 117, 117, 
	117, 117, 117, 117, 117, 117, 117, 117, 
	117, -1, 117, 117, 117, 117, 117, 117, 
	117, 117, 117, 117, 117, 117, 117, 117, 
	117, -1, 117, -1, -1, -1, -1, 117, 
	117, 117, 117, 117, -1, -1, 117, 117, 
	117, 117, 117, 117, 117, 117, 117, 117, 
	117, 117, 117, 117, 117, 117, -1, -1, 
	-1, -1, -1, 117, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	116, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 117, 117, 117, 117, -1, -1, 
	117, 117, 117, 117, 117, 117, -1, -1, 
	-1, -1, 117, 117, 117, 117, 117, 117, 
	117, -1, -1, -1, -1, 117, -1, -1, 
	-1, -1, 117, 117, -1, -1, 117, 117, 
	117, -1, 117, 117, -1, -1, 117, -1, 
	-1, -1, -1, -1, -1, -1, -1, 117, 
	117, 117, 117, 117, 117, 117, -1, -1, 
	-1, 117, 117, 117, -1, -1, 117, 117, 
	-1, 117, 117, 117, 117, 117, -1, 117, 
	117, 117, -1, -1, -1, 117, 117, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 117, 117, 117, -1, -1, 117, -1, 
	-1, -1, -1, 117, -1, 117, 117, 117, 
	117, -1, 117, 117, 117, 117, 117, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 117, -1, 117, -1, -1, 117, -1, 
	117, 117, -1, -1, -1, 117, -1, 117, 
	-1, 117, 118, 118, 118, 118, 118, 118, 
	118, -1, 118, 118, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 118, 118, 118, 
	118, 118, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 118, -1, -1, -1, 
	118, -1, -1, -1, 118, 118, 118, 118, 
	118, 118, -1, -1, -1, -1, 118, 118, 
	118, -1, -1, -1, -1, 118, 118, -1, 
	118, 118, 118, 118, -1, -1, -1, -1, 
	-1, -1, -1, 118, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 118, 118, 118, -1, 118, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 119, 
	119, 119, 119, 119, 119, 119, 119, 119, 
	119, 119, 119, 119, 119, 119, 119, 119, 
	119, 119, 119, 119, 119, 119, 119, 119, 
	119, -1, 119, 119, 119, 119, 119, -1, 
	119, -1, 119, 119, 119, 119, -1, 119, 
	-1, 119, 119, 119, 117, 119, 119, 119, 
	119, 119, 119, 119, 119, 119, 119, 119, 
	119, 119, -1, 119, 119, 119, 119, 119, 
	119, 119, 119, 119, 119, 119, 119, 119, 
	119, 119, -1, 119, -1, -1, -1, -1, 
	119, 119, 119, 119, 119, -1, -1, 119, 
	119, 119, 119, 119, 119, 119, 119, 119, 
	119, 119, 119, 119, 119, 119, 119, -1, 
	-1, -1, -1, -1, 119, -1, -1, -1, 
	-1, -1, -1, -1, -1, 118, 118, 118, 
	118, 118, -1, 118, 118, 118, -1, -1, 
	-1, -1, 118, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 118, 118, 
	118, 118, 118, -1, -1, -1, -1, -1, 
	-1, -1, -1, 119, 119, 119, 119, -1, 
	-1, 119, 119, 119, 119, 119, 119, -1, 
	-1, -1, -1, 119, 119, 119, 119, 119, 
	119, 119, -1, -1, -1, -1, 119, -1, 
	-1, -1, -1, 119, 119, -1, -1, 119, 
	119, 119, -1, 119, 119, -1, -1, 119, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	119, 119, 119, 119, 119, 119, 119, -1, 
	-1, -1, 119, 119, 119, -1, -1, 119, 
	119, -1, 119, 119, 119, 119, 119, -1, 
	119, 119, 119, -1, -1, -1, 119, 119, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 119, 119, 119, -1, -1, 119, 
	-1, -1, -1, -1, 119, -1, 119, 119, 
	119, 119, -1, 119, 119, 119, 119, 119, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 119, -1, 119, -1, -1, 119, 
	-1, 119, 119, -1, -1, -1, 119, -1, 
	119, -1, 119, 123, 123, 123, 123, 123, 
	123, 123, 123, 123, 123, 123, 123, 123, 
	123, 123, 123, 123, 123, 123, 123, 123, 
	123, 123, 123, 123, 123, -1, 123, 123, 
	123, 123, 123, -1, 123, -1, 123, 123, 
	123, 123, -1, 123, -1, 123, 123, 123, 
	-1, 123, 123, 123, 123, 123, 123, 123, 
	123, 123, 123, 123, 123, 123, -1, 123, 
	123, 123, 123, 123, 123, 123, 123, 123, 
	123, 123, 123, 123, 123, 123, -1, 123, 
	-1, -1, -1, -1, 123, 123, 123, 123, 
	123, -1, -1, 123, 123, 123, 123, 123, 
	123, 123, 123, 123, 123, 123, 123, 123, 
	123, 123, 123, -1, -1, -1, -1, -1, 
	123, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 119, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 123, 
	123, 123, 123, -1, -1, 123, 123, 123, 
	123, 123, 123, -1, -1, -1, -1, 123, 
	123, 123, 123, 123, 123, 123, -1, -1, 
	-1, -1, 123, -1, -1, -1, -1, 123, 
	123, -1, -1, 123, 123, 123, -1, 123, 
	123, -1, -1, 123, -1, -1, -1, -1, 
	-1, -1, -1, -1, 123, 123, 123, 123, 
	123, 123, 123, -1, -1, -1, 123, 123, 
	123, -1, -1, 123, 123, -1, 123, 123, 
	123, 123, 123, -1, 123, 123, 123, -1, 
	-1, -1, 123, 123, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 123, 123, 
	123, -1, -1, 123, -1, -1, -1, -1, 
	123, -1, 123, 123, 123, 123, -1, 123, 
	123, 123, 123, 123, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 123, -1, 
	123, -1, -1, 123, -1, 123, 123, -1, 
	-1, -1, 123, -1, 123, -1, 123, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 140, 
	140, 140, 140, 140, 140, 140, 140, 140, 
	-1, 140, 140, -1, -1, 140, 140, 140, 
	140, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 140, 140, 140, 
	-1, -1, -1, 140, -1, -1, -1, -1, 
	140, -1, -1, -1, -1, -1, 140, 140, 
	-1, 118, 118, 118, 118, 118, -1, 118, 
	118, 118, -1, -1, 140, -1, 118, 140, 
	140, 140, 140, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 140, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 118, 118, 118, 118, -1, 140, 
	140, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 123, 125, 125, 125, 125, 125, 125, 
	125, 125, 125, 125, 125, 125, 125, 125, 
	125, 125, 125, 125, 125, 125, 125, 125, 
	125, 125, 125, 125, -1, 125, 125, 125, 
	125, 125, -1, 125, -1, 125, 125, 125, 
	125, -1, 125, -1, 125, 125, 125, -1, 
	125, 125, 125, 125, 125, 125, 125, 125, 
	125, 125, 125, 125, 125, -1, 125, 125, 
	125, 125, 125, 125, 125, 125, 125, 125, 
	125, 125, 125, 125, 125, -1, 125, -1, 
	-1, -1, -1, 125, 125, 125, 125, 125, 
	-1, -1, 125, 125, 125, 125, 125, 125, 
	125, 125, 125, 125, 125, 125, 125, 125, 
	125, 125, -1, -1, -1, 140, -1, 125, 
	-1, -1, -1, -1, 140, -1, -1, -1, 
	-1, 140, 140, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 140, -1, -1, -1, 
	-1, 140, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	140, 140, 140, -1, -1, -1, -1, -1, 
	140, 140, -1, -1, -1, -1, 125, 125, 
	125, 125, -1, -1, 125, 125, 125, 125, 
	125, 125, -1, -1, -1, -1, 125, 125, 
	125, 125, 125, 125, 125, -1, -1, -1, 
	-1, 125, -1, -1, -1, -1, 125, 125, 
	-1, -1, 125, 125, 125, -1, 125, 125, 
	-1, -1, 125, -1, -1, -1, -1, -1, 
	-1, -1, -1, 125, 125, 125, 125, 125, 
	125, 125, -1, -1, -1, 125, 125, 125, 
	-1, -1, 125, 125, -1, 125, 125, 125, 
	125, 125, -1, 125, 125, 125, -1, -1, 
	-1, 125, 125, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 125, 125, 125, 
	-1, -1, 125, -1, -1, -1, -1, 125, 
	-1, 125, 125, 125, 125, -1, 125, 125, 
	125, 125, 125, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 125, -1, 125, 
	-1, -1, 125, -1, 125, 125, -1, -1, 
	-1, 125, -1, 125, -1, 125, 126, 126, 
	126, 126, 126, 126, 126, 126, 126, 126, 
	126, 126, 126, 126, 126, 126, 126, 126, 
	126, 126, 126, 126, 126, 126, 126, 126, 
	126, 126, 126, 126, 126, 126, -1, 126, 
	-1, 126, 126, 126, 126, 126, 126, -1, 
	126, 126, 126, -1, -1, 126, 126, 126, 
	126, 126, 126, 126, 126, -1, 126, 126, 
	126, 126, -1, -1, -1, 126, 126, 126, 
	126, 126, -1, -1, 126, 126, 126, 126, 
	-1, -1, -1, 126, -1, -1, -1, 126, 
	126, -1, 126, -1, -1, 126, -1, -1, 
	126, -1, 126, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 126, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 126, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	125, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 126, 126, 126, 126, -1, -1, 
	126, 126, 126, 126, 126, 126, -1, -1, 
	-1, -1, 126, 126, 126, 126, 126, 126, 
	126, -1, -1, 126, -1, 126, -1, -1, 
	-1, -1, 126, 126, -1, 126, 126, 126, 
	126, -1, 126, 126, -1, -1, 126, -1, 
	-1, -1, -1, -1, 126, -1, 126, 126, 
	126, 126, 126, 126, 126, 126, -1, -1, 
	-1, -1, 126, 126, -1, 126, 126, 126, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	126, 126, -1, -1, 126, -1, 126, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	126, 126, 126, -1, -1, 126, 126, 126, 
	-1, -1, -1, -1, -1, 126, 126, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 126, -1, 126, -1, -1, 126, 126, 
	126, 127, 127, 127, 127, 127, 127, 127, 
	127, 127, 127, 127, 127, 127, 127, 127, 
	127, 127, 127, 127, 127, 127, 127, 127, 
	127, 127, 127, 127, 127, 127, 127, 127, 
	127, -1, 127, -1, 127, 127, 127, 127, 
	127, 127, -1, 127, 127, 127, -1, -1, 
	127, 127, 127, 127, 127, 127, 127, 127, 
	-1, 127, 127, 127, 127, -1, -1, -1, 
	127, 127, 127, 127, 127, -1, -1, 127, 
	127, 127, 127, -1, -1, -1, 127, -1, 
	-1, -1, 127, 127, -1, 127, -1, -1, 
	127, -1, -1, 127, -1, 127, -1, -1, 
	-1, 140, -1, -1, -1, -1, -1, -1, 
	140, -1, -1, -1, -1, 140, 140, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	140, -1, -1, -1, -1, 140, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 127, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 127, -1, -1, 140, 140, 140, -1, 
	-1, -1, -1, -1, 140, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 126, 127, 127, 127, 
	127, -1, -1, 127, 127, 127, 127, 127, 
	127, -1, -1, -1, -1, 127, 127, 127, 
	127, 127, 127, 127, -1, -1, 127, -1, 
	127, -1, -1, -1, -1, 127, 127, -1, 
	127, 127, 127, 127, -1, 127, 127, -1, 
	-1, 127, -1, -1, -1, -1, -1, 127, 
	-1, 127, 127, 127, 127, 127, 127, 127, 
	127, -1, -1, -1, -1, 127, 127, -1, 
	127, 127, 127, -1, -1, -1, -1, -1, 
	-1, -1, -1, 127, 127, -1, -1, 127, 
	-1, 127, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 127, 127, 127, -1, -1, 
	127, 127, 127, -1, -1, -1, -1, -1, 
	127, 127, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 127, -1, 127, -1, 
	-1, 127, 127, 127, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, -1, 128, -1, 128, 
	128, 128, 128, 128, 128, -1, 128, 128, 
	128, -1, -1, 128, 128, 128, 128, 128, 
	128, 128, 128, -1, 128, 128, 128, 128, 
	-1, -1, -1, 128, 128, 128, 128, 128, 
	-1, -1, 128, 128, 128, 128, -1, -1, 
	-1, 128, -1, -1, -1, 128, 128, -1, 
	128, -1, -1, 128, -1, -1, 128, -1, 
	128, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 128, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 128, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 127, 
	128, 128, 128, 128, -1, -1, 128, 128, 
	128, 128, 128, 128, -1, -1, -1, -1, 
	128, 128, 128, 128, 128, 128, 128, -1, 
	-1, 128, -1, 128, -1, -1, -1, -1, 
	128, 128, -1, 128, 128, 128, 128, -1, 
	128, 128, -1, -1, 128, -1, -1, -1, 
	-1, -1, 128, -1, 128, 128, 128, 128, 
	128, 128, 128, 128, -1, -1, -1, -1, 
	128, 128, -1, 128, 128, 128, -1, -1, 
	-1, -1, -1, -1, -1, -1, 128, 128, 
	-1, -1, 128, -1, 128, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 128, 128, 
	128, -1, -1, 128, 128, 128, -1, -1, 
	-1, -1, -1, 128, 128, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 128, 
	-1, 128, -1, -1, 128, 128, 128, 134, 
	134, 134, 134, 134, 134, 134, 134, 134, 
	134, 134, 134, 134, 134, 134, 134, 134, 
	134, 134, 134, 134, 134, 134, 134, 134, 
	134, -1, 134, 134, 134, 134, 134, -1, 
	134, -1, 134, 134, 134, 134, -1, 134, 
	-1, 134, 134, 134, -1, 134, 134, 134, 
	134, 134, 134, 134, 134, 134, 134, 134, 
	134, 134, -1, 134, 134, 134, 134, 134, 
	134, 134, 134, 134, 134, 134, 134, 134, 
	134, 134, -1, 134, -1, -1, -1, -1, 
	134, 134, 134, 134, 134, -1, -1, 134, 
	134, 134, 134, 134, 134, 134, 134, 134, 
	134, 134, 134, 134, 134, 134, 134, -1, 
	-1, -1, -1, -1, 134, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 128, 134, 134, 134, 134, -1, 
	-1, 134, 134, 134, 134, 134, 134, -1, 
	-1, -1, -1, 134, 134, 134, 134, 134, 
	134, 134, -1, -1, -1, -1, 134, -1, 
	-1, -1, -1, 134, 134, -1, -1, 134, 
	134, 134, -1, 134, 134, -1, -1, 134, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	134, 134, 134, 134, 134, 134, 134, -1, 
	-1, -1, 134, 134, 134, -1, -1, 134, 
	134, -1, 134, 134, 134, 134, 134, -1, 
	134, 134, 134, -1, -1, -1, 134, 134, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 134, 134, 134, -1, -1, 134, 
	-1, -1, -1, -1, 134, -1, 134, 134, 
	134, 134, -1, 134, 134, 134, 134, 134, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 134, -1, 134, -1, -1, 134, 
	-1, 134, 134, -1, -1, -1, 134, -1, 
	134, -1, 134, 138, 138, 138, 138, 138, 
	138, 138, -1, 138, 138, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 138, 138, 
	138, 138, 138, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 138, -1, -1, 
	-1, 138, -1, -1, -1, 138, 138, 138, 
	138, 138, 138, -1, -1, -1, -1, 138, 
	138, 138, -1, -1, -1, -1, 138, 138, 
	-1, 138, 138, 138, 138, 138, -1, -1, 
	-1, -1, -1, -1, 138, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 138, 138, 138, 138, 138, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 139, 
	139, 139, 139, 139, 139, 139, 139, 139, 
	139, 139, 139, 139, 139, 139, 139, 139, 
	139, 139, 139, 139, 139, 139, 139, 139, 
	139, -1, 139, 139, 139, 139, 139, -1, 
	139, -1, 139, 139, 139, 139, -1, 139, 
	-1, 139, 139, 139, -1, 134, 139, 139, 
	139, 139, 139, 139, 139, 139, -1, 139, 
	139, 139, -1, -1, -1, -1, 139, 139, 
	139, 139, 139, -1, -1, 139, 139, 139, 
	139, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 139, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 138, 138, 
	138, 138, 138, -1, 138, 138, 138, -1, 
	-1, -1, -1, 138, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 138, 138, 
	138, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 138, -1, 138, 
	138, 138, 138, 138, -1, -1, -1, -1, 
	-1, -1, -1, 139, 139, 139, 139, -1, 
	-1, 139, 139, -1, 139, 139, 139, -1, 
	-1, -1, -1, 139, 139, 139, 138, 139, 
	139, 139, -1, -1, -1, -1, 139, -1, 
	-1, -1, -1, 139, -1, -1, -1, 139, 
	139, 139, -1, 139, 139, -1, -1, 139, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	139, 139, 139, 139, 139, 139, 139, -1, 
	-1, -1, -1, 139, 139, -1, -1, 139, 
	139, -1, -1, -1, -1, -1, -1, -1, 
	-1, 139, 139, -1, -1, -1, -1, 139, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 139, 139, 
	139, -1, -1, -1, -1, -1, 139, 139, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 139, -1, -1, -1, -1, -1, 
	-1, 139, 142, 142, 142, 142, 142, 142, 
	142, 142, 142, 142, 142, 142, 142, 142, 
	142, -1, 142, 142, 142, 142, 142, 142, 
	142, 142, -1, -1, -1, 142, 142, 142, 
	142, 142, -1, 142, -1, 142, 142, 142, 
	142, -1, 142, -1, 142, 142, 142, -1, 
	-1, 142, -1, -1, 142, 142, 142, 142, 
	142, -1, 142, 142, 142, -1, -1, -1, 
	-1, 142, 142, 142, 142, 142, -1, -1, 
	142, 142, 142, 142, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 142, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 139, 142, 142, 
	142, 142, -1, -1, 142, 142, 142, 142, 
	142, 142, -1, -1, -1, -1, 142, 142, 
	142, 142, 142, 142, 142, -1, -1, -1, 
	-1, 142, -1, -1, -1, -1, 142, -1, 
	-1, -1, 142, 142, 142, -1, 142, 142, 
	-1, -1, 142, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 142, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 142, 142, 142, -1, -1, -1, -1, 
	-1, -1, -1, -1, 142, 142, -1, -1, 
	-1, -1, 142, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 142, 142, 142, -1, -1, -1, -1, 
	-1, 142, 142, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 142, -1, 142, 
	-1, -1, -1, -1, -1, -1, -1, 143, 
	143, 143, 143, 143, 143, 143, 143, 143, 
	143, 143, 143, 143, 143, 143, 143, 143, 
	143, 143, 143, 143, 143, 143, 143, 143, 
	143, -1, 143, 143, 143, 143, 143, -1, 
	143, -1, 143, 143, 143, 143, -1, 143, 
	-1, 143, 143, 143, -1, -1, 143, 143, 
	143, 143, 143, 143, 143, 143, -1, 143, 
	143, 143, -1, -1, -1, -1, 143, 143, 
	143, 143, 143, -1, -1, 143, 143, 143, 
	143, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 143, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 143, 143, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 138, 138, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 138, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	142, -1, -1, 143, 143, 143, 143, -1, 
	-1, 143, 143, -1, 143, 143, 143, -1, 
	-1, -1, 138, 143, 143, 143, -1, 143, 
	143, 143, -1, -1, -1, -1, 143, -1, 
	-1, -1, -1, 143, -1, -1, -1, 143, 
	143, 143, -1, 143, 143, -1, -1, 143, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	143, 143, 143, 143, 143, 143, 143, -1, 
	-1, -1, -1, 143, 143, -1, -1, 143, 
	143, -1, -1, -1, -1, -1, -1, -1, 
	-1, 143, 143, -1, -1, -1, -1, 143, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 143, 143, 
	143, -1, -1, -1, -1, -1, 143, 143, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 143, -1, -1, -1, -1, -1, 
	-1, 143, -1, -1, 146, 146, 146, 146, 
	146, 146, 146, 146, 146, 146, 146, 146, 
	-1, -1, 146, 146, 146, 146, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 146, 146, 146, -1, -1, -1, 
	146, -1, -1, -1, -1, 146, -1, -1, 
	-1, -1, -1, 146, 146, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 146, -1, -1, 146, 146, 146, 146, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 146, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 147, 147, 
	147, 147, 147, 147, 147, 147, 147, 147, 
	147, 147, 147, 147, 147, -1, 147, 147, 
	147, 147, 147, 147, 147, 147, -1, -1, 
	-1, 147, 147, 147, 147, 147, -1, 147, 
	-1, 147, 147, 147, 147, -1, 147, -1, 
	147, 147, 147, -1, -1, 147, -1, -1, 
	147, 147, 147, 147, 147, 143, 147, 147, 
	147, -1, -1, -1, -1, 147, 147, 147, 
	147, 147, -1, -1, 147, 147, 147, 147, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 147, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 146, -1, -1, -1, -1, -1, 
	-1, -1, 146, 146, 146, 142, 146, 146, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 146, -1, -1, -1, -1, 146, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 146, 146, 146, 
	-1, -1, -1, -1, -1, 146, 146, -1, 
	-1, -1, 147, 147, 147, 147, -1, -1, 
	147, 147, -1, 147, 147, 147, -1, -1, 
	146, -1, 147, 147, 147, -1, 147, 147, 
	147, -1, -1, -1, -1, 147, -1, -1, 
	-1, -1, 147, 147, -1, -1, 147, 147, 
	147, -1, 147, 147, -1, -1, 147, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 147, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 147, 147, 147, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	147, 147, -1, -1, -1, -1, 147, -1, 
	-1, -1, -1, -1, -1, 149, 149, 149, 
	149, 149, 149, 149, -1, 149, 149, -1, 
	-1, -1, -1, -1, -1, 147, 147, 147, 
	149, 149, 149, 149, 149, 147, 147, -1, 
	-1, -1, -1, -1, -1, -1, -1, 149, 
	-1, 147, -1, 149, -1, -1, 147, 149, 
	149, 149, 149, 149, 149, -1, -1, -1, 
	-1, 149, 149, 149, -1, -1, -1, -1, 
	149, 149, -1, 149, 149, 149, 149, -1, 
	-1, -1, -1, -1, -1, -1, 149, 149, 
	150, 150, 150, 150, 150, 150, 150, -1, 
	150, 150, -1, -1, 149, 149, 149, -1, 
	149, -1, -1, 150, 150, 150, 150, 150, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 150, -1, -1, -1, 150, -1, 
	-1, -1, 150, 150, 150, 150, 150, 150, 
	-1, -1, -1, -1, 150, 150, 150, -1, 
	-1, -1, -1, 150, 150, -1, 150, 150, 
	150, 150, -1, -1, -1, -1, -1, -1, 
	-1, 150, 150, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 150, 
	150, 150, -1, 150, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 147, -1, -1, -1, 
	-1, -1, -1, -1, -1, 149, 149, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	149, 149, 149, 149, 149, -1, 149, 149, 
	149, -1, -1, -1, -1, 149, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 149, 149, 149, 149, 149, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	150, 150, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 150, 150, 150, 150, 150, 
	-1, 150, 150, 150, -1, -1, -1, -1, 
	150, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 150, 150, 150, 150, 
	150, -1, -1, -1, -1, -1, -1, -1, 
	-1, 151, 151, 151, 151, 151, 151, 151, 
	151, 151, 151, 151, 151, 151, 151, 151, 
	-1, 151, 151, 151, 151, 151, 151, 151, 
	151, -1, -1, -1, 151, 151, 151, 151, 
	151, -1, 151, -1, 151, 151, 151, 151, 
	-1, 151, -1, 151, 151, 151, -1, -1, 
	151, -1, -1, 151, 151, 151, 151, 151, 
	-1, 151, 151, 151, 151, -1, -1, -1, 
	151, 151, 151, 151, 151, -1, 151, 151, 
	151, 151, 151, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 326, 326, 326, 
	326, 326, 326, -1, -1, -1, 146, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	146, -1, 146, 146, -1, -1, -1, -1, 
	326, 326, 326, 326, 326, 146, 326, -1, 
	326, -1, 146, -1, -1, 326, -1, -1, 
	326, -1, -1, -1, -1, -1, -1, 326, 
	326, 326, -1, -1, -1, 326, 326, 326, 
	-1, 146, 146, 146, 326, 326, 326, -1, 
	326, 146, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 146, 151, 151, 151, 
	151, -1, -1, 151, 151, 151, 151, 151, 
	151, -1, -1, -1, -1, 151, 151, 151, 
	151, 151, 151, 151, -1, 151, 151, -1, 
	151, -1, -1, -1, -1, 151, 151, -1, 
	-1, 151, 151, 151, -1, 151, 151, -1, 
	-1, 151, -1, -1, -1, -1, -1, -1, 
	-1, 147, -1, -1, -1, 151, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 151, 151, -1, -1, -1, -1, -1, 
	-1, -1, -1, 151, 151, -1, -1, -1, 
	-1, 151, -1, 326, 326, -1, -1, 326, 
	326, 326, 326, -1, 326, -1, -1, -1, 
	-1, 326, 326, 326, 326, 326, 326, 326, 
	151, 151, 151, -1, -1, -1, -1, -1, 
	151, 151, -1, -1, -1, 326, 326, 326, 
	-1, 326, 326, -1, 151, 326, 151, -1, 
	-1, 151, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 326, -1, 216, 
	216, 216, 216, 216, 216, -1, -1, 326, 
	326, -1, -1, -1, -1, -1, -1, -1, 
	-1, 216, -1, -1, -1, -1, -1, -1, 
	-1, -1, 216, 216, 216, 216, 216, -1, 
	216, -1, 216, -1, -1, -1, -1, 216, 
	-1, -1, 216, 216, -1, -1, -1, -1, 
	-1, 216, 216, 216, -1, -1, -1, 216, 
	216, 216, 326, -1, -1, -1, 216, 216, 
	216, 216, 216, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 149, 149, -1, -1, -1, -1, 151, 
	-1, -1, -1, -1, 149, 149, 149, 149, 
	149, -1, 149, 149, 149, -1, -1, -1, 
	-1, 149, -1, -1, 216, 216, 216, -1, 
	-1, 216, 216, -1, -1, 216, 216, -1, 
	-1, -1, -1, 216, 216, 216, -1, 216, 
	216, 216, -1, -1, -1, 149, 149, 149, 
	149, -1, -1, 216, 216, -1, -1, 216, 
	216, 216, -1, 216, 216, -1, -1, 216, 
	-1, -1, -1, -1, 150, 150, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 150, 
	150, 150, 150, 150, -1, 150, 150, 150, 
	-1, -1, -1, -1, 150, -1, -1, -1, 
	-1, 216, 216, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	150, 150, 150, 150, -1, -1, -1, 152, 
	152, 152, 152, 152, 152, 152, 152, 152, 
	152, 152, 152, 152, 152, 152, -1, 152, 
	152, 152, 152, 152, 152, 152, 152, 216, 
	-1, -1, 152, 152, 152, 152, 152, -1, 
	152, -1, 152, 152, 152, 152, -1, 152, 
	-1, 152, 152, 152, -1, -1, 152, -1, 
	-1, 152, 152, 152, 152, 152, -1, 152, 
	152, 152, 152, -1, -1, -1, 152, 152, 
	152, 152, 152, -1, 152, 152, 152, 152, 
	152, -1, 160, 160, 160, 160, 160, 160, 
	160, -1, 160, 160, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 160, 160, 160, 
	160, 160, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 160, -1, -1, -1, 
	160, -1, -1, -1, 160, 160, 160, 160, 
	160, 160, -1, -1, -1, -1, 160, 160, 
	160, -1, -1, -1, -1, 160, 160, -1, 
	160, 160, 160, 160, -1, -1, -1, -1, 
	-1, -1, -1, 160, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 160, 160, 160, 160, 160, -1, -1, 
	-1, -1, -1, 152, 152, 152, 152, 160, 
	-1, 152, 152, 152, 152, 152, 152, -1, 
	-1, -1, -1, 152, 152, 152, 152, 152, 
	152, 152, -1, 152, 152, -1, 152, -1, 
	-1, 151, 151, 152, 152, -1, -1, 152, 
	152, 152, -1, 152, 152, -1, -1, 152, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 152, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 152, 
	152, -1, -1, -1, -1, -1, -1, -1, 
	-1, 152, 152, -1, -1, -1, -1, 152, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 152, 152, 
	152, -1, -1, -1, -1, -1, 152, 152, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 152, -1, 152, -1, -1, 152, 
	-1, -1, -1, -1, -1, 160, 160, 160, 
	160, 160, -1, 160, 160, 160, -1, -1, 
	-1, -1, 160, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 160, 160, 160, 
	-1, -1, -1, -1, -1, -1, -1, 160, 
	-1, -1, -1, -1, -1, -1, 160, 160, 
	160, 160, 160, 166, 166, 166, 166, 166, 
	166, 166, -1, 166, 166, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 166, 166, 
	166, 166, 166, 160, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 166, -1, -1, 
	-1, 166, -1, -1, -1, 166, 166, 166, 
	166, 166, 166, -1, -1, -1, -1, 166, 
	166, 166, -1, -1, -1, -1, 166, 166, 
	-1, 166, 166, 166, 166, 166, -1, -1, 
	-1, -1, -1, -1, 166, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 166, 166, 166, 166, 166, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	166, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 152, -1, -1, 
	-1, -1, -1, 170, 170, 170, 170, 170, 
	170, 170, 170, 170, 170, 170, 170, 170, 
	170, 170, -1, 170, 170, 170, 170, 170, 
	170, 170, 170, -1, -1, -1, 170, 170, 
	170, 170, 170, -1, 170, -1, 170, 170, 
	170, 170, -1, 170, -1, 170, 170, 170, 
	-1, -1, 170, -1, -1, 170, 170, 170, 
	170, 170, -1, 170, 170, 170, -1, -1, 
	-1, -1, 170, 170, 170, 170, 170, -1, 
	-1, 170, 170, 170, 170, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 170, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 166, 166, 
	166, 166, 166, -1, 166, 166, 166, -1, 
	-1, -1, -1, 166, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 166, 166, 
	166, -1, -1, -1, -1, -1, -1, -1, 
	166, -1, -1, -1, -1, -1, -1, 166, 
	166, 166, 166, 166, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 170, 
	170, 170, 170, -1, 166, 170, 170, 170, 
	170, 170, 170, -1, -1, -1, -1, 170, 
	170, 170, 170, 170, 170, 170, -1, -1, 
	-1, -1, 170, -1, -1, -1, -1, 170, 
	170, -1, -1, 170, 170, 170, -1, 170, 
	170, -1, -1, 170, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 170, 
	-1, -1, -1, -1, 175, 175, 175, 175, 
	175, 175, -1, 170, 170, -1, -1, -1, 
	-1, -1, -1, -1, -1, 170, 170, -1, 
	-1, -1, -1, 170, -1, -1, -1, 175, 
	175, 175, 175, 175, -1, 175, -1, 175, 
	-1, -1, -1, -1, 175, -1, -1, 175, 
	-1, -1, 170, 170, 170, -1, 175, 175, 
	175, -1, 170, 170, 175, 175, 175, -1, 
	-1, -1, -1, 175, 175, 175, 170, 175, 
	170, -1, -1, 170, -1, -1, 171, 171, 
	171, 171, 171, 171, 171, 171, 171, 171, 
	171, 171, 171, 171, 171, -1, 171, 171, 
	171, 171, 171, 171, 171, 171, -1, -1, 
	-1, 171, 171, 171, 171, 171, -1, 171, 
	-1, 171, 171, 171, 171, -1, 171, -1, 
	171, 171, 171, -1, -1, 171, -1, -1, 
	171, 171, 171, 171, 171, -1, 171, 171, 
	171, -1, -1, -1, -1, 171, 171, 171, 
	171, 171, -1, -1, 171, 171, 171, 171, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	171, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 175, 175, -1, -1, 175, 175, 
	175, 175, -1, 175, -1, -1, -1, -1, 
	175, 175, 175, 175, 175, 175, 175, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 175, 175, 175, -1, 
	175, 175, -1, -1, 175, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 160, 160, -1, -1, -1, -1, 
	-1, -1, -1, 160, 175, -1, -1, -1, 
	-1, 170, 171, 171, 171, 171, 175, 175, 
	171, 171, 171, 171, 171, 171, -1, -1, 
	-1, -1, 171, 171, 171, 171, 171, 171, 
	171, -1, -1, -1, -1, 171, -1, 160, 
	-1, -1, 171, 171, -1, -1, 171, 171, 
	171, -1, 171, 171, -1, -1, 171, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 175, 171, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 171, 171, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	171, 171, -1, -1, -1, -1, 171, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 171, 171, 171, 
	-1, -1, -1, -1, -1, 171, 171, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 171, -1, 171, -1, -1, 171, -1, 
	-1, -1, -1, -1, -1, 176, 176, 176, 
	176, 176, 176, 176, 176, 176, 176, 176, 
	176, 176, 176, 176, 176, 176, 176, 176, 
	176, 176, 176, 176, 176, 176, 176, -1, 
	176, 176, 176, 176, 176, -1, 176, -1, 
	176, 176, 176, 176, -1, 176, -1, 176, 
	176, 176, -1, -1, 176, 176, 176, 176, 
	176, 176, 176, 176, -1, 176, 176, 176, 
	-1, -1, -1, -1, 176, 176, 176, 176, 
	176, -1, -1, 176, 176, 176, 176, -1, 
	-1, -1, 177, 177, 177, 177, 177, 177, 
	177, 176, 177, 177, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 177, 177, 177, 
	177, 177, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 177, -1, -1, -1, 
	177, -1, -1, -1, 177, 177, 177, 177, 
	177, 177, -1, 166, 166, -1, 177, 177, 
	177, -1, -1, -1, 166, 177, 177, -1, 
	177, 177, 177, 177, -1, -1, -1, -1, 
	-1, -1, -1, 177, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 177, 177, 177, 171, 177, -1, -1, 
	166, 176, 176, 176, 176, -1, -1, 176, 
	176, -1, 176, 176, 176, -1, -1, -1, 
	-1, 176, 176, 176, -1, 176, 176, 176, 
	-1, -1, -1, -1, 176, -1, -1, -1, 
	-1, 176, -1, -1, -1, 176, 176, 176, 
	-1, 176, 176, -1, -1, 176, -1, -1, 
	-1, -1, -1, -1, -1, -1, 176, 176, 
	176, 176, 176, 176, 176, -1, -1, -1, 
	-1, 176, 176, -1, -1, 176, 176, -1, 
	-1, -1, -1, -1, -1, -1, -1, 176, 
	176, -1, -1, -1, -1, 176, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 176, 176, 176, -1, 
	-1, -1, -1, -1, 176, 176, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	176, -1, -1, -1, -1, -1, -1, 176, 
	-1, -1, -1, -1, -1, 177, 177, 177, 
	177, 177, -1, 177, 177, 177, -1, -1, 
	-1, -1, 177, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 177, 177, 
	177, 177, 177, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 175, 175, 
	-1, -1, 175, 175, 175, 175, -1, 175, 
	-1, -1, -1, -1, 175, 175, 175, 175, 
	175, 175, 175, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	175, 175, 175, -1, 175, 175, -1, -1, 
	175, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	175, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 176, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 180, 180, 180, 180, 180, 
	180, 180, 180, 180, 180, 180, 180, 180, 
	180, 180, 180, 180, 180, 180, 180, 180, 
	180, 180, 180, 180, 180, -1, 180, 180, 
	180, 180, 180, -1, 180, 175, 180, 180, 
	180, 180, -1, 180, -1, 180, 180, 180, 
	180, 180, 180, 180, 180, 180, 180, 180, 
	180, 180, 180, 180, 180, 180, -1, 180, 
	180, 180, 180, 180, 180, 180, 180, 180, 
	180, 180, 180, 180, 180, 180, -1, 180, 
	-1, -1, 180, -1, 180, 180, 180, 180, 
	180, -1, -1, 180, 180, 180, 180, 180, 
	180, 180, 180, 180, 180, 180, 180, 180, 
	180, 180, 180, -1, -1, -1, -1, -1, 
	180, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 180, 
	180, 180, 180, -1, -1, 180, 180, 180, 
	180, 180, 180, -1, -1, -1, -1, 180, 
	180, 180, 180, 180, 180, 180, -1, -1, 
	-1, -1, 180, -1, -1, -1, -1, 180, 
	180, -1, -1, 180, 180, 180, -1, 180, 
	180, -1, -1, 180, -1, -1, -1, -1, 
	-1, -1, -1, -1, 180, 180, 180, 180, 
	180, 180, 180, -1, -1, -1, 180, 180, 
	180, -1, -1, 180, 180, -1, 180, 180, 
	180, 180, 180, 180, 180, 180, 180, -1, 
	-1, -1, 180, 180, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 180, 180, 
	180, -1, -1, 180, -1, -1, -1, -1, 
	180, -1, 180, 180, 180, 180, -1, 180, 
	180, 180, 180, 180, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 180, -1, 
	180, -1, -1, 180, -1, 180, 180, -1, 
	-1, -1, 180, -1, 180, -1, 180, 181, 
	181, 181, 181, 181, 181, 181, 181, 181, 
	181, 181, 181, 181, 181, 181, 181, 181, 
	181, 181, 181, 181, 181, 181, 181, 181, 
	181, -1, 181, 181, 181, 181, 181, -1, 
	181, -1, 181, 181, 181, 181, -1, 181, 
	-1, 181, 181, 181, -1, -1, 181, 181, 
	181, 181, 181, 181, 181, 181, -1, 181, 
	181, 181, -1, -1, -1, -1, 181, 181, 
	181, 181, 181, -1, -1, 181, 181, 181, 
	181, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 181, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 177, 177, 177, 177, 177, -1, 177, 
	177, 177, -1, -1, -1, -1, 177, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 177, 177, 177, 177, -1, -1, 
	-1, 180, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 181, 181, 181, 181, -1, 
	-1, 181, 181, -1, 181, 181, 181, -1, 
	-1, -1, -1, 181, 181, 181, -1, 181, 
	181, 181, -1, -1, -1, -1, 181, -1, 
	-1, -1, -1, 181, -1, -1, -1, 181, 
	181, 181, -1, 181, 181, -1, -1, 181, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	181, 181, 181, 181, 181, 181, 181, -1, 
	-1, -1, -1, 181, 181, -1, -1, 181, 
	181, -1, -1, -1, -1, -1, -1, -1, 
	-1, 181, 181, -1, -1, -1, -1, 181, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 181, 181, 
	181, -1, -1, -1, -1, -1, 181, 181, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 181, -1, -1, -1, -1, -1, 
	-1, 181, 182, 182, 182, 182, 182, 182, 
	182, 182, 182, 182, 182, 182, 182, 182, 
	182, 182, 182, 182, 182, 182, 182, 182, 
	182, 182, 182, 182, -1, 182, 182, 182, 
	182, 182, -1, 182, -1, 182, 182, 182, 
	182, -1, 182, -1, 182, 182, 182, -1, 
	182, 182, 182, 182, 182, 182, 182, 182, 
	182, 182, 182, 182, 182, -1, 182, 182, 
	182, 182, 182, 182, 182, 182, 182, 182, 
	182, 182, 182, 182, 182, -1, 182, -1, 
	-1, -1, -1, 182, 182, 182, 182, 182, 
	-1, -1, 182, 182, 182, 182, 182, 182, 
	182, 182, 182, 182, 182, 182, 182, 182, 
	182, 182, -1, -1, -1, -1, -1, 182, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 181, 182, 182, 
	182, 182, -1, -1, 182, 182, 182, 182, 
	182, 182, -1, -1, -1, -1, 182, 182, 
	182, 182, 182, 182, 182, -1, -1, -1, 
	-1, 182, -1, -1, -1, -1, 182, 182, 
	-1, -1, 182, 182, 182, -1, 182, 182, 
	-1, -1, 182, -1, -1, -1, -1, -1, 
	-1, -1, -1, 182, 182, 182, 182, 182, 
	182, 182, -1, -1, -1, 182, 182, 182, 
	-1, -1, 182, 182, -1, 182, 182, 182, 
	182, 182, -1, 182, 182, 182, -1, -1, 
	-1, 182, 182, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 182, 182, 182, 
	-1, -1, 182, -1, -1, -1, -1, 182, 
	-1, 182, 182, 182, 182, -1, 182, 182, 
	182, 182, 182, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 182, -1, 182, 
	-1, -1, 182, -1, 182, 182, -1, -1, 
	-1, 182, -1, 182, -1, 182, 183, 183, 
	183, 183, 183, 183, 183, 183, 183, 183, 
	183, 183, 183, 183, 183, 183, 183, 183, 
	183, 183, 183, 183, 183, 183, 183, 183, 
	-1, 183, 183, 183, 183, 183, -1, 183, 
	-1, 183, 183, 183, 183, -1, 183, -1, 
	183, 183, 183, -1, 183, 183, 183, 183, 
	183, 183, 183, 183, 183, 183, 183, 183, 
	183, -1, 183, 183, 183, 183, 183, 183, 
	183, 183, 183, 183, 183, 183, 183, 183, 
	183, -1, 183, -1, -1, -1, -1, 183, 
	183, 183, 183, 183, -1, -1, 183, 183, 
	183, 183, 183, 183, 183, 183, 183, 183, 
	183, 183, 183, 183, 183, 183, -1, -1, 
	-1, -1, -1, 183, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	182, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 183, 183, 183, 183, -1, -1, 
	183, 183, 183, 183, 183, 183, -1, -1, 
	-1, -1, 183, 183, 183, 183, 183, 183, 
	183, -1, -1, -1, -1, 183, -1, -1, 
	-1, -1, 183, 183, -1, -1, 183, 183, 
	183, -1, 183, 183, -1, -1, 183, -1, 
	-1, -1, -1, -1, -1, -1, -1, 183, 
	183, 183, 183, 183, 183, 183, -1, -1, 
	-1, 183, 183, 183, -1, -1, 183, 183, 
	-1, 183, 183, 183, 183, 183, -1, 183, 
	183, 183, -1, -1, -1, 183, 183, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 183, 183, 183, -1, -1, 183, -1, 
	-1, -1, -1, 183, -1, 183, 183, 183, 
	183, -1, 183, 183, 183, 183, 183, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 183, -1, 183, -1, -1, 183, -1, 
	183, 183, -1, -1, -1, 183, -1, 183, 
	-1, 183, 184, 184, 184, 184, 184, 184, 
	184, -1, 184, 184, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 184, 184, 184, 
	184, 184, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 184, -1, -1, -1, 
	184, -1, -1, -1, 184, 184, 184, 184, 
	184, 184, -1, -1, -1, -1, 184, 184, 
	184, -1, -1, -1, -1, 184, 184, -1, 
	184, 184, 184, 184, -1, -1, -1, -1, 
	-1, -1, -1, 184, -1, -1, 185, 185, 
	185, 185, 185, 185, 185, -1, 185, 185, 
	-1, 184, 184, 184, -1, 184, -1, -1, 
	-1, 185, 185, 185, 185, 185, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	185, -1, -1, -1, 185, -1, -1, -1, 
	185, 185, 185, 185, 185, 185, -1, -1, 
	-1, -1, 185, 185, 185, -1, -1, -1, 
	-1, 185, 185, -1, 185, 185, 185, 185, 
	-1, -1, -1, -1, -1, -1, -1, 185, 
	185, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 183, 185, 185, 185, 
	-1, 185, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 184, 184, 184, 
	184, 184, -1, 184, 184, 184, -1, -1, 
	-1, -1, 184, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 184, 184, 
	184, 184, 184, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 185, 185, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 185, 185, 185, 185, 185, -1, 185, 
	185, 185, -1, -1, -1, -1, 185, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 185, 185, 185, 185, 185, 188, 
	188, 188, 188, 188, 188, 188, 188, 188, 
	188, 188, 188, 188, 188, 188, -1, 188, 
	188, 188, 188, 188, 188, 188, 188, -1, 
	-1, -1, 188, 188, 188, 188, 188, -1, 
	188, -1, 188, 188, 188, 188, -1, 188, 
	-1, 188, 188, 188, -1, -1, 188, -1, 
	-1, 188, 188, 188, 188, 188, -1, 188, 
	188, 188, -1, -1, -1, -1, 188, 188, 
	188, 188, 188, -1, -1, 188, 188, 188, 
	188, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 327, 327, 327, 327, 327, 
	327, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 327, 327, 
	327, 327, 327, -1, 327, -1, 327, -1, 
	-1, -1, -1, 327, -1, -1, 327, -1, 
	-1, -1, -1, -1, -1, 327, 327, 327, 
	-1, -1, -1, 327, 327, 327, -1, -1, 
	-1, -1, 327, 327, 327, -1, 327, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 188, 188, 188, 188, -1, 
	-1, 188, 188, 188, 188, 188, 188, -1, 
	-1, -1, -1, 188, 188, 188, 188, 188, 
	188, 188, -1, -1, -1, -1, 188, -1, 
	-1, -1, -1, 188, 188, -1, -1, 188, 
	188, 188, -1, 188, 188, -1, -1, 188, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 188, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 188, 
	188, -1, -1, -1, -1, -1, -1, -1, 
	-1, 188, 188, -1, -1, -1, -1, 188, 
	-1, 327, 327, -1, -1, 327, 327, 327, 
	327, -1, 327, -1, -1, -1, -1, 327, 
	327, 327, 327, 327, 327, 327, 188, 188, 
	188, -1, -1, -1, -1, -1, 188, 188, 
	-1, -1, -1, 327, 327, 327, -1, 327, 
	327, -1, 188, 327, 188, -1, -1, 188, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 327, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 327, 327, 190, 
	190, 190, 190, 190, 190, 190, 190, 190, 
	190, 190, 190, 190, 190, 190, -1, 190, 
	190, 190, 190, 190, 190, 190, 190, -1, 
	-1, -1, 190, 190, 190, 190, 190, -1, 
	190, -1, 190, 190, 190, 190, -1, 190, 
	-1, 190, 190, 190, -1, -1, 190, -1, 
	327, 190, 190, 190, 190, 190, -1, 190, 
	190, 190, -1, -1, -1, -1, 190, 190, 
	190, 190, 190, -1, -1, 190, 190, 190, 
	190, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 188, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 184, 184, 184, 184, 184, -1, 184, 
	184, 184, -1, -1, -1, -1, 184, -1, 
	-1, -1, -1, 190, 190, 190, 190, -1, 
	-1, 190, 190, 190, 190, 190, 190, -1, 
	-1, -1, -1, 190, 190, 190, 190, 190, 
	190, 190, 184, 184, 184, 184, 190, -1, 
	-1, -1, -1, 190, 190, -1, -1, 190, 
	190, 190, -1, 190, 190, -1, -1, 190, 
	-1, -1, 185, 185, -1, -1, -1, -1, 
	-1, -1, -1, 190, -1, 185, 185, 185, 
	185, 185, -1, 185, 185, 185, -1, 190, 
	190, -1, 185, -1, -1, -1, -1, -1, 
	-1, 190, 190, -1, -1, -1, -1, 190, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 185, 185, 
	185, 185, -1, -1, -1, -1, 190, 190, 
	190, -1, -1, -1, -1, -1, 190, 190, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 190, -1, 190, -1, -1, 190, 
	-1, -1, 204, 204, 204, 204, 204, 204, 
	204, 204, 204, 204, 204, 204, 204, 204, 
	204, 204, 204, 204, 204, 204, 204, 204, 
	204, 204, 204, 204, -1, 204, 204, 204, 
	204, 204, -1, 204, -1, 204, 204, 204, 
	204, -1, 204, -1, 204, 204, 204, -1, 
	204, 204, 204, 204, 204, 204, 204, 204, 
	204, 204, 204, 204, 204, -1, 204, 204, 
	204, 204, 204, 204, 204, 204, 204, 204, 
	204, 204, 204, 204, 204, -1, 204, -1, 
	-1, -1, -1, 204, 204, 204, 204, 204, 
	-1, -1, 204, 204, 204, 204, 204, 204, 
	204, 204, 204, 204, 204, 204, 204, 204, 
	204, 204, -1, -1, -1, -1, -1, 204, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 190, 204, 204, 
	204, 204, -1, -1, 204, 204, 204, 204, 
	204, 204, -1, -1, -1, -1, 204, 204, 
	204, 204, 204, 204, 204, -1, -1, -1, 
	-1, 204, -1, -1, -1, -1, 204, 204, 
	-1, -1, 204, 204, 204, -1, 204, 204, 
	-1, -1, 204, -1, -1, -1, -1, -1, 
	-1, -1, -1, 204, 204, 204, 204, 204, 
	204, 204, -1, -1, -1, 204, 204, 204, 
	-1, -1, 204, 204, -1, 204, 204, 204, 
	204, 204, -1, 204, 204, 204, -1, -1, 
	-1, 204, 204, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 204, 204, 204, 
	-1, -1, 204, -1, -1, -1, -1, 204, 
	-1, 204, 204, 204, 204, -1, 204, 204, 
	204, 204, 204, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 204, -1, 204, 
	-1, -1, 204, -1, 204, 204, -1, -1, 
	-1, 204, -1, 204, -1, 204, 205, 205, 
	205, 205, 205, 205, 205, 205, 205, 205, 
	205, 205, 205, 205, 205, 205, 205, 205, 
	205, 205, 205, 205, 205, 205, 205, 205, 
	-1, 205, 205, 205, 205, 205, -1, 205, 
	-1, 205, 205, 205, 205, -1, 205, -1, 
	205, 205, 205, -1, 205, 205, 205, 205, 
	205, 205, 205, 205, 205, 205, 205, 205, 
	205, -1, 205, 205, 205, 205, 205, 205, 
	205, 205, 205, 205, 205, 205, 205, 205, 
	205, -1, 205, -1, -1, -1, -1, 205, 
	205, 205, 205, 205, -1, -1, 205, 205, 
	205, 205, 205, 205, 205, 205, 205, 205, 
	205, 205, 205, 205, 205, 205, -1, -1, 
	-1, -1, -1, 205, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	204, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 205, 205, 205, 205, -1, -1, 
	205, 205, 205, 205, 205, 205, -1, -1, 
	-1, -1, 205, 205, 205, 205, 205, 205, 
	205, -1, -1, -1, -1, 205, -1, -1, 
	-1, -1, 205, 205, -1, -1, 205, 205, 
	205, -1, 205, 205, -1, -1, 205, -1, 
	-1, -1, -1, -1, -1, -1, -1, 205, 
	205, 205, 205, 205, 205, 205, -1, -1, 
	-1, 205, 205, 205, 205, -1, 205, 205, 
	-1, 205, 205, 205, 205, 205, -1, 205, 
	205, 205, -1, -1, -1, 205, 205, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 205, 205, 205, -1, -1, 205, -1, 
	-1, -1, -1, 205, -1, 205, 205, 205, 
	205, -1, 205, 205, 205, 205, 205, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 205, -1, 205, -1, -1, 205, -1, 
	205, 205, -1, -1, -1, 205, -1, 205, 
	-1, 205, 206, 206, 206, 206, 206, 206, 
	206, 206, 206, 206, 206, 206, 206, 206, 
	206, 206, 206, 206, 206, 206, 206, 206, 
	206, 206, 206, 206, -1, 206, 206, 206, 
	206, 206, -1, 206, -1, 206, 206, 206, 
	206, -1, 206, -1, 206, 206, 206, -1, 
	206, 206, 206, 206, 206, 206, 206, 206, 
	206, 206, 206, 206, 206, -1, 206, 206, 
	206, 206, 206, 206, 206, 206, 206, 206, 
	206, 206, 206, 206, 206, -1, 206, -1, 
	-1, -1, -1, 206, 206, 206, 206, 206, 
	-1, -1, 206, 206, 206, 206, 206, 206, 
	206, 206, 206, 206, 206, 206, 206, 206, 
	206, 206, -1, -1, -1, -1, -1, 206, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 205, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 206, 206, 
	206, 206, -1, -1, 206, 206, 206, 206, 
	206, 206, -1, -1, -1, -1, 206, 206, 
	206, 206, 206, 206, 206, -1, -1, -1, 
	-1, 206, -1, -1, -1, -1, 206, 206, 
	-1, -1, 206, 206, 206, -1, 206, 206, 
	-1, -1, 206, -1, -1, -1, -1, -1, 
	-1, -1, -1, 206, 206, 206, 206, 206, 
	206, 206, -1, -1, -1, 206, 206, 206, 
	206, -1, 206, 206, -1, 206, 206, 206, 
	206, 206, -1, 206, 206, 206, -1, -1, 
	-1, 206, 206, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 206, 206, 206, 
	-1, -1, 206, -1, -1, -1, -1, 206, 
	-1, 206, 206, 206, 206, -1, 206, 206, 
	206, 206, 206, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 206, -1, 206, 
	-1, -1, 206, -1, 206, 206, -1, -1, 
	-1, 206, -1, 206, -1, 206, 211, 211, 
	211, 211, 211, 211, 211, 211, 211, 211, 
	211, 211, 211, 211, 211, 211, 211, 211, 
	211, 211, 211, 211, 211, 211, 211, 211, 
	-1, 211, 211, 211, 211, 211, -1, 211, 
	-1, 211, 211, 211, 211, -1, 211, -1, 
	211, 211, 211, 211, 211, 211, 211, 211, 
	211, 211, 211, 211, 211, 211, 211, 211, 
	211, -1, 211, 211, 211, 211, 211, 211, 
	211, 211, 211, 211, 211, 211, 211, 211, 
	211, -1, 211, -1, -1, 211, -1, 211, 
	211, 211, 211, 211, -1, -1, 211, 211, 
	211, 211, 211, 211, 211, 211, 211, 211, 
	211, 211, 211, 211, 211, 211, -1, -1, 
	-1, -1, -1, 211, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	206, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 211, 211, 211, 211, -1, -1, 
	211, 211, 211, 211, 211, 211, -1, -1, 
	-1, -1, 211, 211, 211, 211, 211, 211, 
	211, -1, -1, -1, -1, 211, -1, -1, 
	-1, -1, 211, 211, -1, -1, 211, 211, 
	211, -1, 211, 211, -1, -1, 211, -1, 
	-1, -1, -1, -1, -1, -1, -1, 211, 
	211, 211, 211, 211, 211, 211, -1, -1, 
	-1, 211, 211, 211, -1, -1, 211, 211, 
	-1, 211, 211, 211, 211, 211, 211, 211, 
	211, 211, -1, -1, -1, 211, 211, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 211, 211, 211, -1, -1, 211, -1, 
	-1, -1, -1, 211, -1, 211, 211, 211, 
	211, -1, 211, 211, 211, 211, 211, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 211, -1, 211, -1, -1, 211, -1, 
	211, 211, -1, -1, -1, 211, -1, 211, 
	-1, 211, 212, 212, 212, 212, 212, 212, 
	212, 212, 212, 212, 212, 212, 212, 212, 
	212, 212, 212, 212, 212, 212, 212, 212, 
	212, 212, 212, 212, -1, 212, 212, 212, 
	212, 212, -1, 212, -1, 212, 212, 212, 
	212, -1, 212, -1, 212, 212, 212, 212, 
	212, 212, 212, 212, 212, 212, 212, 212, 
	212, 212, 212, 212, 212, -1, 212, 212, 
	212, 212, 212, 212, 212, 212, 212, 212, 
	212, 212, 212, 212, 212, -1, 212, -1, 
	-1, 212, -1, 212, 212, 212, 212, 212, 
	-1, -1, 212, 212, 212, 212, 212, 212, 
	212, 212, 212, 212, 212, 212, 212, 212, 
	212, 212, -1, -1, -1, -1, -1, 212, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 211, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 212, 212, 
	212, 212, -1, -1, 212, 212, 212, 212, 
	212, 212, -1, -1, -1, -1, 212, 212, 
	212, 212, 212, 212, 212, -1, -1, -1, 
	-1, 212, -1, -1, -1, -1, 212, 212, 
	-1, -1, 212, 212, 212, -1, 212, 212, 
	-1, -1, 212, -1, -1, -1, -1, -1, 
	-1, -1, -1, 212, 212, 212, 212, 212, 
	212, 212, -1, -1, -1, 212, 212, 212, 
	-1, -1, 212, 212, -1, 212, 212, 212, 
	212, 212, 212, 212, 212, 212, -1, -1, 
	-1, 212, 212, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 212, 212, 212, 
	-1, -1, 212, -1, -1, -1, -1, 212, 
	-1, 212, 212, 212, 212, -1, 212, 212, 
	212, 212, 212, -1, -1, 214, 214, 214, 
	214, 214, 214, -1, -1, 212, -1, 212, 
	-1, -1, 212, -1, 212, 212, -1, 214, 
	-1, 212, -1, 212, -1, 212, -1, -1, 
	214, 214, 214, 214, 214, -1, 214, -1, 
	214, -1, -1, -1, -1, 214, -1, -1, 
	214, 214, -1, -1, -1, -1, -1, 214, 
	214, 214, -1, -1, -1, 214, 214, 214, 
	-1, -1, -1, -1, 214, 214, 214, 214, 
	214, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 217, 217, 
	217, 217, 217, 217, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	217, -1, -1, -1, -1, -1, -1, -1, 
	-1, 217, 217, 217, 217, 217, -1, 217, 
	-1, 217, -1, -1, -1, -1, 217, -1, 
	-1, 217, 217, -1, -1, -1, -1, -1, 
	217, 217, 217, -1, -1, -1, 217, 217, 
	217, -1, -1, -1, -1, 217, 217, 217, 
	217, 217, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 214, 214, 214, -1, -1, 214, 
	214, -1, -1, 214, 214, -1, -1, -1, 
	212, 214, 214, 214, -1, 214, 214, 214, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 214, 214, -1, -1, 214, 214, 214, 
	-1, 214, 214, -1, -1, 214, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 214, 
	214, -1, 211, 217, 217, 217, -1, -1, 
	217, 217, -1, -1, 217, 217, -1, -1, 
	-1, -1, 217, 217, 217, -1, 217, 217, 
	217, -1, -1, 218, 218, 218, 218, 218, 
	218, -1, 217, 217, -1, -1, 217, 217, 
	217, -1, 217, 217, -1, 218, 217, -1, 
	-1, -1, -1, -1, -1, 214, 218, 218, 
	218, 218, 218, -1, 218, -1, 218, -1, 
	-1, -1, -1, 218, -1, -1, 218, 218, 
	-1, -1, -1, -1, -1, 218, 218, 218, 
	217, 217, -1, 218, 218, 218, -1, -1, 
	-1, -1, 218, 218, 218, 218, 218, -1, 
	-1, 219, 219, 219, 219, 219, 219, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 219, -1, -1, -1, -1, 
	-1, -1, -1, -1, 219, 219, 219, 219, 
	219, -1, 219, -1, 219, -1, 217, -1, 
	-1, 219, -1, -1, 219, 219, -1, -1, 
	-1, -1, -1, 219, 219, 219, -1, -1, 
	-1, 219, 219, 219, -1, -1, -1, -1, 
	219, 219, 219, 219, 219, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	218, 218, 218, -1, -1, 218, 218, -1, 
	-1, 218, 218, -1, -1, -1, -1, 218, 
	218, 218, -1, 218, 218, 218, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 218, 
	218, -1, -1, 218, 218, 218, -1, 218, 
	218, -1, -1, 218, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 219, 219, 
	219, -1, -1, 219, 219, 218, 218, 219, 
	219, -1, -1, -1, -1, 219, 219, 219, 
	-1, 219, 219, 219, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 219, 219, -1, 
	-1, 219, 219, 219, -1, 219, 219, -1, 
	-1, 219, -1, -1, -1, -1, 212, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 218, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 219, 219, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 219, -1, -1, -1, 220, 220, 220, 
	220, 220, 220, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 220, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	220, 220, 220, 220, 220, -1, 220, -1, 
	220, -1, -1, -1, -1, 220, -1, -1, 
	220, 220, -1, -1, -1, -1, -1, 220, 
	220, 220, -1, -1, -1, 220, 220, 220, 
	-1, -1, -1, -1, 220, 220, 220, 220, 
	220, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 214, 214, 
	214, -1, -1, 214, 214, -1, -1, 214, 
	214, -1, -1, -1, -1, 214, 214, 214, 
	-1, 214, 214, 214, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 214, 214, -1, 
	-1, 214, 214, 214, -1, 214, 214, -1, 
	-1, 214, 220, 220, 220, -1, -1, 220, 
	220, -1, -1, 220, 220, -1, -1, -1, 
	-1, 220, 220, 220, -1, 220, 220, 220, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 220, 220, -1, -1, 220, 220, 220, 
	-1, 220, 220, -1, -1, 220, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 221, 
	221, 221, 221, 221, 221, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 221, -1, -1, -1, -1, -1, 220, 
	220, -1, 221, 221, 221, 221, 221, -1, 
	221, 214, 221, -1, -1, -1, -1, 221, 
	-1, -1, 221, 221, -1, -1, -1, -1, 
	-1, 221, 221, 221, -1, -1, -1, 221, 
	221, 221, -1, -1, -1, -1, 221, 221, 
	221, 221, 221, -1, -1, 222, 222, 222, 
	222, 222, 222, -1, -1, 220, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 222, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	222, 222, 222, 222, 222, -1, 222, -1, 
	222, -1, -1, -1, -1, 222, -1, -1, 
	222, 222, -1, -1, -1, -1, -1, 222, 
	222, 222, -1, -1, -1, 222, 222, 222, 
	-1, -1, -1, -1, 222, 222, 222, 222, 
	222, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 221, 221, 221, -1, 
	-1, 221, 221, -1, -1, 221, 221, -1, 
	-1, -1, -1, 221, 221, 221, -1, 221, 
	221, 221, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 221, 221, -1, -1, 221, 
	221, 221, -1, 221, 221, -1, -1, 221, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 222, 222, 222, -1, -1, 222, 
	222, 221, 221, 222, 222, -1, -1, -1, 
	-1, 222, 222, 222, -1, 222, 222, 222, 
	-1, 223, 223, 223, 223, 223, 223, -1, 
	-1, 222, 222, -1, -1, 222, 222, 222, 
	-1, 222, 222, 223, -1, 222, -1, -1, 
	-1, -1, -1, -1, 223, 223, 223, 223, 
	223, -1, 223, -1, 223, -1, -1, 221, 
	-1, 223, -1, -1, 223, 223, -1, -1, 
	-1, -1, -1, 223, 223, 223, -1, 222, 
	222, 223, 223, 223, -1, -1, -1, -1, 
	223, 223, 223, 223, 223, -1, -1, 224, 
	224, 224, 224, 224, 224, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 224, -1, -1, -1, -1, -1, -1, 
	-1, -1, 224, 224, 224, 224, 224, -1, 
	224, -1, 224, -1, -1, 222, -1, 224, 
	-1, -1, 224, 224, -1, -1, -1, -1, 
	-1, 224, 224, 224, -1, -1, -1, 224, 
	224, 224, -1, -1, -1, -1, 224, 224, 
	224, 224, 224, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 223, 223, 
	223, -1, -1, 223, 223, -1, -1, 223, 
	223, -1, -1, -1, -1, 223, 223, 223, 
	-1, 223, 223, 223, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 223, 223, -1, 
	-1, 223, 223, 223, -1, 223, 223, -1, 
	-1, 223, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 224, 224, 224, -1, 
	-1, 224, 224, 223, 223, 224, 224, -1, 
	-1, -1, -1, 224, 224, 224, -1, 224, 
	224, 224, -1, 225, 225, 225, 225, 225, 
	225, -1, -1, 224, 224, -1, -1, 224, 
	224, 224, -1, 224, 224, 225, -1, 224, 
	-1, -1, -1, -1, -1, -1, 225, 225, 
	225, 225, 225, -1, 225, -1, 225, -1, 
	-1, 223, -1, 225, -1, -1, 225, 225, 
	-1, -1, -1, -1, -1, 225, 225, 225, 
	-1, 224, 224, 225, 225, 225, -1, -1, 
	-1, -1, 225, 225, 225, 225, 225, -1, 
	-1, 226, 226, 226, 226, 226, 226, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 226, -1, -1, -1, -1, 
	-1, -1, -1, -1, 226, 226, 226, 226, 
	226, -1, 226, -1, 226, -1, -1, 224, 
	-1, 226, -1, -1, 226, 226, -1, -1, 
	-1, -1, -1, 226, 226, 226, -1, -1, 
	-1, 226, 226, 226, -1, -1, -1, -1, 
	226, 226, 226, 226, 226, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	225, 225, 225, -1, -1, 225, 225, -1, 
	-1, 225, 225, -1, -1, -1, -1, 225, 
	225, 225, -1, 225, 225, 225, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 225, 
	225, -1, -1, 225, 225, 225, -1, 225, 
	225, -1, -1, 225, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 226, 226, 
	226, -1, -1, 226, 226, 225, 225, 226, 
	226, -1, -1, -1, -1, 226, 226, 226, 
	-1, 226, 226, 226, -1, 227, 227, 227, 
	227, 227, 227, -1, -1, 226, 226, -1, 
	-1, 226, 226, 226, -1, 226, 226, 227, 
	-1, 226, -1, -1, -1, -1, -1, -1, 
	227, 227, 227, 227, 227, -1, 227, -1, 
	227, -1, -1, 225, -1, 227, -1, -1, 
	227, 227, -1, -1, -1, -1, -1, 227, 
	227, 227, -1, 226, 226, 227, 227, 227, 
	-1, -1, -1, -1, 227, 227, 227, 227, 
	227, -1, -1, 228, 228, 228, 228, 228, 
	228, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 228, -1, -1, 
	-1, -1, -1, -1, -1, -1, 228, 228, 
	228, 228, 228, -1, 228, -1, 228, -1, 
	-1, 226, -1, 228, -1, -1, 228, 228, 
	-1, -1, -1, -1, -1, 228, 228, 228, 
	-1, -1, -1, 228, 228, 228, -1, -1, 
	-1, -1, 228, 228, 228, 228, 228, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 227, 227, 227, -1, -1, 227, 
	227, -1, -1, 227, 227, -1, -1, -1, 
	-1, 227, 227, 227, -1, 227, 227, 227, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 227, 227, -1, -1, 227, 227, 227, 
	-1, 227, 227, -1, -1, 227, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	228, 228, 228, -1, -1, 228, 228, 227, 
	227, 228, 228, -1, -1, -1, -1, 228, 
	228, 228, -1, 228, 228, 228, -1, 229, 
	229, 229, 229, 229, 229, -1, -1, 228, 
	228, -1, -1, 228, 228, 228, -1, 228, 
	228, 229, -1, 228, -1, -1, -1, -1, 
	-1, -1, 229, 229, 229, 229, 229, -1, 
	229, -1, 229, -1, -1, 227, -1, 229, 
	-1, -1, 229, 229, -1, -1, -1, -1, 
	-1, 229, 229, 229, -1, 228, 228, 229, 
	229, 229, -1, -1, -1, -1, 229, 229, 
	229, 229, 229, -1, -1, 230, 230, 230, 
	230, 230, 230, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 230, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	230, 230, 230, 230, 230, -1, 230, -1, 
	230, -1, -1, 228, -1, 230, -1, -1, 
	230, 230, -1, -1, -1, -1, -1, 230, 
	230, 230, -1, -1, -1, 230, 230, 230, 
	-1, -1, -1, -1, 230, 230, 230, 230, 
	230, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 229, 229, 229, -1, 
	-1, 229, 229, -1, -1, 229, 229, -1, 
	-1, -1, -1, 229, 229, 229, -1, 229, 
	229, 229, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 229, 229, -1, -1, 229, 
	229, 229, -1, 229, 229, -1, -1, 229, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 230, 230, 230, -1, -1, 230, 
	230, 229, 229, 230, 230, -1, -1, -1, 
	-1, 230, 230, 230, -1, 230, 230, 230, 
	-1, 231, 231, 231, 231, 231, 231, -1, 
	-1, 230, 230, -1, -1, 230, 230, 230, 
	-1, 230, 230, 231, -1, 230, -1, -1, 
	-1, -1, -1, -1, 231, 231, 231, 231, 
	231, -1, 231, -1, 231, -1, -1, 229, 
	-1, 231, -1, -1, 231, 231, -1, -1, 
	-1, -1, -1, 231, 231, 231, -1, 230, 
	230, 231, 231, 231, -1, -1, -1, -1, 
	231, 231, 231, 231, 231, -1, -1, -1, 
	249, 249, 249, 249, 249, 249, 249, -1, 
	249, 249, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 249, 249, 249, 249, 249, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 249, -1, -1, 230, 249, -1, 
	-1, -1, 249, 249, 249, 249, 249, 249, 
	-1, -1, -1, -1, 249, 249, 249, -1, 
	-1, -1, -1, 249, 249, -1, 249, 249, 
	249, 249, -1, -1, -1, -1, -1, -1, 
	-1, 249, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 249, 
	249, 249, 249, 249, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 249, 231, 231, 
	231, -1, -1, 231, 231, -1, -1, 231, 
	231, -1, -1, -1, -1, 231, 231, 231, 
	-1, 231, 231, 231, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 231, 231, -1, 
	-1, 231, 231, 231, -1, 231, 231, -1, 
	-1, 231, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 231, 231, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 231, -1, 249, 249, 249, 249, 249, 
	-1, 249, 249, 249, -1, -1, -1, -1, 
	249, 253, 253, 253, 253, 253, 253, 253, 
	-1, 253, 253, 249, 249, 249, -1, -1, 
	-1, -1, -1, -1, 253, 253, 253, 253, 
	253, -1, 249, -1, 249, 249, 249, 249, 
	249, -1, -1, 253, -1, -1, -1, 253, 
	-1, -1, -1, 253, 253, 253, 253, 253, 
	253, -1, -1, -1, -1, 253, 253, 253, 
	-1, -1, -1, 249, 253, 253, -1, 253, 
	253, 253, 253, 253, -1, -1, -1, -1, 
	-1, -1, 253, 255, 255, 255, 255, 255, 
	255, 255, -1, 255, 255, -1, -1, -1, 
	253, 253, 253, 253, 253, -1, 255, 255, 
	255, 255, 255, -1, -1, -1, 253, -1, 
	-1, -1, -1, -1, -1, 255, -1, -1, 
	-1, 255, -1, -1, -1, 255, 255, 255, 
	255, 255, 255, -1, -1, -1, -1, 255, 
	255, 255, -1, -1, -1, -1, 255, 255, 
	-1, 255, 255, 255, 255, -1, -1, -1, 
	-1, -1, -1, -1, 255, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 255, 255, 255, 255, 255, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 253, 253, 253, 253, 
	253, -1, 253, 253, 253, -1, -1, -1, 
	-1, 253, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 253, 253, 253, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 253, -1, 253, 253, 253, 
	253, 253, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 253, -1, 255, 255, 
	255, 255, 255, -1, 255, 255, 255, -1, 
	-1, -1, -1, 255, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 255, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 255, 
	255, 255, 255, 255, -1, -1, -1, -1, 
	-1, -1, 257, 257, 257, 257, 257, 257, 
	257, 257, 257, 257, 257, 257, 257, 257, 
	257, 257, 257, 257, 257, 257, 257, 257, 
	257, 257, 257, 257, -1, 257, 257, 257, 
	257, 257, -1, 257, -1, 257, 257, 257, 
	257, -1, 257, -1, 257, 257, 257, -1, 
	257, 257, 257, 257, 257, 257, 257, 257, 
	257, 257, 257, 257, 257, -1, 257, 257, 
	257, 257, 257, 257, 257, 257, 257, 257, 
	257, 257, 257, 257, 257, -1, 257, -1, 
	-1, -1, -1, 257, 257, 257, 257, 257, 
	-1, -1, 257, 257, 257, 257, 257, 257, 
	257, 257, 257, 257, 257, 257, 257, 257, 
	257, 257, -1, -1, -1, -1, -1, 257, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 257, 257, 
	257, 257, -1, -1, 257, 257, 257, 257, 
	257, 257, -1, -1, -1, -1, 257, 257, 
	257, 257, 257, 257, 257, -1, -1, -1, 
	-1, 257, -1, -1, -1, -1, 257, 257, 
	-1, -1, 257, 257, 257, -1, 257, 257, 
	-1, -1, 257, -1, -1, -1, -1, -1, 
	-1, -1, -1, 257, 257, 257, 257, 257, 
	257, 257, -1, -1, -1, 257, 257, 257, 
	-1, -1, 257, 257, -1, 257, 257, 257, 
	257, 257, -1, 257, 257, 257, -1, -1, 
	-1, 257, 257, -1, -1, -1, -1, -1, 
	249, 249, -1, -1, -1, 257, 257, 257, 
	-1, -1, 257, -1, -1, -1, 249, 257, 
	-1, 257, 257, 257, 257, -1, 257, 257, 
	257, 257, 257, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 257, -1, 257, 
	-1, -1, 257, -1, 257, 257, -1, 249, 
	-1, 257, -1, 257, -1, 257, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 258, 
	258, 258, 258, 258, 258, 258, 258, 258, 
	258, 258, 258, 258, 258, 258, 258, 258, 
	258, 258, 258, 258, 258, 258, 258, 258, 
	258, -1, 258, 258, 258, 258, 258, -1, 
	258, -1, 258, 258, 258, 258, -1, 258, 
	-1, 258, 258, 258, -1, 258, 258, 258, 
	258, 258, 258, 258, 258, 258, 258, 258, 
	258, 258, -1, 258, 258, 258, 258, 258, 
	258, 258, 258, 258, 258, 258, 258, 258, 
	258, 258, -1, 258, -1, -1, -1, -1, 
	258, 258, 258, 258, 258, -1, -1, 258, 
	258, 258, 258, 258, 258, 258, 258, 258, 
	258, 258, 258, 258, 258, 258, 258, -1, 
	-1, -1, -1, -1, 258, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	257, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 258, 258, 258, 258, -1, 
	-1, 258, 258, 258, 258, 258, 258, -1, 
	-1, 253, 253, 258, 258, 258, 258, 258, 
	258, 258, -1, -1, -1, -1, 258, 253, 
	-1, -1, -1, 258, 258, -1, -1, 258, 
	258, 258, -1, 258, 258, -1, -1, 258, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	258, 258, 258, 258, 258, 258, 258, -1, 
	253, -1, 258, 258, 258, -1, -1, 258, 
	258, -1, 258, 258, 258, 258, 258, -1, 
	258, 258, 258, -1, -1, -1, 258, 258, 
	-1, -1, 255, -1, -1, -1, -1, -1, 
	-1, -1, 258, 258, 258, -1, -1, 258, 
	-1, -1, -1, -1, 258, -1, 258, 258, 
	258, 258, -1, 258, 258, 258, 258, 258, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 258, -1, 258, -1, -1, 258, 
	-1, 258, 258, -1, -1, -1, 258, -1, 
	258, -1, 258, 259, 259, 259, 259, 259, 
	259, 259, -1, 259, 259, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 259, 259, 
	259, 259, 259, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 259, -1, -1, 
	-1, 259, -1, -1, -1, 259, 259, 259, 
	259, 259, 259, -1, -1, -1, -1, 259, 
	259, 259, -1, -1, -1, -1, 259, 259, 
	-1, 259, 259, 259, 259, -1, -1, -1, 
	-1, -1, -1, -1, 259, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	260, 260, 260, 260, 260, 260, 260, 260, 
	260, 260, 260, 260, 260, 260, 260, 260, 
	260, 260, 260, 260, 260, 260, 260, 260, 
	260, 260, -1, 260, 260, 260, 260, 260, 
	-1, 260, -1, 260, 260, 260, 260, -1, 
	260, -1, 260, 260, 260, 258, 260, 260, 
	260, 260, 260, 260, 260, 260, 260, 260, 
	260, 260, 260, -1, 260, 260, 260, 260, 
	260, 260, 260, 260, 260, 260, 260, 260, 
	260, 260, 260, -1, 260, -1, -1, -1, 
	-1, 260, 260, 260, 260, 260, -1, -1, 
	260, 260, 260, 260, 260, 260, 260, 260, 
	260, 260, 260, 260, 260, 260, 260, 260, 
	-1, -1, -1, -1, -1, 260, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 259, 259, 259, -1, 
	-1, -1, -1, 259, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 259, 
	259, 259, 259, 259, -1, -1, -1, -1, 
	-1, -1, -1, -1, 260, 260, 260, 260, 
	-1, -1, 260, 260, 260, 260, 260, 260, 
	-1, -1, -1, -1, 260, 260, 260, 260, 
	260, 260, 260, -1, -1, -1, -1, 260, 
	-1, -1, -1, -1, 260, 260, -1, -1, 
	260, 260, 260, -1, 260, 260, -1, -1, 
	260, -1, -1, -1, -1, -1, -1, -1, 
	-1, 260, 260, 260, 260, 260, 260, 260, 
	-1, -1, -1, 260, 260, 260, -1, -1, 
	260, 260, -1, 260, 260, 260, 260, 260, 
	-1, 260, 260, 260, -1, -1, -1, 260, 
	260, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 260, 260, 260, -1, -1, 
	260, -1, -1, -1, -1, 260, -1, 260, 
	260, 260, 260, -1, 260, 260, 260, 260, 
	260, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 260, -1, 260, -1, -1, 
	260, -1, 260, 260, -1, -1, -1, 260, 
	-1, 260, -1, 260, 261, 261, 261, 261, 
	261, 261, 261, 261, 261, 261, 261, 261, 
	261, 261, 261, 261, 261, 261, 261, 261, 
	261, 261, 261, 261, 261, 261, -1, 261, 
	261, 261, 261, 261, -1, 261, -1, 261, 
	261, 261, 261, -1, 261, -1, 261, 261, 
	261, -1, 261, 261, 261, 261, 261, 261, 
	261, 261, 261, 261, 261, 261, 261, -1, 
	261, 261, 261, 261, 261, 261, 261, 261, 
	261, 261, 261, 261, 261, 261, 261, -1, 
	261, -1, -1, -1, -1, 261, 261, 261, 
	261, 261, -1, -1, 261, 261, 261, 261, 
	261, 261, 261, 261, 261, 261, 261, 261, 
	261, 261, 261, 261, -1, -1, -1, -1, 
	-1, 261, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 260, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	261, 261, 261, 261, -1, -1, 261, 261, 
	261, 261, 261, 261, -1, -1, -1, -1, 
	261, 261, 261, 261, 261, 261, 261, -1, 
	-1, -1, -1, 261, -1, -1, -1, -1, 
	261, 261, -1, -1, 261, 261, 261, -1, 
	261, 261, -1, -1, 261, -1, -1, -1, 
	-1, -1, -1, -1, -1, 261, 261, 261, 
	261, 261, 261, 261, -1, -1, -1, 261, 
	261, 261, -1, -1, 261, 261, -1, 261, 
	261, 261, 261, 261, -1, 261, 261, 261, 
	-1, -1, -1, 261, 261, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 261, 
	261, 261, -1, -1, 261, -1, -1, -1, 
	-1, 261, -1, 261, 261, 261, 261, -1, 
	261, 261, 261, 261, 261, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 261, 
	-1, 261, -1, -1, 261, -1, 261, 261, 
	-1, -1, -1, 261, -1, 261, -1, 261, 
	262, 262, 262, 262, 262, 262, 262, 262, 
	262, 262, 262, 262, 262, 262, 262, 262, 
	262, 262, 262, 262, 262, 262, 262, 262, 
	262, 262, -1, 262, 262, 262, 262, 262, 
	-1, 262, -1, 262, 262, 262, 262, -1, 
	262, -1, 262, 262, 262, -1, -1, 262, 
	262, 262, 262, 262, 262, 262, 262, -1, 
	262, 262, 262, -1, -1, -1, -1, 262, 
	262, 262, 262, 262, -1, -1, 262, 262, 
	262, 262, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 262, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	259, 259, 259, -1, -1, -1, -1, 259, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 259, 259, 259, 259, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 261, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 262, 262, 262, 262, 
	-1, -1, 262, 262, -1, 262, 262, 262, 
	-1, -1, -1, -1, 262, 262, 262, -1, 
	262, 262, 262, -1, -1, -1, -1, 262, 
	-1, -1, -1, -1, 262, -1, -1, -1, 
	262, 262, 262, -1, 262, 262, -1, -1, 
	262, -1, -1, -1, -1, -1, -1, -1, 
	-1, 262, 262, 262, 262, 262, 262, 262, 
	-1, -1, -1, -1, 262, 262, -1, -1, 
	262, 262, -1, -1, -1, -1, -1, -1, 
	-1, -1, 262, 262, -1, -1, -1, -1, 
	262, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 262, 
	262, 262, -1, -1, -1, -1, -1, 262, 
	262, 263, 263, 263, 263, 263, 263, 263, 
	-1, 263, 263, 262, -1, -1, -1, -1, 
	-1, -1, 262, -1, 263, 263, 263, 263, 
	263, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 263, -1, -1, -1, 263, 
	-1, -1, -1, 263, 263, 263, 263, 263, 
	263, -1, -1, -1, -1, 263, 263, 263, 
	-1, -1, -1, -1, 263, 263, -1, 263, 
	263, 263, 263, -1, -1, -1, -1, -1, 
	-1, -1, 263, 264, 264, 264, 264, 264, 
	264, 264, -1, 264, 264, -1, -1, -1, 
	263, 263, 263, -1, 263, -1, 264, 264, 
	264, 264, 264, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 264, -1, -1, 
	-1, 264, -1, -1, -1, 264, 264, 264, 
	264, 264, 264, -1, -1, -1, -1, 264, 
	264, 264, -1, -1, -1, -1, 264, 264, 
	-1, 264, 264, 264, 264, -1, -1, -1, 
	-1, -1, -1, -1, 264, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 264, 264, 264, -1, 264, 265, 
	265, 265, 265, 265, 265, 265, 265, 265, 
	265, 265, 265, -1, -1, 265, 265, 265, 
	265, -1, -1, -1, -1, -1, 262, -1, 
	-1, -1, -1, -1, -1, 265, 265, 265, 
	-1, -1, -1, 265, -1, -1, -1, -1, 
	265, -1, -1, -1, -1, -1, 265, 265, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 265, -1, -1, 265, 
	265, 265, 265, -1, -1, 263, 263, 263, 
	263, -1, 263, 263, 263, 265, -1, -1, 
	-1, 263, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 263, 263, 263, 
	263, 263, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 264, 
	264, 264, 264, -1, 264, 264, 264, -1, 
	-1, -1, -1, 264, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 264, 
	264, 264, 264, 264, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 265, -1, -1, 
	-1, -1, -1, -1, -1, 265, 265, 265, 
	-1, 265, 265, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 265, -1, -1, -1, 
	-1, 265, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	265, 265, 265, -1, -1, -1, -1, -1, 
	265, 265, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 265, 266, 266, 266, 266, 
	266, 266, 266, 266, 266, 266, 266, 266, 
	266, 266, 266, 266, 266, 266, 266, 266, 
	266, 266, 266, 266, 266, 266, -1, 266, 
	266, 266, 266, 266, -1, 266, -1, 266, 
	266, 266, 266, -1, 266, -1, 266, 266, 
	266, -1, -1, 266, 266, 266, 266, 266, 
	266, 266, 266, -1, 266, 266, 266, -1, 
	-1, -1, -1, 266, 266, 266, 266, 266, 
	-1, -1, 266, 266, 266, 266, 267, 267, 
	267, 267, 267, 267, 267, -1, 267, 267, 
	266, 262, 262, 262, -1, -1, -1, -1, 
	-1, 267, 267, 267, 267, 267, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	267, -1, -1, -1, 267, -1, -1, -1, 
	267, 267, 267, 267, 267, 267, -1, -1, 
	-1, -1, 267, 267, 267, -1, -1, -1, 
	-1, 267, 267, -1, 267, 267, 267, 267, 
	-1, -1, -1, -1, -1, -1, -1, 267, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 267, 267, 267, 
	-1, 267, -1, -1, -1, -1, -1, -1, 
	266, 266, 266, 266, -1, -1, 266, 266, 
	-1, 266, 266, 266, -1, -1, -1, -1, 
	266, 266, 266, -1, 266, 266, 266, -1, 
	-1, -1, -1, 266, -1, -1, -1, -1, 
	266, -1, -1, -1, 266, 266, 266, -1, 
	266, 266, -1, -1, 266, -1, -1, -1, 
	-1, -1, -1, -1, -1, 266, 266, 266, 
	266, 266, 266, 266, -1, -1, -1, -1, 
	266, 266, -1, -1, 266, 266, -1, -1, 
	-1, -1, -1, -1, -1, -1, 266, 266, 
	-1, -1, -1, -1, 266, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 266, 266, 266, -1, -1, 
	-1, -1, -1, 266, 266, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 266, 
	-1, -1, -1, -1, -1, -1, 266, -1, 
	-1, -1, -1, 267, 267, 267, -1, 267, 
	267, 267, -1, -1, -1, -1, 267, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 267, 267, 267, 267, 267, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 263, 263, 263, 263, -1, 263, 263, 
	263, -1, -1, -1, -1, 263, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 263, 263, 263, 263, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 264, 264, 264, 264, -1, 
	264, 264, 264, -1, -1, -1, -1, 264, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 266, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 264, 264, 264, 264, -1, 
	-1, -1, -1, -1, -1, -1, 268, 268, 
	268, 268, 268, 268, 268, -1, 268, 268, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 268, 268, 268, 268, 268, -1, -1, 
	-1, 265, -1, -1, -1, -1, -1, -1, 
	268, -1, -1, 265, 268, 265, 265, -1, 
	268, 268, 268, 268, 268, 268, -1, -1, 
	265, -1, 268, 268, 268, 265, -1, -1, 
	-1, 268, 268, -1, 268, 268, 268, 268, 
	-1, -1, -1, -1, -1, -1, -1, 268, 
	-1, -1, -1, -1, 265, 265, 265, -1, 
	-1, -1, -1, -1, 265, 268, 268, 268, 
	-1, 268, 269, 269, 269, 269, 269, 269, 
	269, -1, 269, 269, -1, -1, -1, 265, 
	-1, -1, -1, -1, -1, 269, 269, 269, 
	269, 269, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 269, -1, -1, -1, 
	269, -1, -1, -1, 269, 269, 269, 269, 
	269, 269, -1, -1, -1, -1, 269, 269, 
	269, -1, -1, -1, -1, 269, 269, -1, 
	269, 269, 269, 269, -1, -1, -1, -1, 
	-1, -1, -1, 269, -1, 270, 270, 270, 
	270, 270, 270, 270, -1, 270, 270, -1, 
	-1, 269, 269, 269, -1, 269, -1, -1, 
	270, 270, 270, 270, 270, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 270, 
	-1, -1, -1, 270, -1, -1, -1, 270, 
	270, 270, 270, 270, 270, -1, -1, -1, 
	-1, 270, 270, 270, -1, -1, -1, -1, 
	270, 270, -1, 270, 270, 270, 270, -1, 
	-1, -1, -1, 268, 268, 268, 270, 268, 
	268, 268, -1, -1, -1, -1, 268, -1, 
	-1, -1, -1, -1, 270, 270, 270, -1, 
	270, -1, -1, -1, -1, 271, 271, 271, 
	271, 271, 271, 271, -1, 271, 271, -1, 
	-1, -1, 268, 268, 268, 268, 268, -1, 
	271, 271, 271, 271, 271, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 271, 
	-1, -1, -1, 271, -1, -1, -1, 271, 
	271, 271, 271, 271, 271, -1, -1, -1, 
	-1, 271, 271, 271, -1, -1, -1, -1, 
	271, 271, -1, 271, 271, 271, 271, 269, 
	269, 269, -1, 269, 269, 269, 271, -1, 
	-1, -1, 269, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 271, 271, 271, -1, 
	271, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 269, 269, 
	269, 269, 269, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 270, 270, 270, -1, 270, 270, 
	270, -1, -1, -1, -1, 270, -1, 267, 
	267, 267, -1, 267, 267, 267, -1, -1, 
	-1, -1, 267, -1, 272, 272, 272, 272, 
	272, 272, 272, -1, 272, 272, -1, -1, 
	-1, 270, 270, 270, 270, 270, -1, 272, 
	272, 272, 272, 272, -1, -1, 267, 267, 
	267, 267, -1, -1, -1, -1, 272, -1, 
	-1, -1, 272, -1, -1, -1, 272, 272, 
	272, 272, 272, 272, -1, -1, -1, -1, 
	272, 272, 272, -1, -1, -1, -1, 272, 
	272, -1, 272, 272, 272, 272, -1, -1, 
	-1, -1, 271, 271, 271, 272, 271, 271, 
	271, -1, -1, -1, -1, 271, -1, -1, 
	-1, -1, -1, 272, 272, 272, -1, 272, 
	-1, -1, -1, 273, 273, 273, 273, 273, 
	273, 273, -1, 273, 273, -1, -1, -1, 
	-1, 271, 271, 271, 271, 271, 273, 273, 
	273, 273, 273, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 273, -1, -1, 
	-1, 273, -1, -1, -1, 273, 273, 273, 
	273, 273, 273, -1, -1, -1, -1, 273, 
	273, 273, -1, -1, -1, -1, 273, 273, 
	-1, 273, 273, 273, 273, -1, -1, -1, 
	-1, -1, -1, -1, 273, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 273, 273, 273, -1, 273, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 272, 272, 272, -1, 272, 272, 272, 
	-1, -1, -1, -1, 272, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 274, 274, 274, 274, 274, 274, 
	274, -1, 274, 274, -1, -1, -1, -1, 
	272, 272, 272, 272, 272, 274, 274, 274, 
	274, 274, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 274, -1, -1, -1, 
	274, -1, -1, -1, 274, 274, 274, 274, 
	274, 274, -1, -1, -1, -1, 274, 274, 
	274, -1, -1, -1, -1, 274, 274, -1, 
	274, 274, 274, 274, -1, -1, -1, -1, 
	-1, 273, 273, 274, 273, 273, 273, -1, 
	-1, -1, -1, 273, -1, -1, -1, -1, 
	-1, 274, 274, 274, -1, 274, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 273, 
	273, 273, 273, 273, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 681, 681, 
	681, 681, 681, 681, 681, 681, 681, -1, 
	681, 681, -1, -1, 681, 681, 681, 681, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 681, 681, 681, 268, 
	268, 268, 681, 268, 268, 268, -1, 681, 
	-1, -1, 268, -1, -1, 681, 681, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 681, -1, -1, 681, 681, 
	681, 681, -1, -1, -1, -1, 268, 268, 
	268, 268, -1, 681, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	274, 274, -1, 274, 274, 274, -1, -1, 
	-1, -1, 274, 269, 269, 269, -1, 269, 
	269, 269, -1, -1, -1, -1, 269, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 274, 274, 
	274, 274, 274, -1, -1, -1, -1, -1, 
	-1, -1, 269, 269, 269, 269, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 270, 270, 
	270, -1, 270, 270, 270, -1, -1, -1, 
	-1, 270, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 681, -1, -1, -1, 
	-1, -1, -1, 681, -1, -1, -1, -1, 
	681, 681, -1, -1, -1, 270, 270, 270, 
	270, -1, -1, 681, -1, -1, -1, -1, 
	681, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 681, 
	681, 681, -1, -1, -1, -1, -1, 681, 
	681, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 271, 271, 
	271, -1, 271, 271, 271, -1, -1, -1, 
	-1, 271, 275, 275, 275, 275, 275, 275, 
	275, -1, 275, 275, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 275, 275, 275, 
	275, 275, -1, -1, -1, 271, 271, 271, 
	271, -1, -1, -1, 275, -1, -1, -1, 
	275, -1, -1, -1, 275, 275, 275, 275, 
	275, 275, -1, -1, -1, -1, 275, 275, 
	275, -1, -1, -1, -1, 275, 275, -1, 
	275, 275, 275, 275, -1, -1, -1, -1, 
	-1, -1, -1, 275, -1, -1, 276, 276, 
	276, 276, 276, 276, 276, -1, 276, 276, 
	-1, 275, 275, 275, -1, 275, -1, -1, 
	-1, 276, 276, 276, 276, 276, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	276, -1, -1, -1, 276, -1, -1, -1, 
	276, 276, 276, 276, 276, 276, -1, -1, 
	-1, -1, 276, 276, 276, -1, -1, -1, 
	-1, 276, 276, -1, 276, 276, 276, 276, 
	-1, -1, -1, -1, -1, -1, -1, 276, 
	-1, -1, -1, -1, -1, 272, 272, 272, 
	-1, 272, 272, 272, -1, 276, 276, 276, 
	272, 276, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 272, 272, 272, 272, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 275, -1, 275, 275, 275, -1, -1, 
	-1, -1, 275, -1, -1, 273, 273, -1, 
	273, 273, 273, -1, -1, -1, -1, 273, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 275, 275, 
	275, 275, 275, -1, -1, -1, -1, -1, 
	-1, -1, -1, 273, 273, 273, 273, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 276, -1, 276, 
	276, 276, -1, -1, -1, -1, 276, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 279, 279, 279, 279, 
	279, 279, 279, -1, 279, 279, -1, -1, 
	-1, -1, 276, 276, 276, 276, 276, 279, 
	279, 279, 279, 279, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 279, -1, 
	-1, -1, 279, -1, -1, -1, 279, 279, 
	279, 279, 279, 279, -1, -1, -1, -1, 
	279, 279, 279, -1, -1, -1, -1, 279, 
	279, -1, 279, 279, 279, 279, -1, -1, 
	-1, -1, -1, -1, -1, 279, 279, -1, 
	-1, -1, -1, -1, 274, 274, -1, 274, 
	274, 274, -1, 279, 279, 279, 274, 279, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 274, 274, 274, 274, 278, 278, 
	278, 278, 278, 278, 278, 278, 278, 278, 
	278, 278, 278, 278, 278, 278, 278, 278, 
	278, 278, 278, 278, 278, 278, 278, 278, 
	278, 278, 278, 278, 278, 278, -1, 278, 
	-1, 278, 278, 278, 278, 278, 278, -1, 
	278, 278, 278, -1, -1, 278, 278, 278, 
	278, 278, 278, 278, 278, -1, 278, 278, 
	278, 278, -1, -1, -1, 278, 278, 278, 
	278, 278, -1, -1, 278, 278, 278, 278, 
	-1, -1, -1, 278, 278, -1, -1, 278, 
	278, -1, 278, 278, 278, 278, -1, -1, 
	278, -1, 278, -1, -1, -1, -1, -1, 
	-1, -1, 278, -1, 279, 279, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 279, 
	279, 279, 279, 279, -1, 279, 279, 279, 
	-1, -1, -1, -1, 279, -1, -1, -1, 
	-1, -1, -1, -1, 278, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 278, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	279, 279, 279, 279, 279, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 278, 278, 278, 278, -1, -1, 
	278, 278, 278, 278, 278, 278, -1, -1, 
	-1, -1, 278, 278, 278, 278, 278, 278, 
	278, -1, -1, 278, -1, 278, -1, -1, 
	-1, -1, 278, 278, -1, 278, 278, 278, 
	278, -1, 278, 278, -1, -1, 278, -1, 
	-1, -1, -1, -1, 278, -1, 278, 278, 
	278, 278, 278, 278, 278, 278, -1, -1, 
	-1, -1, 278, 278, -1, 278, 278, 278, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	278, 278, 278, -1, 278, -1, 278, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	278, 278, 278, -1, -1, 278, 278, 278, 
	-1, -1, -1, -1, -1, 278, 278, 316, 
	316, 316, 316, 316, 316, 316, -1, 316, 
	316, 278, -1, 278, -1, -1, 278, 278, 
	278, -1, 316, 316, 316, 316, 316, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 316, -1, -1, -1, 316, -1, -1, 
	-1, 316, 316, 316, 316, 316, 316, -1, 
	-1, -1, -1, 316, 316, 316, -1, -1, 
	-1, -1, 316, 316, -1, 316, 316, 316, 
	316, -1, -1, -1, -1, -1, -1, -1, 
	316, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 316, 316, 
	316, -1, 316, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 275, -1, 275, 
	275, 275, -1, -1, -1, -1, 275, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 275, 275, 275, 275, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 276, -1, 276, 276, 276, -1, -1, 
	-1, -1, 276, -1, 278, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 276, 276, 
	276, 276, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 316, 316, 316, 316, 316, -1, 
	316, 316, 316, -1, -1, -1, -1, 316, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 316, 316, 316, 316, 316, 
	-1, 280, 280, 280, 280, 280, 280, 280, 
	280, 280, 280, 280, 280, 280, 280, 280, 
	280, 280, 280, 280, 280, 280, 280, 280, 
	280, 280, 280, -1, 280, 280, 280, 280, 
	280, -1, 280, -1, 280, 280, 280, 280, 
	-1, 280, -1, 280, 280, 280, -1, -1, 
	280, 280, 280, 280, 280, 280, 280, 280, 
	-1, 280, 280, 280, -1, -1, -1, -1, 
	280, 280, 280, 280, 280, -1, -1, 280, 
	280, 280, 280, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 280, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	279, 279, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 279, 279, 279, 279, 279, 
	-1, 279, 279, 279, -1, -1, -1, -1, 
	279, -1, -1, -1, -1, 280, 280, 280, 
	280, -1, -1, 280, 280, -1, 280, 280, 
	280, -1, -1, -1, -1, 280, 280, 280, 
	-1, 280, 280, 280, 279, 279, 279, 279, 
	280, -1, -1, -1, -1, 280, -1, -1, 
	-1, 280, 280, 280, -1, 280, 280, -1, 
	-1, 280, -1, -1, -1, -1, -1, -1, 
	-1, -1, 280, 280, 280, 280, 280, 280, 
	280, -1, -1, -1, -1, 280, 280, -1, 
	-1, 280, 280, -1, -1, -1, -1, -1, 
	-1, -1, -1, 280, 280, -1, -1, -1, 
	-1, 280, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	280, 280, 280, -1, -1, -1, -1, -1, 
	280, 280, -1, -1, -1, -1, 278, -1, 
	-1, -1, -1, -1, 280, -1, -1, -1, 
	-1, -1, -1, 280, 282, 282, 282, 282, 
	282, 282, 282, 282, 282, 282, 282, 282, 
	282, 282, 282, -1, 282, 282, 282, 282, 
	282, 282, 282, 282, -1, -1, -1, 282, 
	282, 282, 282, 282, -1, 282, -1, 282, 
	282, 282, 282, -1, 282, -1, 282, 282, 
	282, -1, -1, 282, -1, -1, 282, 282, 
	282, 282, 282, -1, 282, 282, 282, -1, 
	-1, -1, -1, 282, 282, 282, 282, 282, 
	-1, -1, 282, 282, 282, 282, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 280, 
	282, 282, 282, 282, -1, -1, 282, 282, 
	282, 282, 282, 282, -1, -1, -1, -1, 
	282, 282, 282, 282, 282, 282, 282, -1, 
	-1, -1, -1, 282, -1, -1, -1, -1, 
	282, -1, -1, -1, 282, 282, 282, -1, 
	282, 282, -1, -1, 282, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	282, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 282, 282, -1, -1, 
	-1, -1, -1, -1, -1, -1, 282, 282, 
	-1, -1, -1, -1, 282, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 282, 282, 282, -1, -1, 
	-1, -1, -1, 282, 282, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 282, 
	-1, 282, 283, 283, 283, 283, 283, 283, 
	283, 283, 283, 283, 283, 283, 283, 283, 
	283, -1, 283, 283, 283, 283, 283, 283, 
	283, 283, -1, -1, -1, 283, 283, 283, 
	283, 283, -1, 283, -1, 283, 283, 283, 
	283, -1, 283, -1, 283, 283, 283, -1, 
	-1, 283, -1, -1, 283, 283, 283, 283, 
	283, -1, 283, 283, 283, -1, -1, -1, 
	-1, 283, 283, 283, 283, 283, -1, -1, 
	283, 283, 283, 283, -1, 287, 287, 287, 
	287, 287, 287, 287, 287, 287, 287, 287, 
	287, -1, -1, 287, 287, 287, 287, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 287, 287, 287, -1, -1, 
	-1, 287, -1, -1, -1, -1, 287, -1, 
	-1, -1, -1, -1, 287, 287, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 287, -1, -1, 287, 287, 287, 
	287, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 287, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 283, 283, 
	283, 283, 282, -1, 283, 283, 283, 283, 
	283, 283, -1, -1, -1, -1, 283, 283, 
	283, 283, 283, 283, 283, -1, -1, -1, 
	-1, 283, -1, -1, -1, -1, 283, 283, 
	-1, -1, 283, 283, 283, -1, 283, 283, 
	-1, -1, 283, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 283, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 283, 283, -1, -1, -1, -1, 
	-1, -1, -1, -1, 283, 283, -1, -1, 
	-1, -1, 283, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 283, 283, 283, -1, -1, -1, -1, 
	-1, 283, 283, -1, -1, -1, -1, -1, 
	-1, -1, -1, 287, -1, 283, -1, 283, 
	-1, -1, 283, 287, 287, -1, -1, 287, 
	287, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 287, -1, -1, -1, -1, 287, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 287, 287, 
	287, -1, -1, -1, -1, -1, 287, 287, 
	-1, -1, 288, 288, 288, 288, 288, 288, 
	288, 288, 288, 288, 288, 288, 288, 288, 
	288, 287, 288, 288, 288, 288, 288, 288, 
	288, 288, -1, -1, -1, 288, 288, 288, 
	288, 288, -1, 288, -1, 288, 288, 288, 
	288, -1, 288, -1, 288, 288, 288, -1, 
	-1, 288, -1, -1, 288, 288, 288, 288, 
	288, -1, 288, 288, 288, -1, -1, -1, 
	-1, 288, 288, 288, 288, 288, -1, -1, 
	288, 288, 288, 288, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	283, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 288, 288, 
	288, 288, -1, -1, 288, 288, -1, 288, 
	288, 288, -1, -1, -1, -1, 288, 288, 
	288, -1, 288, 288, 288, -1, -1, -1, 
	-1, 288, -1, -1, -1, -1, 288, 288, 
	-1, -1, 288, 288, 288, -1, 288, 288, 
	-1, -1, 288, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 288, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 288, 288, -1, -1, -1, -1, 
	-1, -1, -1, -1, 288, 288, -1, -1, 
	-1, -1, 288, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 288, 288, 288, -1, -1, -1, -1, 
	-1, 288, 288, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 288, -1, -1, 
	-1, -1, 288, -1, -1, 289, 289, 289, 
	289, 289, 289, 289, 289, 289, 289, 289, 
	289, 289, 289, 289, 289, 289, 289, 289, 
	289, 289, 289, 289, 289, 289, 289, -1, 
	289, 289, 289, 289, 289, -1, 289, -1, 
	289, 289, 289, 289, -1, 289, -1, 289, 
	289, 289, -1, -1, 289, 289, 289, 289, 
	289, 289, 289, 289, -1, 289, 289, 289, 
	-1, -1, -1, -1, 289, 289, 289, 289, 
	289, -1, -1, 289, 289, 289, 289, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 289, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	288, 289, 289, 289, 289, -1, -1, 289, 
	289, -1, 289, 289, 289, -1, -1, -1, 
	-1, 289, 289, 289, -1, 289, 289, 289, 
	-1, -1, -1, -1, 289, -1, -1, -1, 
	-1, 289, -1, -1, -1, 289, 289, 289, 
	-1, 289, 289, -1, -1, 289, -1, -1, 
	-1, -1, -1, -1, -1, -1, 289, 289, 
	289, 289, 289, 289, 289, -1, -1, -1, 
	-1, 289, 289, -1, -1, 289, 289, 287, 
	-1, -1, -1, -1, -1, -1, -1, 289, 
	289, -1, -1, 287, 287, 289, -1, -1, 
	-1, -1, -1, -1, -1, -1, 287, -1, 
	-1, -1, -1, 287, -1, -1, -1, -1, 
	-1, -1, -1, -1, 289, 289, 289, -1, 
	-1, -1, -1, -1, 289, 289, -1, -1, 
	-1, -1, 287, 287, 287, -1, -1, -1, 
	289, -1, 287, -1, -1, -1, -1, 289, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 287, 291, 291, 
	291, 291, 291, 291, 291, 291, 291, 291, 
	291, 291, 291, 291, 291, 291, 291, 291, 
	291, 291, 291, 291, 291, 291, 291, 291, 
	-1, 291, 291, 291, 291, 291, -1, 291, 
	-1, 291, 291, 291, 291, -1, 291, -1, 
	291, 291, 291, -1, -1, 291, 291, 291, 
	291, 291, 291, 291, 291, -1, 291, 291, 
	291, -1, -1, -1, -1, 291, 291, 291, 
	291, 291, -1, -1, 291, 291, 291, 291, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 291, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 289, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 291, 291, 291, 291, -1, -1, 
	291, 291, -1, 291, 291, 291, -1, -1, 
	-1, -1, 291, 291, 291, -1, 291, 291, 
	291, -1, -1, -1, -1, 291, -1, -1, 
	-1, -1, 291, -1, -1, -1, 291, 291, 
	291, -1, 291, 291, -1, -1, 291, -1, 
	-1, -1, -1, -1, -1, -1, -1, 291, 
	291, 291, 291, 291, 291, 291, -1, -1, 
	-1, -1, 291, 291, -1, -1, 291, 291, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	291, 291, -1, -1, -1, -1, 291, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 291, 291, 291, 
	-1, -1, -1, -1, -1, 291, 291, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 291, -1, -1, -1, -1, -1, -1, 
	291, 292, 292, 292, 292, 292, 292, 292, 
	292, 292, 292, 292, 292, 292, 292, 292, 
	292, 292, 292, 292, 292, 292, 292, 292, 
	292, 292, 292, -1, 292, 292, 292, 292, 
	292, -1, 292, -1, 292, 292, 292, 292, 
	-1, 292, -1, 292, 292, 292, -1, -1, 
	292, 292, 292, 292, 292, 292, 292, 292, 
	-1, 292, 292, 292, -1, -1, -1, -1, 
	292, 292, 292, 292, 292, -1, -1, 292, 
	292, 292, 292, -1, 294, 294, 294, 294, 
	294, 294, 294, 294, 294, 292, 294, 294, 
	-1, -1, 294, 294, 294, 294, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 294, 294, 294, -1, -1, -1, 
	294, -1, -1, -1, -1, 294, -1, -1, 
	-1, -1, -1, 294, 294, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 294, -1, -1, 294, 294, 294, 294, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 294, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 291, 292, 292, 292, 
	292, -1, -1, 292, 292, -1, 292, 292, 
	292, -1, -1, -1, -1, 292, 292, 292, 
	-1, 292, 292, 292, -1, -1, -1, -1, 
	292, -1, -1, -1, -1, 292, -1, -1, 
	-1, 292, 292, 292, -1, 292, 292, -1, 
	-1, 292, -1, -1, -1, -1, -1, -1, 
	-1, -1, 292, 292, 292, 292, 292, 292, 
	292, -1, -1, -1, -1, 292, 292, -1, 
	-1, 292, 292, -1, -1, -1, -1, -1, 
	-1, -1, -1, 292, 292, -1, -1, -1, 
	-1, 292, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	292, 292, 292, -1, -1, -1, -1, -1, 
	292, 292, -1, -1, -1, -1, -1, -1, 
	-1, -1, 294, -1, 292, -1, -1, -1, 
	-1, 294, -1, 292, -1, -1, 294, 294, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 294, -1, -1, -1, -1, 294, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 294, 294, 294, 
	-1, -1, -1, -1, -1, 294, 294, -1, 
	-1, -1, 298, 298, 298, 298, 298, 298, 
	298, 298, 298, 298, 298, 298, 298, 298, 
	298, -1, 298, 298, 298, 298, 298, 298, 
	298, 298, -1, -1, -1, 298, 298, 298, 
	298, 298, -1, 298, -1, 298, 298, 298, 
	298, -1, 298, -1, 298, 298, 298, -1, 
	-1, 298, -1, -1, 298, 298, 298, 298, 
	298, -1, 298, 298, 298, 298, -1, -1, 
	-1, 298, 298, 298, 298, 298, -1, 298, 
	298, 298, 298, 298, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 292, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 291, 291, 291, 298, 298, 
	298, 298, -1, -1, 298, 298, 298, 298, 
	298, 298, -1, -1, -1, -1, 298, 298, 
	298, 298, 298, 298, 298, -1, 298, 298, 
	-1, 298, -1, -1, -1, -1, 298, 298, 
	-1, -1, 298, 298, 298, -1, 298, 298, 
	-1, -1, 298, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 298, -1, 
	-1, -1, -1, 328, 328, 328, 328, 328, 
	328, -1, 298, 298, -1, -1, -1, -1, 
	-1, -1, -1, -1, 298, 298, -1, -1, 
	-1, -1, 298, -1, -1, -1, 328, 328, 
	328, 328, 328, -1, 328, -1, 328, -1, 
	-1, -1, -1, 328, -1, -1, 328, -1, 
	-1, 298, 298, 298, -1, 328, 328, 328, 
	-1, 298, 298, 328, 328, 328, -1, -1, 
	-1, -1, 328, 328, 328, 298, 328, 298, 
	-1, -1, 298, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 299, 299, 
	299, 299, 299, 299, 299, 299, 299, 299, 
	299, 299, 299, 299, 299, -1, 299, 299, 
	299, 299, 299, 299, 299, 299, -1, -1, 
	-1, 299, 299, 299, 299, 299, -1, 299, 
	-1, 299, 299, 299, 299, -1, 299, -1, 
	299, 299, 299, -1, -1, 299, -1, -1, 
	299, 299, 299, 299, 299, -1, 299, 299, 
	299, 299, -1, -1, -1, 299, 299, 299, 
	299, 299, -1, 299, 299, 299, 299, 299, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 328, 328, -1, -1, 328, 328, 328, 
	328, -1, 328, 299, -1, -1, -1, 328, 
	328, 328, 328, 328, 328, 328, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 328, 328, 328, -1, 328, 
	328, -1, -1, 328, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 328, -1, -1, -1, -1, 
	298, -1, -1, -1, -1, 328, 328, -1, 
	-1, -1, 299, 299, 299, 299, -1, -1, 
	299, 299, 299, 299, 299, 299, -1, -1, 
	-1, -1, 299, 299, 299, 299, 299, 299, 
	299, -1, 299, 299, 299, 299, -1, -1, 
	-1, -1, 299, 299, -1, -1, 299, 299, 
	299, -1, 299, 299, -1, -1, 299, -1, 
	328, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 299, -1, -1, -1, 294, -1, 
	-1, -1, -1, -1, -1, 294, 299, 299, 
	-1, -1, 294, 294, -1, -1, -1, -1, 
	299, 299, -1, -1, -1, 294, 299, -1, 
	-1, -1, 294, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 299, 299, 299, 
	-1, 294, 294, 294, -1, 299, 299, -1, 
	-1, 294, -1, -1, -1, -1, -1, -1, 
	-1, 299, -1, 299, -1, -1, 299, -1, 
	-1, 301, 301, 301, 301, 301, 301, 301, 
	301, 301, 301, 301, 301, 301, 301, 301, 
	301, 301, 301, 301, 301, 301, 301, 301, 
	301, 301, 301, -1, 301, 301, 301, 301, 
	301, -1, 301, -1, 301, 301, 301, 301, 
	301, 301, -1, 301, 301, 301, -1, -1, 
	301, 301, 301, 301, 301, 301, 301, 301, 
	-1, 301, 301, 301, 301, -1, -1, -1, 
	301, 301, 301, 301, 301, -1, -1, 301, 
	301, 301, 301, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 301, -1, -1, 
	301, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 301, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 299, 301, 301, 301, 
	301, -1, -1, 301, 301, 301, 301, 301, 
	301, -1, -1, -1, -1, 301, 301, 301, 
	301, 301, 301, 301, -1, -1, 301, -1, 
	301, -1, -1, -1, -1, 301, 301, -1, 
	301, 301, 301, 301, -1, 301, 301, -1, 
	-1, 301, -1, -1, -1, -1, -1, 301, 
	-1, 301, 301, 301, 301, 301, 301, 301, 
	301, -1, -1, -1, -1, 301, 301, -1, 
	301, 301, 301, -1, -1, -1, -1, -1, 
	-1, -1, -1, 301, 301, -1, -1, -1, 
	-1, 301, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	301, 301, 301, -1, -1, -1, -1, -1, 
	301, 301, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 301, -1, 301, -1, 
	-1, 301, 301, 301, 304, 304, 304, 304, 
	304, 304, 304, 304, 304, 304, 304, 304, 
	304, 304, 304, 304, 304, 304, 304, 304, 
	304, 304, 304, 304, 304, 304, -1, 304, 
	304, 304, 304, 304, -1, 304, -1, 304, 
	304, 304, 304, -1, 304, -1, 304, 304, 
	304, 304, 304, 304, 304, 304, 304, 304, 
	304, 304, 304, 304, 304, 304, 304, -1, 
	304, 304, 304, 304, 304, 304, 304, 304, 
	304, 304, 304, 304, 304, 304, 304, -1, 
	304, -1, -1, 304, -1, 304, 304, 304, 
	304, 304, -1, -1, 304, 304, 304, 304, 
	304, 304, 304, 304, 304, 304, 304, 304, 
	304, 304, 304, 304, -1, -1, -1, -1, 
	-1, 304, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 301, 
	304, 304, 304, 304, -1, -1, 304, 304, 
	304, 304, 304, 304, -1, -1, -1, -1, 
	304, 304, 304, 304, 304, 304, 304, -1, 
	299, -1, -1, 304, -1, -1, -1, -1, 
	304, 304, -1, -1, 304, 304, 304, -1, 
	304, 304, -1, -1, 304, -1, -1, -1, 
	-1, -1, -1, -1, -1, 304, 304, 304, 
	304, 304, 304, 304, -1, -1, -1, 304, 
	304, 304, -1, -1, 304, 304, -1, 304, 
	304, 304, 304, 304, 304, 304, 304, 304, 
	-1, -1, -1, 304, 304, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 304, 
	304, 304, -1, -1, 304, -1, -1, -1, 
	-1, 304, -1, 304, 304, 304, 304, -1, 
	304, 304, 304, 304, 304, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 304, 
	-1, 304, -1, -1, 304, -1, 304, 304, 
	-1, -1, -1, 304, -1, 304, -1, 304, 
	305, 305, 305, 305, 305, 305, 305, 305, 
	305, 305, 305, 305, 305, 305, 305, 305, 
	305, 305, 305, 305, 305, 305, 305, 305, 
	305, 305, -1, 305, 305, 305, 305, 305, 
	-1, 305, -1, 305, 305, 305, 305, -1, 
	305, -1, 305, 305, 305, 305, 305, 305, 
	305, 305, 305, 305, 305, 305, 305, 305, 
	305, 305, 305, -1, 305, 305, 305, 305, 
	305, 305, 305, 305, 305, 305, 305, 305, 
	305, 305, 305, -1, 305, -1, -1, 305, 
	-1, 305, 305, 305, 305, 305, -1, -1, 
	305, 305, 305, 305, 305, 305, 305, 305, 
	305, 305, 305, 305, 305, 305, 305, 305, 
	-1, -1, -1, -1, -1, 305, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 304, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 305, 305, 305, 305, 
	-1, -1, 305, 305, 305, 305, 305, 305, 
	-1, -1, -1, -1, 305, 305, 305, 305, 
	305, 305, 305, -1, -1, -1, -1, 305, 
	-1, -1, -1, -1, 305, 305, -1, -1, 
	305, 305, 305, -1, 305, 305, -1, -1, 
	305, -1, -1, -1, -1, -1, -1, -1, 
	-1, 305, 305, 305, 305, 305, 305, 305, 
	-1, -1, -1, 305, 305, 305, 305, -1, 
	305, 305, -1, 305, 305, 305, 305, 305, 
	305, 305, 305, 305, -1, -1, -1, 305, 
	305, 305, -1, -1, -1, 305, 305, -1, 
	-1, -1, -1, 305, 305, 305, -1, -1, 
	305, -1, -1, -1, -1, 305, -1, 305, 
	305, 305, 305, -1, 305, 305, 305, 305, 
	305, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 305, -1, 305, -1, -1, 
	305, -1, 305, 305, -1, 305, -1, 305, 
	-1, 305, -1, 305, 306, 306, 306, 306, 
	306, 306, 306, 306, 306, 306, 306, 306, 
	306, 306, 306, 306, 306, 306, 306, 306, 
	306, 306, 306, 306, 306, 306, -1, 306, 
	306, 306, 306, 306, -1, 306, -1, 306, 
	306, 306, 306, -1, 306, -1, 306, 306, 
	306, 306, 306, 306, 306, 306, 306, 306, 
	306, 306, 306, 306, 306, 306, 306, -1, 
	306, 306, 306, 306, 306, 306, 306, 306, 
	306, 306, 306, 306, 306, 306, 306, -1, 
	306, -1, -1, 306, -1, 306, 306, 306, 
	306, 306, -1, -1, 306, 306, 306, 306, 
	306, 306, 306, 306, 306, 306, 306, 306, 
	306, 306, 306, 306, -1, -1, -1, -1, 
	-1, 306, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 305, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	306, 306, 306, 306, -1, -1, 306, 306, 
	306, 306, 306, 306, -1, -1, -1, -1, 
	306, 306, 306, 306, 306, 306, 306, -1, 
	-1, -1, -1, 306, -1, -1, -1, -1, 
	306, 306, -1, -1, 306, 306, 306, -1, 
	306, 306, -1, -1, 306, -1, -1, -1, 
	-1, -1, -1, -1, -1, 306, 306, 306, 
	306, 306, 306, 306, -1, -1, -1, 306, 
	306, 306, 306, -1, 306, 306, -1, 306, 
	306, 306, 306, 306, 306, 306, 306, 306, 
	-1, -1, -1, 306, 306, 306, -1, -1, 
	-1, 306, 306, -1, -1, -1, -1, 306, 
	306, 306, -1, -1, 306, -1, -1, -1, 
	-1, 306, -1, 306, 306, 306, 306, -1, 
	306, 306, 306, 306, 306, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 306, 
	-1, 306, -1, -1, 306, -1, 306, 306, 
	-1, 306, -1, 306, -1, 306, -1, 306, 
	308, 308, 308, 308, 308, 308, 308, 308, 
	308, 308, 308, 308, 308, 308, 308, 308, 
	308, 308, 308, 308, 308, 308, 308, 308, 
	308, 308, -1, 308, 308, 308, 308, 308, 
	-1, 308, -1, 308, 308, 308, 308, -1, 
	308, -1, 308, 308, 308, 308, 308, 308, 
	308, 308, 308, 308, 308, 308, 308, 308, 
	308, 308, 308, -1, 308, 308, 308, 308, 
	308, 308, 308, 308, 308, 308, 308, 308, 
	308, 308, 308, -1, 308, -1, -1, 308, 
	-1, 308, 308, 308, 308, 308, -1, -1, 
	308, 308, 308, 308, 308, 308, 308, 308, 
	308, 308, 308, 308, 308, 308, 308, 308, 
	-1, -1, -1, -1, -1, 308, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 306, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 308, 308, 308, 308, 
	-1, -1, 308, 308, 308, 308, 308, 308, 
	-1, -1, -1, -1, 308, 308, 308, 308, 
	308, 308, 308, -1, -1, -1, -1, 308, 
	-1, -1, -1, -1, 308, 308, -1, -1, 
	308, 308, 308, -1, 308, 308, -1, -1, 
	308, -1, -1, -1, -1, -1, -1, -1, 
	-1, 308, 308, 308, 308, 308, 308, 308, 
	-1, -1, -1, 308, 308, 308, -1, -1, 
	308, 308, -1, 308, 308, 308, 308, 308, 
	308, 308, 308, 308, -1, -1, -1, 308, 
	308, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 308, 308, 308, -1, -1, 
	308, -1, -1, -1, -1, 308, -1, 308, 
	308, 308, 308, -1, 308, 308, 308, 308, 
	308, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 308, -1, 308, -1, -1, 
	308, -1, 308, 308, -1, -1, -1, 308, 
	-1, 308, -1, 308, 309, 309, 309, 309, 
	309, 309, 309, 309, 309, 309, 309, 309, 
	309, 309, 309, 309, 309, 309, 309, 309, 
	309, 309, 309, 309, 309, 309, -1, 309, 
	309, 309, 309, 309, -1, 309, -1, 309, 
	309, 309, 309, -1, 309, -1, 309, 309, 
	309, 309, 309, 309, 309, 309, 309, 309, 
	309, 309, 309, 309, 309, 309, 309, -1, 
	309, 309, 309, 309, 309, 309, 309, 309, 
	309, 309, 309, 309, 309, 309, 309, -1, 
	309, -1, -1, 309, -1, 309, 309, 309, 
	309, 309, -1, -1, 309, 309, 309, 309, 
	309, 309, 309, 309, 309, 309, 309, 309, 
	309, 309, 309, 309, -1, -1, -1, -1, 
	-1, 309, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 308, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	309, 309, 309, 309, -1, -1, 309, 309, 
	309, 309, 309, 309, -1, -1, -1, -1, 
	309, 309, 309, 309, 309, 309, 309, -1, 
	-1, -1, -1, 309, -1, -1, -1, -1, 
	309, 309, -1, -1, 309, 309, 309, -1, 
	309, 309, -1, -1, 309, -1, -1, -1, 
	-1, -1, -1, -1, -1, 309, 309, 309, 
	309, 309, 309, 309, -1, -1, -1, 309, 
	309, 309, 309, -1, 309, 309, -1, 309, 
	309, 309, 309, 309, 309, 309, 309, 309, 
	-1, -1, -1, 309, 309, 309, -1, -1, 
	-1, 309, 309, -1, -1, -1, -1, 309, 
	309, 309, -1, -1, 309, -1, -1, -1, 
	-1, 309, -1, 309, 309, 309, 309, -1, 
	309, 309, 309, 309, 309, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 309, 
	-1, 309, -1, -1, 309, -1, 309, 309, 
	-1, 309, -1, 309, -1, 309, -1, 309, 
	310, 310, 310, 310, 310, 310, 310, 310, 
	310, 310, 310, 310, 310, 310, 310, 310, 
	310, 310, 310, 310, 310, 310, 310, 310, 
	310, 310, -1, 310, 310, 310, 310, 310, 
	-1, 310, -1, 310, 310, 310, 310, -1, 
	310, -1, 310, 310, 310, 310, 310, 310, 
	310, 310, 310, 310, 310, 310, 310, 310, 
	310, 310, 310, -1, 310, 310, 310, 310, 
	310, 310, 310, 310, 310, 310, 310, 310, 
	310, 310, 310, -1, 310, -1, -1, 310, 
	-1, 310, 310, 310, 310, 310, -1, -1, 
	310, 310, 310, 310, 310, 310, 310, 310, 
	310, 310, 310, 310, 310, 310, 310, 310, 
	-1, -1, -1, -1, -1, 310, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 309, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 310, 310, 310, 310, 
	-1, -1, 310, 310, 310, 310, 310, 310, 
	-1, -1, -1, -1, 310, 310, 310, 310, 
	310, 310, 310, -1, -1, -1, -1, 310, 
	-1, -1, -1, -1, 310, 310, -1, -1, 
	310, 310, 310, -1, 310, 310, -1, -1, 
	310, -1, -1, -1, -1, -1, -1, -1, 
	-1, 310, 310, 310, 310, 310, 310, 310, 
	-1, -1, -1, 310, 310, 310, 310, -1, 
	310, 310, -1, 310, 310, 310, 310, 310, 
	310, 310, 310, 310, -1, -1, -1, 310, 
	310, 310, -1, -1, -1, 310, 310, -1, 
	-1, -1, -1, 310, 310, 310, -1, -1, 
	310, -1, -1, -1, -1, 310, -1, 310, 
	310, 310, 310, -1, 310, 310, 310, 310, 
	310, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 310, -1, 310, -1, -1, 
	310, -1, 310, 310, -1, 310, -1, 310, 
	-1, 310, -1, 310, 311, 311, 311, 311, 
	311, 311, 311, 311, 311, 311, 311, 311, 
	311, 311, 311, 311, 311, 311, 311, 311, 
	311, 311, 311, 311, 311, 311, -1, 311, 
	311, 311, 311, 311, -1, 311, -1, 311, 
	311, 311, 311, -1, 311, -1, 311, 311, 
	311, 311, 311, 311, 311, 311, 311, 311, 
	311, 311, 311, 311, 311, 311, 311, -1, 
	311, 311, 311, 311, 311, 311, 311, 311, 
	311, 311, 311, 311, 311, 311, 311, -1, 
	311, -1, -1, 311, -1, 311, 311, 311, 
	311, 311, -1, -1, 311, 311, 311, 311, 
	311, 311, 311, 311, 311, 311, 311, 311, 
	311, 311, 311, 311, -1, -1, -1, -1, 
	-1, 311, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 310, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	311, 311, 311, 311, -1, -1, 311, 311, 
	311, 311, 311, 311, -1, -1, -1, -1, 
	311, 311, 311, 311, 311, 311, 311, -1, 
	-1, -1, -1, 311, -1, -1, -1, -1, 
	311, 311, -1, -1, 311, 311, 311, -1, 
	311, 311, -1, -1, 311, -1, -1, -1, 
	-1, -1, -1, -1, -1, 311, 311, 311, 
	311, 311, 311, 311, -1, -1, -1, 311, 
	311, 311, -1, -1, 311, 311, -1, 311, 
	311, 311, 311, 311, 311, 311, 311, 311, 
	-1, -1, -1, 311, 311, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 311, 
	311, 311, -1, -1, 311, -1, -1, -1, 
	-1, 311, -1, 311, 311, 311, 311, -1, 
	311, 311, 311, 311, 311, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 311, 
	-1, 311, -1, -1, 311, -1, 311, 311, 
	-1, -1, -1, 311, -1, 311, -1, 311, 
	315, 315, 315, 315, 315, 315, 315, -1, 
	315, 315, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 315, 315, 315, 315, 315, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 315, -1, -1, -1, 315, -1, 
	-1, -1, 315, 315, 315, 315, 315, 315, 
	-1, -1, -1, -1, 315, 315, 315, -1, 
	-1, -1, -1, 315, 315, -1, 315, 315, 
	315, 315, -1, -1, -1, -1, -1, -1, 
	-1, 315, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 315, 
	315, 315, -1, 315, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 318, 318, 318, 318, 318, 318, 318, 
	318, 318, 318, 318, 318, 318, 318, 318, 
	318, 318, 318, 318, 318, 318, 318, 318, 
	318, 318, 318, -1, 318, 318, 318, 318, 
	318, -1, 318, -1, 318, 318, 318, 318, 
	-1, 318, 311, 318, 318, 318, 318, 318, 
	318, 318, 318, 318, 318, 318, 318, 318, 
	318, 318, 318, 318, -1, 318, 318, 318, 
	318, 318, 318, 318, 318, 318, 318, 318, 
	318, 318, 318, 318, -1, 318, -1, -1, 
	318, -1, 318, 318, 318, 318, 318, -1, 
	-1, 318, 318, 318, 318, 318, 318, 318, 
	318, 318, 318, 318, 318, 318, 318, 318, 
	318, -1, -1, -1, -1, -1, 318, -1, 
	-1, -1, -1, 315, 315, 315, 315, 315, 
	-1, 315, 315, 315, -1, -1, -1, -1, 
	315, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 315, 315, 315, 315, 
	315, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 318, 318, 318, 
	318, -1, -1, 318, 318, 318, 318, 318, 
	318, -1, -1, -1, -1, 318, 318, 318, 
	318, 318, 318, 318, -1, -1, -1, -1, 
	318, -1, -1, -1, -1, 318, 318, -1, 
	-1, 318, 318, 318, -1, 318, 318, -1, 
	-1, 318, -1, -1, -1, -1, -1, -1, 
	-1, -1, 318, 318, 318, 318, 318, 318, 
	318, -1, -1, -1, 318, 318, 318, -1, 
	-1, 318, 318, -1, 318, 318, 318, 318, 
	318, 318, 318, 318, 318, -1, -1, -1, 
	318, 318, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 318, 318, 318, -1, 
	-1, 318, -1, -1, -1, -1, 318, -1, 
	318, 318, 318, 318, -1, 318, 318, 318, 
	318, 318, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 318, -1, 318, -1, 
	-1, 318, -1, 318, 318, -1, -1, -1, 
	318, -1, 318, -1, 318, 320, 320, 320, 
	320, 320, 320, 320, 320, 320, 320, 320, 
	320, 320, 320, 320, -1, 320, 320, 320, 
	320, 320, 320, 320, 320, -1, -1, -1, 
	320, 320, 320, 320, 320, -1, 320, -1, 
	320, 320, 320, 320, -1, 320, -1, 320, 
	320, 320, -1, -1, 320, -1, -1, 320, 
	320, 320, 320, 320, -1, 320, 320, 320, 
	-1, -1, -1, -1, 320, 320, 320, 320, 
	320, -1, -1, 320, 320, 320, 320, -1, 
	-1, -1, -1, 320, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 320, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 318, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 320, 320, 320, 320, -1, -1, 320, 
	320, 320, 320, 320, 320, -1, -1, -1, 
	-1, 320, 320, 320, 320, 320, 320, 320, 
	-1, -1, -1, -1, 320, -1, -1, -1, 
	-1, 320, 320, -1, -1, 320, 320, 320, 
	-1, 320, 320, -1, -1, 320, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 320, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 320, 320, -1, 
	-1, -1, -1, -1, -1, -1, -1, 320, 
	320, -1, -1, -1, -1, 320, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 320, 320, 320, -1, 
	-1, -1, -1, -1, 320, 320, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	320, -1, 320, -1, -1, 320, -1, -1, 
	321, 321, 321, 321, 321, 321, 321, 321, 
	321, 321, 321, 321, 321, 321, 321, -1, 
	321, 321, 321, 321, 321, 321, 321, 321, 
	-1, -1, -1, 321, 321, 321, 321, 321, 
	-1, 321, -1, 321, 321, 321, 321, -1, 
	321, -1, 321, 321, 321, -1, -1, 321, 
	-1, -1, 321, 321, 321, 321, 321, -1, 
	321, 321, 321, -1, -1, -1, -1, 321, 
	321, 321, 321, 321, -1, -1, 321, 321, 
	321, 321, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 321, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 315, 
	315, 315, 315, 315, -1, 315, 315, 315, 
	-1, -1, -1, -1, 315, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	315, 315, 315, 315, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 320, 321, 321, 321, 321, 
	-1, -1, 321, 321, 321, 321, 321, 321, 
	-1, -1, -1, -1, 321, 321, 321, 321, 
	321, 321, 321, -1, -1, -1, -1, 321, 
	-1, -1, -1, -1, 321, 321, -1, -1, 
	321, 321, 321, -1, 321, 321, -1, -1, 
	321, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 321, -1, -1, -1, 
	-1, 324, 324, 324, 324, 324, 324, -1, 
	321, 321, -1, -1, -1, -1, -1, -1, 
	-1, -1, 321, 321, -1, -1, -1, -1, 
	321, -1, -1, -1, 324, 324, 324, 324, 
	324, -1, 324, -1, 324, -1, -1, -1, 
	-1, 324, -1, -1, 324, -1, -1, 321, 
	321, 321, -1, 324, 324, 324, -1, 321, 
	321, 324, 324, 324, -1, -1, -1, -1, 
	324, 324, 324, 321, 324, 321, -1, -1, 
	321, -1, -1, 329, 329, 329, 329, 329, 
	329, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 329, 329, 
	329, 329, 329, -1, 329, -1, 329, -1, 
	-1, -1, -1, 329, -1, -1, 329, -1, 
	-1, -1, -1, -1, -1, 329, 329, 329, 
	-1, -1, -1, 329, 329, 329, -1, -1, 
	-1, -1, 329, 329, 329, -1, 329, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 324, 
	324, -1, -1, 324, 324, 324, 324, -1, 
	324, -1, -1, -1, -1, 324, 324, 324, 
	324, 324, 324, 324, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 324, 324, 324, -1, 324, 324, -1, 
	-1, 324, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 324, -1, -1, -1, -1, 321, -1, 
	-1, 329, 329, 324, 324, 329, 329, 329, 
	329, -1, 329, -1, -1, -1, -1, 329, 
	329, 329, 329, 329, 329, 329, -1, -1, 
	-1, -1, -1, -1, -1, 330, 330, 330, 
	330, 330, 330, 329, 329, 329, -1, 329, 
	329, -1, -1, 329, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 324, -1, 
	330, 330, 330, 330, 330, -1, 330, -1, 
	330, -1, -1, 329, -1, 330, -1, -1, 
	330, -1, -1, -1, -1, 329, 329, 330, 
	330, 330, -1, -1, -1, 330, 330, 330, 
	-1, -1, -1, -1, 330, 330, 330, -1, 
	330, -1, -1, -1, -1, -1, -1, 331, 
	331, 331, 331, 331, 331, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	329, -1, 331, 331, 331, 331, 331, -1, 
	331, -1, 331, -1, -1, -1, -1, 331, 
	-1, -1, 331, -1, -1, -1, -1, -1, 
	-1, 331, 331, 331, -1, -1, -1, 331, 
	331, 331, -1, -1, -1, -1, 331, 331, 
	331, -1, 331, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 330, 330, -1, -1, 330, 
	330, 330, 330, -1, 330, -1, -1, -1, 
	-1, 330, 330, 330, 330, 330, 330, 330, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 330, 330, 330, 
	-1, 330, 330, -1, -1, 330, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 330, -1, -1, 
	-1, -1, -1, -1, -1, 331, 331, 330, 
	330, 331, 331, 331, 331, -1, 331, -1, 
	-1, -1, -1, 331, 331, 331, 331, 331, 
	331, 331, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 331, 
	331, 331, -1, 331, 331, -1, -1, 331, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 330, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 331, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 331, 331, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 331, 332, 332, 332, 
	332, 332, 332, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	332, 332, 332, 332, 332, -1, 332, -1, 
	332, -1, -1, -1, -1, 332, -1, -1, 
	332, 333, 333, 333, 333, 333, 333, 332, 
	332, 332, -1, -1, -1, 332, 332, 332, 
	-1, -1, -1, -1, 332, 332, 332, -1, 
	332, -1, -1, -1, 333, 333, 333, 333, 
	333, -1, 333, -1, 333, -1, -1, -1, 
	-1, 333, -1, -1, 333, -1, -1, -1, 
	-1, -1, -1, 333, 333, 333, -1, -1, 
	-1, 333, 333, 333, -1, -1, -1, -1, 
	333, 333, 333, -1, 333, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 324, 324, -1, -1, 324, 
	324, 324, 324, -1, 324, -1, -1, -1, 
	-1, 324, 324, 324, 324, 324, 324, 324, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 324, 324, 324, 
	-1, 324, 324, 332, 332, 324, -1, 332, 
	332, 332, 332, -1, 332, -1, -1, -1, 
	-1, 332, 332, 332, 332, 332, 332, 332, 
	-1, -1, -1, -1, -1, 324, -1, -1, 
	-1, -1, -1, -1, -1, 332, 332, 332, 
	-1, 332, 332, -1, -1, 332, -1, 333, 
	333, -1, -1, 333, 333, 333, 333, -1, 
	333, -1, -1, -1, -1, 333, 333, 333, 
	333, 333, 333, 333, -1, 332, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 332, 
	332, 333, 333, 333, -1, 333, 333, -1, 
	-1, 333, 324, -1, -1, -1, -1, -1, 
	-1, -1, 334, 334, 334, 334, 334, 334, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 333, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 333, 333, 334, 334, 334, 
	334, 334, 332, 334, -1, 334, -1, -1, 
	-1, -1, 334, -1, -1, 334, 335, 335, 
	335, 335, 335, 335, 334, 334, 334, -1, 
	-1, -1, 334, 334, 334, -1, -1, -1, 
	-1, 334, 334, 334, -1, 334, -1, -1, 
	-1, 335, 335, 335, 335, 335, 333, 335, 
	-1, 335, -1, -1, -1, -1, 335, -1, 
	-1, 335, -1, -1, -1, -1, -1, -1, 
	335, 335, 335, -1, -1, -1, 335, 335, 
	335, -1, -1, -1, -1, 335, 335, 335, 
	-1, 335, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	334, 334, -1, -1, 334, 334, 334, 334, 
	-1, 334, -1, -1, -1, -1, 334, 334, 
	334, 334, 334, 334, 334, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 334, 334, 334, -1, 334, 334, 
	-1, -1, 334, -1, 335, 335, -1, -1, 
	335, 335, 335, 335, -1, 335, -1, -1, 
	-1, -1, 335, 335, 335, 335, 335, 335, 
	335, -1, 334, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 334, 334, 335, 335, 
	335, -1, 335, 335, -1, -1, 335, -1, 
	-1, -1, -1, -1, -1, -1, -1, 336, 
	336, 336, 336, 336, 336, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 335, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	335, 335, 336, 336, 336, 336, 336, 334, 
	336, -1, 336, -1, -1, -1, -1, 336, 
	-1, -1, 336, 337, 337, 337, 337, 337, 
	337, 336, 336, 336, -1, -1, -1, 336, 
	336, 336, -1, -1, -1, -1, 336, 336, 
	336, -1, 336, -1, -1, -1, 337, 337, 
	337, 337, 337, 335, 337, -1, 337, -1, 
	-1, -1, -1, 337, -1, -1, 337, -1, 
	-1, -1, -1, -1, -1, 337, 337, 337, 
	-1, -1, -1, 337, 337, 337, -1, -1, 
	-1, -1, 337, 337, 337, -1, 337, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 336, 336, -1, 
	-1, 336, 336, 336, 336, -1, 336, -1, 
	-1, -1, -1, 336, 336, 336, 336, 336, 
	336, 336, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 336, 
	336, 336, -1, 336, 336, -1, -1, 336, 
	-1, 337, 337, -1, -1, 337, 337, 337, 
	337, -1, 337, -1, -1, -1, -1, 337, 
	337, 337, 337, 337, 337, 337, -1, 336, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 336, 336, 337, 337, 337, -1, 337, 
	337, -1, -1, 337, -1, -1, -1, -1, 
	-1, -1, -1, -1, 338, 338, 338, 338, 
	338, 338, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 337, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 337, 337, 338, 
	338, 338, 338, 338, 336, 338, -1, 338, 
	-1, -1, -1, -1, 338, -1, -1, 338, 
	339, 339, 339, 339, 339, 339, 338, 338, 
	338, -1, -1, -1, 338, 338, 338, -1, 
	-1, -1, -1, 338, 338, 338, -1, 338, 
	-1, -1, -1, 339, 339, 339, 339, 339, 
	337, 339, -1, 339, -1, -1, -1, -1, 
	339, -1, -1, 339, -1, -1, -1, -1, 
	-1, -1, 339, 339, 339, -1, -1, -1, 
	339, 339, 339, -1, -1, -1, -1, 339, 
	339, 339, -1, 339, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 338, 338, -1, -1, 338, 338, 
	338, 338, -1, 338, -1, -1, -1, -1, 
	338, 338, 338, 338, 338, 338, 338, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 338, 338, 338, -1, 
	338, 338, -1, -1, 338, -1, 339, 339, 
	-1, -1, 339, 339, 339, 339, -1, 339, 
	-1, -1, -1, -1, 339, 339, 339, 339, 
	339, 339, 339, -1, 338, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 338, 338, 
	339, 339, 339, -1, 339, 339, -1, -1, 
	339, -1, -1, -1, -1, -1, -1, -1, 
	-1, 340, 340, 340, 340, 340, 340, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	339, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 339, 339, 340, 340, 340, 340, 
	340, 338, 340, -1, 340, -1, -1, -1, 
	-1, 340, -1, -1, 340, 341, 341, 341, 
	341, 341, 341, 340, 340, 340, -1, -1, 
	-1, 340, 340, 340, -1, -1, -1, -1, 
	340, 340, 340, -1, 340, -1, -1, -1, 
	341, 341, 341, 341, 341, 339, 341, -1, 
	341, -1, -1, -1, -1, 341, -1, -1, 
	341, -1, -1, -1, -1, -1, -1, 341, 
	341, 341, -1, -1, -1, 341, 341, 341, 
	-1, -1, -1, -1, 341, 341, 341, -1, 
	341, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 340, 
	340, -1, -1, 340, 340, 340, 340, -1, 
	340, -1, -1, -1, -1, 340, 340, 340, 
	340, 340, 340, 340, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 340, 340, 340, -1, 340, 340, -1, 
	-1, 340, -1, 341, 341, -1, -1, 341, 
	341, 341, 341, -1, 341, -1, -1, -1, 
	-1, 341, 341, 341, 341, 341, 341, 341, 
	-1, 340, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 340, 340, 341, 341, 341, 
	-1, 341, 341, -1, -1, 341, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 341, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 341, 
	341, -1, -1, -1, -1, -1, 340, -1, 
	-1, 342, 342, 342, 342, 342, 342, 342, 
	342, 342, 342, 342, 342, 342, 342, 342, 
	342, 342, 342, 342, 342, 342, 342, 342, 
	342, 342, 342, -1, 342, 342, 342, 342, 
	342, -1, 342, -1, 342, 342, 342, 342, 
	-1, 342, 341, 342, 342, 342, -1, -1, 
	342, 342, 342, 342, 342, 342, 342, 342, 
	-1, 342, 342, 342, -1, -1, -1, -1, 
	342, 342, 342, 342, 342, -1, -1, 342, 
	342, 342, 342, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 342, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 342, 
	342, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 342, 342, 342, 
	342, -1, -1, 342, 342, 342, 342, 342, 
	342, -1, -1, -1, -1, 342, 342, 342, 
	342, 342, 342, 342, -1, -1, -1, -1, 
	342, -1, -1, -1, -1, 342, 342, -1, 
	-1, 342, 342, 342, -1, 342, 342, -1, 
	-1, 342, -1, -1, -1, -1, -1, -1, 
	-1, -1, 342, 342, 342, 342, 342, 342, 
	342, -1, -1, -1, -1, 342, 342, -1, 
	-1, 342, 342, -1, -1, -1, -1, -1, 
	-1, -1, -1, 342, 342, -1, -1, -1, 
	-1, 342, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	342, 342, 342, -1, -1, -1, -1, -1, 
	342, 342, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 342, -1, 342, -1, 
	-1, 342, -1, 342, 344, 344, 344, 344, 
	344, 344, 344, 344, 344, 344, 344, 344, 
	344, 344, 344, 344, 344, 344, 344, 344, 
	344, 344, 344, 344, 344, 344, -1, 344, 
	344, 344, 344, 344, -1, 344, -1, 344, 
	344, 344, 344, -1, 344, -1, 344, 344, 
	344, -1, 344, 344, 344, 344, 344, 344, 
	344, 344, 344, 344, 344, 344, 344, -1, 
	344, 344, 344, 344, 344, 344, 344, 344, 
	344, 344, 344, 344, 344, 344, 344, -1, 
	344, -1, -1, 344, 344, 344, 344, 344, 
	344, 344, -1, 344, 344, 344, 344, 344, 
	344, 344, 344, 344, 344, 344, 344, 344, 
	344, 344, 344, 344, -1, -1, -1, -1, 
	-1, 344, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 342, 
	344, 344, 344, 344, -1, -1, 344, 344, 
	344, 344, 344, 344, -1, -1, -1, -1, 
	344, 344, 344, 344, 344, 344, 344, -1, 
	-1, -1, -1, 344, -1, -1, -1, -1, 
	344, 344, -1, -1, 344, 344, 344, -1, 
	344, 344, -1, -1, 344, -1, -1, -1, 
	-1, -1, -1, -1, -1, 344, 344, 344, 
	344, 344, 344, 344, -1, -1, -1, 344, 
	344, 344, -1, -1, 344, 344, -1, 344, 
	344, 344, 344, 344, -1, 344, 344, 344, 
	-1, -1, -1, 344, 344, -1, -1, -1, 
	-1, -1, -1, -1, 344, 344, 344, 344, 
	344, 344, -1, -1, 344, -1, -1, -1, 
	-1, 344, -1, 344, 344, 344, 344, -1, 
	344, 344, 344, 344, 344, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 344, 
	-1, 344, -1, -1, 344, -1, 344, 344, 
	-1, -1, -1, 344, -1, 344, -1, 344, 
	346, 346, 346, 346, 346, 346, 346, 346, 
	346, 346, 346, 346, 346, 346, 346, 346, 
	346, 346, 346, 346, 346, 346, 346, 346, 
	346, 346, -1, 346, 346, 346, 346, 346, 
	-1, 346, -1, 346, 346, 346, 346, -1, 
	346, -1, 346, 346, 346, -1, -1, 346, 
	346, 346, 346, 346, 346, 346, 346, -1, 
	346, 346, 346, -1, -1, -1, -1, 346, 
	346, 346, 346, 346, -1, -1, 346, 346, 
	346, 346, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 346, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 346, 346, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 344, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 346, 346, 346, 346, 
	-1, -1, 346, 346, -1, 346, 346, 346, 
	-1, -1, -1, -1, 346, 346, 346, -1, 
	346, 346, 346, -1, -1, -1, -1, 346, 
	-1, -1, -1, -1, 346, -1, -1, -1, 
	346, 346, 346, -1, 346, 346, -1, -1, 
	346, -1, -1, -1, -1, -1, -1, -1, 
	-1, 346, 346, 346, 346, 346, 346, 346, 
	-1, -1, -1, -1, 346, 346, -1, -1, 
	346, 346, -1, -1, -1, -1, -1, -1, 
	-1, -1, 346, 346, -1, -1, -1, -1, 
	346, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 346, 
	346, 346, -1, -1, -1, -1, -1, 346, 
	346, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 346, -1, -1, -1, -1, 
	-1, -1, 346, 368, 368, 368, 368, 368, 
	368, 368, 368, 368, 368, 368, 368, 368, 
	368, 368, 368, 368, 368, 368, 368, 368, 
	368, 368, 368, 368, 368, -1, 368, 368, 
	368, 368, 368, -1, 368, -1, 368, 368, 
	368, 368, -1, 368, -1, 368, 368, 368, 
	-1, -1, 368, 368, 368, 368, 368, 368, 
	368, 368, -1, 368, 368, 368, -1, -1, 
	-1, -1, 368, 368, 368, 368, 368, -1, 
	-1, 368, 368, 368, 368, 369, 369, 369, 
	369, 369, 369, 369, -1, 369, 369, 368, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	369, 369, 369, 369, 369, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 369, 
	-1, -1, -1, 369, -1, -1, -1, 369, 
	369, 369, 369, 369, 369, -1, -1, -1, 
	-1, 369, 369, 369, -1, -1, -1, -1, 
	369, 369, -1, 369, 369, 369, 369, -1, 
	-1, -1, -1, -1, -1, -1, 369, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 369, 369, 369, -1, 
	369, -1, -1, -1, -1, -1, 346, 368, 
	368, 368, 368, -1, -1, 368, 368, -1, 
	368, 368, 368, -1, -1, -1, -1, 368, 
	368, 368, -1, 368, 368, 368, -1, -1, 
	-1, -1, 368, -1, -1, -1, -1, 368, 
	-1, -1, -1, 368, 368, 368, -1, 368, 
	368, -1, -1, 368, -1, -1, -1, -1, 
	-1, -1, -1, -1, 368, 368, 368, 368, 
	368, 368, 368, -1, -1, -1, -1, 368, 
	368, -1, -1, 368, 368, -1, -1, -1, 
	-1, -1, -1, -1, -1, 368, 368, -1, 
	-1, -1, -1, 368, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 368, 368, 368, -1, -1, -1, 
	-1, -1, 368, 368, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 369, 368, -1, 
	-1, -1, -1, -1, -1, 368, -1, -1, 
	369, 369, 369, 369, 369, -1, 369, 369, 
	369, -1, -1, -1, -1, 369, 370, 370, 
	370, 370, 370, 370, 370, -1, 370, 370, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 370, 370, 370, 370, 370, -1, -1, 
	-1, 369, 369, 369, 369, 369, -1, -1, 
	370, -1, -1, -1, 370, -1, -1, -1, 
	370, 370, 370, 370, 370, 370, -1, -1, 
	-1, -1, 370, 370, 370, -1, -1, -1, 
	-1, 370, 370, -1, 370, 370, 370, 370, 
	-1, -1, -1, -1, -1, -1, -1, 370, 
	370, 372, 372, 372, 372, 372, 372, 372, 
	-1, 372, 372, -1, -1, 370, 370, 370, 
	-1, 370, -1, -1, 372, 372, 372, 372, 
	372, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 372, -1, -1, -1, 372, 
	-1, -1, -1, 372, 372, 372, 372, 372, 
	372, -1, -1, -1, -1, 372, 372, 372, 
	-1, -1, -1, -1, 372, 372, -1, 372, 
	372, 372, 372, -1, -1, -1, -1, -1, 
	-1, -1, 372, 372, -1, -1, -1, -1, 
	-1, 368, -1, -1, -1, -1, -1, -1, 
	372, 372, 372, -1, 372, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 370, 370, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 370, 370, 370, 370, 370, -1, 370, 
	370, 370, -1, -1, -1, -1, 370, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 370, 370, 370, 370, 370, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 372, 372, 372, 372, 
	372, -1, 372, 372, 372, -1, -1, -1, 
	372, 372, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 618, 
	618, 618, 618, 618, 618, 618, -1, 618, 
	618, -1, -1, -1, -1, 372, 372, 372, 
	372, 372, 618, 618, 618, 618, 618, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 618, -1, -1, 372, 618, -1, -1, 
	-1, 618, 618, 618, 618, 618, 618, -1, 
	-1, -1, -1, 618, 618, 618, -1, -1, 
	-1, -1, 618, 618, -1, 618, 618, 618, 
	618, -1, -1, -1, -1, -1, -1, -1, 
	618, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 618, 618, 
	618, 618, 618, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 391, 391, 391, 
	391, 391, 391, 391, 391, 391, 391, 391, 
	391, 391, 391, 391, 391, 391, 391, 391, 
	391, 391, 391, 391, 391, 391, 391, -1, 
	391, 391, 391, 391, 391, -1, 391, -1, 
	391, 391, 391, 391, -1, 391, -1, 391, 
	391, 391, -1, 391, 391, 391, 391, 391, 
	391, 391, 391, 391, 391, 391, 391, 391, 
	-1, 391, 391, 391, 391, 391, 391, 391, 
	391, 391, 391, 391, 391, 391, 391, 391, 
	-1, 391, -1, -1, -1, -1, 391, 391, 
	391, 391, 391, -1, -1, 391, 391, 391, 
	391, 391, 391, 391, 391, 391, 391, 391, 
	391, 391, 391, 391, 391, -1, -1, -1, 
	-1, -1, 391, -1, -1, -1, -1, -1, 
	-1, -1, 618, 618, 618, 618, 618, -1, 
	618, 618, 618, -1, -1, -1, -1, 618, 
	-1, 369, -1, -1, -1, -1, -1, -1, 
	-1, -1, 618, -1, 369, 369, 369, 369, 
	369, -1, 369, 369, 369, -1, -1, -1, 
	-1, 369, -1, 618, 618, 618, 618, 618, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 391, 391, 391, 391, -1, -1, 391, 
	391, 391, 391, 391, 391, 369, 369, 369, 
	369, 391, 391, 391, 391, 391, 391, 391, 
	-1, -1, -1, -1, 391, -1, -1, -1, 
	-1, 391, 391, -1, -1, 391, 391, 391, 
	-1, 391, 391, -1, -1, 391, -1, -1, 
	-1, -1, -1, -1, -1, -1, 391, 391, 
	391, 391, 391, 391, 391, -1, -1, -1, 
	391, 391, 391, -1, -1, 391, 391, -1, 
	391, 391, 391, 391, 391, -1, 391, 391, 
	391, -1, -1, -1, 391, 391, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	391, 391, 391, -1, -1, 391, -1, -1, 
	-1, -1, 391, -1, 391, 391, 391, 391, 
	-1, 391, 391, 391, 391, 391, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	391, -1, 391, -1, -1, 391, -1, 391, 
	391, -1, -1, -1, 391, -1, 391, -1, 
	391, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 370, 370, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 370, 370, 370, 
	370, 370, -1, 370, 370, 370, -1, -1, 
	-1, -1, 370, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 370, 370, 
	370, 370, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	372, 372, 372, 372, 372, -1, 372, 372, 
	372, -1, -1, 391, 372, 372, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 372, 372, 372, 372, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	372, 392, 392, 392, 392, 392, 392, 392, 
	392, 392, 392, 392, 392, 392, 392, 392, 
	392, 392, 392, 392, 392, 392, 392, 392, 
	392, 392, 392, -1, 392, 392, 392, 392, 
	392, -1, 392, -1, 392, 392, 392, 392, 
	-1, 392, -1, 392, 392, 392, -1, 392, 
	392, 392, 392, 392, 392, 392, 392, 392, 
	392, 392, 392, 392, -1, 392, 392, 392, 
	392, 392, 392, 392, 392, 392, 392, 392, 
	392, 392, 392, 392, -1, 392, -1, -1, 
	-1, -1, 392, 392, 392, 392, 392, -1, 
	-1, 392, 392, 392, 392, 392, 392, 392, 
	392, 392, 392, 392, 392, 392, 392, 392, 
	392, -1, -1, -1, -1, -1, 392, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 392, 392, 392, 
	392, -1, -1, 392, 392, 392, 392, 392, 
	392, -1, -1, -1, -1, 392, 392, 392, 
	392, 392, 392, 392, -1, -1, -1, -1, 
	392, -1, -1, -1, -1, 392, 392, -1, 
	-1, 392, 392, 392, -1, 392, 392, -1, 
	-1, 392, -1, -1, -1, -1, 618, -1, 
	-1, -1, 392, 392, 392, 392, 392, 392, 
	392, -1, -1, -1, 392, 392, 392, -1, 
	-1, 392, 392, -1, 392, 392, 392, 392, 
	392, -1, 392, 392, 392, -1, -1, -1, 
	392, 392, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 392, 392, 392, -1, 
	-1, 392, -1, -1, -1, -1, 392, -1, 
	392, 392, 392, 392, -1, 392, 392, 392, 
	392, 392, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 392, -1, 392, -1, 
	-1, 392, -1, 392, 392, -1, -1, -1, 
	392, -1, 392, -1, 392, 394, 394, 394, 
	394, 394, 394, 394, 394, 394, 394, 394, 
	394, 394, 394, 394, -1, 394, 394, 394, 
	394, 394, 394, 394, 394, -1, -1, -1, 
	394, 394, 394, 394, 394, -1, 394, -1, 
	394, 394, 394, 394, -1, 394, -1, 394, 
	394, 394, -1, -1, 394, -1, -1, 394, 
	394, 394, 394, 394, -1, 394, 394, 394, 
	-1, -1, -1, -1, 394, 394, 394, 394, 
	394, -1, -1, 394, 394, 394, 394, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 392, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 394, 394, 394, 394, -1, -1, 394, 
	394, -1, 394, 394, 394, -1, -1, -1, 
	-1, 394, 394, 394, -1, 394, 394, 394, 
	-1, -1, -1, -1, 394, -1, -1, -1, 
	-1, 394, 394, -1, -1, 394, 394, 394, 
	-1, 394, 394, -1, -1, 394, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 394, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 394, 394, -1, 
	-1, -1, -1, -1, -1, -1, -1, 394, 
	394, -1, -1, -1, -1, 394, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 394, 394, 394, -1, 
	-1, -1, -1, -1, 394, 394, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	394, -1, -1, -1, -1, 394, -1, -1, 
	398, 398, 398, 398, 398, 398, 398, 398, 
	398, 398, 398, 398, 398, 398, 398, -1, 
	398, 398, 398, 398, 398, 398, 398, 398, 
	-1, -1, -1, 398, 398, 398, 398, 398, 
	-1, 398, -1, 398, 398, 398, 398, -1, 
	398, -1, 398, 398, 398, -1, -1, 398, 
	-1, -1, 398, 398, 398, 398, 398, -1, 
	398, 398, 398, -1, -1, -1, -1, 398, 
	398, 398, 398, 398, -1, -1, 398, 398, 
	398, 398, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 394, 398, 398, 398, 398, 
	-1, -1, 398, 398, -1, 398, 398, 398, 
	-1, -1, -1, -1, 398, 398, 398, -1, 
	398, 398, 398, -1, -1, -1, -1, 398, 
	-1, -1, -1, -1, 398, -1, -1, -1, 
	398, 398, 398, -1, 398, 398, -1, -1, 
	398, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 398, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	398, 398, -1, -1, -1, -1, -1, -1, 
	-1, -1, 398, 398, -1, -1, -1, -1, 
	398, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 398, 
	398, 398, -1, -1, -1, -1, -1, 398, 
	398, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 398, -1, 409, 409, 409, 
	409, 409, 409, 409, 409, 409, 409, 409, 
	409, 409, 409, 409, 409, 409, 409, 409, 
	409, 409, 409, 409, 409, 409, 409, -1, 
	409, 409, 409, 409, 409, -1, 409, -1, 
	409, 409, 409, 409, -1, 409, -1, 409, 
	409, 409, -1, 409, 409, 409, 409, 409, 
	409, 409, 409, 409, 409, 409, 409, 409, 
	-1, 409, 409, 409, 409, 409, 409, 409, 
	409, 409, 409, 409, 409, 409, 409, 409, 
	-1, 409, -1, -1, -1, -1, 409, 409, 
	409, 409, 409, -1, -1, 409, 409, 409, 
	409, 409, 409, 409, 409, 409, 409, 409, 
	409, 409, 409, 409, 409, -1, -1, -1, 
	-1, -1, 409, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 409, 409, 409, 409, -1, 398, 409, 
	409, 409, 409, 409, 409, -1, -1, -1, 
	-1, 409, 409, 409, 409, 409, 409, 409, 
	-1, -1, -1, -1, 409, -1, -1, -1, 
	-1, 409, 409, -1, -1, 409, 409, 409, 
	-1, 409, 409, -1, -1, 409, -1, -1, 
	-1, -1, -1, -1, -1, -1, 409, 409, 
	409, 409, 409, 409, 409, -1, -1, -1, 
	409, 409, 409, -1, -1, 409, 409, -1, 
	409, 409, 409, 409, 409, -1, 409, 409, 
	409, -1, -1, -1, 409, 409, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	409, 409, 409, -1, -1, 409, -1, -1, 
	-1, -1, 409, -1, 409, 409, 409, 409, 
	-1, 409, 409, 409, 409, 409, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	409, -1, 409, -1, -1, 409, -1, 409, 
	409, -1, -1, -1, 409, -1, 409, -1, 
	409, 410, 410, 410, 410, 410, 410, 410, 
	410, 410, 410, 410, 410, 410, 410, 410, 
	410, 410, 410, 410, 410, 410, 410, 410, 
	410, 410, 410, -1, 410, 410, 410, 410, 
	410, -1, 410, -1, 410, 410, 410, 410, 
	-1, 410, -1, 410, 410, 410, -1, 410, 
	410, 410, 410, 410, 410, 410, 410, 410, 
	410, 410, 410, 410, -1, 410, 410, 410, 
	410, 410, 410, 410, 410, 410, 410, 410, 
	410, 410, 410, 410, -1, 410, -1, -1, 
	-1, -1, 410, 410, 410, 410, 410, -1, 
	-1, 410, 410, 410, 410, 410, 410, 410, 
	410, 410, 410, 410, 410, 410, 410, 410, 
	410, -1, -1, -1, -1, -1, 410, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 409, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 410, 410, 410, 
	410, -1, -1, 410, 410, 410, 410, 410, 
	410, -1, -1, -1, -1, 410, 410, 410, 
	410, 410, 410, 410, -1, -1, -1, -1, 
	410, -1, -1, -1, -1, 410, 410, -1, 
	-1, 410, 410, 410, -1, 410, 410, -1, 
	-1, 410, -1, -1, -1, -1, -1, -1, 
	-1, -1, 410, 410, 410, 410, 410, 410, 
	410, -1, -1, -1, 410, 410, 410, -1, 
	-1, 410, 410, -1, 410, 410, 410, 410, 
	410, -1, 410, 410, 410, -1, -1, -1, 
	410, 410, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 410, 410, 410, -1, 
	-1, 410, -1, -1, -1, -1, 410, -1, 
	410, 410, 410, 410, -1, 410, 410, 410, 
	410, 410, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 410, -1, 410, -1, 
	-1, 410, -1, 410, 410, -1, -1, -1, 
	410, -1, 410, -1, 410, 411, 411, 411, 
	411, 411, 411, 411, 411, 411, 411, 411, 
	411, 411, 411, 411, 411, 411, 411, 411, 
	411, 411, 411, 411, 411, 411, 411, -1, 
	411, 411, 411, 411, 411, -1, 411, -1, 
	411, 411, 411, 411, -1, 411, -1, 411, 
	411, 411, -1, 411, 411, 411, 411, 411, 
	411, 411, 411, 411, 411, 411, 411, 411, 
	-1, 411, 411, 411, 411, 411, 411, 411, 
	411, 411, 411, 411, 411, 411, 411, 411, 
	-1, 411, -1, -1, -1, -1, 411, 411, 
	411, 411, 411, -1, -1, 411, 411, 411, 
	411, 411, 411, 411, 411, 411, 411, 411, 
	411, 411, 411, 411, 411, -1, -1, -1, 
	-1, -1, 411, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 410, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 411, 411, 411, 411, -1, -1, 411, 
	411, 411, 411, 411, 411, -1, -1, -1, 
	-1, 411, 411, 411, 411, 411, 411, 411, 
	-1, -1, -1, -1, 411, -1, -1, -1, 
	-1, 411, 411, -1, -1, 411, 411, 411, 
	-1, 411, 411, -1, -1, 411, -1, -1, 
	-1, -1, -1, -1, -1, -1, 411, 411, 
	411, 411, 411, 411, 411, -1, -1, -1, 
	411, 411, 411, -1, -1, 411, 411, -1, 
	411, 411, 411, 411, 411, -1, 411, 411, 
	411, -1, -1, -1, 411, 411, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	411, 411, 411, -1, -1, 411, -1, -1, 
	-1, -1, 411, -1, 411, 411, 411, 411, 
	-1, 411, 411, 411, 411, 411, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	411, -1, 411, -1, -1, 411, -1, 411, 
	411, -1, -1, -1, 411, -1, 411, -1, 
	411, 415, 415, 415, 415, 415, 415, 415, 
	-1, 415, 415, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 415, 415, 415, 415, 
	415, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 415, -1, -1, -1, 415, 
	-1, -1, -1, 415, 415, 415, 415, 415, 
	415, -1, -1, -1, -1, 415, 415, 415, 
	-1, -1, -1, -1, 415, 415, -1, 415, 
	415, 415, 415, -1, -1, -1, -1, -1, 
	-1, -1, 415, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	415, 415, 415, -1, 415, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 417, 417, 
	417, 417, 417, 417, 417, 417, 417, 417, 
	417, 417, 417, 417, 417, 417, 417, 417, 
	417, 417, 417, 417, 417, 417, 417, 417, 
	-1, 417, 417, 417, 417, 417, -1, 417, 
	-1, 417, 417, 417, 417, -1, 417, -1, 
	417, 417, 417, 411, 417, 417, 417, 417, 
	417, 417, 417, 417, 417, 417, 417, 417, 
	417, -1, 417, 417, 417, 417, 417, 417, 
	417, 417, 417, 417, 417, 417, 417, 417, 
	417, -1, 417, -1, -1, -1, -1, 417, 
	417, 417, 417, 417, -1, -1, 417, 417, 
	417, 417, 417, 417, 417, 417, 417, 417, 
	417, 417, 417, 417, 417, 417, -1, -1, 
	-1, -1, -1, 417, -1, -1, -1, -1, 
	-1, -1, -1, -1, 415, 415, 415, 415, 
	415, -1, 415, 415, 415, -1, -1, -1, 
	-1, 415, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 415, 415, 415, 
	415, 415, -1, -1, -1, -1, -1, -1, 
	-1, -1, 417, 417, 417, 417, -1, -1, 
	417, 417, 417, 417, 417, 417, -1, -1, 
	-1, -1, 417, 417, 417, 417, 417, 417, 
	417, -1, -1, -1, -1, 417, -1, -1, 
	-1, -1, 417, 417, -1, -1, 417, 417, 
	417, -1, 417, 417, -1, -1, 417, -1, 
	-1, -1, -1, -1, -1, -1, -1, 417, 
	417, 417, 417, 417, 417, 417, -1, -1, 
	-1, 417, 417, 417, -1, -1, 417, 417, 
	-1, 417, 417, 417, 417, 417, -1, 417, 
	417, 417, -1, -1, -1, 417, 417, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 417, 417, 417, -1, -1, 417, -1, 
	-1, -1, -1, 417, -1, 417, 417, 417, 
	417, -1, 417, 417, 417, 417, 417, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 417, -1, 417, -1, -1, 417, -1, 
	417, 417, -1, -1, -1, 417, -1, 417, 
	-1, 417, 418, 418, 418, 418, 418, 418, 
	418, 418, 418, 418, 418, 418, 418, 418, 
	418, 418, 418, 418, 418, 418, 418, 418, 
	418, 418, 418, 418, -1, 418, 418, 418, 
	418, 418, -1, 418, -1, 418, 418, 418, 
	418, -1, 418, -1, 418, 418, 418, -1, 
	418, 418, 418, 418, 418, 418, 418, 418, 
	418, 418, 418, 418, 418, -1, 418, 418, 
	418, 418, 418, 418, 418, 418, 418, 418, 
	418, 418, 418, 418, 418, -1, 418, -1, 
	-1, -1, -1, 418, 418, 418, 418, 418, 
	-1, -1, 418, 418, 418, 418, 418, 418, 
	418, 418, 418, 418, 418, 418, 418, 418, 
	418, 418, -1, -1, -1, -1, -1, 418, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 417, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 418, 418, 
	418, 418, -1, -1, 418, 418, 418, 418, 
	418, 418, -1, -1, -1, -1, 418, 418, 
	418, 418, 418, 418, 418, -1, -1, -1, 
	-1, 418, -1, -1, -1, -1, 418, 418, 
	-1, -1, 418, 418, 418, -1, 418, 418, 
	-1, -1, 418, -1, -1, -1, -1, -1, 
	-1, -1, -1, 418, 418, 418, 418, 418, 
	418, 418, -1, -1, -1, 418, 418, 418, 
	-1, -1, 418, 418, -1, 418, 418, 418, 
	418, 418, -1, 418, 418, 418, -1, -1, 
	-1, 418, 418, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 418, 418, 418, 
	-1, -1, 418, -1, -1, -1, -1, 418, 
	-1, 418, 418, 418, 418, -1, 418, 418, 
	418, 418, 418, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 418, -1, 418, 
	-1, -1, 418, -1, 418, 418, -1, -1, 
	-1, 418, -1, 418, -1, 418, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 646, 646, 
	646, 646, 646, 646, 646, 646, 646, 646, 
	646, 646, -1, -1, 646, 646, 646, 646, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 646, 646, 646, -1, 
	-1, -1, 646, -1, -1, -1, -1, 646, 
	-1, -1, -1, -1, -1, 646, 646, -1, 
	415, 415, 415, 415, 415, -1, 415, 415, 
	415, -1, -1, 646, -1, 415, 646, 646, 
	646, 646, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 646, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 415, 415, 415, 415, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	418, 419, 419, 419, 419, 419, 419, 419, 
	419, 419, 419, 419, 419, 419, 419, 419, 
	419, 419, 419, 419, 419, 419, 419, 419, 
	419, 419, 419, -1, 419, 419, 419, 419, 
	419, -1, 419, -1, 419, 419, 419, 419, 
	-1, 419, -1, 419, 419, 419, -1, 419, 
	419, 419, 419, 419, 419, 419, 419, 419, 
	419, 419, 419, 419, -1, 419, 419, 419, 
	419, 419, 419, 419, 419, 419, 419, 419, 
	419, 419, 419, 419, -1, 419, -1, -1, 
	-1, -1, 419, 419, 419, 419, 419, -1, 
	-1, 419, 419, 419, 419, 419, 419, 419, 
	419, 419, 419, 419, 419, 419, 419, 419, 
	419, -1, -1, -1, 646, -1, 419, -1, 
	-1, -1, -1, -1, 646, 646, 646, -1, 
	646, 646, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 646, -1, -1, -1, -1, 
	646, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 646, 
	646, 646, -1, -1, -1, -1, -1, 646, 
	646, -1, -1, -1, -1, 419, 419, 419, 
	419, -1, -1, 419, 419, 419, 419, 419, 
	419, -1, 646, -1, -1, 419, 419, 419, 
	419, 419, 419, 419, -1, -1, -1, -1, 
	419, -1, -1, -1, -1, 419, 419, -1, 
	-1, 419, 419, 419, -1, 419, 419, -1, 
	-1, 419, -1, -1, -1, -1, -1, -1, 
	-1, -1, 419, 419, 419, 419, 419, 419, 
	419, -1, -1, -1, 419, 419, 419, -1, 
	-1, 419, 419, -1, 419, 419, 419, 419, 
	419, -1, 419, 419, 419, -1, -1, -1, 
	419, 419, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 419, 419, 419, -1, 
	-1, 419, -1, -1, -1, -1, 419, -1, 
	419, 419, 419, 419, -1, 419, 419, 419, 
	419, 419, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 419, -1, 419, -1, 
	-1, 419, -1, 419, 419, -1, -1, -1, 
	419, -1, 419, -1, 419, 421, 421, 421, 
	421, 421, 421, 421, 421, 421, 421, 421, 
	421, 421, 421, 421, 421, 421, 421, 421, 
	421, 421, 421, 421, 421, 421, 421, -1, 
	421, 421, 421, 421, 421, -1, 421, -1, 
	421, 421, 421, 421, -1, 421, -1, 421, 
	421, 421, -1, 421, 421, 421, 421, 421, 
	421, 421, 421, 421, 421, 421, 421, 421, 
	-1, 421, 421, 421, 421, 421, 421, 421, 
	421, 421, 421, 421, 421, 421, 421, 421, 
	-1, -1, -1, -1, -1, -1, 421, 421, 
	421, 421, -1, -1, -1, 421, 421, 421, 
	421, 421, 421, 421, 421, 421, 421, 421, 
	421, -1, -1, 421, 421, -1, -1, -1, 
	-1, -1, 421, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 419, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 421, 421, 421, 421, -1, -1, 421, 
	421, 421, 421, 421, 421, -1, -1, -1, 
	-1, 421, 421, 421, 421, 421, 421, 421, 
	-1, -1, -1, -1, 421, -1, -1, -1, 
	-1, 421, 421, -1, -1, 421, 421, 421, 
	-1, 421, 421, -1, -1, 421, -1, -1, 
	-1, -1, -1, -1, -1, -1, 421, 421, 
	421, 421, 421, 421, 421, -1, -1, -1, 
	421, 421, 421, -1, -1, 421, 421, -1, 
	421, 421, 421, 421, 421, -1, 421, 421, 
	421, -1, -1, -1, 421, 421, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	421, 421, 421, -1, -1, 421, -1, -1, 
	-1, -1, 421, -1, 421, 421, 421, 421, 
	-1, 421, 421, 421, 421, 421, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	421, -1, 421, -1, -1, 421, -1, 421, 
	421, -1, -1, -1, 421, -1, 421, -1, 
	421, 422, 422, 422, 422, 422, 422, 422, 
	422, 422, 422, 422, 422, 422, 422, 422, 
	422, 422, 422, 422, 422, 422, 422, 422, 
	422, 422, 422, -1, 422, 422, 422, 422, 
	422, -1, 422, -1, 422, 422, 422, 422, 
	-1, 422, -1, 422, 422, 422, -1, 422, 
	422, 422, 422, 422, 422, 422, 422, 422, 
	422, 422, 422, 422, -1, 422, 422, 422, 
	422, 422, 422, 422, 422, 422, 422, 422, 
	422, 422, 422, 422, -1, -1, -1, -1, 
	-1, -1, 422, 422, 422, 422, -1, -1, 
	-1, 422, 422, 422, 422, 422, 422, 422, 
	422, 422, 422, 422, 422, -1, -1, 422, 
	422, -1, -1, -1, -1, -1, 422, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 421, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 422, 422, 422, 
	422, -1, -1, 422, 422, 422, 422, 422, 
	422, -1, -1, -1, -1, 422, 422, 422, 
	422, 422, 422, 422, -1, -1, -1, -1, 
	422, -1, -1, -1, -1, 422, 422, -1, 
	-1, 422, 422, 422, -1, 422, 422, -1, 
	-1, 422, -1, -1, -1, -1, -1, -1, 
	-1, -1, 422, 422, 422, 422, 422, 422, 
	422, -1, -1, -1, 422, 422, 422, -1, 
	-1, 422, 422, -1, 422, 422, 422, 422, 
	422, -1, 422, 422, 422, -1, -1, -1, 
	422, 422, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 422, 422, 422, -1, 
	-1, 422, -1, -1, -1, -1, 422, -1, 
	422, 422, 422, 422, -1, 422, 422, 422, 
	422, 422, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 422, -1, 422, -1, 
	-1, 422, -1, 422, 422, -1, -1, -1, 
	422, -1, 422, -1, 422, 423, 423, 423, 
	423, 423, 423, 423, 423, 423, 423, 423, 
	423, 423, 423, 423, 423, 423, 423, 423, 
	423, 423, 423, 423, 423, 423, 423, -1, 
	423, 423, 423, 423, 423, -1, 423, -1, 
	423, 423, 423, 423, -1, 423, -1, 423, 
	423, 423, -1, -1, 423, 423, 423, 423, 
	423, 423, 423, 423, -1, 423, 423, 423, 
	-1, -1, -1, -1, 423, 423, 423, 423, 
	423, -1, -1, 423, 423, 423, 423, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 423, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 422, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 423, 423, 423, 423, -1, -1, 423, 
	423, -1, 423, 423, 423, -1, -1, -1, 
	-1, 423, 423, 423, -1, 423, 423, 423, 
	-1, -1, -1, -1, 423, -1, -1, -1, 
	-1, 423, -1, -1, -1, 423, 423, 423, 
	-1, 423, 423, -1, -1, 423, -1, -1, 
	-1, -1, -1, -1, -1, -1, 423, 423, 
	423, 423, 423, 423, 423, -1, -1, -1, 
	-1, 423, 423, -1, -1, 423, 423, -1, 
	-1, -1, -1, -1, -1, -1, -1, 423, 
	423, -1, -1, -1, -1, 423, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 423, 423, 423, -1, 
	-1, -1, -1, -1, 423, 423, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	423, -1, -1, -1, -1, -1, -1, 423, 
	424, 424, 424, 424, 424, 424, 424, 424, 
	424, 424, 424, 424, 424, 424, 424, 424, 
	424, 424, 424, 424, 424, 424, 424, 424, 
	424, 424, -1, 424, 424, 424, 424, 424, 
	-1, 424, -1, 424, 424, 424, 424, -1, 
	424, -1, 424, 424, 424, -1, -1, 424, 
	424, 424, 424, 424, 424, 424, 424, -1, 
	424, 424, 424, -1, -1, -1, -1, 424, 
	424, 424, 424, 424, -1, -1, 424, 424, 
	424, 424, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 424, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 423, 424, 424, 424, 424, 
	-1, -1, 424, 424, -1, 424, 424, 424, 
	-1, -1, -1, -1, 424, 424, 424, -1, 
	424, 424, 424, -1, -1, -1, -1, 424, 
	-1, -1, -1, -1, 424, -1, -1, -1, 
	424, 424, 424, -1, 424, 424, -1, -1, 
	424, -1, -1, -1, -1, -1, -1, -1, 
	-1, 424, 424, 424, 424, 424, 424, 424, 
	-1, -1, -1, -1, 424, 424, -1, -1, 
	424, 424, -1, -1, -1, -1, -1, -1, 
	-1, -1, 424, 424, -1, -1, -1, -1, 
	424, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 424, 
	424, 424, -1, -1, -1, -1, -1, 424, 
	424, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 424, -1, -1, -1, -1, 
	-1, -1, 424, 425, 425, 425, 425, 425, 
	425, 425, 425, 425, 425, 425, 425, 425, 
	425, 425, 425, 425, 425, 425, 425, 425, 
	425, 425, 425, 425, 425, -1, 425, 425, 
	425, 425, 425, -1, 425, -1, 425, 425, 
	425, 425, -1, 425, -1, 425, 425, 425, 
	-1, -1, 425, 425, 425, 425, 425, 425, 
	425, 425, -1, 425, 425, 425, -1, -1, 
	-1, -1, 425, 425, 425, 425, 425, -1, 
	-1, 425, 425, 425, 425, 426, 426, 426, 
	426, 426, 426, 426, -1, 426, 426, 425, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	426, 426, 426, 426, 426, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 426, 
	-1, -1, -1, 426, -1, -1, -1, 426, 
	426, 426, 426, 426, 426, -1, -1, -1, 
	-1, 426, 426, 426, -1, -1, -1, -1, 
	426, 426, -1, 426, 426, 426, 426, -1, 
	-1, -1, -1, -1, -1, -1, 426, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 426, 426, 426, -1, 
	426, -1, -1, -1, -1, -1, 424, 425, 
	425, 425, 425, -1, -1, 425, 425, -1, 
	425, 425, 425, -1, -1, -1, -1, 425, 
	425, 425, -1, 425, 425, 425, -1, -1, 
	-1, -1, 425, -1, -1, -1, -1, 425, 
	-1, -1, -1, 425, 425, 425, -1, 425, 
	425, -1, -1, 425, -1, -1, -1, -1, 
	-1, -1, -1, -1, 425, 425, 425, 425, 
	425, 425, 425, -1, -1, -1, -1, 425, 
	425, -1, -1, 425, 425, -1, -1, -1, 
	-1, -1, -1, -1, -1, 425, 425, -1, 
	-1, -1, -1, 425, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 425, 425, 425, -1, -1, -1, 
	-1, -1, 425, 425, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 425, -1, 
	-1, -1, -1, -1, -1, 425, -1, -1, 
	426, 426, 426, 426, 426, -1, 426, 426, 
	426, -1, -1, -1, -1, 426, -1, -1, 
	427, 427, 427, 427, 427, 427, 427, 427, 
	427, -1, 427, 427, -1, -1, 427, 427, 
	427, 427, -1, -1, -1, -1, -1, -1, 
	-1, 426, 426, 426, 426, 426, 427, 427, 
	427, -1, -1, -1, 427, -1, -1, -1, 
	-1, 427, -1, -1, -1, -1, -1, 427, 
	427, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 427, -1, -1, 
	427, 427, 427, 427, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 427, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 425, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 424, 424, 424, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 427, -1, 
	-1, -1, -1, -1, -1, 427, -1, -1, 
	-1, -1, 427, 427, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 427, -1, -1, 
	-1, -1, 427, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 427, 427, 427, -1, -1, -1, -1, 
	-1, 427, 427, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 428, 428, 428, 428, 428, 428, 
	428, 428, 428, 428, 428, 428, 428, 428, 
	428, 428, 428, 428, 428, 428, 428, 428, 
	428, 428, 428, 428, -1, 428, 428, 428, 
	428, 428, -1, 428, -1, 428, 428, 428, 
	428, -1, 428, -1, 428, 428, 428, -1, 
	428, 428, 428, 428, 428, 428, 428, 428, 
	428, 428, 428, 428, 428, -1, 428, 428, 
	428, 428, 428, 428, 428, 428, 428, 428, 
	428, 428, 428, 428, 428, -1, -1, -1, 
	-1, -1, -1, 428, 428, 428, 428, -1, 
	-1, -1, 428, 428, 428, 428, 428, 428, 
	428, 428, 428, 428, 428, 428, 428, 428, 
	428, 428, -1, -1, -1, -1, -1, 428, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 428, 428, 
	428, 428, -1, -1, 428, 428, 428, 428, 
	428, 428, -1, -1, -1, -1, 428, 428, 
	428, 428, 428, 428, 428, -1, -1, -1, 
	-1, 428, -1, -1, -1, -1, 428, 428, 
	-1, -1, 428, 428, 428, -1, 428, 428, 
	-1, -1, 428, -1, -1, -1, -1, -1, 
	-1, -1, -1, 428, 428, 428, 428, 428, 
	428, 428, -1, -1, -1, 428, 428, 428, 
	-1, -1, 428, 428, -1, 428, 428, 428, 
	428, 428, -1, 428, 428, 428, -1, -1, 
	-1, 428, 428, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 428, 428, 428, 
	-1, -1, 428, -1, -1, -1, -1, 428, 
	-1, 428, 428, 428, 428, -1, 428, 428, 
	428, 428, 428, -1, 426, 426, 426, 426, 
	426, -1, 426, 426, 426, 428, -1, 428, 
	-1, 426, 428, -1, 428, 428, -1, -1, 
	-1, 428, -1, 428, -1, 428, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 426, 426, 426, 
	426, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	428, -1, -1, -1, -1, 731, 731, 731, 
	731, 731, 731, 731, 731, 731, -1, 731, 
	731, -1, -1, 731, 731, 731, 731, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 731, 731, 731, -1, -1, 
	-1, 731, -1, -1, -1, -1, 731, -1, 
	-1, -1, 427, -1, 731, 731, -1, -1, 
	-1, 427, -1, -1, -1, -1, 427, 427, 
	-1, -1, 731, -1, -1, 731, 731, 731, 
	731, 427, -1, -1, -1, -1, 427, -1, 
	-1, -1, 731, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 427, 427, 427, 
	-1, -1, -1, -1, -1, 427, 429, 429, 
	429, 429, 429, 429, 429, 429, 429, 429, 
	429, 429, 429, 429, 429, 429, 429, 429, 
	429, 429, 429, 429, 429, 429, 429, 429, 
	-1, 429, 429, 429, 429, 429, -1, 429, 
	-1, 429, 429, 429, 429, -1, 429, -1, 
	429, 429, 429, -1, 429, 429, 429, 429, 
	429, 429, 429, 429, 429, 429, 429, 429, 
	429, -1, 429, 429, 429, 429, 429, 429, 
	429, 429, 429, 429, 429, 429, 429, 429, 
	429, -1, -1, -1, -1, -1, -1, 429, 
	429, 429, 429, -1, -1, -1, 429, 429, 
	429, 429, 429, 429, 429, 429, 429, 429, 
	429, 429, 429, 429, 429, 429, -1, -1, 
	-1, -1, -1, 429, -1, -1, -1, -1, 
	-1, -1, -1, 731, -1, -1, -1, -1, 
	-1, -1, 731, -1, -1, -1, -1, 731, 
	731, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 731, -1, -1, -1, -1, 731, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 731, 731, 
	731, -1, 429, 429, 429, 429, 731, 731, 
	429, 429, 429, 429, 429, 429, -1, -1, 
	-1, -1, 429, 429, 429, 429, 429, 429, 
	429, -1, -1, -1, -1, 429, -1, -1, 
	-1, -1, 429, 429, -1, -1, 429, 429, 
	429, -1, 429, 429, -1, -1, 429, -1, 
	-1, -1, -1, -1, -1, -1, -1, 429, 
	429, 429, 429, 429, 429, 429, -1, -1, 
	-1, 429, 429, 429, -1, -1, 429, 429, 
	-1, 429, 429, 429, 429, 429, -1, 429, 
	429, 429, -1, -1, -1, 429, 429, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 429, 429, 429, -1, -1, 429, -1, 
	-1, -1, -1, 429, -1, 429, 429, 429, 
	429, -1, 429, 429, 429, 429, 429, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 429, -1, 429, -1, -1, 429, -1, 
	429, 429, -1, -1, -1, 429, -1, 429, 
	-1, 429, 430, 430, 430, 430, 430, 430, 
	430, 430, 430, 430, 430, 430, 430, 430, 
	430, 430, 430, 430, 430, 430, 430, 430, 
	430, 430, 430, 430, -1, 430, 430, 430, 
	430, 430, -1, 430, -1, 430, 430, 430, 
	430, -1, 430, -1, 430, 430, 430, -1, 
	430, 430, 430, 430, 430, 430, 430, 430, 
	430, 430, 430, 430, 430, -1, 430, 430, 
	430, 430, 430, 430, 430, 430, 430, 430, 
	430, 430, 430, 430, 430, -1, -1, -1, 
	-1, -1, -1, 430, 430, 430, 430, -1, 
	-1, -1, 430, 430, 430, 430, 430, 430, 
	430, 430, 430, 430, 430, 430, 430, 430, 
	430, 430, -1, -1, -1, -1, -1, 430, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 429, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 430, 430, 
	430, 430, -1, -1, 430, 430, 430, 430, 
	430, 430, -1, -1, -1, -1, 430, 430, 
	430, 430, 430, 430, 430, -1, -1, -1, 
	-1, 430, -1, -1, -1, -1, 430, 430, 
	-1, -1, 430, 430, 430, -1, 430, 430, 
	-1, -1, 430, -1, -1, -1, -1, -1, 
	-1, -1, -1, 430, 430, 430, 430, 430, 
	430, 430, -1, -1, -1, 430, 430, 430, 
	-1, -1, 430, 430, -1, 430, 430, 430, 
	430, 430, -1, 430, 430, 430, -1, -1, 
	-1, 430, 430, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 430, 430, 430, 
	-1, -1, 430, -1, -1, -1, -1, 430, 
	-1, 430, 430, 430, 430, -1, 430, 430, 
	430, 430, 430, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 430, -1, 430, 
	-1, -1, 430, -1, 430, 430, -1, -1, 
	-1, 430, -1, 430, -1, 430, 431, 431, 
	431, 431, 431, 431, 431, 431, 431, 431, 
	431, 431, 431, 431, 431, 431, 431, 431, 
	431, 431, 431, 431, 431, 431, 431, 431, 
	-1, 431, 431, 431, 431, 431, -1, 431, 
	-1, 431, 431, 431, 431, -1, 431, -1, 
	431, 431, 431, -1, 431, 431, 431, 431, 
	431, 431, 431, 431, 431, 431, 431, 431, 
	431, -1, 431, 431, 431, 431, 431, 431, 
	431, 431, 431, 431, 431, 431, 431, 431, 
	431, -1, -1, -1, -1, -1, -1, 431, 
	431, 431, 431, -1, -1, -1, 431, 431, 
	431, 431, 431, 431, 431, 431, 431, 431, 
	431, 431, 431, 431, 431, 431, -1, -1, 
	-1, -1, -1, 431, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	430, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 431, 431, 431, 431, -1, -1, 
	431, 431, 431, 431, 431, 431, -1, -1, 
	-1, -1, 431, 431, 431, 431, 431, 431, 
	431, -1, -1, -1, -1, 431, -1, -1, 
	-1, -1, 431, 431, -1, -1, 431, 431, 
	431, -1, 431, 431, -1, -1, 431, -1, 
	-1, -1, -1, -1, -1, -1, -1, 431, 
	431, 431, 431, 431, 431, 431, -1, -1, 
	-1, 431, 431, 431, -1, -1, 431, 431, 
	-1, 431, 431, 431, 431, 431, -1, 431, 
	431, 431, -1, -1, -1, 431, 431, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 431, 431, 431, -1, -1, 431, -1, 
	-1, -1, -1, 431, -1, 431, 431, 431, 
	431, -1, 431, 431, 431, 431, 431, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 431, -1, 431, -1, -1, 431, -1, 
	431, 431, -1, -1, -1, 431, -1, 431, 
	-1, 431, 432, 432, 432, 432, 432, 432, 
	432, 432, 432, 432, 432, 432, 432, 432, 
	432, 432, 432, 432, 432, 432, 432, 432, 
	432, 432, 432, 432, -1, 432, 432, 432, 
	432, 432, -1, 432, -1, 432, 432, 432, 
	432, -1, 432, -1, 432, 432, 432, -1, 
	432, 432, 432, 432, 432, 432, 432, 432, 
	432, 432, 432, 432, 432, -1, 432, 432, 
	432, 432, 432, 432, 432, 432, 432, 432, 
	432, 432, 432, 432, 432, -1, -1, -1, 
	-1, -1, -1, 432, 432, 432, 432, -1, 
	-1, -1, 432, 432, 432, 432, 432, 432, 
	432, 432, 432, 432, 432, 432, 432, 432, 
	432, 432, -1, -1, -1, -1, -1, 432, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 431, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 432, 432, 
	432, 432, -1, -1, 432, 432, 432, 432, 
	432, 432, -1, -1, -1, -1, 432, 432, 
	432, 432, 432, 432, 432, -1, -1, -1, 
	-1, 432, -1, -1, -1, -1, 432, 432, 
	-1, -1, 432, 432, 432, -1, 432, 432, 
	-1, -1, 432, -1, -1, -1, -1, -1, 
	-1, -1, -1, 432, 432, 432, 432, 432, 
	432, 432, -1, -1, -1, 432, 432, 432, 
	-1, -1, 432, 432, -1, 432, 432, 432, 
	432, 432, -1, 432, 432, 432, -1, -1, 
	-1, 432, 432, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 432, 432, 432, 
	-1, -1, 432, -1, -1, -1, -1, 432, 
	-1, 432, 432, 432, 432, -1, 432, 432, 
	432, 432, 432, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 432, -1, 432, 
	-1, -1, 432, -1, 432, 432, -1, -1, 
	-1, 432, -1, 432, -1, 432, 433, 433, 
	433, 433, 433, 433, 433, 433, 433, 433, 
	433, 433, 433, 433, 433, 433, 433, 433, 
	433, 433, 433, 433, 433, 433, 433, 433, 
	-1, 433, 433, 433, 433, 433, -1, 433, 
	-1, 433, 433, 433, 433, -1, 433, -1, 
	433, 433, 433, -1, 433, 433, 433, 433, 
	433, 433, 433, 433, 433, 433, 433, 433, 
	433, -1, 433, 433, 433, 433, 433, 433, 
	433, 433, 433, 433, 433, 433, 433, 433, 
	433, -1, -1, -1, -1, -1, -1, 433, 
	433, 433, 433, -1, -1, -1, 433, 433, 
	433, 433, 433, 433, 433, 433, 433, 433, 
	433, 433, 433, 433, 433, 433, -1, -1, 
	-1, -1, -1, 433, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	432, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 433, 433, 433, 433, -1, -1, 
	433, 433, 433, 433, 433, 433, -1, -1, 
	-1, -1, 433, 433, 433, 433, 433, 433, 
	433, -1, -1, -1, -1, 433, -1, -1, 
	-1, -1, 433, 433, -1, -1, 433, 433, 
	433, -1, 433, 433, -1, -1, 433, -1, 
	-1, -1, -1, -1, -1, -1, -1, 433, 
	433, 433, 433, 433, 433, 433, -1, -1, 
	-1, 433, 433, 433, -1, -1, 433, 433, 
	-1, 433, 433, 433, 433, 433, -1, 433, 
	433, 433, -1, -1, -1, 433, 433, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 433, 433, 433, -1, -1, 433, -1, 
	-1, -1, -1, 433, -1, 433, 433, 433, 
	433, -1, 433, 433, 433, 433, 433, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 433, -1, 433, -1, -1, 433, -1, 
	433, 433, -1, -1, -1, 433, -1, 433, 
	-1, 433, 434, 434, 434, 434, 434, 434, 
	434, 434, 434, 434, 434, 434, 434, 434, 
	434, 434, 434, 434, 434, 434, 434, 434, 
	434, 434, 434, 434, -1, 434, 434, 434, 
	434, 434, -1, 434, -1, 434, 434, 434, 
	434, -1, 434, -1, 434, 434, 434, -1, 
	434, 434, 434, 434, 434, 434, 434, 434, 
	434, 434, 434, 434, 434, -1, 434, 434, 
	434, 434, 434, 434, 434, 434, 434, 434, 
	434, 434, 434, 434, 434, -1, 434, -1, 
	-1, -1, -1, 434, 434, 434, 434, 434, 
	-1, -1, 434, 434, 434, 434, 434, 434, 
	434, 434, 434, 434, 434, 434, 434, 434, 
	434, 434, -1, -1, -1, -1, -1, 434, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 433, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 434, 434, 
	434, 434, -1, -1, 434, 434, 434, 434, 
	434, 434, -1, -1, -1, -1, 434, 434, 
	434, 434, 434, 434, 434, -1, -1, -1, 
	-1, 434, -1, -1, -1, -1, 434, 434, 
	-1, -1, 434, 434, 434, -1, 434, 434, 
	-1, -1, 434, -1, -1, -1, -1, -1, 
	-1, -1, -1, 434, 434, 434, 434, 434, 
	434, 434, -1, -1, -1, 434, 434, 434, 
	-1, -1, 434, 434, -1, 434, 434, 434, 
	434, 434, -1, 434, 434, 434, -1, -1, 
	-1, 434, 434, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 434, 434, 434, 
	-1, -1, 434, -1, -1, -1, -1, 434, 
	-1, 434, 434, 434, 434, -1, 434, 434, 
	434, 434, 434, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 434, -1, 434, 
	-1, -1, 434, -1, 434, 434, -1, -1, 
	-1, 434, -1, 434, -1, 434, 435, 435, 
	435, 435, 435, 435, 435, 435, 435, 435, 
	435, 435, 435, 435, 435, 435, 435, 435, 
	435, 435, 435, 435, 435, 435, 435, 435, 
	-1, 435, 435, 435, 435, 435, -1, 435, 
	-1, 435, 435, 435, 435, -1, 435, -1, 
	435, 435, 435, -1, 435, 435, 435, 435, 
	435, 435, 435, 435, 435, 435, 435, 435, 
	435, -1, 435, 435, 435, 435, 435, 435, 
	435, 435, 435, 435, 435, 435, 435, 435, 
	435, -1, 435, -1, -1, -1, -1, 435, 
	435, 435, 435, 435, -1, -1, 435, 435, 
	435, 435, 435, 435, 435, 435, 435, 435, 
	435, 435, 435, 435, 435, 435, -1, -1, 
	-1, -1, -1, 435, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	434, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 435, 435, 435, 435, -1, -1, 
	435, 435, 435, 435, 435, 435, -1, -1, 
	-1, -1, 435, 435, 435, 435, 435, 435, 
	435, -1, -1, -1, -1, 435, -1, -1, 
	-1, -1, 435, 435, -1, -1, 435, 435, 
	435, -1, 435, 435, -1, -1, 435, -1, 
	-1, -1, -1, -1, -1, -1, -1, 435, 
	435, 435, 435, 435, 435, 435, -1, -1, 
	-1, 435, 435, 435, -1, -1, 435, 435, 
	-1, 435, 435, 435, 435, 435, -1, 435, 
	435, 435, -1, -1, -1, 435, 435, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 435, 435, 435, -1, -1, 435, -1, 
	-1, -1, -1, 435, -1, 435, 435, 435, 
	435, -1, 435, 435, 435, 435, 435, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 435, -1, 435, -1, -1, 435, -1, 
	435, 435, -1, -1, -1, 435, -1, 435, 
	-1, 435, 436, 436, 436, 436, 436, 436, 
	436, 436, 436, 436, 436, 436, 436, 436, 
	436, 436, 436, 436, 436, 436, 436, 436, 
	436, 436, 436, 436, -1, 436, 436, 436, 
	436, 436, -1, 436, -1, 436, 436, 436, 
	436, -1, 436, -1, 436, 436, 436, -1, 
	436, 436, 436, 436, 436, 436, 436, 436, 
	436, 436, 436, 436, 436, -1, 436, 436, 
	436, 436, 436, 436, 436, 436, 436, 436, 
	436, 436, 436, 436, 436, -1, 436, -1, 
	-1, -1, -1, 436, 436, 436, 436, 436, 
	-1, -1, 436, 436, 436, 436, 436, 436, 
	436, 436, 436, 436, 436, 436, 436, 436, 
	436, 436, -1, -1, -1, -1, -1, 436, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 435, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 436, 436, 
	436, 436, -1, -1, 436, 436, 436, 436, 
	436, 436, -1, -1, -1, -1, 436, 436, 
	436, 436, 436, 436, 436, -1, -1, -1, 
	-1, 436, -1, -1, -1, -1, 436, 436, 
	-1, -1, 436, 436, 436, -1, 436, 436, 
	-1, -1, 436, -1, -1, -1, -1, -1, 
	-1, -1, -1, 436, 436, 436, 436, 436, 
	436, 436, -1, -1, -1, 436, 436, 436, 
	-1, -1, 436, 436, -1, 436, 436, 436, 
	436, 436, -1, 436, 436, 436, -1, -1, 
	-1, 436, 436, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 436, 436, 436, 
	-1, -1, 436, -1, -1, -1, -1, 436, 
	-1, 436, 436, 436, 436, -1, 436, 436, 
	436, 436, 436, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 436, -1, 436, 
	-1, -1, 436, -1, 436, 436, -1, -1, 
	-1, 436, -1, 436, -1, 436, 437, 437, 
	437, 437, 437, 437, 437, 437, 437, 437, 
	437, 437, 437, 437, 437, 437, 437, 437, 
	437, 437, 437, 437, 437, 437, 437, 437, 
	-1, 437, 437, 437, 437, 437, -1, 437, 
	-1, 437, 437, 437, 437, -1, 437, -1, 
	437, 437, 437, -1, 437, 437, 437, 437, 
	437, 437, 437, 437, 437, 437, 437, 437, 
	437, -1, 437, 437, 437, 437, 437, 437, 
	437, 437, 437, 437, 437, 437, 437, 437, 
	437, -1, 437, -1, -1, -1, -1, 437, 
	437, 437, 437, 437, -1, -1, 437, 437, 
	437, 437, 437, 437, 437, 437, 437, 437, 
	437, 437, 437, 437, 437, 437, -1, -1, 
	-1, -1, -1, 437, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	436, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 437, 437, 437, 437, -1, -1, 
	437, 437, 437, 437, 437, 437, -1, -1, 
	-1, -1, 437, 437, 437, 437, 437, 437, 
	437, -1, -1, -1, -1, 437, -1, -1, 
	-1, -1, 437, 437, -1, -1, 437, 437, 
	437, -1, 437, 437, -1, -1, 437, -1, 
	-1, -1, -1, -1, -1, -1, -1, 437, 
	437, 437, 437, 437, 437, 437, -1, -1, 
	-1, 437, 437, 437, -1, -1, 437, 437, 
	-1, 437, 437, 437, 437, 437, -1, 437, 
	437, 437, -1, -1, -1, 437, 437, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 437, 437, 437, -1, -1, 437, -1, 
	-1, -1, -1, 437, -1, 437, 437, 437, 
	437, -1, 437, 437, 437, 437, 437, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 437, -1, 437, -1, -1, 437, -1, 
	437, 437, -1, -1, -1, 437, -1, 437, 
	-1, 437, 438, 438, 438, 438, 438, 438, 
	438, 438, 438, 438, 438, 438, 438, 438, 
	438, 438, 438, 438, 438, 438, 438, 438, 
	438, 438, 438, 438, -1, 438, 438, 438, 
	438, 438, -1, 438, -1, 438, 438, 438, 
	438, -1, 438, -1, 438, 438, 438, -1, 
	438, 438, 438, 438, 438, 438, 438, 438, 
	438, 438, 438, 438, 438, -1, 438, 438, 
	438, 438, 438, 438, 438, 438, 438, 438, 
	438, 438, 438, 438, 438, -1, 438, -1, 
	-1, -1, -1, 438, 438, 438, 438, 438, 
	-1, -1, 438, 438, 438, 438, 438, 438, 
	438, 438, 438, 438, 438, 438, 438, 438, 
	438, 438, -1, -1, -1, -1, -1, 438, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 437, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 438, 438, 
	438, 438, -1, -1, 438, 438, 438, 438, 
	438, 438, -1, -1, -1, -1, 438, 438, 
	438, 438, 438, 438, 438, -1, -1, -1, 
	-1, 438, -1, -1, -1, -1, 438, 438, 
	-1, -1, 438, 438, 438, -1, 438, 438, 
	-1, -1, 438, -1, -1, -1, -1, -1, 
	-1, -1, -1, 438, 438, 438, 438, 438, 
	438, 438, -1, -1, -1, 438, 438, 438, 
	-1, -1, 438, 438, -1, 438, 438, 438, 
	438, 438, -1, 438, 438, 438, -1, -1, 
	-1, 438, 438, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 438, 438, 438, 
	-1, -1, 438, -1, -1, -1, -1, 438, 
	-1, 438, 438, 438, 438, -1, 438, 438, 
	438, 438, 438, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 438, -1, 438, 
	-1, -1, 438, -1, 438, 438, -1, -1, 
	-1, 438, -1, 438, -1, 438, 439, 439, 
	439, 439, 439, 439, 439, 439, 439, 439, 
	439, 439, 439, 439, 439, 439, 439, 439, 
	439, 439, 439, 439, 439, 439, 439, 439, 
	439, 439, 439, 439, 439, 439, -1, 439, 
	-1, 439, 439, 439, 439, 439, 439, -1, 
	439, 439, 439, -1, -1, 439, 439, 439, 
	439, 439, 439, 439, 439, -1, 439, 439, 
	439, 439, -1, -1, -1, 439, 439, 439, 
	439, 439, -1, -1, 439, 439, 439, 439, 
	-1, -1, -1, 439, -1, -1, -1, 439, 
	439, -1, 439, -1, -1, 439, -1, -1, 
	439, -1, 439, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 439, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 439, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	438, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 439, 439, 439, 439, -1, -1, 
	439, 439, 439, 439, 439, 439, -1, -1, 
	-1, -1, 439, 439, 439, 439, 439, 439, 
	439, -1, -1, 439, -1, 439, -1, -1, 
	-1, -1, 439, 439, -1, 439, 439, 439, 
	439, -1, 439, 439, -1, -1, 439, -1, 
	-1, -1, -1, -1, 439, -1, 439, 439, 
	439, 439, 439, 439, 439, 439, -1, -1, 
	-1, -1, 439, 439, -1, 439, 439, 439, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	439, 439, -1, -1, 439, -1, 439, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	439, 439, 439, -1, -1, 439, 439, 439, 
	-1, -1, -1, -1, -1, 439, 439, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 439, -1, 439, -1, -1, 439, 439, 
	439, 440, 440, 440, 440, 440, 440, 440, 
	440, 440, 440, 440, 440, 440, 440, 440, 
	440, 440, 440, 440, 440, 440, 440, 440, 
	440, 440, 440, 440, 440, 440, 440, 440, 
	440, -1, 440, -1, 440, 440, 440, 440, 
	440, 440, -1, 440, 440, 440, -1, -1, 
	440, 440, 440, 440, 440, 440, 440, 440, 
	-1, 440, 440, 440, 440, -1, -1, -1, 
	440, 440, 440, 440, 440, -1, 440, 440, 
	440, 440, 440, 440, -1, -1, 440, -1, 
	-1, -1, 440, 440, -1, 440, -1, -1, 
	440, -1, -1, 440, -1, 440, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 440, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 440, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 440, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 439, 440, 440, 440, 
	440, -1, -1, 440, 440, 440, 440, 440, 
	440, -1, -1, -1, -1, 440, 440, 440, 
	440, 440, 440, 440, -1, -1, 440, -1, 
	440, -1, -1, -1, -1, 440, 440, -1, 
	440, 440, 440, 440, -1, 440, 440, -1, 
	-1, 440, 440, 440, -1, -1, -1, 440, 
	-1, 440, 440, 440, 440, 440, 440, 440, 
	440, -1, -1, -1, -1, 440, 440, -1, 
	440, 440, 440, -1, -1, -1, -1, -1, 
	-1, -1, -1, 440, 440, -1, -1, 440, 
	-1, 440, 440, -1, -1, -1, 440, 440, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 440, 440, 440, -1, -1, 
	440, 440, 440, -1, -1, -1, -1, -1, 
	440, 440, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 440, -1, 440, -1, 
	-1, 440, 440, 440, -1, -1, 440, 441, 
	441, 441, 441, 441, 441, 441, 441, 441, 
	441, 441, 441, 441, 441, 441, 441, 441, 
	441, 441, 441, 441, 441, 441, 441, 441, 
	441, 441, 441, 441, 441, 441, 441, -1, 
	441, -1, 441, 441, 441, 441, 441, 441, 
	-1, 441, 441, 441, -1, -1, 441, 441, 
	441, 441, 441, 441, 441, 441, -1, 441, 
	441, 441, 441, -1, -1, -1, 441, 441, 
	441, 441, 441, -1, 441, 441, 441, 441, 
	441, 441, -1, -1, 441, -1, -1, -1, 
	441, 441, -1, 441, -1, -1, 441, -1, 
	-1, 441, -1, 441, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 441, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 441, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 441, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 440, 
	-1, -1, -1, 441, 441, 441, 441, -1, 
	-1, 441, 441, 441, 441, 441, 441, -1, 
	-1, -1, -1, 441, 441, 441, 441, 441, 
	441, 441, -1, -1, 441, -1, 441, -1, 
	-1, -1, -1, 441, 441, -1, 441, 441, 
	441, 441, -1, 441, 441, -1, -1, 441, 
	441, 441, -1, -1, -1, 441, -1, 441, 
	441, 441, 441, 441, 441, 441, 441, -1, 
	-1, -1, -1, 441, 441, -1, 441, 441, 
	441, -1, -1, -1, -1, -1, -1, -1, 
	-1, 441, 441, -1, -1, 441, -1, 441, 
	441, -1, -1, -1, 441, 441, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 441, 441, 441, -1, -1, 441, 441, 
	441, -1, -1, -1, -1, -1, 441, 441, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 441, -1, 441, -1, -1, 441, 
	441, 441, -1, -1, 441, 442, 442, 442, 
	442, 442, 442, 442, 442, 442, 442, 442, 
	442, 442, 442, 442, 442, 442, 442, 442, 
	442, 442, 442, 442, 442, 442, 442, 442, 
	442, 442, 442, 442, 442, -1, 442, -1, 
	442, 442, 442, 442, 442, 442, -1, 442, 
	442, 442, -1, -1, 442, 442, 442, 442, 
	442, 442, 442, 442, -1, 442, 442, 442, 
	442, -1, -1, -1, 442, 442, 442, 442, 
	442, -1, 442, 442, 442, 442, 442, 442, 
	-1, -1, 442, -1, -1, -1, 442, 442, 
	-1, 442, -1, -1, 442, -1, -1, 442, 
	-1, 442, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 442, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 442, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 442, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 441, -1, -1, 
	-1, 442, 442, 442, 442, -1, -1, 442, 
	442, 442, 442, 442, 442, -1, -1, -1, 
	-1, 442, 442, 442, 442, 442, 442, 442, 
	-1, -1, 442, -1, 442, -1, -1, -1, 
	-1, 442, 442, -1, 442, 442, 442, 442, 
	-1, 442, 442, -1, -1, 442, 442, 442, 
	-1, -1, -1, 442, -1, 442, 442, 442, 
	442, 442, 442, 442, 442, -1, -1, -1, 
	-1, 442, 442, -1, 442, 442, 442, -1, 
	-1, -1, -1, -1, -1, -1, -1, 442, 
	442, -1, -1, 442, -1, 442, 442, -1, 
	-1, -1, 442, 442, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 442, 
	442, 442, -1, -1, 442, 442, 442, -1, 
	-1, -1, -1, -1, 442, 442, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	442, -1, 442, -1, -1, 442, 442, 442, 
	-1, -1, 442, 448, 448, 448, 448, 448, 
	448, 448, -1, 448, 448, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 448, 448, 
	448, 448, 448, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 448, -1, -1, 
	-1, 448, -1, -1, -1, 448, 448, 448, 
	448, 448, 448, -1, -1, -1, -1, 448, 
	448, 448, -1, -1, -1, -1, 448, 448, 
	-1, 448, 448, 448, 448, -1, -1, -1, 
	-1, -1, -1, -1, 448, 448, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 448, 448, 448, -1, 448, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 450, 450, 450, 450, 
	450, 450, 450, 450, 450, 450, 450, 450, 
	450, 450, 450, -1, 450, 450, 450, 450, 
	450, 450, 450, 450, -1, -1, -1, 450, 
	450, 450, 450, 450, -1, 450, -1, 450, 
	450, 450, 450, -1, 450, -1, 450, 450, 
	450, -1, -1, 450, -1, -1, 450, 450, 
	450, 450, 450, 442, 450, 450, 450, -1, 
	-1, -1, -1, 450, 450, 450, 450, 450, 
	-1, -1, 450, 450, 450, 450, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 448, 448, 
	448, 448, 448, -1, 448, 448, 448, -1, 
	-1, -1, 448, 448, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 448, 
	448, 448, 448, 448, -1, -1, -1, -1, 
	450, 450, 450, 450, -1, -1, 450, 450, 
	450, 450, 450, 450, -1, -1, 448, -1, 
	450, 450, 450, 450, 450, 450, 450, -1, 
	-1, -1, -1, 450, -1, -1, -1, -1, 
	450, 450, -1, -1, 450, 450, 450, -1, 
	450, 450, -1, -1, 450, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	450, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 450, 450, -1, -1, 
	-1, -1, -1, -1, -1, -1, 450, 450, 
	-1, -1, -1, -1, 450, -1, -1, 452, 
	452, 452, 452, 452, 452, 452, 452, 452, 
	452, 452, 452, -1, -1, 452, 452, 452, 
	452, -1, -1, 450, 450, 450, -1, -1, 
	-1, -1, -1, 450, 450, 452, 452, 452, 
	-1, -1, -1, 452, -1, -1, -1, 450, 
	452, 450, -1, -1, 450, -1, 452, 452, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 452, -1, -1, 452, 
	452, 452, 452, -1, 454, 454, 454, 454, 
	454, 454, 454, 454, 454, 452, 454, 454, 
	-1, -1, 454, 454, 454, 454, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 454, 454, 454, -1, -1, -1, 
	454, -1, -1, -1, -1, 454, -1, -1, 
	-1, -1, -1, 454, 454, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 454, -1, -1, 454, 454, 454, 454, 
	455, 455, 455, 455, 455, 455, 455, 455, 
	455, 454, 455, 455, -1, -1, 455, 455, 
	455, 455, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 455, 455, 
	455, -1, -1, -1, 455, -1, -1, -1, 
	-1, 455, -1, -1, -1, -1, -1, 455, 
	455, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 455, -1, -1, 
	455, 455, 455, 455, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 455, -1, -1, 
	-1, -1, 450, -1, -1, 452, -1, -1, 
	-1, -1, -1, -1, -1, 452, 452, 452, 
	-1, 452, 452, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 452, -1, -1, -1, 
	-1, 452, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	452, 452, 452, -1, -1, -1, -1, -1, 
	452, 452, -1, -1, -1, -1, -1, -1, 
	-1, -1, 454, -1, -1, -1, -1, -1, 
	-1, 454, -1, 452, -1, -1, 454, 454, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 454, -1, -1, -1, -1, 454, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 454, 454, 454, 
	-1, -1, -1, -1, -1, 454, 454, -1, 
	-1, -1, -1, -1, -1, -1, 455, -1, 
	-1, -1, -1, -1, -1, 455, -1, -1, 
	-1, -1, 455, 455, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 455, -1, -1, 
	-1, -1, 455, -1, -1, -1, -1, -1, 
	-1, -1, 455, 455, 455, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 455, 455, 455, -1, -1, -1, -1, 
	-1, 455, 455, -1, -1, -1, -1, -1, 
	682, 682, 682, 682, 682, 682, 682, 682, 
	682, -1, 682, 682, -1, -1, 682, 682, 
	682, 682, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 682, 682, 
	682, -1, -1, -1, 682, -1, -1, -1, 
	-1, 682, -1, -1, -1, -1, -1, 682, 
	682, -1, 448, 448, 448, 448, 448, -1, 
	448, 448, 448, -1, -1, 682, 448, 448, 
	682, 682, 682, 682, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 682, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 448, 448, 448, 448, -1, 
	682, 682, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 448, -1, -1, 456, 456, 456, 
	456, 456, 456, 456, 456, 456, 456, 456, 
	456, 456, 456, 456, 456, 456, 456, 456, 
	456, 456, 456, 456, 456, 456, 456, -1, 
	456, 456, 456, 456, 456, -1, 456, -1, 
	456, 456, 456, 456, -1, 456, -1, 456, 
	456, 456, -1, -1, 456, 456, 456, 456, 
	456, 456, 456, 456, -1, 456, 456, 456, 
	-1, -1, -1, -1, 456, 456, 456, 456, 
	456, -1, -1, 456, 456, 456, 456, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 456, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 682, -1, 
	-1, -1, -1, -1, -1, 682, -1, -1, 
	-1, -1, 682, 682, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 682, -1, -1, 
	-1, -1, 682, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 682, 682, 682, -1, -1, -1, -1, 
	-1, 682, 682, -1, -1, -1, -1, -1, 
	-1, 456, 456, 456, 456, -1, -1, 456, 
	456, -1, 456, 456, 456, -1, -1, -1, 
	-1, 456, 456, 456, -1, 456, 456, 456, 
	-1, -1, -1, -1, 456, -1, -1, -1, 
	-1, 456, -1, -1, -1, 456, 456, 456, 
	-1, 456, 456, -1, -1, 456, -1, -1, 
	-1, -1, -1, -1, -1, -1, 456, 456, 
	456, 456, 456, 456, 456, -1, -1, -1, 
	-1, 456, 456, -1, -1, 456, 456, -1, 
	-1, -1, -1, -1, -1, -1, -1, 456, 
	456, -1, -1, -1, -1, 456, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 456, 456, 456, -1, 
	-1, -1, -1, -1, 456, 456, -1, -1, 
	-1, 452, -1, -1, -1, -1, -1, -1, 
	456, -1, -1, 452, -1, 452, 452, 456, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	452, -1, -1, -1, -1, 452, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 452, 452, 452, -1, 
	-1, -1, -1, -1, 452, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 454, -1, 
	-1, -1, -1, -1, -1, 454, -1, 452, 
	-1, -1, 454, 454, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 454, -1, -1, 
	-1, -1, 454, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 454, 454, 454, -1, -1, -1, -1, 
	-1, 454, -1, -1, -1, -1, -1, -1, 
	-1, -1, 455, -1, -1, -1, -1, -1, 
	-1, 455, -1, -1, -1, -1, 455, 455, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 455, -1, -1, -1, -1, 455, -1, 
	-1, -1, -1, -1, -1, -1, 455, 455, 
	455, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 456, -1, 455, 455, 455, 
	-1, -1, -1, -1, -1, 455, 458, 458, 
	458, 458, 458, 458, 458, 458, 458, 458, 
	458, 458, 458, 458, 458, 458, 458, 458, 
	458, 458, 458, 458, 458, 458, 458, 458, 
	-1, 458, 458, 458, 458, 458, -1, 458, 
	-1, 458, 458, 458, 458, -1, 458, -1, 
	458, 458, 458, -1, -1, 458, 458, 458, 
	458, 458, 458, 458, 458, -1, 458, 458, 
	458, -1, -1, -1, -1, 458, 458, 458, 
	458, 458, -1, -1, 458, 458, 458, 458, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 458, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 458, 458, 458, 458, -1, -1, 
	458, 458, -1, 458, 458, 458, -1, -1, 
	-1, -1, 458, 458, 458, -1, 458, 458, 
	458, -1, -1, -1, -1, 458, -1, -1, 
	-1, -1, 458, -1, -1, -1, 458, 458, 
	458, -1, 458, 458, -1, -1, 458, -1, 
	-1, -1, -1, -1, -1, -1, -1, 458, 
	458, 458, 458, 458, 458, 458, -1, -1, 
	-1, -1, 458, 458, -1, -1, 458, 458, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	458, 458, -1, -1, -1, -1, 458, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 458, 458, 458, 
	-1, -1, -1, -1, -1, 458, 458, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 458, -1, -1, -1, -1, -1, -1, 
	458, 459, 459, 459, 459, 459, 459, 459, 
	459, 459, 459, 459, 459, 459, 459, 459, 
	459, 459, 459, 459, 459, 459, 459, 459, 
	459, 459, 459, -1, 459, 459, 459, 459, 
	459, -1, 459, -1, 459, 459, 459, 459, 
	-1, 459, -1, 459, 459, 459, -1, 459, 
	459, 459, 459, 459, 459, 459, 459, 459, 
	459, 459, 459, 459, -1, 459, 459, 459, 
	459, 459, 459, 459, 459, 459, 459, 459, 
	459, 459, 459, 459, -1, 459, -1, -1, 
	-1, -1, 459, 459, 459, 459, 459, -1, 
	-1, 459, 459, 459, 459, 459, 459, 459, 
	459, 459, 459, 459, 459, 459, 459, 459, 
	459, -1, -1, -1, -1, -1, 459, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 458, 459, 459, 459, 
	459, -1, -1, 459, 459, 459, 459, 459, 
	459, -1, -1, -1, -1, 459, 459, 459, 
	459, 459, 459, 459, -1, -1, -1, -1, 
	459, -1, -1, -1, -1, 459, 459, -1, 
	-1, 459, 459, 459, -1, 459, 459, -1, 
	-1, 459, -1, -1, -1, -1, -1, -1, 
	-1, -1, 459, 459, 459, 459, 459, 459, 
	459, -1, -1, -1, 459, 459, 459, -1, 
	-1, 459, 459, -1, 459, 459, 459, 459, 
	459, -1, 459, 459, 459, -1, -1, -1, 
	459, 459, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 459, 459, 459, -1, 
	-1, 459, -1, -1, -1, -1, 459, -1, 
	459, 459, 459, 459, -1, 459, 459, 459, 
	459, 459, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 459, -1, 459, -1, 
	-1, 459, -1, 459, 459, -1, -1, -1, 
	459, -1, 459, -1, 459, 460, 460, 460, 
	460, 460, 460, 460, 460, 460, 460, 460, 
	460, 460, 460, 460, 460, 460, 460, 460, 
	460, 460, 460, 460, 460, 460, 460, -1, 
	460, 460, 460, 460, 460, -1, 460, -1, 
	460, 460, 460, 460, -1, 460, -1, 460, 
	460, 460, -1, 460, 460, 460, 460, 460, 
	460, 460, 460, 460, 460, 460, 460, 460, 
	-1, 460, 460, 460, 460, 460, 460, 460, 
	460, 460, 460, 460, 460, 460, 460, 460, 
	-1, 460, -1, -1, -1, -1, 460, 460, 
	460, 460, 460, -1, -1, 460, 460, 460, 
	460, 460, 460, 460, 460, 460, 460, 460, 
	460, 460, 460, 460, 460, -1, -1, -1, 
	-1, -1, 460, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 459, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 460, 460, 460, 460, -1, -1, 460, 
	460, 460, 460, 460, 460, -1, -1, -1, 
	-1, 460, 460, 460, 460, 460, 460, 460, 
	-1, -1, -1, -1, 460, -1, -1, -1, 
	-1, 460, 460, -1, -1, 460, 460, 460, 
	-1, 460, 460, -1, -1, 460, -1, -1, 
	-1, -1, -1, -1, -1, -1, 460, 460, 
	460, 460, 460, 460, 460, -1, -1, -1, 
	460, 460, 460, -1, -1, 460, 460, -1, 
	460, 460, 460, 460, 460, -1, 460, 460, 
	460, -1, -1, -1, 460, 460, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	460, 460, 460, -1, -1, 460, -1, -1, 
	-1, -1, 460, -1, 460, 460, 460, 460, 
	-1, 460, 460, 460, 460, 460, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	460, -1, 460, -1, -1, 460, -1, 460, 
	460, -1, -1, -1, 460, -1, 460, -1, 
	460, 461, 461, 461, 461, 461, 461, 461, 
	461, 461, 461, 461, 461, 461, 461, 461, 
	-1, 461, 461, 461, 461, 461, 461, 461, 
	461, -1, -1, -1, 461, 461, 461, 461, 
	461, -1, 461, -1, 461, 461, 461, 461, 
	-1, 461, -1, 461, 461, 461, -1, -1, 
	461, -1, -1, 461, 461, 461, 461, 461, 
	-1, 461, 461, 461, 461, -1, -1, -1, 
	461, 461, 461, 461, 461, -1, 461, 461, 
	461, 461, 461, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 460, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 461, 461, 461, 
	461, -1, -1, 461, 461, 461, 461, 461, 
	461, -1, -1, -1, -1, 461, 461, 461, 
	461, 461, 461, 461, -1, 461, 461, -1, 
	461, -1, -1, -1, -1, 461, 461, -1, 
	-1, 461, 461, 461, -1, 461, 461, -1, 
	-1, 461, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 461, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 461, 461, -1, -1, -1, -1, -1, 
	-1, -1, -1, 461, 461, -1, -1, -1, 
	-1, 461, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	461, 461, 461, -1, -1, -1, -1, -1, 
	461, 461, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 461, -1, 461, -1, 
	-1, 461, -1, -1, 463, 463, 463, 463, 
	463, 463, 463, 463, 463, 463, 463, 463, 
	463, 463, 463, -1, 463, 463, 463, 463, 
	463, 463, 463, 463, -1, -1, -1, 463, 
	463, 463, 463, 463, -1, 463, -1, 463, 
	463, 463, 463, -1, 463, -1, 463, 463, 
	463, -1, -1, 463, -1, -1, 463, 463, 
	463, 463, 463, -1, 463, 463, 463, -1, 
	-1, -1, -1, 463, 463, 463, 463, 463, 
	-1, -1, 463, 463, 463, 463, -1, 468, 
	468, 468, 468, 468, 468, 468, -1, 468, 
	468, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 468, 468, 468, 468, 468, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 468, -1, -1, -1, 468, -1, -1, 
	-1, 468, 468, 468, 468, 468, 468, -1, 
	-1, -1, -1, 468, 468, 468, -1, -1, 
	-1, -1, 468, 468, -1, 468, 468, 468, 
	468, 468, -1, -1, -1, -1, -1, -1, 
	468, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 468, 468, 
	468, 468, 468, -1, -1, 468, 468, 461, 
	463, 463, 463, 463, 468, -1, 463, 463, 
	-1, 463, 463, 463, -1, -1, -1, -1, 
	463, 463, 463, -1, 463, 463, 463, -1, 
	-1, -1, -1, 463, -1, -1, -1, -1, 
	463, 463, -1, -1, 463, 463, 463, -1, 
	463, 463, -1, -1, 463, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	463, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 463, 463, -1, -1, 
	-1, -1, -1, -1, -1, -1, 463, 463, 
	-1, -1, -1, -1, 463, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 463, 463, 463, -1, -1, 
	-1, -1, -1, 463, 463, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 463, 
	-1, -1, -1, -1, 463, -1, -1, -1, 
	-1, -1, 468, 468, 468, 468, 468, -1, 
	468, 468, 468, -1, -1, -1, -1, 468, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 468, 468, 468, -1, -1, -1, 
	-1, -1, -1, -1, 468, -1, -1, -1, 
	-1, -1, -1, 468, 468, 468, 468, 468, 
	469, 469, 469, 469, 469, 469, 469, 469, 
	469, 469, 469, 469, 469, 469, 469, -1, 
	469, 469, 469, 469, 469, 469, 469, 469, 
	468, -1, -1, 469, 469, 469, 469, 469, 
	-1, 469, -1, 469, 469, 469, 469, -1, 
	469, -1, 469, 469, 469, -1, -1, 469, 
	-1, -1, 469, 469, 469, 469, 469, -1, 
	469, 469, 469, -1, -1, -1, -1, 469, 
	469, 469, 469, 469, -1, -1, 469, 469, 
	469, 469, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 469, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 463, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 469, 469, 469, 469, 
	-1, -1, 469, 469, 469, 469, 469, 469, 
	-1, -1, -1, -1, 469, 469, 469, 469, 
	469, 469, 469, -1, -1, -1, -1, 469, 
	-1, -1, -1, -1, 469, 469, -1, -1, 
	469, 469, 469, -1, 469, 469, -1, -1, 
	469, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 469, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	469, 469, -1, -1, -1, -1, -1, -1, 
	-1, -1, 469, 469, -1, -1, -1, -1, 
	469, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 469, 
	469, 469, -1, -1, -1, -1, -1, 469, 
	469, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 469, -1, 469, -1, -1, 
	469, -1, -1, 472, 472, 472, 472, 472, 
	472, 472, 472, 472, 472, 472, 472, 472, 
	472, 472, -1, 472, 472, 472, 472, 472, 
	472, 472, 472, -1, -1, -1, 472, 472, 
	472, 472, 472, -1, 472, -1, 472, 472, 
	472, 472, -1, 472, -1, 472, 472, 472, 
	-1, -1, 472, -1, -1, 472, 472, 472, 
	472, 472, -1, 472, 472, 472, -1, -1, 
	-1, -1, 472, 472, 472, 472, 472, -1, 
	-1, 472, 472, 472, 472, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 469, 472, 
	472, 472, 472, -1, -1, 472, 472, 472, 
	472, 472, 472, -1, -1, -1, -1, 472, 
	472, 472, 472, 472, 472, 472, -1, -1, 
	-1, -1, 472, -1, -1, -1, -1, 472, 
	472, -1, -1, 472, 472, 472, -1, 472, 
	472, -1, -1, 472, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 472, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 472, 472, -1, -1, -1, 
	-1, -1, -1, -1, -1, 472, 472, -1, 
	-1, -1, -1, 472, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 472, 472, 472, -1, -1, -1, 
	-1, -1, 472, 472, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 472, -1, 
	472, -1, -1, 472, -1, -1, 475, 475, 
	475, 475, 475, 475, 475, 475, 475, 475, 
	475, 475, 475, 475, 475, 475, 475, 475, 
	475, 475, 475, 475, 475, 475, 475, 475, 
	-1, 475, 475, 475, 475, 475, -1, 475, 
	-1, 475, 475, 475, 475, -1, 475, -1, 
	475, 475, 475, -1, -1, 475, 475, 475, 
	475, 475, 475, 475, 475, -1, 475, 475, 
	475, -1, -1, -1, -1, 475, 475, 475, 
	475, 475, -1, -1, 475, 475, 475, 475, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 475, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 472, 475, 475, 475, 475, -1, -1, 
	475, 475, -1, 475, 475, 475, -1, -1, 
	-1, -1, 475, 475, 475, -1, 475, 475, 
	475, -1, -1, -1, -1, 475, -1, -1, 
	-1, -1, 475, -1, -1, -1, 475, 475, 
	475, -1, 475, 475, -1, -1, 475, -1, 
	-1, -1, -1, -1, -1, -1, -1, 475, 
	475, 475, 475, 475, 475, 475, -1, -1, 
	-1, -1, 475, 475, -1, -1, 475, 475, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	475, 475, -1, -1, -1, -1, 475, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 475, 475, 475, 
	-1, -1, -1, -1, -1, 475, 475, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 475, -1, -1, -1, -1, -1, -1, 
	475, 476, 476, 476, 476, 476, 476, 476, 
	476, 476, 476, 476, 476, 476, 476, 476, 
	-1, 476, 476, 476, 476, 476, 476, 476, 
	476, -1, -1, -1, 476, 476, 476, 476, 
	476, -1, 476, -1, 476, 476, 476, 476, 
	-1, 476, -1, 476, 476, 476, -1, -1, 
	476, -1, -1, 476, 476, 476, 476, 476, 
	-1, 476, 476, 476, -1, -1, -1, -1, 
	476, 476, 476, 476, 476, -1, -1, 476, 
	476, 476, 476, -1, 476, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 475, 476, 476, 476, 
	476, -1, -1, 476, 476, 476, 476, 476, 
	476, -1, -1, -1, -1, 476, 476, 476, 
	476, 476, 476, 476, -1, -1, -1, -1, 
	476, -1, -1, -1, -1, 476, 476, -1, 
	-1, 476, 476, 476, -1, 476, 476, -1, 
	-1, 476, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 476, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 476, 476, -1, -1, -1, -1, -1, 
	-1, -1, -1, 476, 476, -1, -1, -1, 
	-1, 476, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	476, 476, 476, -1, -1, -1, -1, -1, 
	476, 476, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 476, -1, 476, -1, 
	-1, 476, -1, -1, 477, 477, 477, 477, 
	477, 477, 477, 477, 477, 477, 477, 477, 
	477, 477, 477, -1, 477, 477, 477, 477, 
	477, 477, 477, 477, -1, -1, -1, 477, 
	477, 477, 477, 477, -1, 477, -1, 477, 
	477, 477, 477, -1, 477, -1, 477, 477, 
	477, -1, -1, 477, -1, -1, 477, 477, 
	477, 477, 477, -1, 477, 477, 477, -1, 
	-1, -1, -1, 477, 477, 477, 477, 477, 
	-1, -1, 477, 477, 477, 477, -1, 477, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 476, 
	477, 477, 477, 477, -1, -1, 477, 477, 
	477, 477, 477, 477, -1, -1, -1, -1, 
	477, 477, 477, 477, 477, 477, 477, -1, 
	-1, -1, -1, 477, -1, -1, -1, -1, 
	477, 477, -1, -1, 477, 477, 477, -1, 
	477, 477, -1, -1, 477, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	477, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 477, 477, -1, -1, 
	-1, -1, -1, -1, -1, -1, 477, 477, 
	-1, -1, -1, -1, 477, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 477, 477, 477, -1, -1, 
	-1, -1, -1, 477, 477, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 477, 
	-1, 477, -1, -1, 477, -1, -1, 484, 
	484, 484, 484, 484, 484, 484, 484, 484, 
	484, 484, 484, 484, 484, 484, -1, 484, 
	484, 484, 484, 484, 484, 484, 484, -1, 
	-1, -1, 484, 484, 484, 484, 484, -1, 
	484, -1, 484, 484, 484, 484, -1, 484, 
	-1, 484, 484, 484, -1, -1, 484, -1, 
	-1, 484, 484, 484, 484, 484, -1, 484, 
	484, 484, -1, -1, -1, -1, 484, 484, 
	484, 484, 484, -1, -1, 484, 484, 484, 
	484, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 477, 484, 484, 484, 484, -1, 
	-1, 484, 484, 484, 484, 484, 484, -1, 
	-1, -1, -1, 484, 484, 484, 484, 484, 
	484, 484, -1, -1, -1, -1, 484, -1, 
	-1, -1, -1, 484, 484, -1, -1, 484, 
	484, 484, -1, 484, 484, -1, -1, 484, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 484, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 484, 
	484, -1, -1, -1, -1, -1, -1, -1, 
	-1, 484, 484, -1, -1, -1, -1, 484, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 484, 484, 
	484, -1, -1, -1, -1, -1, 484, 484, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 484, -1, 484, -1, -1, 484, 
	-1, -1, 500, 500, 500, 500, 500, 500, 
	500, 500, 500, 500, 500, 500, 500, 500, 
	500, -1, 500, 500, 500, 500, 500, 500, 
	500, 500, -1, -1, -1, 500, 500, 500, 
	500, 500, -1, 500, -1, 500, 500, 500, 
	500, -1, 500, -1, 500, 500, 500, -1, 
	-1, 500, -1, -1, 500, 500, 500, 500, 
	500, -1, 500, 500, 500, -1, -1, -1, 
	-1, 500, 500, 500, 500, 500, -1, -1, 
	500, 500, 500, 500, 504, 504, 504, 504, 
	504, 504, 504, -1, 504, 504, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 504, 
	504, 504, 504, 504, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 504, -1, 
	-1, -1, 504, -1, -1, -1, 504, 504, 
	504, 504, 504, 504, -1, -1, -1, -1, 
	504, 504, 504, -1, -1, -1, -1, 504, 
	504, -1, 504, 504, 504, 504, -1, -1, 
	-1, -1, -1, -1, -1, 504, 504, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 504, 504, 504, -1, 504, 
	-1, -1, -1, -1, -1, 484, 500, 500, 
	500, 500, -1, -1, 500, 500, 500, 500, 
	500, 500, -1, -1, -1, -1, 500, 500, 
	500, 500, 500, 500, 500, -1, -1, -1, 
	-1, 500, -1, -1, -1, -1, 500, 500, 
	-1, -1, 500, 500, 500, -1, 500, 500, 
	-1, -1, 500, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 500, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 500, 500, -1, -1, -1, -1, 
	-1, -1, -1, -1, 500, 500, -1, -1, 
	-1, -1, 500, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 500, 500, 500, -1, -1, -1, -1, 
	-1, 500, 500, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 500, -1, 500, 
	-1, -1, 500, -1, -1, -1, -1, 504, 
	504, 504, 504, 504, -1, 504, 504, 504, 
	-1, -1, -1, 504, 504, 505, 505, 505, 
	505, 505, 505, 505, -1, 505, 505, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	505, 505, 505, 505, 505, -1, -1, -1, 
	504, 504, 504, 504, 504, -1, -1, 505, 
	-1, -1, -1, 505, -1, -1, -1, 505, 
	505, 505, 505, 505, 505, -1, -1, 504, 
	-1, 505, 505, 505, -1, -1, -1, -1, 
	505, 505, -1, 505, 505, 505, 505, -1, 
	-1, -1, -1, -1, -1, -1, 505, 505, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 505, 505, 505, -1, 
	505, -1, -1, 505, 505, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 506, 
	506, 506, 506, 506, 506, 506, 506, 506, 
	506, 506, 506, 506, 506, 506, 506, 506, 
	506, 506, 506, 506, 506, 506, 506, 506, 
	506, -1, 506, 506, 506, 506, 506, -1, 
	506, -1, 506, 506, 506, 506, -1, 506, 
	500, 506, 506, 506, -1, 506, 506, 506, 
	506, 506, 506, 506, 506, 506, 506, 506, 
	506, 506, -1, 506, 506, 506, 506, 506, 
	506, 506, 506, 506, 506, 506, 506, 506, 
	506, 506, -1, 506, -1, -1, -1, -1, 
	506, 506, 506, 506, 506, -1, -1, 506, 
	506, 506, 506, 506, 506, 506, 506, 506, 
	506, 506, 506, 506, 506, 506, 506, -1, 
	-1, -1, -1, -1, 506, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	505, 505, 505, 505, 505, -1, 505, 505, 
	505, -1, -1, -1, 505, 505, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 505, 505, 505, 505, 505, -1, -1, 
	-1, -1, -1, 506, 506, 506, 506, -1, 
	-1, 506, 506, 506, 506, 506, 506, -1, 
	505, -1, -1, 506, 506, 506, 506, 506, 
	506, 506, -1, -1, -1, -1, 506, -1, 
	-1, -1, -1, 506, 506, -1, -1, 506, 
	506, 506, -1, 506, 506, -1, -1, 506, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	506, 506, 506, 506, 506, 506, 506, -1, 
	-1, -1, 506, 506, 506, -1, -1, 506, 
	506, -1, 506, 506, 506, 506, 506, -1, 
	506, 506, 506, -1, -1, -1, 506, 506, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 506, 506, 506, -1, -1, 506, 
	-1, -1, -1, -1, 506, -1, 506, 506, 
	506, 506, -1, 506, 506, 506, 506, 506, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 506, -1, 506, -1, -1, 506, 
	-1, 506, 506, -1, -1, -1, 506, -1, 
	506, -1, 506, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 507, 507, 507, 507, 507, 507, 507, 
	507, 507, 507, 507, 507, 507, 507, 507, 
	507, 507, 507, 507, 507, 507, 507, 507, 
	507, 507, 507, -1, 507, 507, 507, 507, 
	507, -1, 507, -1, 507, 507, 507, 507, 
	-1, 507, -1, 507, 507, 507, -1, 507, 
	507, 507, 507, 507, 507, 507, 507, 507, 
	507, 507, 507, 507, -1, 507, 507, 507, 
	507, 507, 507, 507, 507, 507, 507, 507, 
	507, 507, 507, 507, -1, 507, -1, -1, 
	-1, -1, 507, 507, 507, 507, 507, -1, 
	-1, 507, 507, 507, 507, 507, 507, 507, 
	507, 507, 507, 507, 507, 507, 507, 507, 
	507, -1, -1, -1, -1, -1, 507, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 506, -1, -1, 
	-1, -1, -1, 504, 504, 504, 504, 504, 
	-1, 504, 504, 504, -1, -1, -1, 504, 
	504, -1, -1, -1, -1, 507, 507, 507, 
	507, -1, -1, 507, 507, 507, 507, 507, 
	507, -1, -1, -1, -1, 507, 507, 507, 
	507, 507, 507, 507, 504, 504, 504, 504, 
	507, -1, -1, -1, -1, 507, 507, -1, 
	-1, 507, 507, 507, -1, 507, 507, -1, 
	-1, 507, -1, 504, -1, -1, -1, -1, 
	-1, -1, 507, 507, 507, 507, 507, 507, 
	507, -1, -1, -1, 507, 507, 507, -1, 
	-1, 507, 507, -1, 507, 507, 507, 507, 
	507, -1, 507, 507, 507, -1, -1, -1, 
	507, 507, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 507, 507, 507, -1, 
	-1, 507, -1, -1, -1, -1, 507, -1, 
	507, 507, 507, 507, -1, 507, 507, 507, 
	507, 507, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 507, -1, 507, -1, 
	-1, 507, -1, 507, 507, -1, -1, -1, 
	507, -1, 507, -1, 507, 508, 508, 508, 
	508, 508, 508, 508, 508, 508, 508, 508, 
	508, 508, 508, 508, 508, 508, 508, 508, 
	508, 508, 508, 508, 508, 508, 508, -1, 
	508, 508, 508, 508, 508, -1, 508, -1, 
	508, 508, 508, 508, -1, 508, -1, 508, 
	508, 508, -1, 508, 508, 508, 508, 508, 
	508, 508, 508, 508, 508, 508, 508, 508, 
	-1, 508, 508, 508, 508, 508, 508, 508, 
	508, 508, 508, 508, 508, 508, 508, 508, 
	-1, 508, -1, -1, -1, -1, 508, 508, 
	508, 508, 508, -1, -1, 508, 508, 508, 
	508, 508, 508, 508, 508, 508, 508, 508, 
	508, 508, 508, 508, 508, -1, -1, -1, 
	-1, -1, 508, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 507, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 508, 508, 508, 508, -1, -1, 508, 
	508, 508, 508, 508, 508, -1, -1, -1, 
	-1, 508, 508, 508, 508, 508, 508, 508, 
	-1, -1, -1, -1, 508, -1, -1, -1, 
	-1, 508, 508, -1, -1, 508, 508, 508, 
	-1, 508, 508, -1, -1, 508, -1, -1, 
	-1, -1, -1, -1, -1, -1, 508, 508, 
	508, 508, 508, 508, 508, -1, -1, -1, 
	508, 508, 508, -1, -1, 508, 508, -1, 
	508, 508, 508, 508, 508, -1, 508, 508, 
	508, -1, -1, -1, 508, 508, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	508, 508, 508, -1, -1, 508, -1, -1, 
	-1, -1, 508, -1, 508, 508, 508, 508, 
	-1, 508, 508, 508, 508, 508, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	508, -1, 508, -1, -1, 508, -1, 508, 
	508, -1, -1, -1, 508, -1, 508, -1, 
	508, 509, 509, 509, 509, 509, 509, 509, 
	509, 509, 509, 509, 509, 509, 509, 509, 
	509, 509, 509, 509, 509, 509, 509, 509, 
	509, 509, 509, -1, 509, 509, 509, 509, 
	509, -1, 509, -1, 509, 509, 509, 509, 
	-1, 509, -1, 509, 509, 509, -1, 509, 
	509, 509, 509, 509, 509, 509, 509, 509, 
	509, 509, 509, 509, -1, 509, 509, 509, 
	509, 509, 509, 509, 509, 509, 509, 509, 
	509, 509, 509, 509, -1, 509, -1, -1, 
	-1, -1, 509, 509, 509, 509, 509, -1, 
	-1, 509, 509, 509, 509, 509, 509, 509, 
	509, 509, 509, 509, 509, 509, 509, 509, 
	509, -1, -1, -1, -1, -1, 509, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 508, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 509, 509, 509, 
	509, -1, -1, 509, 509, 509, 509, 509, 
	509, -1, -1, -1, -1, 509, 509, 509, 
	509, 509, 509, 509, -1, -1, -1, -1, 
	509, -1, -1, -1, -1, 509, 509, -1, 
	-1, 509, 509, 509, -1, 509, 509, -1, 
	-1, 509, -1, -1, -1, -1, -1, -1, 
	-1, -1, 509, 509, 509, 509, 509, 509, 
	509, -1, -1, -1, 509, 509, 509, -1, 
	-1, 509, 509, -1, 509, 509, 509, 509, 
	509, -1, 509, 509, 509, -1, -1, -1, 
	509, 509, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 509, 509, 509, -1, 
	-1, 509, -1, -1, -1, -1, 509, -1, 
	509, 509, 509, 509, -1, 509, 509, 509, 
	509, 509, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 509, -1, 509, -1, 
	-1, 509, -1, 509, 509, -1, -1, -1, 
	509, -1, 509, -1, 509, 510, 510, 510, 
	510, 510, 510, 510, 510, 510, 510, 510, 
	510, 510, 510, 510, 510, 510, 510, 510, 
	510, 510, 510, 510, 510, 510, 510, -1, 
	510, 510, 510, 510, 510, -1, 510, -1, 
	510, 510, 510, 510, -1, 510, -1, 510, 
	510, 510, -1, 510, 510, 510, 510, 510, 
	510, 510, 510, 510, 510, 510, 510, 510, 
	-1, 510, 510, 510, 510, 510, 510, 510, 
	510, 510, 510, 510, 510, 510, 510, 510, 
	-1, 510, -1, -1, -1, -1, 510, 510, 
	510, 510, 510, -1, -1, 510, 510, 510, 
	510, 510, 510, 510, 510, 510, 510, 510, 
	510, 510, 510, 510, 510, -1, -1, -1, 
	-1, -1, 510, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 509, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 510, 510, 510, 510, -1, -1, 510, 
	510, 510, 510, 510, 510, -1, -1, -1, 
	-1, 510, 510, 510, 510, 510, 510, 510, 
	-1, -1, -1, -1, 510, -1, -1, -1, 
	-1, 510, 510, -1, -1, 510, 510, 510, 
	-1, 510, 510, -1, -1, 510, -1, -1, 
	-1, -1, -1, -1, -1, -1, 510, 510, 
	510, 510, 510, 510, 510, -1, -1, -1, 
	510, 510, 510, -1, -1, 510, 510, -1, 
	510, 510, 510, 510, 510, -1, 510, 510, 
	510, -1, -1, -1, 510, 510, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	510, 510, 510, -1, -1, 510, -1, -1, 
	-1, -1, 510, -1, 510, 510, 510, 510, 
	-1, 510, 510, 510, 510, 510, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	510, -1, 510, -1, -1, 510, -1, 510, 
	510, -1, -1, -1, 510, -1, 510, -1, 
	510, 511, 511, 511, 511, 511, 511, 511, 
	511, 511, 511, 511, 511, 511, 511, 511, 
	511, 511, 511, 511, 511, 511, 511, 511, 
	511, 511, 511, -1, 511, 511, 511, 511, 
	511, -1, 511, -1, 511, 511, 511, 511, 
	-1, 511, -1, 511, 511, 511, -1, 511, 
	511, 511, 511, 511, 511, 511, 511, 511, 
	511, 511, 511, 511, -1, 511, 511, 511, 
	511, 511, 511, 511, 511, 511, 511, 511, 
	511, 511, 511, 511, -1, 511, -1, -1, 
	-1, -1, 511, 511, 511, 511, 511, -1, 
	-1, 511, 511, 511, 511, 511, 511, 511, 
	511, 511, 511, 511, 511, 511, 511, 511, 
	511, -1, -1, -1, -1, -1, 511, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 510, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 511, 511, 511, 
	511, -1, -1, 511, 511, 511, 511, 511, 
	511, -1, -1, -1, -1, 511, 511, 511, 
	511, 511, 511, 511, -1, -1, -1, -1, 
	511, -1, -1, -1, -1, 511, 511, -1, 
	-1, 511, 511, 511, -1, 511, 511, -1, 
	-1, 511, -1, -1, -1, -1, -1, -1, 
	-1, -1, 511, 511, 511, 511, 511, 511, 
	511, -1, -1, -1, 511, 511, 511, -1, 
	-1, 511, 511, -1, 511, 511, 511, 511, 
	511, -1, 511, 511, 511, -1, -1, -1, 
	511, 511, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 511, 511, 511, -1, 
	-1, 511, -1, -1, -1, -1, 511, -1, 
	511, 511, 511, 511, -1, 511, 511, 511, 
	511, 511, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 511, -1, 511, -1, 
	-1, 511, -1, 511, 511, -1, -1, -1, 
	511, -1, 511, -1, 511, 512, 512, 512, 
	512, 512, 512, 512, 512, 512, 512, 512, 
	512, 512, 512, 512, 512, 512, 512, 512, 
	512, 512, 512, 512, 512, 512, 512, -1, 
	512, 512, 512, 512, 512, -1, 512, -1, 
	512, 512, 512, 512, -1, 512, -1, 512, 
	512, 512, -1, 512, 512, 512, 512, 512, 
	512, 512, 512, 512, 512, 512, 512, 512, 
	-1, 512, 512, 512, 512, 512, 512, 512, 
	512, 512, 512, 512, 512, 512, 512, 512, 
	-1, 512, -1, -1, -1, -1, 512, 512, 
	512, 512, 512, -1, -1, 512, 512, 512, 
	512, 512, 512, 512, 512, 512, 512, 512, 
	512, 512, 512, 512, 512, -1, -1, -1, 
	-1, -1, 512, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 511, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 512, 512, 512, 512, -1, -1, 512, 
	512, 512, 512, 512, 512, -1, -1, -1, 
	-1, 512, 512, 512, 512, 512, 512, 512, 
	-1, -1, -1, -1, 512, -1, -1, -1, 
	-1, 512, 512, -1, -1, 512, 512, 512, 
	-1, 512, 512, -1, -1, 512, -1, -1, 
	-1, -1, -1, -1, -1, -1, 512, 512, 
	512, 512, 512, 512, 512, -1, -1, -1, 
	512, 512, 512, -1, -1, 512, 512, -1, 
	512, 512, 512, 512, 512, -1, 512, 512, 
	512, -1, -1, -1, 512, 512, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	512, 512, 512, -1, -1, 512, -1, -1, 
	-1, -1, 512, -1, 512, 512, 512, 512, 
	-1, 512, 512, 512, 512, 512, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	512, -1, 512, -1, -1, 512, -1, 512, 
	512, -1, -1, -1, 512, -1, 512, -1, 
	512, 513, 513, 513, 513, 513, 513, 513, 
	513, 513, 513, 513, 513, 513, 513, 513, 
	513, 513, 513, 513, 513, 513, 513, 513, 
	513, 513, 513, -1, 513, 513, 513, 513, 
	513, -1, 513, -1, 513, 513, 513, 513, 
	-1, 513, -1, 513, 513, 513, -1, 513, 
	513, 513, 513, 513, 513, 513, 513, 513, 
	513, 513, 513, 513, -1, 513, 513, 513, 
	513, 513, 513, 513, 513, 513, 513, 513, 
	513, 513, 513, 513, -1, 513, -1, -1, 
	-1, -1, 513, 513, 513, 513, 513, -1, 
	-1, 513, 513, 513, 513, 513, 513, 513, 
	513, 513, 513, 513, 513, 513, 513, 513, 
	513, -1, -1, -1, -1, -1, 513, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 512, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 513, 513, 513, 
	513, -1, -1, 513, 513, 513, 513, 513, 
	513, -1, -1, -1, -1, 513, 513, 513, 
	513, 513, 513, 513, -1, -1, -1, -1, 
	513, -1, -1, -1, -1, 513, 513, -1, 
	-1, 513, 513, 513, -1, 513, 513, -1, 
	-1, 513, -1, -1, -1, -1, -1, -1, 
	-1, -1, 513, 513, 513, 513, 513, 513, 
	513, -1, -1, -1, 513, 513, 513, -1, 
	-1, 513, 513, -1, 513, 513, 513, 513, 
	513, -1, 513, 513, 513, -1, -1, -1, 
	513, 513, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 513, 513, 513, -1, 
	-1, 513, -1, -1, -1, -1, 513, -1, 
	513, 513, 513, 513, -1, 513, 513, 513, 
	513, 513, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 513, -1, 513, -1, 
	-1, 513, -1, 513, 513, -1, -1, -1, 
	513, -1, 513, -1, 513, 517, 517, 517, 
	517, 517, 517, 517, -1, 517, 517, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	517, 517, 517, 517, 517, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 517, 
	-1, -1, -1, 517, -1, -1, -1, 517, 
	517, 517, 517, 517, 517, -1, -1, -1, 
	-1, 517, 517, 517, -1, -1, -1, -1, 
	517, 517, 517, 517, 517, 517, 517, 517, 
	-1, -1, -1, -1, -1, -1, 517, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 517, 517, 517, 517, 
	517, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 520, 520, 520, 520, 520, 520, 
	520, 520, 520, 520, 520, 520, 520, 520, 
	520, 520, 520, 520, 520, 520, 520, 520, 
	520, 520, 520, 520, -1, 520, 520, 520, 
	520, 520, -1, 520, -1, 520, 520, 520, 
	520, -1, 520, -1, 520, 520, 520, 513, 
	520, 520, 520, 520, 520, 520, 520, 520, 
	520, 520, 520, 520, 520, -1, 520, 520, 
	520, 520, 520, 520, 520, 520, 520, 520, 
	520, 520, 520, 520, 520, -1, 520, -1, 
	-1, -1, -1, 520, 520, 520, 520, 520, 
	-1, -1, 520, 520, 520, 520, 520, 520, 
	520, 520, 520, 520, 520, 520, 520, 520, 
	520, 520, -1, -1, -1, -1, -1, 520, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	517, 517, 517, 517, 517, -1, 517, 517, 
	517, -1, -1, -1, -1, 517, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	517, 517, 517, -1, -1, 517, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 517, 517, 517, 517, 517, -1, -1, 
	-1, -1, -1, -1, -1, -1, 520, 520, 
	520, 520, -1, -1, 520, 520, 520, 520, 
	520, 520, -1, -1, 517, -1, 520, 520, 
	520, 520, 520, 520, 520, -1, -1, -1, 
	-1, 520, -1, -1, -1, -1, 520, 520, 
	-1, -1, 520, 520, 520, -1, 520, 520, 
	-1, -1, 520, -1, -1, -1, -1, -1, 
	-1, -1, -1, 520, 520, 520, 520, 520, 
	520, 520, -1, -1, -1, 520, 520, 520, 
	520, -1, 520, 520, -1, 520, 520, 520, 
	520, 520, -1, 520, 520, 520, -1, -1, 
	-1, 520, 520, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 520, 520, 520, 
	-1, -1, 520, -1, -1, -1, -1, 520, 
	-1, 520, 520, 520, 520, -1, 520, 520, 
	520, 520, 520, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 520, -1, 520, 
	-1, -1, 520, -1, 520, 520, -1, -1, 
	-1, 520, -1, 520, -1, 520, 521, 521, 
	521, 521, 521, 521, 521, 521, 521, 521, 
	521, 521, 521, 521, 521, 521, 521, 521, 
	521, 521, 521, 521, 521, 521, 521, 521, 
	-1, 521, 521, 521, 521, 521, -1, 521, 
	-1, 521, 521, 521, 521, -1, 521, -1, 
	521, 521, 521, -1, 521, 521, 521, 521, 
	521, 521, 521, 521, 521, 521, 521, 521, 
	521, -1, 521, 521, 521, 521, 521, 521, 
	521, 521, 521, 521, 521, 521, 521, 521, 
	521, -1, 521, -1, -1, -1, -1, 521, 
	521, 521, 521, 521, -1, -1, 521, 521, 
	521, 521, 521, 521, 521, 521, 521, 521, 
	521, 521, 521, 521, 521, 521, -1, -1, 
	-1, -1, -1, 521, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	520, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 521, 521, 521, 521, -1, -1, 
	521, 521, 521, 521, 521, 521, -1, -1, 
	-1, -1, 521, 521, 521, 521, 521, 521, 
	521, -1, -1, -1, -1, 521, -1, -1, 
	-1, -1, 521, 521, -1, -1, 521, 521, 
	521, -1, 521, 521, -1, -1, 521, -1, 
	-1, -1, -1, -1, -1, -1, -1, 521, 
	521, 521, 521, 521, 521, 521, -1, -1, 
	-1, 521, 521, 521, 521, -1, 521, 521, 
	-1, 521, 521, 521, 521, 521, -1, 521, 
	521, 521, -1, -1, -1, 521, 521, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 521, 521, 521, -1, -1, 521, -1, 
	-1, -1, -1, 521, -1, 521, 521, 521, 
	521, -1, 521, 521, 521, 521, 521, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 521, -1, 521, -1, -1, 521, -1, 
	521, 521, -1, -1, -1, 521, -1, 521, 
	-1, 521, 522, 522, 522, 522, 522, 522, 
	522, 522, 522, 522, 522, 522, 522, 522, 
	522, 522, 522, 522, 522, 522, 522, 522, 
	522, 522, 522, 522, -1, 522, 522, 522, 
	522, 522, -1, 522, -1, 522, 522, 522, 
	522, -1, 522, -1, 522, 522, 522, -1, 
	522, 522, 522, 522, 522, 522, 522, 522, 
	522, 522, 522, 522, 522, -1, 522, 522, 
	522, 522, 522, 522, 522, 522, 522, 522, 
	522, 522, 522, 522, 522, -1, 522, -1, 
	-1, -1, -1, 522, 522, 522, 522, 522, 
	-1, -1, 522, 522, 522, 522, 522, 522, 
	522, 522, 522, 522, 522, 522, 522, 522, 
	522, 522, -1, -1, -1, -1, -1, 522, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 517, 517, -1, 
	-1, 517, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 521, -1, -1, -1, 
	517, -1, -1, -1, -1, -1, 522, 522, 
	522, 522, -1, -1, 522, 522, 522, 522, 
	522, 522, -1, -1, -1, -1, 522, 522, 
	522, 522, 522, 522, 522, -1, -1, -1, 
	-1, 522, -1, -1, -1, -1, 522, 522, 
	-1, -1, 522, 522, 522, -1, 522, 522, 
	-1, -1, 522, -1, -1, -1, -1, -1, 
	-1, -1, -1, 522, 522, 522, 522, 522, 
	522, 522, -1, -1, -1, 522, 522, 522, 
	522, -1, 522, 522, -1, 522, 522, 522, 
	522, 522, -1, 522, 522, 522, -1, -1, 
	-1, 522, 522, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 522, 522, 522, 
	-1, -1, 522, -1, -1, -1, -1, 522, 
	-1, 522, 522, 522, 522, -1, 522, 522, 
	522, 522, 522, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 522, -1, 522, 
	-1, -1, 522, -1, 522, 522, -1, -1, 
	-1, 522, -1, 522, -1, 522, 530, 530, 
	530, 530, 530, 530, 530, 530, 530, 530, 
	530, 530, 530, 530, 530, 530, 530, 530, 
	530, 530, 530, 530, 530, 530, 530, 530, 
	-1, 530, 530, 530, 530, 530, -1, 530, 
	-1, 530, 530, 530, 530, -1, 530, -1, 
	530, 530, 530, -1, 530, 530, 530, 530, 
	530, 530, 530, 530, 530, 530, 530, 530, 
	530, -1, 530, 530, 530, 530, 530, 530, 
	530, 530, 530, 530, 530, 530, 530, 530, 
	530, -1, 530, -1, -1, -1, -1, 530, 
	530, 530, 530, 530, -1, -1, 530, 530, 
	530, 530, 530, 530, 530, 530, 530, 530, 
	530, 530, 530, 530, 530, 530, -1, -1, 
	-1, -1, -1, 530, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	522, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 530, 530, 530, 530, -1, -1, 
	530, 530, 530, 530, 530, 530, -1, -1, 
	-1, -1, 530, 530, 530, 530, 530, 530, 
	530, -1, -1, -1, -1, 530, -1, -1, 
	-1, -1, 530, 530, -1, -1, 530, 530, 
	530, -1, 530, 530, -1, -1, 530, -1, 
	-1, -1, -1, -1, -1, -1, -1, 530, 
	530, 530, 530, 530, 530, 530, -1, -1, 
	-1, 530, 530, 530, 530, -1, 530, 530, 
	-1, 530, 530, 530, 530, 530, -1, 530, 
	530, 530, -1, -1, -1, 530, 530, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 530, 530, 530, -1, -1, 530, -1, 
	-1, -1, -1, 530, -1, 530, 530, 530, 
	530, -1, 530, 530, 530, 530, 530, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 530, -1, 530, -1, -1, 530, -1, 
	530, 530, -1, -1, -1, 530, -1, 530, 
	-1, 530, 547, 547, 547, 547, 547, 547, 
	547, -1, 547, 547, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 547, 547, 547, 
	547, 547, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 547, -1, -1, -1, 
	547, -1, -1, -1, 547, 547, 547, 547, 
	547, 547, -1, -1, -1, -1, 547, 547, 
	547, -1, -1, -1, -1, 547, 547, -1, 
	547, 547, 547, 547, -1, -1, -1, -1, 
	-1, -1, -1, 547, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 547, 547, 547, -1, 547, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 548, 548, 548, 548, 548, 
	548, 548, 548, 548, 548, 548, 548, 548, 
	548, 548, 548, 548, 548, 548, 548, 548, 
	548, 548, 548, 548, 548, 548, 548, 548, 
	548, 548, 548, -1, 548, -1, 548, 548, 
	548, 548, 548, 548, 530, 548, 548, 548, 
	-1, -1, 548, 548, 548, 548, 548, 548, 
	548, 548, -1, 548, 548, 548, 548, -1, 
	-1, -1, 548, 548, 548, 548, 548, -1, 
	-1, 548, 548, 548, 548, -1, -1, -1, 
	548, -1, -1, -1, 548, 548, -1, 548, 
	-1, -1, 548, -1, -1, 548, -1, 548, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 547, -1, -1, -1, 
	-1, -1, -1, -1, -1, 547, 547, 547, 
	547, 547, -1, 547, 547, 547, -1, -1, 
	-1, -1, 547, -1, -1, -1, -1, -1, 
	-1, 548, -1, -1, -1, -1, 547, 547, 
	547, -1, -1, 548, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 547, 547, 
	547, 547, 547, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 548, 
	548, 548, 548, -1, -1, 548, 548, 548, 
	548, 548, 548, -1, -1, -1, -1, 548, 
	548, 548, 548, 548, 548, 548, -1, -1, 
	548, -1, 548, -1, -1, -1, -1, 548, 
	548, -1, 548, 548, 548, 548, -1, 548, 
	548, -1, -1, 548, -1, -1, -1, -1, 
	-1, 548, -1, 548, 548, 548, 548, 548, 
	548, 548, 548, -1, -1, -1, -1, 548, 
	548, -1, 548, 548, 548, -1, -1, -1, 
	-1, -1, -1, -1, -1, 548, 548, -1, 
	-1, 548, -1, 548, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 548, 548, 548, 
	-1, -1, 548, 548, 548, -1, -1, -1, 
	-1, -1, 548, 548, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 548, -1, 
	548, -1, -1, 548, 548, 548, 549, 549, 
	549, 549, 549, 549, 549, 549, 549, 549, 
	549, 549, 549, 549, 549, 549, 549, 549, 
	549, 549, 549, 549, 549, 549, 549, 549, 
	549, 549, 549, 549, 549, 549, -1, 549, 
	-1, 549, 549, 549, 549, 549, 549, -1, 
	549, 549, 549, -1, -1, 549, 549, 549, 
	549, 549, 549, 549, 549, -1, 549, 549, 
	549, 549, -1, -1, -1, 549, 549, 549, 
	549, 549, -1, -1, 549, 549, 549, 549, 
	-1, -1, -1, 549, -1, -1, -1, 549, 
	549, -1, 549, -1, -1, 549, -1, -1, 
	549, -1, 549, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 549, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 549, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 548, 549, 549, 549, 549, -1, -1, 
	549, 549, 549, 549, 549, 549, -1, -1, 
	-1, -1, 549, 549, 549, 549, 549, 549, 
	549, -1, -1, 549, -1, 549, -1, -1, 
	-1, -1, 549, 549, -1, 549, 549, 549, 
	549, -1, 549, 549, -1, -1, 549, -1, 
	-1, -1, -1, -1, 549, -1, 549, 549, 
	549, 549, 549, 549, 549, 549, -1, -1, 
	-1, -1, 549, 549, -1, 549, 549, 549, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	549, 549, -1, -1, 549, -1, 549, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	549, 549, 549, -1, -1, 549, 549, 549, 
	-1, -1, -1, -1, -1, 549, 549, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 549, -1, 549, -1, -1, 549, 549, 
	549, 550, 550, 550, 550, 550, 550, 550, 
	550, 550, 550, 550, 550, 550, 550, 550, 
	550, 550, 550, 550, 550, 550, 550, 550, 
	550, 550, 550, 550, 550, 550, 550, 550, 
	550, -1, 550, -1, 550, 550, 550, 550, 
	550, 550, -1, 550, 550, 550, -1, -1, 
	550, 550, 550, 550, 550, 550, 550, 550, 
	-1, 550, 550, 550, 550, -1, -1, -1, 
	550, 550, 550, 550, 550, -1, -1, 550, 
	550, 550, 550, -1, -1, -1, 550, -1, 
	-1, -1, 550, 550, -1, 550, -1, -1, 
	550, -1, -1, 550, -1, 550, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	547, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 550, 
	-1, -1, 547, 547, 547, -1, -1, -1, 
	-1, 550, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 549, 550, 550, 550, 
	550, -1, -1, 550, 550, 550, 550, 550, 
	550, -1, -1, -1, -1, 550, 550, 550, 
	550, 550, 550, 550, -1, -1, 550, -1, 
	550, -1, -1, -1, -1, 550, 550, -1, 
	550, 550, 550, 550, -1, 550, 550, -1, 
	-1, 550, -1, -1, -1, -1, -1, 550, 
	-1, 550, 550, 550, 550, 550, 550, 550, 
	550, -1, -1, -1, -1, 550, 550, -1, 
	550, 550, 550, -1, -1, -1, -1, -1, 
	-1, -1, -1, 550, 550, -1, -1, 550, 
	-1, 550, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 550, 550, 550, -1, -1, 
	550, 550, 550, -1, -1, -1, -1, -1, 
	550, 550, 553, 553, 553, 553, 553, 553, 
	553, -1, 553, 553, 550, -1, 550, -1, 
	-1, 550, 550, 550, -1, 553, 553, 553, 
	553, 553, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 553, -1, -1, -1, 
	553, -1, -1, -1, 553, 553, 553, 553, 
	553, 553, -1, -1, -1, -1, 553, 553, 
	553, -1, -1, -1, -1, 553, 553, -1, 
	553, 553, 553, 553, -1, -1, -1, -1, 
	-1, -1, -1, 553, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 554, 
	554, 554, 554, 554, 554, 554, 554, 554, 
	554, 554, 554, 554, 554, 554, 554, 554, 
	554, 554, 554, 554, 554, 554, 554, 554, 
	554, -1, 554, 554, 554, 554, 554, -1, 
	554, -1, 554, 554, 554, 554, -1, 554, 
	-1, 554, 554, 554, -1, 554, 554, 554, 
	554, 554, 554, 554, 554, 554, 554, 554, 
	554, 554, -1, 554, 554, 554, 554, 554, 
	554, 554, 554, 554, 554, 554, 554, 554, 
	554, 554, -1, 554, -1, -1, -1, 550, 
	554, 554, 554, 554, 554, -1, -1, 554, 
	554, 554, 554, 554, 554, 554, 554, 554, 
	554, 554, 554, 554, 554, 554, 554, -1, 
	-1, -1, -1, -1, 554, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 553, 553, 553, -1, -1, 
	-1, -1, 553, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 553, 553, 
	553, 553, 553, 554, 554, 554, 554, -1, 
	-1, 554, 554, 554, 554, 554, 554, -1, 
	-1, -1, -1, 554, 554, 554, 554, 554, 
	554, 554, -1, -1, -1, -1, 554, -1, 
	-1, -1, -1, 554, 554, -1, -1, 554, 
	554, 554, -1, 554, 554, -1, -1, 554, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	554, 554, 554, 554, 554, 554, 554, -1, 
	-1, -1, 554, 554, 554, -1, -1, 554, 
	554, -1, 554, 554, 554, 554, 554, -1, 
	554, 554, 554, -1, -1, -1, 554, 554, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 554, 554, 554, -1, -1, 554, 
	-1, -1, -1, -1, 554, -1, 554, 554, 
	554, 554, -1, 554, 554, 554, 554, 554, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 554, -1, 554, -1, -1, 554, 
	-1, 554, 554, -1, -1, -1, 554, -1, 
	554, -1, 554, 559, 559, 559, 559, 559, 
	559, 559, -1, 559, 559, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 559, 559, 
	559, 559, 559, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 559, -1, -1, 
	-1, 559, -1, -1, -1, 559, 559, 559, 
	559, 559, 559, -1, -1, -1, -1, 559, 
	559, 559, -1, -1, -1, -1, 559, 559, 
	-1, 559, 559, 559, 559, 559, -1, -1, 
	-1, -1, -1, -1, 559, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 559, 559, 559, 559, 559, -1, 
	-1, 559, 559, -1, -1, -1, -1, -1, 
	559, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 560, 
	560, 560, 560, 560, 560, 560, 560, 560, 
	560, 560, 560, 560, 560, 560, 560, 560, 
	560, 560, 560, 560, 560, 560, 560, 560, 
	560, -1, 560, 560, 560, 560, 560, -1, 
	560, -1, 560, 560, 560, 560, -1, 560, 
	-1, 560, 560, 560, -1, 554, 560, 560, 
	560, 560, 560, 560, 560, 560, -1, 560, 
	560, 560, -1, -1, -1, -1, 560, 560, 
	560, 560, 560, -1, -1, 560, 560, 560, 
	560, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 560, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 559, 559, 
	559, 559, 559, -1, 559, 559, 559, -1, 
	-1, -1, -1, 559, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 559, 559, 
	559, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 559, -1, 559, 
	559, 559, 559, 559, -1, -1, -1, -1, 
	-1, -1, -1, 560, 560, 560, 560, -1, 
	-1, 560, 560, -1, 560, 560, 560, -1, 
	-1, -1, -1, 560, 560, 560, 559, 560, 
	560, 560, -1, -1, -1, -1, 560, -1, 
	-1, -1, -1, 560, -1, -1, -1, 560, 
	560, 560, -1, 560, 560, -1, -1, 560, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	560, 560, 560, 560, 560, 560, 560, -1, 
	-1, -1, -1, 560, 560, -1, -1, 560, 
	560, -1, -1, -1, -1, -1, -1, -1, 
	-1, 560, 560, -1, -1, -1, -1, 560, 
	-1, -1, -1, 561, 561, 561, 561, 561, 
	561, 561, 561, 561, -1, 561, 561, -1, 
	-1, 561, 561, 561, 561, -1, 560, 560, 
	560, -1, -1, -1, -1, -1, 560, 560, 
	-1, 561, 561, 561, -1, -1, -1, 561, 
	-1, -1, 560, -1, 561, -1, -1, -1, 
	-1, 560, 561, 561, -1, -1, -1, 553, 
	553, 553, -1, -1, -1, -1, 553, -1, 
	561, -1, -1, 561, 561, 561, 561, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	561, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 553, 553, 553, 553, -1, -1, 
	-1, -1, -1, 561, 561, -1, -1, -1, 
	-1, -1, -1, -1, 562, 562, 562, 562, 
	562, 562, 562, 562, 562, 562, 562, 562, 
	562, 562, 562, 562, 562, 562, 562, 562, 
	562, 562, 562, 562, 562, 562, -1, 562, 
	562, 562, 562, 562, -1, 562, -1, 562, 
	562, 562, 562, -1, 562, -1, 562, 562, 
	562, -1, -1, 562, 562, 562, 562, 562, 
	562, 562, 562, -1, 562, 562, 562, -1, 
	-1, -1, -1, 562, 562, 562, 562, 562, 
	-1, -1, 562, 562, 562, 562, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	562, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 560, -1, -1, 
	-1, 561, -1, -1, -1, -1, -1, -1, 
	561, -1, -1, -1, -1, 561, 561, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	561, -1, -1, -1, -1, 561, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 561, 561, 561, -1, 
	562, 562, 562, 562, 561, 561, 562, 562, 
	-1, 562, 562, 562, -1, -1, -1, -1, 
	562, 562, 562, -1, 562, 562, 562, -1, 
	-1, -1, -1, 562, -1, -1, -1, -1, 
	562, -1, -1, -1, 562, 562, 562, -1, 
	562, 562, -1, -1, 562, -1, -1, -1, 
	-1, -1, -1, -1, -1, 562, 562, 562, 
	562, 562, 562, 562, -1, -1, -1, -1, 
	562, 562, -1, -1, 562, 562, -1, -1, 
	-1, -1, -1, -1, -1, -1, 562, 562, 
	-1, -1, -1, -1, 562, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 562, 562, 562, -1, -1, 
	-1, -1, -1, 562, 562, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 562, 
	-1, -1, -1, -1, -1, -1, 562, 563, 
	563, 563, 563, 563, 563, 563, 563, 563, 
	563, 563, 563, 563, 563, 563, 563, 563, 
	563, 563, 563, 563, 563, 563, 563, 563, 
	563, -1, 563, 563, 563, 563, 563, -1, 
	563, -1, 563, 563, 563, 563, -1, 563, 
	-1, 563, 563, 563, -1, -1, 563, 563, 
	563, 563, 563, 563, 563, 563, -1, 563, 
	563, 563, -1, -1, -1, -1, 563, 563, 
	563, 563, 563, -1, -1, 563, 563, 563, 
	563, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 563, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 562, 563, 563, 563, 563, -1, 
	-1, 563, 563, -1, 563, 563, 563, -1, 
	-1, -1, -1, 563, 563, 563, -1, 563, 
	563, 563, -1, -1, -1, -1, 563, -1, 
	-1, -1, -1, 563, -1, -1, -1, 563, 
	563, 563, -1, 563, 563, -1, -1, 563, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	563, 563, 563, 563, 563, 563, 563, -1, 
	-1, -1, -1, 563, 563, -1, -1, 563, 
	563, -1, -1, -1, -1, -1, -1, -1, 
	-1, 563, 563, -1, -1, -1, -1, 563, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 563, 563, 
	563, -1, -1, -1, -1, -1, 563, 563, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 563, -1, -1, -1, -1, -1, 
	-1, 563, -1, -1, -1, 564, 564, 564, 
	564, 564, 564, 564, 564, 564, 564, 564, 
	564, 564, 564, 564, 564, 564, 564, 564, 
	564, 564, 564, 564, 564, 564, 564, -1, 
	564, 564, 564, 564, 564, -1, 564, -1, 
	564, 564, 564, 564, -1, 564, -1, 564, 
	564, 564, -1, 564, 564, 564, 564, 564, 
	564, 564, 564, 564, 564, 564, 564, 564, 
	-1, 564, 564, 564, 564, 564, 564, 564, 
	564, 564, 564, 564, 564, 564, 564, 564, 
	-1, 564, -1, -1, -1, -1, 564, 564, 
	564, 564, 564, -1, -1, 564, 564, 564, 
	564, 564, 564, 564, 564, 564, 564, 564, 
	564, 564, 564, 564, 564, -1, -1, -1, 
	-1, -1, 564, -1, -1, 561, -1, -1, 
	-1, -1, -1, -1, 561, -1, -1, -1, 
	-1, 561, 561, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 561, -1, -1, -1, 
	-1, 561, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	561, 561, 561, -1, -1, 563, -1, -1, 
	561, 564, 564, 564, 564, -1, -1, 564, 
	564, 564, 564, 564, 564, -1, -1, -1, 
	-1, 564, 564, 564, 564, 564, 564, 564, 
	-1, -1, -1, -1, 564, -1, -1, -1, 
	-1, 564, 564, -1, -1, 564, 564, 564, 
	-1, 564, 564, -1, -1, 564, -1, -1, 
	-1, -1, -1, -1, -1, -1, 564, 564, 
	564, 564, 564, 564, 564, -1, -1, -1, 
	564, 564, 564, -1, -1, 564, 564, -1, 
	564, 564, 564, 564, 564, -1, 564, 564, 
	564, -1, -1, -1, 564, 564, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	564, 564, 564, -1, -1, 564, -1, -1, 
	-1, -1, 564, -1, 564, 564, 564, 564, 
	-1, 564, 564, 564, 564, 564, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	564, -1, 564, -1, -1, 564, -1, 564, 
	564, -1, -1, -1, 564, -1, 564, -1, 
	564, 571, 571, 571, 571, 571, 571, 571, 
	571, 571, 571, 571, 571, 571, 571, 571, 
	571, 571, 571, 571, 571, 571, 571, 571, 
	571, 571, 571, -1, 571, 571, 571, 571, 
	571, -1, 571, -1, 571, 571, 571, 571, 
	-1, 571, -1, 571, 571, 571, -1, -1, 
	571, 571, 571, 571, 571, 571, 571, 571, 
	-1, 571, 571, 571, -1, -1, -1, -1, 
	571, 571, 571, 571, 571, -1, -1, 571, 
	571, 571, 571, -1, 572, 572, 572, 572, 
	572, 572, 572, 572, 572, 571, 572, 572, 
	-1, -1, 572, 572, 572, 572, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 572, 572, 572, -1, -1, -1, 
	572, -1, -1, -1, -1, 572, -1, -1, 
	-1, -1, -1, 572, 572, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 572, -1, -1, 572, 572, 572, 572, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 572, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 564, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 571, 571, 571, 
	571, -1, -1, 571, 571, -1, 571, 571, 
	571, -1, -1, -1, -1, 571, 571, 571, 
	-1, 571, 571, 571, -1, -1, -1, -1, 
	571, -1, -1, -1, -1, 571, -1, -1, 
	-1, 571, 571, 571, -1, 571, 571, -1, 
	-1, 571, -1, -1, -1, -1, -1, -1, 
	-1, -1, 571, 571, 571, 571, 571, 571, 
	571, -1, -1, -1, -1, 571, 571, -1, 
	-1, 571, 571, -1, -1, -1, -1, -1, 
	-1, -1, -1, 571, 571, -1, -1, -1, 
	-1, 571, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	571, 571, 571, -1, -1, -1, -1, -1, 
	571, 571, -1, -1, -1, -1, -1, -1, 
	-1, -1, 572, -1, 571, -1, -1, -1, 
	-1, 572, -1, 571, -1, -1, 572, 572, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 572, -1, -1, -1, -1, 572, -1, 
	-1, -1, -1, -1, -1, 576, 576, 576, 
	576, 576, 576, 576, -1, 576, 576, -1, 
	-1, -1, -1, -1, -1, 572, 572, 572, 
	576, 576, 576, 576, 576, 572, 572, -1, 
	-1, -1, -1, -1, -1, -1, -1, 576, 
	-1, -1, -1, 576, -1, -1, -1, 576, 
	576, 576, 576, 576, 576, -1, -1, -1, 
	-1, 576, 576, 576, -1, -1, -1, -1, 
	576, 576, 576, 576, 576, 576, 576, 576, 
	-1, -1, -1, -1, -1, -1, 576, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 576, 576, 576, 576, 
	576, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 577, 
	577, 577, 577, 577, 577, 577, 577, 577, 
	577, 577, 577, 577, 577, 577, 577, 577, 
	577, 577, 577, 577, 577, 577, 577, 577, 
	577, -1, 577, 577, 577, 577, 577, 571, 
	577, -1, 577, 577, 577, 577, -1, 577, 
	-1, 577, 577, 577, -1, -1, 577, 577, 
	577, 577, 577, 577, 577, 577, -1, 577, 
	577, 577, -1, -1, -1, -1, 577, 577, 
	577, 577, 577, -1, -1, 577, 577, 577, 
	577, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 577, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	576, 576, 576, 576, 576, -1, 576, 576, 
	576, -1, -1, -1, -1, 576, 576, -1, 
	-1, -1, 576, 576, -1, -1, -1, -1, 
	576, 576, 576, -1, -1, -1, -1, -1, 
	-1, -1, 576, -1, -1, -1, -1, -1, 
	-1, 576, 576, 576, 576, 576, -1, -1, 
	-1, -1, -1, 577, 577, 577, 577, -1, 
	-1, 577, 577, -1, 577, 577, 577, -1, 
	-1, -1, 576, 577, 577, 577, 576, 577, 
	577, 577, -1, -1, -1, -1, 577, -1, 
	-1, -1, -1, 577, -1, -1, -1, 577, 
	577, 577, -1, 577, 577, -1, -1, 577, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	577, 577, 577, 577, 577, 577, 577, -1, 
	-1, -1, -1, 577, 577, -1, -1, 577, 
	577, -1, -1, -1, -1, -1, -1, -1, 
	-1, 577, 577, -1, -1, -1, -1, 577, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 577, 577, 
	577, -1, -1, -1, -1, -1, 577, 577, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 577, -1, -1, -1, -1, -1, 
	-1, 577, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	578, 578, 578, 578, 578, 578, 578, 578, 
	578, 578, 578, 578, 578, 578, 578, 578, 
	578, 578, 578, 578, 578, 578, 578, 578, 
	578, 578, -1, 578, 578, 578, 578, 578, 
	-1, 578, -1, 578, 578, 578, 578, -1, 
	578, -1, 578, 578, 578, -1, -1, 578, 
	578, 578, 578, 578, 578, 578, 578, -1, 
	578, 578, 578, -1, -1, -1, -1, 578, 
	578, 578, 578, 578, -1, -1, 578, 578, 
	578, 578, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 578, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 572, -1, 
	-1, -1, -1, -1, -1, 572, -1, -1, 
	-1, -1, 572, 572, -1, 577, -1, -1, 
	-1, -1, -1, -1, -1, 572, -1, -1, 
	-1, -1, 572, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 572, 572, 572, 578, 578, 578, 578, 
	-1, 572, 578, 578, -1, 578, 578, 578, 
	-1, -1, -1, -1, 578, 578, 578, -1, 
	578, 578, 578, -1, -1, -1, -1, 578, 
	-1, -1, -1, -1, 578, -1, -1, -1, 
	578, 578, 578, -1, 578, 578, -1, -1, 
	578, -1, -1, -1, -1, -1, -1, -1, 
	-1, 578, 578, 578, 578, 578, 578, 578, 
	-1, -1, -1, -1, 578, 578, -1, -1, 
	578, 578, -1, -1, -1, -1, -1, -1, 
	-1, -1, 578, 578, -1, -1, -1, -1, 
	578, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 578, 
	578, 578, -1, -1, -1, -1, -1, 578, 
	578, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 578, -1, -1, -1, -1, 
	-1, -1, 578, 579, 579, 579, 579, 579, 
	579, 579, 579, 579, 579, 579, 579, 579, 
	579, 579, -1, 579, 579, 579, 579, 579, 
	579, 579, 579, -1, -1, -1, 579, 579, 
	579, 579, 579, -1, 579, -1, 579, 579, 
	579, 579, -1, 579, -1, 579, 579, 579, 
	-1, -1, 579, -1, -1, 579, 579, 579, 
	579, 579, -1, 579, 579, 579, 579, -1, 
	-1, -1, 579, 579, 579, 579, 579, -1, 
	579, 579, 579, 579, 579, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 579, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 576, -1, -1, -1, -1, 576, 
	-1, -1, -1, -1, -1, 576, 576, -1, 
	-1, -1, -1, -1, -1, -1, 576, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 576, -1, 
	-1, -1, 576, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 578, 579, 
	579, 579, 579, -1, -1, 579, 579, 579, 
	579, 579, 579, -1, -1, -1, -1, 579, 
	579, 579, 579, 579, 579, 579, -1, 579, 
	579, -1, 579, -1, -1, -1, -1, 579, 
	579, -1, -1, 579, 579, 579, -1, 579, 
	579, 579, -1, 579, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 579, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 579, 579, -1, -1, -1, 
	-1, -1, -1, -1, -1, 579, 579, -1, 
	-1, -1, -1, 579, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 579, 579, 579, -1, -1, -1, 
	-1, -1, 579, 579, 580, 580, 580, 580, 
	580, 580, 580, -1, 580, 580, 579, -1, 
	579, -1, -1, 579, -1, -1, -1, 580, 
	580, 580, 580, 580, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 580, -1, 
	-1, -1, 580, -1, -1, -1, 580, 580, 
	580, 580, 580, 580, -1, -1, -1, -1, 
	580, 580, 580, -1, -1, -1, -1, 580, 
	580, -1, 580, 580, 580, 580, 580, -1, 
	-1, -1, -1, -1, -1, 580, 581, 581, 
	581, 581, 581, 581, 581, -1, 581, 581, 
	-1, -1, -1, 580, 580, 580, 580, 580, 
	-1, 581, 581, 581, 581, 581, -1, -1, 
	-1, 580, -1, -1, -1, -1, -1, -1, 
	581, -1, -1, -1, 581, -1, -1, -1, 
	581, 581, 581, 581, 581, 581, -1, -1, 
	-1, -1, 581, 581, 581, -1, -1, -1, 
	-1, 581, 581, -1, 581, 581, 581, 581, 
	581, -1, -1, -1, -1, -1, -1, 581, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 581, 581, 581, 
	581, 581, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 581, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 579, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 580, 
	580, 580, 580, 580, -1, 580, 580, 580, 
	-1, -1, -1, -1, 580, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 580, 
	580, 580, -1, -1, -1, -1, -1, -1, 
	-1, 580, -1, -1, -1, -1, -1, -1, 
	580, 580, 580, 580, 580, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 580, -1, -1, 
	-1, 581, 581, 581, 581, 581, -1, 581, 
	581, 581, -1, -1, -1, -1, 581, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 581, 581, 581, -1, -1, -1, -1, 
	-1, -1, -1, 581, -1, -1, -1, -1, 
	-1, -1, 581, 581, 581, 581, 581, 582, 
	582, 582, 582, 582, 582, 582, -1, 582, 
	582, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 582, 582, 582, 582, 582, 581, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 582, -1, -1, -1, 582, -1, -1, 
	-1, 582, 582, 582, 582, 582, 582, -1, 
	-1, -1, -1, 582, 582, 582, -1, -1, 
	-1, -1, 582, 582, -1, 582, 582, 582, 
	582, 582, -1, -1, -1, -1, -1, -1, 
	582, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 582, 582, 
	582, 582, 582, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 582, -1, -1, -1, 
	-1, -1, -1, -1, 606, 606, 606, 606, 
	606, 606, 606, 606, 606, 606, 606, 606, 
	606, 606, 606, 606, 606, 606, 606, 606, 
	606, 606, 606, 606, 606, 606, -1, 606, 
	606, 606, 606, 606, -1, 606, -1, 606, 
	606, 606, 606, -1, 606, -1, 606, 606, 
	606, -1, -1, 606, 606, 606, 606, 606, 
	606, 606, 606, -1, 606, 606, 606, -1, 
	-1, -1, -1, 606, 606, 606, 606, 606, 
	-1, -1, 606, 606, 606, 606, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	606, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 582, 582, 582, 582, 582, -1, 
	582, 582, 582, -1, -1, -1, -1, 582, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 582, 582, 582, -1, -1, -1, 
	-1, -1, -1, -1, 582, -1, -1, -1, 
	-1, -1, -1, 582, 582, 582, 582, 582, 
	606, 606, 606, 606, -1, -1, 606, 606, 
	-1, 606, 606, 606, -1, -1, -1, -1, 
	606, 606, 606, -1, 606, 606, 606, -1, 
	582, -1, -1, 606, -1, -1, -1, -1, 
	606, -1, -1, -1, 606, 606, 606, -1, 
	606, 606, -1, -1, 606, -1, -1, -1, 
	-1, -1, -1, -1, -1, 606, 606, 606, 
	606, 606, 606, 606, -1, -1, -1, -1, 
	606, 606, -1, -1, 606, 606, -1, -1, 
	-1, -1, -1, -1, -1, -1, 606, 606, 
	-1, -1, -1, -1, 606, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 606, 606, 606, -1, -1, 
	-1, -1, -1, 606, 606, 612, 612, 612, 
	612, 612, 612, 612, -1, 612, 612, 606, 
	-1, -1, -1, -1, -1, -1, 606, -1, 
	612, 612, 612, 612, 612, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 612, 
	-1, -1, -1, 612, -1, -1, -1, 612, 
	612, 612, 612, 612, 612, -1, -1, -1, 
	-1, 612, 612, 612, -1, -1, -1, -1, 
	612, 612, 612, 612, 612, 612, 612, -1, 
	-1, -1, -1, -1, -1, -1, 612, 616, 
	616, 616, 616, 616, 616, 616, -1, 616, 
	616, -1, -1, -1, 612, 612, 612, 612, 
	612, -1, 616, 616, 616, 616, 616, -1, 
	-1, -1, 612, -1, -1, -1, -1, -1, 
	-1, 616, -1, -1, -1, 616, -1, -1, 
	-1, 616, 616, 616, 616, 616, 616, -1, 
	-1, -1, -1, 616, 616, 616, -1, -1, 
	-1, -1, 616, 616, 616, 616, 616, 616, 
	616, 616, -1, -1, -1, -1, -1, -1, 
	616, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 616, 616, 
	616, 616, 616, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 616, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 606, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	612, 612, 612, 612, 612, -1, 612, 612, 
	612, -1, -1, -1, -1, 612, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	612, 612, 612, -1, -1, 612, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 612, 612, 612, 612, 612, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 612, -1, -1, -1, 
	-1, -1, 616, 616, 616, 616, 616, -1, 
	616, 616, 616, -1, -1, -1, -1, 616, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 616, 616, 616, -1, -1, 616, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 616, 616, 616, 616, 616, 
	629, 629, 629, 629, 629, 629, 629, 629, 
	629, -1, 629, 629, -1, -1, 629, 629, 
	629, 629, -1, -1, -1, -1, 616, -1, 
	-1, -1, -1, -1, -1, -1, 629, 629, 
	629, -1, -1, -1, 629, -1, -1, -1, 
	-1, 629, -1, -1, -1, -1, -1, 629, 
	629, 632, 632, 632, 632, 632, 632, 632, 
	-1, 632, 632, -1, -1, 629, -1, -1, 
	629, 629, 629, 629, 632, 632, 632, 632, 
	632, -1, -1, -1, -1, 629, -1, -1, 
	-1, -1, -1, 632, -1, -1, -1, 632, 
	-1, -1, -1, 632, 632, 632, 632, 632, 
	632, -1, -1, -1, -1, 632, 632, 632, 
	-1, -1, -1, -1, 632, 632, -1, 632, 
	632, 632, 632, -1, -1, -1, -1, -1, 
	-1, -1, 632, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	632, 632, 632, -1, 632, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 629, -1, 
	-1, -1, -1, -1, -1, 629, -1, -1, 
	-1, -1, 629, 629, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 629, -1, -1, 
	-1, -1, 629, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 629, 629, 629, -1, -1, -1, -1, 
	-1, 629, 629, -1, 632, 632, 632, 632, 
	632, -1, 632, 632, 632, -1, -1, -1, 
	-1, 632, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 632, 632, 632, 
	632, 632, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 635, 635, 635, 
	635, 635, 635, 635, 635, 635, 635, 635, 
	635, 635, 635, 635, 635, 635, 635, 635, 
	635, 635, 635, 635, 635, 635, 635, -1, 
	635, 635, 635, 635, 635, -1, 635, -1, 
	635, 635, 635, 635, -1, 635, -1, 635, 
	635, 635, -1, 635, 635, 635, 635, 635, 
	635, 635, 635, 635, 635, 635, 635, 635, 
	-1, 635, 635, 635, 635, 635, 635, 635, 
	635, 635, 635, 635, 635, 635, 635, 635, 
	-1, 635, -1, -1, -1, -1, 635, 635, 
	635, 635, 635, -1, -1, 635, 635, 635, 
	635, 635, 635, 635, 635, 635, 635, 635, 
	635, 635, 635, 635, 635, -1, -1, -1, 
	-1, -1, 635, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 612, 612, -1, 
	-1, 612, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 635, 635, 635, 635, -1, -1, 635, 
	635, 635, 635, 635, 635, -1, -1, -1, 
	612, 635, 635, 635, 635, 635, 635, 635, 
	-1, -1, -1, -1, 635, -1, -1, -1, 
	-1, 635, 635, -1, -1, 635, 635, 635, 
	-1, 635, 635, -1, -1, 635, -1, 616, 
	616, -1, -1, 616, -1, -1, 635, 635, 
	635, 635, 635, 635, 635, -1, -1, -1, 
	635, 635, 635, -1, -1, 635, 635, -1, 
	635, 635, 635, 635, 635, -1, 635, 635, 
	635, -1, -1, -1, 635, 635, -1, -1, 
	-1, -1, 616, -1, -1, -1, -1, -1, 
	635, 635, 635, -1, -1, 635, -1, -1, 
	-1, -1, 635, -1, 635, 635, 635, 635, 
	-1, 635, 635, 635, 635, 635, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	635, -1, 635, -1, -1, 635, -1, 635, 
	635, -1, -1, -1, 635, -1, 635, -1, 
	635, -1, -1, -1, -1, 636, 636, 636, 
	636, 636, 636, 636, -1, 636, 636, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	636, 636, 636, 636, 636, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 636, 
	-1, -1, -1, 636, -1, -1, -1, 636, 
	636, 636, 636, 636, 636, -1, -1, -1, 
	-1, 636, 636, 636, -1, -1, -1, -1, 
	636, 636, -1, 636, 636, 636, 636, 636, 
	-1, -1, -1, -1, -1, -1, 636, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 636, 636, 636, 636, 
	636, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 636, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 629, -1, -1, -1, -1, -1, 
	-1, 629, -1, -1, -1, -1, 629, 629, 
	-1, -1, -1, 635, -1, -1, -1, -1, 
	-1, 629, -1, -1, -1, -1, 629, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 629, 629, 629, 
	-1, -1, -1, -1, -1, 629, -1, -1, 
	632, 632, 632, 632, 632, -1, 632, 632, 
	632, -1, -1, -1, -1, 632, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	636, 636, 636, 636, 636, -1, 636, 636, 
	636, 632, 632, 632, 632, 636, 637, 637, 
	637, 637, 637, 637, 637, -1, 637, 637, 
	636, 636, 636, -1, -1, -1, -1, -1, 
	-1, 637, 637, 637, 637, 637, -1, 636, 
	-1, 636, 636, 636, 636, 636, -1, -1, 
	637, -1, -1, -1, 637, -1, -1, -1, 
	637, 637, 637, 637, 637, 637, -1, -1, 
	-1, -1, 637, 637, 637, -1, -1, -1, 
	636, 637, 637, -1, 637, 637, 637, 637, 
	637, -1, -1, -1, -1, -1, -1, 637, 
	638, 638, 638, 638, 638, 638, 638, -1, 
	638, 638, -1, -1, -1, 637, 637, 637, 
	637, 637, -1, 638, 638, 638, 638, 638, 
	-1, -1, -1, 637, -1, -1, -1, -1, 
	-1, -1, 638, -1, -1, -1, 638, -1, 
	-1, -1, 638, 638, 638, 638, 638, 638, 
	-1, -1, -1, -1, 638, 638, 638, -1, 
	-1, -1, -1, 638, 638, -1, 638, 638, 
	638, 638, 638, -1, -1, -1, -1, -1, 
	-1, 638, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 638, 
	638, 638, 638, 638, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 638, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 637, 637, 637, 637, 637, -1, 637, 
	637, 637, -1, -1, -1, -1, 637, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 637, 637, 637, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	637, -1, 637, 637, 637, 637, 637, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 637, -1, 638, 638, 638, 638, 638, 
	-1, 638, 638, 638, -1, -1, -1, -1, 
	638, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 638, 638, 638, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 638, -1, 638, 638, 638, 638, 
	638, 639, 639, 639, 639, 639, 639, 639, 
	639, 639, 639, 639, 639, 639, 639, 639, 
	639, 639, 639, 639, 639, 639, 639, 639, 
	639, 639, 639, 638, 639, 639, 639, 639, 
	639, -1, 639, -1, 639, 639, 639, 639, 
	-1, 639, -1, 639, 639, 639, -1, -1, 
	639, 639, 639, 639, 639, 639, 639, 639, 
	-1, 639, 639, 639, -1, -1, -1, -1, 
	639, 639, 639, 639, 639, -1, -1, 639, 
	639, 639, 639, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 639, 643, 643, 
	643, 643, 643, 643, 643, 643, 643, 643, 
	643, 643, -1, -1, 643, 643, 643, 643, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 643, 643, 643, -1, 
	-1, -1, 643, -1, -1, -1, -1, 643, 
	-1, -1, -1, -1, -1, 643, 643, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 643, -1, -1, 643, 643, 
	643, 643, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 643, -1, -1, -1, 
	-1, -1, -1, -1, -1, 639, 639, 639, 
	639, -1, -1, 639, 639, -1, 639, 639, 
	639, -1, -1, -1, -1, 639, 639, 639, 
	-1, 639, 639, 639, -1, -1, -1, -1, 
	639, -1, -1, -1, -1, 639, -1, -1, 
	-1, 639, 639, 639, -1, 639, 639, -1, 
	-1, 639, -1, -1, -1, -1, -1, -1, 
	-1, -1, 639, 639, 639, 639, 639, 639, 
	639, -1, -1, -1, -1, 639, 639, -1, 
	-1, 639, 639, -1, -1, -1, -1, -1, 
	-1, -1, -1, 639, 639, -1, -1, -1, 
	-1, 639, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	639, 639, 639, -1, -1, -1, -1, -1, 
	639, 639, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 639, -1, -1, -1, 
	-1, -1, -1, 639, 643, -1, -1, -1, 
	-1, -1, -1, -1, 643, 643, 643, -1, 
	643, 643, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 643, -1, -1, -1, -1, 
	643, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 643, 
	643, 643, -1, -1, -1, -1, -1, 643, 
	643, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 643, -1, -1, -1, -1, -1, 
	645, 645, 645, 645, 645, 645, 645, 645, 
	645, 645, 645, 645, 645, 645, 645, 645, 
	645, 645, 645, 645, 645, 645, 645, 645, 
	645, 645, -1, 645, 645, 645, 645, 645, 
	-1, 645, -1, 645, 645, 645, 645, -1, 
	645, -1, 645, 645, 645, -1, 645, 645, 
	645, 645, 645, 645, 645, 645, 645, 645, 
	645, 645, 645, -1, 645, 645, 645, 645, 
	645, 645, 645, 645, 645, 645, 645, 645, 
	645, 645, 645, -1, 645, -1, -1, -1, 
	-1, 645, 645, 645, 645, 645, -1, 639, 
	645, 645, 645, 645, 645, 645, 645, 645, 
	645, 645, 645, 645, 645, 645, 645, 645, 
	-1, -1, -1, -1, -1, 645, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 645, 645, 645, 645, 
	-1, -1, 645, 645, 645, 645, 645, 645, 
	-1, -1, -1, -1, 645, 645, 645, 645, 
	645, 645, 645, -1, -1, -1, -1, 645, 
	-1, -1, -1, -1, 645, 645, -1, -1, 
	645, 645, 645, -1, 645, 645, -1, -1, 
	645, -1, -1, -1, -1, -1, -1, -1, 
	-1, 645, 645, 645, 645, 645, 645, 645, 
	-1, -1, -1, 645, 645, 645, -1, -1, 
	645, 645, -1, 645, 645, 645, 645, 645, 
	-1, 645, 645, 645, -1, -1, -1, 645, 
	645, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 645, 645, 645, -1, -1, 
	645, -1, -1, -1, -1, 645, -1, 645, 
	645, 645, 645, -1, 645, 645, 645, 645, 
	645, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 645, -1, 645, -1, -1, 
	645, -1, 645, 645, -1, -1, -1, 645, 
	-1, 645, -1, 645, -1, -1, -1, -1, 
	-1, -1, -1, 648, 648, 648, 648, 648, 
	648, 648, -1, 648, 648, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 648, 648, 
	648, 648, 648, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 648, -1, -1, 
	-1, 648, -1, -1, -1, 648, 648, 648, 
	648, 648, 648, -1, -1, -1, -1, 648, 
	648, 648, -1, -1, -1, -1, 648, 648, 
	648, 648, 648, 648, 648, -1, -1, -1, 
	-1, -1, -1, -1, 648, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 648, 648, 648, 648, 648, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	648, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 651, 651, 651, 
	651, 651, 651, 651, 651, 651, 651, 651, 
	651, 651, 651, 651, 651, 651, 651, 651, 
	651, 651, 651, 651, 651, 651, 651, -1, 
	651, 651, 651, 651, 651, -1, 651, -1, 
	651, 651, 651, 651, -1, 651, 645, 651, 
	651, 651, -1, -1, 651, 651, 651, 651, 
	651, 651, 651, 651, -1, 651, 651, 651, 
	-1, -1, -1, -1, 651, 651, 651, 651, 
	651, -1, -1, 651, 651, 651, 651, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 651, -1, -1, -1, -1, -1, -1, 
	643, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 643, -1, 643, 643, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 643, 
	-1, -1, -1, -1, 643, -1, 648, 648, 
	648, 648, 648, -1, 648, 648, 648, -1, 
	-1, -1, -1, 648, 648, -1, -1, -1, 
	648, 648, -1, 643, 643, 643, 648, 648, 
	648, -1, -1, 643, -1, -1, -1, -1, 
	648, -1, -1, -1, -1, -1, -1, 648, 
	648, 648, 648, 648, -1, -1, 643, -1, 
	-1, 651, 651, 651, 651, -1, -1, 651, 
	651, -1, 651, 651, 651, -1, -1, -1, 
	648, 651, 651, 651, 648, 651, 651, 651, 
	-1, -1, -1, -1, 651, -1, -1, -1, 
	-1, 651, -1, -1, -1, 651, 651, 651, 
	-1, 651, 651, -1, -1, 651, -1, -1, 
	-1, -1, -1, -1, -1, -1, 651, 651, 
	651, 651, 651, 651, 651, -1, -1, -1, 
	-1, 651, 651, -1, -1, 651, 651, -1, 
	-1, -1, -1, -1, -1, -1, -1, 651, 
	651, -1, -1, -1, -1, 651, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 651, 651, 651, -1, 
	-1, -1, -1, -1, 651, 651, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	651, -1, -1, -1, -1, -1, -1, 651, 
	654, 654, 654, 654, 654, 654, 654, 654, 
	654, 654, 654, 654, 654, 654, 654, -1, 
	654, 654, 654, 654, 654, 654, 654, 654, 
	-1, -1, -1, 654, 654, 654, 654, 654, 
	-1, 654, -1, 654, 654, 654, 654, -1, 
	654, 654, 654, 654, 654, -1, -1, 654, 
	-1, -1, 654, 654, 654, 654, 654, -1, 
	654, 654, 654, -1, -1, -1, -1, 654, 
	654, 654, 654, 654, -1, -1, 654, 654, 
	654, 654, -1, 654, -1, 654, -1, -1, 
	-1, -1, -1, 654, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 651, 654, 654, 654, 654, 
	-1, -1, 654, 654, 654, 654, 654, 654, 
	-1, -1, -1, -1, 654, 654, 654, 654, 
	654, 654, 654, -1, -1, -1, -1, 654, 
	-1, -1, -1, -1, 654, 654, -1, -1, 
	654, 654, 654, -1, 654, 654, -1, -1, 
	654, -1, -1, -1, 654, 654, -1, 654, 
	-1, -1, -1, -1, 654, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	654, 654, -1, -1, -1, -1, -1, -1, 
	-1, -1, 654, 654, -1, -1, -1, -1, 
	654, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 654, 
	654, 654, -1, -1, -1, -1, -1, 654, 
	654, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 654, -1, 654, -1, -1, 
	654, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 657, 657, 657, 
	657, 657, 657, 657, 657, 657, 657, 657, 
	657, 657, 657, 657, -1, 657, 657, 657, 
	657, 657, 657, 657, 657, -1, -1, -1, 
	657, 657, 657, 657, 657, -1, 657, -1, 
	657, 657, 657, 657, -1, 657, -1, 657, 
	657, 657, -1, -1, 657, -1, -1, 657, 
	657, 657, 657, 657, -1, 657, 657, 657, 
	-1, -1, -1, -1, 657, 657, 657, 657, 
	657, -1, -1, 657, 657, 657, 657, -1, 
	657, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	648, -1, -1, -1, -1, 648, -1, -1, 
	-1, -1, -1, 648, 648, -1, -1, -1, 
	-1, -1, -1, -1, 648, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 654, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 648, -1, -1, -1, 
	648, 657, 657, 657, 657, -1, -1, 657, 
	657, 657, 657, 657, 657, -1, -1, -1, 
	-1, 657, 657, 657, 657, 657, 657, 657, 
	-1, -1, -1, -1, 657, -1, -1, -1, 
	-1, 657, 657, -1, -1, 657, 657, 657, 
	-1, 657, 657, -1, -1, 657, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 657, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 657, 657, -1, 
	-1, -1, -1, -1, -1, -1, -1, 657, 
	657, -1, -1, -1, -1, 657, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 657, 657, 657, -1, 
	-1, -1, -1, -1, 657, 657, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	657, -1, 657, -1, -1, 657, -1, -1, 
	658, 658, 658, 658, 658, 658, 658, 658, 
	658, 658, 658, 658, 658, 658, 658, -1, 
	658, 658, 658, 658, 658, 658, 658, 658, 
	-1, -1, -1, 658, 658, 658, 658, 658, 
	-1, 658, -1, 658, 658, 658, 658, -1, 
	658, -1, 658, 658, 658, -1, -1, 658, 
	-1, -1, 658, 658, 658, 658, 658, -1, 
	658, 658, 658, -1, -1, -1, -1, 658, 
	658, 658, 658, 658, -1, -1, 658, 658, 
	658, 658, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 658, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 658, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 657, 658, 658, 658, 658, 
	-1, -1, 658, 658, 658, 658, 658, 658, 
	-1, -1, -1, -1, 658, 658, 658, 658, 
	658, 658, 658, -1, -1, -1, 658, 658, 
	-1, 654, -1, -1, 658, 658, -1, -1, 
	658, 658, 658, -1, 658, 658, 658, -1, 
	658, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 658, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	658, 658, -1, -1, -1, -1, -1, -1, 
	-1, -1, 658, 658, -1, -1, -1, -1, 
	658, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 658, 
	658, 658, -1, -1, -1, -1, -1, 658, 
	658, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 658, -1, 658, -1, -1, 
	658, -1, -1, 665, 665, 665, 665, 665, 
	665, 665, 665, 665, 665, 665, 665, 665, 
	665, 665, 665, 665, 665, 665, 665, 665, 
	665, 665, 665, 665, 665, -1, 665, 665, 
	665, 665, 665, -1, 665, -1, 665, 665, 
	665, 665, -1, 665, -1, 665, 665, 665, 
	-1, 665, 665, 665, 665, 665, 665, 665, 
	665, 665, 665, 665, 665, 665, -1, 665, 
	665, 665, 665, 665, 665, 665, 665, 665, 
	665, 665, 665, 665, 665, 665, -1, 665, 
	-1, -1, -1, -1, 665, 665, 665, 665, 
	665, -1, -1, 665, 665, 665, 665, 665, 
	665, 665, 665, 665, 665, 665, 665, 665, 
	665, 665, 665, -1, -1, -1, -1, -1, 
	665, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 658, 665, 
	665, 665, 665, -1, -1, 665, 665, 665, 
	665, 665, 665, -1, -1, -1, -1, 665, 
	665, 665, 665, 665, 665, 665, -1, -1, 
	-1, -1, 665, -1, -1, -1, -1, 665, 
	665, -1, -1, 665, 665, 665, -1, 665, 
	665, -1, -1, 665, -1, -1, -1, -1, 
	-1, -1, -1, -1, 665, 665, 665, 665, 
	665, 665, 665, -1, -1, -1, 665, 665, 
	665, -1, -1, 665, 665, -1, 665, 665, 
	665, 665, 665, -1, 665, 665, 665, -1, 
	-1, -1, 665, 665, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 665, 665, 
	665, -1, -1, 665, -1, -1, -1, -1, 
	665, -1, 665, 665, 665, 665, -1, 665, 
	665, 665, 665, 665, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 665, -1, 
	665, -1, -1, 665, -1, 665, 665, -1, 
	-1, -1, 665, -1, 665, -1, 665, 666, 
	666, 666, 666, 666, 666, 666, 666, 666, 
	666, 666, 666, 666, 666, 666, 666, 666, 
	666, 666, 666, 666, 666, 666, 666, 666, 
	666, -1, 666, 666, 666, 666, 666, -1, 
	666, -1, 666, 666, 666, 666, -1, 666, 
	-1, 666, 666, 666, -1, 666, 666, 666, 
	666, 666, 666, 666, 666, 666, 666, 666, 
	666, 666, -1, 666, 666, 666, 666, 666, 
	666, 666, 666, 666, 666, 666, 666, 666, 
	666, 666, -1, 666, -1, -1, -1, -1, 
	666, 666, 666, 666, 666, -1, -1, 666, 
	666, 666, 666, 666, 666, 666, 666, 666, 
	666, 666, 666, 666, 666, 666, 666, -1, 
	-1, -1, -1, -1, 666, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 665, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 666, 666, 666, 666, -1, 
	-1, 666, 666, 666, 666, 666, 666, -1, 
	-1, -1, 658, 666, 666, 666, 666, 666, 
	666, 666, -1, -1, -1, -1, 666, -1, 
	-1, -1, -1, 666, 666, -1, -1, 666, 
	666, 666, -1, 666, 666, -1, -1, 666, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	666, 666, 666, 666, 666, 666, 666, -1, 
	-1, -1, 666, 666, 666, -1, -1, 666, 
	666, -1, 666, 666, 666, 666, 666, -1, 
	666, 666, 666, -1, -1, -1, 666, 666, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 666, 666, 666, -1, -1, 666, 
	-1, -1, -1, -1, 666, -1, 666, 666, 
	666, 666, -1, 666, 666, 666, 666, 666, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 666, -1, 666, -1, -1, 666, 
	-1, 666, 666, -1, -1, -1, 666, -1, 
	666, -1, 666, 667, 667, 667, 667, 667, 
	667, 667, 667, 667, 667, 667, 667, 667, 
	667, 667, 667, 667, 667, 667, 667, 667, 
	667, 667, 667, 667, 667, -1, 667, 667, 
	667, 667, 667, -1, 667, -1, 667, 667, 
	667, 667, -1, 667, -1, 667, 667, 667, 
	-1, 667, 667, 667, 667, 667, 667, 667, 
	667, 667, 667, 667, 667, 667, -1, 667, 
	667, 667, 667, 667, 667, 667, 667, 667, 
	667, 667, 667, 667, 667, 667, -1, 667, 
	-1, -1, -1, -1, 667, 667, 667, 667, 
	667, -1, -1, 667, 667, 667, 667, 667, 
	667, 667, 667, 667, 667, 667, 667, 667, 
	667, 667, 667, -1, -1, -1, -1, -1, 
	667, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 666, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 667, 
	667, 667, 667, -1, -1, 667, 667, 667, 
	667, 667, 667, -1, -1, -1, -1, 667, 
	667, 667, 667, 667, 667, 667, -1, -1, 
	-1, -1, 667, -1, -1, -1, -1, 667, 
	667, -1, -1, 667, 667, 667, -1, 667, 
	667, -1, -1, 667, -1, -1, -1, -1, 
	-1, -1, -1, -1, 667, 667, 667, 667, 
	667, 667, 667, -1, -1, -1, 667, 667, 
	667, -1, -1, 667, 667, -1, 667, 667, 
	667, 667, 667, -1, 667, 667, 667, -1, 
	-1, -1, 667, 667, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 667, 667, 
	667, -1, -1, 667, -1, -1, -1, -1, 
	667, -1, 667, 667, 667, 667, -1, 667, 
	667, 667, 667, 667, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 667, -1, 
	667, -1, -1, 667, -1, 667, 667, -1, 
	-1, -1, 667, -1, 667, -1, 667, 672, 
	672, 672, 672, 672, 672, 672, -1, 672, 
	672, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 672, 672, 672, 672, 672, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 672, -1, -1, -1, 672, -1, -1, 
	-1, 672, 672, 672, 672, 672, 672, -1, 
	-1, -1, -1, 672, 672, 672, -1, -1, 
	-1, -1, 672, 672, -1, 672, 672, 672, 
	672, -1, -1, -1, -1, -1, -1, -1, 
	672, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 672, 672, 
	672, -1, 672, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 674, 674, 674, 674, 
	674, 674, 674, 674, 674, 674, 674, 674, 
	674, 674, 674, 674, 674, 674, 674, 674, 
	674, 674, 674, 674, 674, 674, -1, 674, 
	674, 674, 674, 674, -1, 674, -1, 674, 
	674, 674, 674, -1, 674, -1, 674, 674, 
	674, 667, 674, 674, 674, 674, 674, 674, 
	674, 674, 674, 674, 674, 674, 674, -1, 
	674, 674, 674, 674, 674, 674, 674, 674, 
	674, 674, 674, 674, 674, 674, 674, -1, 
	674, -1, -1, -1, -1, 674, 674, 674, 
	674, 674, -1, -1, 674, 674, 674, 674, 
	674, 674, 674, 674, 674, 674, 674, 674, 
	674, 674, 674, 674, -1, -1, -1, -1, 
	-1, 674, -1, -1, -1, -1, -1, -1, 
	-1, -1, 672, 672, 672, 672, 672, -1, 
	672, 672, 672, -1, -1, -1, -1, 672, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 672, 672, 672, 672, 672, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	674, 674, 674, 674, -1, -1, 674, 674, 
	674, 674, 674, 674, -1, -1, -1, -1, 
	674, 674, 674, 674, 674, 674, 674, -1, 
	-1, -1, -1, 674, -1, -1, -1, -1, 
	674, 674, -1, -1, 674, 674, 674, -1, 
	674, 674, -1, -1, 674, -1, -1, -1, 
	-1, -1, -1, -1, -1, 674, 674, 674, 
	674, 674, 674, 674, -1, -1, -1, 674, 
	674, 674, -1, -1, 674, 674, -1, 674, 
	674, 674, 674, 674, -1, 674, 674, 674, 
	-1, -1, -1, 674, 674, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 674, 
	674, 674, -1, -1, 674, -1, -1, -1, 
	-1, 674, -1, 674, 674, 674, 674, -1, 
	674, 674, 674, 674, 674, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 674, 
	-1, 674, -1, -1, 674, -1, 674, 674, 
	-1, -1, -1, 674, -1, 674, -1, 674, 
	679, 679, 679, 679, 679, 679, 679, 679, 
	679, 679, 679, 679, 679, 679, 679, 679, 
	679, 679, 679, 679, 679, 679, 679, 679, 
	679, 679, -1, 679, 679, 679, 679, 679, 
	-1, 679, -1, 679, 679, 679, 679, -1, 
	679, -1, 679, 679, 679, -1, -1, 679, 
	679, 679, 679, 679, 679, 679, 679, -1, 
	679, 679, 679, -1, -1, -1, -1, 679, 
	679, 679, 679, 679, -1, -1, 679, 679, 
	679, 679, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 679, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 674, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 679, 679, 679, 679, 
	-1, -1, 679, 679, -1, 679, 679, 679, 
	-1, -1, -1, -1, 679, 679, 679, -1, 
	679, 679, 679, -1, -1, -1, -1, 679, 
	-1, -1, -1, -1, 679, -1, -1, -1, 
	679, 679, 679, -1, 679, 679, -1, -1, 
	679, -1, -1, -1, -1, -1, -1, -1, 
	-1, 679, 679, 679, 679, 679, 679, 679, 
	-1, -1, -1, -1, 679, 679, -1, -1, 
	679, 679, -1, -1, -1, -1, -1, -1, 
	-1, -1, 679, 679, -1, -1, -1, -1, 
	679, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 679, 
	679, 679, -1, -1, -1, -1, -1, 679, 
	679, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 679, -1, -1, -1, -1, 
	-1, -1, 679, 683, 683, 683, 683, 683, 
	683, 683, 683, 683, 683, 683, 683, 683, 
	683, 683, 683, 683, 683, 683, 683, 683, 
	683, 683, 683, 683, 683, 683, 683, 683, 
	683, 683, 683, -1, 683, -1, 683, 683, 
	683, 683, 683, 683, -1, 683, 683, 683, 
	-1, -1, 683, 683, 683, 683, 683, 683, 
	683, 683, -1, 683, 683, 683, 683, -1, 
	-1, -1, 683, 683, 683, 683, 683, -1, 
	-1, 683, 683, 683, 683, -1, -1, -1, 
	683, -1, -1, -1, 683, 683, -1, 683, 
	-1, -1, 683, -1, -1, 683, -1, 683, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 672, 672, 
	672, 672, 672, -1, 672, 672, 672, -1, 
	-1, -1, -1, 672, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 683, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 683, -1, -1, -1, 672, 
	672, 672, 672, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 679, 683, 
	683, 683, 683, -1, -1, 683, 683, 683, 
	683, 683, 683, -1, -1, -1, -1, 683, 
	683, 683, 683, 683, 683, 683, -1, -1, 
	683, -1, 683, -1, -1, -1, -1, 683, 
	683, -1, 683, 683, 683, 683, -1, 683, 
	683, -1, -1, 683, -1, -1, -1, -1, 
	-1, 683, -1, 683, 683, 683, 683, 683, 
	683, 683, 683, -1, -1, -1, -1, 683, 
	683, -1, 683, 683, 683, -1, -1, -1, 
	-1, -1, -1, -1, -1, 683, 683, -1, 
	-1, 683, -1, 683, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 683, 683, 683, 
	-1, -1, 683, 683, 683, -1, -1, -1, 
	-1, -1, 683, 683, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 683, -1, 
	683, -1, -1, 683, 683, 683, 684, 684, 
	684, 684, 684, 684, 684, 684, 684, 684, 
	684, 684, 684, 684, 684, 684, 684, 684, 
	684, 684, 684, 684, 684, 684, 684, 684, 
	684, 684, 684, 684, 684, 684, -1, 684, 
	-1, 684, 684, 684, 684, 684, 684, -1, 
	684, 684, 684, -1, -1, 684, 684, 684, 
	684, 684, 684, 684, 684, -1, 684, 684, 
	684, 684, -1, -1, -1, 684, 684, 684, 
	684, 684, -1, -1, 684, 684, 684, 684, 
	-1, -1, -1, 684, -1, -1, -1, 684, 
	684, -1, 684, -1, -1, 684, -1, -1, 
	684, -1, 684, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 684, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 684, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 683, 684, 684, 684, 684, -1, -1, 
	684, 684, 684, 684, 684, 684, -1, -1, 
	-1, -1, 684, 684, 684, 684, 684, 684, 
	684, -1, -1, 684, -1, 684, -1, -1, 
	-1, -1, 684, 684, -1, 684, 684, 684, 
	684, -1, 684, 684, -1, -1, 684, -1, 
	-1, -1, -1, -1, 684, -1, 684, 684, 
	684, 684, 684, 684, 684, 684, -1, -1, 
	-1, -1, 684, 684, -1, 684, 684, 684, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	684, 684, -1, -1, 684, -1, 684, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	684, 684, 684, -1, -1, 684, 684, 684, 
	-1, -1, -1, -1, -1, 684, 684, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 684, -1, 684, -1, -1, 684, 684, 
	684, 687, 687, 687, 687, 687, 687, 687, 
	687, 687, 687, 687, 687, 687, 687, 687, 
	687, 687, 687, 687, 687, 687, 687, 687, 
	687, 687, 687, -1, 687, 687, 687, 687, 
	687, -1, 687, -1, 687, 687, 687, 687, 
	-1, 687, -1, 687, 687, 687, 687, 687, 
	687, 687, 687, 687, 687, 687, 687, 687, 
	687, 687, 687, 687, -1, 687, 687, 687, 
	687, 687, 687, 687, 687, 687, 687, 687, 
	687, 687, 687, 687, -1, 687, -1, -1, 
	687, -1, 687, 687, 687, 687, 687, -1, 
	-1, 687, 687, 687, 687, 687, 687, 687, 
	687, 687, 687, 687, 687, 687, 687, 687, 
	687, -1, -1, -1, -1, -1, 687, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 684, 687, 687, 687, 
	687, -1, -1, 687, 687, 687, 687, 687, 
	687, -1, -1, -1, -1, 687, 687, 687, 
	687, 687, 687, 687, -1, -1, -1, -1, 
	687, -1, -1, -1, -1, 687, 687, -1, 
	-1, 687, 687, 687, -1, 687, 687, -1, 
	-1, 687, -1, -1, -1, -1, -1, -1, 
	-1, -1, 687, 687, 687, 687, 687, 687, 
	687, -1, -1, -1, 687, 687, 687, 687, 
	-1, 687, 687, -1, 687, 687, 687, 687, 
	687, 687, 687, 687, 687, -1, -1, -1, 
	687, 687, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 687, 687, 687, -1, 
	-1, 687, -1, -1, -1, -1, 687, -1, 
	687, 687, 687, 687, -1, 687, 687, 687, 
	687, 687, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 687, -1, 687, -1, 
	-1, 687, -1, 687, 687, -1, -1, -1, 
	687, -1, 687, -1, 687, 688, 688, 688, 
	688, 688, 688, 688, 688, 688, 688, 688, 
	688, 688, 688, 688, 688, 688, 688, 688, 
	688, 688, 688, 688, 688, 688, 688, -1, 
	688, 688, 688, 688, 688, -1, 688, -1, 
	688, 688, 688, 688, -1, 688, -1, 688, 
	688, 688, 688, 688, 688, 688, 688, 688, 
	688, 688, 688, 688, 688, 688, 688, 688, 
	-1, 688, 688, 688, 688, 688, 688, 688, 
	688, 688, 688, 688, 688, 688, 688, 688, 
	-1, 688, -1, -1, 688, -1, 688, 688, 
	688, 688, 688, -1, -1, 688, 688, 688, 
	688, 688, 688, 688, 688, 688, 688, 688, 
	688, 688, 688, 688, 688, -1, -1, -1, 
	-1, -1, 688, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 687, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 688, 688, 688, 688, -1, -1, 688, 
	688, 688, 688, 688, 688, -1, -1, -1, 
	-1, 688, 688, 688, 688, 688, 688, 688, 
	-1, -1, -1, -1, 688, -1, -1, -1, 
	-1, 688, 688, -1, -1, 688, 688, 688, 
	-1, 688, 688, -1, -1, 688, -1, -1, 
	-1, -1, -1, -1, -1, -1, 688, 688, 
	688, 688, 688, 688, 688, -1, -1, -1, 
	688, 688, 688, 688, -1, 688, 688, -1, 
	688, 688, 688, 688, 688, 688, 688, 688, 
	688, -1, -1, -1, 688, 688, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	688, 688, 688, -1, -1, 688, -1, -1, 
	-1, -1, 688, -1, 688, 688, 688, 688, 
	-1, 688, 688, 688, 688, 688, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	688, -1, 688, -1, -1, 688, -1, 688, 
	688, -1, -1, -1, 688, -1, 688, -1, 
	688, 689, 689, 689, 689, 689, 689, 689, 
	689, 689, 689, 689, 689, -1, -1, 689, 
	689, 689, 689, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 689, 
	689, 689, -1, -1, -1, 689, -1, -1, 
	-1, -1, 689, -1, -1, -1, -1, -1, 
	689, 689, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 689, -1, 
	-1, 689, 689, 689, 689, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 689, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 692, 692, 692, 692, 692, 692, 
	692, 692, 692, 692, 692, 692, 692, 692, 
	692, -1, 692, 692, 692, 692, 692, 692, 
	692, 692, -1, -1, -1, 692, 692, 692, 
	692, 692, -1, 692, -1, 692, 692, 692, 
	692, -1, 692, 692, 692, 692, 692, -1, 
	-1, 692, -1, 688, 692, 692, 692, 692, 
	692, -1, 692, 692, 692, -1, -1, -1, 
	-1, 692, 692, 692, 692, 692, -1, -1, 
	692, 692, 692, 692, -1, 692, -1, -1, 
	-1, -1, -1, -1, -1, 692, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 689, 
	-1, -1, -1, -1, -1, -1, -1, 689, 
	689, 689, -1, 689, 689, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 689, -1, 
	-1, -1, -1, 689, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 689, 689, 689, -1, -1, -1, 
	-1, -1, 689, 689, -1, -1, 692, 692, 
	692, 692, -1, -1, 692, 692, 692, 692, 
	692, 692, -1, -1, -1, 689, 692, 692, 
	692, 692, 692, 692, 692, -1, -1, -1, 
	-1, 692, -1, -1, -1, -1, 692, 692, 
	-1, -1, 692, 692, 692, -1, 692, 692, 
	-1, -1, 692, -1, -1, -1, 692, -1, 
	-1, 692, -1, -1, -1, -1, 692, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 692, 692, -1, -1, -1, -1, 
	-1, -1, -1, -1, 692, 692, -1, -1, 
	-1, -1, 692, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 692, 692, 692, -1, -1, -1, -1, 
	-1, 692, 692, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 692, -1, 692, 
	-1, -1, 692, -1, -1, 695, 695, 695, 
	695, 695, 695, 695, 695, 695, 695, 695, 
	695, 695, 695, 695, -1, 695, 695, 695, 
	695, 695, 695, 695, 695, -1, -1, -1, 
	695, 695, 695, 695, 695, -1, 695, -1, 
	695, 695, 695, 695, -1, 695, -1, 695, 
	695, 695, -1, -1, 695, -1, -1, 695, 
	695, 695, 695, 695, -1, 695, 695, 695, 
	-1, -1, -1, -1, 695, 695, 695, 695, 
	695, -1, -1, 695, 695, 695, 695, -1, 
	-1, 704, 704, 704, 704, 704, 704, 704, 
	695, 704, 704, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 704, 704, 704, 704, 
	704, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 704, -1, -1, -1, 704, 
	-1, -1, -1, 704, 704, 704, 704, 704, 
	704, -1, -1, -1, -1, 704, 704, 704, 
	-1, -1, -1, -1, 704, 704, 704, 704, 
	704, 704, 704, 704, -1, -1, -1, -1, 
	-1, -1, 704, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	704, 704, 704, 704, 704, -1, -1, -1, 
	692, 695, 695, 695, 695, -1, 704, 695, 
	695, 695, 695, 695, 695, -1, -1, -1, 
	-1, 695, 695, 695, 695, 695, 695, 695, 
	-1, -1, -1, -1, 695, -1, -1, -1, 
	-1, 695, 695, -1, -1, 695, 695, 695, 
	-1, 695, 695, 695, -1, 695, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 695, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 695, 695, -1, 
	-1, -1, -1, -1, -1, -1, -1, 695, 
	695, -1, -1, -1, -1, 695, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 695, 695, 695, -1, 
	-1, -1, -1, -1, 695, 695, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	695, -1, 695, -1, -1, 695, -1, -1, 
	-1, -1, -1, -1, 704, 704, 704, 704, 
	704, -1, 704, 704, 704, -1, -1, -1, 
	-1, 704, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 704, 704, 704, -1, 
	-1, 704, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 704, 704, 704, 
	704, 704, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	704, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 689, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 689, -1, 689, 
	689, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 689, -1, -1, -1, -1, 689, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 689, 689, 
	689, -1, -1, -1, -1, -1, 689, -1, 
	-1, -1, -1, 695, -1, -1, -1, -1, 
	-1, -1, 705, 705, 705, 705, 705, 705, 
	705, 689, 705, 705, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 705, 705, 705, 
	705, 705, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 705, -1, -1, -1, 
	705, -1, 692, -1, 705, 705, 705, 705, 
	705, 705, -1, -1, -1, -1, 705, 705, 
	705, -1, -1, -1, -1, 705, 705, 705, 
	705, 705, 705, 705, 705, -1, -1, -1, 
	-1, -1, -1, 705, -1, -1, -1, 707, 
	707, 707, 707, 707, 707, 707, -1, 707, 
	707, 705, 705, 705, 705, 705, -1, -1, 
	705, 705, 707, 707, 707, 707, 707, 705, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 707, -1, -1, -1, 707, -1, -1, 
	-1, 707, 707, 707, 707, 707, 707, -1, 
	-1, -1, -1, 707, 707, 707, -1, -1, 
	-1, -1, 707, 707, -1, 707, 707, 707, 
	707, -1, -1, -1, -1, -1, -1, -1, 
	707, 707, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 707, 707, 
	707, -1, 707, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 705, 705, 705, 
	705, 705, -1, 705, 705, 705, -1, -1, 
	-1, -1, 705, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 705, 705, 705, 
	-1, -1, 705, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 705, 705, 
	705, 705, 705, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 707, 
	707, 705, -1, -1, -1, -1, -1, -1, 
	-1, -1, 707, 707, 707, 707, 707, -1, 
	707, 707, 707, -1, -1, -1, -1, 707, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 695, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 707, 707, 707, 707, 707, 
	709, 709, 709, 709, 709, 709, 709, 709, 
	709, 709, 709, 709, 709, 709, 709, -1, 
	709, 709, 709, 709, 709, 709, 709, 709, 
	-1, -1, -1, 709, 709, 709, 709, 709, 
	-1, 709, -1, 709, 709, 709, 709, -1, 
	709, -1, 709, 709, 709, -1, -1, 709, 
	-1, -1, 709, 709, 709, 709, 709, -1, 
	709, 709, 709, -1, -1, -1, -1, 709, 
	709, 709, 709, 709, -1, -1, 709, 709, 
	709, 709, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 709, 709, 709, 709, 
	-1, -1, 709, 709, 709, 709, 709, 709, 
	-1, -1, -1, -1, 709, 709, 709, 709, 
	709, 709, 709, -1, -1, -1, -1, 709, 
	-1, -1, -1, -1, 709, 709, -1, -1, 
	709, 709, 709, -1, 709, 709, -1, -1, 
	709, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 709, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	709, 709, -1, -1, -1, -1, -1, -1, 
	-1, -1, 709, 709, -1, -1, -1, -1, 
	709, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 709, 
	709, 709, -1, -1, -1, -1, -1, 709, 
	709, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 709, -1, 709, -1, -1, 
	709, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 711, 
	711, 711, 711, 711, 711, 711, 711, 711, 
	711, 711, 711, 711, 711, 711, -1, 711, 
	711, 711, 711, 711, 711, 711, 711, -1, 
	-1, -1, 711, 711, 711, 711, 711, -1, 
	711, -1, 711, 711, 711, 711, -1, 711, 
	-1, 711, 711, 711, -1, -1, 711, -1, 
	-1, 711, 711, 711, 711, 711, -1, 711, 
	711, 711, -1, -1, -1, -1, 711, 711, 
	711, 711, 711, -1, -1, 711, 711, 711, 
	711, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 709, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 711, 711, 711, 711, -1, 
	-1, 711, 711, 711, 711, 711, 711, -1, 
	-1, -1, -1, 711, 711, 711, 711, 711, 
	711, 711, -1, -1, -1, -1, 711, -1, 
	-1, -1, -1, 711, 711, -1, -1, 711, 
	711, 711, -1, 711, 711, -1, -1, 711, 
	-1, -1, -1, 707, 707, -1, -1, -1, 
	-1, -1, -1, 711, -1, -1, 707, 707, 
	707, 707, 707, -1, 707, 707, 707, 711, 
	711, -1, -1, 707, -1, -1, -1, -1, 
	-1, 711, 711, -1, -1, -1, -1, 711, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 707, 
	707, 707, 707, -1, -1, -1, 711, 711, 
	711, -1, -1, -1, -1, -1, 711, 711, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 711, -1, 711, -1, -1, 711, 
	-1, -1, 712, 712, 712, 712, 712, 712, 
	712, 712, 712, 712, 712, 712, 712, 712, 
	712, -1, 712, 712, 712, 712, 712, 712, 
	712, 712, -1, -1, -1, 712, 712, 712, 
	712, 712, -1, 712, -1, 712, 712, 712, 
	712, -1, 712, 712, 712, 712, 712, -1, 
	-1, 712, -1, -1, 712, 712, 712, 712, 
	712, -1, 712, 712, 712, -1, -1, -1, 
	-1, 712, 712, 712, 712, 712, -1, -1, 
	712, 712, 712, 712, -1, 712, -1, -1, 
	-1, -1, -1, -1, -1, 712, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 711, 712, 712, 
	712, 712, -1, -1, 712, 712, 712, 712, 
	712, 712, -1, -1, -1, -1, 712, 712, 
	712, 712, 712, 712, 712, -1, -1, -1, 
	-1, 712, -1, -1, -1, -1, 712, 712, 
	-1, -1, 712, 712, 712, -1, 712, 712, 
	-1, -1, 712, -1, -1, -1, 712, -1, 
	-1, 712, -1, -1, -1, -1, 712, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 712, 712, -1, -1, -1, -1, 
	-1, -1, -1, -1, 712, 712, -1, -1, 
	-1, -1, 712, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 712, 712, 712, -1, -1, -1, -1, 
	-1, 712, 712, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 712, -1, 712, 
	-1, -1, 712, -1, -1, 713, 713, 713, 
	713, 713, 713, 713, 713, 713, 713, 713, 
	713, 713, 713, 713, -1, 713, 713, 713, 
	713, 713, 713, 713, 713, -1, -1, -1, 
	713, 713, 713, 713, 713, -1, 713, -1, 
	713, 713, 713, 713, -1, 713, -1, 713, 
	713, 713, -1, -1, 713, -1, -1, 713, 
	713, 713, 713, 713, -1, 713, 713, 713, 
	-1, -1, -1, -1, 713, 713, 713, 713, 
	713, -1, -1, 713, 713, 713, 713, -1, 
	713, -1, -1, -1, -1, -1, -1, -1, 
	713, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	712, 713, 713, 713, 713, -1, -1, 713, 
	713, 713, 713, 713, 713, -1, -1, -1, 
	-1, 713, 713, 713, 713, 713, 713, 713, 
	-1, -1, -1, -1, 713, -1, -1, -1, 
	-1, 713, 713, -1, -1, 713, 713, 713, 
	-1, 713, 713, -1, -1, 713, -1, -1, 
	-1, -1, -1, -1, 713, -1, -1, -1, 
	-1, 713, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 713, 713, -1, 
	-1, -1, -1, -1, -1, -1, -1, 713, 
	713, -1, -1, -1, -1, 713, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 713, 713, 713, -1, 
	-1, -1, -1, -1, 713, 713, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	713, -1, 713, -1, -1, 713, -1, -1, 
	714, 714, 714, 714, 714, 714, 714, 714, 
	714, 714, 714, 714, 714, 714, 714, -1, 
	714, 714, 714, 714, 714, 714, 714, 714, 
	-1, -1, -1, 714, 714, 714, 714, 714, 
	-1, 714, -1, 714, 714, 714, 714, -1, 
	714, -1, 714, 714, 714, -1, -1, 714, 
	-1, -1, 714, 714, 714, 714, 714, -1, 
	714, 714, 714, -1, -1, -1, -1, 714, 
	714, 714, 714, 714, -1, -1, 714, 714, 
	714, 714, -1, 714, -1, -1, -1, -1, 
	-1, -1, -1, 714, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 713, 714, 714, 714, 714, 
	-1, -1, 714, 714, 714, 714, 714, 714, 
	-1, -1, -1, -1, 714, 714, 714, 714, 
	714, 714, 714, -1, -1, -1, -1, 714, 
	-1, -1, -1, -1, 714, 714, -1, -1, 
	714, 714, 714, -1, 714, 714, -1, -1, 
	714, -1, -1, -1, -1, -1, -1, 714, 
	-1, -1, -1, -1, 714, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	714, 714, -1, -1, -1, -1, -1, -1, 
	-1, -1, 714, 714, -1, -1, -1, -1, 
	714, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 714, 
	714, 714, -1, -1, -1, -1, -1, 714, 
	714, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 714, -1, 714, -1, -1, 
	714, -1, -1, 717, 717, 717, 717, 717, 
	717, 717, 717, 717, 717, 717, 717, 717, 
	717, 717, -1, 717, 717, 717, 717, 717, 
	717, 717, 717, -1, -1, -1, 717, 717, 
	717, 717, 717, -1, 717, -1, 717, 717, 
	717, 717, -1, 717, -1, 717, 717, 717, 
	-1, -1, 717, -1, -1, 717, 717, 717, 
	717, 717, -1, 717, 717, 717, -1, -1, 
	-1, -1, 717, 717, 717, 717, 717, -1, 
	-1, 717, 717, 717, 717, -1, 718, 718, 
	718, 718, 718, 718, 718, 718, 718, 718, 
	718, 718, -1, -1, 718, 718, 718, 718, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 718, 718, 718, -1, 
	-1, -1, 718, -1, -1, -1, -1, 718, 
	-1, -1, -1, -1, -1, 718, 718, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 718, -1, -1, 718, 718, 
	718, 718, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 718, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 714, 717, 
	717, 717, 717, -1, -1, 717, 717, 717, 
	717, 717, 717, -1, -1, -1, -1, 717, 
	717, 717, 717, 717, 717, 717, -1, -1, 
	-1, -1, 717, -1, -1, -1, -1, 717, 
	717, -1, -1, 717, 717, 717, -1, 717, 
	717, -1, -1, 717, -1, -1, -1, -1, 
	713, -1, -1, -1, -1, -1, -1, 717, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 717, 717, -1, -1, -1, 
	-1, -1, -1, -1, -1, 717, 717, -1, 
	-1, -1, -1, 717, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 717, 717, 717, -1, -1, -1, 
	-1, -1, 717, 717, -1, -1, -1, -1, 
	-1, -1, -1, -1, 718, -1, 717, -1, 
	717, -1, -1, 717, 718, 718, 718, -1, 
	718, 718, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 718, -1, -1, -1, -1, 
	718, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 718, 
	718, 718, -1, -1, -1, -1, -1, 718, 
	718, 720, 720, 720, 720, 720, 720, 720, 
	-1, 720, 720, -1, -1, -1, -1, -1, 
	-1, -1, 718, -1, 720, 720, 720, 720, 
	720, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 720, -1, -1, -1, 720, 
	-1, -1, -1, 720, 720, 720, 720, 720, 
	720, -1, -1, -1, -1, 720, 720, 720, 
	-1, -1, -1, -1, 720, 720, 720, 720, 
	720, 720, 720, 720, -1, -1, -1, -1, 
	-1, -1, 720, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	720, 720, 720, 720, 720, -1, -1, 721, 
	721, 721, 721, 721, 721, 721, 720, 721, 
	721, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 721, 721, 721, 721, 721, -1, 
	-1, 717, -1, -1, -1, -1, -1, -1, 
	-1, 721, -1, -1, -1, 721, -1, -1, 
	-1, 721, 721, 721, 721, 721, 721, -1, 
	-1, -1, -1, 721, 721, 721, -1, -1, 
	-1, -1, 721, 721, 721, 721, 721, 721, 
	721, 721, -1, -1, -1, -1, -1, -1, 
	721, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 721, 721, 
	721, 721, 721, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 721, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 720, 720, 720, 720, 
	720, -1, 720, 720, 720, -1, -1, -1, 
	-1, 720, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 720, 720, 720, -1, 
	-1, 720, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 720, 720, 720, 
	720, 720, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	720, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 721, 721, 721, 721, 721, -1, 
	721, 721, 721, -1, -1, -1, -1, 721, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 721, 721, 721, -1, -1, 721, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 721, 721, 721, 721, 721, 
	-1, -1, -1, -1, 722, 722, 722, 722, 
	722, 722, 722, -1, 722, 722, -1, -1, 
	-1, -1, -1, -1, -1, -1, 721, 722, 
	722, 722, 722, 722, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 722, -1, 
	-1, -1, 722, -1, -1, -1, 722, 722, 
	722, 722, 722, 722, -1, -1, -1, -1, 
	722, 722, 722, -1, -1, -1, -1, 722, 
	722, 722, 722, 722, 722, 722, 722, -1, 
	-1, -1, -1, -1, -1, 722, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 722, 722, 722, 722, 722, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 722, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	718, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 718, -1, 718, 718, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 718, 
	-1, -1, -1, -1, 718, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 718, 718, 718, -1, -1, 
	-1, -1, -1, 718, -1, -1, -1, 722, 
	722, 722, 722, 722, -1, 722, 722, 722, 
	-1, -1, -1, -1, 722, -1, 718, -1, 
	-1, -1, -1, -1, -1, -1, -1, 722, 
	722, 722, -1, -1, 722, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	722, 722, 722, 722, 722, -1, -1, -1, 
	-1, -1, -1, -1, 725, 725, 725, 725, 
	725, 725, 725, 725, 725, 725, 725, 725, 
	725, 725, 725, 722, 725, 725, 725, 725, 
	725, 725, 725, 725, -1, -1, -1, 725, 
	725, 725, 725, 725, -1, 725, -1, 725, 
	725, 725, 725, -1, 725, -1, 725, 725, 
	725, -1, -1, 725, -1, -1, 725, 725, 
	725, 725, 725, -1, 725, 725, 725, -1, 
	-1, -1, -1, 725, 725, 725, 725, 725, 
	-1, -1, 725, 725, 725, 725, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	725, 725, 725, 725, -1, -1, 725, 725, 
	725, 725, 725, 725, -1, -1, -1, -1, 
	725, 725, 725, 725, 725, 725, 725, -1, 
	-1, -1, -1, 725, -1, -1, -1, -1, 
	725, 725, -1, -1, 725, 725, 725, -1, 
	725, 725, -1, -1, 725, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	725, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 725, 725, -1, -1, 
	-1, -1, -1, -1, -1, -1, 725, 725, 
	-1, -1, -1, -1, 725, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 725, 725, 725, -1, -1, 
	-1, -1, -1, 725, 725, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 725, 
	-1, 725, -1, -1, 725, -1, -1, 726, 
	726, 726, 726, 726, 726, 726, 726, 726, 
	726, 726, 726, 726, 726, 726, -1, 726, 
	726, 726, 726, 726, 726, 726, 726, -1, 
	-1, -1, 726, 726, 726, 726, 726, -1, 
	726, -1, 726, 726, 726, 726, -1, 726, 
	-1, 726, 726, 726, -1, -1, 726, -1, 
	-1, 726, 726, 726, 726, 726, -1, 726, 
	726, 726, -1, -1, -1, -1, 726, 726, 
	726, 726, 726, -1, -1, 726, 726, 726, 
	726, -1, 726, 727, 727, 727, 727, 727, 
	727, 727, 727, 727, 727, 727, 727, -1, 
	-1, 727, 727, 727, 727, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 727, 727, 727, -1, -1, -1, 727, 
	-1, -1, -1, -1, 727, -1, -1, -1, 
	-1, -1, 727, 727, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	727, -1, -1, 727, 727, 727, 727, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 727, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 725, 726, 726, 726, 726, -1, 
	-1, 726, 726, 726, 726, 726, 726, -1, 
	-1, -1, -1, 726, 726, 726, 726, 726, 
	726, 726, -1, -1, -1, -1, 726, -1, 
	-1, -1, -1, 726, 726, -1, -1, 726, 
	726, 726, -1, 726, 726, -1, -1, 726, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 726, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 726, 
	726, -1, -1, -1, -1, -1, -1, -1, 
	-1, 726, 726, -1, -1, -1, -1, 726, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 726, 726, 
	726, -1, -1, -1, -1, -1, 726, 726, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 727, 726, -1, 726, -1, -1, 726, 
	-1, 727, 727, 727, -1, 727, 727, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	727, -1, -1, -1, -1, 727, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 727, 727, 727, -1, 
	-1, -1, -1, -1, 727, 727, -1, -1, 
	733, 733, 733, 733, 733, 733, 733, 733, 
	733, 733, 733, 733, 733, 733, 733, 727, 
	733, 733, 733, 733, 733, 733, 733, 733, 
	-1, -1, -1, 733, 733, 733, 733, 733, 
	-1, 733, -1, 733, 733, 733, 733, -1, 
	733, -1, 733, 733, 733, -1, -1, 733, 
	-1, -1, 733, 733, 733, 733, 733, -1, 
	733, 733, 733, -1, -1, -1, -1, 733, 
	733, 733, 733, 733, -1, -1, 733, 733, 
	733, 733, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 726, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 733, 733, 733, 733, 
	-1, -1, 733, 733, 733, 733, 733, 733, 
	-1, -1, -1, -1, 733, 733, 733, 733, 
	733, 733, 733, -1, -1, -1, -1, 733, 
	-1, -1, -1, -1, 733, 733, -1, -1, 
	733, 733, 733, -1, 733, 733, -1, -1, 
	733, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 733, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	733, 733, -1, -1, -1, -1, -1, -1, 
	-1, -1, 733, 733, -1, -1, -1, -1, 
	733, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 733, 
	733, 733, -1, -1, -1, -1, -1, 733, 
	733, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 733, -1, 733, -1, -1, 
	733, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 734, 734, 734, 
	734, 734, 734, 734, 734, 734, 734, 734, 
	734, 734, 734, 734, -1, 734, 734, 734, 
	734, 734, 734, 734, 734, -1, -1, -1, 
	734, 734, 734, 734, 734, -1, 734, -1, 
	734, 734, 734, 734, -1, 734, -1, 734, 
	734, 734, -1, -1, 734, -1, -1, 734, 
	734, 734, 734, 734, -1, 734, 734, 734, 
	-1, -1, -1, -1, 734, 734, 734, 734, 
	734, -1, -1, 734, 734, 734, 734, -1, 
	734, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 733, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 734, 734, 734, 734, -1, -1, 734, 
	734, 734, 734, 734, 734, -1, -1, -1, 
	-1, 734, 734, 734, 734, 734, 734, 734, 
	-1, -1, -1, -1, 734, -1, -1, -1, 
	-1, 734, 734, -1, -1, 734, 734, 734, 
	-1, 734, 734, -1, -1, 734, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 734, -1, -1, -1, 727, -1, -1, 
	-1, -1, -1, -1, -1, 734, 734, 727, 
	-1, 727, 727, -1, -1, -1, -1, 734, 
	734, -1, -1, -1, 727, 734, -1, -1, 
	-1, 727, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 734, 734, 734, -1, 
	727, 727, 727, -1, 734, 734, -1, -1, 
	727, -1, -1, -1, -1, -1, -1, -1, 
	734, -1, 734, -1, -1, 734, -1, -1, 
	-1, -1, -1, 727, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 734
};

static int pid_0_parser_keys[] = {
	4, 915, 482, 482, 482, 482, 4, 915, 
	4, 482, 4, 482, 4, 482, 4, 482, 
	4, 482, 4, 482, 4, 482, 4, 482, 
	4, 482, 4, 482, 4, 482, 4, 482, 
	4, 482, 4, 482, 4, 482, 4, 482, 
	4, 482, 4, 482, 4, 482, 4, 482, 
	71, 71, 63, 813, 71, 71, 71, 831, 
	71, 71, 4, 915, 71, 71, 71, 71, 
	31, 867, 71, 71, 4, 482, 4, 855, 
	71, 71, 12, 903, 71, 903, 12, 903, 
	85, 91, 71, 903, 12, 903, 4, 482, 
	4, 482, 4, 482, 4, 864, 71, 856, 
	31, 856, 87, 87, 71, 867, 71, 71, 
	75, 75, 71, 71, 71, 71, 71, 71, 
	74, 897, 85, 85, 81, 81, 71, 904, 
	31, 869, 31, 869, 31, 869, 71, 71, 
	71, 71, 71, 903, 71, 903, 85, 85, 
	85, 85, 31, 869, 71, 903, 31, 869, 
	4, 482, 71, 255, 71, 255, 71, 255, 
	4, 896, 110, 928, 115, 916, 118, 876, 
	12, 929, 43, 921, 6, 6, 63, 921, 
	138, 138, 138, 138, 138, 138, 12, 903, 
	4, 482, 71, 903, 31, 867, 81, 81, 
	31, 867, 31, 867, 31, 867, 31, 867, 
	31, 867, 74, 882, 74, 897, 74, 897, 
	4, 920, 6, 918, 81, 81, 10, 903, 
	4, 482, 4, 482, 4, 482, 4, 482, 
	12, 903, 12, 903, 12, 903, 12, 903, 
	4, 482, 4, 482, 4, 482, 4, 482, 
	4, 482, 4, 482, 12, 903, 4, 482, 
	30, 30, 95, 95, 95, 95, 4, 482, 
	71, 904, 4, 482, 4, 482, 4, 482, 
	4, 482, 95, 95, 95, 95, 95, 95, 
	95, 95, 95, 95, 4, 482, 110, 930, 
	115, 916, 118, 876, 12, 931, 4, 482, 
	10, 903, 85, 85, 4, 855, 4, 482, 
	31, 867, 31, 867, 10, 922, 4, 855, 
	52, 843, 12, 903, 12, 903, 4, 813, 
	4, 482, 73, 73, 105, 105, 115, 916, 
	31, 867, 110, 874, 110, 928, 110, 316, 
	12, 929, 115, 875, 115, 916, 118, 118, 
	118, 118, 78, 78, 12, 929, 74, 76, 
	12, 883, 6, 482, 4, 482, 4, 482, 
	71, 73, 71, 71, 71, 71, 4, 917, 
	4, 482, 12, 903, 82, 82, 71, 71, 
	4, 482, 4, 482, 4, 482, 4, 482, 
	12, 903, 12, 903, 43, 823, 43, 921, 
	4, 482, 63, 813, 4, 482, 120, 912, 
	120, 912, 86, 86, 86, 86, 86, 107, 
	94, 94, 31, 255, 74, 870, 74, 870, 
	74, 870, 74, 870, 74, 870, 74, 870, 
	4, 482, 4, 482, 4, 482, 110, 924, 
	115, 916, 118, 876, 71, 925, 4, 864, 
	4, 864, 6, 6, 4, 920, 4, 308, 
	4, 308, 4, 308, 4, 308, 4, 308, 
	4, 308, 4, 308, 4, 308, 4, 308, 
	4, 308, 4, 308, 4, 308, 4, 308, 
	4, 308, 4, 308, 4, 308, 4, 308, 
	31, 255, 6, 6, 6, 918, 6, 306, 
	6, 306, 81, 148, 31, 867, 31, 867, 
	31, 867, 31, 867, 31, 867, 31, 867, 
	31, 867, 31, 867, 110, 874, 110, 930, 
	110, 318, 12, 931, 115, 875, 118, 118, 
	78, 78, 12, 931, 74, 76, 12, 883, 
	86, 107, 4, 482, 4, 482, 12, 903, 
	4, 482, 4, 482, 4, 847, 12, 903, 
	12, 903, 10, 922, 4, 482, 12, 903, 
	12, 903, 12, 903, 12, 903, 12, 903, 
	12, 903, 12, 903, 12, 903, 12, 903, 
	12, 903, 71, 903, 4, 868, 12, 903, 
	4, 482, 71, 803, 4, 482, 4, 482, 
	85, 85, 88, 88, 19, 853, 10, 922, 
	4, 482, 4, 482, 52, 843, 4, 843, 
	4, 482, 71, 882, 10, 903, 86, 86, 
	86, 86, 73, 138, 4, 482, 4, 814, 
	115, 875, 4, 482, 113, 113, 110, 262, 
	4, 482, 4, 482, 4, 482, 115, 263, 
	4, 482, 4, 482, 4, 482, 4, 482, 
	110, 928, 115, 916, 118, 876, 12, 903, 
	12, 292, 78, 113, 4, 482, 71, 867, 
	4, 482, 4, 482, 85, 85, 6, 6, 
	4, 917, 4, 305, 4, 305, 4, 305, 
	4, 305, 4, 305, 4, 305, 4, 305, 
	4, 305, 4, 305, 4, 305, 4, 305, 
	4, 305, 4, 305, 4, 305, 4, 305, 
	4, 305, 4, 305, 4, 482, 71, 292, 
	4, 482, 86, 86, 4, 482, 43, 228, 
	77, 840, 77, 228, 138, 138, 125, 139, 
	120, 906, 87, 300, 87, 300, 120, 912, 
	87, 300, 87, 300, 87, 300, 87, 300, 
	87, 300, 135, 135, 146, 913, 146, 913, 
	120, 912, 87, 300, 138, 138, 125, 139, 
	4, 482, 12, 903, 12, 903, 74, 897, 
	12, 923, 74, 897, 74, 897, 74, 897, 
	74, 897, 74, 892, 110, 874, 110, 924, 
	110, 312, 71, 925, 115, 875, 118, 118, 
	78, 78, 71, 925, 71, 877, 110, 924, 
	115, 916, 118, 876, 81, 81, 4, 482, 
	4, 482, 6, 6, 4, 482, 6, 6, 
	148, 919, 71, 71, 4, 482, 30, 30, 
	96, 96, 96, 96, 96, 96, 94, 94, 
	94, 94, 96, 96, 96, 96, 113, 113, 
	110, 262, 4, 482, 4, 482, 4, 482, 
	110, 930, 115, 916, 118, 876, 12, 903, 
	78, 113, 4, 482, 4, 482, 4, 482, 
	88, 88, 4, 482, 4, 482, 4, 482, 
	4, 847, 4, 482, 12, 903, 10, 903, 
	4, 482, 4, 482, 4, 482, 4, 482, 
	4, 482, 4, 482, 4, 482, 4, 482, 
	4, 482, 4, 482, 4, 482, 4, 482, 
	4, 482, 4, 482, 4, 482, 86, 86, 
	86, 86, 86, 86, 86, 94, 81, 81, 
	12, 923, 19, 241, 4, 482, 88, 88, 
	10, 922, 71, 903, 10, 903, 10, 903, 
	4, 482, 88, 88, 4, 482, 4, 482, 
	4, 482, 4, 482, 63, 63, 4, 482, 
	110, 316, 110, 874, 115, 875, 118, 118, 
	12, 317, 4, 482, 71, 803, 6, 6, 
	4, 482, 71, 71, 71, 71, 4, 482, 
	4, 482, 4, 482, 71, 835, 120, 912, 
	125, 139, 87, 300, 146, 914, 146, 914, 
	4, 482, 120, 912, 120, 912, 120, 912, 
	120, 912, 120, 912, 120, 912, 120, 912, 
	120, 912, 120, 300, 87, 300, 87, 300, 
	87, 300, 87, 300, 94, 121, 121, 911, 
	4, 482, 86, 86, 86, 86, 86, 86, 
	12, 923, 12, 311, 4, 482, 4, 482, 
	4, 482, 4, 482, 4, 482, 4, 482, 
	4, 482, 4, 482, 110, 926, 115, 916, 
	118, 876, 12, 927, 113, 113, 110, 262, 
	4, 482, 4, 482, 4, 482, 71, 265, 
	110, 874, 115, 875, 118, 118, 71, 313, 
	71, 73, 78, 113, 4, 482, 148, 148, 
	149, 149, 148, 919, 148, 307, 148, 307, 
	148, 307, 148, 307, 148, 307, 148, 307, 
	148, 307, 148, 307, 148, 307, 148, 307, 
	148, 307, 148, 307, 148, 919, 12, 886, 
	4, 482, 4, 482, 4, 482, 31, 867, 
	31, 867, 12, 903, 4, 482, 110, 318, 
	110, 874, 115, 875, 118, 118, 12, 319, 
	4, 482, 10, 903, 4, 482, 4, 482, 
	4, 482, 31, 867, 87, 87, 71, 803, 
	86, 86, 74, 882, 88, 88, 4, 482, 
	10, 903, 110, 928, 115, 916, 118, 876, 
	12, 929, 4, 482, 4, 482, 4, 482, 
	12, 317, 12, 317, 12, 317, 86, 86, 
	71, 834, 77, 838, 138, 138, 87, 300, 
	87, 300, 146, 302, 145, 302, 87, 300, 
	120, 906, 120, 906, 120, 906, 120, 906, 
	87, 300, 87, 300, 87, 300, 87, 300, 
	88, 94, 121, 121, 87, 300, 87, 300, 
	87, 300, 87, 300, 4, 482, 86, 86, 
	74, 285, 110, 874, 110, 926, 110, 314, 
	12, 927, 115, 875, 118, 118, 78, 78, 
	12, 927, 71, 867, 12, 883, 110, 312, 
	71, 313, 71, 313, 71, 313, 71, 868, 
	71, 868, 148, 919, 149, 149, 149, 149, 
	6, 306, 10, 903, 71, 903, 71, 71, 
	12, 903, 96, 96, 96, 96, 4, 482, 
	12, 319, 12, 319, 12, 319, 4, 482, 
	86, 94, 86, 94, 95, 95, 10, 922, 
	86, 86, 4, 482, 10, 310, 110, 316, 
	12, 929, 115, 875, 118, 118, 4, 482, 
	87, 91, 71, 255, 4, 837, 71, 867, 
	81, 81, 4, 482, 4, 814, 146, 146, 
	88, 88, 87, 300, 88, 121, 113, 113, 
	110, 262, 4, 482, 4, 482, 4, 482, 
	71, 73, 110, 926, 115, 916, 118, 876, 
	12, 903, 78, 113, 4, 482, 71, 313, 
	71, 313, 149, 149, 148, 307, 4, 482, 
	85, 85, 10, 292, 10, 292, 4, 482, 
	4, 482, 31, 867, 88, 88, 4, 482, 
	4, 482, 10, 922, 71, 71, 71, 255, 
	4, 836, 71, 71, 71, 73, 4, 830, 
	146, 302, 87, 300, 87, 300, 88, 88, 
	110, 314, 110, 874, 115, 875, 118, 118, 
	12, 315, 12, 315, 6, 306, 12, 903, 
	96, 96, 4, 482, 88, 88, 4, 482, 
	4, 482, 4, 839, 4, 482, 71, 868, 
	71, 868, 4, 482, 10, 922, 87, 300, 
	12, 315, 12, 315, 12, 315, 86, 86, 
	86, 94, 4, 482, 4, 482, 10, 922, 
	71, 255, 71, 255, 88, 88, 10, 292, 
	88, 88, 4, 482, 4, 482, 0, 0
};

static unsigned int pid_0_parser_offsets[] = {
	0, 2, 15, 301, 1213, 1514, 1815, 2116, 
	2417, 2718, 3019, 3320, 3621, 3922, 4223, 4524, 
	4825, 5126, 5427, 5728, 6029, 6330, 6631, 6932, 
	24, 49, 25, 32, 26, 7233, 34, 39, 
	102, 41, 7533, 8145, 45, 7607, 46, 8468, 
	55, 48, 8542, 8825, 9434, 9741, 10048, 60, 
	137, 62, 86, 68, 69, 74, 75, 76, 
	80, 77, 78, 79, 219, 390, 399, 84, 
	85, 149, 156, 87, 89, 462, 158, 520, 
	10355, 92, 108, 143, 10674, 234, 146, 100, 
	10990, 249, 90, 396, 93, 95, 96, 11066, 
	11347, 163, 546, 97, 595, 603, 608, 636, 
	649, 224, 496, 525, 11614, 1108, 98, 11702, 
	11985, 12596, 12912, 13228, 9135, 11450, 13544, 13610, 
	13891, 14502, 14818, 15134, 15450, 15766, 16082, 16199, 
	107, 109, 111, 16515, 128, 16994, 17310, 17617, 
	17924, 112, 113, 114, 115, 116, 18231, 260, 
	387, 117, 18547, 18663, 16879, 119, 18970, 19279, 
	727, 846, 19588, 19702, 503, 19965, 20040, 20329, 
	20935, 120, 121, 530, 916, 123, 722, 590, 
	21010, 130, 564, 122, 129, 132, 21291, 133, 
	14207, 153, 21419, 21726, 150, 136, 144, 21652, 
	22037, 22114, 151, 154, 22531, 22847, 23154, 23470, 
	23786, 23862, 248, 1104, 24143, 271, 24479, 999, 
	1434, 155, 157, 237, 159, 1035, 699, 714, 
	971, 975, 1413, 572, 24786, 25102, 25418, 963, 
	665, 295, 1473, 25734, 26050, 164, 26341, 8064, 
	20655, 26422, 26619, 26689, 26997, 27223, 27293, 27489, 
	27559, 27755, 27825, 28021, 28091, 28287, 28357, 28553, 
	1143, 165, 1710, 2012, 2313, 198, 1961, 2044, 
	2049, 2262, 2345, 2350, 2563, 2636, 284, 1202, 
	833, 28624, 273, 166, 167, 28873, 168, 28947, 
	405, 29234, 29559, 29875, 29992, 30308, 30624, 30913, 
	30987, 31079, 31380, 31454, 31886, 31978, 32053, 32149, 
	32316, 32411, 32578, 33010, 33086, 286, 33470, 33348, 
	34041, 641, 34348, 34650, 176, 184, 516, 34725, 
	35010, 35317, 562, 35638, 35945, 1599, 36020, 191, 
	197, 207, 36306, 36622, 410, 36929, 200, 297, 
	37236, 37552, 37868, 214, 38184, 38500, 38816, 39132, 
	1109, 690, 447, 39448, 33759, 363, 39569, 913, 
	39885, 40192, 203, 205, 40425, 12329, 20413, 24227, 
	36539, 40499, 40701, 40775, 41077, 41121, 41346, 41390, 
	41615, 41659, 41884, 41928, 42153, 42197, 42457, 380, 
	42764, 206, 43080, 1479, 615, 519, 211, 554, 
	1931, 2499, 2766, 2492, 3067, 3368, 3669, 3970, 
	4271, 229, 771, 788, 2502, 4572, 231, 644, 
	43387, 43461, 43710, 2032, 43785, 2190, 2316, 2617, 
	2641, 991, 407, 1207, 1503, 2646, 536, 239, 
	247, 3549, 812, 1744, 695, 876, 254, 44165, 
	44697, 255, 45013, 293, 3146, 316, 45320, 356, 
	375, 381, 385, 395, 397, 427, 428, 429, 
	663, 45621, 45937, 46253, 1591, 747, 888, 46569, 
	446, 46686, 47002, 47481, 435, 47797, 48113, 48429, 
	48736, 49043, 49117, 49368, 49674, 50262, 50578, 50894, 
	51210, 51526, 51842, 52158, 52474, 52790, 53106, 53422, 
	53729, 54039, 54349, 444, 451, 452, 453, 454, 
	54659, 533, 54772, 455, 55031, 1369, 55100, 55168, 
	55573, 456, 56062, 56369, 56685, 57001, 457, 57308, 
	1772, 703, 539, 458, 57383, 57664, 885, 459, 
	57971, 460, 467, 58278, 58585, 58892, 1481, 3595, 
	1042, 4873, 861, 905, 59199, 2993, 3249, 3851, 
	3889, 4151, 4190, 4452, 4491, 2947, 5174, 5475, 
	5776, 6077, 671, 1902, 59506, 469, 472, 477, 
	59580, 59829, 59943, 60273, 60589, 60905, 61221, 61537, 
	61853, 62169, 2662, 930, 921, 62485, 488, 781, 
	62602, 62918, 63234, 958, 856, 809, 492, 4754, 
	675, 518, 63550, 501, 508, 3748, 4049, 4079, 
	4336, 4650, 4951, 5252, 5531, 5545, 5560, 5832, 
	5846, 5861, 6137, 63866, 63987, 64294, 64601, 3542, 
	4746, 64890, 64999, 2235, 948, 866, 512, 65315, 
	65431, 65691, 65796, 66103, 66413, 5950, 561, 946, 
	578, 1148, 579, 66729, 66804, 3309, 1778, 1162, 
	67061, 67175, 67520, 67827, 68116, 68190, 68471, 584, 
	2099, 914, 587, 6378, 6690, 708, 1301, 6713, 
	6446, 6848, 7029, 7149, 7315, 7865, 7926, 8603, 
	624, 617, 8717, 8907, 8938, 9196, 68580, 621, 
	2777, 1130, 4816, 1335, 68869, 968, 634, 647, 
	68943, 1457, 44047, 2203, 5055, 6886, 7187, 7448, 
	9090, 6156, 654, 655, 7751, 69224, 2036, 662, 
	69273, 669, 679, 69597, 69917, 70166, 70240, 70521, 
	713, 757, 683, 70606, 693, 70912, 47366, 5115, 
	71235, 1050, 694, 71349, 966, 2011, 71656, 1375, 
	711, 71981, 72288, 718, 720, 9489, 803, 732, 
	1160, 72595, 72911, 73227, 773, 6274, 1781, 1324, 
	73543, 733, 73660, 7682, 7750, 745, 6487, 73976, 
	758, 32702, 55456, 74283, 74590, 5047, 763, 74897, 
	75213, 75529, 774, 1314, 75642, 780, 839, 75949, 
	934, 9516, 9796, 817, 4044, 1238, 1297, 823, 
	76025, 76434, 8236, 76511, 829, 76792, 830, 77127, 
	77434, 77741, 78048, 6827, 7312, 78355, 78430, 9823, 
	78713, 78807, 79092, 851, 896, 79380, 79687, 79763, 
	2683, 2687, 865, 50157, 881, 80048, 80365, 0
};

static unsigned int pid_0_parser_targs[] = {
	1, 2, 3, 4, 5, 6, 7, 8, 
	9, 10, 11, 12, 13, 14, 15, 16, 
	17, 18, 19, 20, 21, 22, 23, 24, 
	25, 26, 27, 28, 29, 30, 31, 32, 
	33, 34, 35, 36, 37, 38, 39, 40, 
	41, 42, 43, 44, 45, 46, 47, 48, 
	49, 50, 51, 52, 53, 54, 55, 56, 
	57, 58, 58, 58, 58, 58, 59, 59, 
	60, 61, 62, 63, 64, 65, 66, 67, 
	68, 69, 70, 71, 72, 73, 74, 75, 
	76, 76, 77, 77, 78, 78, 79, 79, 
	80, 80, 81, 82, 83, 84, 85, 86, 
	87, 88, 89, 90, 91, 92, 93, 94, 
	95, 96, 97, 98, 99, 100, 101, 102, 
	103, 104, 105, 106, 107, 108, 109, 110, 
	111, 112, 113, 114, 115, 116, 117, 118, 
	119, 120, 121, 122, 123, 124, 125, 126, 
	127, 128, 129, 130, 131, 132, 133, 134, 
	135, 136, 137, 138, 139, 140, 141, 142, 
	143, 144, 145, 146, 147, 148, 149, 150, 
	151, 152, 153, 154, 155, 156, 157, 158, 
	159, 160, 161, 162, 163, 164, 165, 166, 
	167, 168, 169, 170, 171, 172, 173, 174, 
	175, 176, 177, 178, 178, 179, 180, 180, 
	181, 182, 183, 184, 185, 186, 187, 188, 
	189, 190, 191, 192, 193, 194, 195, 196, 
	197, 198, 199, 200, 201, 202, 203, 204, 
	205, 206, 207, 208, 209, 210, 211, 212, 
	213, 214, 215, 216, 217, 218, 219, 220, 
	221, 222, 223, 224, 225, 226, 227, 228, 
	229, 230, 231, 232, 233, 234, 235, 236, 
	237, 238, 239, 240, 241, 242, 243, 244, 
	245, 246, 247, 248, 249, 250, 251, 252, 
	253, 254, 255, 256, 257, 258, 259, 260, 
	261, 262, 263, 264, 265, 266, 267, 268, 
	269, 270, 271, 272, 273, 274, 275, 276, 
	277, 278, 278, 279, 280, 281, 282, 283, 
	284, 285, 286, 287, 288, 289, 290, 291, 
	291, 292, 292, 293, 293, 294, 294, 295, 
	296, 297, 298, 299, 300, 301, 302, 303, 
	304, 305, 306, 307, 308, 309, 310, 311, 
	312, 313, 314, 315, 316, 317, 318, 319, 
	320, 321, 322, 323, 324, 325, 326, 327, 
	328, 329, 330, 331, 332, 333, 334, 335, 
	336, 337, 338, 339, 340, 341, 342, 343, 
	344, 345, 346, 347, 348, 349, 350, 351, 
	352, 353, 354, 355, 356, 357, 358, 359, 
	360, 361, 362, 363, 364, 365, 366, 367, 
	368, 369, 370, 371, 372, 373, 374, 375, 
	376, 377, 378, 379, 380, 381, 382, 383, 
	384, 385, 386, 387, 387, 388, 388, 389, 
	389, 390, 390, 391, 392, 393, 394, 395, 
	396, 397, 398, 399, 400, 401, 402, 403, 
	404, 405, 406, 407, 408, 409, 410, 411, 
	412, 413, 414, 415, 416, 417, 418, 419, 
	420, 421, 422, 423, 423, 424, 424, 425, 
	425, 426, 427, 428, 429, 430, 431, 432, 
	433, 434, 435, 436, 437, 438, 439, 440, 
	441, 442, 443, 444, 445, 446, 447, 448, 
	449, 450, 451, 452, 453, 454, 455, 456, 
	457, 458, 458, 459, 460, 461, 462, 463, 
	464, 465, 466, 467, 468, 469, 470, 471, 
	472, 473, 474, 475, 476, 477, 478, 479, 
	480, 481, 482, 483, 484, 485, 486, 487, 
	488, 489, 490, 491, 492, 493, 494, 495, 
	496, 497, 498, 499, 500, 501, 502, 503, 
	504, 505, 506, 507, 508, 509, 510, 511, 
	512, 513, 514, 515, 516, 517, 518, 519, 
	520, 521, 522, 523, 524, 525, 526, 527, 
	528, 529, 530, 531, 532, 533, 534, 535, 
	536, 537, 538, 539, 540, 541, 542, 543, 
	544, 545, 546, 547, 548, 549, 550, 551, 
	552, 553, 554, 555, 556, 557, 558, 559, 
	560, 561, 562, 563, 563, 564, 565, 566, 
	567, 568, 569, 570, 571, 572, 573, 574, 
	575, 576, 577, 578, 579, 580, 581, 582, 
	583, 584, 585, 586, 587, 588, 589, 590, 
	591, 592, 593, 594, 595, 596, 597, 598, 
	599, 600, 601, 602, 603, 604, 605, 606, 
	607, 608, 609, 610, 611, 612, 613, 614, 
	615, 616, 617, 618, 619, 620, 621, 622, 
	623, 624, 625, 626, 627, 628, 629, 630, 
	631, 632, 633, 634, 635, 636, 637, 638, 
	639, 640, 641, 642, 643, 644, 645, 646, 
	647, 648, 649, 650, 651, 652, 653, 654, 
	655, 656, 657, 658, 659, 660, 661, 662, 
	663, 664, 665, 666, 667, 668, 669, 670, 
	671, 672, 673, 674, 675, 676, 677, 678, 
	679, 680, 681, 682, 683, 684, 685, 686, 
	687, 688, 689, 690, 691, 692, 693, 694, 
	695, 696, 697, 698, 699, 700, 701, 702, 
	703, 704, 705, 706, 707, 708, 709, 710, 
	711, 712, 713, 714, 715, 716, 717, 718, 
	719, 720, 721, 722, 723, 724, 725, 726, 
	727, 728, 729, 730, 731, 732, 733, 734, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735, 735, 735, 735, 
	735, 735, 735, 735, 735
};

static unsigned int pid_0_parser_actInds[] = {
	0, 2, 4, 6, 8, 10, 12, 14, 
	16, 18, 20, 22, 24, 26, 28, 30, 
	32, 34, 36, 38, 40, 42, 44, 46, 
	48, 50, 52, 54, 56, 58, 60, 62, 
	64, 66, 68, 70, 72, 74, 76, 78, 
	80, 82, 84, 86, 88, 90, 92, 94, 
	96, 98, 100, 102, 104, 106, 108, 110, 
	112, 114, 116, 119, 122, 125, 129, 131, 
	134, 136, 138, 140, 142, 144, 146, 148, 
	150, 152, 154, 156, 158, 160, 162, 164, 
	166, 168, 171, 173, 176, 178, 181, 183, 
	186, 188, 191, 193, 195, 197, 199, 201, 
	203, 205, 207, 209, 211, 214, 216, 218, 
	220, 222, 224, 226, 228, 230, 232, 234, 
	236, 238, 240, 242, 244, 246, 248, 250, 
	252, 254, 256, 258, 260, 262, 264, 266, 
	268, 270, 272, 274, 276, 278, 280, 282, 
	284, 286, 288, 290, 292, 294, 296, 298, 
	300, 302, 304, 306, 308, 310, 312, 314, 
	316, 318, 320, 322, 324, 326, 328, 330, 
	332, 334, 336, 338, 340, 342, 344, 346, 
	348, 350, 352, 354, 356, 358, 360, 362, 
	364, 366, 368, 370, 372, 374, 376, 378, 
	380, 382, 384, 386, 388, 391, 393, 395, 
	398, 400, 402, 404, 406, 408, 410, 412, 
	414, 416, 418, 420, 422, 424, 426, 428, 
	430, 432, 434, 436, 438, 440, 442, 444, 
	446, 448, 450, 452, 454, 456, 458, 460, 
	462, 464, 466, 468, 470, 472, 474, 476, 
	478, 480, 482, 484, 486, 488, 490, 492, 
	494, 496, 498, 500, 502, 504, 506, 508, 
	510, 512, 514, 516, 518, 520, 522, 524, 
	526, 528, 530, 532, 534, 536, 538, 540, 
	542, 544, 546, 548, 550, 552, 554, 556, 
	558, 560, 562, 564, 566, 568, 570, 572, 
	574, 576, 578, 580, 582, 584, 586, 588, 
	590, 592, 594, 597, 600, 602, 604, 606, 
	608, 610, 612, 614, 616, 618, 620, 622, 
	624, 627, 629, 632, 634, 637, 639, 642, 
	644, 646, 648, 650, 652, 654, 656, 658, 
	660, 662, 664, 666, 668, 670, 672, 674, 
	676, 678, 680, 682, 684, 686, 688, 690, 
	692, 694, 696, 698, 700, 702, 704, 706, 
	708, 710, 712, 714, 716, 718, 720, 722, 
	724, 726, 728, 730, 732, 734, 736, 738, 
	740, 742, 744, 746, 748, 750, 752, 754, 
	756, 758, 760, 762, 764, 766, 768, 770, 
	772, 774, 776, 778, 780, 782, 784, 786, 
	788, 790, 792, 794, 796, 798, 800, 802, 
	804, 806, 808, 810, 812, 814, 816, 818, 
	820, 822, 824, 826, 828, 832, 834, 838, 
	840, 844, 847, 851, 853, 855, 857, 859, 
	861, 863, 865, 867, 869, 871, 873, 875, 
	877, 879, 881, 883, 885, 887, 889, 891, 
	893, 895, 897, 899, 901, 903, 905, 907, 
	909, 911, 913, 915, 917, 920, 922, 925, 
	927, 930, 933, 936, 938, 940, 942, 944, 
	946, 948, 950, 952, 954, 956, 958, 960, 
	962, 964, 966, 968, 970, 972, 974, 976, 
	978, 980, 982, 984, 986, 988, 990, 992, 
	994, 996, 998, 1001, 1003, 1005, 1007, 1009, 
	1011, 1013, 1015, 1017, 1019, 1021, 1023, 1025, 
	1027, 1029, 1031, 1033, 1035, 1037, 1039, 1041, 
	1043, 1045, 1047, 1049, 1051, 1053, 1055, 1057, 
	1059, 1061, 1063, 1065, 1067, 1069, 1071, 1073, 
	1075, 1077, 1079, 1081, 1083, 1085, 1087, 1089, 
	1091, 1093, 1095, 1097, 1099, 1101, 1103, 1105, 
	1107, 1109, 1111, 1113, 1115, 1117, 1119, 1121, 
	1123, 1125, 1127, 1129, 1131, 1133, 1135, 1137, 
	1139, 1141, 1143, 1145, 1147, 1149, 1151, 1153, 
	1155, 1157, 1159, 1161, 1163, 1165, 1167, 1169, 
	1171, 1173, 1175, 1177, 1179, 1181, 1183, 1185, 
	1187, 1189, 1191, 1193, 1195, 1197, 1199, 1201, 
	1203, 1205, 1207, 1209, 1211, 1214, 1216, 1218, 
	1220, 1222, 1224, 1226, 1228, 1230, 1232, 1234, 
	1236, 1238, 1240, 1242, 1244, 1246, 1248, 1250, 
	1252, 1254, 1256, 1258, 1260, 1262, 1264, 1266, 
	1268, 1270, 1272, 1274, 1276, 1278, 1280, 1282, 
	1284, 1286, 1288, 1290, 1292, 1294, 1296, 1298, 
	1300, 1302, 1304, 1306, 1308, 1310, 1312, 1314, 
	1316, 1318, 1320, 1322, 1324, 1326, 1328, 1330, 
	1332, 1334, 1336, 1338, 1340, 1342, 1344, 1346, 
	1348, 1350, 1352, 1354, 1356, 1358, 1360, 1362, 
	1364, 1366, 1368, 1370, 1372, 1374, 1376, 1378, 
	1380, 1382, 1384, 1386, 1388, 1390, 1392, 1394, 
	1396, 1398, 1401, 1403, 1405, 1407, 1409, 1411, 
	1413, 1415, 1417, 1419, 1421, 1423, 1425, 1427, 
	1429, 1431, 1433, 1435, 1437, 1439, 1441, 1443, 
	1445, 1447, 1449, 1451, 1453, 1455, 1457, 1459, 
	1461, 1463, 1465, 1467, 1469, 1471, 1473, 1475, 
	1477, 1479, 1481, 1483, 1485, 1487, 1489, 1491, 
	1493, 1495, 1497, 1499, 1501, 1503, 1505, 1507, 
	1509, 1511, 1513, 1515, 1517, 1519, 1521, 1523, 
	1525, 1527, 1529, 1531, 1533, 1535, 1537, 1539, 
	1541, 1543, 1545, 1547, 1549, 1551, 1553, 1555, 
	1557, 1559, 1561, 1563, 1565, 1567, 1569, 1571, 
	1573, 1575, 1577, 1579, 1581, 1583, 1585, 1587, 
	1589, 1591, 1593, 1595, 1597, 1599, 1601, 1603, 
	1605, 1607, 1609, 1611, 1613, 1615, 1617, 1619, 
	1621, 1623, 1625, 1627, 1629, 1631, 1633, 1635, 
	1637, 1639, 1641, 1643, 1645, 1647, 1649, 1651, 
	1653, 1655, 1657, 1659, 1661, 1663, 1665, 1667, 
	1669, 1671, 1673, 1675, 1677, 1679, 1681, 1683, 
	1685, 1687, 1689, 1691, 1693, 1695, 1697, 1699, 
	1701, 1703, 1705, 1707, 1709, 1711, 1713, 1715, 
	1717, 1719, 1721, 1723, 1725, 1727, 1729, 1731, 
	1733, 1735, 1737, 1739, 1741, 1743, 1745, 1747, 
	1749, 1751, 1753, 1755, 1757, 1759, 1761, 1763, 
	1765, 1767, 1769, 1771, 1773, 1775, 1777, 1779, 
	1781, 1783, 1785, 1787, 1789, 1791, 1793, 1795, 
	1797, 1799, 1801, 1803, 1805, 1807, 1809, 1811, 
	1813, 1815, 1817, 1819, 1821, 1823, 1825, 1827, 
	1829, 1831, 1833, 1835, 1837, 1839, 1841, 1843, 
	1845, 1847, 1849, 1851, 1853, 1855, 1857, 1859, 
	1861, 1863, 1865, 1867, 1869, 1871, 1873, 1875, 
	1877, 1879, 1881, 1883, 1885, 1887, 1889, 1891, 
	1893, 1895, 1897, 1899, 1901, 1903, 1905, 1907, 
	1909, 1911, 1913, 1915, 1917, 1919, 1921, 1923, 
	1925, 1927, 1929, 1931, 1933, 1935, 1937, 1939, 
	1941, 1943, 1945, 1947, 1949, 1951, 1953, 1955, 
	1957, 1959, 1961, 1963, 1965, 1967, 1969, 1971, 
	1973, 1975, 1977, 1979, 1981, 1983, 1985, 1987, 
	1989, 1991, 1993, 1995, 1997, 1999, 2001, 2003, 
	2005, 2007, 2009, 2011, 2013, 2015, 2017, 2019, 
	2021, 2023, 2025, 2027, 2029, 2031, 2033, 2035, 
	2037, 2039, 2041, 2043, 2045, 2047, 2049, 2051, 
	2053, 2055, 2057, 2059, 2061, 2063, 2065, 2067, 
	2069, 2071, 2073, 2075, 2077, 2079, 2081, 2083, 
	2085, 2087, 2089, 2091, 2093, 2095, 2097, 2099, 
	2101, 2103, 2105, 2107, 2109, 2111, 2113, 2115, 
	2117, 2119, 2121, 2123, 2125, 2127, 2129, 2131, 
	2133, 2135, 2137, 2139, 2141, 2143, 2145, 2147, 
	2149, 2151, 2153, 2155, 2157, 2159, 2161, 2163, 
	2165, 2167, 2169, 2171, 2173, 2175, 2177, 2179, 
	2181, 2183, 2185, 2187, 2189, 2191, 2193, 2195, 
	2197, 2199, 2201, 2203, 2205, 2207, 2209, 2211, 
	2213, 2215, 2217, 2219, 2221, 2223, 2225, 2227, 
	2229, 2231, 2233, 2235, 2237, 2239, 2241, 2243, 
	2245, 2247, 2249, 2251, 2253, 2255, 2257, 2259, 
	2261, 2263, 2265, 2267, 2269, 2271, 2273, 2275, 
	2277, 2279, 2281, 2283, 2285, 2287, 2289, 2291, 
	2293, 2295, 2297, 2299, 2301, 2303, 2305, 2307, 
	2309, 2311, 2313, 2315, 2317, 2319, 2321, 2323, 
	2325, 2327, 2329, 2331, 2333, 2335, 2337, 2339, 
	2341, 2343, 2345, 2348, 2351, 2354, 2357, 2360, 
	2363, 2366, 2369, 2372, 2375
};

static unsigned int pid_0_parser_actions[] = {
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 238, 0, 1, 
	938, 0, 234, 1, 0, 238, 1, 938, 
	0, 1, 0, 238, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 1234, 0, 1, 0, 1, 1234, 0, 
	1, 0, 1, 1234, 0, 1, 0, 1, 
	1234, 0, 1, 0, 1, 1234, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 962, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 1302, 0, 1, 
	0, 1, 0, 1234, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 1302, 0, 1, 858, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 582, 0, 1, 0, 582, 1, 0, 
	1, 0, 1, 582, 0, 1, 0, 582, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1122, 1126, 1, 0, 
	1, 0, 1122, 1126, 1, 0, 1, 0, 
	1122, 1126, 1, 0, 1, 1030, 0, 1126, 
	1, 1030, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 666, 1, 0, 
	1, 0, 1, 666, 0, 1, 0, 666, 
	1, 0, 1, 666, 0, 1, 666, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 582, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 666, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 514, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 598, 0, 570, 
	0, 602, 0, 562, 0, 566, 0, 614, 
	0, 618, 0, 574, 0, 594, 0, 622, 
	0, 626, 0, 6, 0, 10, 0, 14, 
	0, 18, 0, 22, 0, 26, 0, 30, 
	0, 34, 0, 38, 0, 42, 0, 46, 
	0, 50, 0, 54, 0, 58, 0, 62, 
	0, 66, 0, 70, 0, 74, 0, 78, 
	0, 82, 0, 130, 0, 134, 0, 138, 
	0, 142, 0, 146, 0, 150, 0, 154, 
	0, 158, 0, 162, 0, 166, 0, 170, 
	0, 174, 0, 178, 0, 182, 0, 186, 
	0, 190, 0, 362, 0, 366, 0, 374, 
	0, 378, 0, 382, 0, 386, 0, 390, 
	0, 394, 0, 398, 0, 402, 0, 406, 
	0, 410, 0, 414, 0, 418, 0, 422, 
	0, 426, 0, 430, 0, 434, 0, 438, 
	0, 590, 0, 630, 0, 634, 0, 1, 
	0, 2, 0, 86, 0, 90, 0, 94, 
	0, 98, 0, 102, 0, 106, 0, 110, 
	0, 114, 0, 118, 0, 122, 0, 126, 
	0, 194, 0, 198, 0, 202, 0, 206, 
	0, 210, 0, 214, 0, 218, 0, 222, 
	0, 226, 0, 230, 0, 234, 0, 238, 
	0, 242, 0, 246, 0, 250, 0, 254, 
	0, 258, 0, 262, 0, 266, 0, 270, 
	0, 274, 0, 278, 0, 282, 0, 286, 
	0, 290, 0, 294, 0, 298, 0, 302, 
	0, 306, 0, 310, 0, 314, 0, 318, 
	0, 322, 0, 326, 0, 330, 0, 334, 
	0, 338, 0, 342, 0, 346, 0, 350, 
	0, 354, 0, 358, 0, 370, 0, 446, 
	0, 450, 0, 454, 0, 458, 0, 462, 
	0, 466, 0, 470, 0, 474, 0, 478, 
	0, 482, 0, 486, 0, 490, 0, 494, 
	0, 498, 0, 502, 0, 506, 0, 510, 
	0, 514, 0, 518, 0, 522, 0, 526, 
	0, 530, 0, 534, 0, 538, 0, 542, 
	0, 546, 0, 550, 0, 554, 0, 558, 
	0, 578, 0, 582, 0, 586, 0, 606, 
	0, 610, 0, 638, 0, 642, 0, 646, 
	0, 650, 0, 654, 0, 658, 0, 662, 
	0, 666, 0, 670, 0, 674, 0, 678, 
	0, 682, 0, 686, 0, 690, 0, 694, 
	0, 698, 0, 702, 0, 706, 0, 710, 
	0, 714, 0, 718, 0, 722, 0, 726, 
	0, 730, 0, 734, 0, 738, 0, 742, 
	0, 750, 0, 754, 0, 758, 0, 762, 
	0, 766, 0, 770, 0, 774, 0, 778, 
	0, 782, 0, 786, 0, 790, 0, 794, 
	0, 798, 0, 802, 0, 806, 0, 810, 
	0, 814, 0, 818, 0, 822, 0, 826, 
	0, 830, 0, 834, 0, 838, 0, 842, 
	0, 846, 0, 850, 0, 854, 0, 858, 
	0, 862, 0, 866, 0, 870, 0, 874, 
	0, 878, 0, 882, 0, 886, 0, 890, 
	0, 894, 0, 898, 0, 902, 0, 906, 
	0, 910, 0, 914, 0, 918, 0, 922, 
	0, 926, 0, 930, 0, 934, 0, 938, 
	0, 942, 0, 946, 0, 950, 0, 954, 
	0, 958, 0, 962, 0, 966, 0, 970, 
	0, 974, 0, 978, 0, 982, 0, 986, 
	0, 990, 0, 994, 0, 998, 0, 1002, 
	0, 1006, 0, 1010, 0, 1014, 0, 1018, 
	0, 1022, 0, 1026, 0, 1030, 0, 1034, 
	0, 1038, 0, 1042, 0, 1046, 0, 1050, 
	0, 1054, 0, 1058, 0, 1062, 0, 1066, 
	0, 1070, 0, 1074, 0, 1078, 0, 1082, 
	0, 1086, 0, 1090, 0, 1094, 0, 1098, 
	0, 1102, 0, 1106, 0, 1110, 0, 1114, 
	0, 1118, 0, 1122, 0, 1126, 0, 1130, 
	0, 1138, 0, 1142, 0, 1146, 0, 1150, 
	0, 1154, 0, 1158, 0, 1162, 0, 1166, 
	0, 1170, 0, 1174, 0, 1178, 0, 1182, 
	0, 1186, 0, 1190, 0, 1194, 0, 1198, 
	0, 1202, 0, 1206, 0, 1210, 0, 1214, 
	0, 1218, 0, 1222, 0, 1226, 0, 1230, 
	0, 1234, 0, 1238, 0, 1242, 0, 1246, 
	0, 1250, 0, 1254, 0, 1258, 0, 1262, 
	0, 1266, 0, 1270, 0, 1274, 0, 1278, 
	0, 1282, 0, 1286, 0, 1290, 0, 1294, 
	0, 1298, 0, 1306, 0, 1310, 0, 1314, 
	0, 1318, 0, 1322, 0, 1326, 0, 1330, 
	0, 1334, 0, 1338, 0, 1342, 0, 1346, 
	0, 1350, 0, 1354, 0, 1358, 0, 1362, 
	0, 1366, 0, 1370, 0, 1374, 0, 1378, 
	0, 1382, 0, 1386, 0, 1390, 0, 1394, 
	0, 1398, 0, 1402, 0, 1406, 0, 1410, 
	0, 1414, 0, 1418, 0, 1430, 0, 1434, 
	0, 1438, 0, 1442, 0, 1446, 0, 1450, 
	0, 1454, 0, 1458, 0, 1462, 0, 1466, 
	0, 1470, 0, 1474, 0, 1478, 0, 1482, 
	0, 1486, 0, 1490, 0, 1494, 0, 1498, 
	0, 1502, 0, 1506, 0, 1510, 0, 1514, 
	0, 1518, 0, 1522, 0, 1526, 0, 1530, 
	0, 1534, 0, 1538, 0, 1542, 0, 1546, 
	0, 1550, 0, 1554, 0, 1558, 0, 1562, 
	0, 1566, 0, 1570, 0, 1574, 0, 1578, 
	0, 1582, 0, 1586, 0, 1590, 0, 1594, 
	0, 1122, 1126, 0, 1122, 1130, 0, 1126, 
	1030, 0, 1206, 1082, 0, 1218, 1094, 0, 
	1222, 1098, 0, 1422, 1406, 0, 1426, 1410, 
	0, 1570, 1538, 0, 1578, 1546, 0, 1122, 
	1126, 1130, 0
};

static int pid_0_parser_commitLen[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	-7, -4, -4, -3, -3, -3, -3, -2, 
	-2, -2, -2, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0
};

static int pid_0_parser_tokenRegionInds[] = {
	1, 3, 5, 7, 9, 11, 13, 15, 
	17, 19, 21, 23, 25, 27, 29, 31, 
	33, 35, 37, 39, 41, 43, 45, 47, 
	49, 51, 53, 55, 58, 60, 62, 64, 
	66, 68, 70, 72, 74, 76, 78, 80, 
	82, 84, 86, 88, 90, 92, 94, 96, 
	98, 100, 102, 104, 106, 108, 110, 112, 
	114, 116, 118, 120, 122, 124, 126, 128, 
	130, 132, 134, 136, 138, 140, 142, 144, 
	146, 149, 151, 153, 155, 158, 160, 162, 
	164, 166, 168, 170, 173, 175, 177, 179, 
	181, 183, 185, 187, 189, 191, 193, 195, 
	197, 199, 201, 203, 205, 207, 209, 211, 
	213, 216, 219, 222, 225, 227, 229, 231, 
	233, 236, 239, 242, 245, 248, 251, 253, 
	256, 258, 260, 262, 265, 267, 270, 274, 
	278, 282, 284, 286, 288, 290, 292, 295, 
	297, 299, 301, 303, 305, 307, 309, 311, 
	313, 315, 317, 319, 321, 323, 325, 327, 
	329, 331, 333, 335, 337, 339, 341, 343, 
	345, 348, 350, 352, 354, 356, 358, 361, 
	363, 365, 367, 369, 371, 373, 375, 377, 
	379, 381, 383, 385, 387, 390, 392, 395, 
	398, 400, 402, 404, 407, 409, 412, 414, 
	416, 418, 420, 422, 424, 426, 428, 430, 
	432, 434, 436, 438, 440, 443, 446, 449, 
	451, 453, 455, 457, 460, 463, 465, 467, 
	469, 471, 473, 475, 477, 479, 481, 483, 
	485, 487, 489, 491, 493, 495, 497, 499, 
	501, 503, 505, 507, 509, 511, 514, 516, 
	518, 520, 522, 524, 526, 528, 530, 532, 
	534, 536, 539, 541, 543, 545, 548, 550, 
	552, 554, 557, 560, 562, 565, 568, 570, 
	572, 574, 576, 578, 580, 582, 584, 586, 
	588, 590, 592, 594, 596, 598, 600, 604, 
	606, 608, 610, 612, 614, 616, 618, 620, 
	622, 624, 626, 628, 630, 632, 634, 636, 
	638, 640, 643, 645, 647, 649, 652, 654, 
	656, 659, 662, 665, 667, 670, 673, 676, 
	679, 681, 683, 685, 687, 689, 692, 695, 
	697, 699, 701, 703, 705, 707, 709, 711, 
	713, 715, 717, 719, 721, 723, 725, 727, 
	729, 731, 733, 735, 737, 739, 741, 743, 
	745, 748, 750, 752, 755, 757, 759, 761, 
	763, 765, 768, 771, 773, 776, 779, 782, 
	785, 788, 790, 792, 794, 796, 799, 801, 
	803, 805, 807, 809, 811, 813, 815, 817, 
	819, 821, 823, 825, 827, 829, 832, 834, 
	836, 838, 841, 843, 845, 847, 849, 851, 
	854, 857, 859, 861, 863, 865, 867, 869, 
	871, 873, 875, 877, 879, 881, 883, 885, 
	887, 889, 892, 895, 898, 900, 902, 904, 
	906, 909, 912, 915, 918, 920, 923, 926, 
	928, 930, 932, 934, 936, 939, 942, 945, 
	948, 951, 954, 957, 960, 963, 966, 969, 
	973, 978, 983, 988, 990, 992, 994, 996, 
	998, 1000, 1002, 1004, 1006, 1008, 1010, 1012, 
	1014, 1016, 1018, 1020, 1023, 1026, 1028, 1030, 
	1032, 1034, 1036, 1038, 1040, 1043, 1045, 1047, 
	1049, 1051, 1053, 1055, 1057, 1059, 1061, 1063, 
	1065, 1067, 1070, 1072, 1074, 1076, 1078, 1080, 
	1082, 1084, 1086, 1088, 1090, 1092, 1094, 1097, 
	1100, 1103, 1106, 1109, 1111, 1113, 1115, 1117, 
	1119, 1121, 1123, 1126, 1129, 1132, 1135, 1138, 
	1141, 1144, 1147, 1149, 1151, 1153, 1155, 1157, 
	1159, 1162, 1165, 1168, 1170, 1172, 1174, 1176, 
	1179, 1181, 1184, 1187, 1189, 1191, 1193, 1195, 
	1197, 1199, 1201, 1203, 1205, 1207, 1209, 1211, 
	1213, 1215, 1217, 1219, 1221, 1225, 1229, 1233, 
	1235, 1237, 1239, 1242, 1244, 1246, 1248, 1250, 
	1253, 1255, 1257, 1259, 1261, 1264, 1266, 1268, 
	1270, 1272, 1274, 1276, 1278, 1280, 1282, 1284, 
	1286, 1288, 1290, 1292, 1294, 1297, 1300, 1303, 
	1305, 1307, 1309, 1311, 1314, 1317, 1319, 1321, 
	1324, 1326, 1328, 1330, 1332, 1335, 1338, 1341, 
	1344, 1346, 1348, 1351, 1354, 1357, 1360, 1362, 
	1364, 1366, 1368, 1370, 1372, 1375, 1377, 1379, 
	1381, 1384, 1386, 1388, 1390, 1393, 1396, 1399, 
	1402, 1405, 1407, 1409, 1411, 1413, 1415, 1417, 
	1419, 1421, 1423, 1425, 1428, 1431, 1434, 1437, 
	1439, 1441, 1443, 1445, 1447, 1449, 1452, 1454, 
	1456, 1459, 1461, 1463, 1465, 1467, 1469, 1471, 
	1473, 1475, 1477, 1479, 1481, 1483, 1486, 1489, 
	1491, 1493, 1496, 1499, 1502, 1504, 1506, 1508, 
	1510, 1512, 1515, 1518, 1521, 1524, 1526, 1528, 
	1530, 1532, 1534, 1536, 1540, 1544, 1546, 1548, 
	1551, 1554, 1556, 1558, 1560, 1562, 1564, 1566, 
	1568, 1570, 1573, 1576, 1578, 1580, 1582, 1584, 
	1586, 1589, 1592, 1594, 1596, 1598, 1600, 1602, 
	1604, 1606, 1608, 1610, 1612, 1614, 1616, 1618, 
	1621, 1624, 1627, 1630, 1632, 1634, 1636, 1638, 
	1640, 1642, 1644, 1646, 1648, 1650, 1652, 1654
};

static int pid_0_parser_tokenRegions[] = {
	0, 1, 0, 0, 0, 0, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	17, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 5, 0, 1, 0, 1, 
	0, 1, 0, 1, 5, 0, 5, 0, 
	9, 0, 13, 0, 1, 0, 1, 0, 
	1, 0, 1, 17, 0, 17, 0, 17, 
	0, 17, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 5, 0, 
	1, 5, 0, 1, 5, 0, 1, 5, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 5, 0, 1, 5, 0, 1, 
	5, 0, 1, 5, 0, 1, 5, 0, 
	1, 5, 0, 1, 0, 1, 5, 0, 
	1, 0, 1, 0, 1, 0, 1, 5, 
	0, 1, 0, 1, 5, 0, 1, 17, 
	25, 0, 1, 17, 25, 0, 1, 17, 
	25, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 5, 0, 5, 
	0, 9, 0, 13, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 9, 
	0, 1, 0, 5, 0, 5, 0, 5, 
	0, 1, 5, 0, 9, 0, 9, 0, 
	13, 0, 13, 0, 1, 0, 1, 5, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 5, 0, 1, 0, 
	1, 5, 0, 1, 5, 0, 1, 0, 
	1, 0, 1, 0, 1, 17, 0, 1, 
	0, 1, 17, 0, 1, 0, 17, 0, 
	17, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 5, 0, 1, 5, 0, 1, 5, 
	0, 5, 0, 9, 0, 13, 0, 1, 
	0, 1, 5, 0, 1, 5, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 25, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 5, 0, 5, 0, 5, 0, 
	1, 5, 0, 9, 0, 13, 0, 1, 
	0, 1, 5, 0, 1, 0, 1, 0, 
	1, 0, 1, 5, 0, 1, 5, 0, 
	1, 0, 1, 5, 0, 1, 5, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 17, 25, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 17, 0, 1, 0, 1, 0, 9, 
	0, 1, 17, 0, 5, 0, 5, 0, 
	1, 5, 0, 1, 5, 0, 1, 5, 
	0, 9, 0, 1, 5, 0, 1, 5, 
	0, 1, 5, 0, 1, 5, 0, 5, 
	0, 9, 0, 13, 0, 1, 0, 1, 
	0, 1, 5, 0, 1, 5, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 5, 0, 1, 0, 1, 0, 
	1, 17, 0, 1, 0, 1, 0, 17, 
	0, 17, 0, 17, 0, 1, 17, 0, 
	1, 17, 0, 17, 0, 1, 17, 0, 
	1, 17, 0, 1, 17, 0, 1, 17, 
	0, 1, 17, 0, 17, 0, 21, 0, 
	21, 0, 17, 0, 17, 1, 0, 17, 
	0, 17, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 5, 
	0, 5, 0, 5, 0, 1, 5, 0, 
	9, 0, 13, 0, 1, 0, 1, 5, 
	0, 1, 0, 5, 0, 9, 0, 13, 
	0, 1, 0, 1, 5, 0, 1, 5, 
	0, 1, 0, 1, 0, 1, 0, 25, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 5, 0, 5, 
	0, 1, 5, 0, 1, 5, 0, 1, 
	5, 0, 5, 0, 9, 0, 13, 0, 
	1, 0, 1, 5, 0, 1, 5, 0, 
	1, 5, 0, 1, 5, 0, 1, 0, 
	1, 5, 0, 1, 5, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 5, 0, 1, 5, 0, 1, 5, 
	0, 1, 5, 0, 1, 5, 0, 1, 
	5, 0, 1, 5, 0, 1, 5, 0, 
	1, 5, 0, 1, 5, 0, 1, 5, 
	0, 1, 17, 25, 0, 1, 17, 25, 
	5, 0, 1, 17, 25, 5, 0, 1, 
	17, 25, 5, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 5, 0, 1, 
	5, 0, 1, 0, 1, 0, 1, 0, 
	5, 0, 5, 0, 9, 0, 13, 0, 
	1, 5, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 17, 
	0, 17, 0, 1, 17, 0, 21, 0, 
	21, 0, 1, 0, 17, 0, 17, 0, 
	17, 0, 17, 0, 17, 0, 17, 0, 
	17, 0, 17, 0, 17, 0, 17, 1, 
	0, 17, 1, 0, 17, 1, 0, 17, 
	1, 0, 17, 1, 0, 17, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 5, 0, 1, 5, 
	0, 1, 5, 0, 1, 5, 0, 1, 
	5, 0, 1, 5, 0, 1, 5, 0, 
	1, 5, 0, 5, 0, 9, 0, 13, 
	0, 1, 0, 5, 0, 5, 0, 1, 
	5, 0, 1, 5, 0, 1, 5, 0, 
	1, 0, 5, 0, 9, 0, 13, 0, 
	1, 5, 0, 1, 0, 1, 5, 0, 
	1, 5, 0, 25, 0, 25, 0, 25, 
	0, 25, 0, 25, 0, 25, 0, 25, 
	0, 25, 0, 25, 0, 25, 0, 25, 
	0, 25, 0, 25, 0, 25, 0, 25, 
	0, 25, 0, 1, 0, 1, 17, 25, 
	0, 1, 17, 25, 0, 1, 17, 25, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	5, 0, 5, 0, 5, 0, 9, 0, 
	13, 0, 1, 5, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 5, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	5, 0, 9, 0, 13, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 5, 
	0, 1, 5, 0, 1, 5, 0, 1, 
	0, 1, 0, 1, 0, 17, 0, 1, 
	17, 0, 1, 17, 0, 21, 0, 21, 
	0, 1, 17, 0, 17, 0, 17, 0, 
	17, 0, 17, 0, 17, 1, 0, 17, 
	1, 0, 17, 1, 0, 17, 1, 0, 
	1, 0, 17, 0, 1, 17, 0, 1, 
	17, 0, 1, 17, 0, 1, 17, 0, 
	1, 0, 1, 0, 1, 0, 5, 0, 
	5, 0, 5, 0, 1, 5, 0, 9, 
	0, 13, 0, 1, 0, 1, 5, 0, 
	1, 0, 1, 0, 5, 0, 1, 5, 
	0, 1, 5, 0, 1, 5, 0, 1, 
	5, 0, 1, 5, 0, 25, 0, 25, 
	0, 25, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 5, 0, 1, 5, 0, 1, 
	5, 0, 1, 5, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 5, 0, 1, 0, 5, 0, 
	1, 5, 0, 9, 0, 13, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 21, 
	0, 1, 0, 1, 17, 0, 17, 1, 
	0, 5, 0, 5, 0, 1, 5, 0, 
	1, 5, 0, 1, 5, 0, 1, 0, 
	5, 0, 9, 0, 13, 0, 1, 0, 
	1, 5, 0, 1, 5, 0, 1, 5, 
	0, 1, 5, 0, 25, 0, 25, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 17, 25, 0, 1, 17, 25, 0, 
	1, 0, 1, 0, 1, 5, 0, 1, 
	5, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	21, 0, 1, 17, 0, 1, 17, 0, 
	1, 0, 5, 0, 5, 0, 9, 0, 
	13, 0, 1, 5, 0, 1, 5, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 17, 0, 1, 5, 0, 
	1, 5, 0, 1, 5, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 0
};

static int pid_0_parser_tokenPreRegions[] = {
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, 3, 0, 3, 0, 3, 0, 3, 
	3, 0, 3, 0, 3, 0, -1, 0, 
	3, 0, -1, 0, 3, 0, -1, 0, 
	-1, 0, 3, 0, 3, 0, 3, 0, 
	3, 0, -1, 0, 3, 0, 3, 0, 
	3, 0, 3, 0, -1, 0, -1, 0, 
	3, 0, 3, 0, 3, 0, -1, 0, 
	3, 0, 3, 0, 3, 0, 3, 0, 
	3, 0, 3, 0, 3, 0, 3, 0, 
	-1, 0, 3, 0, 3, 0, 3, 0, 
	3, 0, 3, 0, 3, 0, 3, 0, 
	3, 0, 3, 0, 3, 0, 3, 0, 
	3, 0, -1, -1, 0, 3, 0, 3, 
	0, 3, 0, -1, -1, 0, -1, 0, 
	-1, 0, -1, 0, 3, 0, 3, 0, 
	-1, 0, 3, 3, 0, 3, 0, -1, 
	0, 3, 0, 3, 0, -1, 0, 3, 
	0, -1, 0, 3, 0, 3, 0, 3, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, 3, 0, 3, 
	0, 3, 0, -1, 0, -1, -1, 0, 
	-1, -1, 0, -1, -1, 0, -1, -1, 
	0, 3, 0, 3, 0, 3, 0, 3, 
	0, -1, -1, 0, 3, 3, 0, -1, 
	-1, 0, 3, 3, 0, 3, 3, 0, 
	3, 3, 0, 3, 0, -1, -1, 0, 
	-1, 0, 3, 0, 3, 0, -1, -1, 
	0, -1, 0, -1, -1, 0, 3, 3, 
	3, 0, 3, 3, 3, 0, 3, 3, 
	3, 0, 3, 0, 3, 0, 3, 0, 
	3, 0, 3, 0, -1, -1, 0, -1, 
	0, -1, 0, -1, 0, 3, 0, -1, 
	0, -1, 0, 3, 0, -1, 0, -1, 
	0, 3, 0, -1, 0, 3, 0, -1, 
	0, -1, 0, 3, 0, 3, 0, -1, 
	0, -1, 0, -1, 0, 3, 0, -1, 
	0, 3, 0, -1, 0, -1, 0, -1, 
	0, -1, -1, 0, -1, 0, -1, 0, 
	-1, 0, -1, 0, -1, 0, -1, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, 3, 0, -1, 0, 3, 0, 3, 
	0, -1, 0, -1, -1, 0, -1, 0, 
	3, 3, 0, 3, 3, 0, 3, 0, 
	3, 0, -1, 0, -1, -1, 0, 3, 
	0, -1, -1, 0, 3, 0, 19, 0, 
	19, 0, -1, 0, -1, 0, -1, 0, 
	-1, 0, 3, 0, -1, 0, -1, 0, 
	-1, 0, -1, 0, -1, 0, -1, 0, 
	-1, -1, 0, -1, -1, 0, -1, -1, 
	0, -1, 0, -1, 0, -1, 0, 3, 
	0, -1, -1, 0, -1, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, 3, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	-1, 0, 3, 0, 3, 0, 3, 0, 
	3, 0, 3, 0, 3, 0, 3, 0, 
	3, 0, -1, 0, -1, 0, -1, 0, 
	-1, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, -1, 0, -1, 0, -1, 0, 
	-1, 0, -1, -1, 0, -1, -1, 0, 
	3, 0, -1, -1, 0, -1, -1, 0, 
	-1, 0, 3, 0, 3, 0, 3, 0, 
	-1, 0, 3, 0, 3, 0, 3, 0, 
	3, 0, 3, 0, 3, 0, 3, 0, 
	3, 0, 3, 0, 3, 0, 3, 0, 
	3, 3, 3, 0, 3, 0, -1, 0, 
	3, 0, -1, 0, -1, 0, -1, 0, 
	-1, 0, -1, 0, -1, 0, -1, 0, 
	-1, 0, 3, 0, -1, 0, -1, 0, 
	3, 0, 3, 0, -1, 0, -1, 0, 
	3, 3, 0, -1, 0, 3, 0, -1, 
	0, -1, -1, 0, -1, 0, -1, 0, 
	-1, -1, 0, -1, -1, 0, -1, -1, 
	0, -1, 0, -1, -1, 0, -1, -1, 
	0, -1, -1, 0, -1, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, 3, 
	0, -1, -1, 0, 3, 3, 0, 3, 
	0, 3, 0, 3, 0, 3, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, 3, 
	0, 3, 3, 0, -1, 0, -1, 0, 
	-1, -1, 0, -1, 0, 3, 0, -1, 
	0, -1, 0, -1, 0, -1, -1, 0, 
	-1, -1, 0, 19, 0, -1, -1, 0, 
	19, 19, 0, 19, 19, 0, 19, 19, 
	0, 19, 19, 0, -1, 0, -1, 0, 
	-1, 0, 19, 0, -1, -1, 0, -1, 
	0, -1, 0, 3, 0, 3, 0, 3, 
	0, -1, 0, 3, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, -1, 0, 
	-1, 0, -1, 0, -1, 0, -1, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, 3, 0, -1, -1, 0, -1, -1, 
	0, -1, 0, 3, 0, -1, 0, -1, 
	0, 3, 0, 3, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, -1, 0, -1, -1, 0, -1, 
	-1, 0, -1, 0, -1, 0, -1, 0, 
	-1, 0, -1, -1, 0, 3, 3, 0, 
	3, 3, 0, -1, -1, 0, -1, 0, 
	-1, -1, 0, -1, -1, 0, -1, 0, 
	-1, 0, -1, 0, 3, 0, 3, 0, 
	-1, -1, 0, -1, -1, 0, -1, -1, 
	0, -1, -1, 0, -1, -1, 0, -1, 
	-1, 0, -1, -1, 0, -1, -1, 0, 
	-1, -1, 0, -1, -1, 0, -1, -1, 
	0, -1, -1, -1, 0, 3, 3, 3, 
	3, 0, 3, 3, 3, 3, 0, 3, 
	3, 3, 3, 0, -1, 0, -1, 0, 
	-1, 0, -1, 0, 3, 0, 3, 0, 
	-1, 0, 3, 0, -1, 0, -1, 0, 
	3, 0, -1, 0, 3, 0, -1, 0, 
	-1, 0, -1, 0, 3, 3, 0, 3, 
	3, 0, -1, 0, 3, 0, -1, 0, 
	-1, 0, -1, 0, -1, 0, -1, 0, 
	-1, -1, 0, -1, 0, 3, 0, -1, 
	0, 3, 0, 3, 0, 3, 0, 3, 
	0, -1, 0, -1, 0, 3, 0, 19, 
	0, -1, 0, -1, -1, 0, -1, 0, 
	-1, 0, 19, 0, 19, 0, 19, 0, 
	19, 0, 19, 0, -1, 0, 19, 0, 
	19, 0, 19, 0, 19, 0, 19, 19, 
	0, 19, 19, 0, 19, 19, 0, 19, 
	19, 0, 3, 3, 0, 19, 0, 19, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, -1, 0, -1, -1, 
	0, -1, -1, 0, -1, -1, 0, -1, 
	-1, 0, -1, -1, 0, -1, -1, 0, 
	-1, -1, 0, -1, 0, -1, 0, -1, 
	0, 3, 0, -1, 0, -1, 0, -1, 
	-1, 0, -1, -1, 0, -1, -1, 0, 
	3, 0, -1, 0, -1, 0, -1, 0, 
	-1, -1, 0, -1, 0, -1, -1, 0, 
	3, 3, 0, 3, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, 3, 0, 3, 3, 3, 
	0, 3, 3, 3, 0, 3, 3, 3, 
	0, 3, 0, 3, 0, 3, 0, 3, 
	3, 0, -1, 0, -1, 0, -1, 0, 
	-1, 0, -1, -1, 0, 3, 0, -1, 
	0, -1, 0, -1, 0, 3, 3, 0, 
	3, 0, 3, 0, 3, 0, -1, 0, 
	-1, 0, -1, 0, -1, 0, -1, 0, 
	-1, 0, -1, 0, -1, 0, 3, 0, 
	-1, 0, 3, 0, 3, 0, -1, -1, 
	0, -1, -1, 0, -1, -1, 0, -1, 
	0, -1, 0, 3, 0, -1, 0, 19, 
	19, 0, -1, -1, 0, -1, 0, -1, 
	0, -1, -1, 0, -1, 0, -1, 0, 
	-1, 0, -1, 0, -1, -1, 0, -1, 
	-1, 0, -1, -1, 0, -1, -1, 0, 
	19, 0, 3, 0, -1, -1, 0, 19, 
	19, 0, 19, 19, 0, 19, 19, 0, 
	3, 0, -1, 0, 3, 0, -1, 0, 
	-1, 0, -1, 0, -1, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, -1, 0, 
	-1, 0, -1, 0, -1, 0, -1, -1, 
	0, -1, -1, 0, -1, -1, 0, 3, 
	3, 0, 3, 3, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, -1, 0, -1, -1, 0, -1, 
	-1, 0, -1, -1, 0, -1, 0, -1, 
	0, -1, 0, 3, 0, 3, 0, -1, 
	0, 3, 3, 0, -1, 0, -1, 0, 
	-1, -1, 0, -1, 0, -1, 0, -1, 
	0, 3, 0, -1, 0, 3, 0, -1, 
	0, 3, 0, -1, 0, 19, 0, -1, 
	0, 19, 0, 3, 3, 0, 3, 3, 
	0, -1, 0, -1, 0, -1, -1, 0, 
	-1, -1, 0, -1, -1, 0, -1, 0, 
	-1, 0, -1, 0, -1, 0, -1, 0, 
	-1, -1, 0, 3, 3, 0, -1, -1, 
	0, -1, -1, 0, -1, 0, -1, 0, 
	-1, 0, -1, 0, 3, 0, -1, 0, 
	3, 3, 3, 0, 3, 3, 3, 0, 
	3, 0, -1, 0, -1, -1, 0, -1, 
	-1, 0, 3, 0, 3, 0, 3, 0, 
	-1, 0, 3, 0, -1, 0, -1, 0, 
	-1, 0, 3, 3, 0, 3, 3, 0, 
	19, 0, -1, 0, -1, 0, -1, 0, 
	-1, 0, 3, 3, 0, -1, -1, 0, 
	-1, 0, 3, 0, -1, 0, 3, 0, 
	-1, 0, 3, 0, 3, 0, -1, 0, 
	3, 0, 3, 0, 3, 0, -1, 0, 
	3, 0, 3, 3, 0, -1, -1, 0, 
	-1, -1, 0, -1, -1, 0, -1, 0, 
	3, 0, 3, 0, -1, 0, 3, 0, 
	-1, 0, -1, 0, -1, 0, 3, 0, 
	-1, 0, 3, 0, 3, 0, 0
};

static struct pda_tables pid_0_pdaTables =
{
	pid_0_parser_indicies,
	pid_0_parser_owners,
	pid_0_parser_keys,
	pid_0_parser_offsets,
	pid_0_parser_targs,
	pid_0_parser_actInds,
	pid_0_parser_actions,
	pid_0_parser_commitLen,
	pid_0_parser_tokenRegionInds,
	pid_0_parser_tokenRegions,
	pid_0_parser_tokenPreRegions,

	80844,
	1472,
	736,
	1165,
	1165,
	2379,
	1165,
	1655,
	1655
};

static struct local_info locals_0[] = {
	{ 1, -1 }, { 1, -2 }
};

static unsigned char copy_0[] = {
	0, 0
};

static unsigned char copy_1[] = {
	0, 0
};

static unsigned char copy_2[] = {
	0, 0
};

static unsigned char copy_3[] = {
	0, 0
};

static unsigned char copy_4[] = {
	0, 0
};

static unsigned char copy_5[] = {
	0, 0
};

static unsigned char copy_6[] = {
	0, 0
};

static unsigned char copy_7[] = {
	0, 0
};

static unsigned char copy_8[] = {
	0, 0
};

static unsigned char copy_9[] = {
	0, 0
};

static unsigned char copy_10[] = {
	0, 0
};

static unsigned char copy_11[] = {
	0, 0
};

static unsigned char copy_12[] = {
	0, 0
};

static unsigned char copy_13[] = {
	0, 0
};

static unsigned char copy_14[] = {
	0, 0
};

static unsigned char copy_15[] = {
	0, 0
};

static unsigned char copy_16[] = {
	0, 0
};

static unsigned char copy_17[] = {
	0, 0
};

static unsigned char copy_18[] = {
	0, 0
};

static unsigned char copy_19[] = {
	0, 0
};

static unsigned char copy_20[] = {
	0, 0
};

static unsigned char copy_21[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_22[] = {
	0, 0, 0, 1
};

static unsigned char copy_23[] = {
	0, 0
};

static unsigned char copy_24[] = {
	0, 0
};

static unsigned char copy_25[] = {
	0, 0
};

static unsigned char copy_26[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_27[] = {
	0, 0
};

static unsigned char copy_28[] = {
	0, 0, 0, 1
};

static unsigned char copy_29[] = {
	0, 0, 0, 1
};

static unsigned char copy_30[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_31[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_32[] = {
	0, 0
};

static unsigned char copy_33[] = {
	0, 0
};

static unsigned char copy_34[] = {
	0, 0
};

static unsigned char copy_35[] = {
	0, 0
};

static unsigned char copy_36[] = {
	0, 0
};

static unsigned char copy_37[] = {
	0, 0
};

static unsigned char copy_38[] = {
	0, 0
};

static unsigned char copy_39[] = {
	0, 0
};

static unsigned char copy_40[] = {
	0, 0
};

static unsigned char copy_41[] = {
	0, 0
};

static unsigned char copy_42[] = {
	0, 0
};

static unsigned char copy_43[] = {
	0, 0
};

static unsigned char copy_44[] = {
	0, 0
};

static unsigned char copy_45[] = {
	0, 0
};

static unsigned char copy_46[] = {
	0, 0
};

static unsigned char copy_47[] = {
	0, 0
};

static unsigned char copy_48[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_49[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_50[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 0, 7
};

static unsigned char copy_51[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_52[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_53[] = {
	0, 0
};

static unsigned char copy_54[] = {
	0, 0
};

static unsigned char copy_56[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_57[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_58[] = {
	0, 0
};

static unsigned char copy_60[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 0, 7, 
	0, 8
};

static unsigned char copy_61[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 0, 7
};

static unsigned char copy_62[] = {
	0, 0
};

static unsigned char copy_63[] = {
	0, 0
};

static unsigned char copy_64[] = {
	0, 0
};

static unsigned char copy_65[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_66[] = {
	0, 0, 0, 1
};

static unsigned char copy_67[] = {
	0, 0, 0, 1
};

static unsigned char copy_68[] = {
	0, 0
};

static unsigned char copy_69[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_70[] = {
	0, 0, 0, 1
};

static unsigned char copy_72[] = {
	0, 0, 0, 1
};

static unsigned char copy_74[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_75[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_76[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4, 0, 5
};

static unsigned char copy_77[] = {
	0, 0
};

static unsigned char copy_78[] = {
	0, 0
};

static unsigned char copy_79[] = {
	0, 0
};

static unsigned char copy_80[] = {
	0, 0
};

static unsigned char copy_81[] = {
	0, 0
};

static unsigned char copy_82[] = {
	0, 0
};

static unsigned char copy_83[] = {
	0, 0
};

static unsigned char copy_84[] = {
	0, 0
};

static unsigned char copy_85[] = {
	0, 0
};

static unsigned char copy_86[] = {
	0, 0
};

static unsigned char copy_87[] = {
	0, 0
};

static unsigned char copy_88[] = {
	0, 0
};

static unsigned char copy_89[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_90[] = {
	0, 0
};

static unsigned char copy_91[] = {
	0, 0
};

static unsigned char copy_92[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_93[] = {
	0, 0
};

static unsigned char copy_94[] = {
	0, 0
};

static unsigned char copy_95[] = {
	0, 0
};

static unsigned char copy_96[] = {
	0, 0
};

static unsigned char copy_97[] = {
	0, 0
};

static unsigned char copy_98[] = {
	0, 0
};

static unsigned char copy_99[] = {
	0, 0
};

static unsigned char copy_100[] = {
	0, 0
};

static unsigned char copy_101[] = {
	0, 0
};

static unsigned char copy_102[] = {
	0, 0
};

static unsigned char copy_103[] = {
	0, 0
};

static unsigned char copy_104[] = {
	0, 0
};

static unsigned char copy_105[] = {
	0, 0
};

static unsigned char copy_106[] = {
	0, 0
};

static unsigned char copy_107[] = {
	0, 0
};

static unsigned char copy_108[] = {
	0, 0
};

static unsigned char copy_109[] = {
	0, 0
};

static unsigned char copy_111[] = {
	0, 0
};

static unsigned char copy_113[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_114[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_115[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_116[] = {
	0, 0
};

static unsigned char copy_118[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 0, 7, 
	0, 8
};

static unsigned char copy_119[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_120[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_122[] = {
	0, 0
};

static unsigned char copy_124[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_125[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_126[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_127[] = {
	0, 0, 0, 1
};

static unsigned char copy_129[] = {
	0, 0, 0, 1
};

static unsigned char copy_131[] = {
	0, 0
};

static unsigned char copy_133[] = {
	0, 0, 0, 1
};

static unsigned char copy_135[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4, 0, 5
};

static unsigned char copy_136[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_138[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_139[] = {
	0, 0
};

static unsigned char copy_140[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_141[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_142[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_143[] = {
	0, 0, 0, 1
};

static unsigned char copy_144[] = {
	0, 0, 0, 1
};

static unsigned char copy_145[] = {
	0, 0
};

static unsigned char copy_146[] = {
	0, 0
};

static unsigned char copy_147[] = {
	0, 0
};

static unsigned char copy_148[] = {
	0, 0, 0, 1
};

static unsigned char copy_149[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4, 0, 5, 0, 6
};

static unsigned char copy_150[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_151[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_152[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_153[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_154[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_155[] = {
	0, 0, 0, 1
};

static unsigned char copy_156[] = {
	0, 0, 0, 1
};

static unsigned char copy_157[] = {
	0, 0
};

static unsigned char copy_158[] = {
	0, 0
};

static unsigned char copy_159[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_160[] = {
	0, 0
};

static unsigned char copy_161[] = {
	0, 0, 0, 1
};

static unsigned char copy_162[] = {
	0, 0, 0, 1
};

static unsigned char copy_163[] = {
	0, 0
};

static unsigned char copy_164[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_165[] = {
	0, 0, 0, 1
};

static unsigned char copy_167[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_168[] = {
	0, 0
};

static unsigned char copy_169[] = {
	0, 0
};

static unsigned char copy_171[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_172[] = {
	0, 0, 0, 1
};

static unsigned char copy_173[] = {
	0, 0, 0, 1
};

static unsigned char copy_174[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_175[] = {
	0, 0
};

static unsigned char copy_176[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_177[] = {
	0, 0, 0, 1
};

static unsigned char copy_179[] = {
	0, 0, 0, 1
};

static unsigned char copy_180[] = {
	0, 0, 0, 1
};

static unsigned char copy_182[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_183[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_184[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4, 0, 5
};

static unsigned char copy_185[] = {
	0, 0, 0, 1
};

static unsigned char copy_186[] = {
	0, 0
};

static unsigned char copy_187[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_188[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_189[] = {
	0, 0
};

static unsigned char copy_190[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_191[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_192[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_193[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_194[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_195[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_196[] = {
	0, 0
};

static unsigned char copy_197[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_198[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_199[] = {
	0, 0
};

static unsigned char copy_200[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_201[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_202[] = {
	0, 0
};

static unsigned char copy_203[] = {
	0, 0, 0, 1
};

static unsigned char copy_204[] = {
	0, 0, 0, 1
};

static unsigned char copy_205[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_206[] = {
	0, 0, 0, 1
};

static unsigned char copy_207[] = {
	0, 0, 0, 1
};

static unsigned char copy_208[] = {
	0, 0
};

static unsigned char copy_209[] = {
	0, 0
};

static unsigned char copy_210[] = {
	0, 0
};

static unsigned char copy_212[] = {
	0, 0
};

static unsigned char copy_213[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_214[] = {
	0, 0
};

static unsigned char copy_215[] = {
	0, 0
};

static unsigned char copy_216[] = {
	0, 0
};

static unsigned char copy_217[] = {
	0, 0
};

static unsigned char copy_218[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_219[] = {
	0, 0
};

static unsigned char copy_220[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_221[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_222[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_223[] = {
	0, 0
};

static unsigned char copy_224[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_225[] = {
	0, 0
};

static unsigned char copy_226[] = {
	0, 0
};

static unsigned char copy_227[] = {
	0, 0
};

static unsigned char copy_228[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_229[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_230[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4, 0, 5
};

static unsigned char copy_231[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_232[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4, 0, 5
};

static unsigned char copy_233[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_235[] = {
	0, 0
};

static unsigned char copy_236[] = {
	0, 0
};

static unsigned char copy_237[] = {
	0, 0
};

static unsigned char copy_239[] = {
	0, 0, 0, 1
};

static unsigned char copy_241[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_243[] = {
	0, 0
};

static unsigned char copy_244[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_245[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_246[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_247[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_248[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_249[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_250[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_251[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_252[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_253[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_254[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_255[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4, 0, 5
};

static unsigned char copy_256[] = {
	0, 0, 0, 1
};

static unsigned char copy_258[] = {
	0, 0
};

static unsigned char copy_259[] = {
	0, 0
};

static unsigned char copy_260[] = {
	0, 0
};

static unsigned char copy_261[] = {
	0, 0
};

static unsigned char copy_262[] = {
	0, 0
};

static unsigned char copy_264[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_265[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_266[] = {
	0, 0, 0, 1
};

static unsigned char copy_267[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_268[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_269[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_270[] = {
	0, 0
};

static unsigned char copy_271[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_272[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_273[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_274[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_275[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_276[] = {
	0, 0
};

static unsigned char copy_277[] = {
	0, 0
};

static unsigned char copy_278[] = {
	0, 0
};

static unsigned char copy_284[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_285[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_286[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_287[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_288[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_289[] = {
	0, 0
};

static unsigned char copy_290[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_291[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_292[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_293[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_294[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_295[] = {
	0, 0
};

static unsigned char copy_296[] = {
	0, 0
};

static unsigned char copy_297[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_298[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_299[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_300[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_301[] = {
	0, 0
};

static unsigned char copy_302[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_303[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_304[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_305[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_306[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_307[] = {
	0, 0, 0, 1
};

static unsigned char copy_308[] = {
	0, 0
};

static unsigned char copy_309[] = {
	0, 0
};

static unsigned char copy_310[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_311[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_312[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_313[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_314[] = {
	0, 0
};

static unsigned char copy_315[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_316[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_317[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_318[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_319[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_320[] = {
	0, 0
};

static unsigned char copy_321[] = {
	0, 0
};

static unsigned char copy_322[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_323[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_324[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_326[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_327[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_328[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_329[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_330[] = {
	0, 0
};

static unsigned char copy_331[] = {
	0, 0
};

static unsigned char copy_333[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_334[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_335[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_336[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_337[] = {
	0, 0
};

static unsigned char copy_338[] = {
	0, 0, 0, 1
};

static unsigned char copy_339[] = {
	0, 0, 0, 1
};

static unsigned char copy_340[] = {
	0, 0, 0, 1
};

static unsigned char copy_341[] = {
	0, 0, 0, 1
};

static unsigned char copy_342[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_343[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_344[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_345[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4, 0, 5
};

static unsigned char copy_346[] = {
	0, 0
};

static unsigned char copy_347[] = {
	0, 0, 0, 1
};

static unsigned char copy_348[] = {
	0, 0
};

static unsigned char copy_349[] = {
	0, 0
};

static unsigned char copy_350[] = {
	0, 0
};

static unsigned char copy_351[] = {
	0, 0
};

static unsigned char copy_352[] = {
	0, 0
};

static unsigned char copy_353[] = {
	0, 0
};

static unsigned char copy_354[] = {
	0, 0
};

static unsigned char copy_355[] = {
	0, 0
};

static unsigned char copy_356[] = {
	0, 0
};

static unsigned char copy_357[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_358[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_359[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_360[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_361[] = {
	0, 0, 0, 1
};

static unsigned char copy_363[] = {
	0, 0
};

static unsigned char copy_364[] = {
	0, 0, 0, 1, 0, 2
};

static code_t parser_rootCode[] = {
	255, 8, 4, 0, 255, 7, 3, 0, 
	255, 62, 2, 0, 85, 147, 3, 0, 
	255, 52, 3, 0, 39, 255, 255, 241, 
	1, 0, 0, 0, 37, 255, 255, 2, 
	1, 0, 0, 0, 0, 0, 0, 0, 
	180, 144, 162, 135, 162, 31, 91, 1, 
	0, 226, 91, 0, 0, 242, 39, 254, 
	255, 29, 37, 254, 255, 87, 251, 0, 
	0, 85, 204, 87, 251, 1, 0, 255, 
	10
};

static struct lang_el_info parser_lelInfo[] = {
	{ "__UNUSED",  "__UNUSED", 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 0, 0 },
	{ "ptr",  "ptr", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "str",  "str", 0, 0, 0, 0, -1, 292, 0, 0, 0, -1, 0, 0 },
	{ "il",  "il", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "DEF",  "DEF", 0, 0, 0, 0, -1, 5, 0, 0, 0, -1, 0, 0 },
	{ "LEX",  "LEX", 0, 0, 0, 0, -1, 6, 0, 0, 0, -1, 0, 0 },
	{ "END",  "END", 0, 0, 0, 0, -1, 7, 0, 0, 0, -1, 0, 0 },
	{ "TOKEN",  "TOKEN", 0, 0, 0, 0, -1, 8, 0, 0, 0, -1, 0, 0 },
	{ "RL",  "RL", 0, 0, 0, 0, -1, 9, 0, 0, 0, -1, 0, 0 },
	{ "IGNORE",  "IGNORE", 0, 0, 0, 0, -1, 10, 0, 0, 0, -1, 0, 0 },
	{ "PRINT",  "PRINT", 0, 0, 0, 0, -1, 11, 0, 0, 0, -1, 0, 0 },
	{ "PRINTS",  "PRINTS", 0, 0, 0, 0, -1, 12, 0, 0, 0, -1, 0, 0 },
	{ "PARSE",  "PARSE", 0, 0, 0, 0, -1, 13, 0, 0, 0, -1, 0, 0 },
	{ "REDUCE",  "REDUCE", 0, 0, 0, 0, -1, 14, 0, 0, 0, -1, 0, 0 },
	{ "READ_REDUCE",  "READ_REDUCE", 0, 0, 0, 0, -1, 15, 0, 0, 0, -1, 0, 0 },
	{ "PARSE_TREE",  "PARSE_TREE", 0, 0, 0, 0, -1, 16, 0, 0, 0, -1, 0, 0 },
	{ "PARSE_STOP",  "PARSE_STOP", 0, 0, 0, 0, -1, 17, 0, 0, 0, -1, 0, 0 },
	{ "CONS",  "CONS", 0, 0, 0, 0, -1, 18, 0, 0, 0, -1, 0, 0 },
	{ "MATCH",  "MATCH", 0, 0, 0, 0, -1, 19, 0, 0, 0, -1, 0, 0 },
	{ "REQUIRE",  "REQUIRE", 0, 0, 0, 0, -1, 20, 0, 0, 0, -1, 0, 0 },
	{ "SEND",  "SEND", 0, 0, 0, 0, -1, 21, 0, 0, 0, -1, 0, 0 },
	{ "SEND_TREE",  "SEND_TREE", 0, 0, 0, 0, -1, 22, 0, 0, 0, -1, 0, 0 },
	{ "NAMESPACE",  "NAMESPACE", 0, 0, 0, 0, -1, 23, 0, 0, 0, -1, 0, 0 },
	{ "REDUCTION",  "REDUCTION", 0, 0, 0, 0, -1, 24, 0, 0, 0, -1, 0, 0 },
	{ "FOR",  "FOR", 0, 0, 0, 0, -1, 25, 0, 0, 0, -1, 0, 0 },
	{ "IF",  "IF", 0, 0, 0, 0, -1, 26, 0, 0, 0, -1, 0, 0 },
	{ "YIELD",  "YIELD", 0, 0, 0, 0, -1, 27, 0, 0, 0, -1, 0, 0 },
	{ "WHILE",  "WHILE", 0, 0, 0, 0, -1, 28, 0, 0, 0, -1, 0, 0 },
	{ "ELSIF",  "ELSIF", 0, 0, 0, 0, -1, 29, 0, 0, 0, -1, 0, 0 },
	{ "ELSE",  "ELSE", 0, 0, 0, 0, -1, 30, 0, 0, 0, -1, 0, 0 },
	{ "IN",  "IN", 0, 0, 0, 0, -1, 31, 0, 0, 0, -1, 0, 0 },
	{ "PARSER",  "PARSER", 0, 0, 0, 0, -1, 32, 0, 0, 0, -1, 0, 0 },
	{ "LIST",  "LIST", 0, 0, 0, 0, -1, 33, 0, 0, 0, -1, 0, 0 },
	{ "LIST_EL",  "LIST_EL", 0, 0, 0, 0, -1, 34, 0, 0, 0, -1, 0, 0 },
	{ "MAP",  "MAP", 0, 0, 0, 0, -1, 35, 0, 0, 0, -1, 0, 0 },
	{ "MAP_EL",  "MAP_EL", 0, 0, 0, 0, -1, 36, 0, 0, 0, -1, 0, 0 },
	{ "PTR",  "PTR", 0, 0, 0, 0, -1, 37, 0, 0, 0, -1, 0, 0 },
	{ "ITER",  "ITER", 0, 0, 0, 0, -1, 38, 0, 0, 0, -1, 0, 0 },
	{ "REF",  "REF", 0, 0, 0, 0, -1, 39, 0, 0, 0, -1, 0, 0 },
	{ "EXPORT",  "EXPORT", 0, 0, 0, 0, -1, 40, 0, 0, 0, -1, 0, 0 },
	{ "RETURN",  "RETURN", 0, 0, 0, 0, -1, 41, 0, 0, 0, -1, 0, 0 },
	{ "BREAK",  "BREAK", 0, 0, 0, 0, -1, 42, 0, 0, 0, -1, 0, 0 },
	{ "REJECT",  "REJECT", 0, 0, 0, 0, -1, 43, 0, 0, 0, -1, 0, 0 },
	{ "REDUCEFIRST",  "REDUCEFIRST", 0, 0, 0, 0, -1, 44, 0, 0, 0, -1, 0, 0 },
	{ "ALIAS",  "ALIAS", 0, 0, 0, 0, -1, 45, 0, 0, 0, -1, 0, 0 },
	{ "COMMIT",  "COMMIT", 0, 0, 0, 0, -1, 46, 0, 0, 0, -1, 0, 0 },
	{ "NEW",  "NEW", 0, 0, 0, 0, -1, 47, 0, 0, 0, -1, 0, 0 },
	{ "PREEOF",  "PREEOF", 0, 0, 0, 0, -1, 48, 0, 0, 0, -1, 0, 0 },
	{ "GLOBAL",  "GLOBAL", 0, 0, 0, 0, -1, 49, 0, 0, 0, -1, 0, 0 },
	{ "EOS",  "EOS", 0, 0, 0, 0, -1, 50, 0, 0, 0, -1, 0, 0 },
	{ "CAST",  "CAST", 0, 0, 0, 0, -1, 51, 0, 0, 0, -1, 0, 0 },
	{ "SWITCH",  "SWITCH", 0, 0, 0, 0, -1, 52, 0, 0, 0, -1, 0, 0 },
	{ "CASE",  "CASE", 0, 0, 0, 0, -1, 53, 0, 0, 0, -1, 0, 0 },
	{ "DEFAULT",  "DEFAULT", 0, 0, 0, 0, -1, 54, 0, 0, 0, -1, 0, 0 },
	{ "INT",  "INT", 0, 0, 0, 0, -1, 55, 0, 0, 0, -1, 0, 0 },
	{ "BOOL",  "BOOL", 0, 0, 0, 0, -1, 56, 0, 0, 0, -1, 0, 0 },
	{ "VOID",  "VOID", 0, 0, 0, 0, -1, 57, 0, 0, 0, -1, 0, 0 },
	{ "MAKE_TOKEN",  "MAKE_TOKEN", 0, 0, 0, 0, -1, 58, 0, 0, 0, -1, 0, 0 },
	{ "MAKE_TREE",  "MAKE_TREE", 0, 0, 0, 0, -1, 59, 0, 0, 0, -1, 0, 0 },
	{ "TYPEID",  "TYPEID", 0, 0, 0, 0, -1, 60, 0, 0, 0, -1, 0, 0 },
	{ "LITERAL",  "LITERAL", 0, 0, 0, 0, -1, 61, 0, 0, 0, -1, 0, 0 },
	{ "CONTEXT",  "CONTEXT", 0, 0, 0, 0, -1, 62, 0, 0, 0, -1, 0, 0 },
	{ "STRUCT",  "STRUCT", 0, 0, 0, 0, -1, 63, 0, 0, 0, -1, 0, 0 },
	{ "NI",  "NI", 0, 0, 0, 0, -1, 64, 0, 0, 0, -1, 0, 0 },
	{ "NIL",  "NIL", 0, 0, 0, 0, -1, 65, 0, 0, 0, -1, 0, 0 },
	{ "TRUE",  "TRUE", 0, 0, 0, 0, -1, 66, 0, 0, 0, -1, 0, 0 },
	{ "FALSE",  "FALSE", 0, 0, 0, 0, -1, 67, 0, 0, 0, -1, 0, 0 },
	{ "LEFT",  "LEFT", 0, 0, 0, 0, -1, 68, 0, 0, 0, -1, 0, 0 },
	{ "RIGHT",  "RIGHT", 0, 0, 0, 0, -1, 69, 0, 0, 0, -1, 0, 0 },
	{ "NONASSOC",  "NONASSOC", 0, 0, 0, 0, -1, 70, 0, 0, 0, -1, 0, 0 },
	{ "INCLUDE",  "INCLUDE", 0, 0, 0, 0, -1, 71, 0, 0, 0, -1, 0, 0 },
	{ "id",  "id", 0, 0, 0, 0, -1, 72, 0, 0, 0, -1, 0, 0 },
	{ "number",  "number", 0, 0, 0, 0, -1, 73, 0, 0, 0, -1, 0, 0 },
	{ "backtick_lit",  "backtick_lit", 0, 0, 0, 0, -1, 74, 0, 0, 0, -1, 0, 0 },
	{ "DQ",  "DQ", 0, 0, 0, 0, -1, 75, 0, 0, 0, -1, 0, 0 },
	{ "SQ",  "SQ", 0, 0, 0, 0, -1, 76, 0, 0, 0, -1, 0, 0 },
	{ "TILDE",  "TILDE", 0, 0, 0, 0, -1, 77, 0, 0, 0, -1, 0, 0 },
	{ "SQOPEN",  "SQOPEN", 0, 0, 0, 0, -1, 78, 0, 0, 0, -1, 0, 0 },
	{ "SQCLOSE",  "SQCLOSE", 0, 0, 0, 0, -1, 79, 0, 0, 0, -1, 0, 0 },
	{ "BAR",  "BAR", 0, 0, 0, 0, -1, 80, 0, 0, 0, -1, 0, 0 },
	{ "FSLASH",  "FSLASH", 0, 0, 0, 0, -1, 81, 0, 0, 0, -1, 0, 0 },
	{ "COLON",  "COLON", 0, 0, 0, 0, -1, 82, 0, 0, 0, -1, 0, 0 },
	{ "DOUBLE_COLON",  "DOUBLE_COLON", 0, 0, 0, 0, -1, 83, 0, 0, 0, -1, 0, 0 },
	{ "DOT",  "DOT", 0, 0, 0, 0, -1, 84, 0, 0, 0, -1, 0, 0 },
	{ "ARROW",  "ARROW", 0, 0, 0, 0, -1, 85, 0, 0, 0, -1, 0, 0 },
	{ "POPEN",  "POPEN", 0, 0, 0, 0, -1, 86, 0, 0, 0, -1, 0, 0 },
	{ "PCLOSE",  "PCLOSE", 0, 0, 0, 0, -1, 87, 0, 0, 0, -1, 0, 0 },
	{ "COPEN",  "COPEN", 0, 0, 0, 0, -1, 88, 0, 0, 0, -1, 0, 0 },
	{ "CCLOSE",  "CCLOSE", 0, 0, 0, 0, -1, 89, 0, 0, 0, -1, 0, 0 },
	{ "STAR",  "STAR", 0, 0, 0, 0, -1, 90, 0, 0, 0, -1, 0, 0 },
	{ "QUESTION",  "QUESTION", 0, 0, 0, 0, -1, 91, 0, 0, 0, -1, 0, 0 },
	{ "EQUALS",  "EQUALS", 0, 0, 0, 0, -1, 92, 0, 0, 0, -1, 0, 0 },
	{ "EQEQ",  "EQEQ", 0, 0, 0, 0, -1, 93, 0, 0, 0, -1, 0, 0 },
	{ "NEQ",  "NEQ", 0, 0, 0, 0, -1, 94, 0, 0, 0, -1, 0, 0 },
	{ "COMMA",  "COMMA", 0, 0, 0, 0, -1, 95, 0, 0, 0, -1, 0, 0 },
	{ "LT",  "LT", 0, 0, 0, 0, -1, 96, 0, 0, 0, -1, 0, 0 },
	{ "GT",  "GT", 0, 0, 0, 0, -1, 97, 0, 0, 0, -1, 0, 0 },
	{ "LTEQ",  "LTEQ", 0, 0, 0, 0, -1, 98, 0, 0, 0, -1, 0, 0 },
	{ "GTEQ",  "GTEQ", 0, 0, 0, 0, -1, 99, 0, 0, 0, -1, 0, 0 },
	{ "BANG",  "BANG", 0, 0, 0, 0, -1, 100, 0, 0, 0, -1, 0, 0 },
	{ "DOLLAR",  "DOLLAR", 0, 0, 0, 0, -1, 101, 0, 0, 0, -1, 0, 0 },
	{ "CARET",  "CARET", 0, 0, 0, 0, -1, 102, 0, 0, 0, -1, 0, 0 },
	{ "AT",  "AT", 0, 0, 0, 0, -1, 103, 0, 0, 0, -1, 0, 0 },
	{ "PERCENT",  "PERCENT", 0, 0, 0, 0, -1, 104, 0, 0, 0, -1, 0, 0 },
	{ "PLUS",  "PLUS", 0, 0, 0, 0, -1, 105, 0, 0, 0, -1, 0, 0 },
	{ "MINUS",  "MINUS", 0, 0, 0, 0, -1, 106, 0, 0, 0, -1, 0, 0 },
	{ "AMPAMP",  "AMPAMP", 0, 0, 0, 0, -1, 107, 0, 0, 0, -1, 0, 0 },
	{ "BARBAR",  "BARBAR", 0, 0, 0, 0, -1, 108, 0, 0, 0, -1, 0, 0 },
	{ "_ignore_00d1",  "_ignore_00d1", 0, 0, 0, 1, -1, 109, 0, 0, 0, -1, 0, 0 },
	{ "_ignore_00d3",  "_ignore_00d3", 0, 0, 0, 1, -1, 110, 0, 0, 0, -1, 0, 0 },
	{ "LIT_DQ",  "LIT_DQ", 0, 0, 0, 0, -1, 111, 0, 0, 0, -1, 0, 0 },
	{ "LIT_DQ_NL",  "LIT_DQ_NL", 0, 0, 0, 0, -1, 112, 0, 0, 0, -1, 0, 0 },
	{ "LIT_SQOPEN",  "LIT_SQOPEN", 0, 0, 0, 0, -1, 113, 0, 0, 0, -1, 0, 0 },
	{ "LIT_SQCLOSE",  "LIT_SQCLOSE", 0, 0, 0, 0, -1, 114, 0, 0, 0, -1, 0, 0 },
	{ "lit_dq_data",  "lit_dq_data", 0, 0, 0, 0, -1, 115, 0, 0, 0, -1, 0, 0 },
	{ "CONS_SQ",  "CONS_SQ", 0, 0, 0, 0, -1, 116, 0, 0, 0, -1, 0, 0 },
	{ "CONS_SQ_NL",  "CONS_SQ_NL", 0, 0, 0, 0, -1, 117, 0, 0, 0, -1, 0, 0 },
	{ "sq_cons_data",  "sq_cons_data", 0, 0, 0, 0, -1, 118, 0, 0, 0, -1, 0, 0 },
	{ "TILDE_NL",  "TILDE_NL", 0, 0, 0, 0, -1, 119, 0, 0, 0, -1, 0, 0 },
	{ "tilde_data",  "tilde_data", 0, 0, 0, 0, -1, 120, 0, 0, 0, -1, 0, 0 },
	{ "lex_id",  "lex_id", 0, 0, 0, 0, -1, 121, 0, 0, 0, -1, 0, 0 },
	{ "lex_uint",  "lex_uint", 0, 0, 0, 0, -1, 122, 0, 0, 0, -1, 0, 0 },
	{ "lex_hex",  "lex_hex", 0, 0, 0, 0, -1, 123, 0, 0, 0, -1, 0, 0 },
	{ "lex_lit",  "lex_lit", 0, 0, 0, 0, -1, 124, 0, 0, 0, -1, 0, 0 },
	{ "LEX_DOT",  "LEX_DOT", 0, 0, 0, 0, -1, 125, 0, 0, 0, -1, 0, 0 },
	{ "LEX_BAR",  "LEX_BAR", 0, 0, 0, 0, -1, 126, 0, 0, 0, -1, 0, 0 },
	{ "LEX_AMP",  "LEX_AMP", 0, 0, 0, 0, -1, 127, 0, 0, 0, -1, 0, 0 },
	{ "LEX_DASH",  "LEX_DASH", 0, 0, 0, 0, -1, 128, 0, 0, 0, -1, 0, 0 },
	{ "LEX_POPEN",  "LEX_POPEN", 0, 0, 0, 0, -1, 129, 0, 0, 0, -1, 0, 0 },
	{ "LEX_PCLOSE",  "LEX_PCLOSE", 0, 0, 0, 0, -1, 130, 0, 0, 0, -1, 0, 0 },
	{ "LEX_STAR",  "LEX_STAR", 0, 0, 0, 0, -1, 131, 0, 0, 0, -1, 0, 0 },
	{ "LEX_STARSTAR",  "LEX_STARSTAR", 0, 0, 0, 0, -1, 132, 0, 0, 0, -1, 0, 0 },
	{ "LEX_QUESTION",  "LEX_QUESTION", 0, 0, 0, 0, -1, 133, 0, 0, 0, -1, 0, 0 },
	{ "LEX_PLUS",  "LEX_PLUS", 0, 0, 0, 0, -1, 134, 0, 0, 0, -1, 0, 0 },
	{ "LEX_CARET",  "LEX_CARET", 0, 0, 0, 0, -1, 135, 0, 0, 0, -1, 0, 0 },
	{ "LEX_DOTDOT",  "LEX_DOTDOT", 0, 0, 0, 0, -1, 136, 0, 0, 0, -1, 0, 0 },
	{ "LEX_SQOPEN_POS",  "LEX_SQOPEN_POS", 0, 0, 0, 0, -1, 137, 0, 0, 0, -1, 0, 0 },
	{ "LEX_SQOPEN_NEG",  "LEX_SQOPEN_NEG", 0, 0, 0, 0, -1, 138, 0, 0, 0, -1, 0, 0 },
	{ "LEX_FSLASH",  "LEX_FSLASH", 0, 0, 0, 0, -1, 139, 0, 0, 0, -1, 0, 0 },
	{ "LEX_DASHDASH",  "LEX_DASHDASH", 0, 0, 0, 0, -1, 140, 0, 0, 0, -1, 0, 0 },
	{ "LEX_COLON_GT",  "LEX_COLON_GT", 0, 0, 0, 0, -1, 141, 0, 0, 0, -1, 0, 0 },
	{ "LEX_COLON_GTGT",  "LEX_COLON_GTGT", 0, 0, 0, 0, -1, 142, 0, 0, 0, -1, 0, 0 },
	{ "LEX_LT_COLON",  "LEX_LT_COLON", 0, 0, 0, 0, -1, 143, 0, 0, 0, -1, 0, 0 },
	{ "_ignore_0117",  "_ignore_0117", 0, 0, 0, 1, -1, 144, 0, 0, 0, -1, 0, 0 },
	{ "_ignore_0119",  "_ignore_0119", 0, 0, 0, 1, -1, 145, 0, 0, 0, -1, 0, 0 },
	{ "RE_DASH",  "RE_DASH", 0, 0, 0, 0, -1, 146, 0, 0, 0, -1, 0, 0 },
	{ "RE_CHAR",  "RE_CHAR", 0, 0, 0, 0, -1, 147, 0, 0, 0, -1, 0, 0 },
	{ "RE_SQCLOSE",  "RE_SQCLOSE", 0, 0, 0, 0, -1, 148, 0, 0, 0, -1, 0, 0 },
	{ "RED_OPEN",  "RED_OPEN", 0, 0, 0, 0, -1, 178, 0, 0, 0, -1, 0, 0 },
	{ "RED_CLOSE",  "RED_CLOSE", 0, 0, 0, 0, -1, 179, 0, 0, 0, -1, 0, 0 },
	{ "red_id",  "red_id", 0, 0, 0, 0, -1, 180, 0, 0, 0, -1, 0, 0 },
	{ "red_comment",  "red_comment", 0, 0, 0, 0, -1, 181, 0, 0, 0, -1, 0, 0 },
	{ "red_ws",  "red_ws", 0, 0, 0, 0, -1, 182, 0, 0, 0, -1, 0, 0 },
	{ "red_lit",  "red_lit", 0, 0, 0, 0, -1, 183, 0, 0, 0, -1, 0, 0 },
	{ "RED_LHS",  "RED_LHS", 0, 0, 0, 0, -1, 184, 0, 0, 0, -1, 0, 0 },
	{ "RED_RHS_REF",  "RED_RHS_REF", 0, 0, 0, 0, -1, 185, 0, 0, 0, -1, 0, 0 },
	{ "RED_RHS_LOC",  "RED_RHS_LOC", 0, 0, 0, 0, -1, 186, 0, 0, 0, -1, 0, 0 },
	{ "RED_TREE_REF",  "RED_TREE_REF", 0, 0, 0, 0, -1, 187, 0, 0, 0, -1, 0, 0 },
	{ "RED_RHS_NREF",  "RED_RHS_NREF", 0, 0, 0, 0, -1, 188, 0, 0, 0, -1, 0, 0 },
	{ "RED_RHS_NLOC",  "RED_RHS_NLOC", 0, 0, 0, 0, -1, 189, 0, 0, 0, -1, 0, 0 },
	{ "RED_TREE_NREF",  "RED_TREE_NREF", 0, 0, 0, 0, -1, 190, 0, 0, 0, -1, 0, 0 },
	{ "red_any",  "red_any", 0, 0, 0, 0, -1, 191, 0, 0, 0, -1, 0, 0 },
	{ "_ign_0x5643f054b600",  "_ign_0x5643f054b600", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_ign_0x5643f057b270",  "_ign_0x5643f057b270", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_ign_0x5643f057dd80",  "_ign_0x5643f057dd80", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_ign_0x5643f057fa70",  "_ign_0x5643f057fa70", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_ign_0x5643f0580a10",  "_ign_0x5643f0580a10", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_ign_0x5643f058dc80",  "_ign_0x5643f058dc80", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_ign_0x5643f05ad620",  "_ign_0x5643f05ad620", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "__0x5643f057b310_DEF_PAT_1",  "__0x5643f057b310_DEF_PAT_1", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "__0x5643f057de20_DEF_PAT_2",  "__0x5643f057de20_DEF_PAT_2", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "__0x5643f057fb10_DEF_PAT_3",  "__0x5643f057fb10_DEF_PAT_3", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "__0x5643f058dd20_DEF_PAT_4",  "__0x5643f058dd20_DEF_PAT_4", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "__0x5643f05ad6c0_DEF_PAT_5",  "__0x5643f05ad6c0_DEF_PAT_5", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_T_any",  "_T_any", 0, 0, 0, 0, -1, 0, 0, 0, 786, -1, 0, 0 },
	{ "_T_start",  "_T_start", 0, 0, 0, 0, -1, 149, 0, 0, 787, -1, 0, 0 },
	{ "_T_root_item",  "_T_root_item", 0, 0, 0, 0, -1, 150, 0, 0, 788, -1, 0, 0 },
	{ "_T_include",  "_T_include", 0, 0, 0, 0, -1, 151, 0, 0, 789, -1, 0, 0 },
	{ "_T_precedence_def",  "_T_precedence_def", 0, 0, 0, 0, -1, 152, 0, 0, 790, -1, 0, 0 },
	{ "_T_pred_type",  "_T_pred_type", 0, 0, 0, 0, -1, 153, 0, 0, 791, -1, 0, 0 },
	{ "_T_pred_token_list",  "_T_pred_token_list", 0, 0, 0, 0, -1, 154, 0, 0, 792, -1, 0, 0 },
	{ "_T_pred_token",  "_T_pred_token", 0, 0, 0, 0, -1, 155, 0, 0, 793, -1, 0, 0 },
	{ "_T_pre_eof_def",  "_T_pre_eof_def", 0, 0, 0, 0, -1, 156, 0, 0, 794, -1, 0, 0 },
	{ "_T_alias_def",  "_T_alias_def", 0, 0, 0, 0, -1, 157, 0, 0, 795, -1, 0, 0 },
	{ "_T_struct_item",  "_T_struct_item", 0, 0, 0, 0, -1, 158, 0, 0, 796, -1, 0, 0 },
	{ "_T_export_def",  "_T_export_def", 0, 0, 0, 0, -1, 159, 0, 0, 797, -1, 0, 0 },
	{ "_T_global_def",  "_T_global_def", 0, 0, 0, 0, -1, 160, 0, 0, 798, -1, 0, 0 },
	{ "_T_iter_def",  "_T_iter_def", 0, 0, 0, 0, -1, 161, 0, 0, 799, -1, 0, 0 },
	{ "_T_reference_type_ref",  "_T_reference_type_ref", 0, 0, 0, 0, -1, 162, 0, 0, 800, -1, 0, 0 },
	{ "_T_param_var_def_seq",  "_T_param_var_def_seq", 0, 0, 0, 0, -1, 163, 0, 0, 801, -1, 0, 0 },
	{ "_T_param_var_def_list",  "_T_param_var_def_list", 0, 0, 0, 0, -1, 164, 0, 0, 802, -1, 0, 0 },
	{ "_T_param_var_def",  "_T_param_var_def", 0, 0, 0, 0, -1, 165, 0, 0, 803, -1, 0, 0 },
	{ "_T_opt_export",  "_T_opt_export", 0, 0, 0, 0, -1, 166, 0, 0, 804, -1, 0, 0 },
	{ "_T_function_def",  "_T_function_def", 0, 0, 0, 0, -1, 167, 0, 0, 805, -1, 0, 0 },
	{ "_T_in_host_def",  "_T_in_host_def", 0, 0, 0, 0, -1, 168, 0, 0, 806, -1, 0, 0 },
	{ "_T_struct_var_def",  "_T_struct_var_def", 0, 0, 0, 0, -1, 169, 0, 0, 807, -1, 0, 0 },
	{ "_T_struct_key",  "_T_struct_key", 0, 0, 0, 0, -1, 170, 0, 0, 808, -1, 0, 0 },
	{ "_T_struct_def",  "_T_struct_def", 0, 0, 0, 0, -1, 171, 0, 0, 809, -1, 0, 0 },
	{ "_T_literal_def",  "_T_literal_def", 0, 0, 0, 0, -1, 172, 0, 0, 810, -1, 0, 0 },
	{ "_T_literal_list",  "_T_literal_list", 0, 0, 0, 0, -1, 173, 0, 0, 811, -1, 0, 0 },
	{ "_T_literal_item",  "_T_literal_item", 0, 0, 0, 0, -1, 174, 0, 0, 812, -1, 0, 0 },
	{ "_T_no_ignore_left",  "_T_no_ignore_left", 0, 0, 0, 0, -1, 175, 0, 0, 813, -1, 0, 0 },
	{ "_T_no_ignore_right",  "_T_no_ignore_right", 0, 0, 0, 0, -1, 176, 0, 0, 814, -1, 0, 0 },
	{ "_T_reduction_def",  "_T_reduction_def", 0, 0, 0, 0, -1, 177, 0, 0, 815, -1, 0, 0 },
	{ "_T_red_nonterm",  "_T_red_nonterm", 0, 0, 0, 0, -1, 192, 0, 0, 816, -1, 0, 0 },
	{ "_T_red_action",  "_T_red_action", 0, 0, 0, 0, -1, 193, 0, 0, 817, -1, 0, 0 },
	{ "_T_host_item",  "_T_host_item", 0, 0, 0, 0, -1, 194, 0, 0, 818, -1, 0, 0 },
	{ "_T_reduction_item",  "_T_reduction_item", 0, 0, 0, 0, -1, 195, 0, 0, 819, -1, 0, 0 },
	{ "_T_namespace_def",  "_T_namespace_def", 0, 0, 0, 0, -1, 196, 0, 0, 820, -1, 0, 0 },
	{ "_T_namespace_item",  "_T_namespace_item", 0, 0, 0, 0, -1, 197, 0, 0, 821, -1, 0, 0 },
	{ "_T_obj_var_list",  "_T_obj_var_list", 0, 0, 0, 0, -1, 198, 0, 0, 822, -1, 0, 0 },
	{ "_T_opt_reduce_first",  "_T_opt_reduce_first", 0, 0, 0, 0, -1, 199, 0, 0, 823, -1, 0, 0 },
	{ "_T_cfl_def",  "_T_cfl_def", 0, 0, 0, 0, -1, 200, 0, 0, 824, -1, 0, 0 },
	{ "_T_region_def",  "_T_region_def", 0, 0, 0, 0, -1, 201, 0, 0, 825, -1, 0, 0 },
	{ "_T_rl_def",  "_T_rl_def", 0, 0, 0, 0, -1, 202, 0, 0, 826, -1, 0, 0 },
	{ "_T_opt_lex_expr",  "_T_opt_lex_expr", 0, 0, 0, 0, -1, 203, 0, 0, 827, -1, 0, 0 },
	{ "_T_token_def",  "_T_token_def", 0, 0, 0, 0, -1, 204, 0, 0, 828, -1, 0, 0 },
	{ "_T_ic_def",  "_T_ic_def", 0, 0, 0, 0, -1, 205, 0, 0, 829, -1, 0, 0 },
	{ "_T_opt_translate",  "_T_opt_translate", 0, 0, 0, 0, -1, 206, 0, 0, 830, -1, 0, 0 },
	{ "_T_opt_id",  "_T_opt_id", 0, 0, 0, 0, -1, 207, 0, 0, 831, -1, 0, 0 },
	{ "_T_ignore_def",  "_T_ignore_def", 0, 0, 0, 0, -1, 208, 0, 0, 832, -1, 0, 0 },
	{ "_T_prod_el",  "_T_prod_el", 0, 0, 0, 0, -1, 209, 0, 0, 833, -1, 0, 0 },
	{ "_T_opt_prod_el_name",  "_T_opt_prod_el_name", 0, 0, 0, 0, -1, 210, 0, 0, 834, -1, 0, 0 },
	{ "_T_prod_el_list",  "_T_prod_el_list", 0, 0, 0, 0, -1, 211, 0, 0, 835, -1, 0, 0 },
	{ "_T_opt_commit",  "_T_opt_commit", 0, 0, 0, 0, -1, 212, 0, 0, 836, -1, 0, 0 },
	{ "_T_opt_prod_name",  "_T_opt_prod_name", 0, 0, 0, 0, -1, 213, 0, 0, 837, -1, 0, 0 },
	{ "_T_prod",  "_T_prod", 0, 0, 0, 0, -1, 214, 0, 0, 838, -1, 0, 0 },
	{ "_T_opt_reduce",  "_T_opt_reduce", 0, 0, 0, 0, -1, 215, 0, 0, 839, -1, 0, 0 },
	{ "_T_prod_list",  "_T_prod_list", 0, 0, 0, 0, -1, 216, 0, 0, 840, -1, 0, 0 },
	{ "_T_case_clause",  "_T_case_clause", 0, 0, 0, 0, -1, 217, 0, 0, 841, -1, 0, 0 },
	{ "_T_default_clause",  "_T_default_clause", 0, 0, 0, 0, -1, 218, 0, 0, 842, -1, 0, 0 },
	{ "_T_case_clause_list",  "_T_case_clause_list", 0, 0, 0, 0, -1, 219, 0, 0, 843, -1, 0, 0 },
	{ "_T_statement",  "_T_statement", 0, 0, 0, 0, -1, 220, 0, 0, 844, -1, 0, 0 },
	{ "_T_elsif_list",  "_T_elsif_list", 0, 0, 0, 0, -1, 221, 0, 0, 845, -1, 0, 0 },
	{ "_T_elsif_clause",  "_T_elsif_clause", 0, 0, 0, 0, -1, 222, 0, 0, 846, -1, 0, 0 },
	{ "_T_optional_else",  "_T_optional_else", 0, 0, 0, 0, -1, 223, 0, 0, 847, -1, 0, 0 },
	{ "_T_call_arg_seq",  "_T_call_arg_seq", 0, 0, 0, 0, -1, 224, 0, 0, 848, -1, 0, 0 },
	{ "_T_call_arg_list",  "_T_call_arg_list", 0, 0, 0, 0, -1, 225, 0, 0, 849, -1, 0, 0 },
	{ "_T_iter_call",  "_T_iter_call", 0, 0, 0, 0, -1, 226, 0, 0, 850, -1, 0, 0 },
	{ "_T_block_or_single",  "_T_block_or_single", 0, 0, 0, 0, -1, 227, 0, 0, 851, -1, 0, 0 },
	{ "_T_require_pattern",  "_T_require_pattern", 0, 0, 0, 0, -1, 228, 0, 0, 852, -1, 0, 0 },
	{ "_T_opt_require_stmt",  "_T_opt_require_stmt", 0, 0, 0, 0, -1, 229, 0, 0, 853, -1, 0, 0 },
	{ "_T_lang_stmt_list",  "_T_lang_stmt_list", 0, 0, 0, 0, -1, 230, 0, 0, 854, -1, 0, 0 },
	{ "_T_opt_def_init",  "_T_opt_def_init", 0, 0, 0, 0, -1, 231, 0, 0, 855, -1, 0, 0 },
	{ "_T_var_def",  "_T_var_def", 0, 0, 0, 0, -1, 232, 0, 0, 856, -1, 0, 0 },
	{ "_T_print_stmt",  "_T_print_stmt", 0, 0, 0, 0, -1, 233, 0, 0, 857, -1, 0, 0 },
	{ "_T_expr_stmt",  "_T_expr_stmt", 0, 0, 0, 0, -1, 234, 0, 0, 858, -1, 0, 0 },
	{ "_T_code_expr",  "_T_code_expr", 0, 0, 0, 0, -1, 235, 0, 0, 859, -1, 0, 0 },
	{ "_T_code_relational",  "_T_code_relational", 0, 0, 0, 0, -1, 236, 0, 0, 860, -1, 0, 0 },
	{ "_T_code_additive",  "_T_code_additive", 0, 0, 0, 0, -1, 237, 0, 0, 861, -1, 0, 0 },
	{ "_T_code_multiplicitive",  "_T_code_multiplicitive", 0, 0, 0, 0, -1, 238, 0, 0, 862, -1, 0, 0 },
	{ "_T_code_unary",  "_T_code_unary", 0, 0, 0, 0, -1, 239, 0, 0, 863, -1, 0, 0 },
	{ "_T_opt_eos",  "_T_opt_eos", 0, 0, 0, 0, -1, 240, 0, 0, 864, -1, 0, 0 },
	{ "_T_code_factor",  "_T_code_factor", 0, 0, 0, 0, -1, 241, 0, 0, 865, -1, 0, 0 },
	{ "_T_type_ref",  "_T_type_ref", 0, 0, 0, 0, -1, 242, 0, 0, 866, -1, 0, 0 },
	{ "_T_region_qual",  "_T_region_qual", 0, 0, 0, 0, -1, 243, 0, 0, 867, -1, 0, 0 },
	{ "_T_opt_repeat",  "_T_opt_repeat", 0, 0, 0, 0, -1, 244, 0, 0, 868, -1, 0, 0 },
	{ "_T_opt_capture",  "_T_opt_capture", 0, 0, 0, 0, -1, 245, 0, 0, 869, -1, 0, 0 },
	{ "_T_opt_field_init",  "_T_opt_field_init", 0, 0, 0, 0, -1, 246, 0, 0, 870, -1, 0, 0 },
	{ "_T_field_init",  "_T_field_init", 0, 0, 0, 0, -1, 247, 0, 0, 871, -1, 0, 0 },
	{ "_T_stmt_or_factor",  "_T_stmt_or_factor", 0, 0, 0, 0, -1, 248, 0, 0, 872, -1, 0, 0 },
	{ "_T_opt_label",  "_T_opt_label", 0, 0, 0, 0, -1, 249, 0, 0, 873, -1, 0, 0 },
	{ "_T_dq_lit_term",  "_T_dq_lit_term", 0, 0, 0, 0, -1, 250, 0, 0, 874, -1, 0, 0 },
	{ "_T_sq_lit_term",  "_T_sq_lit_term", 0, 0, 0, 0, -1, 251, 0, 0, 875, -1, 0, 0 },
	{ "_T_opt_tilde_data",  "_T_opt_tilde_data", 0, 0, 0, 0, -1, 252, 0, 0, 876, -1, 0, 0 },
	{ "_T_pattern_el_lel",  "_T_pattern_el_lel", 0, 0, 0, 0, -1, 253, 0, 0, 877, -1, 0, 0 },
	{ "_T_pattern_el",  "_T_pattern_el", 0, 0, 0, 0, -1, 254, 0, 0, 878, -1, 0, 0 },
	{ "_T_litpat_el",  "_T_litpat_el", 0, 0, 0, 0, -1, 255, 0, 0, 879, -1, 0, 0 },
	{ "_T_pattern_top_el",  "_T_pattern_top_el", 0, 0, 0, 0, -1, 256, 0, 0, 880, -1, 0, 0 },
	{ "_T_pattern_list",  "_T_pattern_list", 0, 0, 0, 0, -1, 257, 0, 0, 881, -1, 0, 0 },
	{ "_T_pattern",  "_T_pattern", 0, 0, 0, 0, -1, 258, 0, 0, 882, -1, 0, 0 },
	{ "_T_opt_no_trim",  "_T_opt_no_trim", 0, 0, 0, 0, -1, 259, 0, 0, 883, -1, 0, 0 },
	{ "_T_E1",  "_T_E1", 0, 0, 0, 0, -1, 260, 0, 0, 884, -1, 0, 0 },
	{ "_T_E2",  "_T_E2", 0, 0, 0, 0, -1, 261, 0, 0, 885, -1, 0, 0 },
	{ "_T_E3",  "_T_E3", 0, 0, 0, 0, -1, 262, 0, 0, 886, -1, 0, 0 },
	{ "_T_E4",  "_T_E4", 0, 0, 0, 0, -1, 263, 0, 0, 887, -1, 0, 0 },
	{ "_T_cons_el",  "_T_cons_el", 0, 0, 0, 0, -1, 264, 0, 0, 888, -1, 0, 0 },
	{ "_T_lit_cons_el",  "_T_lit_cons_el", 0, 0, 0, 0, -1, 265, 0, 0, 889, -1, 0, 0 },
	{ "_T_cons_top_el",  "_T_cons_top_el", 0, 0, 0, 0, -1, 266, 0, 0, 890, -1, 0, 0 },
	{ "_T_cons_list",  "_T_cons_list", 0, 0, 0, 0, -1, 267, 0, 0, 891, -1, 0, 0 },
	{ "_T_constructor",  "_T_constructor", 0, 0, 0, 0, -1, 268, 0, 0, 892, -1, 0, 0 },
	{ "_T_accum_el",  "_T_accum_el", 0, 0, 0, 0, -1, 269, 0, 0, 893, -1, 0, 0 },
	{ "_T_lit_accum_el",  "_T_lit_accum_el", 0, 0, 0, 0, -1, 270, 0, 0, 894, -1, 0, 0 },
	{ "_T_accum_top_el",  "_T_accum_top_el", 0, 0, 0, 0, -1, 271, 0, 0, 895, -1, 0, 0 },
	{ "_T_accum_list",  "_T_accum_list", 0, 0, 0, 0, -1, 272, 0, 0, 896, -1, 0, 0 },
	{ "_T_accumulate",  "_T_accumulate", 0, 0, 0, 0, -1, 273, 0, 0, 897, -1, 0, 0 },
	{ "_T_string_el",  "_T_string_el", 0, 0, 0, 0, -1, 274, 0, 0, 898, -1, 0, 0 },
	{ "_T_lit_string_el",  "_T_lit_string_el", 0, 0, 0, 0, -1, 275, 0, 0, 899, -1, 0, 0 },
	{ "_T_string_top_el",  "_T_string_top_el", 0, 0, 0, 0, -1, 276, 0, 0, 900, -1, 0, 0 },
	{ "_T_string_list",  "_T_string_list", 0, 0, 0, 0, -1, 277, 0, 0, 901, -1, 0, 0 },
	{ "_T_string",  "_T_string", 0, 0, 0, 0, -1, 278, 0, 0, 902, -1, 0, 0 },
	{ "_T_var_ref",  "_T_var_ref", 0, 0, 0, 0, -1, 279, 0, 0, 903, -1, 0, 0 },
	{ "_T_qual",  "_T_qual", 0, 0, 0, 0, -1, 280, 0, 0, 904, -1, 0, 0 },
	{ "_T_lex_expr",  "_T_lex_expr", 0, 0, 0, 0, -1, 281, 0, 0, 905, -1, 0, 0 },
	{ "_T_opt_lex_dot",  "_T_opt_lex_dot", 0, 0, 0, 0, -1, 282, 0, 0, 906, -1, 0, 0 },
	{ "_T_lex_term",  "_T_lex_term", 0, 0, 0, 0, -1, 283, 0, 0, 907, -1, 0, 0 },
	{ "_T_lex_factor_rep",  "_T_lex_factor_rep", 0, 0, 0, 0, -1, 284, 0, 0, 908, -1, 0, 0 },
	{ "_T_lex_factor_neg",  "_T_lex_factor_neg", 0, 0, 0, 0, -1, 285, 0, 0, 909, -1, 0, 0 },
	{ "_T_lex_range_lit",  "_T_lex_range_lit", 0, 0, 0, 0, -1, 286, 0, 0, 910, -1, 0, 0 },
	{ "_T_lex_num",  "_T_lex_num", 0, 0, 0, 0, -1, 287, 0, 0, 911, -1, 0, 0 },
	{ "_T_lex_factor",  "_T_lex_factor", 0, 0, 0, 0, -1, 288, 0, 0, 912, -1, 0, 0 },
	{ "_T_reg_or_data",  "_T_reg_or_data", 0, 0, 0, 0, -1, 289, 0, 0, 913, -1, 0, 0 },
	{ "_T_reg_or_char",  "_T_reg_or_char", 0, 0, 0, 0, -1, 290, 0, 0, 914, -1, 0, 0 },
	{ "_T__repeat_root_item",  "_T__repeat_root_item", 0, 0, 0, 0, -1, 0, 0, 0, 915, -1, 0, 0 },
	{ "_T__repeat_sq_cons_data",  "_T__repeat_sq_cons_data", 0, 0, 0, 0, -1, 0, 0, 0, 916, -1, 0, 0 },
	{ "_T__repeat_struct_item",  "_T__repeat_struct_item", 0, 0, 0, 0, -1, 0, 0, 0, 917, -1, 0, 0 },
	{ "_T__repeat_reduction_item",  "_T__repeat_reduction_item", 0, 0, 0, 0, -1, 0, 0, 0, 918, -1, 0, 0 },
	{ "_T__repeat_host_item",  "_T__repeat_host_item", 0, 0, 0, 0, -1, 0, 0, 0, 919, -1, 0, 0 },
	{ "_T__repeat_namespace_item",  "_T__repeat_namespace_item", 0, 0, 0, 0, -1, 0, 0, 0, 920, -1, 0, 0 },
	{ "_T__repeat_var_def",  "_T__repeat_var_def", 0, 0, 0, 0, -1, 0, 0, 0, 921, -1, 0, 0 },
	{ "_T__repeat_statement",  "_T__repeat_statement", 0, 0, 0, 0, -1, 0, 0, 0, 922, -1, 0, 0 },
	{ "_T__repeat_field_init",  "_T__repeat_field_init", 0, 0, 0, 0, -1, 0, 0, 0, 923, -1, 0, 0 },
	{ "_T__repeat_litpat_el",  "_T__repeat_litpat_el", 0, 0, 0, 0, -1, 0, 0, 0, 924, -1, 0, 0 },
	{ "_T__repeat_pattern_el",  "_T__repeat_pattern_el", 0, 0, 0, 0, -1, 0, 0, 0, 925, -1, 0, 0 },
	{ "_T__repeat_lit_cons_el",  "_T__repeat_lit_cons_el", 0, 0, 0, 0, -1, 0, 0, 0, 926, -1, 0, 0 },
	{ "_T__repeat_cons_el",  "_T__repeat_cons_el", 0, 0, 0, 0, -1, 0, 0, 0, 927, -1, 0, 0 },
	{ "_T__repeat_lit_accum_el",  "_T__repeat_lit_accum_el", 0, 0, 0, 0, -1, 0, 0, 0, 928, -1, 0, 0 },
	{ "_T__repeat_accum_el",  "_T__repeat_accum_el", 0, 0, 0, 0, -1, 0, 0, 0, 929, -1, 0, 0 },
	{ "_T__repeat_lit_string_el",  "_T__repeat_lit_string_el", 0, 0, 0, 0, -1, 0, 0, 0, 930, -1, 0, 0 },
	{ "_T__repeat_string_el",  "_T__repeat_string_el", 0, 0, 0, 0, -1, 0, 0, 0, 931, -1, 0, 0 },
	{ "_eof_ptr",  "_eof_ptr", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_str",  "_eof_str", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_il",  "_eof_il", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_any",  "_eof_any", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_DEF",  "_eof_DEF", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LEX",  "_eof_LEX", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_END",  "_eof_END", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_TOKEN",  "_eof_TOKEN", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_RL",  "_eof_RL", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_IGNORE",  "_eof_IGNORE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_PRINT",  "_eof_PRINT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_PRINTS",  "_eof_PRINTS", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_PARSE",  "_eof_PARSE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_REDUCE",  "_eof_REDUCE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_READ_REDUCE",  "_eof_READ_REDUCE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_PARSE_TREE",  "_eof_PARSE_TREE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_PARSE_STOP",  "_eof_PARSE_STOP", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_CONS",  "_eof_CONS", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_MATCH",  "_eof_MATCH", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_REQUIRE",  "_eof_REQUIRE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_SEND",  "_eof_SEND", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_SEND_TREE",  "_eof_SEND_TREE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_NAMESPACE",  "_eof_NAMESPACE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_REDUCTION",  "_eof_REDUCTION", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_FOR",  "_eof_FOR", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_IF",  "_eof_IF", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_YIELD",  "_eof_YIELD", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_WHILE",  "_eof_WHILE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_ELSIF",  "_eof_ELSIF", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_ELSE",  "_eof_ELSE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_IN",  "_eof_IN", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_PARSER",  "_eof_PARSER", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LIST",  "_eof_LIST", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LIST_EL",  "_eof_LIST_EL", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_MAP",  "_eof_MAP", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_MAP_EL",  "_eof_MAP_EL", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_PTR",  "_eof_PTR", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_ITER",  "_eof_ITER", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_REF",  "_eof_REF", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_EXPORT",  "_eof_EXPORT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_RETURN",  "_eof_RETURN", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_BREAK",  "_eof_BREAK", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_REJECT",  "_eof_REJECT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_REDUCEFIRST",  "_eof_REDUCEFIRST", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_ALIAS",  "_eof_ALIAS", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_COMMIT",  "_eof_COMMIT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_NEW",  "_eof_NEW", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_PREEOF",  "_eof_PREEOF", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_GLOBAL",  "_eof_GLOBAL", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_EOS",  "_eof_EOS", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_CAST",  "_eof_CAST", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_SWITCH",  "_eof_SWITCH", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_CASE",  "_eof_CASE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_DEFAULT",  "_eof_DEFAULT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_INT",  "_eof_INT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_BOOL",  "_eof_BOOL", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_VOID",  "_eof_VOID", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_MAKE_TOKEN",  "_eof_MAKE_TOKEN", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_MAKE_TREE",  "_eof_MAKE_TREE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_TYPEID",  "_eof_TYPEID", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LITERAL",  "_eof_LITERAL", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_CONTEXT",  "_eof_CONTEXT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_STRUCT",  "_eof_STRUCT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_NI",  "_eof_NI", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_NIL",  "_eof_NIL", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_TRUE",  "_eof_TRUE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_FALSE",  "_eof_FALSE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LEFT",  "_eof_LEFT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_RIGHT",  "_eof_RIGHT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_NONASSOC",  "_eof_NONASSOC", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_INCLUDE",  "_eof_INCLUDE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_id",  "_eof_id", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_number",  "_eof_number", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_backtick_lit",  "_eof_backtick_lit", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_DQ",  "_eof_DQ", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_SQ",  "_eof_SQ", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_TILDE",  "_eof_TILDE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_SQOPEN",  "_eof_SQOPEN", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_SQCLOSE",  "_eof_SQCLOSE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_BAR",  "_eof_BAR", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_FSLASH",  "_eof_FSLASH", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_COLON",  "_eof_COLON", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_DOUBLE_COLON",  "_eof_DOUBLE_COLON", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_DOT",  "_eof_DOT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_ARROW",  "_eof_ARROW", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_POPEN",  "_eof_POPEN", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_PCLOSE",  "_eof_PCLOSE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_COPEN",  "_eof_COPEN", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_CCLOSE",  "_eof_CCLOSE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_STAR",  "_eof_STAR", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_QUESTION",  "_eof_QUESTION", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_EQUALS",  "_eof_EQUALS", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_EQEQ",  "_eof_EQEQ", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_NEQ",  "_eof_NEQ", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_COMMA",  "_eof_COMMA", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LT",  "_eof_LT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_GT",  "_eof_GT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LTEQ",  "_eof_LTEQ", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_GTEQ",  "_eof_GTEQ", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_BANG",  "_eof_BANG", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_DOLLAR",  "_eof_DOLLAR", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_CARET",  "_eof_CARET", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_AT",  "_eof_AT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_PERCENT",  "_eof_PERCENT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_PLUS",  "_eof_PLUS", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_MINUS",  "_eof_MINUS", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_AMPAMP",  "_eof_AMPAMP", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_BARBAR",  "_eof_BARBAR", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__ignore_00d1",  "_eof__ignore_00d1", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__ignore_00d3",  "_eof__ignore_00d3", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LIT_DQ",  "_eof_LIT_DQ", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LIT_DQ_NL",  "_eof_LIT_DQ_NL", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LIT_SQOPEN",  "_eof_LIT_SQOPEN", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LIT_SQCLOSE",  "_eof_LIT_SQCLOSE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_lit_dq_data",  "_eof_lit_dq_data", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_CONS_SQ",  "_eof_CONS_SQ", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_CONS_SQ_NL",  "_eof_CONS_SQ_NL", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_sq_cons_data",  "_eof_sq_cons_data", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_TILDE_NL",  "_eof_TILDE_NL", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_tilde_data",  "_eof_tilde_data", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_lex_id",  "_eof_lex_id", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_lex_uint",  "_eof_lex_uint", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_lex_hex",  "_eof_lex_hex", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_lex_lit",  "_eof_lex_lit", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LEX_DOT",  "_eof_LEX_DOT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LEX_BAR",  "_eof_LEX_BAR", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LEX_AMP",  "_eof_LEX_AMP", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LEX_DASH",  "_eof_LEX_DASH", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LEX_POPEN",  "_eof_LEX_POPEN", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LEX_PCLOSE",  "_eof_LEX_PCLOSE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LEX_STAR",  "_eof_LEX_STAR", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LEX_STARSTAR",  "_eof_LEX_STARSTAR", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LEX_QUESTION",  "_eof_LEX_QUESTION", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LEX_PLUS",  "_eof_LEX_PLUS", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LEX_CARET",  "_eof_LEX_CARET", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LEX_DOTDOT",  "_eof_LEX_DOTDOT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LEX_SQOPEN_POS",  "_eof_LEX_SQOPEN_POS", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LEX_SQOPEN_NEG",  "_eof_LEX_SQOPEN_NEG", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LEX_FSLASH",  "_eof_LEX_FSLASH", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LEX_DASHDASH",  "_eof_LEX_DASHDASH", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LEX_COLON_GT",  "_eof_LEX_COLON_GT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LEX_COLON_GTGT",  "_eof_LEX_COLON_GTGT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_LEX_LT_COLON",  "_eof_LEX_LT_COLON", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__ignore_0117",  "_eof__ignore_0117", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__ignore_0119",  "_eof__ignore_0119", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_RE_DASH",  "_eof_RE_DASH", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_RE_CHAR",  "_eof_RE_CHAR", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_RE_SQCLOSE",  "_eof_RE_SQCLOSE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_RED_OPEN",  "_eof_RED_OPEN", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_RED_CLOSE",  "_eof_RED_CLOSE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_red_id",  "_eof_red_id", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_red_comment",  "_eof_red_comment", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_red_ws",  "_eof_red_ws", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_red_lit",  "_eof_red_lit", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_RED_LHS",  "_eof_RED_LHS", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_RED_RHS_REF",  "_eof_RED_RHS_REF", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_RED_RHS_LOC",  "_eof_RED_RHS_LOC", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_RED_TREE_REF",  "_eof_RED_TREE_REF", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_RED_RHS_NREF",  "_eof_RED_RHS_NREF", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_RED_RHS_NLOC",  "_eof_RED_RHS_NLOC", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_RED_TREE_NREF",  "_eof_RED_TREE_NREF", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_red_any",  "_eof_red_any", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_start",  "_eof_start", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_root_item",  "_eof_root_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_include",  "_eof_include", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_precedence_def",  "_eof_precedence_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_pred_type",  "_eof_pred_type", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_pred_token_list",  "_eof_pred_token_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_pred_token",  "_eof_pred_token", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_pre_eof_def",  "_eof_pre_eof_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_alias_def",  "_eof_alias_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_struct_item",  "_eof_struct_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_export_def",  "_eof_export_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_global_def",  "_eof_global_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_iter_def",  "_eof_iter_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_reference_type_ref",  "_eof_reference_type_ref", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_param_var_def_seq",  "_eof_param_var_def_seq", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_param_var_def_list",  "_eof_param_var_def_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_param_var_def",  "_eof_param_var_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_opt_export",  "_eof_opt_export", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_function_def",  "_eof_function_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_in_host_def",  "_eof_in_host_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_struct_var_def",  "_eof_struct_var_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_struct_key",  "_eof_struct_key", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_struct_def",  "_eof_struct_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_literal_def",  "_eof_literal_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_literal_list",  "_eof_literal_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_literal_item",  "_eof_literal_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_no_ignore_left",  "_eof_no_ignore_left", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_no_ignore_right",  "_eof_no_ignore_right", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_reduction_def",  "_eof_reduction_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_red_nonterm",  "_eof_red_nonterm", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_red_action",  "_eof_red_action", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_host_item",  "_eof_host_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_reduction_item",  "_eof_reduction_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_namespace_def",  "_eof_namespace_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_namespace_item",  "_eof_namespace_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_obj_var_list",  "_eof_obj_var_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_opt_reduce_first",  "_eof_opt_reduce_first", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_cfl_def",  "_eof_cfl_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_region_def",  "_eof_region_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_rl_def",  "_eof_rl_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_opt_lex_expr",  "_eof_opt_lex_expr", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_token_def",  "_eof_token_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_ic_def",  "_eof_ic_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_opt_translate",  "_eof_opt_translate", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_opt_id",  "_eof_opt_id", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_ignore_def",  "_eof_ignore_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_prod_el",  "_eof_prod_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_opt_prod_el_name",  "_eof_opt_prod_el_name", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_prod_el_list",  "_eof_prod_el_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_opt_commit",  "_eof_opt_commit", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_opt_prod_name",  "_eof_opt_prod_name", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_prod",  "_eof_prod", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_opt_reduce",  "_eof_opt_reduce", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_prod_list",  "_eof_prod_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_case_clause",  "_eof_case_clause", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_default_clause",  "_eof_default_clause", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_case_clause_list",  "_eof_case_clause_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_statement",  "_eof_statement", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_elsif_list",  "_eof_elsif_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_elsif_clause",  "_eof_elsif_clause", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_optional_else",  "_eof_optional_else", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_call_arg_seq",  "_eof_call_arg_seq", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_call_arg_list",  "_eof_call_arg_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_iter_call",  "_eof_iter_call", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_block_or_single",  "_eof_block_or_single", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_require_pattern",  "_eof_require_pattern", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_opt_require_stmt",  "_eof_opt_require_stmt", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_lang_stmt_list",  "_eof_lang_stmt_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_opt_def_init",  "_eof_opt_def_init", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_var_def",  "_eof_var_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_print_stmt",  "_eof_print_stmt", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_expr_stmt",  "_eof_expr_stmt", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_code_expr",  "_eof_code_expr", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_code_relational",  "_eof_code_relational", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_code_additive",  "_eof_code_additive", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_code_multiplicitive",  "_eof_code_multiplicitive", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_code_unary",  "_eof_code_unary", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_opt_eos",  "_eof_opt_eos", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_code_factor",  "_eof_code_factor", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_type_ref",  "_eof_type_ref", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_region_qual",  "_eof_region_qual", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_opt_repeat",  "_eof_opt_repeat", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_opt_capture",  "_eof_opt_capture", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_opt_field_init",  "_eof_opt_field_init", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_field_init",  "_eof_field_init", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_stmt_or_factor",  "_eof_stmt_or_factor", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_opt_label",  "_eof_opt_label", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_dq_lit_term",  "_eof_dq_lit_term", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_sq_lit_term",  "_eof_sq_lit_term", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_opt_tilde_data",  "_eof_opt_tilde_data", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_pattern_el_lel",  "_eof_pattern_el_lel", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_pattern_el",  "_eof_pattern_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_litpat_el",  "_eof_litpat_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_pattern_top_el",  "_eof_pattern_top_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_pattern_list",  "_eof_pattern_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_pattern",  "_eof_pattern", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_opt_no_trim",  "_eof_opt_no_trim", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_E1",  "_eof_E1", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_E2",  "_eof_E2", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_E3",  "_eof_E3", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_E4",  "_eof_E4", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_cons_el",  "_eof_cons_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_lit_cons_el",  "_eof_lit_cons_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_cons_top_el",  "_eof_cons_top_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_cons_list",  "_eof_cons_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_constructor",  "_eof_constructor", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_accum_el",  "_eof_accum_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_lit_accum_el",  "_eof_lit_accum_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_accum_top_el",  "_eof_accum_top_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_accum_list",  "_eof_accum_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_accumulate",  "_eof_accumulate", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_string_el",  "_eof_string_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_lit_string_el",  "_eof_lit_string_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_string_top_el",  "_eof_string_top_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_string_list",  "_eof_string_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_string",  "_eof_string", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_var_ref",  "_eof_var_ref", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_qual",  "_eof_qual", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_lex_expr",  "_eof_lex_expr", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_opt_lex_dot",  "_eof_opt_lex_dot", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_lex_term",  "_eof_lex_term", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_lex_factor_rep",  "_eof_lex_factor_rep", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_lex_factor_neg",  "_eof_lex_factor_neg", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_lex_range_lit",  "_eof_lex_range_lit", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_lex_num",  "_eof_lex_num", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_lex_factor",  "_eof_lex_factor", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_reg_or_data",  "_eof_reg_or_data", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof_reg_or_char",  "_eof_reg_or_char", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__ign_0x5643f054b600",  "_eof__ign_0x5643f054b600", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__ign_0x5643f057b270",  "_eof__ign_0x5643f057b270", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__ign_0x5643f057dd80",  "_eof__ign_0x5643f057dd80", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__ign_0x5643f057fa70",  "_eof__ign_0x5643f057fa70", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__ign_0x5643f0580a10",  "_eof__ign_0x5643f0580a10", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__ign_0x5643f058dc80",  "_eof__ign_0x5643f058dc80", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__ign_0x5643f05ad620",  "_eof__ign_0x5643f05ad620", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof___0x5643f057b310_DEF_PAT_1",  "_eof___0x5643f057b310_DEF_PAT_1", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof___0x5643f057de20_DEF_PAT_2",  "_eof___0x5643f057de20_DEF_PAT_2", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof___0x5643f057fb10_DEF_PAT_3",  "_eof___0x5643f057fb10_DEF_PAT_3", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof___0x5643f058dd20_DEF_PAT_4",  "_eof___0x5643f058dd20_DEF_PAT_4", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof___0x5643f05ad6c0_DEF_PAT_5",  "_eof___0x5643f05ad6c0_DEF_PAT_5", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__repeat_root_item",  "_eof__repeat_root_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__repeat_sq_cons_data",  "_eof__repeat_sq_cons_data", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__repeat_struct_item",  "_eof__repeat_struct_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__repeat_reduction_item",  "_eof__repeat_reduction_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__repeat_host_item",  "_eof__repeat_host_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__repeat_namespace_item",  "_eof__repeat_namespace_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__repeat_var_def",  "_eof__repeat_var_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__repeat_statement",  "_eof__repeat_statement", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__repeat_field_init",  "_eof__repeat_field_init", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__repeat_litpat_el",  "_eof__repeat_litpat_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__repeat_pattern_el",  "_eof__repeat_pattern_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__repeat_lit_cons_el",  "_eof__repeat_lit_cons_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__repeat_cons_el",  "_eof__repeat_cons_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__repeat_lit_accum_el",  "_eof__repeat_lit_accum_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__repeat_accum_el",  "_eof__repeat_accum_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__repeat_lit_string_el",  "_eof__repeat_lit_string_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__repeat_string_el",  "_eof__repeat_string_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_any",  "_eof__T_any", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_start",  "_eof__T_start", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_root_item",  "_eof__T_root_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_include",  "_eof__T_include", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_precedence_def",  "_eof__T_precedence_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_pred_type",  "_eof__T_pred_type", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_pred_token_list",  "_eof__T_pred_token_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_pred_token",  "_eof__T_pred_token", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_pre_eof_def",  "_eof__T_pre_eof_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_alias_def",  "_eof__T_alias_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_struct_item",  "_eof__T_struct_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_export_def",  "_eof__T_export_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_global_def",  "_eof__T_global_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_iter_def",  "_eof__T_iter_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_reference_type_ref",  "_eof__T_reference_type_ref", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_param_var_def_seq",  "_eof__T_param_var_def_seq", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_param_var_def_list",  "_eof__T_param_var_def_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_param_var_def",  "_eof__T_param_var_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_opt_export",  "_eof__T_opt_export", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_function_def",  "_eof__T_function_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_in_host_def",  "_eof__T_in_host_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_struct_var_def",  "_eof__T_struct_var_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_struct_key",  "_eof__T_struct_key", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_struct_def",  "_eof__T_struct_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_literal_def",  "_eof__T_literal_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_literal_list",  "_eof__T_literal_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_literal_item",  "_eof__T_literal_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_no_ignore_left",  "_eof__T_no_ignore_left", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_no_ignore_right",  "_eof__T_no_ignore_right", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_reduction_def",  "_eof__T_reduction_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_red_nonterm",  "_eof__T_red_nonterm", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_red_action",  "_eof__T_red_action", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_host_item",  "_eof__T_host_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_reduction_item",  "_eof__T_reduction_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_namespace_def",  "_eof__T_namespace_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_namespace_item",  "_eof__T_namespace_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_obj_var_list",  "_eof__T_obj_var_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_opt_reduce_first",  "_eof__T_opt_reduce_first", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_cfl_def",  "_eof__T_cfl_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_region_def",  "_eof__T_region_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_rl_def",  "_eof__T_rl_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_opt_lex_expr",  "_eof__T_opt_lex_expr", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_token_def",  "_eof__T_token_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_ic_def",  "_eof__T_ic_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_opt_translate",  "_eof__T_opt_translate", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_opt_id",  "_eof__T_opt_id", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_ignore_def",  "_eof__T_ignore_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_prod_el",  "_eof__T_prod_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_opt_prod_el_name",  "_eof__T_opt_prod_el_name", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_prod_el_list",  "_eof__T_prod_el_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_opt_commit",  "_eof__T_opt_commit", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_opt_prod_name",  "_eof__T_opt_prod_name", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_prod",  "_eof__T_prod", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_opt_reduce",  "_eof__T_opt_reduce", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_prod_list",  "_eof__T_prod_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_case_clause",  "_eof__T_case_clause", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_default_clause",  "_eof__T_default_clause", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_case_clause_list",  "_eof__T_case_clause_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_statement",  "_eof__T_statement", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_elsif_list",  "_eof__T_elsif_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_elsif_clause",  "_eof__T_elsif_clause", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_optional_else",  "_eof__T_optional_else", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_call_arg_seq",  "_eof__T_call_arg_seq", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_call_arg_list",  "_eof__T_call_arg_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_iter_call",  "_eof__T_iter_call", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_block_or_single",  "_eof__T_block_or_single", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_require_pattern",  "_eof__T_require_pattern", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_opt_require_stmt",  "_eof__T_opt_require_stmt", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_lang_stmt_list",  "_eof__T_lang_stmt_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_opt_def_init",  "_eof__T_opt_def_init", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_var_def",  "_eof__T_var_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_print_stmt",  "_eof__T_print_stmt", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_expr_stmt",  "_eof__T_expr_stmt", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_code_expr",  "_eof__T_code_expr", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_code_relational",  "_eof__T_code_relational", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_code_additive",  "_eof__T_code_additive", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_code_multiplicitive",  "_eof__T_code_multiplicitive", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_code_unary",  "_eof__T_code_unary", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_opt_eos",  "_eof__T_opt_eos", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_code_factor",  "_eof__T_code_factor", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_type_ref",  "_eof__T_type_ref", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_region_qual",  "_eof__T_region_qual", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_opt_repeat",  "_eof__T_opt_repeat", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_opt_capture",  "_eof__T_opt_capture", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_opt_field_init",  "_eof__T_opt_field_init", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_field_init",  "_eof__T_field_init", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_stmt_or_factor",  "_eof__T_stmt_or_factor", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_opt_label",  "_eof__T_opt_label", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_dq_lit_term",  "_eof__T_dq_lit_term", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_sq_lit_term",  "_eof__T_sq_lit_term", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_opt_tilde_data",  "_eof__T_opt_tilde_data", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_pattern_el_lel",  "_eof__T_pattern_el_lel", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_pattern_el",  "_eof__T_pattern_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_litpat_el",  "_eof__T_litpat_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_pattern_top_el",  "_eof__T_pattern_top_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_pattern_list",  "_eof__T_pattern_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_pattern",  "_eof__T_pattern", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_opt_no_trim",  "_eof__T_opt_no_trim", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_E1",  "_eof__T_E1", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_E2",  "_eof__T_E2", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_E3",  "_eof__T_E3", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_E4",  "_eof__T_E4", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_cons_el",  "_eof__T_cons_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_lit_cons_el",  "_eof__T_lit_cons_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_cons_top_el",  "_eof__T_cons_top_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_cons_list",  "_eof__T_cons_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_constructor",  "_eof__T_constructor", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_accum_el",  "_eof__T_accum_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_lit_accum_el",  "_eof__T_lit_accum_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_accum_top_el",  "_eof__T_accum_top_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_accum_list",  "_eof__T_accum_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_accumulate",  "_eof__T_accumulate", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_string_el",  "_eof__T_string_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_lit_string_el",  "_eof__T_lit_string_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_string_top_el",  "_eof__T_string_top_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_string_list",  "_eof__T_string_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_string",  "_eof__T_string", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_var_ref",  "_eof__T_var_ref", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_qual",  "_eof__T_qual", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_lex_expr",  "_eof__T_lex_expr", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_opt_lex_dot",  "_eof__T_opt_lex_dot", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_lex_term",  "_eof__T_lex_term", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_lex_factor_rep",  "_eof__T_lex_factor_rep", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_lex_factor_neg",  "_eof__T_lex_factor_neg", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_lex_range_lit",  "_eof__T_lex_range_lit", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_lex_num",  "_eof__T_lex_num", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_lex_factor",  "_eof__T_lex_factor", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_reg_or_data",  "_eof__T_reg_or_data", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T_reg_or_char",  "_eof__T_reg_or_char", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T__repeat_root_item",  "_eof__T__repeat_root_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T__repeat_sq_cons_data",  "_eof__T__repeat_sq_cons_data", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T__repeat_struct_item",  "_eof__T__repeat_struct_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T__repeat_reduction_item",  "_eof__T__repeat_reduction_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T__repeat_host_item",  "_eof__T__repeat_host_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T__repeat_namespace_item",  "_eof__T__repeat_namespace_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T__repeat_var_def",  "_eof__T__repeat_var_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T__repeat_statement",  "_eof__T__repeat_statement", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T__repeat_field_init",  "_eof__T__repeat_field_init", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T__repeat_litpat_el",  "_eof__T__repeat_litpat_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T__repeat_pattern_el",  "_eof__T__repeat_pattern_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T__repeat_lit_cons_el",  "_eof__T__repeat_lit_cons_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T__repeat_cons_el",  "_eof__T__repeat_cons_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T__repeat_lit_accum_el",  "_eof__T__repeat_lit_accum_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T__repeat_accum_el",  "_eof__T__repeat_accum_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T__repeat_lit_string_el",  "_eof__T__repeat_lit_string_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_eof__T__repeat_string_el",  "_eof__T__repeat_string_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "_notoken",  "_notoken", 0, 0, 0, 1, -1, 0, 0, 0, 0, -1, 0, 0 },
	{ "any",  "any", 0, 0, 0, 0, -1, 0, 0, 0, 174, -1, 0, 0 },
	{ "start",  "start", 0, 0, 0, 0, -1, 149, 0, 0, 175, -1, 0, 0 },
	{ "root_item",  "root_item", 0, 0, 0, 0, -1, 150, 0, 0, 176, -1, 0, 0 },
	{ "include",  "include", 0, 0, 0, 0, -1, 151, 0, 0, 177, -1, 0, 0 },
	{ "precedence_def",  "precedence_def", 0, 0, 0, 0, -1, 152, 0, 0, 178, -1, 0, 0 },
	{ "pred_type",  "pred_type", 0, 0, 0, 0, -1, 153, 0, 0, 179, -1, 0, 0 },
	{ "pred_token_list",  "pred_token_list", 0, 0, 0, 0, -1, 154, 0, 0, 180, -1, 0, 0 },
	{ "pred_token",  "pred_token", 0, 0, 0, 0, -1, 155, 0, 0, 181, -1, 0, 0 },
	{ "pre_eof_def",  "pre_eof_def", 0, 0, 0, 0, -1, 156, 0, 0, 182, -1, 0, 0 },
	{ "alias_def",  "alias_def", 0, 0, 0, 0, -1, 157, 0, 0, 183, -1, 0, 0 },
	{ "struct_item",  "struct_item", 0, 0, 0, 0, -1, 158, 0, 0, 184, -1, 0, 0 },
	{ "export_def",  "export_def", 0, 0, 0, 0, -1, 159, 0, 0, 185, -1, 0, 0 },
	{ "global_def",  "global_def", 0, 0, 0, 0, -1, 160, 0, 0, 186, -1, 0, 0 },
	{ "iter_def",  "iter_def", 0, 0, 0, 0, -1, 161, 0, 0, 187, -1, 0, 0 },
	{ "reference_type_ref",  "reference_type_ref", 0, 0, 0, 0, -1, 162, 0, 0, 188, -1, 0, 0 },
	{ "param_var_def_seq",  "param_var_def_seq", 0, 0, 0, 0, -1, 163, 0, 0, 189, -1, 0, 0 },
	{ "param_var_def_list",  "param_var_def_list", 0, 0, 0, 0, -1, 164, 0, 0, 190, -1, 0, 0 },
	{ "param_var_def",  "param_var_def", 0, 0, 0, 0, -1, 165, 0, 0, 191, -1, 0, 0 },
	{ "opt_export",  "opt_export", 0, 0, 0, 0, -1, 166, 0, 0, 192, -1, 0, 0 },
	{ "function_def",  "function_def", 0, 0, 0, 0, -1, 167, 0, 0, 193, -1, 0, 0 },
	{ "in_host_def",  "in_host_def", 0, 0, 0, 0, -1, 168, 0, 0, 194, -1, 0, 0 },
	{ "struct_var_def",  "struct_var_def", 0, 0, 0, 0, -1, 169, 0, 0, 195, -1, 0, 0 },
	{ "struct_key",  "struct_key", 0, 0, 0, 0, -1, 170, 0, 0, 196, -1, 0, 0 },
	{ "struct_def",  "struct_def", 0, 0, 0, 0, -1, 171, 0, 0, 197, -1, 0, 0 },
	{ "literal_def",  "literal_def", 0, 0, 0, 0, -1, 172, 0, 0, 198, -1, 0, 0 },
	{ "literal_list",  "literal_list", 0, 0, 0, 0, -1, 173, 0, 0, 199, -1, 0, 0 },
	{ "literal_item",  "literal_item", 0, 0, 0, 0, -1, 174, 0, 0, 200, -1, 0, 0 },
	{ "no_ignore_left",  "no_ignore_left", 0, 0, 0, 0, -1, 175, 0, 0, 201, -1, 0, 0 },
	{ "no_ignore_right",  "no_ignore_right", 0, 0, 0, 0, -1, 176, 0, 0, 202, -1, 0, 0 },
	{ "reduction_def",  "reduction_def", 0, 0, 0, 0, -1, 177, 0, 0, 203, -1, 0, 0 },
	{ "red_nonterm",  "red_nonterm", 0, 0, 0, 0, -1, 192, 0, 0, 204, -1, 0, 0 },
	{ "red_action",  "red_action", 0, 0, 0, 0, -1, 193, 0, 0, 205, -1, 0, 0 },
	{ "host_item",  "host_item", 0, 0, 0, 0, -1, 194, 0, 0, 206, -1, 0, 0 },
	{ "reduction_item",  "reduction_item", 0, 0, 0, 0, -1, 195, 0, 0, 207, -1, 0, 0 },
	{ "namespace_def",  "namespace_def", 0, 0, 0, 0, -1, 196, 0, 0, 208, -1, 0, 0 },
	{ "namespace_item",  "namespace_item", 0, 0, 0, 0, -1, 197, 0, 0, 209, -1, 0, 0 },
	{ "obj_var_list",  "obj_var_list", 0, 0, 0, 0, -1, 198, 0, 0, 210, -1, 0, 0 },
	{ "opt_reduce_first",  "opt_reduce_first", 0, 0, 0, 0, -1, 199, 0, 0, 211, -1, 0, 0 },
	{ "cfl_def",  "cfl_def", 0, 0, 0, 0, -1, 200, 0, 0, 212, -1, 0, 0 },
	{ "region_def",  "region_def", 0, 0, 0, 0, -1, 201, 0, 0, 213, -1, 0, 0 },
	{ "rl_def",  "rl_def", 0, 0, 0, 0, -1, 202, 0, 0, 214, -1, 0, 0 },
	{ "opt_lex_expr",  "opt_lex_expr", 0, 0, 0, 0, -1, 203, 0, 0, 215, -1, 0, 0 },
	{ "token_def",  "token_def", 0, 0, 0, 0, -1, 204, 0, 0, 216, -1, 0, 0 },
	{ "ic_def",  "ic_def", 0, 0, 0, 0, -1, 205, 0, 0, 217, -1, 0, 0 },
	{ "opt_translate",  "opt_translate", 0, 0, 0, 0, -1, 206, 0, 0, 218, -1, 0, 0 },
	{ "opt_id",  "opt_id", 0, 0, 0, 0, -1, 207, 0, 0, 219, -1, 0, 0 },
	{ "ignore_def",  "ignore_def", 0, 0, 0, 0, -1, 208, 0, 0, 220, -1, 0, 0 },
	{ "prod_el",  "prod_el", 0, 0, 0, 0, -1, 209, 0, 0, 221, -1, 0, 0 },
	{ "opt_prod_el_name",  "opt_prod_el_name", 0, 0, 0, 0, -1, 210, 0, 0, 222, -1, 0, 0 },
	{ "prod_el_list",  "prod_el_list", 0, 0, 0, 0, -1, 211, 0, 0, 223, -1, 0, 0 },
	{ "opt_commit",  "opt_commit", 0, 0, 0, 0, -1, 212, 0, 0, 224, -1, 0, 0 },
	{ "opt_prod_name",  "opt_prod_name", 0, 0, 0, 0, -1, 213, 0, 0, 225, -1, 0, 0 },
	{ "prod",  "prod", 0, 0, 0, 0, -1, 214, 0, 0, 226, -1, 0, 0 },
	{ "opt_reduce",  "opt_reduce", 0, 0, 0, 0, -1, 215, 0, 0, 227, -1, 0, 0 },
	{ "prod_list",  "prod_list", 0, 0, 0, 0, -1, 216, 0, 0, 228, -1, 0, 0 },
	{ "case_clause",  "case_clause", 0, 0, 0, 0, -1, 217, 0, 0, 229, -1, 0, 0 },
	{ "default_clause",  "default_clause", 0, 0, 0, 0, -1, 218, 0, 0, 230, -1, 0, 0 },
	{ "case_clause_list",  "case_clause_list", 0, 0, 0, 0, -1, 219, 0, 0, 231, -1, 0, 0 },
	{ "statement",  "statement", 0, 0, 0, 0, -1, 220, 0, 0, 232, -1, 0, 0 },
	{ "elsif_list",  "elsif_list", 0, 0, 0, 0, -1, 221, 0, 0, 233, -1, 0, 0 },
	{ "elsif_clause",  "elsif_clause", 0, 0, 0, 0, -1, 222, 0, 0, 234, -1, 0, 0 },
	{ "optional_else",  "optional_else", 0, 0, 0, 0, -1, 223, 0, 0, 235, -1, 0, 0 },
	{ "call_arg_seq",  "call_arg_seq", 0, 0, 0, 0, -1, 224, 0, 0, 236, -1, 0, 0 },
	{ "call_arg_list",  "call_arg_list", 0, 0, 0, 0, -1, 225, 0, 0, 237, -1, 0, 0 },
	{ "iter_call",  "iter_call", 0, 0, 0, 0, -1, 226, 0, 0, 238, -1, 0, 0 },
	{ "block_or_single",  "block_or_single", 0, 0, 0, 0, -1, 227, 0, 0, 239, -1, 0, 0 },
	{ "require_pattern",  "require_pattern", 0, 0, 0, 0, -1, 228, 0, 0, 240, -1, 0, 0 },
	{ "opt_require_stmt",  "opt_require_stmt", 0, 0, 0, 0, -1, 229, 0, 0, 241, -1, 0, 0 },
	{ "lang_stmt_list",  "lang_stmt_list", 0, 0, 0, 0, -1, 230, 0, 0, 242, -1, 0, 0 },
	{ "opt_def_init",  "opt_def_init", 0, 0, 0, 0, -1, 231, 0, 0, 243, -1, 0, 0 },
	{ "var_def",  "var_def", 0, 0, 0, 0, -1, 232, 0, 0, 244, -1, 0, 0 },
	{ "print_stmt",  "print_stmt", 0, 0, 0, 0, -1, 233, 0, 0, 245, -1, 0, 0 },
	{ "expr_stmt",  "expr_stmt", 0, 0, 0, 0, -1, 234, 0, 0, 246, -1, 0, 0 },
	{ "code_expr",  "code_expr", 0, 0, 0, 0, -1, 235, 0, 0, 247, -1, 0, 0 },
	{ "code_relational",  "code_relational", 0, 0, 0, 0, -1, 236, 0, 0, 248, -1, 0, 0 },
	{ "code_additive",  "code_additive", 0, 0, 0, 0, -1, 237, 0, 0, 249, -1, 0, 0 },
	{ "code_multiplicitive",  "code_multiplicitive", 0, 0, 0, 0, -1, 238, 0, 0, 250, -1, 0, 0 },
	{ "code_unary",  "code_unary", 0, 0, 0, 0, -1, 239, 0, 0, 251, -1, 0, 0 },
	{ "opt_eos",  "opt_eos", 0, 0, 0, 0, -1, 240, 0, 0, 252, -1, 0, 0 },
	{ "code_factor",  "code_factor", 0, 0, 0, 0, -1, 241, 0, 0, 253, -1, 0, 0 },
	{ "type_ref",  "type_ref", 0, 0, 0, 0, -1, 242, 0, 0, 254, -1, 0, 0 },
	{ "region_qual",  "region_qual", 0, 0, 0, 0, -1, 243, 0, 0, 255, -1, 0, 0 },
	{ "opt_repeat",  "opt_repeat", 0, 0, 0, 0, -1, 244, 0, 0, 256, -1, 0, 0 },
	{ "opt_capture",  "opt_capture", 0, 0, 0, 0, -1, 245, 0, 0, 257, -1, 0, 0 },
	{ "opt_field_init",  "opt_field_init", 0, 0, 0, 0, -1, 246, 0, 0, 258, -1, 0, 0 },
	{ "field_init",  "field_init", 0, 0, 0, 0, -1, 247, 0, 0, 259, -1, 0, 0 },
	{ "stmt_or_factor",  "stmt_or_factor", 0, 0, 0, 0, -1, 248, 0, 0, 260, -1, 0, 0 },
	{ "opt_label",  "opt_label", 0, 0, 0, 0, -1, 249, 0, 0, 261, -1, 0, 0 },
	{ "dq_lit_term",  "dq_lit_term", 0, 0, 0, 0, -1, 250, 0, 0, 262, -1, 0, 0 },
	{ "sq_lit_term",  "sq_lit_term", 0, 0, 0, 0, -1, 251, 0, 0, 263, -1, 0, 0 },
	{ "opt_tilde_data",  "opt_tilde_data", 0, 0, 0, 0, -1, 252, 0, 0, 264, -1, 0, 0 },
	{ "pattern_el_lel",  "pattern_el_lel", 0, 0, 0, 0, -1, 253, 0, 0, 265, -1, 0, 0 },
	{ "pattern_el",  "pattern_el", 0, 0, 0, 0, -1, 254, 0, 0, 266, -1, 0, 0 },
	{ "litpat_el",  "litpat_el", 0, 0, 0, 0, -1, 255, 0, 0, 267, -1, 0, 0 },
	{ "pattern_top_el",  "pattern_top_el", 0, 0, 0, 0, -1, 256, 0, 0, 268, -1, 0, 0 },
	{ "pattern_list",  "pattern_list", 0, 0, 0, 0, -1, 257, 0, 0, 269, -1, 0, 0 },
	{ "pattern",  "pattern", 0, 0, 0, 0, -1, 258, 0, 0, 270, -1, 0, 0 },
	{ "opt_no_trim",  "opt_no_trim", 0, 0, 0, 0, -1, 259, 0, 0, 271, -1, 0, 0 },
	{ "E1",  "E1", 0, 0, 0, 0, -1, 260, 0, 0, 272, -1, 0, 0 },
	{ "E2",  "E2", 0, 0, 0, 0, -1, 261, 0, 0, 273, -1, 0, 0 },
	{ "E3",  "E3", 0, 0, 0, 0, -1, 262, 0, 0, 274, -1, 0, 0 },
	{ "E4",  "E4", 0, 0, 0, 0, -1, 263, 0, 0, 275, -1, 0, 0 },
	{ "cons_el",  "cons_el", 0, 0, 0, 0, -1, 264, 0, 0, 276, -1, 0, 0 },
	{ "lit_cons_el",  "lit_cons_el", 0, 0, 0, 0, -1, 265, 0, 0, 277, -1, 0, 0 },
	{ "cons_top_el",  "cons_top_el", 0, 0, 0, 0, -1, 266, 0, 0, 278, -1, 0, 0 },
	{ "cons_list",  "cons_list", 0, 0, 0, 0, -1, 267, 0, 0, 279, -1, 0, 0 },
	{ "constructor",  "constructor", 0, 0, 0, 0, -1, 268, 0, 0, 280, -1, 0, 0 },
	{ "accum_el",  "accum_el", 0, 0, 0, 0, -1, 269, 0, 0, 281, -1, 0, 0 },
	{ "lit_accum_el",  "lit_accum_el", 0, 0, 0, 0, -1, 270, 0, 0, 282, -1, 0, 0 },
	{ "accum_top_el",  "accum_top_el", 0, 0, 0, 0, -1, 271, 0, 0, 283, -1, 0, 0 },
	{ "accum_list",  "accum_list", 0, 0, 0, 0, -1, 272, 0, 0, 284, -1, 0, 0 },
	{ "accumulate",  "accumulate", 0, 0, 0, 0, -1, 273, 0, 0, 285, -1, 0, 0 },
	{ "string_el",  "string_el", 0, 0, 0, 0, -1, 274, 0, 0, 286, -1, 0, 0 },
	{ "lit_string_el",  "lit_string_el", 0, 0, 0, 0, -1, 275, 0, 0, 287, -1, 0, 0 },
	{ "string_top_el",  "string_top_el", 0, 0, 0, 0, -1, 276, 0, 0, 288, -1, 0, 0 },
	{ "string_list",  "string_list", 0, 0, 0, 0, -1, 277, 0, 0, 289, -1, 0, 0 },
	{ "string",  "string", 0, 0, 0, 0, -1, 278, 0, 0, 290, -1, 0, 0 },
	{ "var_ref",  "var_ref", 0, 0, 0, 0, -1, 279, 0, 0, 291, -1, 0, 0 },
	{ "qual",  "qual", 0, 0, 0, 0, -1, 280, 0, 0, 292, -1, 0, 0 },
	{ "lex_expr",  "lex_expr", 0, 0, 0, 0, -1, 281, 0, 0, 293, -1, 0, 0 },
	{ "opt_lex_dot",  "opt_lex_dot", 0, 0, 0, 0, -1, 282, 0, 0, 294, -1, 0, 0 },
	{ "lex_term",  "lex_term", 0, 0, 0, 0, -1, 283, 0, 0, 295, -1, 0, 0 },
	{ "lex_factor_rep",  "lex_factor_rep", 0, 0, 0, 0, -1, 284, 0, 0, 296, -1, 0, 0 },
	{ "lex_factor_neg",  "lex_factor_neg", 0, 0, 0, 0, -1, 285, 0, 0, 297, -1, 0, 0 },
	{ "lex_range_lit",  "lex_range_lit", 0, 0, 0, 0, -1, 286, 0, 0, 298, -1, 0, 0 },
	{ "lex_num",  "lex_num", 0, 0, 0, 0, -1, 287, 0, 0, 299, -1, 0, 0 },
	{ "lex_factor",  "lex_factor", 0, 0, 0, 0, -1, 288, 0, 0, 300, -1, 0, 0 },
	{ "reg_or_data",  "reg_or_data", 0, 0, 0, 0, -1, 289, 0, 0, 301, -1, 0, 0 },
	{ "reg_or_char",  "reg_or_char", 0, 0, 0, 0, -1, 290, 0, 0, 302, -1, 0, 0 },
	{ "_repeat_root_item",  "_repeat_root_item", 1, 0, 0, 0, -1, 0, 0, 0, 303, -1, 0, 0 },
	{ "_repeat_sq_cons_data",  "_repeat_sq_cons_data", 1, 0, 0, 0, -1, 0, 0, 0, 304, -1, 0, 0 },
	{ "_repeat_struct_item",  "_repeat_struct_item", 1, 0, 0, 0, -1, 0, 0, 0, 305, -1, 0, 0 },
	{ "_repeat_reduction_item",  "_repeat_reduction_item", 1, 0, 0, 0, -1, 0, 0, 0, 306, -1, 0, 0 },
	{ "_repeat_host_item",  "_repeat_host_item", 1, 0, 0, 0, -1, 0, 0, 0, 307, -1, 0, 0 },
	{ "_repeat_namespace_item",  "_repeat_namespace_item", 1, 0, 0, 0, -1, 0, 0, 0, 308, -1, 0, 0 },
	{ "_repeat_var_def",  "_repeat_var_def", 1, 0, 0, 0, -1, 0, 0, 0, 309, -1, 0, 0 },
	{ "_repeat_statement",  "_repeat_statement", 1, 0, 0, 0, -1, 0, 0, 0, 310, -1, 0, 0 },
	{ "_repeat_field_init",  "_repeat_field_init", 1, 0, 0, 0, -1, 0, 0, 0, 311, -1, 0, 0 },
	{ "_repeat_litpat_el",  "_repeat_litpat_el", 1, 0, 0, 0, -1, 0, 0, 0, 312, -1, 0, 0 },
	{ "_repeat_pattern_el",  "_repeat_pattern_el", 1, 0, 0, 0, -1, 0, 0, 0, 313, -1, 0, 0 },
	{ "_repeat_lit_cons_el",  "_repeat_lit_cons_el", 1, 0, 0, 0, -1, 0, 0, 0, 314, -1, 0, 0 },
	{ "_repeat_cons_el",  "_repeat_cons_el", 1, 0, 0, 0, -1, 0, 0, 0, 315, -1, 0, 0 },
	{ "_repeat_lit_accum_el",  "_repeat_lit_accum_el", 1, 0, 0, 0, -1, 0, 0, 0, 316, -1, 0, 0 },
	{ "_repeat_accum_el",  "_repeat_accum_el", 1, 0, 0, 0, -1, 0, 0, 0, 317, -1, 0, 0 },
	{ "_repeat_lit_string_el",  "_repeat_lit_string_el", 1, 0, 0, 0, -1, 0, 0, 0, 318, -1, 0, 0 },
	{ "_repeat_string_el",  "_repeat_string_el", 1, 0, 0, 0, -1, 0, 0, 0, 319, -1, 0, 0 },
	{ "_root",  "_root", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 }
};

static short struct_trees_0[] = {
	0, 1, 4, 
};

static short struct_trees_4[] = {
	0, 
};

static struct struct_el_info parser_selInfo[] = {
	{ 5, struct_trees_0, 3,  },
	{ 0, 0, 0,  },
	{ 0, 0, 0,  },
	{ 3, 0, 0,  },
	{ 3, struct_trees_4, 1,  },

};

static struct frame_info parser_frameInfo[] = {
	{ "", 0, 0, 0, 0, locals_0, 2, 0, 2 }
};

static struct prod_info parser_prodInfo[] = {
	{ 787, 0, 1, "start-1", -1, 1, copy_0, 1,  },
	{ 788, 0, 1, "root_item-1", -1, 1, copy_1, 1,  },
	{ 788, 1, 1, "root_item-2", -1, 1, copy_2, 1,  },
	{ 788, 2, 1, "root_item-3", -1, 1, copy_3, 1,  },
	{ 788, 3, 1, "root_item-4", -1, 1, copy_4, 1,  },
	{ 788, 4, 1, "root_item-5", -1, 1, copy_5, 1,  },
	{ 788, 5, 1, "root_item-6", -1, 1, copy_6, 1,  },
	{ 788, 6, 1, "root_item-7", -1, 1, copy_7, 1,  },
	{ 788, 7, 1, "root_item-8", -1, 1, copy_8, 1,  },
	{ 788, 8, 1, "root_item-9", -1, 1, copy_9, 1,  },
	{ 788, 9, 1, "root_item-10", -1, 1, copy_10, 1,  },
	{ 788, 10, 1, "root_item-11", -1, 1, copy_11, 1,  },
	{ 788, 11, 1, "root_item-12", -1, 1, copy_12, 1,  },
	{ 788, 12, 1, "root_item-13", -1, 1, copy_13, 1,  },
	{ 788, 13, 1, "root_item-14", -1, 1, copy_14, 1,  },
	{ 788, 14, 1, "root_item-15", -1, 1, copy_15, 1,  },
	{ 788, 15, 1, "root_item-16", -1, 1, copy_16, 1,  },
	{ 788, 16, 1, "root_item-17", -1, 1, copy_17, 1,  },
	{ 788, 17, 1, "root_item-18", -1, 1, copy_18, 1,  },
	{ 788, 18, 1, "root_item-19", -1, 1, copy_19, 1,  },
	{ 788, 19, 1, "root_item-20", -1, 1, copy_20, 1,  },
	{ 789, 0, 4, "include-1", -1, 1, copy_21, 4,  },
	{ 790, 0, 2, "precedence_def-1", -1, 1, copy_22, 2,  },
	{ 791, 0, 1, "pred_type-1", -1, 1, copy_23, 1,  },
	{ 791, 1, 1, "pred_type-2", -1, 1, copy_24, 1,  },
	{ 791, 2, 1, "pred_type-3", -1, 1, copy_25, 1,  },
	{ 792, 0, 3, "pred_token_list-1", -1, 1, copy_26, 3,  },
	{ 792, 1, 1, "pred_token_list-2", -1, 1, copy_27, 1,  },
	{ 793, 0, 2, "pred_token-1", -1, 1, copy_28, 2,  },
	{ 793, 1, 2, "pred_token-2", -1, 1, copy_29, 2,  },
	{ 794, 0, 4, "pre_eof_def-1", -1, 1, copy_30, 4,  },
	{ 795, 0, 3, "alias_def-1", -1, 1, copy_31, 3,  },
	{ 796, 0, 1, "struct_item-1", -1, 1, copy_32, 1,  },
	{ 796, 1, 1, "struct_item-2", -1, 1, copy_33, 1,  },
	{ 796, 2, 1, "struct_item-3", -1, 1, copy_34, 1,  },
	{ 796, 3, 1, "struct_item-4", -1, 1, copy_35, 1,  },
	{ 796, 4, 1, "struct_item-5", -1, 1, copy_36, 1,  },
	{ 796, 5, 1, "struct_item-6", -1, 1, copy_37, 1,  },
	{ 796, 6, 1, "struct_item-7", -1, 1, copy_38, 1,  },
	{ 796, 7, 1, "struct_item-8", -1, 1, copy_39, 1,  },
	{ 796, 8, 1, "struct_item-9", -1, 1, copy_40, 1,  },
	{ 796, 9, 1, "struct_item-10", -1, 1, copy_41, 1,  },
	{ 796, 10, 1, "struct_item-11", -1, 1, copy_42, 1,  },
	{ 796, 11, 1, "struct_item-12", -1, 1, copy_43, 1,  },
	{ 796, 12, 1, "struct_item-13", -1, 1, copy_44, 1,  },
	{ 796, 13, 1, "struct_item-14", -1, 1, copy_45, 1,  },
	{ 796, 14, 1, "struct_item-15", -1, 1, copy_46, 1,  },
	{ 796, 15, 1, "struct_item-16", -1, 1, copy_47, 1,  },
	{ 797, 0, 3, "export_def-1", -1, 1, copy_48, 3,  },
	{ 798, 0, 3, "global_def-1", -1, 1, copy_49, 3,  },
	{ 799, 0, 8, "iter_def-1", -1, 1, copy_50, 8,  },
	{ 800, 0, 4, "reference_type_ref-1", -1, 1, copy_51, 4,  },
	{ 801, 0, 3, "param_var_def_seq-1", -1, 1, copy_52, 3,  },
	{ 801, 1, 1, "param_var_def_seq-2", -1, 1, copy_53, 1,  },
	{ 802, 0, 1, "param_var_def_list-1", -1, 1, copy_54, 1,  },
	{ 802, 1, 0, "param_var_def_list-2", -1, 1, 0, 0,  },
	{ 803, 0, 3, "param_var_def-1", -1, 1, copy_56, 3,  },
	{ 803, 1, 3, "param_var_def-2", -1, 1, copy_57, 3,  },
	{ 804, 0, 1, "opt_export-1", -1, 1, copy_58, 1,  },
	{ 804, 1, 0, "opt_export-2", -1, 1, 0, 0,  },
	{ 805, 0, 9, "function_def-1", -1, 1, copy_60, 9,  },
	{ 806, 0, 8, "in_host_def-1", -1, 1, copy_61, 8,  },
	{ 807, 0, 1, "struct_var_def-1", -1, 1, copy_62, 1,  },
	{ 808, 0, 1, "struct_key-1", -1, 1, copy_63, 1,  },
	{ 808, 1, 1, "struct_key-2", -1, 1, copy_64, 1,  },
	{ 809, 0, 4, "struct_def-1", -1, 1, copy_65, 4,  },
	{ 810, 0, 2, "literal_def-1", -1, 1, copy_66, 2,  },
	{ 811, 0, 2, "literal_list-1", -1, 1, copy_67, 2,  },
	{ 811, 1, 1, "literal_list-2", -1, 1, copy_68, 1,  },
	{ 812, 0, 3, "literal_item-1", -1, 1, copy_69, 3,  },
	{ 813, 0, 2, "no_ignore_left-1", -1, 1, copy_70, 2,  },
	{ 813, 1, 0, "no_ignore_left-2", -1, 1, 0, 0,  },
	{ 814, 0, 2, "no_ignore_right-1", -1, 1, copy_72, 2,  },
	{ 814, 1, 0, "no_ignore_right-2", -1, 1, 0, 0,  },
	{ 815, 0, 4, "reduction_def-1", -1, 1, copy_74, 4,  },
	{ 816, 0, 4, "red_nonterm-1", -1, 1, copy_75, 4,  },
	{ 817, 0, 6, "red_action-1", -1, 1, copy_76, 6,  },
	{ 818, 0, 1, "host_item-1", -1, 1, copy_77, 1,  },
	{ 818, 1, 1, "host_item-2", -1, 1, copy_78, 1,  },
	{ 818, 2, 1, "host_item-3", -1, 1, copy_79, 1,  },
	{ 818, 3, 1, "host_item-4", -1, 1, copy_80, 1,  },
	{ 818, 4, 1, "host_item-5", -1, 1, copy_81, 1,  },
	{ 818, 5, 1, "host_item-6", -1, 1, copy_82, 1,  },
	{ 818, 6, 1, "host_item-7", -1, 1, copy_83, 1,  },
	{ 818, 7, 1, "host_item-8", -1, 1, copy_84, 1,  },
	{ 818, 8, 1, "host_item-9", -1, 1, copy_85, 1,  },
	{ 818, 9, 1, "host_item-10", -1, 1, copy_86, 1,  },
	{ 818, 10, 1, "host_item-11", -1, 1, copy_87, 1,  },
	{ 818, 11, 1, "host_item-12", -1, 1, copy_88, 1,  },
	{ 818, 12, 3, "host_item-13", -1, 1, copy_89, 3,  },
	{ 819, 0, 1, "reduction_item-1", -1, 1, copy_90, 1,  },
	{ 819, 1, 1, "reduction_item-2", -1, 1, copy_91, 1,  },
	{ 820, 0, 4, "namespace_def-1", -1, 1, copy_92, 4,  },
	{ 821, 0, 1, "namespace_item-1", -1, 1, copy_93, 1,  },
	{ 821, 1, 1, "namespace_item-2", -1, 1, copy_94, 1,  },
	{ 821, 2, 1, "namespace_item-3", -1, 1, copy_95, 1,  },
	{ 821, 3, 1, "namespace_item-4", -1, 1, copy_96, 1,  },
	{ 821, 4, 1, "namespace_item-5", -1, 1, copy_97, 1,  },
	{ 821, 5, 1, "namespace_item-6", -1, 1, copy_98, 1,  },
	{ 821, 6, 1, "namespace_item-7", -1, 1, copy_99, 1,  },
	{ 821, 7, 1, "namespace_item-8", -1, 1, copy_100, 1,  },
	{ 821, 8, 1, "namespace_item-9", -1, 1, copy_101, 1,  },
	{ 821, 9, 1, "namespace_item-10", -1, 1, copy_102, 1,  },
	{ 821, 10, 1, "namespace_item-11", -1, 1, copy_103, 1,  },
	{ 821, 11, 1, "namespace_item-12", -1, 1, copy_104, 1,  },
	{ 821, 12, 1, "namespace_item-13", -1, 1, copy_105, 1,  },
	{ 821, 13, 1, "namespace_item-14", -1, 1, copy_106, 1,  },
	{ 821, 14, 1, "namespace_item-15", -1, 1, copy_107, 1,  },
	{ 821, 15, 1, "namespace_item-16", -1, 1, copy_108, 1,  },
	{ 821, 16, 1, "namespace_item-17", -1, 1, copy_109, 1,  },
	{ 822, 0, 0, "obj_var_list-1", -1, 1, 0, 0,  },
	{ 823, 0, 1, "opt_reduce_first-1", -1, 1, copy_111, 1,  },
	{ 823, 1, 0, "opt_reduce_first-2", -1, 1, 0, 0,  },
	{ 824, 0, 5, "cfl_def-1", -1, 1, copy_113, 5,  },
	{ 825, 0, 3, "region_def-1", -1, 1, copy_114, 3,  },
	{ 826, 0, 5, "rl_def-1", -1, 1, copy_115, 5,  },
	{ 827, 0, 1, "opt_lex_expr-1", -1, 1, copy_116, 1,  },
	{ 827, 1, 0, "opt_lex_expr-2", -1, 1, 0, 0,  },
	{ 828, 0, 9, "token_def-1", -1, 1, copy_118, 9,  },
	{ 829, 0, 3, "ic_def-1", -1, 1, copy_119, 3,  },
	{ 830, 0, 3, "opt_translate-1", -1, 1, copy_120, 3,  },
	{ 830, 1, 0, "opt_translate-2", -1, 1, 0, 0,  },
	{ 831, 0, 1, "opt_id-1", -1, 1, copy_122, 1,  },
	{ 831, 1, 0, "opt_id-2", -1, 1, 0, 0,  },
	{ 832, 0, 5, "ignore_def-1", -1, 1, copy_124, 5,  },
	{ 833, 0, 4, "prod_el-1", -1, 1, copy_125, 4,  },
	{ 833, 1, 4, "prod_el-2", -1, 1, copy_126, 4,  },
	{ 834, 0, 2, "opt_prod_el_name-1", -1, 1, copy_127, 2,  },
	{ 834, 1, 0, "opt_prod_el_name-2", -1, 1, 0, 0,  },
	{ 835, 0, 2, "prod_el_list-1", -1, 1, copy_129, 2,  },
	{ 835, 1, 0, "prod_el_list-2", -1, 1, 0, 0,  },
	{ 836, 0, 1, "opt_commit-1", -1, 1, copy_131, 1,  },
	{ 836, 1, 0, "opt_commit-2", -1, 1, 0, 0,  },
	{ 837, 0, 2, "opt_prod_name-1", -1, 1, copy_133, 2,  },
	{ 837, 1, 0, "opt_prod_name-2", -1, 1, 0, 0,  },
	{ 838, 0, 6, "prod-1", -1, 1, copy_135, 6,  },
	{ 839, 0, 3, "opt_reduce-1", -1, 1, copy_136, 3,  },
	{ 839, 1, 0, "opt_reduce-2", -1, 1, 0, 0,  },
	{ 840, 0, 3, "prod_list-1", -1, 1, copy_138, 3,  },
	{ 840, 1, 1, "prod_list-2", -1, 1, copy_139, 1,  },
	{ 841, 0, 3, "case_clause-1", -1, 1, copy_140, 3,  },
	{ 841, 1, 3, "case_clause-2", -1, 1, copy_141, 3,  },
	{ 841, 2, 4, "case_clause-3", -1, 1, copy_142, 4,  },
	{ 842, 0, 2, "default_clause-1", -1, 1, copy_143, 2,  },
	{ 843, 0, 2, "case_clause_list-1", -1, 1, copy_144, 2,  },
	{ 843, 1, 1, "case_clause_list-2", -1, 1, copy_145, 1,  },
	{ 843, 2, 1, "case_clause_list-3", -1, 1, copy_146, 1,  },
	{ 844, 0, 1, "statement-1", -1, 1, copy_147, 1,  },
	{ 844, 1, 2, "statement-2", -1, 1, copy_148, 2,  },
	{ 844, 2, 7, "statement-3", -1, 1, copy_149, 7,  },
	{ 844, 3, 4, "statement-4", -1, 1, copy_150, 4,  },
	{ 844, 4, 3, "statement-5", -1, 1, copy_151, 3,  },
	{ 844, 5, 5, "statement-6", -1, 1, copy_152, 5,  },
	{ 844, 6, 3, "statement-7", -1, 1, copy_153, 3,  },
	{ 844, 7, 3, "statement-8", -1, 1, copy_154, 3,  },
	{ 844, 8, 2, "statement-9", -1, 1, copy_155, 2,  },
	{ 844, 9, 2, "statement-10", -1, 1, copy_156, 2,  },
	{ 844, 10, 1, "statement-11", -1, 1, copy_157, 1,  },
	{ 844, 11, 1, "statement-12", -1, 1, copy_158, 1,  },
	{ 844, 12, 4, "statement-13", -1, 1, copy_159, 4,  },
	{ 844, 13, 1, "statement-14", -1, 1, copy_160, 1,  },
	{ 844, 14, 2, "statement-15", -1, 1, copy_161, 2,  },
	{ 845, 0, 2, "elsif_list-1", -1, 1, copy_162, 2,  },
	{ 845, 1, 1, "elsif_list-2", -1, 1, copy_163, 1,  },
	{ 846, 0, 3, "elsif_clause-1", -1, 1, copy_164, 3,  },
	{ 847, 0, 2, "optional_else-1", -1, 1, copy_165, 2,  },
	{ 847, 1, 0, "optional_else-2", -1, 1, 0, 0,  },
	{ 848, 0, 3, "call_arg_seq-1", -1, 1, copy_167, 3,  },
	{ 848, 1, 1, "call_arg_seq-2", -1, 1, copy_168, 1,  },
	{ 849, 0, 1, "call_arg_list-1", -1, 1, copy_169, 1,  },
	{ 849, 1, 0, "call_arg_list-2", -1, 1, 0, 0,  },
	{ 850, 0, 5, "iter_call-1", -1, 1, copy_171, 5,  },
	{ 850, 1, 2, "iter_call-2", -1, 1, copy_172, 2,  },
	{ 850, 2, 2, "iter_call-3", -1, 1, copy_173, 2,  },
	{ 851, 0, 3, "block_or_single-1", -1, 1, copy_174, 3,  },
	{ 851, 1, 1, "block_or_single-2", -1, 1, copy_175, 1,  },
	{ 852, 0, 3, "require_pattern-1", -1, 1, copy_176, 3,  },
	{ 853, 0, 2, "opt_require_stmt-1", -1, 1, copy_177, 2,  },
	{ 853, 1, 0, "opt_require_stmt-2", -1, 1, 0, 0,  },
	{ 854, 0, 2, "lang_stmt_list-1", -1, 1, copy_179, 2,  },
	{ 855, 0, 2, "opt_def_init-1", -1, 1, copy_180, 2,  },
	{ 855, 1, 0, "opt_def_init-2", -1, 1, 0, 0,  },
	{ 856, 0, 3, "var_def-1", -1, 1, copy_182, 3,  },
	{ 857, 0, 4, "print_stmt-1", -1, 1, copy_183, 4,  },
	{ 857, 1, 6, "print_stmt-2", -1, 1, copy_184, 6,  },
	{ 857, 2, 2, "print_stmt-3", -1, 1, copy_185, 2,  },
	{ 858, 0, 1, "expr_stmt-1", -1, 1, copy_186, 1,  },
	{ 859, 0, 3, "code_expr-1", -1, 1, copy_187, 3,  },
	{ 859, 1, 3, "code_expr-2", -1, 1, copy_188, 3,  },
	{ 859, 2, 1, "code_expr-3", -1, 1, copy_189, 1,  },
	{ 860, 0, 3, "code_relational-1", -1, 1, copy_190, 3,  },
	{ 860, 1, 3, "code_relational-2", -1, 1, copy_191, 3,  },
	{ 860, 2, 3, "code_relational-3", -1, 1, copy_192, 3,  },
	{ 860, 3, 3, "code_relational-4", -1, 1, copy_193, 3,  },
	{ 860, 4, 3, "code_relational-5", -1, 1, copy_194, 3,  },
	{ 860, 5, 3, "code_relational-6", -1, 1, copy_195, 3,  },
	{ 860, 6, 1, "code_relational-7", -1, 1, copy_196, 1,  },
	{ 861, 0, 3, "code_additive-1", -1, 1, copy_197, 3,  },
	{ 861, 1, 3, "code_additive-2", -1, 1, copy_198, 3,  },
	{ 861, 2, 1, "code_additive-3", -1, 1, copy_199, 1,  },
	{ 862, 0, 3, "code_multiplicitive-1", -1, 1, copy_200, 3,  },
	{ 862, 1, 3, "code_multiplicitive-2", -1, 1, copy_201, 3,  },
	{ 862, 2, 1, "code_multiplicitive-3", -1, 1, copy_202, 1,  },
	{ 863, 0, 2, "code_unary-1", -1, 1, copy_203, 2,  },
	{ 863, 1, 2, "code_unary-2", -1, 1, copy_204, 2,  },
	{ 863, 2, 3, "code_unary-3", -1, 1, copy_205, 3,  },
	{ 863, 3, 2, "code_unary-4", -1, 1, copy_206, 2,  },
	{ 863, 4, 2, "code_unary-5", -1, 1, copy_207, 2,  },
	{ 863, 5, 1, "code_unary-6", -1, 1, copy_208, 1,  },
	{ 864, 0, 1, "opt_eos-1", -1, 1, copy_209, 1,  },
	{ 864, 1, 1, "opt_eos-2", -1, 1, copy_210, 1,  },
	{ 864, 2, 0, "opt_eos-3", -1, 1, 0, 0,  },
	{ 865, 0, 1, "code_factor-1", -1, 1, copy_212, 1,  },
	{ 865, 1, 4, "code_factor-2", -1, 1, copy_213, 4,  },
	{ 865, 2, 1, "code_factor-3", -1, 1, copy_214, 1,  },
	{ 865, 3, 1, "code_factor-4", -1, 1, copy_215, 1,  },
	{ 865, 4, 1, "code_factor-5", -1, 1, copy_216, 1,  },
	{ 865, 5, 1, "code_factor-6", -1, 1, copy_217, 1,  },
	{ 865, 6, 3, "code_factor-7", -1, 1, copy_218, 3,  },
	{ 865, 7, 1, "code_factor-8", -1, 1, copy_219, 1,  },
	{ 865, 8, 3, "code_factor-9", -1, 1, copy_220, 3,  },
	{ 865, 9, 4, "code_factor-10", -1, 1, copy_221, 4,  },
	{ 865, 10, 5, "code_factor-11", -1, 1, copy_222, 5,  },
	{ 865, 11, 1, "code_factor-12", -1, 1, copy_223, 1,  },
	{ 866, 0, 3, "type_ref-1", -1, 1, copy_224, 3,  },
	{ 866, 1, 1, "type_ref-2", -1, 1, copy_225, 1,  },
	{ 866, 2, 1, "type_ref-3", -1, 1, copy_226, 1,  },
	{ 866, 3, 1, "type_ref-4", -1, 1, copy_227, 1,  },
	{ 866, 4, 4, "type_ref-5", -1, 1, copy_228, 4,  },
	{ 866, 5, 4, "type_ref-6", -1, 1, copy_229, 4,  },
	{ 866, 6, 6, "type_ref-7", -1, 1, copy_230, 6,  },
	{ 866, 7, 4, "type_ref-8", -1, 1, copy_231, 4,  },
	{ 866, 8, 6, "type_ref-9", -1, 1, copy_232, 6,  },
	{ 867, 0, 3, "region_qual-1", -1, 1, copy_233, 3,  },
	{ 867, 1, 0, "region_qual-2", -1, 1, 0, 0,  },
	{ 868, 0, 1, "opt_repeat-1", -1, 1, copy_235, 1,  },
	{ 868, 1, 1, "opt_repeat-2", -1, 1, copy_236, 1,  },
	{ 868, 2, 1, "opt_repeat-3", -1, 1, copy_237, 1,  },
	{ 868, 3, 0, "opt_repeat-4", -1, 1, 0, 0,  },
	{ 869, 0, 2, "opt_capture-1", -1, 1, copy_239, 2,  },
	{ 869, 1, 0, "opt_capture-2", -1, 1, 0, 0,  },
	{ 870, 0, 3, "opt_field_init-1", -1, 1, copy_241, 3,  },
	{ 870, 1, 0, "opt_field_init-2", -1, 1, 0, 0,  },
	{ 871, 0, 1, "field_init-1", -1, 1, copy_243, 1,  },
	{ 872, 0, 5, "stmt_or_factor-1", -1, 1, copy_244, 5,  },
	{ 872, 1, 5, "stmt_or_factor-2", -1, 1, copy_245, 5,  },
	{ 872, 2, 5, "stmt_or_factor-3", -1, 1, copy_246, 5,  },
	{ 872, 3, 5, "stmt_or_factor-4", -1, 1, copy_247, 5,  },
	{ 872, 4, 5, "stmt_or_factor-5", -1, 1, copy_248, 5,  },
	{ 872, 5, 4, "stmt_or_factor-6", -1, 1, copy_249, 4,  },
	{ 872, 6, 4, "stmt_or_factor-7", -1, 1, copy_250, 4,  },
	{ 872, 7, 4, "stmt_or_factor-8", -1, 1, copy_251, 4,  },
	{ 872, 8, 4, "stmt_or_factor-9", -1, 1, copy_252, 4,  },
	{ 872, 9, 5, "stmt_or_factor-10", -1, 1, copy_253, 5,  },
	{ 872, 10, 3, "stmt_or_factor-11", -1, 1, copy_254, 3,  },
	{ 872, 11, 6, "stmt_or_factor-12", -1, 1, copy_255, 6,  },
	{ 873, 0, 2, "opt_label-1", -1, 1, copy_256, 2,  },
	{ 873, 1, 0, "opt_label-2", -1, 1, 0, 0,  },
	{ 874, 0, 1, "dq_lit_term-1", -1, 1, copy_258, 1,  },
	{ 874, 1, 1, "dq_lit_term-2", -1, 1, copy_259, 1,  },
	{ 875, 0, 1, "sq_lit_term-1", -1, 1, copy_260, 1,  },
	{ 875, 1, 1, "sq_lit_term-2", -1, 1, copy_261, 1,  },
	{ 876, 0, 1, "opt_tilde_data-1", -1, 1, copy_262, 1,  },
	{ 876, 1, 0, "opt_tilde_data-2", -1, 1, 0, 0,  },
	{ 877, 0, 3, "pattern_el_lel-1", -1, 1, copy_264, 3,  },
	{ 877, 1, 3, "pattern_el_lel-2", -1, 1, copy_265, 3,  },
	{ 878, 0, 2, "pattern_el-1", -1, 1, copy_266, 2,  },
	{ 878, 1, 3, "pattern_el-2", -1, 1, copy_267, 3,  },
	{ 878, 2, 3, "pattern_el-3", -1, 1, copy_268, 3,  },
	{ 878, 3, 3, "pattern_el-4", -1, 1, copy_269, 3,  },
	{ 879, 0, 1, "litpat_el-1", -1, 1, copy_270, 1,  },
	{ 879, 1, 3, "litpat_el-2", -1, 1, copy_271, 3,  },
	{ 880, 0, 3, "pattern_top_el-1", -1, 1, copy_272, 3,  },
	{ 880, 1, 3, "pattern_top_el-2", -1, 1, copy_273, 3,  },
	{ 880, 2, 3, "pattern_top_el-3", -1, 1, copy_274, 3,  },
	{ 880, 3, 3, "pattern_top_el-4", -1, 1, copy_275, 3,  },
	{ 881, 0, 1, "pattern_list-1", -1, 1, copy_276, 1,  },
	{ 882, 0, 1, "pattern-1", -1, 1, copy_277, 1,  },
	{ 883, 0, 1, "opt_no_trim-1", -1, 1, copy_278, 1,  },
	{ 883, 1, 0, "opt_no_trim-2", -1, 1, 0, 0,  },
	{ 884, 0, 0, "E1-1", -1, 1, 0, 0,  },
	{ 885, 0, 0, "E2-1", -1, 1, 0, 0,  },
	{ 886, 0, 0, "E3-1", -1, 1, 0, 0,  },
	{ 887, 0, 0, "E4-1", -1, 1, 0, 0,  },
	{ 888, 0, 3, "cons_el-1", -1, 1, copy_284, 3,  },
	{ 888, 1, 4, "cons_el-2", -1, 1, copy_285, 4,  },
	{ 888, 2, 4, "cons_el-3", -1, 1, copy_286, 4,  },
	{ 888, 3, 4, "cons_el-4", -1, 1, copy_287, 4,  },
	{ 888, 4, 3, "cons_el-5", -1, 1, copy_288, 3,  },
	{ 889, 0, 1, "lit_cons_el-1", -1, 1, copy_289, 1,  },
	{ 889, 1, 3, "lit_cons_el-2", -1, 1, copy_290, 3,  },
	{ 890, 0, 3, "cons_top_el-1", -1, 1, copy_291, 3,  },
	{ 890, 1, 3, "cons_top_el-2", -1, 1, copy_292, 3,  },
	{ 890, 2, 3, "cons_top_el-3", -1, 1, copy_293, 3,  },
	{ 890, 3, 3, "cons_top_el-4", -1, 1, copy_294, 3,  },
	{ 891, 0, 1, "cons_list-1", -1, 1, copy_295, 1,  },
	{ 892, 0, 1, "constructor-1", -1, 1, copy_296, 1,  },
	{ 893, 0, 4, "accum_el-1", -1, 1, copy_297, 4,  },
	{ 893, 1, 4, "accum_el-2", -1, 1, copy_298, 4,  },
	{ 893, 2, 4, "accum_el-3", -1, 1, copy_299, 4,  },
	{ 893, 3, 3, "accum_el-4", -1, 1, copy_300, 3,  },
	{ 894, 0, 1, "lit_accum_el-1", -1, 1, copy_301, 1,  },
	{ 894, 1, 3, "lit_accum_el-2", -1, 1, copy_302, 3,  },
	{ 895, 0, 3, "accum_top_el-1", -1, 1, copy_303, 3,  },
	{ 895, 1, 3, "accum_top_el-2", -1, 1, copy_304, 3,  },
	{ 895, 2, 3, "accum_top_el-3", -1, 1, copy_305, 3,  },
	{ 895, 3, 3, "accum_top_el-4", -1, 1, copy_306, 3,  },
	{ 896, 0, 2, "accum_list-1", -1, 1, copy_307, 2,  },
	{ 896, 1, 1, "accum_list-2", -1, 1, copy_308, 1,  },
	{ 897, 0, 1, "accumulate-1", -1, 1, copy_309, 1,  },
	{ 898, 0, 4, "string_el-1", -1, 1, copy_310, 4,  },
	{ 898, 1, 4, "string_el-2", -1, 1, copy_311, 4,  },
	{ 898, 2, 4, "string_el-3", -1, 1, copy_312, 4,  },
	{ 898, 3, 3, "string_el-4", -1, 1, copy_313, 3,  },
	{ 899, 0, 1, "lit_string_el-1", -1, 1, copy_314, 1,  },
	{ 899, 1, 3, "lit_string_el-2", -1, 1, copy_315, 3,  },
	{ 900, 0, 3, "string_top_el-1", -1, 1, copy_316, 3,  },
	{ 900, 1, 3, "string_top_el-2", -1, 1, copy_317, 3,  },
	{ 900, 2, 3, "string_top_el-3", -1, 1, copy_318, 3,  },
	{ 900, 3, 3, "string_top_el-4", -1, 1, copy_319, 3,  },
	{ 901, 0, 1, "string_list-1", -1, 1, copy_320, 1,  },
	{ 902, 0, 1, "string-1", -1, 1, copy_321, 1,  },
	{ 903, 0, 3, "var_ref-1", -1, 1, copy_322, 3,  },
	{ 904, 0, 3, "qual-1", -1, 1, copy_323, 3,  },
	{ 904, 1, 3, "qual-2", -1, 1, copy_324, 3,  },
	{ 904, 2, 0, "qual-3", -1, 1, 0, 0,  },
	{ 905, 0, 3, "lex_expr-1", -1, 1, copy_326, 3,  },
	{ 905, 1, 3, "lex_expr-2", -1, 1, copy_327, 3,  },
	{ 905, 2, 3, "lex_expr-3", -1, 1, copy_328, 3,  },
	{ 905, 3, 3, "lex_expr-4", -1, 1, copy_329, 3,  },
	{ 905, 4, 1, "lex_expr-5", -1, 1, copy_330, 1,  },
	{ 906, 0, 1, "opt_lex_dot-1", -1, 1, copy_331, 1,  },
	{ 906, 1, 0, "opt_lex_dot-2", -1, 1, 0, 0,  },
	{ 907, 0, 3, "lex_term-1", -1, 1, copy_333, 3,  },
	{ 907, 1, 3, "lex_term-2", -1, 1, copy_334, 3,  },
	{ 907, 2, 3, "lex_term-3", -1, 1, copy_335, 3,  },
	{ 907, 3, 3, "lex_term-4", -1, 1, copy_336, 3,  },
	{ 907, 4, 1, "lex_term-5", -1, 1, copy_337, 1,  },
	{ 908, 0, 2, "lex_factor_rep-1", -1, 1, copy_338, 2,  },
	{ 908, 1, 2, "lex_factor_rep-2", -1, 1, copy_339, 2,  },
	{ 908, 2, 2, "lex_factor_rep-3", -1, 1, copy_340, 2,  },
	{ 908, 3, 2, "lex_factor_rep-4", -1, 1, copy_341, 2,  },
	{ 908, 4, 4, "lex_factor_rep-5", -1, 1, copy_342, 4,  },
	{ 908, 5, 5, "lex_factor_rep-6", -1, 1, copy_343, 5,  },
	{ 908, 6, 5, "lex_factor_rep-7", -1, 1, copy_344, 5,  },
	{ 908, 7, 6, "lex_factor_rep-8", -1, 1, copy_345, 6,  },
	{ 908, 8, 1, "lex_factor_rep-9", -1, 1, copy_346, 1,  },
	{ 909, 0, 2, "lex_factor_neg-1", -1, 1, copy_347, 2,  },
	{ 909, 1, 1, "lex_factor_neg-2", -1, 1, copy_348, 1,  },
	{ 910, 0, 1, "lex_range_lit-1", -1, 1, copy_349, 1,  },
	{ 910, 1, 1, "lex_range_lit-2", -1, 1, copy_350, 1,  },
	{ 911, 0, 1, "lex_num-1", -1, 1, copy_351, 1,  },
	{ 911, 1, 1, "lex_num-2", -1, 1, copy_352, 1,  },
	{ 912, 0, 1, "lex_factor-1", -1, 1, copy_353, 1,  },
	{ 912, 1, 1, "lex_factor-2", -1, 1, copy_354, 1,  },
	{ 912, 2, 1, "lex_factor-3", -1, 1, copy_355, 1,  },
	{ 912, 3, 1, "lex_factor-4", -1, 1, copy_356, 1,  },
	{ 912, 4, 3, "lex_factor-5", -1, 1, copy_357, 3,  },
	{ 912, 5, 3, "lex_factor-6", -1, 1, copy_358, 3,  },
	{ 912, 6, 3, "lex_factor-7", -1, 1, copy_359, 3,  },
	{ 912, 7, 3, "lex_factor-8", -1, 1, copy_360, 3,  },
	{ 913, 0, 2, "reg_or_data-1", -1, 1, copy_361, 2,  },
	{ 913, 1, 0, "reg_or_data-2", -1, 1, 0, 0,  },
	{ 914, 0, 1, "reg_or_char-1", -1, 1, copy_363, 1,  },
	{ 914, 1, 3, "reg_or_char-2", -1, 1, copy_364, 3,  },
	{ 915, 0, 2, "_repeat_root_item-1", -1, 1, 0, 0,  },
	{ 915, 1, 0, "_repeat_root_item-2", -1, 1, 0, 0,  },
	{ 916, 0, 2, "_repeat_sq_cons_data-1", -1, 1, 0, 0,  },
	{ 916, 1, 0, "_repeat_sq_cons_data-2", -1, 1, 0, 0,  },
	{ 917, 0, 2, "_repeat_struct_item-1", -1, 1, 0, 0,  },
	{ 917, 1, 0, "_repeat_struct_item-2", -1, 1, 0, 0,  },
	{ 918, 0, 2, "_repeat_reduction_item-1", -1, 1, 0, 0,  },
	{ 918, 1, 0, "_repeat_reduction_item-2", -1, 1, 0, 0,  },
	{ 919, 0, 2, "_repeat_host_item-1", -1, 1, 0, 0,  },
	{ 919, 1, 0, "_repeat_host_item-2", -1, 1, 0, 0,  },
	{ 920, 0, 2, "_repeat_namespace_item-1", -1, 1, 0, 0,  },
	{ 920, 1, 0, "_repeat_namespace_item-2", -1, 1, 0, 0,  },
	{ 921, 0, 2, "_repeat_var_def-1", -1, 1, 0, 0,  },
	{ 921, 1, 0, "_repeat_var_def-2", -1, 1, 0, 0,  },
	{ 922, 0, 2, "_repeat_statement-1", -1, 1, 0, 0,  },
	{ 922, 1, 0, "_repeat_statement-2", -1, 1, 0, 0,  },
	{ 923, 0, 2, "_repeat_field_init-1", -1, 1, 0, 0,  },
	{ 923, 1, 0, "_repeat_field_init-2", -1, 1, 0, 0,  },
	{ 924, 0, 2, "_repeat_litpat_el-1", -1, 1, 0, 0,  },
	{ 924, 1, 0, "_repeat_litpat_el-2", -1, 1, 0, 0,  },
	{ 925, 0, 2, "_repeat_pattern_el-1", -1, 1, 0, 0,  },
	{ 925, 1, 0, "_repeat_pattern_el-2", -1, 1, 0, 0,  },
	{ 926, 0, 2, "_repeat_lit_cons_el-1", -1, 1, 0, 0,  },
	{ 926, 1, 0, "_repeat_lit_cons_el-2", -1, 1, 0, 0,  },
	{ 927, 0, 2, "_repeat_cons_el-1", -1, 1, 0, 0,  },
	{ 927, 1, 0, "_repeat_cons_el-2", -1, 1, 0, 0,  },
	{ 928, 0, 2, "_repeat_lit_accum_el-1", -1, 1, 0, 0,  },
	{ 928, 1, 0, "_repeat_lit_accum_el-2", -1, 1, 0, 0,  },
	{ 929, 0, 2, "_repeat_accum_el-1", -1, 1, 0, 0,  },
	{ 929, 1, 0, "_repeat_accum_el-2", -1, 1, 0, 0,  },
	{ 930, 0, 2, "_repeat_lit_string_el-1", -1, 1, 0, 0,  },
	{ 930, 1, 0, "_repeat_lit_string_el-2", -1, 1, 0, 0,  },
	{ 931, 0, 2, "_repeat_string_el-1", -1, 1, 0, 0,  },
	{ 931, 1, 0, "_repeat_string_el-2", -1, 1, 0, 0,  },
	{ 932, 0, 1, "_root-1", -1, 1, 0, 0,  },
	{ 932, 1, 1, "_root-2", -1, 1, 0, 0,  },
	{ 932, 2, 1, "_root-3", -1, 1, 0, 0,  },
	{ 932, 3, 1, "_root-4", -1, 1, 0, 0,  },
	{ 932, 4, 1, "_root-5", -1, 1, 0, 0,  },
	{ 932, 5, 1, "_root-6", -1, 1, 0, 0,  },
	{ 932, 6, 1, "_root-7", -1, 1, 0, 0,  },
	{ 932, 7, 1, "_root-8", -1, 1, 0, 0,  },
	{ 932, 8, 1, "_root-9", -1, 1, 0, 0,  },
	{ 932, 9, 1, "_root-10", -1, 1, 0, 0,  },
	{ 932, 10, 1, "_root-11", -1, 1, 0, 0,  },
	{ 932, 11, 1, "_root-12", -1, 1, 0, 0,  },
	{ 932, 12, 1, "_root-13", -1, 1, 0, 0,  },
	{ 932, 13, 1, "_root-14", -1, 1, 0, 0,  },
	{ 932, 14, 1, "_root-15", -1, 1, 0, 0,  },
	{ 932, 15, 1, "_root-16", -1, 1, 0, 0,  },
	{ 932, 16, 1, "_root-17", -1, 1, 0, 0,  },
	{ 932, 17, 1, "_root-18", -1, 1, 0, 0,  },
	{ 932, 18, 1, "_root-19", -1, 1, 0, 0,  },
	{ 932, 19, 1, "_root-20", -1, 1, 0, 0,  },
	{ 932, 20, 1, "_root-21", -1, 1, 0, 0,  },
	{ 932, 21, 1, "_root-22", -1, 1, 0, 0,  },
	{ 932, 22, 1, "_root-23", -1, 1, 0, 0,  },
	{ 932, 23, 1, "_root-24", -1, 1, 0, 0,  },
	{ 932, 24, 1, "_root-25", -1, 1, 0, 0,  },
	{ 932, 25, 1, "_root-26", -1, 1, 0, 0,  },
	{ 932, 26, 1, "_root-27", -1, 1, 0, 0,  },
	{ 932, 27, 1, "_root-28", -1, 1, 0, 0,  },
	{ 932, 28, 1, "_root-29", -1, 1, 0, 0,  },
	{ 932, 29, 1, "_root-30", -1, 1, 0, 0,  },
	{ 932, 30, 1, "_root-31", -1, 1, 0, 0,  },
	{ 932, 31, 1, "_root-32", -1, 1, 0, 0,  },
	{ 932, 32, 1, "_root-33", -1, 1, 0, 0,  },
	{ 932, 33, 1, "_root-34", -1, 1, 0, 0,  },
	{ 932, 34, 1, "_root-35", -1, 1, 0, 0,  },
	{ 932, 35, 1, "_root-36", -1, 1, 0, 0,  },
	{ 932, 36, 1, "_root-37", -1, 1, 0, 0,  },
	{ 932, 37, 1, "_root-38", -1, 1, 0, 0,  },
	{ 932, 38, 1, "_root-39", -1, 1, 0, 0,  },
	{ 932, 39, 1, "_root-40", -1, 1, 0, 0,  },
	{ 932, 40, 1, "_root-41", -1, 1, 0, 0,  },
	{ 932, 41, 1, "_root-42", -1, 1, 0, 0,  },
	{ 932, 42, 1, "_root-43", -1, 1, 0, 0,  },
	{ 932, 43, 1, "_root-44", -1, 1, 0, 0,  },
	{ 932, 44, 1, "_root-45", -1, 1, 0, 0,  },
	{ 932, 45, 1, "_root-46", -1, 1, 0, 0,  },
	{ 932, 46, 1, "_root-47", -1, 1, 0, 0,  },
	{ 932, 47, 1, "_root-48", -1, 1, 0, 0,  },
	{ 932, 48, 1, "_root-49", -1, 1, 0, 0,  },
	{ 932, 49, 1, "_root-50", -1, 1, 0, 0,  },
	{ 932, 50, 1, "_root-51", -1, 1, 0, 0,  },
	{ 932, 51, 1, "_root-52", -1, 1, 0, 0,  },
	{ 932, 52, 1, "_root-53", -1, 1, 0, 0,  },
	{ 932, 53, 1, "_root-54", -1, 1, 0, 0,  },
	{ 932, 54, 1, "_root-55", -1, 1, 0, 0,  },
	{ 932, 55, 1, "_root-56", -1, 1, 0, 0,  },
	{ 932, 56, 1, "_root-57", -1, 1, 0, 0,  },
	{ 932, 57, 1, "_root-58", -1, 1, 0, 0,  },
	{ 932, 58, 1, "_root-59", -1, 1, 0, 0,  },
	{ 932, 59, 1, "_root-60", -1, 1, 0, 0,  },
	{ 932, 60, 1, "_root-61", -1, 1, 0, 0,  },
	{ 932, 61, 1, "_root-62", -1, 1, 0, 0,  },
	{ 932, 62, 1, "_root-63", -1, 1, 0, 0,  },
	{ 932, 63, 1, "_root-64", -1, 1, 0, 0,  },
	{ 932, 64, 1, "_root-65", -1, 1, 0, 0,  },
	{ 932, 65, 1, "_root-66", -1, 1, 0, 0,  },
	{ 932, 66, 1, "_root-67", -1, 1, 0, 0,  },
	{ 932, 67, 1, "_root-68", -1, 1, 0, 0,  },
	{ 932, 68, 1, "_root-69", -1, 1, 0, 0,  },
	{ 932, 69, 1, "_root-70", -1, 1, 0, 0,  },
	{ 932, 70, 1, "_root-71", -1, 1, 0, 0,  },
	{ 932, 71, 1, "_root-72", -1, 1, 0, 0,  },
	{ 932, 72, 1, "_root-73", -1, 1, 0, 0,  },
	{ 932, 73, 1, "_root-74", -1, 1, 0, 0,  },
	{ 932, 74, 1, "_root-75", -1, 1, 0, 0,  },
	{ 932, 75, 1, "_root-76", -1, 1, 0, 0,  },
	{ 932, 76, 1, "_root-77", -1, 1, 0, 0,  },
	{ 932, 77, 1, "_root-78", -1, 1, 0, 0,  },
	{ 932, 78, 1, "_root-79", -1, 1, 0, 0,  },
	{ 932, 79, 1, "_root-80", -1, 1, 0, 0,  },
	{ 932, 80, 1, "_root-81", -1, 1, 0, 0,  },
	{ 932, 81, 1, "_root-82", -1, 1, 0, 0,  },
	{ 932, 82, 1, "_root-83", -1, 1, 0, 0,  },
	{ 932, 83, 1, "_root-84", -1, 1, 0, 0,  },
	{ 932, 84, 1, "_root-85", -1, 1, 0, 0,  },
	{ 932, 85, 1, "_root-86", -1, 1, 0, 0,  },
	{ 932, 86, 1, "_root-87", -1, 1, 0, 0,  },
	{ 932, 87, 1, "_root-88", -1, 1, 0, 0,  },
	{ 932, 88, 1, "_root-89", -1, 1, 0, 0,  },
	{ 932, 89, 1, "_root-90", -1, 1, 0, 0,  },
	{ 932, 90, 1, "_root-91", -1, 1, 0, 0,  },
	{ 932, 91, 1, "_root-92", -1, 1, 0, 0,  },
	{ 932, 92, 1, "_root-93", -1, 1, 0, 0,  },
	{ 932, 93, 1, "_root-94", -1, 1, 0, 0,  },
	{ 932, 94, 1, "_root-95", -1, 1, 0, 0,  },
	{ 932, 95, 1, "_root-96", -1, 1, 0, 0,  },
	{ 932, 96, 1, "_root-97", -1, 1, 0, 0,  },
	{ 932, 97, 1, "_root-98", -1, 1, 0, 0,  },
	{ 932, 98, 1, "_root-99", -1, 1, 0, 0,  },
	{ 932, 99, 1, "_root-100", -1, 1, 0, 0,  },
	{ 932, 100, 1, "_root-101", -1, 1, 0, 0,  },
	{ 932, 101, 1, "_root-102", -1, 1, 0, 0,  },
	{ 932, 102, 1, "_root-103", -1, 1, 0, 0,  },
	{ 932, 103, 1, "_root-104", -1, 1, 0, 0,  },
	{ 932, 104, 1, "_root-105", -1, 1, 0, 0,  },
	{ 932, 105, 1, "_root-106", -1, 1, 0, 0,  },
	{ 932, 106, 1, "_root-107", -1, 1, 0, 0,  },
	{ 932, 107, 1, "_root-108", -1, 1, 0, 0,  },
	{ 932, 108, 1, "_root-109", -1, 1, 0, 0,  },
	{ 932, 109, 1, "_root-110", -1, 1, 0, 0,  },
	{ 932, 110, 1, "_root-111", -1, 1, 0, 0,  },
	{ 932, 111, 1, "_root-112", -1, 1, 0, 0,  },
	{ 932, 112, 1, "_root-113", -1, 1, 0, 0,  },
	{ 932, 113, 1, "_root-114", -1, 1, 0, 0,  },
	{ 932, 114, 1, "_root-115", -1, 1, 0, 0,  },
	{ 932, 115, 1, "_root-116", -1, 1, 0, 0,  },
	{ 932, 116, 1, "_root-117", -1, 1, 0, 0,  },
	{ 932, 117, 1, "_root-118", -1, 1, 0, 0,  },
	{ 932, 118, 1, "_root-119", -1, 1, 0, 0,  },
	{ 932, 119, 1, "_root-120", -1, 1, 0, 0,  },
	{ 932, 120, 1, "_root-121", -1, 1, 0, 0,  },
	{ 932, 121, 1, "_root-122", -1, 1, 0, 0,  },
	{ 932, 122, 1, "_root-123", -1, 1, 0, 0,  },
	{ 932, 123, 1, "_root-124", -1, 1, 0, 0,  },
	{ 932, 124, 1, "_root-125", -1, 1, 0, 0,  },
	{ 932, 125, 1, "_root-126", -1, 1, 0, 0,  },
	{ 932, 126, 1, "_root-127", -1, 1, 0, 0,  },
	{ 932, 127, 1, "_root-128", -1, 1, 0, 0,  },
	{ 932, 128, 1, "_root-129", -1, 1, 0, 0,  },
	{ 932, 129, 1, "_root-130", -1, 1, 0, 0,  },
	{ 932, 130, 1, "_root-131", -1, 1, 0, 0,  },
	{ 932, 131, 1, "_root-132", -1, 1, 0, 0,  },
	{ 932, 132, 1, "_root-133", -1, 1, 0, 0,  },
	{ 932, 133, 1, "_root-134", -1, 1, 0, 0,  },
	{ 932, 134, 1, "_root-135", -1, 1, 0, 0,  },
	{ 932, 135, 1, "_root-136", -1, 1, 0, 0,  },
	{ 932, 136, 1, "_root-137", -1, 1, 0, 0,  },
	{ 932, 137, 1, "_root-138", -1, 1, 0, 0,  },
	{ 932, 138, 1, "_root-139", -1, 1, 0, 0,  },
	{ 932, 139, 1, "_root-140", -1, 1, 0, 0,  },
	{ 932, 140, 1, "_root-141", -1, 1, 0, 0,  },
	{ 932, 141, 1, "_root-142", -1, 1, 0, 0,  },
	{ 932, 142, 1, "_root-143", -1, 1, 0, 0,  },
	{ 932, 143, 1, "_root-144", -1, 1, 0, 0,  },
	{ 932, 144, 1, "_root-145", -1, 1, 0, 0,  },
	{ 932, 145, 1, "_root-146", -1, 1, 0, 0,  },
	{ 932, 146, 1, "_root-147", -1, 1, 0, 0,  },
	{ 932, 147, 1, "_root-148", -1, 1, 0, 0,  },
	{ 932, 148, 1, "_root-149", -1, 1, 0, 0,  },
	{ 932, 149, 1, "_root-150", -1, 1, 0, 0,  },
	{ 932, 150, 1, "_root-151", -1, 1, 0, 0,  },
	{ 932, 151, 1, "_root-152", -1, 1, 0, 0,  },
	{ 932, 152, 1, "_root-153", -1, 1, 0, 0,  },
	{ 932, 153, 1, "_root-154", -1, 1, 0, 0,  },
	{ 932, 154, 1, "_root-155", -1, 1, 0, 0,  },
	{ 932, 155, 1, "_root-156", -1, 1, 0, 0,  },
	{ 932, 156, 1, "_root-157", -1, 1, 0, 0,  },
	{ 932, 157, 1, "_root-158", -1, 1, 0, 0,  },
	{ 932, 158, 1, "_root-159", -1, 1, 0, 0,  },
	{ 932, 159, 1, "_root-160", -1, 1, 0, 0,  },
	{ 932, 160, 1, "_root-161", -1, 1, 0, 0,  },
	{ 932, 161, 1, "_root-162", -1, 1, 0, 0,  },
	{ 932, 162, 1, "_root-163", -1, 1, 0, 0,  },
	{ 932, 163, 1, "_root-164", -1, 1, 0, 0,  },
	{ 932, 164, 1, "_root-165", -1, 1, 0, 0,  },
	{ 932, 165, 1, "_root-166", -1, 1, 0, 0,  },
	{ 932, 166, 1, "_root-167", -1, 1, 0, 0,  },
	{ 932, 167, 1, "_root-168", -1, 1, 0, 0,  },
	{ 932, 168, 1, "_root-169", -1, 1, 0, 0,  },
	{ 932, 169, 1, "_root-170", -1, 1, 0, 0,  },
	{ 932, 170, 1, "_root-171", -1, 1, 0, 0,  },
	{ 932, 171, 1, "_root-172", -1, 1, 0, 0,  },
	{ 932, 172, 1, "_root-173", -1, 1, 0, 0,  },
	{ 932, 173, 1, "_root-174", -1, 1, 0, 0,  },
	{ 932, 174, 1, "_root-175", -1, 1, 0, 0,  },
	{ 932, 175, 1, "_root-176", -1, 1, 0, 0,  },
	{ 932, 176, 1, "_root-177", -1, 1, 0, 0,  },
	{ 932, 177, 1, "_root-178", -1, 1, 0, 0,  },
	{ 932, 178, 1, "_root-179", -1, 1, 0, 0,  },
	{ 932, 179, 1, "_root-180", -1, 1, 0, 0,  },
	{ 932, 180, 1, "_root-181", -1, 1, 0, 0,  },
	{ 932, 181, 1, "_root-182", -1, 1, 0, 0,  },
	{ 932, 182, 1, "_root-183", -1, 1, 0, 0,  },
	{ 932, 183, 1, "_root-184", -1, 1, 0, 0,  },
	{ 932, 184, 1, "_root-185", -1, 1, 0, 0,  },
	{ 932, 185, 1, "_root-186", -1, 1, 0, 0,  },
	{ 932, 186, 1, "_root-187", -1, 1, 0, 0,  },
	{ 932, 187, 1, "_root-188", -1, 1, 0, 0,  },
	{ 932, 188, 1, "_root-189", -1, 1, 0, 0,  },
	{ 932, 189, 1, "_root-190", -1, 1, 0, 0,  },
	{ 932, 190, 1, "_root-191", -1, 1, 0, 0,  },
	{ 932, 191, 1, "_root-192", -1, 1, 0, 0,  },
	{ 932, 192, 1, "_root-193", -1, 1, 0, 0,  },
	{ 932, 193, 1, "_root-194", -1, 1, 0, 0,  },
	{ 932, 194, 1, "_root-195", -1, 1, 0, 0,  },
	{ 932, 195, 1, "_root-196", -1, 1, 0, 0,  },
	{ 932, 196, 1, "_root-197", -1, 1, 0, 0,  },
	{ 932, 197, 1, "_root-198", -1, 1, 0, 0,  },
	{ 932, 198, 1, "_root-199", -1, 1, 0, 0,  },
	{ 932, 199, 1, "_root-200", -1, 1, 0, 0,  },
	{ 932, 200, 1, "_root-201", -1, 1, 0, 0,  },
	{ 932, 201, 1, "_root-202", -1, 1, 0, 0,  },
	{ 932, 202, 1, "_root-203", -1, 1, 0, 0,  },
	{ 932, 203, 1, "_root-204", -1, 1, 0, 0,  },
	{ 932, 204, 1, "_root-205", -1, 1, 0, 0,  },
	{ 932, 205, 1, "_root-206", -1, 1, 0, 0,  },
	{ 932, 206, 1, "_root-207", -1, 1, 0, 0,  },
	{ 932, 207, 1, "_root-208", -1, 1, 0, 0,  },
	{ 932, 208, 1, "_root-209", -1, 1, 0, 0,  },
	{ 932, 209, 1, "_root-210", -1, 1, 0, 0,  },
	{ 932, 210, 1, "_root-211", -1, 1, 0, 0,  },
	{ 932, 211, 1, "_root-212", -1, 1, 0, 0,  },
	{ 932, 212, 1, "_root-213", -1, 1, 0, 0,  },
	{ 932, 213, 1, "_root-214", -1, 1, 0, 0,  },
	{ 932, 214, 1, "_root-215", -1, 1, 0, 0,  },
	{ 932, 215, 1, "_root-216", -1, 1, 0, 0,  },
	{ 932, 216, 1, "_root-217", -1, 1, 0, 0,  },
	{ 932, 217, 1, "_root-218", -1, 1, 0, 0,  },
	{ 932, 218, 1, "_root-219", -1, 1, 0, 0,  },
	{ 932, 219, 1, "_root-220", -1, 1, 0, 0,  },
	{ 932, 220, 1, "_root-221", -1, 1, 0, 0,  },
	{ 932, 221, 1, "_root-222", -1, 1, 0, 0,  },
	{ 932, 222, 1, "_root-223", -1, 1, 0, 0,  },
	{ 932, 223, 1, "_root-224", -1, 1, 0, 0,  },
	{ 932, 224, 1, "_root-225", -1, 1, 0, 0,  },
	{ 932, 225, 1, "_root-226", -1, 1, 0, 0,  },
	{ 932, 226, 1, "_root-227", -1, 1, 0, 0,  },
	{ 932, 227, 1, "_root-228", -1, 1, 0, 0,  },
	{ 932, 228, 1, "_root-229", -1, 1, 0, 0,  },
	{ 932, 229, 1, "_root-230", -1, 1, 0, 0,  },
	{ 932, 230, 1, "_root-231", -1, 1, 0, 0,  },
	{ 932, 231, 1, "_root-232", -1, 1, 0, 0,  },
	{ 932, 232, 1, "_root-233", -1, 1, 0, 0,  },
	{ 932, 233, 1, "_root-234", -1, 1, 0, 0,  },
	{ 932, 234, 1, "_root-235", -1, 1, 0, 0,  },
	{ 932, 235, 1, "_root-236", -1, 1, 0, 0,  },
	{ 932, 236, 1, "_root-237", -1, 1, 0, 0,  },
	{ 932, 237, 1, "_root-238", -1, 1, 0, 0,  },
	{ 932, 238, 1, "_root-239", -1, 1, 0, 0,  },
	{ 932, 239, 1, "_root-240", -1, 1, 0, 0,  },
	{ 932, 240, 1, "_root-241", -1, 1, 0, 0,  },
	{ 932, 241, 1, "_root-242", -1, 1, 0, 0,  },
	{ 932, 242, 1, "_root-243", -1, 1, 0, 0,  },
	{ 932, 243, 1, "_root-244", -1, 1, 0, 0,  },
	{ 932, 244, 1, "_root-245", -1, 1, 0, 0,  },
	{ 932, 245, 1, "_root-246", -1, 1, 0, 0,  },
	{ 932, 246, 1, "_root-247", -1, 1, 0, 0,  },
	{ 932, 247, 1, "_root-248", -1, 1, 0, 0,  },
	{ 932, 248, 1, "_root-249", -1, 1, 0, 0,  },
	{ 932, 249, 1, "_root-250", -1, 1, 0, 0,  },
	{ 932, 250, 1, "_root-251", -1, 1, 0, 0,  },
	{ 932, 251, 1, "_root-252", -1, 1, 0, 0,  },
	{ 932, 252, 1, "_root-253", -1, 1, 0, 0,  },
	{ 932, 253, 1, "_root-254", -1, 1, 0, 0,  },
	{ 932, 254, 1, "_root-255", -1, 1, 0, 0,  },
	{ 932, 255, 1, "_root-256", -1, 1, 0, 0,  },
	{ 932, 256, 1, "_root-257", -1, 1, 0, 0,  },
	{ 932, 257, 1, "_root-258", -1, 1, 0, 0,  },
	{ 932, 258, 1, "_root-259", -1, 1, 0, 0,  },
	{ 932, 259, 1, "_root-260", -1, 1, 0, 0,  },
	{ 932, 260, 1, "_root-261", -1, 1, 0, 0,  },
	{ 932, 261, 1, "_root-262", -1, 1, 0, 0,  },
	{ 932, 262, 1, "_root-263", -1, 1, 0, 0,  },
	{ 932, 263, 1, "_root-264", -1, 1, 0, 0,  },
	{ 932, 264, 1, "_root-265", -1, 1, 0, 0,  },
	{ 932, 265, 1, "_root-266", -1, 1, 0, 0,  },
	{ 932, 266, 1, "_root-267", -1, 1, 0, 0,  },
	{ 932, 267, 1, "_root-268", -1, 1, 0, 0,  },
	{ 932, 268, 1, "_root-269", -1, 1, 0, 0,  },
	{ 932, 269, 1, "_root-270", -1, 1, 0, 0,  },
	{ 932, 270, 1, "_root-271", -1, 1, 0, 0,  },
	{ 932, 271, 1, "_root-272", -1, 1, 0, 0,  },
	{ 932, 272, 1, "_root-273", -1, 1, 0, 0,  },
	{ 932, 273, 1, "_root-274", -1, 1, 0, 0,  },
	{ 932, 274, 1, "_root-275", -1, 1, 0, 0,  },
	{ 932, 275, 1, "_root-276", -1, 1, 0, 0,  },
	{ 932, 276, 1, "_root-277", -1, 1, 0, 0,  },
	{ 932, 277, 1, "_root-278", -1, 1, 0, 0,  },
	{ 932, 278, 1, "_root-279", -1, 1, 0, 0,  },
	{ 932, 279, 1, "_root-280", -1, 1, 0, 0,  },
	{ 932, 280, 1, "_root-281", -1, 1, 0, 0,  },
	{ 932, 281, 1, "_root-282", -1, 1, 0, 0,  },
	{ 932, 282, 1, "_root-283", -1, 1, 0, 0,  },
	{ 932, 283, 1, "_root-284", -1, 1, 0, 0,  },
	{ 932, 284, 1, "_root-285", -1, 1, 0, 0,  },
	{ 932, 285, 1, "_root-286", -1, 1, 0, 0,  },
	{ 932, 286, 1, "_root-287", -1, 1, 0, 0,  },
	{ 932, 287, 1, "_root-288", -1, 1, 0, 0,  },
	{ 932, 288, 1, "_root-289", -1, 1, 0, 0,  },
	{ 932, 289, 1, "_root-290", -1, 1, 0, 0,  },
	{ 932, 290, 1, "_root-291", -1, 1, 0, 0,  },
	{ 932, 291, 1, "_root-292", -1, 1, 0, 0,  },
	{ 932, 292, 1, "_root-293", -1, 1, 0, 0,  },
	{ 932, 293, 1, "_root-294", -1, 1, 0, 0,  },
	{ 932, 294, 1, "_root-295", -1, 1, 0, 0,  },
	{ 932, 295, 1, "_root-296", -1, 1, 0, 0,  },
	{ 932, 296, 1, "_root-297", -1, 1, 0, 0,  },
	{ 932, 297, 1, "_root-298", -1, 1, 0, 0,  },
	{ 932, 298, 1, "_root-299", -1, 1, 0, 0,  },
	{ 932, 299, 1, "_root-300", -1, 1, 0, 0,  },
	{ 932, 300, 1, "_root-301", -1, 1, 0, 0,  },
	{ 932, 301, 1, "_root-302", -1, 1, 0, 0,  },
	{ 932, 302, 1, "_root-303", -1, 1, 0, 0,  },
	{ 932, 303, 1, "_root-304", -1, 1, 0, 0,  },
	{ 932, 304, 1, "_root-305", -1, 1, 0, 0,  },
	{ 932, 305, 1, "_root-306", -1, 1, 0, 0,  },
	{ 932, 306, 1, "_root-307", -1, 1, 0, 0,  },
	{ 932, 307, 1, "_root-308", -1, 1, 0, 0,  },
	{ 932, 308, 1, "_root-309", -1, 1, 0, 0,  },
	{ 932, 309, 1, "_root-310", -1, 1, 0, 0,  },
	{ 932, 310, 1, "_root-311", -1, 1, 0, 0,  },
	{ 932, 311, 1, "_root-312", -1, 1, 0, 0,  },
	{ 932, 312, 1, "_root-313", -1, 1, 0, 0,  },
	{ 932, 313, 1, "_root-314", -1, 1, 0, 0,  },
	{ 932, 314, 1, "_root-315", -1, 1, 0, 0,  },
	{ 932, 315, 1, "_root-316", -1, 1, 0, 0,  },
	{ 932, 316, 1, "_root-317", -1, 1, 0, 0,  },
	{ 932, 317, 1, "_root-318", -1, 1, 0, 0,  },
	{ 932, 318, 1, "_root-319", -1, 1, 0, 0,  },
	{ 932, 319, 1, "_root-320", -1, 1, 0, 0,  },
	{ 932, 320, 1, "_root-321", -1, 1, 0, 0,  },
	{ 932, 321, 1, "_root-322", -1, 1, 0, 0,  },
	{ 932, 322, 1, "_root-323", -1, 1, 0, 0,  },
	{ 932, 323, 1, "_root-324", -1, 1, 0, 0,  },
	{ 932, 324, 1, "_root-325", -1, 1, 0, 0,  },
	{ 932, 325, 1, "_root-326", -1, 1, 0, 0,  },
	{ 932, 326, 1, "_root-327", -1, 1, 0, 0,  },
	{ 932, 327, 1, "_root-328", -1, 1, 0, 0,  },
	{ 932, 328, 1, "_root-329", -1, 1, 0, 0,  },
	{ 932, 329, 1, "_root-330", -1, 1, 0, 0,  },
	{ 932, 330, 1, "_root-331", -1, 1, 0, 0,  },
	{ 932, 331, 1, "_root-332", -1, 1, 0, 0,  },
	{ 932, 332, 1, "_root-333", -1, 1, 0, 0,  },
	{ 932, 333, 1, "_root-334", -1, 1, 0, 0,  },
	{ 932, 334, 1, "_root-335", -1, 1, 0, 0,  },
	{ 932, 335, 1, "_root-336", -1, 1, 0, 0,  },
	{ 932, 336, 1, "_root-337", -1, 1, 0, 0,  },
	{ 932, 337, 1, "_root-338", -1, 1, 0, 0,  },
	{ 932, 338, 1, "_root-339", -1, 1, 0, 0,  },
	{ 932, 339, 1, "_root-340", -1, 1, 0, 0,  },
	{ 932, 340, 1, "_root-341", -1, 1, 0, 0,  },
	{ 932, 341, 1, "_root-342", -1, 1, 0, 0,  },
	{ 932, 342, 1, "_root-343", -1, 1, 0, 0,  },
	{ 932, 343, 1, "_root-344", -1, 1, 0, 0,  },
	{ 932, 344, 1, "_root-345", -1, 1, 0, 0,  },
	{ 932, 345, 1, "_root-346", -1, 1, 0, 0,  },
	{ 932, 346, 1, "_root-347", -1, 1, 0, 0,  },
	{ 932, 347, 1, "_root-348", -1, 1, 0, 0,  },
	{ 932, 348, 1, "_root-349", -1, 1, 0, 0,  },
	{ 932, 349, 1, "_root-350", -1, 1, 0, 0,  },
	{ 932, 350, 1, "_root-351", -1, 1, 0, 0,  },
	{ 932, 351, 1, "_root-352", -1, 1, 0, 0,  },
	{ 932, 352, 1, "_root-353", -1, 1, 0, 0,  },
	{ 932, 353, 1, "_root-354", -1, 1, 0, 0,  },
	{ 932, 354, 1, "_root-355", -1, 1, 0, 0,  },
	{ 932, 355, 1, "_root-356", -1, 1, 0, 0,  },
	{ 932, 356, 1, "_root-357", -1, 1, 0, 0,  },
	{ 932, 357, 1, "_root-358", -1, 1, 0, 0,  },
	{ 932, 358, 1, "_root-359", -1, 1, 0, 0,  },
	{ 932, 359, 1, "_root-360", -1, 1, 0, 0,  },
	{ 932, 360, 1, "_root-361", -1, 1, 0, 0,  },
	{ 932, 361, 1, "_root-362", -1, 1, 0, 0,  },
	{ 932, 362, 1, "_root-363", -1, 1, 0, 0,  },
	{ 932, 363, 1, "_root-364", -1, 1, 0, 0,  },
	{ 932, 364, 1, "_root-365", -1, 1, 0, 0,  },
	{ 932, 365, 1, "_root-366", -1, 1, 0, 0,  },
	{ 932, 366, 1, "_root-367", -1, 1, 0, 0,  },
	{ 932, 367, 1, "_root-368", -1, 1, 0, 0,  },
	{ 932, 368, 1, "_root-369", -1, 1, 0, 0,  },
	{ 932, 369, 1, "_root-370", -1, 1, 0, 0,  },
	{ 932, 370, 1, "_root-371", -1, 1, 0, 0,  },
	{ 932, 371, 1, "_root-372", -1, 1, 0, 0,  },
	{ 932, 372, 1, "_root-373", -1, 1, 0, 0,  },
	{ 932, 373, 1, "_root-374", -1, 1, 0, 0,  },
	{ 932, 374, 1, "_root-375", -1, 1, 0, 0,  },
	{ 932, 375, 1, "_root-376", -1, 1, 0, 0,  },
	{ 932, 376, 1, "_root-377", -1, 1, 0, 0,  },
	{ 932, 377, 1, "_root-378", -1, 1, 0, 0,  },
	{ 932, 378, 1, "_root-379", -1, 1, 0, 0,  },
	{ 932, 379, 1, "_root-380", -1, 1, 0, 0,  },
	{ 932, 380, 1, "_root-381", -1, 1, 0, 0,  },
	{ 932, 381, 1, "_root-382", -1, 1, 0, 0,  },
	{ 932, 382, 1, "_root-383", -1, 1, 0, 0,  },
	{ 932, 383, 1, "_root-384", -1, 1, 0, 0,  },
	{ 932, 384, 1, "_root-385", -1, 1, 0, 0,  },
	{ 932, 385, 1, "_root-386", -1, 1, 0, 0,  },
	{ 932, 386, 1, "_root-387", -1, 1, 0, 0,  },
	{ 932, 387, 1, "_root-388", -1, 1, 0, 0,  },
	{ 932, 388, 1, "_root-389", -1, 1, 0, 0,  },
	{ 932, 389, 1, "_root-390", -1, 1, 0, 0,  },
	{ 932, 390, 1, "_root-391", -1, 1, 0, 0,  },
	{ 932, 391, 1, "_root-392", -1, 1, 0, 0,  },
	{ 932, 392, 1, "_root-393", -1, 1, 0, 0,  },
	{ 932, 393, 1, "_root-394", -1, 1, 0, 0,  },
	{ 932, 394, 1, "_root-395", -1, 1, 0, 0,  },
	{ 932, 395, 1, "_root-396", -1, 1, 0, 0,  },
	{ 932, 396, 1, "_root-397", -1, 1, 0, 0,  },
	{ 932, 397, 1, "_root-398", -1, 1, 0, 0,  },
	{ 932, 398, 1, "_root-399", -1, 1, 0, 0,  },
	{ 932, 399, 1, "_root-400", -1, 1, 0, 0,  },
	{ 932, 400, 1, "_root-401", -1, 1, 0, 0,  },
	{ 932, 401, 1, "_root-402", -1, 1, 0, 0,  },
	{ 932, 402, 1, "_root-403", -1, 1, 0, 0,  },
	{ 932, 403, 1, "_root-404", -1, 1, 0, 0,  },
	{ 932, 404, 1, "_root-405", -1, 1, 0, 0,  },
	{ 932, 405, 1, "_root-406", -1, 1, 0, 0,  },
	{ 932, 406, 1, "_root-407", -1, 1, 0, 0,  },
	{ 932, 407, 1, "_root-408", -1, 1, 0, 0,  },
	{ 932, 408, 1, "_root-409", -1, 1, 0, 0,  },
	{ 932, 409, 1, "_root-410", -1, 1, 0, 0,  },
	{ 932, 410, 1, "_root-411", -1, 1, 0, 0,  },
	{ 932, 411, 1, "_root-412", -1, 1, 0, 0,  },
	{ 932, 412, 1, "_root-413", -1, 1, 0, 0,  },
	{ 932, 413, 1, "_root-414", -1, 1, 0, 0,  },
	{ 932, 414, 1, "_root-415", -1, 1, 0, 0,  },
	{ 932, 415, 1, "_root-416", -1, 1, 0, 0,  },
	{ 932, 416, 1, "_root-417", -1, 1, 0, 0,  },
	{ 932, 417, 1, "_root-418", -1, 1, 0, 0,  },
	{ 932, 418, 1, "_root-419", -1, 1, 0, 0,  },
	{ 932, 419, 1, "_root-420", -1, 1, 0, 0,  },
	{ 932, 420, 1, "_root-421", -1, 1, 0, 0,  },
	{ 932, 421, 1, "_root-422", -1, 1, 0, 0,  },
	{ 932, 422, 1, "_root-423", -1, 1, 0, 0,  },
	{ 932, 423, 1, "_root-424", -1, 1, 0, 0,  },
	{ 932, 424, 1, "_root-425", -1, 1, 0, 0,  },
	{ 932, 425, 1, "_root-426", -1, 1, 0, 0,  },
	{ 932, 426, 1, "_root-427", -1, 1, 0, 0,  },
	{ 932, 427, 1, "_root-428", -1, 1, 0, 0,  },
	{ 932, 428, 1, "_root-429", -1, 1, 0, 0,  },
	{ 932, 429, 1, "_root-430", -1, 1, 0, 0,  },
	{ 932, 430, 1, "_root-431", -1, 1, 0, 0,  },
	{ 932, 431, 1, "_root-432", -1, 1, 0, 0,  },
	{ 932, 432, 1, "_root-433", -1, 1, 0, 0,  },
	{ 932, 433, 1, "_root-434", -1, 1, 0, 0,  },
	{ 932, 434, 1, "_root-435", -1, 1, 0, 0,  },
	{ 932, 435, 1, "_root-436", -1, 1, 0, 0,  },
	{ 932, 436, 1, "_root-437", -1, 1, 0, 0,  },
	{ 932, 437, 1, "_root-438", -1, 1, 0, 0,  },
	{ 932, 438, 1, "_root-439", -1, 1, 0, 0,  },
	{ 932, 439, 1, "_root-440", -1, 1, 0, 0,  },
	{ 932, 440, 1, "_root-441", -1, 1, 0, 0,  },
	{ 932, 441, 1, "_root-442", -1, 1, 0, 0,  },
	{ 932, 442, 1, "_root-443", -1, 1, 0, 0,  },
	{ 932, 443, 1, "_root-444", -1, 1, 0, 0,  },
	{ 932, 444, 1, "_root-445", -1, 1, 0, 0,  },
	{ 932, 445, 1, "_root-446", -1, 1, 0, 0,  },
	{ 932, 446, 1, "_root-447", -1, 1, 0, 0,  },
	{ 932, 447, 1, "_root-448", -1, 1, 0, 0,  },
	{ 932, 448, 1, "_root-449", -1, 1, 0, 0,  },
	{ 932, 449, 1, "_root-450", -1, 1, 0, 0,  },
	{ 932, 450, 1, "_root-451", -1, 1, 0, 0,  },
	{ 932, 451, 1, "_root-452", -1, 1, 0, 0,  },
	{ 932, 452, 1, "_root-453", -1, 1, 0, 0,  },
	{ 932, 453, 1, "_root-454", -1, 1, 0, 0,  },
	{ 932, 454, 1, "_root-455", -1, 1, 0, 0,  },
	{ 932, 455, 1, "_root-456", -1, 1, 0, 0,  },
	{ 932, 456, 1, "_root-457", -1, 1, 0, 0,  },
	{ 932, 457, 1, "_root-458", -1, 1, 0, 0,  },
	{ 932, 458, 1, "_root-459", -1, 1, 0, 0,  },
	{ 932, 459, 1, "_root-460", -1, 1, 0, 0,  },
	{ 932, 460, 1, "_root-461", -1, 1, 0, 0,  },
	{ 932, 461, 1, "_root-462", -1, 1, 0, 0,  },
	{ 932, 462, 1, "_root-463", -1, 1, 0, 0,  },
	{ 932, 463, 1, "_root-464", -1, 1, 0, 0,  },
	{ 932, 464, 1, "_root-465", -1, 1, 0, 0,  },
	{ 932, 465, 1, "_root-466", -1, 1, 0, 0,  },
	{ 932, 466, 1, "_root-467", -1, 1, 0, 0,  },
	{ 932, 467, 1, "_root-468", -1, 1, 0, 0,  },
	{ 932, 468, 1, "_root-469", -1, 1, 0, 0,  },
	{ 932, 469, 1, "_root-470", -1, 1, 0, 0,  },
	{ 932, 470, 1, "_root-471", -1, 1, 0, 0,  },
	{ 932, 471, 1, "_root-472", -1, 1, 0, 0,  },
	{ 932, 472, 1, "_root-473", -1, 1, 0, 0,  },
	{ 932, 473, 1, "_root-474", -1, 1, 0, 0,  },
	{ 932, 474, 1, "_root-475", -1, 1, 0, 0,  },
	{ 932, 475, 1, "_root-476", -1, 1, 0, 0,  },
	{ 932, 476, 1, "_root-477", -1, 1, 0, 0,  },
	{ 932, 477, 1, "_root-478", -1, 1, 0, 0,  },
	{ 932, 478, 1, "_root-479", -1, 1, 0, 0,  },
	{ 932, 479, 1, "_root-480", -1, 1, 0, 0,  },
	{ 932, 480, 1, "_root-481", -1, 1, 0, 0,  },
	{ 932, 481, 1, "_root-482", -1, 1, 0, 0,  },
	{ 932, 482, 1, "_root-483", -1, 1, 0, 0,  },
	{ 932, 483, 1, "_root-484", -1, 1, 0, 0,  },
	{ 932, 484, 1, "_root-485", -1, 1, 0, 0,  },
	{ 932, 485, 1, "_root-486", -1, 1, 0, 0,  },
	{ 932, 486, 1, "_root-487", -1, 1, 0, 0,  },
	{ 932, 487, 1, "_root-488", -1, 1, 0, 0,  },
	{ 932, 488, 1, "_root-489", -1, 1, 0, 0,  },
	{ 932, 489, 1, "_root-490", -1, 1, 0, 0,  },
	{ 932, 490, 1, "_root-491", -1, 1, 0, 0,  },
	{ 932, 491, 1, "_root-492", -1, 1, 0, 0,  },
	{ 932, 492, 1, "_root-493", -1, 1, 0, 0,  },
	{ 932, 493, 1, "_root-494", -1, 1, 0, 0,  },
	{ 932, 494, 1, "_root-495", -1, 1, 0, 0,  },
	{ 932, 495, 1, "_root-496", -1, 1, 0, 0,  },
	{ 932, 496, 1, "_root-497", -1, 1, 0, 0,  },
	{ 932, 497, 1, "_root-498", -1, 1, 0, 0,  },
	{ 932, 498, 1, "_root-499", -1, 1, 0, 0,  },
	{ 932, 499, 1, "_root-500", -1, 1, 0, 0,  },
	{ 932, 500, 1, "_root-501", -1, 1, 0, 0,  },
	{ 932, 501, 1, "_root-502", -1, 1, 0, 0,  },
	{ 932, 502, 1, "_root-503", -1, 1, 0, 0,  },
	{ 932, 503, 1, "_root-504", -1, 1, 0, 0,  },
	{ 932, 504, 1, "_root-505", -1, 1, 0, 0,  },
	{ 932, 505, 1, "_root-506", -1, 1, 0, 0,  },
	{ 932, 506, 1, "_root-507", -1, 1, 0, 0,  },
	{ 932, 507, 1, "_root-508", -1, 1, 0, 0,  },
	{ 932, 508, 1, "_root-509", -1, 1, 0, 0,  },
	{ 932, 509, 1, "_root-510", -1, 1, 0, 0,  },
	{ 932, 510, 1, "_root-511", -1, 1, 0, 0,  },
	{ 932, 511, 1, "_root-512", -1, 1, 0, 0,  },
	{ 932, 512, 1, "_root-513", -1, 1, 0, 0,  },
	{ 932, 513, 1, "_root-514", -1, 1, 0, 0,  },
	{ 932, 514, 1, "_root-515", -1, 1, 0, 0,  },
	{ 932, 515, 1, "_root-516", -1, 1, 0, 0,  },
	{ 932, 516, 1, "_root-517", -1, 1, 0, 0,  },
	{ 932, 517, 1, "_root-518", -1, 1, 0, 0,  },
	{ 932, 518, 1, "_root-519", -1, 1, 0, 0,  },
	{ 932, 519, 1, "_root-520", -1, 1, 0, 0,  },
	{ 932, 520, 1, "_root-521", -1, 1, 0, 0,  },
	{ 932, 521, 1, "_root-522", -1, 1, 0, 0,  },
	{ 932, 522, 1, "_root-523", -1, 1, 0, 0,  },
	{ 932, 523, 1, "_root-524", -1, 1, 0, 0,  },
	{ 932, 524, 1, "_root-525", -1, 1, 0, 0,  },
	{ 932, 525, 1, "_root-526", -1, 1, 0, 0,  },
	{ 932, 526, 1, "_root-527", -1, 1, 0, 0,  },
	{ 932, 527, 1, "_root-528", -1, 1, 0, 0,  },
	{ 932, 528, 1, "_root-529", -1, 1, 0, 0,  },
	{ 932, 529, 1, "_root-530", -1, 1, 0, 0,  },
	{ 932, 530, 1, "_root-531", -1, 1, 0, 0,  },
	{ 932, 531, 1, "_root-532", -1, 1, 0, 0,  },
	{ 932, 532, 1, "_root-533", -1, 1, 0, 0,  },
	{ 932, 533, 1, "_root-534", -1, 1, 0, 0,  },
	{ 932, 534, 1, "_root-535", -1, 1, 0, 0,  },
	{ 932, 535, 1, "_root-536", -1, 1, 0, 0,  },
	{ 932, 536, 1, "_root-537", -1, 1, 0, 0,  },
	{ 932, 537, 1, "_root-538", -1, 1, 0, 0,  },
	{ 932, 538, 1, "_root-539", -1, 1, 0, 0,  },
	{ 932, 539, 1, "_root-540", -1, 1, 0, 0,  },
	{ 932, 540, 1, "_root-541", -1, 1, 0, 0,  },
	{ 932, 541, 1, "_root-542", -1, 1, 0, 0,  },
	{ 932, 542, 1, "_root-543", -1, 1, 0, 0,  },
	{ 932, 543, 1, "_root-544", -1, 1, 0, 0,  },
	{ 932, 544, 1, "_root-545", -1, 1, 0, 0,  },
	{ 932, 545, 1, "_root-546", -1, 1, 0, 0,  },
	{ 932, 546, 1, "_root-547", -1, 1, 0, 0,  },
	{ 932, 547, 1, "_root-548", -1, 1, 0, 0,  },
	{ 932, 548, 1, "_root-549", -1, 1, 0, 0,  },
	{ 932, 549, 1, "_root-550", -1, 1, 0, 0,  },
	{ 932, 550, 1, "_root-551", -1, 1, 0, 0,  },
	{ 932, 551, 1, "_root-552", -1, 1, 0, 0,  },
	{ 932, 552, 1, "_root-553", -1, 1, 0, 0,  },
	{ 932, 553, 1, "_root-554", -1, 1, 0, 0,  },
	{ 932, 554, 1, "_root-555", -1, 1, 0, 0,  },
	{ 932, 555, 1, "_root-556", -1, 1, 0, 0,  },
	{ 932, 556, 1, "_root-557", -1, 1, 0, 0,  },
	{ 932, 557, 1, "_root-558", -1, 1, 0, 0,  },
	{ 932, 558, 1, "_root-559", -1, 1, 0, 0,  },
	{ 932, 559, 1, "_root-560", -1, 1, 0, 0,  },
	{ 932, 560, 1, "_root-561", -1, 1, 0, 0,  },
	{ 932, 561, 1, "_root-562", -1, 1, 0, 0,  },
	{ 932, 562, 1, "_root-563", -1, 1, 0, 0,  },
	{ 932, 563, 1, "_root-564", -1, 1, 0, 0,  },
	{ 932, 564, 1, "_root-565", -1, 1, 0, 0,  },
	{ 932, 565, 1, "_root-566", -1, 1, 0, 0,  },
	{ 932, 566, 1, "_root-567", -1, 1, 0, 0,  },
	{ 932, 567, 1, "_root-568", -1, 1, 0, 0,  },
	{ 932, 568, 1, "_root-569", -1, 1, 0, 0,  },
	{ 932, 569, 1, "_root-570", -1, 1, 0, 0,  },
	{ 932, 570, 1, "_root-571", -1, 1, 0, 0,  },
	{ 932, 571, 1, "_root-572", -1, 1, 0, 0,  },
	{ 932, 572, 1, "_root-573", -1, 1, 0, 0,  },
	{ 932, 573, 1, "_root-574", -1, 1, 0, 0,  },
	{ 932, 574, 1, "_root-575", -1, 1, 0, 0,  },
	{ 932, 575, 1, "_root-576", -1, 1, 0, 0,  },
	{ 932, 576, 1, "_root-577", -1, 1, 0, 0,  },
	{ 932, 577, 1, "_root-578", -1, 1, 0, 0,  },
	{ 932, 578, 1, "_root-579", -1, 1, 0, 0,  },
	{ 932, 579, 1, "_root-580", -1, 1, 0, 0,  },
	{ 932, 580, 1, "_root-581", -1, 1, 0, 0,  },
	{ 932, 581, 1, "_root-582", -1, 1, 0, 0,  },
	{ 932, 582, 1, "_root-583", -1, 1, 0, 0,  },
	{ 932, 583, 1, "_root-584", -1, 1, 0, 0,  },
	{ 932, 584, 1, "_root-585", -1, 1, 0, 0,  },
	{ 932, 585, 1, "_root-586", -1, 1, 0, 0,  },
	{ 932, 586, 1, "_root-587", -1, 1, 0, 0,  },
	{ 932, 587, 1, "_root-588", -1, 1, 0, 0,  },
	{ 932, 588, 1, "_root-589", -1, 1, 0, 0,  },
	{ 932, 589, 1, "_root-590", -1, 1, 0, 0,  },
	{ 932, 590, 1, "_root-591", -1, 1, 0, 0,  },
	{ 932, 591, 1, "_root-592", -1, 1, 0, 0,  },
	{ 932, 592, 1, "_root-593", -1, 1, 0, 0,  },
	{ 932, 593, 1, "_root-594", -1, 1, 0, 0,  },
	{ 932, 594, 1, "_root-595", -1, 1, 0, 0,  },
	{ 932, 595, 1, "_root-596", -1, 1, 0, 0,  },
	{ 932, 596, 1, "_root-597", -1, 1, 0, 0,  },
	{ 932, 597, 1, "_root-598", -1, 1, 0, 0,  },
	{ 932, 598, 1, "_root-599", -1, 1, 0, 0,  },
	{ 932, 599, 1, "_root-600", -1, 1, 0, 0,  },
	{ 932, 600, 1, "_root-601", -1, 1, 0, 0,  },
	{ 932, 601, 1, "_root-602", -1, 1, 0, 0,  },
	{ 932, 602, 1, "_root-603", -1, 1, 0, 0,  },
	{ 932, 603, 1, "_root-604", -1, 1, 0, 0,  },
	{ 932, 604, 1, "_root-605", -1, 1, 0, 0,  },
	{ 932, 605, 1, "_root-606", -1, 1, 0, 0,  },
	{ 932, 606, 1, "_root-607", -1, 1, 0, 0,  },
	{ 932, 607, 1, "_root-608", -1, 1, 0, 0,  },
	{ 932, 608, 1, "_root-609", -1, 1, 0, 0,  },
	{ 932, 609, 1, "_root-610", -1, 1, 0, 0,  },
	{ 932, 610, 1, "_root-611", -1, 1, 0, 0,  },
	{ 932, 611, 1, "_root-612", -1, 1, 0, 0,  },
	{ 932, 612, 1, "_root-613", -1, 1, 0, 0,  },
	{ 932, 613, 1, "_root-614", -1, 1, 0, 0,  },
	{ 932, 614, 1, "_root-615", -1, 1, 0, 0,  },
	{ 932, 615, 1, "_root-616", -1, 1, 0, 0,  },
	{ 932, 616, 1, "_root-617", -1, 1, 0, 0,  },
	{ 932, 617, 1, "_root-618", -1, 1, 0, 0,  },
	{ 932, 618, 1, "_root-619", -1, 1, 0, 0,  },
	{ 932, 619, 1, "_root-620", -1, 1, 0, 0,  },
	{ 932, 620, 1, "_root-621", -1, 1, 0, 0,  },
	{ 932, 621, 1, "_root-622", -1, 1, 0, 0,  },
	{ 932, 622, 1, "_root-623", -1, 1, 0, 0,  },
	{ 932, 623, 1, "_root-624", -1, 1, 0, 0,  },
	{ 932, 624, 1, "_root-625", -1, 1, 0, 0,  },
	{ 932, 625, 1, "_root-626", -1, 1, 0, 0,  },
	{ 932, 626, 1, "_root-627", -1, 1, 0, 0,  },
	{ 932, 627, 1, "_root-628", -1, 1, 0, 0,  },
	{ 932, 628, 1, "_root-629", -1, 1, 0, 0,  },
	{ 932, 629, 1, "_root-630", -1, 1, 0, 0,  },
	{ 932, 630, 1, "_root-631", -1, 1, 0, 0,  },
	{ 932, 631, 1, "_root-632", -1, 1, 0, 0,  },
	{ 932, 632, 1, "_root-633", -1, 1, 0, 0,  },
	{ 932, 633, 1, "_root-634", -1, 1, 0, 0,  },
	{ 932, 634, 1, "_root-635", -1, 1, 0, 0,  },
	{ 932, 635, 1, "_root-636", -1, 1, 0, 0,  },
	{ 932, 636, 1, "_root-637", -1, 1, 0, 0,  },
	{ 932, 637, 1, "_root-638", -1, 1, 0, 0,  },
	{ 932, 638, 1, "_root-639", -1, 1, 0, 0,  },
	{ 932, 639, 1, "_root-640", -1, 1, 0, 0,  },
	{ 932, 640, 1, "_root-641", -1, 1, 0, 0,  },
	{ 932, 641, 1, "_root-642", -1, 1, 0, 0,  },
	{ 932, 642, 1, "_root-643", -1, 1, 0, 0,  },
	{ 932, 643, 1, "_root-644", -1, 1, 0, 0,  },
	{ 932, 644, 1, "_root-645", -1, 1, 0, 0,  },
	{ 932, 645, 1, "_root-646", -1, 1, 0, 0,  },
	{ 932, 646, 1, "_root-647", -1, 1, 0, 0,  },
	{ 932, 647, 1, "_root-648", -1, 1, 0, 0,  },
	{ 932, 648, 1, "_root-649", -1, 1, 0, 0,  },
	{ 932, 649, 1, "_root-650", -1, 1, 0, 0,  },
	{ 932, 650, 1, "_root-651", -1, 1, 0, 0,  },
	{ 932, 651, 1, "_root-652", -1, 1, 0, 0,  },
	{ 932, 652, 1, "_root-653", -1, 1, 0, 0,  },
	{ 932, 653, 1, "_root-654", -1, 1, 0, 0,  },
	{ 932, 654, 1, "_root-655", -1, 1, 0, 0,  },
	{ 932, 655, 1, "_root-656", -1, 1, 0, 0,  },
	{ 932, 656, 1, "_root-657", -1, 1, 0, 0,  },
	{ 932, 657, 1, "_root-658", -1, 1, 0, 0,  },
	{ 932, 658, 1, "_root-659", -1, 1, 0, 0,  },
	{ 932, 659, 1, "_root-660", -1, 1, 0, 0,  },
	{ 932, 660, 1, "_root-661", -1, 1, 0, 0,  },
	{ 932, 661, 1, "_root-662", -1, 1, 0, 0,  },
	{ 932, 662, 1, "_root-663", -1, 1, 0, 0,  },
	{ 932, 663, 1, "_root-664", -1, 1, 0, 0,  },
	{ 932, 664, 1, "_root-665", -1, 1, 0, 0,  },
	{ 932, 665, 1, "_root-666", -1, 1, 0, 0,  },
	{ 932, 666, 1, "_root-667", -1, 1, 0, 0,  },
	{ 932, 667, 1, "_root-668", -1, 1, 0, 0,  },
	{ 932, 668, 1, "_root-669", -1, 1, 0, 0,  },
	{ 932, 669, 1, "_root-670", -1, 1, 0, 0,  },
	{ 932, 670, 1, "_root-671", -1, 1, 0, 0,  },
	{ 932, 671, 1, "_root-672", -1, 1, 0, 0,  },
	{ 932, 672, 1, "_root-673", -1, 1, 0, 0,  },
	{ 932, 673, 1, "_root-674", -1, 1, 0, 0,  },
	{ 932, 674, 1, "_root-675", -1, 1, 0, 0,  },
	{ 932, 675, 1, "_root-676", -1, 1, 0, 0,  },
	{ 932, 676, 1, "_root-677", -1, 1, 0, 0,  },
	{ 932, 677, 1, "_root-678", -1, 1, 0, 0,  },
	{ 932, 678, 1, "_root-679", -1, 1, 0, 0,  },
	{ 932, 679, 1, "_root-680", -1, 1, 0, 0,  },
	{ 932, 680, 1, "_root-681", -1, 1, 0, 0,  },
	{ 932, 681, 1, "_root-682", -1, 1, 0, 0,  },
	{ 932, 682, 1, "_root-683", -1, 1, 0, 0,  },
	{ 932, 683, 1, "_root-684", -1, 1, 0, 0,  },
	{ 932, 684, 1, "_root-685", -1, 1, 0, 0,  },
	{ 932, 685, 1, "_root-686", -1, 1, 0, 0,  },
	{ 932, 686, 1, "_root-687", -1, 1, 0, 0,  },
	{ 932, 687, 1, "_root-688", -1, 1, 0, 0,  },
	{ 932, 688, 1, "_root-689", -1, 1, 0, 0,  },
	{ 932, 689, 1, "_root-690", -1, 1, 0, 0,  },
	{ 932, 690, 1, "_root-691", -1, 1, 0, 0,  },
	{ 932, 691, 1, "_root-692", -1, 1, 0, 0,  },
	{ 932, 692, 1, "_root-693", -1, 1, 0, 0,  },
	{ 932, 693, 1, "_root-694", -1, 1, 0, 0,  },
	{ 932, 694, 1, "_root-695", -1, 1, 0, 0,  },
	{ 932, 695, 1, "_root-696", -1, 1, 0, 0,  },
	{ 932, 696, 1, "_root-697", -1, 1, 0, 0,  },
	{ 932, 697, 1, "_root-698", -1, 1, 0, 0,  },
	{ 932, 698, 1, "_root-699", -1, 1, 0, 0,  },
	{ 932, 699, 1, "_root-700", -1, 1, 0, 0,  },
	{ 932, 700, 1, "_root-701", -1, 1, 0, 0,  },
	{ 932, 701, 1, "_root-702", -1, 1, 0, 0,  },
	{ 932, 702, 1, "_root-703", -1, 1, 0, 0,  },
	{ 932, 703, 1, "_root-704", -1, 1, 0, 0,  },
	{ 932, 704, 1, "_root-705", -1, 1, 0, 0,  },
	{ 932, 705, 1, "_root-706", -1, 1, 0, 0,  },
	{ 932, 706, 1, "_root-707", -1, 1, 0, 0,  },
	{ 932, 707, 1, "_root-708", -1, 1, 0, 0,  },
	{ 932, 708, 1, "_root-709", -1, 1, 0, 0,  },
	{ 932, 709, 1, "_root-710", -1, 1, 0, 0,  },
	{ 932, 710, 1, "_root-711", -1, 1, 0, 0,  },
	{ 932, 711, 1, "_root-712", -1, 1, 0, 0,  },
	{ 932, 712, 1, "_root-713", -1, 1, 0, 0,  },
	{ 932, 713, 1, "_root-714", -1, 1, 0, 0,  },
	{ 932, 714, 1, "_root-715", -1, 1, 0, 0,  },
	{ 932, 715, 1, "_root-716", -1, 1, 0, 0,  },
	{ 932, 716, 1, "_root-717", -1, 1, 0, 0,  },
	{ 932, 717, 1, "_root-718", -1, 1, 0, 0,  },
	{ 932, 718, 1, "_root-719", -1, 1, 0, 0,  },
	{ 932, 719, 1, "_root-720", -1, 1, 0, 0,  },
	{ 932, 720, 1, "_root-721", -1, 1, 0, 0,  },
	{ 932, 721, 1, "_root-722", -1, 1, 0, 0,  },
	{ 932, 722, 1, "_root-723", -1, 1, 0, 0,  },
	{ 932, 723, 1, "_root-724", -1, 1, 0, 0,  },
	{ 932, 724, 1, "_root-725", -1, 1, 0, 0,  },
	{ 932, 725, 1, "_root-726", -1, 1, 0, 0,  },
	{ 932, 726, 1, "_root-727", -1, 1, 0, 0,  },
	{ 932, 727, 1, "_root-728", -1, 1, 0, 0,  },
	{ 932, 728, 1, "_root-729", -1, 1, 0, 0,  },
	{ 932, 729, 1, "_root-730", -1, 1, 0, 0,  },
	{ 932, 730, 1, "_root-731", -1, 1, 0, 0,  },
	{ 932, 731, 1, "_root-732", -1, 1, 0, 0,  },
	{ 932, 732, 1, "_root-733", -1, 1, 0, 0,  },
	{ 932, 733, 1, "_root-734", -1, 1, 0, 0,  },
	{ 932, 734, 1, "_root-735", -1, 1, 0, 0,  },
	{ 932, 735, 1, "_root-736", -1, 1, 0, 0,  },
	{ 932, 736, 1, "_root-737", -1, 1, 0, 0,  },
	{ 932, 737, 1, "_root-738", -1, 1, 0, 0,  },
	{ 932, 738, 1, "_root-739", -1, 1, 0, 0,  },
	{ 932, 739, 1, "_root-740", -1, 1, 0, 0,  },
	{ 932, 740, 1, "_root-741", -1, 1, 0, 0,  },
	{ 932, 741, 1, "_root-742", -1, 1, 0, 0,  },
	{ 932, 742, 1, "_root-743", -1, 1, 0, 0,  },
	{ 932, 743, 1, "_root-744", -1, 1, 0, 0,  },
	{ 932, 744, 1, "_root-745", -1, 1, 0, 0,  },
	{ 932, 745, 1, "_root-746", -1, 1, 0, 0,  },
	{ 932, 746, 1, "_root-747", -1, 1, 0, 0,  },
	{ 932, 747, 1, "_root-748", -1, 1, 0, 0,  },
	{ 932, 748, 1, "_root-749", -1, 1, 0, 0,  },
	{ 932, 749, 1, "_root-750", -1, 1, 0, 0,  },
	{ 932, 750, 1, "_root-751", -1, 1, 0, 0,  },
	{ 932, 751, 1, "_root-752", -1, 1, 0, 0,  },
	{ 932, 752, 1, "_root-753", -1, 1, 0, 0,  },
	{ 932, 753, 1, "_root-754", -1, 1, 0, 0,  },
	{ 932, 754, 1, "_root-755", -1, 1, 0, 0,  },
	{ 932, 755, 1, "_root-756", -1, 1, 0, 0,  },
	{ 932, 756, 1, "_root-757", -1, 1, 0, 0,  },
	{ 932, 757, 1, "_root-758", -1, 1, 0, 0,  },
	{ 932, 758, 1, "_root-759", -1, 1, 0, 0,  },
	{ 932, 759, 1, "_root-760", -1, 1, 0, 0,  },
	{ 932, 760, 1, "_root-761", -1, 1, 0, 0,  },
	{ 932, 761, 1, "_root-762", -1, 1, 0, 0,  },
	{ 932, 762, 1, "_root-763", -1, 1, 0, 0,  },
	{ 932, 763, 1, "_root-764", -1, 1, 0, 0,  },
	{ 932, 764, 1, "_root-765", -1, 1, 0, 0,  },
	{ 932, 765, 1, "_root-766", -1, 1, 0, 0,  },
	{ 932, 766, 1, "_root-767", -1, 1, 0, 0,  },
	{ 932, 767, 1, "_root-768", -1, 1, 0, 0,  },
	{ 932, 768, 1, "_root-769", -1, 1, 0, 0,  },
	{ 932, 769, 1, "_root-770", -1, 1, 0, 0,  },
	{ 932, 770, 1, "_root-771", -1, 1, 0, 0,  },
	{ 932, 771, 1, "_root-772", -1, 1, 0, 0,  },
	{ 932, 772, 1, "_root-773", -1, 1, 0, 0,  },
	{ 932, 773, 1, "_root-774", -1, 1, 0, 0,  },
	{ 932, 774, 1, "_root-775", -1, 1, 0, 0,  },
	{ 932, 775, 1, "_root-776", -1, 1, 0, 0,  },
	{ 932, 776, 1, "_root-777", -1, 1, 0, 0,  },
	{ 932, 777, 1, "_root-778", -1, 1, 0, 0,  },
	{ 932, 778, 1, "_root-779", -1, 1, 0, 0,  },
	{ 932, 779, 1, "_root-780", -1, 1, 0, 0,  },
	{ 932, 780, 1, "_root-781", -1, 1, 0, 0,  },
	{ 932, 781, 1, "_root-782", -1, 1, 0, 0,  },
	{ 932, 782, 1, "_root-783", -1, 1, 0, 0,  },
	{ 932, 783, 1, "_root-784", -1, 1, 0, 0,  },
	{ 932, 784, 1, "_root-785", -1, 1, 0, 0,  },
	{ 932, 785, 1, "_root-786", -1, 1, 0, 0,  },
	{ 932, 786, 1, "_root-787", -1, 1, 0, 0,  },
	{ 932, 787, 1, "_root-788", -1, 1, 0, 0,  },
	{ 932, 788, 1, "_root-789", -1, 1, 0, 0,  },
	{ 932, 789, 1, "_root-790", -1, 1, 0, 0,  },
	{ 932, 790, 1, "_root-791", -1, 1, 0, 0,  },
	{ 932, 791, 1, "_root-792", -1, 1, 0, 0,  },
	{ 932, 792, 1, "_root-793", -1, 1, 0, 0,  },
	{ 932, 793, 1, "_root-794", -1, 1, 0, 0,  },
	{ 932, 794, 1, "_root-795", -1, 1, 0, 0,  },
	{ 932, 795, 1, "_root-796", -1, 1, 0, 0,  },
	{ 932, 796, 1, "_root-797", -1, 1, 0, 0,  },
	{ 932, 797, 1, "_root-798", -1, 1, 0, 0,  },
	{ 932, 798, 1, "_root-799", -1, 1, 0, 0,  },
	{ 932, 799, 1, "_root-800", -1, 1, 0, 0,  },
	{ 932, 800, 1, "_root-801", -1, 1, 0, 0,  },
	{ 932, 801, 1, "_root-802", -1, 1, 0, 0,  },
	{ 932, 802, 1, "_root-803", -1, 1, 0, 0,  },
	{ 932, 803, 1, "_root-804", -1, 1, 0, 0,  },
	{ 932, 804, 1, "_root-805", -1, 1, 0, 0,  },
	{ 932, 805, 1, "_root-806", -1, 1, 0, 0,  },
	{ 932, 806, 1, "_root-807", -1, 1, 0, 0,  },
	{ 932, 807, 1, "_root-808", -1, 1, 0, 0,  },
	{ 932, 808, 1, "_root-809", -1, 1, 0, 0,  },
	{ 932, 809, 1, "_root-810", -1, 1, 0, 0,  },
	{ 932, 810, 1, "_root-811", -1, 1, 0, 0,  },
	{ 932, 811, 1, "_root-812", -1, 1, 0, 0,  },
	{ 932, 812, 1, "_root-813", -1, 1, 0, 0,  },
	{ 932, 813, 1, "_root-814", -1, 1, 0, 0,  },
	{ 932, 814, 1, "_root-815", -1, 1, 0, 0,  },
	{ 932, 815, 1, "_root-816", -1, 1, 0, 0,  },
	{ 932, 816, 1, "_root-817", -1, 1, 0, 0,  },
	{ 932, 817, 1, "_root-818", -1, 1, 0, 0,  },
	{ 932, 818, 1, "_root-819", -1, 1, 0, 0,  },
	{ 932, 819, 1, "_root-820", -1, 1, 0, 0,  },
	{ 932, 820, 1, "_root-821", -1, 1, 0, 0,  },
	{ 932, 821, 1, "_root-822", -1, 1, 0, 0,  },
	{ 932, 822, 1, "_root-823", -1, 1, 0, 0,  },
	{ 932, 823, 1, "_root-824", -1, 1, 0, 0,  },
	{ 932, 824, 1, "_root-825", -1, 1, 0, 0,  },
	{ 932, 825, 1, "_root-826", -1, 1, 0, 0,  },
	{ 932, 826, 1, "_root-827", -1, 1, 0, 0,  },
	{ 932, 827, 1, "_root-828", -1, 1, 0, 0,  },
	{ 932, 828, 1, "_root-829", -1, 1, 0, 0,  },
	{ 932, 829, 1, "_root-830", -1, 1, 0, 0,  },
	{ 932, 830, 1, "_root-831", -1, 1, 0, 0,  },
	{ 932, 831, 1, "_root-832", -1, 1, 0, 0,  },
	{ 932, 832, 1, "_root-833", -1, 1, 0, 0,  },
	{ 932, 833, 1, "_root-834", -1, 1, 0, 0,  },
	{ 932, 834, 1, "_root-835", -1, 1, 0, 0,  },
	{ 932, 835, 1, "_root-836", -1, 1, 0, 0,  },
	{ 932, 836, 1, "_root-837", -1, 1, 0, 0,  },
	{ 932, 837, 1, "_root-838", -1, 1, 0, 0,  },
	{ 932, 838, 1, "_root-839", -1, 1, 0, 0,  },
	{ 932, 839, 1, "_root-840", -1, 1, 0, 0,  },
	{ 932, 840, 1, "_root-841", -1, 1, 0, 0,  },
	{ 932, 841, 1, "_root-842", -1, 1, 0, 0,  },
	{ 932, 842, 1, "_root-843", -1, 1, 0, 0,  },
	{ 932, 843, 1, "_root-844", -1, 1, 0, 0,  },
	{ 932, 844, 1, "_root-845", -1, 1, 0, 0,  },
	{ 932, 845, 1, "_root-846", -1, 1, 0, 0,  },
	{ 932, 846, 1, "_root-847", -1, 1, 0, 0,  },
	{ 932, 847, 1, "_root-848", -1, 1, 0, 0,  },
	{ 932, 848, 1, "_root-849", -1, 1, 0, 0,  },
	{ 932, 849, 1, "_root-850", -1, 1, 0, 0,  },
	{ 932, 850, 1, "_root-851", -1, 1, 0, 0,  },
	{ 932, 851, 1, "_root-852", -1, 1, 0, 0,  },
	{ 932, 852, 1, "_root-853", -1, 1, 0, 0,  },
	{ 932, 853, 1, "_root-854", -1, 1, 0, 0,  },
	{ 932, 854, 1, "_root-855", -1, 1, 0, 0,  },
	{ 932, 855, 1, "_root-856", -1, 1, 0, 0,  },
	{ 932, 856, 1, "_root-857", -1, 1, 0, 0,  },
	{ 932, 857, 1, "_root-858", -1, 1, 0, 0,  },
	{ 932, 858, 1, "_root-859", -1, 1, 0, 0,  },
	{ 932, 859, 1, "_root-860", -1, 1, 0, 0,  },
	{ 932, 860, 1, "_root-861", -1, 1, 0, 0,  },
	{ 932, 861, 1, "_root-862", -1, 1, 0, 0,  },
	{ 932, 862, 1, "_root-863", -1, 1, 0, 0,  },
	{ 932, 863, 1, "_root-864", -1, 1, 0, 0,  },
	{ 932, 864, 1, "_root-865", -1, 1, 0, 0,  },
	{ 932, 865, 1, "_root-866", -1, 1, 0, 0,  },
	{ 932, 866, 1, "_root-867", -1, 1, 0, 0,  },
	{ 932, 867, 1, "_root-868", -1, 1, 0, 0,  },
	{ 932, 868, 1, "_root-869", -1, 1, 0, 0,  },
	{ 932, 869, 1, "_root-870", -1, 1, 0, 0,  },
	{ 932, 870, 1, "_root-871", -1, 1, 0, 0,  },
	{ 932, 871, 1, "_root-872", -1, 1, 0, 0,  },
	{ 932, 872, 1, "_root-873", -1, 1, 0, 0,  },
	{ 932, 873, 1, "_root-874", -1, 1, 0, 0,  },
	{ 932, 874, 1, "_root-875", -1, 1, 0, 0,  },
	{ 932, 875, 1, "_root-876", -1, 1, 0, 0,  },
	{ 932, 876, 1, "_root-877", -1, 1, 0, 0,  },
	{ 932, 877, 1, "_root-878", -1, 1, 0, 0,  },
	{ 932, 878, 1, "_root-879", -1, 1, 0, 0,  },
	{ 932, 879, 1, "_root-880", -1, 1, 0, 0,  },
	{ 932, 880, 1, "_root-881", -1, 1, 0, 0,  },
	{ 932, 881, 1, "_root-882", -1, 1, 0, 0,  },
	{ 932, 882, 1, "_root-883", -1, 1, 0, 0,  },
	{ 932, 883, 1, "_root-884", -1, 1, 0, 0,  },
	{ 932, 884, 1, "_root-885", -1, 1, 0, 0,  },
	{ 932, 885, 1, "_root-886", -1, 1, 0, 0,  },
	{ 932, 886, 1, "_root-887", -1, 1, 0, 0,  },
	{ 932, 887, 1, "_root-888", -1, 1, 0, 0,  },
	{ 932, 888, 1, "_root-889", -1, 1, 0, 0,  },
	{ 932, 889, 1, "_root-890", -1, 1, 0, 0,  },
	{ 932, 890, 1, "_root-891", -1, 1, 0, 0,  },
	{ 932, 891, 1, "_root-892", -1, 1, 0, 0,  },
	{ 932, 892, 1, "_root-893", -1, 1, 0, 0,  },
	{ 932, 893, 1, "_root-894", -1, 1, 0, 0,  },
	{ 932, 894, 1, "_root-895", -1, 1, 0, 0,  },
	{ 932, 895, 1, "_root-896", -1, 1, 0, 0,  },
	{ 932, 896, 1, "_root-897", -1, 1, 0, 0,  },
	{ 932, 897, 1, "_root-898", -1, 1, 0, 0,  },
	{ 932, 898, 1, "_root-899", -1, 1, 0, 0,  },
	{ 932, 899, 1, "_root-900", -1, 1, 0, 0,  },
	{ 932, 900, 1, "_root-901", -1, 1, 0, 0,  },
	{ 932, 901, 1, "_root-902", -1, 1, 0, 0,  },
	{ 932, 902, 1, "_root-903", -1, 1, 0, 0,  },
	{ 932, 903, 1, "_root-904", -1, 1, 0, 0,  },
	{ 932, 904, 1, "_root-905", -1, 1, 0, 0,  },
	{ 932, 905, 1, "_root-906", -1, 1, 0, 0,  },
	{ 932, 906, 1, "_root-907", -1, 1, 0, 0,  },
	{ 932, 907, 1, "_root-908", -1, 1, 0, 0,  },
	{ 932, 908, 1, "_root-909", -1, 1, 0, 0,  },
	{ 932, 909, 1, "_root-910", -1, 1, 0, 0,  },
	{ 932, 910, 1, "_root-911", -1, 1, 0, 0,  },
	{ 932, 911, 1, "_root-912", -1, 1, 0, 0,  },
	{ 932, 912, 1, "_root-913", -1, 1, 0, 0,  },
	{ 932, 913, 1, "_root-914", -1, 1, 0, 0,  },
	{ 932, 914, 1, "_root-915", -1, 1, 0, 0,  },
	{ 932, 915, 1, "_root-916", -1, 1, 0, 0,  },
	{ 932, 916, 1, "_root-917", -1, 1, 0, 0,  },
	{ 932, 917, 1, "_root-918", -1, 1, 0, 0,  },
	{ 932, 918, 1, "_root-919", -1, 1, 0, 0,  },
	{ 932, 919, 1, "_root-920", -1, 1, 0, 0,  },
	{ 932, 920, 1, "_root-921", -1, 1, 0, 0,  },
	{ 932, 921, 1, "_root-922", -1, 1, 0, 0,  },
	{ 932, 922, 1, "_root-923", -1, 1, 0, 0,  },
	{ 932, 923, 1, "_root-924", -1, 1, 0, 0,  },
	{ 932, 924, 1, "_root-925", -1, 1, 0, 0,  },
	{ 932, 925, 1, "_root-926", -1, 1, 0, 0,  },
	{ 932, 926, 1, "_root-927", -1, 1, 0, 0,  },
	{ 932, 927, 1, "_root-928", -1, 1, 0, 0,  },
	{ 932, 928, 1, "_root-929", -1, 1, 0, 0,  },
	{ 932, 929, 1, "_root-930", -1, 1, 0, 0,  },
	{ 932, 930, 1, "_root-931", -1, 1, 0, 0,  },
	{ 932, 931, 1, "_root-932", -1, 1, 0, 0,  }
};

static struct pat_cons_info parser_patReplInfo[] = {
};

static struct pat_cons_node parser_patReplNodes[] = {
};

static struct function_info parser_functionInfo[] = {

};

static struct region_info parser_regionInfo[] = {
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 162 },
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 163 },
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 164 },
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 165 },
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 166 },
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 167 },
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 168 }
};

static struct generic_info parser_genericInfo[] = {
	{ 0, 0, 0, 0, 0, 0, 0, 0 },
	{ 20, -1, -1, 0, 0, 0, 0, 0 },
	{ 21, 936, 1, 0, 0, 5, 0, -1 },
	{ 21, 937, 1, 0, 0, 2, 0, -1 },
};

static const char *parser_litdata[] = {
	"unwind code\n",
	"r",
};

static long parser_litlen[] = {
	12, 1, };

static head_t *parser_literals[] = {
	0, 0, };

static int startStates[] = {
	0, };

static int eofLelIds[] = {
	482, };

static int parserLelIds[] = {
	787, };

static CaptureAttr captureAttr[] = {
};

tree_t **colm_object_host_call( program_t *prg, long code, tree_t **sp );
void colm_object_commit_reduce_forward( program_t *prg, tree_t **root,
		struct pda_run *pda_run, parse_tree_t *pt );
long colm_object_commit_union_sz( int reducer );
void colm_object_init_need();
int colm_object_reducer_need_tok( program_t *prg, struct pda_run *pda_run, int id );
int colm_object_reducer_need_ign( program_t *prg, struct pda_run *pda_run );
void colm_object_read_reduce( program_t *prg, int reducer, input_t *stream );

struct colm_sections colm_object = 
{
	parser_lelInfo,
	933,

	parser_selInfo,
	5,

	parser_prodInfo,
	1331,

	parser_regionInfo,
	29,

	parser_rootCode,
	73,
	0,

	parser_frameInfo,
	1,

	parser_functionInfo,
	0,

	parser_patReplInfo,
	0,

	parser_patReplNodes,
	0,

	parser_genericInfo,
	4,
	3,
	2,

	parser_litdata,
	parser_litlen,
	parser_literals,
	2,

	captureAttr,
	0,

	&fsmTables_start,
	&pid_0_pdaTables,
	startStates, eofLelIds, parserLelIds, 1,

	5,

	786,
	933,
	-1,
	2,
	786,
	0,
	785,
	933,
	937,
	936,
	938,
	938,
	940,
	&fsm_execute,
	&sendNamedLangEl,
	&initBindings,
	&popBinding,
	&colm_object_host_call,
	&colm_object_commit_reduce_forward,
	&colm_object_commit_union_sz,
	&colm_object_init_need,
	&colm_object_reducer_need_tok,
	&colm_object_reducer_need_ign,
	&colm_object_read_reduce,
};

tree_t **colm_object_host_call( program_t *prg, long code, tree_t **sp )
{
	value_t rtn = 0;
	switch ( code ) {
	}
	vm_push_value( rtn );
	return sp;
}
void colm_object_commit_reduce_forward( program_t *prg, tree_t **root,
		struct pda_run *pda_run, parse_tree_t *pt )
{
	commit_clear_parse_tree( prg, root, pda_run, pt->child );
}

long colm_object_commit_union_sz( int reducer ) { return 0; }
void colm_object_init_need() {}
int colm_object_reducer_need_tok( program_t *prg, struct pda_run *pda_run, int id ) { return COLM_RN_BOTH; }
int colm_object_reducer_need_ign( program_t *prg, struct pda_run *pda_run ) { return COLM_RN_BOTH; }

void colm_object_read_reduce( program_t *prg, int reducer, input_t *stream ) {}
